var Alloy = require('/alloy'),
Backbone = Alloy.Backbone,
_ = Alloy._;




function __processArg(obj, key) {
  var arg = null;
  if (obj) {
    arg = obj[key] || null;
  }
  return arg;
}

function Controller() {

  require('/alloy/controllers/' + 'BaseController').apply(this, Array.prototype.slice.call(arguments));
  this.__controllerPath = 'imageGalleryWindow';
  this.args = arguments[0] || {};

  if (arguments[0]) {
    var __parentSymbol = __processArg(arguments[0], '__parentSymbol');
    var $model = __processArg(arguments[0], '$model');
    var __itemTemplate = __processArg(arguments[0], '__itemTemplate');
  }
  var $ = this;
  var exports = {};
  var __defers = {};







  $.__views.window = Ti.UI.createWindow(
  { backgroundColor: "#D5D5D5", layout: "composite", barColor: "#0067ac", navTintColor: "#fff", titleAttributes: { color: "#FFFFFF" }, title: "Gallery", id: "window" });

  $.__views.window && $.addTopLevelView($.__views.window);
  onClose ? $.addListener($.__views.window, 'close', onClose) : __defers['$.__views.window!close!onClose'] = true;if (true) {
    $.__views.tableView = Ti.UI.createTableView(
    { top: 0, bottom: 50, backgroundColor: "#fff", id: "tableView" });

    $.__views.window.add($.__views.tableView);
    tableViewOnClick ? $.addListener($.__views.tableView, 'singletap', tableViewOnClick) : __defers['$.__views.tableView!singletap!tableViewOnClick'] = true;}
  exports.destroy = function () {};




  _.extend($, $.__views);


  var args = arguments[0] || {};
  var menuItemId = args.menuItemId;
  var panelId = args.panelId;
  var damagePanelIndex = args.damagePanelIndex;

  var fontSizeVal = 15;
  var color = '#000';

  var doLog = true;




  var LOG_TAG = '[ImageGalleryWindow]';

  doLog && console.log(LOG_TAG, ' Start');


  var listOfRowsMediaClips = [];

  function onClose() {
    doLog && console.log(LOG_TAG, "onClose()");
    args.callback(panelId, damagePanelIndex);
    $.window.remove($.tableView);
    menuItemId = null;
    panelId = null;
    damagePanelIndex = null;
    fontSizeVal = null;
    color = null;
  }

  function toggleRowMoving() {
    doLog && console.log(LOG_TAG, 'toggleRowMoving()');
    closeSwipeRowsByPosition(-1, 1);
    $.tableView.moving = !$.tableView.moving;
    Alloy.Globals.rowMovingState = $.tableView.moving;
  }

  if (Alloy.Globals.rowMovingState)
  $.tableView.moving = true;


  function createNewRow(pic_info) {
    doLog && console.log(LOG_TAG, " createNewRow(pic_info) : ", JSON.stringify(pic_info));

    var inspectionName = Alloy.Globals.getCurrentInspection();
    var params = {
      info: pic_info };


    if (pic_info.isImage) {
      var imageFile = pic_info.imageFileName;
      params.imageFile = imageFile;
      params.rowId = pic_info.imageId;
    } else {
      var videoThumb = Titanium.Filesystem.getFile(inspectionDir + "/inspections/" + inspectionName, pic_info.thumb);
      params.videoThumb = videoThumb;
      params.rowId = pic_info.videoId;
    }

    var galleryRowController = Alloy.createWidget('GalleryItem', params);
    if (pic_info.isImage) {
      galleryRowController.setRightButtonOnSwipe('copy');
      galleryRowController.setRightButtonOnSwipe('delete');
    } else {
      galleryRowController.setRightButtonOnSwipe('delete');
    }
    galleryRowController.hideSwipeContainer();
    listOfRowsMediaClips.push(galleryRowController);
    galleryRowController.on('buttonPress', handleButtonPress);
    galleryRowController.on('rowSwipe', closeSwipeRowsByPosition);

    return galleryRowController.getView();
  }





  function handleButtonPress(e) {
    doLog && console.log(LOG_TAG, ' handleButtonPress() ', e.type);
    switch (e.type) {
      case 'deleteClip':
        deleteClip(e);
        break;
      case 'copyClip':
        copyClip(e);
        break;}

  }






  function deleteClip(event) {
    doLog && console.log(LOG_TAG, ' ~-> deleteImages(): ', JSON.stringify(event));

    var alertDelete = Titanium.UI.createAlertDialog({
      title: 'Confirm deletion',
      message: 'Are you sure you want to delete this clip?',
      buttonNames: ['Yes', 'No'],
      cancel: 1 });

    alertDelete.show();
    alertDelete.addEventListener('click', function (eInner) {
      if (eInner.index == 1) {
        return;
      } else {

        updateTableView();
      }
    });
  }






  function copyClip(event) {
    doLog && console.log(LOG_TAG, ' copyClip()', JSON.stringify(event));
    event.cancelBubble = true;
    var alertCopy = Titanium.UI.createAlertDialog({
      title: 'Copy to Section',
      message: 'Are you sure you want to Copy this clip?',
      buttonNames: ['Copy', 'Cancel'],
      cancel: 1 });

    alertCopy.show();
    alertCopy.addEventListener('click', function (eInner) {
      if (eInner.cancel === eInner.index || eInner.cancel === true) {
        return;
      } else {

      }
    });
  }

  function closeSwipeRowsByPosition(currentRowSwipeId, position) {
    doLog && console.log(LOG_TAG, ' closeSwipeRows(rowId)');
    doLog && console.log(LOG_TAG, ' currentRowSwipeId: ', currentRowSwipeId, ', listOfRowsMediaClips.length', listOfRowsMediaClips.length);
    _.each(listOfRowsMediaClips, function (message, rowIdOnlist) {
      doLog && console.log(LOG_TAG, '~~~~~~*****> ', message.isButtonDisplayed, ', rowIdOnlist: ', rowIdOnlist);



      if (!position) {
        if (message.isButtonDisplayed && rowIdOnlist != currentRowSwipeId) {
          message.hideSwipeContainer();
        }
      } else {

        message.hideSwipeContainer();
      }

    });
  }

  function rearrangeImageRows(e) {

    var rows = imageSection.getRows();
    var tempArray = [];

    for (var i = 0; i < rows.length; i++) {
      var id = rows[i].imageId ? rows[i].imageId : rows[i].videoId;
      var caption = Alloy.Globals.root.pictures[id].caption;

      var rowData = JSON.parse(JSON.stringify(rows[i].info));
      rowData.caption = caption;

      updatedImagesData.push(rowData);
      tempArray.push(rowData.imageId);
    }



    for (var i = 0; i < actualImageIds.length; i++) {

      Alloy.Globals.root.pictures[actualImageIds[i]] = updatedImagesData[i];

    }
    listOfRowsMediaClips = [];
    updateTableView();
    updatedImagesData = [];

  }

  function updateTableView() {
    actualImageIds = [];
    var data = [];


    imageSection = Titanium.UI.createTableViewSection({
      headerTitle: "Media" });

    doLog && console.log(LOG_TAG, " damage panels length:", Alloy.Globals.root.template[menuItemId].tabbed_panels[panelId].damage_panels.length);


    if (Alloy.Globals.root.template[menuItemId].tabbed_panels[panelId].damage_panels.length > 0) {
      for (i in Alloy.Globals.root.pictures) {
        if (Alloy.Globals.root.pictures[i].menuItem) {
          var menuItem = Alloy.Globals.root.template[menuItemId];
          var picture = Alloy.Globals.root.pictures[i];






          if (picture.menuItem == menuItem.title && picture.section == menuItem.tabbed_panels[panelId].damage_panels[damagePanelIndex].title) {
            if (picture.isVideo) {
              picture.isImage = false;
              picture.isVideo = true;
              picture.videoId = i;
              var row = createNewRow(picture);
              imageSection.add(row);
            } else {
              picture.isImage = true;
              picture.isVideo = false;
              picture.imageId = i;
              var row = createNewRow(picture);

              imageSection.add(row);
              row = null;
            }
            actualImageIds.push(i);
          }
        }
      }
    }
    doLog && console.log(LOG_TAG, "imageSection.rowCount: ", imageSection.rowCount);
    if (imageSection.rowCount > 0)
    data.push(imageSection);

    $.tableView.setData(data);
    var windowName = '';
    if (Alloy.Globals.root.template[menuItemId].tabbed_panels[panelId].damage_panels.length > 1) {
      windowName = Alloy.Globals.root.template[menuItemId].tabbed_panels[panelId].title + " > " + Alloy.Globals.root.template[menuItemId].tabbed_panels[panelId].damage_panels[damagePanelIndex].title + " > Gallery";
    } else {
      windowName = Alloy.Globals.root.template[menuItemId].tabbed_panels[panelId].title + " > Gallery";
    }

    if (true) {
      $.window.title = windowName;
    }

    setTimeout(function () {
      $.tableView.scrollToIndex(imageSection.rowCount - 1);
    }, 1000);

  }


  function editImages(e) {


  }




  function deleteImages(e) {
    doLog && console.log(LOG_TAG, ' ~-> deleteImages()');

    var alertDelete = Titanium.UI.createAlertDialog({
      title: 'Confirm deletion',
      message: 'Are you sure you want to delete this clip?',
      buttonNames: ['Yes', 'No'],
      cancel: 1 });

    alertDelete.show();
    alertDelete.addEventListener('click', function (eInner) {

      if (eInner.index == 1) {
        return;
      } else {

        updateTableView();
      }
    });

  }




  function deleteVideos(e) {
    doLog && console.log(LOG_TAG, ' ~-> deleteImages()');

    var alertDelete = Titanium.UI.createAlertDialog({
      title: 'Confirm deletion',
      message: 'Are you sure you want to delete this video clip?',
      buttonNames: ['Yes', 'No'],
      cancel: 1 });

    alertDelete.show();
    alertDelete.addEventListener('click', function (eInner) {
      if (eInner.cancel === eInner.index || eInner.cancel === true) {
        return;
      } else {

        updateTableView();
      }
    });
  }

  function tableViewOnClick(e) {
    doLog && console.log(LOG_TAG, ' tableViewOnClick(e): ', JSON.stringify(e));

    switch (e.source.sourceType) {
      case "VideoRow":
        editCaption(e, e.source.sourceType);
        break;
      case "DeleteVideoRow":
        deleteVideos(e);
        break;
      case "PlayVideoRow":
        playVideo(e);
        break;
      case "ImageRow":
        editCaption(e, e.source.sourceType);
        break;
      case "DeleteImageRow":
        deleteImages(e);
        break;
      case "EditImageRow":
        editImages(e);
        break;}


  };


  updateTableView();





  __defers['$.__views.window!close!onClose'] && $.addListener($.__views.window, 'close', onClose);__defers['$.__views.tableView!singletap!tableViewOnClick'] && $.addListener($.__views.tableView, 'singletap', tableViewOnClick);



  _.extend($, exports);
}

module.exports = Controller;