var Alloy = require('/alloy'),
Backbone = Alloy.Backbone,
_ = Alloy._;




function __processArg(obj, key) {
  var arg = null;
  if (obj) {
    arg = obj[key] || null;
  }
  return arg;
}

function Controller() {

  require('/alloy/controllers/' + 'BaseController').apply(this, Array.prototype.slice.call(arguments));
  this.__controllerPath = 'inspectTab';
  this.args = arguments[0] || {};

  if (arguments[0]) {
    var __parentSymbol = __processArg(arguments[0], '__parentSymbol');
    var $model = __processArg(arguments[0], '$model');
    var __itemTemplate = __processArg(arguments[0], '__itemTemplate');
  }
  var $ = this;
  var exports = {};
  var __defers = {};







  $.__views.inspectWindow = (require("tabGroup").createWindow || Ti.UI.createWindow)(
  { backgroundColor: "#D5D5D5", layout: "vertical", barColor: "#0067ac", navTintColor: "#fff", titleAttributes: { color: "#FFFFFF" }, title: "Inspect", id: "inspectWindow" });

  $.__views.__alloyId2 = Ti.UI.createView(
  { top: 0, bottom: 10, backgroundColor: "#c1bec0", height: Ti.UI.SIZE, id: "__alloyId2" });

  $.__views.inspectWindow.add($.__views.__alloyId2);
  $.__views.sessionId = Ti.UI.createLabel(
  { top: 5, bottom: 5, height: Titanium.UI.SIZE, color: "#464345", width: Titanium.UI.FILL, textAlign: "center", font: { fontSize: 13, fontFamily: "verdana,arial,sans-serif" }, left: 10, right: 10, text: 'Here Goes Session ID', id: "sessionId" });

  $.__views.__alloyId2.add($.__views.sessionId);
  if (true) {
    $.__views.tableView = Ti.UI.createTableView(
    { id: "tableView", top: 0, bottom: 50 });

    $.__views.inspectWindow.add($.__views.tableView);
    onRowClick ? $.addListener($.__views.tableView, 'click', onRowClick) : __defers['$.__views.tableView!click!onRowClick'] = true;}
  $.__views.inspectTab = (require("tabGroup").createTab || Ti.UI.createTab)(
  { window: $.__views.inspectWindow, title: "Inspect", icon: "/images/inspectTab.png", id: "inspectTab", activeColor: "#fff", backgroundActiveColor: "#00345e", backgroundColor: "#0066ac", titleColor: "#fff" });

  $.__views.inspectTab && $.addTopLevelView($.__views.inspectTab);
  exports.destroy = function () {};




  _.extend($, $.__views);


  var data = [];
  var argsForHeaderView = {};
  argsForHeaderView.parent = $.inspectTab;

  var doLog = true;
  var LOG_TAG = '[inspectTab]';

  doLog && console.log(LOG_TAG, ' Start');


  $.tableView.backgroundColor = Alloy.Globals.commentRowsBGColor;
  $.inspectWindow.tableView = $.tableView;

  function createMenuRow(row_data, hasTabedPanel) {



    var rowLabel = Ti.UI.createLabel({
      font: {
        fontSize: Alloy.Globals.fontSizeVal },


      color: '#000000',
      text: row_data.title,
      menuId: row_data.id,
      top: '5dp',
      bottom: '5dp',
      height: Ti.UI.SIZE,
      left: '10dp',
      right: '10dp',
      sourceType: 'ROW_HIGHLIGHTER' });

    var row = null;
    var row = Ti.UI.createTableViewRow({
      className: 'comment',
      backgroundColor: Alloy.Globals.commentRowsBGColor,
      rowData: row_data });

    row.add(rowLabel);
    return row;
  };

  function onRowClick(e) {
    doLog && console.log(LOG_TAG, 'e.source.sourceType', e.source.sourceType);
    switch (e.source.sourceType) {
      case "ROW_HIGHLIGHTER":
        doLog && console.log(LOG_TAG, 'ROW_HIGHLIGHTER');
        throttledGoToTabbedPanel(e);
        break;}

  }

  function loadInspectionJson() {

    var currInsp = Alloy.Globals.getCurrentInspection();
    Ti.API.info("currInsp:" + currInsp);
    if (currInsp != null && currInsp != '') {
      $.inspectWindow.title = currInsp;

    } else {
      $.inspectWindow.title = 'Inspect';
    }

  }

  function prepareTableviewData() {
    if (Alloy.Globals.root.template.length > 0) {
      data = [];
      for (i in Alloy.Globals.root.template) {
        var menu_item = Alloy.Globals.root.template[i];


        var row_data = {
          title: menu_item.title,
          id: i };

        if (menu_item.tabbed_panels.length > 0) {
          row_data.hasChild = true;
        } else {
          row_data.hasChild = false;
        }

        var result = _.every(Alloy.Globals.root.template[i].tabbed_panels, function (panel) {

          return panel.checked;
        });

        var row = createMenuRow(row_data, result);


        var colorIP = result ? Alloy.Globals.rowReadColor == '#E5E5E5' ? '#000000' : Alloy.Globals.commentRowsFGColor : Alloy.Globals.commentRowsBGColor == '#E5E5E5' ? '#000000' : Alloy.Globals.commentRowsFGColor;
        if (result) {
          row.backgroundColor = Alloy.Globals.rowReadColor;
          row.color = colorIP;
        }

        data.push(row);
        row = null;
        result = null;
      }
    } else {

      var alertNoTemplate = Titanium.UI.createAlertDialog({
        title: 'Sync First',
        message: 'No current inspection or templates found. Download a template first.',
        buttonNames: ['OK'] });

      alertNoTemplate.addEventListener('click', function (e) {
      });
      alertNoTemplate.show();
    }
  }

  $.inspectTab.prepareTableviewData = prepareTableviewData;
  function refreshTableview() {
    $.tableView.setData(data);
    data = null;
  }

  function checkMenuSelected(menuIndex) {
    var result = _.every(Alloy.Globals.root.template[menuIndex].tabbed_panels, function (panel) {
      return panel.checked;
    });
    return result;
  }

  $.inspectTab.refreshTableview = refreshTableview;
  Alloy.Globals.refreshMenuTable = function () {
    $.inspectTab.prepareTableviewData();
    $.inspectTab.refreshTableview();
  };
  var throttledGoToTabbedPanel = _.debounce(goToTabbedPanel, 1000, true);
  function goToTabbedPanel(e) {

    var row = false ? e.row : e.row.rowData;
    if (row.rowData.hasChild) {
      var args = {};
      args.id = row.rowData.id;
      args.title = row.rowData.title;
      args.containingTab = $.inspectTab;
      args.callback = function (changeColor) {

        doLog && console.log(LOG_TAG, "goToTabbedPanel callback " + changeColor);

        if ($.tableView) {
          if (changeColor) {
            row.backgroundColor = Alloy.Globals.rowReadColor;
          } else {
            row.backgroundColor = Alloy.Globals.commentRowsBGColor;
          }
        }
      };
      var tabbedPanel = Alloy.createController('tabbedPanel', args).getView();

      tabbedPanel.addEventListener('close', function (e) {
        save();
      });

      $.inspectTab.open(tabbedPanel, {
        animated: true });

    }
  }

  function onLoad() {

    var currInsp = Alloy.Globals.getCurrentInspection();
    console.log('currInsp: ', currInsp);
    if (!currInsp) {
      $.tableView.setData([]);
      $.inspectWindow.title = 'No Inspection Found';
      return;
    }
    Ti.API.info("currInsp:" + currInsp);
    loadInspectionJson();
    prepareTableviewData();
    refreshTableview();
    Alloy.Globals.inspectionLoaded = true;

  }

  exports.reload = function () {

    onLoad();
  };

  function save() {

    var currInsp = Alloy.Globals.getCurrentInspection();

    if (currInsp && Alloy.Globals.root.template.length > 0) {
      if (currInsp.length == 0) {
        root.template = [];
        data = [];
      } else {

      }

    }

  }

  exports.save = save;
  Alloy.Globals.saveInspection = save;





  __defers['$.__views.tableView!click!onRowClick'] && $.addListener($.__views.tableView, 'click', onRowClick);



  _.extend($, exports);
}

module.exports = Controller;