var Alloy = require('/alloy'),
Backbone = Alloy.Backbone,
_ = Alloy._;




function __processArg(obj, key) {
  var arg = null;
  if (obj) {
    arg = obj[key] || null;
  }
  return arg;
}

function Controller() {

  require('/alloy/controllers/' + 'BaseController').apply(this, Array.prototype.slice.call(arguments));
  this.__controllerPath = 'tabbedPanel';
  this.args = arguments[0] || {};

  if (arguments[0]) {
    var __parentSymbol = __processArg(arguments[0], '__parentSymbol');
    var $model = __processArg(arguments[0], '$model');
    var __itemTemplate = __processArg(arguments[0], '__itemTemplate');
  }
  var $ = this;
  var exports = {};
  var __defers = {};







  $.__views.tabbedPanelWindow = Ti.UI.createWindow(
  { backgroundColor: "#D5D5D5", layout: "vertical", barColor: "#0067ac", navTintColor: "#fff", titleAttributes: { color: "#FFFFFF" }, id: "tabbedPanelWindow" });

  $.__views.tabbedPanelWindow && $.addTopLevelView($.__views.tabbedPanelWindow);
  onClose ? $.addListener($.__views.tabbedPanelWindow, 'close', onClose) : __defers['$.__views.tabbedPanelWindow!close!onClose'] = true;onOpen ? $.addListener($.__views.tabbedPanelWindow, 'open', onOpen) : __defers['$.__views.tabbedPanelWindow!open!onOpen'] = true;$.__views.searchBar = Ti.UI.createSearchBar(
  { id: "searchBar", backgroundColor: "#fff", color: "#000" });

  searchBarOnCancel ? $.addListener($.__views.searchBar, 'cancel', searchBarOnCancel) : __defers['$.__views.searchBar!cancel!searchBarOnCancel'] = true;$.__views.tableViewTP = Ti.UI.createTableView(
  { search: $.__views.searchBar, id: "tableViewTP" });

  $.__views.tabbedPanelWindow.add($.__views.tableViewTP);
  throttledGoToInspectionPanel ? $.addListener($.__views.tableViewTP, 'singletap', throttledGoToInspectionPanel) : __defers['$.__views.tableViewTP!singletap!throttledGoToInspectionPanel'] = true;exports.destroy = function () {};




  _.extend($, $.__views);


  var args = arguments[0] || {};
  var inspectionService = require('/inspectionsHelper');
  $.tabbedPanelWindow.title = args.title;

  var doLog = Ti.App.Properties.getBool('doLog');




  var LOG_TAG = '[tabbedPanel]';

  doLog && console.log(LOG_TAG, ' start');

  doLog && console.log(LOG_TAG, '~~~~~> Alloy.Globals.countNarrativesPicturesSwitch: ', Alloy.Globals.countNarrativesPicturesSwitch);


  if (true) {
    setTimeout(function () {
      $.searchBar.show();
    }, 500);
  }

  function drawInfo(indexPanelId) {

    var posToScroll = 0;
    var data = [];
    for (i in Alloy.Globals.root.template[args.id].tabbed_panels) {
      var total_number_items = inspectionService.getTotalNumberOfNarrativesAndPicturesByMenuItemIdAndPanelId(args.id, i);

      if (i == indexPanelId) {

        posToScroll = i;
      };


      var row = {
        font: {
          fontSize: Alloy.Globals.fontSizeVal },

        color: Alloy.Globals.commentRowsFGColor,
        backgroundColor: Alloy.Globals.commentRowsBGColor,
        title: Alloy.Globals.root.template[args.id].tabbed_panels[i].title,
        id: i,
        hasDetail: false,
        hasChild: false,
        totalNumberOfItems: total_number_items.total_narratives,
        totalNumberOfItemsSelected: total_number_items.total_narratives_selected,
        totalNumberOfPictures: total_number_items.total_pictures };


      var itemChecked = false;
      var toContinue = true;
      var tabbedPanelChecked = Alloy.Globals.root.template[args.id].tabbed_panels[i].checked;



      if (tabbedPanelChecked) {

        row.backgroundColor = Alloy.Globals.rowReadColor;
        row.color = '#000000';
      } else if (tabbedPanelChecked == undefined) {

        var checkRatingSelected = _.some(Alloy.Globals.root.template[args.id].tabbed_panels[i].ratings, function (itemRating) {


          var innerResultsRatings = _.some(itemRating.options, function (rating) {

            return rating.checked;
          });
          if (innerResultsRatings == true)
          return true;
        });



        if (checkRatingSelected) {
          toContinue = false;
        }

        if (!toContinue) {
          row.backgroundColor = Alloy.Globals.rowReadColor;
          row.color = '#000000';
        }
      }

      if (Alloy.Globals.root.template[args.id].tabbed_panels[i].damage_panels.length > 0 || Alloy.Globals.root.template[args.id].tabbed_panels[i].inspection_panels.length > 0) {
        row.hasChild = true;
        row.hasDetail = true;
      }

      var tabbedPanelCustomRow = require('customRows/tabbedPanelNarrativeRow');
      var rowContainer = new tabbedPanelCustomRow(row);

      if (Alloy.Globals.countNarrativesPicturesSwitch) {

        data.push(rowContainer);

      } else {
        data.push(row);
      }



      row = null;
      result = null;




    }

    $.tableViewTP.setData(data);
    if (Alloy.Globals.countNarrativesPicturesSwitch) {
      $.tableViewTP.filterAttribute = 'titles';
    }


    $.tableViewTP.scrollToIndex(posToScroll, {
      animated: false });



  }

  drawInfo(-1);

  function coloringCustomRow(rowId, colorText, colorBg) {
    $.tableViewTP.getSections()[0].getRows()[rowId].children[0].children[1].children[1].children[0].color = colorText;
    $.tableViewTP.getSections()[0].getRows()[rowId].children[0].children[1].children[0].children[0].tintColor = colorText;


    $.tableViewTP.getSections()[0].getRows()[rowId].children[0].children[1].children[3].children[0].color = colorText;
    $.tableViewTP.getSections()[0].getRows()[rowId].children[0].children[1].children[2].children[0].tintColor = colorText;


    $.tableViewTP.getSections()[0].getRows()[rowId].children[0].children[0].children[0].color = colorText;
    $.tableViewTP.getSections()[0].getRows()[rowId].color = colorText;
    $.tableViewTP.getSections()[0].getRows()[rowId].backgroundColor = colorBg;
  }

  function markSelected(row) {
    Alloy.Globals.root.template[args.id].tabbed_panels[row.id].checked = true;

    if (Alloy.Globals.countNarrativesPicturesSwitch) {

      var colorOpt = Alloy.Globals.rowReadColor == '#E5E5E5' ? '#000000' : Alloy.Globals.commentRowsFGColor;
      coloringCustomRow(row.id, colorOpt, Alloy.Globals.rowReadColor);
    } else {
      row.backgroundColor = Alloy.Globals.rowReadColor;
    }
  }
  function markDeSelected(row) {
    Alloy.Globals.root.template[args.id].tabbed_panels[row.id].checked = false;
    if (Alloy.Globals.countNarrativesPicturesSwitch) {
      var colorOptUn = Alloy.Globals.rowReadColor == '#E5E5E5' ? Alloy.Globals.commentRowsBGColor == '#000000' ? '#FFFFFF' : '#000000' : '#000000';
      coloringCustomRow(row.id, colorOptUn, Alloy.Globals.commentRowsBGColor);
    } else {
      row.backgroundColor = Alloy.Globals.commentRowsBGColor;
    }
  }

  $.tableViewTP.backgroundColor = Alloy.Globals.commentRowsBGColor;
  data = null;
  function onOpen() {
    if (true)
    $.searchBar.hide();
  }

  function onClose() {
    Alloy.Globals.tabbedWindowOpened = false;
    Alloy.Globals.inspectWindowOpened = false;
    Alloy.Globals.damageWindowOpened = false;

    var result;
    if (Alloy.Globals.root.template[args.id].tabbed_panels.checked) {
      result = true;
    } else {
      result = _.every(Alloy.Globals.root.template[args.id].tabbed_panels, function (panel) {
        return panel.checked;
      });
    }
    args.callback(result);


    if ($.tableViewTP && $.tabbedPanelWindow) {

      $.tabbedPanelWindow.remove($.tableViewTP);

    }



  }

  var throttledGoToInspectionPanel = _.debounce(goToInspectionPanel, 1000, true);
  function goToInspectionPanel(e) {



    var nextArgs = {};
    if (e.rowData && e.rowData.id == 0) {
      e.rowData.id = "0";
    }
    if (e.rowData && e.rowData.id) {

      nextArgs.panelId = e.rowData.id;
      nextArgs.menuItemId = args.id;
      var row = e.row;

      nextArgs.title = e.rowData.title;
      nextArgs.containingTab = args.containingTab;
      nextArgs.tabbedPanelWindow = $.tabbedPanelWindow;
      nextArgs.callback = function (changeColor, menuItemId, panelId) {
        try {

          if (Alloy.Globals.saveModeSwitch)
          Alloy.Globals.saveInspection();


          if ($.tabbedPanelWindow) {













            var currentTotalPictures = Alloy.Globals.root.pictures.length,
            oldTotalPictures = Alloy.Globals.initialPictures.length,
            diferenceOfPictures = currentTotalPictures - oldTotalPictures,
            totalPanelsIdByMenuId = Alloy.Globals.root.template[menuItemId].tabbed_panels.length;




            var sliderValue = Ti.App.Properties.getInt('sliderValue'),
            fontSizeValueDefault = Alloy.Globals.fontSizeVal - 6;

            switch (sliderValue) {
              case 1:
                fontSizeValue = fontSizeValueDefault;
                break;
              case 2:
                fontSizeValue = fontSizeValueDefault;
                break;
              case 3:
                fontSizeValue = fontSizeValueDefault;
                break;
              case 4:
                fontSizeValue = fontSizeValueDefault - 6;
                break;
              case 5:
                fontSizeValue = fontSizeValueDefault - 8;
                break;
              case 6:
                fontSizeValue = fontSizeValueDefault - 10;
                break;}




            function getInspectionPanelsAndDamagePanels(damage_panels, inspection_panels) {
              var toContinue = true;

              var checkDamagePanelSelected = _.some(damage_panels, function (itemDamagePanel) {


                var innerResultsDamagePanels = _.some(itemDamagePanel.options, function (damagePanel) {

                  return damagePanel.checked;
                });
                if (innerResultsDamagePanels == true)
                return true;

              });


              if (checkDamagePanelSelected) {
                toContinue = false;
              }

              if (toContinue) {
                var checkInspectionPanelSelected = _.some(inspection_panels, function (itemInspectionPanel) {


                  var innerResultsInspectionPanels = _.some(itemInspectionPanel.options, function (inspectionPanel) {

                    return inspectionPanel.checked;
                  });
                  if (innerResultsInspectionPanels == true)
                  return true;

                });

              }
              if (checkInspectionPanelSelected) {
                toContinue = false;
              }

              return toContinue;
            }

            function getCountItemSelectedOnDamage(damage_panels) {
              var counter = 0,
              counter_total_items = 0,
              global_counter = 0;



              for (i in damage_panels) {

                var toContinue = true;
                var checkDamagePanelSelected = _.some(damage_panels[i].options, function (itemDamagePanel) {

                  return itemDamagePanel.checked;
                });

                if (checkDamagePanelSelected) {
                  toContinue = false;
                }

                if (!toContinue) {
                  counter++;
                  global_counter = counter;
                }
                counter_total_items++;
              }

              return {
                counter_total_items_checked: global_counter,
                counter_total_items: counter_total_items };

            }




            function getRatingsSelected(ratings) {
              var toContinue = true;
              var checkRatingSelected = _.some(ratings, function (itemRating) {


                var innerResultsRatings = _.some(itemRating.options, function (rating) {

                  return rating.checked;
                });
                if (innerResultsRatings == true)
                return true;
              });



              if (checkRatingSelected) {
                toContinue = false;
              }
              return toContinue;
            }

            function hasChildAndDetail(damage_panels, inspection_panels) {
              var hasChild, hasDetail;
              hasChild = false;
              hasDetail = false;
              if (damage_panels.length > 0 || inspection_panels.length > 0) {
                hasChild = true;
                hasDetail = true;
              }

              return { hasChild: hasChild, hasDetail: hasDetail };
            }

            function getHasRatings(ratings, panel_id) {
              var hasRatings = false,
              counter_total_items = 0,
              i = 0;

              for (i in ratings) {


                if (ratings.length == 0 || ratings.length == undefined) {
                  hasRatings = false;
                  counter_total_items++;
                } else if (ratings[i].options.length == 0 || ratings[i].options.length == undefined) {
                  hasRatings = false;
                  counter_total_items++;
                } else {
                  hasRatings = true;
                  counter_total_items++;
                }

              }
              return {
                hasRatings: hasRatings,
                numDamagePanels: counter_total_items };

            }

            function getCountFullItemOnRatings(damage_panels, ratings) {
              var counter = 0,
              counter_total_items = 0,
              global_counter = 0;



              for (i in damage_panels) {

                var toContinue = true;
                var checkRatingSelected = _.some(ratings[i].options, function (itemRating) {

                  return itemRating.checked;
                });

                if (checkRatingSelected) {
                  toContinue = false;
                }

                if (!toContinue) {
                  counter++;
                  global_counter = counter;
                }
                counter_total_items++;
              }

              return {
                counter_total_items_checked: global_counter,
                counter_total_items: counter_total_items };

            }
            doLog && console.log(LOG_TAG, "countNarrativesPicturesSwitch: ", Alloy.Globals.countNarrativesPicturesSwitch);
            if (Alloy.Globals.countNarrativesPicturesSwitch) {

              var visited;
              _.each(Alloy.Globals.root.template[menuItemId].tabbed_panels, function (tabbed_panel, panel_id) {
















                doLog && console.log(LOG_TAG, '***************** START TABBED PANEL ***************** panel_id = ', panel_id, ', panelId ', panelId, ', visited ', visited);

                var colorTb,totalNumberItem,hasRatings,toCompare,
                hasDetail = hasChildAndDetail(tabbed_panel.damage_panels, tabbed_panel.inspection_panels).hasDetail,
                hasChild = hasChildAndDetail(tabbed_panel.damage_panels, tabbed_panel.inspection_panels).hasChild;


                doLog && console.log(LOG_TAG, 'tabbed_panel.title: ', tabbed_panel.title, ', panelId: ', panel_id, ', tabbed_panel.checked: ', tabbed_panel.checked);

                totalNumberItem = inspectionService.getTotalNumberOfNarrativesAndPicturesByMenuItemIdAndPanelId(menuItemId, panel_id);
                doLog && console.log(LOG_TAG, 'totalNumberItem: ', JSON.stringify(totalNumberItem));



                hasRatings = getHasRatings(tabbed_panel.ratings, panel_id).hasRatings;

                doLog && console.log(LOG_TAG, '~~~~> hasRatings: ', JSON.stringify(hasRatings));

                if (!hasRatings) {
                  var checkInspectionsAndDamagePanels = getInspectionPanelsAndDamagePanels(tabbed_panel.damage_panels, tabbed_panel.inspection_panels);
                  doLog && console.log(LOG_TAG, '~~> checkInspectionsAndDamagePanels: ', checkInspectionsAndDamagePanels);

                  if (!checkInspectionsAndDamagePanels) {
                    if (tabbed_panel.damage_panels.length > 1) {
                      doLog && console.log(LOG_TAG, '~~> has damage panel');
                      var toCompare = getCountItemSelectedOnDamage(tabbed_panel.damage_panels),
                      total_items_checked = toCompare.counter_total_items_checked,
                      total_items = toCompare.counter_total_items;

                      doLog && console.log(LOG_TAG, '~~> total_itmes_checked: ', total_items_checked, ', total_items: ', total_items);

                      if (total_items_checked == total_items) {
                        changeColor = true;
                      } else {
                        changeColor = false;
                      }

                    } else {
                      doLog && console.log(LOG_TAG, '~~> hasnot damage panel > 1');
                      changeColor = true;
                    }

                  } else {
                    if (visited && Alloy.Globals.itemRatingCompletedSwitch) {
                      changeColor = true;
                    } else {
                      changeColor = false;
                    }
                  }


                } else {
                  var checkRatingSelected = getRatingsSelected(tabbed_panel.ratings);
                  doLog && console.log(LOG_TAG, '~~> checkRatingSelected: ', checkRatingSelected);

                  if (!checkRatingSelected) {
                    if (tabbed_panel.damage_panels.length > 1) {
                      doLog && console.log(LOG_TAG, '~~> has damage panel');
                      var toCompare = getCountFullItemOnRatings(tabbed_panel.damage_panels, tabbed_panel.ratings),
                      total_items_checked = toCompare.counter_total_items_checked,
                      total_items = toCompare.counter_total_items;

                      doLog && console.log(LOG_TAG, '~~> total_items_checkd: ', total_items_checked, ', total_items: ', total_items);

                      if (total_items_checked == total_items) {
                        changeColor = true;
                      } else {
                        changeColor = false;
                      }
                    } else {

                      doLog && console.log(LOG_TAG, '~~> hasnot damage panel');
                      changeColor = true;
                    }

                  } else {
                    changeColor = false;
                  }
                }

                doLog && console.log(LOG_TAG, '~~~~> changeColor: ', changeColor);
                doLog && console.log(LOG_TAG, '~~~~> Alloy.Globals.rowReadColor: ', Alloy.Globals.rowReadColor, ', Alloy.Globals.commentRowsFGColor: ', Alloy.Globals.commentRowsFGColor, ', Alloy.Globals.commentRowsBGColor: ', Alloy.Globals.commentRowsBGColor);





                if (changeColor) {

                  if (Alloy.Globals.rowReadColor == '#E5E5E5' && Alloy.Globals.commentRowsBGColor == '#FFFFFF') {
                    doLog && console.log('here 1 -ok');
                    colorTb = '#000000';
                    badge_color = '#FFFFFF';
                    badge_border_color = '';
                  } else if (Alloy.Globals.rowReadColor == '#E5E5E5' && Alloy.Globals.commentRowsBGColor == '#000000') {
                    doLog && console.log('here 2 - ok');
                    colorTb = '#000000';
                    badge_color = '#FFFFFF';
                    badge_backgroundColor = '#000000';
                    badge_border_color = '';
                  } else {
                    doLog && console.log('here 3');
                    colorTb = 'green';
                    badge_color = 'green';
                    badge_border_color = 'green';
                  }

                  newBGColor = Alloy.Globals.rowReadColor;
                } else {
                  if (Alloy.Globals.commentRowsBGColor == '#000000') {
                    doLog && console.log('here 4 -ok ');
                    colorTb = '#FFFFFF';
                    badge_color = '#000000';
                    badge_backgroundColor = '#FFFFFF';
                    badge_border_color = '#FFFFFF';
                  } else {
                    doLog && console.log('here 5 - ok');
                    colorTb = '#000000';
                    badge_color = '#FFFFFF';
                    badge_border_color = '';
                  }


                  newBGColor = Alloy.Globals.commentRowsBGColor;
                }

                doLog && console.log(LOG_TAG, '~~~~> colorTb: ', colorTb, ', newBGColor: ', newBGColor);








                $.tableViewTP.getSections()[0].getRows()[panel_id].children[0].children[1].children[0].children[0].text = totalNumberItem.total_narratives_selected;
                $.tableViewTP.getSections()[0].getRows()[panel_id].children[0].children[1].children[0].children[0].color = badge_color;
                $.tableViewTP.getSections()[0].getRows()[panel_id].children[0].children[1].children[0].children[0].backgroundColor = badge_backgroundColor;
                $.tableViewTP.getSections()[0].getRows()[panel_id].children[0].children[1].children[0].children[0].index = 1;
                $.tableViewTP.getSections()[0].getRows()[panel_id].children[0].children[1].children[0].children[0].opacity = 1;
                $.tableViewTP.getSections()[0].getRows()[panel_id].children[0].children[1].children[0].children[0].font = {
                  fontWeight: 'bold', fontSize: 11 };



                $.tableViewTP.getSections()[0].getRows()[panel_id].children[0].children[1].children[1].children[0].text = totalNumberItem.total_pictures;
                $.tableViewTP.getSections()[0].getRows()[panel_id].children[0].children[1].children[1].children[0].color = badge_color;
                $.tableViewTP.getSections()[0].getRows()[panel_id].children[0].children[1].children[1].children[0].backgroundColor = badge_backgroundColor;
                $.tableViewTP.getSections()[0].getRows()[panel_id].children[0].children[1].children[1].children[0].font = {
                  fontWeight: 'bold', fontSize: 11 };



                $.tableViewTP.getSections()[0].getRows()[panel_id].children[0].children[0].children[0].text = Alloy.Globals.root.template[args.id].tabbed_panels[panel_id].title;
                $.tableViewTP.getSections()[0].getRows()[panel_id].children[0].children[0].children[0].font = {
                  fontSize: Alloy.Globals.fontSizeVal };

                $.tableViewTP.getSections()[0].getRows()[panel_id].children[0].children[0].children[0].color = colorTb;
                $.tableViewTP.getSections()[0].getRows()[panel_id].children[0].children[0].children[0].hasDetail = hasDetail;
                $.tableViewTP.getSections()[0].getRows()[panel_id].children[0].children[0].children[0].hasChild = hasChild;


                $.tableViewTP.getSections()[0].getRows()[panel_id].color = colorTb;
                $.tableViewTP.getSections()[0].getRows()[panel_id].backgroundColor = newBGColor;

                totalNumberItem = null,
                colorTb = null,
                changeColor = null,
                newBGColor = null,
                toCompare = null,
                hasRatings = null,
                hasDetail = null,
                hasChild = null,
                checkRatingSelected = null,
                total_items_checked = null,
                total_items = null;

                checkInspectionsAndDamagePanels = null;



              });





            } else {

              if (changeColor) {
                newBGColor = Alloy.Globals.rowReadColor;
              } else {
                newBGColor = Alloy.Globals.commentRowsBGColor;
              }

              var colorTb = changeColor ? Alloy.Globals.rowReadColor == '#E5E5E5' ? '#000000' : Alloy.Globals.commentRowsFGColor : Alloy.Globals.commentRowsBGColor == '#E5E5E5' ? '#000000' : Alloy.Globals.commentRowsFGColor;

              doLog && console.log(LOG_TAG, "total pictures--", Alloy.Globals.root.pictures.length);


              if (true) {

                Alloy.Globals.apm.leaveBreadcrumb(LOG_TAG + ' goToInspectionPanel() -> CALLBACK     .getSections()[0].getRows() : ' + $.tableViewTP.getSections()[0].getRows().length);
                Alloy.Globals.apm.leaveBreadcrumb(LOG_TAG + ' goToInspectionPanel() -> CALLBACK                       getData() : ' + $.tableViewTP.getData().length);

                $.tableViewTP.getSections()[0].getRows()[panelId].backgroundColor = newBGColor;
                $.tableViewTP.getSections()[0].getRows()[panelId].color = colorTb;
                $.tableViewTP.getSections()[0].getRows()[panelId].title = Alloy.Globals.root.template[args.id].tabbed_panels[panelId].title + ' ' + counterItem;
                $.tableViewTP.getSections()[0].getRows()[panelId].id = panelId;
                $.tableViewTP.getSections()[0].getRows()[panelId].hasDetail = hasDetail;
                $.tableViewTP.getSections()[0].getRows()[panelId].hasChild = hasChild;
                $.tableViewTP.getSections()[0].getRows()[panelId].font = {
                  fontSize: Alloy.Globals.fontSizeVal };


              } else {

                $.tableViewTP.updateRow(panelId, {
                  font: {
                    fontSize: Alloy.Globals.fontSizeVal },

                  color: colorTb,
                  backgroundColor: newBGColor,
                  title: Alloy.Globals.root.template[args.id].tabbed_panels[panelId].title,
                  id: panelId,
                  hasDetail: true,
                  hasChild: true });





              }
            }

          }


        } catch (err) {


        }

      };

      nextArgs.closePrev = function () {

        $.tabbedPanelWindow = null;
      };

      var inspectionPanelWindow = Alloy.createController('inspectionPanelWindow', nextArgs).getView();

      args.containingTab.open(inspectionPanelWindow, {
        animated: true });

    }

  }

  function searchBarOnCancel(e) {
    e.source.value = '';
  }

  function destroyController() {

    doLog && console.log(LOG_TAG, 'destroyController()');
    $.destroy();
    $.off();













  }


  doLog && console.log(LOG_TAG, ' orientation global ~~> isLands: : ', Alloy.Globals.isLandscape, ' isPort: ', Alloy.Globals.isPortrait);

  if (Alloy.Globals.countNarrativesPicturesSwitch) {
    Alloy.Globals.events.on('orientationchange', function () {

      doLog && console.log(LOG_TAG, '~~~~~~~~~~~~~~~~~~~~~~~~~~ START ORIENTATION EVENT ()~~~~~~~~~~~~~~~~~~~~~~~~~~~~~');

      if (Alloy.Globals.isLandscape) {

        $.tableViewTP.setData([]);
        destroyController();
        drawInfo(-1);

        doLog && console.log(LOG_TAG, '**** 1.0 ****');

      } else if (Alloy.Globals.isPortrait) {
        $.tableViewTP.setData([]);
        destroyController();
        drawInfo(-1);

        doLog && console.log(LOG_TAG, '**** 1.1 ****');

      }

      doLog && console.log(LOG_TAG, '~~~~~~~~~~~~~~~~~~~~~~~~~~ END ORIENTATION EVENT ()~~~~~~~~~~~~~~~~~~~~~~~~~~~~~');
    });
  }





  __defers['$.__views.tabbedPanelWindow!close!onClose'] && $.addListener($.__views.tabbedPanelWindow, 'close', onClose);__defers['$.__views.tabbedPanelWindow!open!onOpen'] && $.addListener($.__views.tabbedPanelWindow, 'open', onOpen);__defers['$.__views.searchBar!cancel!searchBarOnCancel'] && $.addListener($.__views.searchBar, 'cancel', searchBarOnCancel);__defers['$.__views.tableViewTP!singletap!throttledGoToInspectionPanel'] && $.addListener($.__views.tableViewTP, 'singletap', throttledGoToInspectionPanel);



  _.extend($, exports);
}

module.exports = Controller;