var Alloy = require('/alloy'),
Backbone = Alloy.Backbone,
_ = Alloy._;


function WPATH(s) {
  var index = s.lastIndexOf('/');
  var path = index === -1 ?
  'GalleryItem/' + s :
  s.substring(0, index) + '/GalleryItem/' + s.substring(index + 1);

  return path.indexOf('/') !== 0 ? '/' + path : path;
}

function __processArg(obj, key) {
  var arg = null;
  if (obj) {
    arg = obj[key] || null;
  }
  return arg;
}

function Controller() {
  var Widget = new (require('/alloy/widget'))('GalleryItem');this.__widgetId = 'GalleryItem';
  require('/alloy/controllers/' + 'BaseController').apply(this, Array.prototype.slice.call(arguments));
  this.__controllerPath = 'widget';
  this.args = arguments[0] || {};

  if (arguments[0]) {
    var __parentSymbol = __processArg(arguments[0], '__parentSymbol');
    var $model = __processArg(arguments[0], '$model');
    var __itemTemplate = __processArg(arguments[0], '__itemTemplate');
  }
  var $ = this;
  var exports = {};
  var __defers = {};







  $.__views.rowGallery = Ti.UI.createTableViewRow(
  { height: "92", selected: false, id: "rowGallery" });

  $.__views.rowGallery && $.addTopLevelView($.__views.rowGallery);
  onSwipe ? $.addListener($.__views.rowGallery, 'swipe', onSwipe) : __defers['$.__views.rowGallery!swipe!onSwipe'] = true;$.__views.mainHolder = Ti.UI.createView(
  { layout: "horizontal", height: "92", width: "100%", zIndex: 1, backgroundColor: "#FFFFFF", id: "mainHolder" });

  $.__views.rowGallery.add($.__views.mainHolder);
  $.__views.thumbHolder = Ti.UI.createView(
  { width: "100", height: "92", id: "thumbHolder" });

  $.__views.mainHolder.add($.__views.thumbHolder);
  $.__views.thumbImg = Ti.UI.createImageView(
  { top: "5", left: "5", id: "thumbImg" });

  $.__views.thumbHolder.add($.__views.thumbImg);
  $.__views.txtHolder = Ti.UI.createView(
  { layout: "vertical", left: "0", right: "0", top: "0", bottom: "0", height: "92", id: "txtHolder" });

  $.__views.mainHolder.add($.__views.txtHolder);
  $.__views.txtCaption = Ti.UI.createLabel(
  { top: 5, bottom: 5, height: Ti.UI.FILL, color: "#000", width: Titanium.UI.FILL, textAlign: "left", font: { fontSize: "15", fontFamily: "verdana,arial,sans-serif" }, left: "5", id: "txtCaption" });

  $.__views.txtHolder.add($.__views.txtCaption);
  $.__views.actionHolder = Ti.UI.createView(
  { layout: "vertical", top: "0", height: Ti.UI.FILL, width: "94", backgroundColor: "#FFF", id: "actionHolder" });

  $.__views.mainHolder.add($.__views.actionHolder);
  $.__views.__alloyId0 = Ti.UI.createView(
  { top: "23", height: Ti.UI.SIZE, width: "94", layout: "horizontal", backgroundColor: "#FFF", id: "__alloyId0" });

  $.__views.actionHolder.add($.__views.__alloyId0);
  $.__views.pencilIcon = Ti.UI.createButton(
  { backgroundColor: "white", backgroundImage: "none", borderWidth: "0", borderColor: "transparent", height: "45", width: "44", image: "/images/Pencil.png", left: "2", id: "pencilIcon", sourceType: "EditImageRow" });

  $.__views.__alloyId0.add($.__views.pencilIcon);
  $.__views.addSumaryIcon = Ti.UI.createButton(
  { backgroundColor: "white", backgroundImage: "none", borderWidth: "0", borderColor: "transparent", height: "45", width: "44", image: "/images/addSummary.png", left: "4", right: "0", id: "addSumaryIcon" });

  $.__views.__alloyId0.add($.__views.addSumaryIcon);
  $.__views.rightSwipeContainer = Ti.UI.createView(
  { height: Ti.UI.FILL, right: 0, zIndex: 0, backgroundColor: "white", layout: "horizontal", id: "rightSwipeContainer" });

  $.__views.rowGallery.add($.__views.rightSwipeContainer);
  exports.destroy = function () {};




  _.extend($, $.__views);



  var doLog = true;




  var LOG_TAG = '[Widget - GalleryRow]';




  var isButtonDisplayed = false;




  var hasRightSwipeContainer = false;



  var screen_width = false ? Ti.Platform.displayCaps.platformWidth : Ti.Platform.displayCaps.platformWidth / Ti.Platform.displayCaps.logicalDensityFactor;


  var moment = require('alloy/moment');

  var rightBtn;




  var buttons = {
    copy: {
      image: '/images/clipCopy.png',
      onClick: function () {
        $.trigger('buttonPress', {
          type: 'copyClip',
          pic_info: $.args });

        hideSwipeContainer();
      },
      backgroundColor: '#e0e0e0',
      color: '#000000' },

    delete: {
      image: '/images/iconTrash.png',
      onClick: function () {
        $.trigger('buttonPress', {
          type: 'deleteClip',
          info: $.args.info });

        hideSwipeContainer();
      },
      backgroundColor: '#cc0000',
      color: '#000000' } };








  Object.defineProperties($, {
    isButtonDisplayed: {
      get: function () {
        return isButtonDisplayed;
      },
      set: function (value) {
        isButtonDisplayed = value;
      } } });









  function onSwipe(e) {



    doLog && console.log(LOG_TAG, ' ~~~~>>  e.direction: ', e.direction);
    e.bubbles = true;


    if (e.direction === 'left') {

      if (isButtonDisplayed) {
        hideSwipeContainer();
      } else {
        if (hasRightSwipeContainer) {
          showSwipeRightContainer(e.index);
        }
      }
    } else if (e.direction === 'right') {
      if (isButtonDisplayed) {
        hideSwipeContainer();
      }
    }
  }





  function hideSwipeContainer() {
    doLog && console.log(LOG_TAG, '~~> To Close hideSwipeContainer()');
    $.mainHolder.animate({
      left: 0,
      right: 0,
      duration: 175 },
    function () {
      isButtonDisplayed = false;
    });
  }







  function createBtnOnSwipe(opts) {
    var button = buttons[opts.id];
    console.log(LOG_TAG, ' Button: ~~> ', JSON.stringify(opts), ' - ', JSON.stringify(button));
    var container = $.UI.create('View', {
      height: Ti.UI.FILL,
      width: '46',
      backgroundColor: button.backgroundColor });


    var holder = $.UI.create('View', {
      height: Ti.UI.SIZE,
      width: Ti.UI.SIZE,
      layout: 'vertical',
      touchEnabled: false });

    var icon = $.UI.create('ImageView', {


      image: button.image,

      touchEnabled: false });



    _.extend(container, {
      _id: opts.side });

    container.add(icon);
    container.addEventListener('click', button.onClick);
    return container;
  }




  function showSwipeRightContainer(rowIndexId) {

    $.mainHolder.animate({
      left: -92,
      right: 92,
      duration: 200 },
    function () {
      isButtonDisplayed = true;
      $.trigger('rowSwipe', rowIndexId, 0);
    });

  }



  (function init() {


    doLog && console.log(LOG_TAG, ' $.args: ', JSON.stringify($.args));

    var widthThumbHolder = 100,widthActionHolder = 95;
    var widthCalculate = screen_width - (widthThumbHolder + widthActionHolder);
    console.log('screen_width: ', screen_width);
    console.log('widthCalculate: ', widthCalculate);
    var toContinue = false;

    if ('info' in $.args && 'caption' in $.args.info) {
      $.rowGallery.info = $.args.info;
      toContinue = true;
    }

    if (toContinue) {
      if ($.args.info.isImage) {
        if ('imageId' in $.args.info) {
          $.rowGallery.imageId = $.args.info.imageId;
        }
        if ('imageFile' in $.args) {
          $.thumbImg.image = $.args.imageFile;
        }

        $.txtCaption.sourceType = 'ImageRow';
        $.rightSwipeContainer.width = '92';


      } else {
        if ('videoId' in $.args.info) {
          $.rowGallery.videoId = $.args.info.videoId;
          $.rowGallery.className = 'caption';
        }
        if ('videoThumb' in $.args) {
          $.thumbImg.image = $.args.info.thumb ? $.args.videoThumb.nativePath : '/images/videoPlaying.png';
          $.thumbImg.sourceType = 'PlayVideoRow';
        }

        $.txtCaption.sourceType = 'VideoRow';
        $.rightSwipeContainer.width = '46';

      }

      $.txtCaption.text = $.args.info.caption || 'Tap to Add Caption';
      $.txtHolder.width = widthCalculate;

    }


  })();








  $.setRightButtonOnSwipe = function (id) {
    var obj = {
      id: id,
      side: 'right' };

    var buttonOnSwipe = createBtnOnSwipe(obj);
    if (buttonOnSwipe) {
      $.rightSwipeContainer.add(buttonOnSwipe);
      hasRightSwipeContainer = true;
    }
  };





  $.hideSwipeContainer = hideSwipeContainer;





  __defers['$.__views.rowGallery!swipe!onSwipe'] && $.addListener($.__views.rowGallery, 'swipe', onSwipe);



  _.extend($, exports);
}

module.exports = Controller;