
var tabGroup, win;

function createNavBar(w) {

	var navBar = Ti.UI.createView({
		height: false ? 65 : 45,
		top: 0,
		backgroundColor: w.navTintColor || "#CCC"
	});

	var back = Ti.UI.createButton({
		left: 15,
		bottom: 5,
		top: 6,
		title: "< back",
		color: w.navTextColor || "#000",
		backgroundImage: "null",
		visible: false
	});

	var winTitle = Ti.UI.createLabel({
		top: 10,
		color: w.navTextColor || "#000",
		font: {
			fontWeight: "bold",
			fontSize: 18
		},
		text: w.title
	});

	w.leftNavButton = back;

	navBar.add(back);
	navBar.winTitle = winTitle;
	navBar.add(winTitle);

	w.navBar = navBar;
	w.add(navBar);
}

exports.createTabGroup = function (args) {

	if (false) {
		return Ti.UI.createTabGroup(args);
	}

	win = Ti.UI.createWindow(args);

	tabGroup = Ti.UI.createView({
		height: 55,
		top: 0,
		layout: "horizontal",
		backgroundColor: '#00345e'
	});

	win.add(tabGroup);

	tabGroup.open = function () {
		win.open();
	};
	tabGroup.addEventListener('postlayout', function (e) {
		args.tabs.forEach(function (tab, index) {
			var tabGrpWidth = tabGroup.size.width;
			var width = tabGrpWidth / args.tabs.length;
			if (index == 4) width = width - 5;
			tab.setWidth(width);
		});
	});

	args.tabs.forEach(function (tab, index) {
		tabGroup.add(tab);
		tab.window.top = 55;
		tab.window.bottom = 0;
		if (tab.window) tab.window.visible = false;
		win.add(tab.window);
		tab.window.children.forEach(function (child) {
			tab.window.add(child);
		});
	});
	if (args.tabs[0].window) args.tabs[0].window.visible = true;

	var lastTab = args.tabs[0];

	lastTab.caption.__color = lastTab.caption.color;
	lastTab.__bgcolor = lastTab.backgroundColor;

	lastTab.caption.color = lastTab.activeColor;
	lastTab.backgroundColor = lastTab.backgroundActiveColor;

	tabGroup.activeTab = args.tabs[0];
	tabGroup.setActiveTab = function (index) {

		if (lastTab) {
			if (lastTab.window) lastTab.window.visible = false;

			lastTab.caption.color = lastTab.caption.__color;
			lastTab.backgroundColor = lastTab.__bgcolor;
		}

		var tabToSetActive = args.tabs[index];

		tabToSetActive.caption.__color = tabToSetActive.caption.color;
		tabToSetActive.__bgcolor = tabToSetActive.backgroundColor;

		tabToSetActive.caption.color = tabToSetActive.activeColor;
		tabToSetActive.backgroundColor = tabToSetActive.backgroundActiveColor;

		tabGroup.activeTab = tabToSetActive;
		if (tabToSetActive.window) tabToSetActive.window.visible = true;

		tabGroup.fireEvent("focus", {
			type: "focus",
			previousTab: lastTab,
			previousIndex: _.indexOf(args.tabs, lastTab),
			tab: tabToSetActive,
			index: _.indexOf(args.tabs, tabToSetActive),
			source: tabGroup
		});

		lastTab = tabToSetActive;
	};

	tabGroup.addEventListener("click", function (e) {
		if (lastTab) {
			if (lastTab.window) lastTab.window.visible = false;

			lastTab.caption.color = lastTab.caption.__color;
			lastTab.backgroundColor = lastTab.__bgcolor;
		}

		if (e.source.window) e.source.window.visible = true;

		tabGroup.activeTab = e.source;

		e.source.__bgcolor = e.source.backgroundColor;
		e.source.backgroundColor = e.source.backgroundActiveColor;

		e.source.caption.__color = e.source.caption.color;
		e.source.caption.color = e.source.activeColor;

		tabGroup.fireEvent("focus", {
			type: "focus",
			previousTab: lastTab,
			previousIndex: _.indexOf(args.tabs, lastTab),
			tab: e.source,
			index: _.indexOf(args.tabs, e.source),
			source: tabGroup
		});

		lastTab = e.source;
	});

	return tabGroup;
};

exports.createTab = function (args) {

	if (false) {
		return Ti.UI.createTab(args);
	}

	var tab = Ti.UI.createView(args);

	var icon = {};
	if (args.icon) {
		Ti.API.info("tab have icon" + args.icon);
		icon = Ti.UI.createView({
			backgroundImage: args.icon,
			width: 26,
			height: 26,
			color: "#F00",
			top: 6,
			touchEnabled: false
		});
	}

	var caption = Ti.UI.createLabel({
		text: args.title,
		color: args.color || "#fff",
		bottom: 2,
		font: {
			fontSize: 11
		},
		touchEnabled: false
	});

	tab.icon = icon;
	tab.caption = caption;

	tab.add(icon);
	tab.add(caption);

	tab.open = function (args) {
		if (args.toString().indexOf("TiUIWindow")) {

			args.open();
		} else {
			throw "You need to pass a TiUIWindow";
		}
	};

	return tab;
};

exports.createWindow = function (args) {

	if (false) {
		return Ti.UI.createWindow(args);
	}

	var win = Ti.UI.createView(args);

	return win;
};