var data = [];
var argsForHeaderView = {};
argsForHeaderView.parent = $.inspectTab;

var doLog = true;
var LOG_TAG = '[inspectTab]';

doLog && console.log(LOG_TAG, ' Start');

//$.tableView.headerView = Alloy.createController('sliderHeaderView', argsForHeaderView).getView();
$.tableView.backgroundColor = Alloy.Globals.commentRowsBGColor;
$.inspectWindow.tableView = $.tableView;

function createMenuRow(row_data, hasTabedPanel) {
    //doLog && console.log(LOG_TAG, ' createMenuRow()', validate.combineRowAndLabelTextColor());
    //Ti.API.info(row_data.title);
    //var row = null;
    var rowLabel = Ti.UI.createLabel({
        font : {
            fontSize : Alloy.Globals.fontSizeVal
        },
        //color : (hasTabedPanel) ? '#000000' : validate.combineRowAndLabelTextColor(), //Alloy.Globals.commentRowsFGColor,
        color : '#000000',
        text : row_data.title,
        menuId : row_data.id,
        top : '5dp',
        bottom : '5dp',
        height : Ti.UI.SIZE,
        left : '10dp',
        right : '10dp',
        sourceType : 'ROW_HIGHLIGHTER'
    });
    var row = null;
    var row = Ti.UI.createTableViewRow({
        className : 'comment',
        backgroundColor : Alloy.Globals.commentRowsBGColor,
        rowData : row_data
    });
    row.add(rowLabel);
    return row;
};

function onRowClick(e) {
    doLog && console.log(LOG_TAG, 'e.source.sourceType', e.source.sourceType);
    switch (e.source.sourceType) {
    case "ROW_HIGHLIGHTER":
        doLog && console.log(LOG_TAG, 'ROW_HIGHLIGHTER');
        throttledGoToTabbedPanel(e);
        break;
    }
}

function loadInspectionJson() {

    var currInsp = Alloy.Globals.getCurrentInspection();
    Ti.API.info("currInsp:" + currInsp);
    if (currInsp != null && currInsp != '') {
        $.inspectWindow.title = currInsp;

    } else {
        $.inspectWindow.title = 'Inspect';
    }

}

function prepareTableviewData() {
    if (Alloy.Globals.root.template.length > 0) {
        data = [];
        for (i in Alloy.Globals.root.template) {
            var menu_item = Alloy.Globals.root.template[i];
            //doLog && console.log(LOG_TAG, ' menu_item: ', JSON.stringify(menu_item));
            //doLog && console.log(LOG_TAG, ' menu_item: ', JSON.stringify(menu_item.tabbed_panels));
            var row_data = {
                title : menu_item.title,
                id : i
            };
            if (menu_item.tabbed_panels.length > 0) {
                row_data.hasChild = true;
            } else {
                row_data.hasChild = false;
            }

            var result = _.every(Alloy.Globals.root.template[i].tabbed_panels, function(panel) {
                //console.log(LOG_TAG, 'panel: ',  JSON.stringify(panel));
                return panel.checked;
            });
            //doLog && console.log(LOG_TAG,'result: ', result );
            var row = createMenuRow(row_data, result);
            //doLog && console.log(LOG_TAG,'Alloy.Globals.rowReadColor: ', Alloy.Globals.rowReadColor, ' result: ', result );

            var colorIP = (result) ? (Alloy.Globals.rowReadColor == '#E5E5E5') ? '#000000' : Alloy.Globals.commentRowsFGColor : (Alloy.Globals.commentRowsBGColor == '#E5E5E5') ? '#000000' : Alloy.Globals.commentRowsFGColor;
            if (result) {
                row.backgroundColor = Alloy.Globals.rowReadColor;
                row.color = colorIP;
            }

            data.push(row);
            row = null;
            result = null;
        }
    } else {
        //Display message to sync template
        var alertNoTemplate = Titanium.UI.createAlertDialog({
            title : 'Sync First',
            message : 'No current inspection or templates found. Download a template first.',
            buttonNames : ['OK']
        });
        alertNoTemplate.addEventListener('click', function(e) {
        });
        alertNoTemplate.show();
    }
}

$.inspectTab.prepareTableviewData = prepareTableviewData;
function refreshTableview() {
    $.tableView.setData(data);
    data = null;
}

function checkMenuSelected(menuIndex) {
    var result = _.every(Alloy.Globals.root.template[menuIndex].tabbed_panels, function(panel) {
        return panel.checked;
    });
    return result;
}

$.inspectTab.refreshTableview = refreshTableview;
Alloy.Globals.refreshMenuTable = function() {
    $.inspectTab.prepareTableviewData();
    $.inspectTab.refreshTableview();
};
var throttledGoToTabbedPanel = _.debounce(goToTabbedPanel, 1000, true);
function goToTabbedPanel(e) {

    var row = (OS_IOS) ? e.row : e.row.rowData;
    if (row.rowData.hasChild) {
        var args = {};
        args.id = row.rowData.id;
        args.title = row.rowData.title;
        args.containingTab = $.inspectTab;
        args.callback = function(changeColor) {

            doLog && console.log(LOG_TAG, "goToTabbedPanel callback " + changeColor);

            if ($.tableView) {
                if (changeColor) {
                    row.backgroundColor = Alloy.Globals.rowReadColor;
                } else {
                    row.backgroundColor = Alloy.Globals.commentRowsBGColor;
                }
            }
        };
        var tabbedPanel = Alloy.createController('tabbedPanel', args).getView();

        tabbedPanel.addEventListener('close', function(e) {
            save();
        });

        $.inspectTab.open(tabbedPanel, {
            animated : true
        });
    }
}

function onLoad() {

    var currInsp = Alloy.Globals.getCurrentInspection();
    console.log('currInsp: ', currInsp);
    if (!currInsp) {
        $.tableView.setData([]);
        $.inspectWindow.title = 'No Inspection Found';
        return;
    }
    Ti.API.info("currInsp:" + currInsp);
    loadInspectionJson();
    prepareTableviewData();
    refreshTableview();
    Alloy.Globals.inspectionLoaded = true;
    
}

exports.reload = function() {

    onLoad();
};

function save() {

    var currInsp = Alloy.Globals.getCurrentInspection();

    if (currInsp && Alloy.Globals.root.template.length > 0) {
        if (currInsp.length == 0) {
            root.template = [];
            data = [];
        } else {

        }

    }

}

exports.save = save;
Alloy.Globals.saveInspection = save;