// The contents of this file will be executed before any of
// your view controllers are ever executed, including the index.
// You have access to all functionality on the `Alloy` namespace.
//
// This is a great place to do any initialization for your app
// or create any global variables/functions that you'd like to
// make available throughout your app. You can easily make things
// accessible globally by attaching them to the `Alloy.Globals`
// object. For example:
//
// Alloy.Globals.someGlobalFunction = function(){};


// added during app creation. this will automatically login to
// ACS for your application and then fire an event (see below)
// when connected or errored. if you do not use ACS in your
// application as a client, you should remove this block

Ti.App.Properties.setBool('doLog', true);
Alloy.Globals.countNarrativesPicturesSwitch = true;

//oreintation
Alloy.Globals.isLandscape = false;
Alloy.Globals.isPortrait = true;
 
// Monitor orientationchange constantly
Ti.Gesture.addEventListener('orientationchange', function(e) {
    if ([Ti.UI.LANDSCAPE_LEFT, Ti.UI.LANDSCAPE_RIGHT].indexOf(e.orientation) > -1) {
        //console.log('here landscape');
        Alloy.Globals.isLandscape = true;
        Alloy.Globals.isPortrait = false;
    } else {
        //console.log('here portrait');
        Alloy.Globals.isLandscape = false;
        Alloy.Globals.isPortrait = true;
    }
    // trigger event to watch for in the app globally
    Alloy.Globals.events.trigger('orientationchange');
});

(function() {
    if ([Ti.UI.LANDSCAPE_LEFT, Ti.UI.LANDSCAPE_RIGHT].indexOf(Ti.Gesture.orientation) > -1) {
        console.log('here landscape second');
        Alloy.Globals.isLandscape = true;
        Alloy.Globals.isPortrait = false;
    }
})();

/* Require the core lib */
require('Hip360/core');

/* Create the Alloy.Global objects */
Alloy.Globals.Layout = Hip360.Layout;

// Create Backbone event handler
Alloy.Globals.events = _.clone(Backbone.Events);

var root = {};
root.template = [];
root.pictures = [];
root.videos = [];

var arrayCreate = {"template":[{"id":0,"tabbed_panels":[{"damage_panels":[],"inspection_panels":[{"descr":"In Attendance:","id":3084,"options":[{"checked":false,"id":1,"is_red":false,"text":"Client present"},{"checked":false,"id":1,"is_red":false,"text":"Client present"},{"checked":false,"id":1,"is_red":false,"text":"Buyer Agent present"},{"checked":false,"id":1,"is_red":false,"text":"Selling Agent present"},{"checked":false,"id":1,"is_red":false,"text":"Seller present"},{"checked":false,"id":1,"is_red":false,"text":"Client not present"},{"checked":false,"id":1,"is_red":false,"text":"Agent present"},{"checked":false,"id":1,"is_red":false,"text":"Owner/Client present"},{"checked":false,"id":1,"is_red":false,"text":"Fully Participated"},{"checked":false,"id":1,"is_red":false,"text":"No other parties present at inspection."}],"sepChoice":"1","title":"Attendance"}],"pictures":[],"ratings":[],"title":"Attendance"}],"title":"Inspection Details"},{"id":1,"tabbed_panels":[{"damage_panels":[{"descr":"","id":2179,"options":[{"checked":false,"id":1,"is_red":false,"text":"Driveway in good shape for age and wear. No deficiencies noted."},{"checked":false,"id":1,"is_red":false,"text":"Driveway in good shape for age and wear. Some oil staining. Clean and seal to extend life."},{"checked":false,"id":1,"is_red":false,"text":"Driveway in good shape. Recommend sealing to extend life."},{"checked":false,"id":1,"is_red":false,"text":"The driveway is improperly sloped towards the foundation. Water can infiltrate into the interior. Recommend repairing or replacing the drive to properly slope away from the foundation."},{"checked":false,"id":1,"is_red":false,"text":"There are numerous areas of damaged concrete surfaces. Concrete replacement is expensive. Recommend a concrete specialist provide an estimate for repair and or replacing."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE:  Typical cracking was observed at the concrete surfaces. Further deterioration will occur as water expands and contracts from freeze and thaw cycles. Recommend sealing the cracks to prolong the life of the concrete."},{"checked":false,"id":1,"is_red":false,"text":"Uneven slabs at the driveway. "},{"checked":false,"id":1,"is_red":false,"text":"Uneven slabs at the driveway. This is a potential tripping hazard. Recommend repair and or replacement of the displaced walks."},{"checked":false,"id":1,"is_red":false,"text":"Monitor: Surface deterioration observed at the concrete surface. "},{"checked":false,"id":1,"is_red":false,"text":"Portions of the asphalt driveway has heavy cracking and displacement. Contact a driveway specialist to provide an estimate for replacing."},{"checked":false,"id":1,"is_red":false,"text":"Driveway improperly sloped towards the garage/Recommend slab jacking, repair or replacing the settled concrete."},{"checked":false,"id":1,"is_red":false,"text":"There are areas of damaged concrete surfaces."},{"checked":false,"id":1,"is_red":false,"text":"Improperly sloped towards foundation."},{"checked":false,"id":1,"is_red":false,"text":"Sealant observed between concrete drive and foundation. This is a temporary repair."},{"checked":false,"id":1,"is_red":false,"text":"Obtain an estimate for repairs or replacing before closing."},{"checked":false,"id":1,"is_red":false,"text":"There are minor predictable and common cracks in the asphalt. Monitor these areas for further movement or expansion and repair/seal as needed."},{"checked":false,"id":1,"is_red":false,"text":"Asphalt driveway appears new.  Highly recommend sealing within one year to extend life and maintain appearance."},{"checked":false,"id":1,"is_red":false,"text":"Sunken areas were observed with cracks and breaks."},{"checked":false,"id":1,"is_red":false,"text":"Gravel driveways need ongoing maintenance. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Minor settlement, or \"hairline\" cracks in driveways, are normal for properties of any age. They should, however, be monitored for expansion and sealed as necessary."},{"checked":false,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Moderate cracks in driveway.   Repair and / or monitor for expansion and development of trip hazards."},{"checked":false,"id":1,"is_red":false,"text":"Extensive cracks in driveway.   Repair and / or monitor for expansion and development of trip hazards."},{"checked":false,"id":1,"is_red":false,"text":"Concrete spalling noted at driveway.  This loosening of the top, smooth layer of the cement is a common occurrence, possibly due to an improper curing process, age, or use of snow-melting materials."},{"checked":false,"id":1,"is_red":false,"text":"Moderate cracks in sidewalk.   Repair and / or monitor for expansion and development of trip hazards."},{"checked":false,"id":1,"is_red":false,"text":"Extensive cracks in sidewalk.   Repair and / or monitor for expansion and development of trip hazards."},{"checked":false,"id":1,"is_red":false,"text":"Concrete spalling noted at sidewalk.  This loosening of the top, smooth layer of the cement is a common occurrence, possibly due to an improper curing process, age, or use of snow-melting materials."},{"checked":false,"id":1,"is_red":false,"text":"Potential Trip Hazard(s) at driveway; monitor / repair as necessary "},{"checked":false,"id":1,"is_red":false,"text":"Potential Trip Hazard(s) at sidewalk; monitor / repair as necessary.  "},{"checked":false,"id":1,"is_red":false,"text":"Snow covered; not fully inspected."},{"checked":false,"id":1,"is_red":false,"text":"Partially snow covered not fully inspected."},{"checked":false,"id":1,"is_red":false,"text":"Normal settlement / separation crack at concrete walk / steps junction."},{"checked":false,"id":1,"is_red":false,"text":"Water ponding in several places at walks, driveway & patios may present an ice hazard in winter."},{"checked":false,"id":1,"is_red":false,"text":"Storm drain at property line swale may pose a safety hazard; consider installing a grate over it to prevent falls."},{"checked":false,"id":1,"is_red":false,"text":"Common area maintained by association."}],"sepChoice":"4","title":"Driveway and Walkway Condition"}],"inspection_panels":[{"descr":"","id":3052,"options":[{"checked":true,"id":1,"is_red":false,"text":"Concrete driveway noted."},{"checked":true,"id":1,"is_red":false,"text":"Asphalt driveway noted."},{"checked":false,"id":1,"is_red":false,"text":"Gravel driveway noted."},{"checked":false,"id":1,"is_red":false,"text":"No driveway noted."},{"checked":false,"id":1,"is_red":false,"text":"Concrete sidewalk noted."},{"checked":false,"id":1,"is_red":false,"text":"Gravel sidewalk noted."},{"checked":false,"id":1,"is_red":false,"text":"Block / Brick sidewalk noted."},{"checked":false,"id":1,"is_red":false,"text":"No sidewalk noted."},{"checked":false,"id":1,"is_red":false,"text":"Gravel/dirt driveway and walks noted."},{"checked":false,"id":1,"is_red":false,"text":"Asphalt sidewalk noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood and stone walkways noted."},{"checked":false,"id":1,"is_red":false,"text":"Step stone sidewalk noted."},{"checked":false,"id":1,"is_red":false,"text":"Concrete, gravel and stone walkways noted."},{"checked":false,"id":1,"is_red":false,"text":"Driveway and walkways snow covered; not inspected. "}],"sepChoice":"1","title":"Driveway and Walkway"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":true,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Driveway and Walkway Condition Overall"}],"title":"Driveway/Walkway","checked":true},{"damage_panels":[{"descr":"","id":2189,"options":[{"checked":false,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection."},{"checked":true,"id":1,"is_red":true,"text":"Lot grading and drainage have a significant impact on the building, simply because of the direct and indirect damage that moisture can have on the foundation.  It is very important, therefore, that surface runoff water be  adequately diverted away from the home. Lot grading should slope away and fall a minimum of one (1) inch every foot for a distance of six (6) feet around the perimeter of the building."},{"checked":true,"id":1,"is_red":false,"text":"The exterior drainage is generally away from foundation."},{"checked":true,"id":1,"is_red":false,"text":"The exterior drainage is generally away from foundation -- except where noted below. "},{"checked":true,"id":1,"is_red":false,"text":"The exterior grading is improperly sloped towards the foundation. Water can intrude into the interior. Recommend creating the proper slope away from the foundation to allow for proper drainage."},{"checked":true,"id":1,"is_red":false,"text":"Low and settled grading was observed along the front flower bed.  Water can intrude under porch and affect the foundation. Critters can also infest. Repair as needed."},{"checked":true,"id":1,"is_red":false,"text":"The grading is improperly sloped towards the foundation."},{"checked":true,"id":1,"is_red":false,"text":"Perimeter Pavement:  Appears to slope towards building. Recommend taking measures to direct rainwater away."},{"checked":true,"id":1,"is_red":false,"text":"There are some low spots along the foundation. Recommend adding additional backfill to create the proper slope away from the house to allow for effective drainage."},{"checked":true,"id":1,"is_red":false,"text":"Recommend adding additional backfill to create the proper slope away from the foundation."},{"checked":false,"id":1,"is_red":false,"text":"See driveway observations"},{"checked":false,"id":1,"is_red":false,"text":"While performance of lot drainage and water handling systems may appear serviceable at the time of inspection, the inspector cannot always accurately predict this performance as conditions constantly change. Furthermore, items such as leakage in downspout/gutter systems are very difficult to detect during dry weather. Inspection of foundation performance and water handling systems, therefore, is limited to visible conditions and evidence of past problems."},{"checked":true,"id":1,"is_red":false,"text":"Low areas were observed. Backfill is recommended."},{"checked":true,"id":1,"is_red":false,"text":"Improper slope towards foundation"},{"checked":true,"id":1,"is_red":false,"text":"Highly recommend removing the firewood pile from such close proximity to the house. Present location invites animal/insect infestation and damage to property. "},{"checked":true,"id":1,"is_red":false,"text":"There is no extension on sump pump discharge pipe. Evidence of erosion near foundation exists. Extend discharge pipe, as needed, away from foundation to keep water away from foundation. Consider extending to the nearby drainage culvert."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Install window wells to prevent water penetration through the windows."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Install new raised-type drain guard at bottom of basement walk-out stairs. This type of drain guard resists clogging."},{"checked":false,"id":1,"is_red":false,"text":"MAINTENANCE: Concrete floor drain at bottom of basement walk-out stairs is partially blocked with leaves and debris.  This is a potential basement flooding situation during heavy rains and before Sump Pump can keep up.  This type of drain guard is easily clogged with leaves -- therefore, it must be monitored and kept clean. "},{"checked":false,"id":1,"is_red":false,"text":"MAINTENANCE: Concrete floor drain at bottom of basement walk-out stairs is partially blocked with leaves and debris.  This is a potential basement flooding situation during heavy rains.  This type of drain guard is easily clogged with leaves -- therefore, it must be monitored and kept clean. "},{"checked":false,"id":1,"is_red":false,"text":"Out buildings and sheds are excluded from this report."},{"checked":false,"id":1,"is_red":false,"text":"Koi Pond present, not inspected by the inspector."},{"checked":false,"id":1,"is_red":false,"text":"Siding to Soil contact or proximity.  This may provide entrance of moisture or insects to siding.  Recommend grading soil so there is at least 6\" of space (where practical) between the siding and the soil below and checking for any damaged trim and siding materials."},{"checked":false,"id":1,"is_red":false,"text":"Retaining Wall shows signs of deterioration."},{"checked":false,"id":1,"is_red":false,"text":"Reverse slope at splash block(s).  Recommend sloping away from house so that water is carried away from foundation.  "},{"checked":false,"id":1,"is_red":false,"text":"Lack of uphill drain ditch or basin.  Monitor, as water may flow toward foundation. "},{"checked":false,"id":1,"is_red":false,"text":"Too much debris sitting up against exterior walls."},{"checked":false,"id":1,"is_red":false,"text":"There are separations in the seal between foundation and walkway; seal the walk way to foundation with appropriate caulking methods."},{"checked":false,"id":1,"is_red":false,"text":"The backyard patio concrete is severely cracked which will allow water to seep in and contribute to groundwater seepage potential."},{"checked":false,"id":1,"is_red":false,"text":"The walkway along the home should be sealed with a good caulk to help prevent water from draining along foundation wall."},{"checked":false,"id":1,"is_red":false,"text":"Unable to determine conditions of grade due to snow cover. Make sure that when the ground does become visible that you correct any areas of grade that pitch towards the foundation wall. Always avoid allowing excess water to stand next to the home."},{"checked":false,"id":1,"is_red":false,"text":"Snow covered; not fully inspected."}],"sepChoice":"4","title":"Grading"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":true,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":true,"text":"None"}],"sepChoice":"","title":"Grading Overall"}],"title":"Grading","checked":true},{"damage_panels":[{"descr":"","id":2212,"options":[{"checked":true,"id":1,"is_red":false,"text":"No major system safety or functional concerns noted at time of inspection."},{"checked":true,"id":1,"is_red":false,"text":"Prune or remove any plants that are in contact or proximity to home to eliminate pathways of wood destroying insects."},{"checked":true,"id":1,"is_red":false,"text":"Tree limbs within 10 feet of roof should be trimmed away to provide air and sunlight to roof, while minimizing debris & dampness."},{"checked":false,"id":1,"is_red":false,"text":"Trim trees that are in contact or proximity to home, as branches can abrade roofing or siding. "},{"checked":false,"id":1,"is_red":false,"text":"Trees in proximity to electric lines are a wind and icing hazard.  Contact utility company for trimming."},{"checked":false,"id":1,"is_red":false,"text":"Trees are within 6 feet of foundation. Monitor for potential root damage. "},{"checked":false,"id":1,"is_red":false,"text":"Tree branches are at eye level and a potential injury hazard.  "},{"checked":false,"id":1,"is_red":false,"text":"Tree branches overhanging roof and/or against siding.  Trim trees that are in contact or proximity to home, as branches can abrade siding and damage roofing. "},{"checked":false,"id":1,"is_red":false,"text":"Trees that grow too close, or overhang property, should be trimmed back.  This will help reduce the frequency of having to clean out the gutters, which should be done on a regular basis."},{"checked":false,"id":1,"is_red":false,"text":"Tree stump with apparent carpenter ant damage in proximity to home; recommend treatment or removal to keep wood destroying insects away from home.  Consider professional pest treatment.  See photos."},{"checked":false,"id":1,"is_red":false,"text":"Bamboo noted growing in yard. This is often considered to be an unwelcome and invasive species."},{"checked":false,"id":1,"is_red":false,"text":"Maintenance Tip:  When landscaping, keep plants, even at full growth, at least a foot (preferably 18 inches) from house siding and windows.  Keep trees away from foundation and roof.  Plants in contact or proximity to home can provide pathways for wood destroying insects, as well as abrade and damage siding, screens and roofs."},{"checked":false,"id":1,"is_red":false,"text":"The property has overgrown vegetation that needs to be landscaped. The front of home was maintained but the left side has overgrown bushes that are obscuring windows, the gas meter and the foundation."},{"checked":false,"id":1,"is_red":false,"text":"Shed roof is completely covered in moss."},{"checked":false,"id":1,"is_red":false,"text":"There is a large tree close to the structure, in a side lot.  The roots may cause problems with the plumbing system, and the leaves and branches can potentially fall onto the roof, clog the gutters and cause roofing damage."},{"checked":false,"id":1,"is_red":false,"text":"Snow covered; not fully inspected."}],"sepChoice":"4","title":"Vegetation Observations"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":true,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Vegetation Observations Overall"}],"title":"Vegetation","checked":true},{"damage_panels":[{"descr":"","id":2188,"options":[{"checked":false,"id":1,"is_red":false,"text":"Fences and gates are NOT INCLUDED as part of a home inspection.  Recommend confirming that all fences and gates are in serviceable condition before the close of escrow."},{"checked":false,"id":1,"is_red":false,"text":"Gate hardware missing or damaged; gate will not secure."},{"checked":false,"id":1,"is_red":false,"text":"Damaged gate observed."},{"checked":false,"id":1,"is_red":false,"text":"Gate is sagging."},{"checked":false,"id":1,"is_red":false,"text":"Gate sticks."},{"checked":false,"id":1,"is_red":false,"text":"Gates were locked at the time of inspection, did not operate."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the fences/gates are near the end of their useful life."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review of all gates for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Wood deterioration observed. Suggest repair or replacement as needed."}],"sepChoice":"4","title":"Gate Condition"}],"inspection_panels":[{"descr":"","id":3055,"options":[{"checked":true,"id":1,"is_red":false,"text":"Wood"},{"checked":true,"id":1,"is_red":false,"text":"Wrought iron"},{"checked":true,"id":1,"is_red":false,"text":"Chain link"},{"checked":true,"id":1,"is_red":false,"text":"Plastic"},{"checked":false,"id":1,"is_red":false,"text":"Aluminum"}],"sepChoice":"1","title":"Gate Material"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":true,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Gate Condition Overall"}],"title":"Gates","checked":true},{"damage_panels":[{"descr":"","id":2183,"options":[{"checked":true,"id":1,"is_red":false,"text":"Appeared functional at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Appears in satisfactory and functional condition with normal wear for its age."},{"checked":false,"id":1,"is_red":false,"text":"MAINTENANCE: Whether treated or not, it is important to keep a wood deck surface free of all forms of fungal growth and debris that retains moisture and will cause the deck to eventually rot. Recommend cleaning and resealing the deck annually. Cleaning can be accomplished by scrubbing the deck with a sodium-hypochlorite (bleach) and Tri-Sodium-Phosphate (TSP) deck wash and then rinsing with a pressure washer. Finally, a wood deck should be recoated with a high quality deck sealant.      "},{"checked":false,"id":1,"is_red":false,"text":"MAINTENANCE: Even decks of composite lumber need periodic maintenance to keep them free of algae and mold that can make the surface very slick. Recommend cleaning composite decks annually by scrubbing with a solution of: 1/3 cup laundry soap; 2/3 cup Tri-Sodium-Phosphate (TSP); one quart bleach; and 3 quarts of water. Rinse with a hose--Do Not Use a Pressure-Washer on composite lumber."},{"checked":false,"id":1,"is_red":false,"text":"Rotted Wood."},{"checked":false,"id":1,"is_red":false,"text":"Unstable supports."},{"checked":false,"id":1,"is_red":false,"text":"Reverse Grading."},{"checked":false,"id":1,"is_red":false,"text":"No flashing present."},{"checked":false,"id":1,"is_red":false,"text":"Floor boards damaged."},{"checked":false,"id":1,"is_red":false,"text":"Floor boards rotted."},{"checked":false,"id":1,"is_red":false,"text":"Improper fasteners."},{"checked":false,"id":1,"is_red":false,"text":"Lag bolts not present."},{"checked":false,"id":1,"is_red":false,"text":"Improper attachment of ledger board."},{"checked":false,"id":1,"is_red":false,"text":"Missing fasteners at joist hangers."},{"checked":false,"id":1,"is_red":false,"text":"Joist deck hangers are missing nails. Have all reviewed for adding additional nails."},{"checked":false,"id":1,"is_red":false,"text":"Have the deck reviewed for proper installation and attachment. Check for history of permits."},{"checked":false,"id":1,"is_red":false,"text":"Loose fasteners were observed. Review all fasteners and secure as needed."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Consider upgrading to new composite lumber decking material. "},{"checked":false,"id":1,"is_red":false,"text":"Deck ledger board lacking flashing. Flashing protects the ledger and keeps water away from the side of the house. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"The deck joists are set too far apart for the existing decking boards - as placed on a 45 degree angle to the joists. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Today's deck construction, support, and attachment standards typically call for proper footings, 6X6 posts, and 1/2 inch bolts securing deck to the beam and the house. Not all of these elements appear to be present. Consider upgrading deck to current standards."},{"checked":false,"id":1,"is_red":false,"text":"Missing handrails and balusters."},{"checked":false,"id":1,"is_red":false,"text":"Balusters spaced to far apart."},{"checked":false,"id":1,"is_red":false,"text":"There is wood and soil contact at step supports.  Deterioration may occur."},{"checked":false,"id":1,"is_red":false,"text":"Non-conforming steps, possible safety hazard."},{"checked":false,"id":1,"is_red":false,"text":"The steps are slanted and present a possible slipping hazard."},{"checked":false,"id":1,"is_red":false,"text":"Rails missing at exterior steps, and should be installed for safety."},{"checked":false,"id":1,"is_red":false,"text":"Settlement crack at base of front steps.  Monitor and repair as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Steps are deteriorated and should be evaluated for repair or replacement."},{"checked":false,"id":1,"is_red":false,"text":"Broken / missing step(s)."},{"checked":false,"id":1,"is_red":false,"text":"Clean and Seal Deck:  Recommend cleaning deck and treating with a waterproof sealant claiming to waterproof, block ultraviolet light, and stop mildew."},{"checked":false,"id":1,"is_red":false,"text":"Some deck boards are damaged, and some others need securing."},{"checked":false,"id":1,"is_red":false,"text":"Wood to Soil Contact at deck supports.  Deterioration may occur and insects may gain access to wood."},{"checked":false,"id":1,"is_red":false,"text":"Decking board spacing less than 3/8\". Recommend cleaning deck frequently to avoid accumulation of organic debris causing trapped moisture and eventual rot."},{"checked":false,"id":1,"is_red":false,"text":"Deck Substructure Inspection excluded, due to limited access because of low height or obstructions."},{"checked":false,"id":1,"is_red":false,"text":"Deck installed without supporting bracket hardware.  Recommend installing brackets.  "},{"checked":false,"id":1,"is_red":false,"text":"No Lag Bolts Visible:  The deck ledger board is nailed or screwed to the house, or is covered and not visible. Consider installing lag screws to securely attach ledger board to house, if they have not been used.  "},{"checked":false,"id":1,"is_red":false,"text":"Elevation changes at deck and deck steps; recommend caution and some type of visual alert.  "},{"checked":false,"id":1,"is_red":false,"text":"Deck has two levels that visually blend, which may be a potential fall hazard.  Recommend bright colored tape or paint at edge of step for safety. "},{"checked":false,"id":1,"is_red":false,"text":"Deck physically shakes / sways when walking on it; recommend evaluation / repair by contractor."},{"checked":false,"id":1,"is_red":false,"text":"Flexing deck boards - some boards have \"bounce\" to them and may need re-securing under the carpeted area at deck"},{"checked":false,"id":1,"is_red":false,"text":"Gate at deck will not secure."},{"checked":false,"id":1,"is_red":false,"text":"The deck joists are set too far apart for the existing decking boards - as placed on a 45 degree angle to the joists. Repair as needed."}],"sepChoice":"4","title":"Patio and Porch Deck","checked":true},{"descr":"","id":2184,"options":[{"checked":false,"id":1,"is_red":false,"text":"Appeared functional at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"There were no railings installed at the steps. Location: .  "},{"checked":false,"id":1,"is_red":false,"text":"There were no railings installed at the steps. Location: . This is a potential tripping hazard. Recommend installing protective railings. "},{"checked":false,"id":1,"is_red":false,"text":"The metal railing is damaged."},{"checked":false,"id":1,"is_red":false,"text":"The metal railing is showing areas of rust.  Refinish, prime and paint as needed."},{"checked":false,"id":1,"is_red":false,"text":"Missing handrails and balusters."},{"checked":false,"id":1,"is_red":false,"text":"Unstable railings are present."},{"checked":false,"id":1,"is_red":false,"text":"Balusters spaced too far apart."},{"checked":false,"id":1,"is_red":false,"text":"Handrail should be installed at a height of no less than 34\" and no higher than 38\"."},{"checked":false,"id":1,"is_red":false,"text":"Although railings are not required with drop-offs less than 30\" above grade - consider your own personal needs and those of your family and guests. By today's standards, balusters (spindles) at decks and steps should be spaced no more than 4\" apart for the safety of small children,"},{"checked":false,"id":1,"is_red":false,"text":"Guardrail(s) lower than 36\", or need repair / installation above drop-offs higher than 30\"."},{"checked":false,"id":1,"is_red":false,"text":"Spindles missing; safety hazard. "},{"checked":false,"id":1,"is_red":false,"text":"Spindle spacing exceeds the 4 inch spacing which is considered safe by today’s child safety standards.  "},{"checked":false,"id":1,"is_red":false,"text":"Rails missing in areas with drop offs of greater than 30 inches.  Recommend installation of rails for safety."},{"checked":false,"id":1,"is_red":false,"text":"Porch railing not secure."},{"checked":false,"id":1,"is_red":false,"text":"Handrail not graspable at ____.  By today's standards, rails should be configured so that a hand may grasp around a rail for safety."}],"sepChoice":"4","title":"Stairs & Handrail","checked":true}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":true,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Patio and Porch Deck Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":true,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Stairs & Handrail Overall"}],"title":"Deck/Stairs","checked":true},{"damage_panels":[{"descr":"","id":2185,"options":[{"checked":true,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Covers or globes recommended over bare light bulbs."},{"checked":false,"id":1,"is_red":false,"text":"."},{"checked":false,"id":1,"is_red":false,"text":"OUTLETS:"},{"checked":false,"id":1,"is_red":false,"text":"Outlet cover(s) are for interior use and are not waterproof. "},{"checked":false,"id":1,"is_red":false,"text":"GFCI trip test failed.   "},{"checked":false,"id":1,"is_red":false,"text":"Open ground (or 2-wire) outlets present.  This means that the 3rd (round) part of an appliance plug is not getting ground protection.  This may be a concern with items such as computers and electronic devices."},{"checked":false,"id":1,"is_red":false,"text":"Hot-neutral reversed outlets present.  This means that the black and white wires in the circuit have been reversed, and may be a concern with items such as computers and electronic devices."},{"checked":false,"id":1,"is_red":false,"text":"Outlet damaged or apparently inoperable. "},{"checked":false,"id":1,"is_red":false,"text":"."},{"checked":false,"id":1,"is_red":false,"text":"SWITCHES:"},{"checked":false,"id":1,"is_red":false,"text":"missing switch plate covers were found, make sure they are replaced."},{"checked":false,"id":1,"is_red":false,"text":"The service shutoff for the steamer unit is located inside the laundry closet; and positioned in a way that makes it extremely difficult to access. "},{"checked":false,"id":1,"is_red":false,"text":"Switches are outdated and replacements may be hard to find; have an electrician upgrade them along with the receptacles."},{"checked":false,"id":1,"is_red":false,"text":"Poor, unprofessional installation of switch that controls the under cabinet lighting."},{"checked":false,"id":1,"is_red":false,"text":"The switches located in upstairs hallway are not functioning or their purpose is unknown."},{"checked":false,"id":1,"is_red":false,"text":"Light switches are often rocker type."},{"checked":false,"id":1,"is_red":false,"text":"Incomplete installation "},{"checked":false,"id":1,"is_red":false,"text":"Switch cover not waterproof."},{"checked":false,"id":1,"is_red":false,"text":"Light switch damaged or bulb inoperable."},{"checked":false,"id":1,"is_red":false,"text":"."},{"checked":false,"id":1,"is_red":false,"text":"WIRES:"},{"checked":false,"id":1,"is_red":false,"text":"Extension cord used in lieu of \"hard wire”."},{"checked":false,"id":1,"is_red":false,"text":"Interior grade Romex should be replaced with exterior-rated Romex and enclosed in conduit."},{"checked":false,"id":1,"is_red":false,"text":"Junction Box Covers missing or damaged; install cover for safety."},{"checked":false,"id":1,"is_red":false,"text":"Connections made outside of a Junction Box, which is a potential shock or electrocution hazard. "},{"checked":false,"id":1,"is_red":false,"text":"Frayed wire sheathing; possible shock or electrocution hazard.  Repair or replacement recommended."},{"checked":false,"id":1,"is_red":false,"text":"Wire ends are outside of a Junction Box, which is a potential shock or electrocution hazard."},{"checked":false,"id":1,"is_red":false,"text":"Live Bare Wire Ends, shock or electrocution hazard. See photo."},{"checked":false,"id":1,"is_red":false,"text":"."},{"checked":false,"id":1,"is_red":false,"text":"SERVICE ENTRANCE:"},{"checked":false,"id":1,"is_red":false,"text":"Overhead electrical service clearance -   Service conductors have inadequate height clearance from the ground. Requirements are as follows: 10 feet above a walkway (including decks and balconies), 12 feet above a drive, 18 feet above a roadway and 3 feet from an openable window. Contact local public service company to inquire about correction."},{"checked":false,"id":1,"is_red":false,"text":"- Electrical Service Wires: Less than 10' above ground.  "},{"checked":false,"id":1,"is_red":false,"text":"- Electrical Service Wires: Less than 12' above driveway.  "},{"checked":false,"id":1,"is_red":false,"text":"- Electrical Service Wires: Less than 3' from door or window openings.  "},{"checked":false,"id":1,"is_red":false,"text":"- Electrical Service Wires damaged.  See photo."},{"checked":false,"id":1,"is_red":false,"text":"- Electrical Service Mast: Bent / Loose.  "},{"checked":false,"id":1,"is_red":false,"text":"The Utility company seal is missing  from the meter. This will not affect electric service but the utility company should be notified so a new seal can be installed."},{"checked":false,"id":1,"is_red":false,"text":"Drip loop not present at weatherhead. This condition may allow moisture intrusion, resulting in damage to electrical components. Correction should be made by a qualified electrical contractor."},{"checked":false,"id":1,"is_red":false,"text":"Exterior breaker panel cover adjacent to meter is unsecured at hinges and should be repaired.  See photo."},{"checked":false,"id":1,"is_red":false,"text":"Exterior lights and fixtures have yet to be installed."},{"checked":false,"id":1,"is_red":false,"text":"Note that the main exterior disconnect is located at the side porch, under the decorative table."},{"checked":false,"id":1,"is_red":false,"text":"Garage exterior light loose from siding."},{"checked":false,"id":1,"is_red":false,"text":"Non-standard wiring from house to barn should be evaluated and repaired by licensed electrician."},{"checked":false,"id":1,"is_red":false,"text":"Bare electrical wire ends in detached root cellar should be enclosed in a box or removed."},{"checked":false,"id":1,"is_red":false,"text":"Service mast for (telephone line?) is bent, presumably from snow sliding on roof, and cable is abrading against roof."}],"sepChoice":"4","title":"Grounds Electrical","checked":true},{"descr":"","id":2186,"options":[{"checked":true,"id":1,"is_red":false,"text":"None visible."},{"checked":false,"id":1,"is_red":false,"text":"Weatherproof outlets—Exterior outlet / switch cover(s) not waterproof. Have certified electrician evaluate and repair as necessary."},{"checked":false,"id":1,"is_red":false,"text":"No Ground Fault Circuit Interrupter (GFCI) protection of home electrical outlets was provided in the home at the time of inspection. Although GFCI protection may not have been required at the time the home was built, for safety reasons, consider upgrading the electrical system to include GFCI protection at the following locations:\n•\tBathrooms \n•\tOutside \n•\tGarages \n•\tCrawlspace (at or below grade) \n•\tUnfinished basements \n•\tKitchens \n•\tLaundry rooms \n•\tWithin 6 feet of all plumbing fixtures\n•\tBoathouses \n"},{"checked":false,"id":1,"is_red":false,"text":"The exterior \"patio\" outlet GFCI did not shut of when tested, have a qualified electrician replace it."},{"checked":false,"id":1,"is_red":false,"text":"Replace the grounded outlet receptacle under \"utility sink\" located in mechanical closet with a GFCI protected receptacle as this is considered a wet location."},{"checked":false,"id":1,"is_red":false,"text":"Outlets in the basement were not Ground Fault Circuit Interrupter (GFCI) protected. Adding GFCI protection is relatively inexpensive. All electrical work should be performed by a qualified electrical contractor.\nConsider adding GFCI protection of these outlets.\n"},{"checked":false,"id":1,"is_red":false,"text":"Ejector pump outlet was not a GFCI protected receptacles, Have a qualified electrician replace with GFCIs."},{"checked":false,"id":1,"is_red":false,"text":"GFCI receptacles are in good condition."},{"checked":false,"id":1,"is_red":false,"text":"Outdoor receptacles are not GFCI protected, need to be updated."},{"checked":false,"id":1,"is_red":false,"text":"GFCI: Ground Fault Circuit interrupter ."},{"checked":false,"id":1,"is_red":false,"text":"GFCI not grounded."},{"checked":false,"id":1,"is_red":false,"text":"None."},{"checked":false,"id":1,"is_red":false,"text":"Missing cover."},{"checked":false,"id":1,"is_red":false,"text":"GFCI, lights & fans on same circuit."},{"checked":false,"id":1,"is_red":false,"text":"Irregular installation."},{"checked":false,"id":1,"is_red":false,"text":"Painted over."},{"checked":false,"id":1,"is_red":false,"text":"Reset button worn."},{"checked":false,"id":1,"is_red":false,"text":"Reset button stuck."},{"checked":false,"id":1,"is_red":false,"text":"Would not reset."},{"checked":false,"id":1,"is_red":false,"text":"Did not test."},{"checked":false,"id":1,"is_red":false,"text":"Could not locate GFCI reset."},{"checked":false,"id":1,"is_red":false,"text":"Reset is in the main panel."},{"checked":false,"id":1,"is_red":false,"text":"Reset is in the garage."}],"sepChoice":"4","title":"GFCI","checked":true}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":true,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Grounds Electrical Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":true,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"GFCI Overall"}],"title":"Electrical","checked":true},{"damage_panels":[{"descr":"","id":2251,"options":[{"checked":false,"id":1,"is_red":false,"text":"Meter located at exterior. All gas appliances have cut-off valves in line at each unit. No gas odors detected."},{"checked":false,"id":1,"is_red":false,"text":"Missing shut off valves."},{"checked":false,"id":1,"is_red":false,"text":"The gas service is off to the structure. The inspector cannot inspect this system."},{"checked":false,"id":1,"is_red":false,"text":"There is a gas smell present at the main valve. We recommend contacting the gas utility company to repair."}],"sepChoice":"4","title":"Main Gas Valve Condition"}],"inspection_panels":[{"descr":"","id":3083,"options":[{"checked":true,"id":1,"is_red":false,"text":"North side."},{"checked":true,"id":1,"is_red":false,"text":"East side."},{"checked":true,"id":1,"is_red":false,"text":"South side."},{"checked":true,"id":1,"is_red":false,"text":"West side."},{"checked":false,"id":1,"is_red":false,"text":"At curb only."},{"checked":false,"id":1,"is_red":false,"text":"Front of structure."},{"checked":false,"id":1,"is_red":false,"text":"Rear of structure."},{"checked":false,"id":1,"is_red":false,"text":"Exterior of structure."},{"checked":false,"id":1,"is_red":false,"text":"Under structure."},{"checked":false,"id":1,"is_red":false,"text":"Parking structure."},{"checked":false,"id":1,"is_red":false,"text":"Could not locate."},{"checked":false,"id":1,"is_red":false,"text":"Main gas shut off located at outside meter - East side."},{"checked":false,"id":1,"is_red":false,"text":"LP Gas shutoff located at the gas manifold - labeled and client made aware."}],"sepChoice":"1","title":"Main Gas Valve"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":true,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Main Gas Valve Condition Overall"}],"title":"Main Gas Valve","checked":true},{"damage_panels":[{"descr":"","id":2190,"options":[{"checked":false,"id":1,"is_red":false,"text":"Sewer line— Due to the fact that the home was not well maintained I do recommend a sewer line inspection. This separate inspection will show the condition of the buried sewer line from the home to the city main. Items such as tree roots, broken drain pipes, and other obstructions will be\nrevealed."},{"checked":false,"id":1,"is_red":false,"text":"Sewer line—Due to the age of this home I recommend a sewer line inspection. This separate inspection will show the condition of the buried sewer line from the home to the city main. Items such as tree roots, broken drain pipes, and other obstructions will be revealed. A qualified plumber with a sewer camera sewer rodding machine can inspect."},{"checked":false,"id":1,"is_red":false,"text":"Septic system noted.  Client is advised to seek the services of a specialist in evaluating this system.\n"},{"checked":false,"id":1,"is_red":false,"text":"Potable water supplied by well.  Suggest water testing within inspection contingency period."},{"checked":false,"id":1,"is_red":false,"text":"Most n/a due to insulation covering the pipe."},{"checked":false,"id":1,"is_red":false,"text":"Corrosion is noted. Consult with a licensed plumbing contractor to determine and correct the cause of the issue."},{"checked":false,"id":1,"is_red":false,"text":"Rust is noted. Consult with a licensed plumbing contractor to determine and correct the cause of the issue."},{"checked":false,"id":1,"is_red":false,"text":"Visible leaking is noted. Consuls with a licensed plumbing contractor to determine and correct the cause of the issue."},{"checked":false,"id":1,"is_red":false,"text":"Copper to galvanized missing proper connections. This condition will lead to a galvanic reaction which will corrode the pipes. Contact a licensed plumbing contractor to have the proper fittings installed."},{"checked":false,"id":1,"is_red":false,"text":"Recommend contacting a licensed plumber to evaluate all areas."},{"checked":false,"id":1,"is_red":false,"text":"Front water spigot defective; leaks."}],"sepChoice":"4","title":"Plumbing"}],"inspection_panels":[{"descr":"","id":3056,"options":[{"checked":true,"id":1,"is_red":false,"text":"Copper piping noted."},{"checked":true,"id":1,"is_red":false,"text":"Galvanized piping noted."},{"checked":false,"id":1,"is_red":false,"text":"Aquapex piping noted."},{"checked":false,"id":1,"is_red":false,"text":"PVC piping noted."}],"sepChoice":"1","title":"Plumbing Material Type"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":true,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Plumbing Overall"}],"title":"Plumbing","checked":true},{"damage_panels":[{"descr":"","id":2192,"options":[{"checked":true,"id":1,"is_red":false,"text":"High pressure."},{"checked":false,"id":1,"is_red":false,"text":"recommend 80 psi"},{"checked":false,"id":1,"is_red":false,"text":"Low pressure."},{"checked":false,"id":1,"is_red":false,"text":"n/a"},{"checked":false,"id":1,"is_red":false,"text":"20"},{"checked":false,"id":1,"is_red":false,"text":"25"},{"checked":false,"id":1,"is_red":false,"text":"30"},{"checked":false,"id":1,"is_red":false,"text":"35"},{"checked":false,"id":1,"is_red":false,"text":"40"},{"checked":false,"id":1,"is_red":false,"text":"45"},{"checked":false,"id":1,"is_red":false,"text":"50"},{"checked":false,"id":1,"is_red":false,"text":"55"},{"checked":false,"id":1,"is_red":false,"text":"60"},{"checked":false,"id":1,"is_red":false,"text":"65"},{"checked":false,"id":1,"is_red":false,"text":"70"},{"checked":false,"id":1,"is_red":false,"text":"75"},{"checked":false,"id":1,"is_red":false,"text":"80"},{"checked":false,"id":1,"is_red":false,"text":"85"},{"checked":false,"id":1,"is_red":false,"text":"90"},{"checked":false,"id":1,"is_red":false,"text":"95"},{"checked":false,"id":1,"is_red":false,"text":"100"},{"checked":false,"id":1,"is_red":false,"text":"105"},{"checked":false,"id":1,"is_red":false,"text":"110"},{"checked":false,"id":1,"is_red":false,"text":"115"},{"checked":false,"id":1,"is_red":false,"text":"120"},{"checked":false,"id":1,"is_red":false,"text":"125"},{"checked":false,"id":1,"is_red":false,"text":"130"},{"checked":false,"id":1,"is_red":false,"text":"135"},{"checked":false,"id":1,"is_red":false,"text":"140"},{"checked":false,"id":1,"is_red":false,"text":"145"},{"checked":false,"id":1,"is_red":false,"text":"150"},{"checked":false,"id":1,"is_red":false,"text":"155"},{"checked":false,"id":1,"is_red":false,"text":"160"},{"checked":false,"id":1,"is_red":false,"text":"165"},{"checked":false,"id":1,"is_red":false,"text":"170"},{"checked":false,"id":1,"is_red":false,"text":"175"},{"checked":false,"id":1,"is_red":false,"text":"Water is turned off to the structure."},{"checked":false,"id":1,"is_red":false,"text":"psi"}],"sepChoice":"4","title":"Water Pressure","checked":true},{"descr":"","id":2193,"options":[{"checked":true,"id":1,"is_red":false,"text":"None."},{"checked":false,"id":1,"is_red":false,"text":"Pressure regulator noted."},{"checked":false,"id":1,"is_red":false,"text":"The pressure regulator is leaking."},{"checked":false,"id":1,"is_red":false,"text":"We recommend the installation of a pressure regulator."},{"checked":false,"id":1,"is_red":false,"text":"There is corrosion present around the pressure regulator."},{"checked":false,"id":1,"is_red":false,"text":"The pressure regulator is missing an adjustment screw."},{"checked":false,"id":1,"is_red":false,"text":"The pressure regulator has a stripped adjustment screw."}],"sepChoice":"4","title":"Pressure Regulator","checked":true}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":true,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Water Pressure Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":true,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Pressure Regulator Overall"}],"title":"Water Pressure","checked":true},{"damage_panels":[{"descr":"","id":2194,"options":[{"checked":true,"id":1,"is_red":false,"text":"Hose bib missing handle."},{"checked":false,"id":1,"is_red":false,"text":"Hose bib at north side of house leaks. "},{"checked":false,"id":1,"is_red":false,"text":"Hose bib at south side of house leaks. "},{"checked":false,"id":1,"is_red":false,"text":"Hose bib at east side of house leaks. "},{"checked":false,"id":1,"is_red":false,"text":"Hose bib at west side of house leaks. "},{"checked":false,"id":1,"is_red":false,"text":"Hose bib leaks in garage."},{"checked":false,"id":1,"is_red":false,"text":"The water is off to structure, all water areas not tested."},{"checked":false,"id":1,"is_red":false,"text":"Appears Functional."},{"checked":false,"id":1,"is_red":false,"text":"Home does not appear to have any exterior hose spigots installed. <FYI>"},{"checked":false,"id":1,"is_red":false,"text":"Appears to be leaking at valve seal when in the open position, recommend repair for water conservation and to prevent possible water damage to structure/water intrusion if the hose is left on for extended period."},{"checked":false,"id":1,"is_red":false,"text":"Missing/broken handle noted at time of inspection, repairs recommended."},{"checked":false,"id":1,"is_red":false,"text":"Handle difficult to operate."},{"checked":false,"id":1,"is_red":false,"text":"Recommend upgrading to a frost proof type hose bibb to prevent possible damage due to cracking of water line in below freezing temperatures."},{"checked":false,"id":1,"is_red":false,"text":"The inspector not able to determine if valve is frost proof type due to lack of identification, recommend consulting with plumber as to valve type."},{"checked":false,"id":1,"is_red":false,"text":"Not operational at:"},{"checked":false,"id":1,"is_red":false,"text":"One or more water hose bibs are not frost proof and will need to be winterized before weather turns below 32* as pipe damage can occur."},{"checked":false,"id":1,"is_red":false,"text":"Loose at structure, repairs needed to prevent possible damage to supply line."},{"checked":false,"id":1,"is_red":false,"text":"Not functional at one or more locations, further review and repair recommended."},{"checked":false,"id":1,"is_red":false,"text":"Appears to be damaged, possibly due to freezing. Recommend review and repair by a qualified plumber."},{"checked":false,"id":1,"is_red":false,"text":"Appears to be damaged/leaking. Recommend review and repair by a qualified plumber."}],"sepChoice":"4","title":"Exterior Faucet Condition"}],"inspection_panels":[{"descr":"Location:","id":3057,"options":[{"checked":true,"id":1,"is_red":false,"text":"Front of structure."},{"checked":true,"id":1,"is_red":false,"text":"North side of house."},{"checked":true,"id":1,"is_red":false,"text":"East side of house."},{"checked":false,"id":1,"is_red":false,"text":"South side of house."},{"checked":false,"id":1,"is_red":false,"text":"West side of house."},{"checked":false,"id":1,"is_red":false,"text":"Outside of garage."},{"checked":false,"id":1,"is_red":false,"text":"Could not locate a hose bib."},{"checked":false,"id":1,"is_red":false,"text":"Located under the structure."}],"sepChoice":"1","title":"Exterior Faucet Location"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":true,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Exterior Faucet Condition Overall"}],"title":"Exterior Faucet","checked":true},{"damage_panels":[{"descr":"","id":2181,"options":[{"checked":true,"id":1,"is_red":false,"text":"Appears in satisfactory and functional condition with normal wear for its age.  Appears to be sound structure."},{"checked":false,"id":1,"is_red":false,"text":"MAINTENANCE: Whether treated or not, it is important to keep a wood deck surface free of all forms of fungal growth and debris that retains moisture and will cause the deck to eventually rot. Recommend cleaning and resealing the deck annually. Cleaning can be accomplished by scrubbing the deck with a sodium-hypochlorite (bleach) and Tri-Sodium-Phosphate (TSP) deck wash and then rinsing with a pressure washer. Finally, a wood deck should be recoated with a good-quality deck sealant.      "},{"checked":false,"id":1,"is_red":false,"text":"MAINTENANCE: Even decks of composite lumber need periodic maintenance to keep them free of algae and mold that can make the surface very slick. Recommend cleaning composite decks annually by scrubbing with a solution of: 1/3 cup laundry soap; 2/3 cup Tri-Sodium-Phosphate (TSP); one quart bleach; and 3 quarts of water. Rinse with a hose--Do Not Use a Pressure-Washer on composite lumber."},{"checked":false,"id":1,"is_red":false,"text":"Rotted Wood."},{"checked":false,"id":1,"is_red":false,"text":"Unstable supports."},{"checked":false,"id":1,"is_red":false,"text":"Reverse Grading."},{"checked":false,"id":1,"is_red":false,"text":"No flashing present."},{"checked":false,"id":1,"is_red":false,"text":"Floor boards damaged."},{"checked":false,"id":1,"is_red":false,"text":"Floor boards rotted."},{"checked":false,"id":1,"is_red":false,"text":"Improper fasteners."},{"checked":false,"id":1,"is_red":false,"text":"Lag bolts not present."},{"checked":false,"id":1,"is_red":false,"text":"Improper attachment of ledger board."},{"checked":false,"id":1,"is_red":false,"text":"Missing fasteners at joist hangers."},{"checked":false,"id":1,"is_red":false,"text":"Joist deck hangers are missing nails. Have all reviewed for adding additional nails."},{"checked":false,"id":1,"is_red":false,"text":"Have the deck reviewed for proper installation and attachment. Check for history of permits."},{"checked":false,"id":1,"is_red":false,"text":"Loose fasteners observed. Review all and secure as needed."},{"checked":false,"id":1,"is_red":false,"text":"Not visible underneath."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Consider upgrading to new composite lumber decking material. "},{"checked":false,"id":1,"is_red":false,"text":"Deck ledger board lacking flashing. Flashing protects the ledger and keeps water away from the side of the house. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Today's deck construction, support, and attachment standards typically call for proper footings, 6X6 posts, and 1/2 inch bolts securing deck to the beam and the house. Not all of these elements appear to be present. Consider upgrading deck to current standards."},{"checked":false,"id":1,"is_red":false,"text":"Appeared functional at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Missing handrails and balusters."},{"checked":false,"id":1,"is_red":false,"text":"Unstable railings."},{"checked":false,"id":1,"is_red":false,"text":"Balusters spaced to far apart."}],"sepChoice":"4","title":"Balcony","checked":true},{"descr":"","id":2182,"options":[{"checked":true,"id":1,"is_red":false,"text":"Appears in satisfactory and functional condition with normal wear for its age.  Appears to be sound structure."},{"checked":true,"id":1,"is_red":false,"text":"MAINTENANCE: Whether treated or not, it is important to keep a wood deck surface free of all forms of fungal growth and debris that retains moisture and will cause the deck to eventually rot. Recommend cleaning and resealing the deck annually. Cleaning can be accomplished by scrubbing the deck with a sodium-hypochlorite (bleach) and Tri-Sodium-Phosphate (TSP) deck wash and then rinsing with a pressure washer. Finally, a wood deck should be recoated with a good-quality deck sealant.      "},{"checked":false,"id":1,"is_red":false,"text":"MAINTENANCE: Even decks of composite lumber need periodic maintenance to keep them free of algae and mold that can make the surface very slick. Recommend cleaning composite decks annually by scrubbing with a solution of: 1/3 cup laundry soap; 2/3 cup Tri-Sodium-Phosphate (TSP); one quart bleach; and 3 quarts of water. Rinse with a hose--Do Not Use a Pressure-Washer on composite lumber."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Consider upgrading to new composite lumber decking material. "},{"checked":false,"id":1,"is_red":false,"text":"Rotted Wood."},{"checked":false,"id":1,"is_red":false,"text":"Unstable supports."},{"checked":false,"id":1,"is_red":false,"text":"No flashing present."},{"checked":false,"id":1,"is_red":false,"text":"Floor boards damaged."},{"checked":false,"id":1,"is_red":false,"text":"Floor boards rotted."},{"checked":false,"id":1,"is_red":false,"text":"Improper fasteners."},{"checked":false,"id":1,"is_red":false,"text":"Lag bolts not present"},{"checked":false,"id":1,"is_red":false,"text":"Improper attachment of ledger board."},{"checked":false,"id":1,"is_red":false,"text":"Missing fasteners at joist hangers."},{"checked":false,"id":1,"is_red":false,"text":"Joist deck hangers are missing nails. Have all reviewed for adding additional nails."},{"checked":false,"id":1,"is_red":false,"text":"Loose fasteners observed. Review all and secure as needed."},{"checked":false,"id":1,"is_red":false,"text":"Not visible underneath."},{"checked":false,"id":1,"is_red":false,"text":"Deck ledger board lacking flashing. Flashing protects the ledger and keeps water away from the side of the house. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Appeared functional at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Missing handrails and balusters."},{"checked":false,"id":1,"is_red":false,"text":"Unstable railings observed."},{"checked":false,"id":1,"is_red":false,"text":"Balusters spaced to far apart."},{"checked":false,"id":1,"is_red":false,"text":"Damaged supports."},{"checked":false,"id":1,"is_red":false,"text":"Improper footings."},{"checked":false,"id":1,"is_red":false,"text":"Mortar deterioration was observed."},{"checked":false,"id":1,"is_red":false,"text":"Floor joists damaged/rotting."},{"checked":false,"id":1,"is_red":false,"text":"Beams damaged/rotting."},{"checked":false,"id":1,"is_red":false,"text":"Floor rotted/damaged."},{"checked":false,"id":1,"is_red":false,"text":"Common cracks/Seal as needed."},{"checked":false,"id":1,"is_red":false,"text":"Torn/damaged screens in two areas of Screened Porch."},{"checked":false,"id":1,"is_red":false,"text":"General overall condition appear satisfactory with painted surfaces in good condition, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Routine maintenance required for all exterior painted surfaces."},{"checked":false,"id":1,"is_red":false,"text":"The patio is improperly sloped towards the foundation. Water can infiltrate into the interior. Recommend repairing or replacing the patio to properly slope away from the foundation."},{"checked":false,"id":1,"is_red":false,"text":"The patio has settled with a deteriorated mortar base and has created some tripping hazards. Recommend professional contractor review for repairs."},{"checked":false,"id":1,"is_red":false,"text":"The brick patio has settled and is improperly sloped towards the garage. Water can infiltrate under the slab and addition. The base appears to be inadequate. Recommend removing the bricks and installing the proper base or have a different type of patio installed like stamped concrete. The base and proper grading are the keys."},{"checked":false,"id":1,"is_red":false,"text":"Improve:  Typical cracking was observed at the concrete surfaces. Further deterioration will occur as water expands and contracts from freeze and thaw cycles. Recommend sealing the cracks to prolong the life of the concrete."},{"checked":false,"id":1,"is_red":false,"text":"Wood posts are improperly secured at concrete. Recommend properly securing."},{"checked":false,"id":1,"is_red":false,"text":"The indoor/outdoor carpet is damaged and is a tripping hazard."},{"checked":false,"id":1,"is_red":false,"text":"Uneven slabs at the patio. "},{"checked":false,"id":1,"is_red":false,"text":"Common cracks/Seal as needed."},{"checked":false,"id":1,"is_red":false,"text":"Sunken areas with cracks and breaks"}],"sepChoice":"4","title":"Patio Enclosure","checked":true}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":true,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Balcony Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":true,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Patio Enclosure Overall"}],"title":"Patio","checked":false},{"damage_panels":[{"descr":"","id":2180,"options":[{"checked":false,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Clean roof areas:  Significant amounts of organic debris evident."},{"checked":false,"id":1,"is_red":false,"text":"Moss on roof. This can lead to the premature failure of the roof and subsequent leaks. Recommend treating moss during its growing season (wet months) with a moss killer. For information on various moss treatment products and their pros and cons, visit http://bryophytes.science.oregonstate.edu/page24.htm.  "},{"checked":false,"id":1,"is_red":false,"text":"Snow covered; not fully inspected."},{"checked":false,"id":1,"is_red":false,"text":"With the potential of roof collapses during winter, we recommend that the roof be evaluated for snow load and clearing in the immediate future.  Buildings constructed with building permits are generally designed to carry a snow load of 40 lbs per square foot.  We recommend that you monitor the snow load on your roof during winters and have the roof cleared as necessary.  Note that the snow load and snow load capacity of a roof is beyond the scope of a home inspection.  Snow accumulation, especially on a vacant home, should be monitored as frequently as on a daily basis. "},{"checked":false,"id":1,"is_red":false,"text":"Ridge cap: deteriorated or missing shingles. "},{"checked":false,"id":1,"is_red":false,"text":"Some shingles damaged."},{"checked":false,"id":1,"is_red":false,"text":"Minor shingle damage visible, presumably from raking snow off roof."},{"checked":false,"id":1,"is_red":false,"text":"Some shingles &/or tabs missing."},{"checked":false,"id":1,"is_red":false,"text":"Some shingles curling."},{"checked":false,"id":1,"is_red":false,"text":"Sagging / buckling on roof decking. "},{"checked":false,"id":1,"is_red":false,"text":"Exposed nails on roofing material. Recommend sealing all fastener heads."},{"checked":false,"id":1,"is_red":false,"text":"Roof ventilation may be inadequate; this may contribute to premature roof failure, conducive conditions for mold growth in attic, and/or high heating / cooling bills.  Consider further evaluation by qualified contractor."},{"checked":false,"id":1,"is_red":false,"text":"Semi-flat roof area should be kept clean to avoid leaks, snow loading or ice damming."},{"checked":false,"id":1,"is_red":false,"text":"Slope-slope, slope-wall or slope-semi flat roof design at    Recommend keeping this area clean to avoid leaks or ice damming."},{"checked":false,"id":1,"is_red":false,"text":"Siding-Roof Contact: Check for moisture damage.  Recommend a 1\" gap between the siding and the roofing below where necessary."},{"checked":false,"id":1,"is_red":false,"text":"Flashing appears inadequate; see photo. "},{"checked":false,"id":1,"is_red":false,"text":"Missing plumbing vent pipe; these are necessary for sanitary and smooth flow of the system."},{"checked":false,"id":1,"is_red":false,"text":"Damaged plumbing vent, presumably from sliding snow.  See photo."},{"checked":false,"id":1,"is_red":false,"text":"Partially snow covered, not fully inspected. "},{"checked":false,"id":1,"is_red":false,"text":"..."},{"checked":false,"id":1,"is_red":false,"text":"No \"Cricket\" (a small ridged roof section just above the chimney to shed water off to the sides) is installed above the (wider than 2’) chimney. Keep clean of any accumulated debris which may cause leaks. "},{"checked":false,"id":1,"is_red":false,"text":"Serviceability of roof is questionable; it should be evaluated and repaired as necessary by a professional roofing contractor."},{"checked":false,"id":1,"is_red":false,"text":"Wood Shake Roof: Consider professional evaluation and cleaning, and possibly having a preservative applied. "},{"checked":false,"id":1,"is_red":false,"text":"Some wood shakes missing / damaged / nails lifting."},{"checked":false,"id":1,"is_red":false,"text":"Some areas roofed by plastic or fiberglass panels; monitor for leaks or accumulated debris."},{"checked":false,"id":1,"is_red":false,"text":"Some areas not visible from inspection level"},{"checked":false,"id":1,"is_red":false,"text":"Ponding in areas."},{"checked":false,"id":1,"is_red":false,"text":"Recommend roofing contractor to evaluate."},{"checked":false,"id":1,"is_red":false,"text":"Under construction n/a."},{"checked":false,"id":1,"is_red":false,"text":"Porch roof sagging."},{"checked":false,"id":1,"is_red":false,"text":"Note that experts recommend that any roof over 10 years old receive a roof certification by a local roofing specialist. "},{"checked":false,"id":1,"is_red":false,"text":"Indications of past or present water leaks, seeps, or condensation at eaves."},{"checked":false,"id":1,"is_red":false,"text":"Maintenance Tip:  Structures constructed with building permits are generally designed to carry a snow load of 40 lbs per square foot.  We recommend that you monitor the snow load on your roof during winters and have the roof cleared as necessary. "},{"checked":false,"id":1,"is_red":false,"text":"Maintenance Tip: Roof design has many peaks and valleys; keep roof cleared of debris and heavy snow loads to extend life of roof."},{"checked":false,"id":1,"is_red":false,"text":"Maintenance Tip:  Weather permitting, keep debris cleared from roof valleys to extend life of roof. "}],"sepChoice":"4","title":"Patio and Porch Condition"}],"inspection_panels":[{"descr":"","id":3053,"options":[{"checked":true,"id":1,"is_red":false,"text":"The patio/porch roof is the same as main structure."},{"checked":true,"id":1,"is_red":false,"text":"Asphalt shingles noted."},{"checked":true,"id":1,"is_red":false,"text":"Concrete tiles noted."},{"checked":true,"id":1,"is_red":false,"text":"Rolled roofing noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood shingles noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood shakes noted."},{"checked":false,"id":1,"is_red":false,"text":"Metal standing seam roofing noted."},{"checked":false,"id":1,"is_red":false,"text":"Fiberglass composite shingles noted."},{"checked":true,"id":1,"is_red":false,"text":"Composition shingles noted."},{"checked":false,"id":1,"is_red":false,"text":"Flat roof, rubber membrane, inspected with Ladder."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum standing seam roof present."}],"sepChoice":"1","title":"Patio and Porch Roofing"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Patio and Porch Condition Overall"}],"title":"Patio/Porch Roof","checked":false},{"damage_panels":[{"descr":"","id":2187,"options":[{"checked":false,"id":1,"is_red":false,"text":"The inspector could not inspect due to overgrown ground cover."},{"checked":false,"id":1,"is_red":false,"text":"Retaining wall is leaning."},{"checked":false,"id":1,"is_red":false,"text":"Settled\\Loose stone observed."},{"checked":false,"id":1,"is_red":false,"text":"Appeared serviceable at time of inspection.  Structural assembly inaccessible."},{"checked":false,"id":1,"is_red":false,"text":"Damaged/ missing mortar observed, suggest tuckpointing as necessary."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the retaining walls are near the end of their useful life."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified professional for repair or replacement, as necess\n[INFO] :   ary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Peeling paint observed, suggest scraping and painting as necessary."},{"checked":false,"id":1,"is_red":false,"text":"**FENCING**"},{"checked":false,"id":1,"is_red":false,"text":"Fence leaning in areas."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the fences/gates are near the end of their useful life."},{"checked":false,"id":1,"is_red":false,"text":"Loose top blocks observed. This is a safety concern. Suggest maintenance/repairs as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Wood deterioration observed. Suggest repairs/replacement as needed."},{"checked":false,"id":1,"is_red":false,"text":"Fence damaged."}],"sepChoice":"4","title":"Fence Condition"}],"inspection_panels":[{"descr":"","id":3054,"options":[{"checked":true,"id":1,"is_red":false,"text":"Wood"},{"checked":true,"id":1,"is_red":false,"text":"Concrete"},{"checked":true,"id":1,"is_red":false,"text":"Block"},{"checked":false,"id":1,"is_red":false,"text":"Stone"},{"checked":false,"id":1,"is_red":false,"text":"Brick"},{"checked":false,"id":1,"is_red":false,"text":"Not Visible"}],"sepChoice":"1","title":"Fence or Wall Material"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":true,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Fence Condition Overall"}],"title":"Fencing and Walls","checked":true},{"damage_panels":[{"descr":"","id":2191,"options":[{"checked":true,"id":1,"is_red":true,"text":"Home is equipped with an underground sprinkler system. The inspector recommends client consult with home owner for operation instructions and proper winterizing information. Sprinkler systems are beyond the scope of a Home Inspection, due to most of its parts/piping not visible for inspection."},{"checked":true,"id":1,"is_red":false,"text":"Sprinkler system noted; client is advised to seek advice of a specialist in evaluating this system before use."},{"checked":false,"id":1,"is_red":false,"text":"The sprinkler system operates with a control panel located in the garage."},{"checked":false,"id":1,"is_red":false,"text":"The sprinkler system operates with a control panel located in the basement."},{"checked":false,"id":1,"is_red":false,"text":"Several zone valves appear to be leaking. We recommend contacting a qualified contractor to repair. "},{"checked":false,"id":1,"is_red":false,"text":"Several heads appear to need adjustment to broaden their coverage area."},{"checked":false,"id":1,"is_red":false,"text":"A few of the sprinkler heads are spraying structure. We recommend adjusting the heads so they do not spray the house."},{"checked":false,"id":1,"is_red":false,"text":"The system did not operate when tested."},{"checked":false,"id":1,"is_red":false,"text":"The inspector noted a few broken heads."},{"checked":true,"id":1,"is_red":false,"text":"Main valve in off position, probably due to winterization. We cannot test without the valves being open."},{"checked":true,"id":1,"is_red":false,"text":"Main valve is missing its handle, probably due to winterization. We cannot test without the valves being open."},{"checked":true,"id":1,"is_red":false,"text":"The inspector could not locate the zone valve box. Consult with the seller for its location."},{"checked":true,"id":1,"is_red":false,"text":"The inspector could not access the zone valve box. Consult with the seller for its location."},{"checked":true,"id":1,"is_red":false,"text":"It appears that the zone valves are not connected to the control panel. We could not locate any form of wireless devices either."},{"checked":false,"id":1,"is_red":false,"text":"PVC line leaking."}],"sepChoice":"4","title":"Sprinklers"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":true,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Sprinklers Overall"}],"title":"Sprinklers","checked":true}],"title":"Grounds"}],"pictures":[{"menuItem":null,"caption":"Cover Photo","section":"Cover","id":-1,"imageFileName":"0.jpg"},{"menuItem":"Grounds","caption":"","section":"Grading","id":2189,"imageFileName":"1.jpg","height":350,"width":350,"isImage":true,"isVideo":false,"imageId":"1"},{"menuItem":"Grounds","caption":"","section":"Grading","id":2189,"imageFileName":"2.jpg","height":350,"width":350,"isImage":true,"isVideo":false,"imageId":"2"},{"menuItem":"Grounds","caption":"","section":"Grading","id":2189,"imageFileName":"3.jpg","height":350,"width":350,"isImage":true,"isVideo":false,"imageId":"3"}],"videos":[],"insertsFileType":"JSON","insertsJSON":{"inserts":[{"n":"<<Bathrom Locations>>","c":[]}]},"currInsp":"Test_9-30-18"};
//var arrayCreate ={"template":[{"id":0,"tabbed_panels":[{"damage_panels":[],"inspection_panels":[{"descr":"In Attendance:","id":3084,"options":[{"checked":false,"id":1,"is_red":false,"text":"Client present"},{"checked":false,"id":1,"is_red":false,"text":"Client present"},{"checked":false,"id":1,"is_red":false,"text":"Buyer Agent present"},{"checked":false,"id":1,"is_red":false,"text":"Selling Agent present"},{"checked":false,"id":1,"is_red":false,"text":"Seller present"},{"checked":false,"id":1,"is_red":false,"text":"Client not present"},{"checked":false,"id":1,"is_red":false,"text":"Agent present"},{"checked":false,"id":1,"is_red":false,"text":"Owner/Client present"},{"checked":false,"id":1,"is_red":false,"text":"Fully Participated"},{"checked":false,"id":1,"is_red":false,"text":"No other parties present at inspection."}],"sepChoice":"1","title":"Attendance"}],"pictures":[],"ratings":[],"title":"Attendance"},{"damage_panels":[],"inspection_panels":[{"descr":"Home Type:","id":3085,"options":[{"checked":false,"id":1,"is_red":false,"text":"Attached"},{"checked":false,"id":1,"is_red":false,"text":"Detached"},{"checked":false,"id":1,"is_red":false,"text":"Single Family Home"},{"checked":false,"id":1,"is_red":false,"text":"Multi family home"},{"checked":false,"id":1,"is_red":false,"text":"Condominium/Townhouse"},{"checked":false,"id":1,"is_red":false,"text":"Ranch Style"},{"checked":false,"id":1,"is_red":false,"text":"Bungalow Style"},{"checked":false,"id":1,"is_red":false,"text":"Colonial Style"},{"checked":false,"id":1,"is_red":false,"text":"Split Level Style"},{"checked":false,"id":1,"is_red":false,"text":"Cape Cod Style"},{"checked":false,"id":1,"is_red":false,"text":"Split Foyer Style - Two Levels"},{"checked":false,"id":1,"is_red":false,"text":"Single family, three-level Townhouse"}],"sepChoice":"1","title":"Home Type"}],"pictures":[],"ratings":[],"title":"Home Type"},{"damage_panels":[],"inspection_panels":[{"descr":"Occupancy:","id":3086,"options":[{"checked":false,"id":1,"is_red":false,"text":"Vacant"},{"checked":false,"id":1,"is_red":false,"text":"Vacant - Furnished"},{"checked":false,"id":1,"is_red":false,"text":"Occupied - Furnished"},{"checked":false,"id":1,"is_red":false,"text":"Occupied - Furnished: Heavy volume of personal and household items observed."},{"checked":false,"id":1,"is_red":false,"text":"The utilities were on at the time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"The utilities were off at the time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Moderate to heavy personal and household items observed."},{"checked":false,"id":1,"is_red":false,"text":"Moderate storage was observed."},{"checked":false,"id":1,"is_red":false,"text":"Access to some items such as: electrical outlets/receptacles, windows, wall/floor surfaces, and cabinet interiors may be restricted by furniture or personal belongings. Any such items are excluded from this inspection report."},{"checked":false,"id":1,"is_red":false,"text":"ACCESS TO SOME ITEMS SUCH AS: ELECTRICAL OUTLETS, WINDOWS, WALL/FLOOR SURFACES, AND CABINET INTERIORS WAS RESTRICTED BY FURNITURE AND LARGE QUANTITY OF PERSONAL BELONGINGS. ANY SUCH ITEMS ARE EXCLUDED FROM THIS INSPECTION REPORT."},{"checked":false,"id":1,"is_red":false,"text":"Natural gas hot water heater NOT ON"}],"sepChoice":"1","title":"Occupancy"}],"pictures":[],"ratings":[],"title":"Occupancy"}],"title":"Inspection Details"},{"id":1,"tabbed_panels":[{"damage_panels":[{"descr":"","id":2179,"options":[{"checked":false,"id":1,"is_red":false,"text":"Driveway in good shape for age and wear. No deficiencies noted."},{"checked":false,"id":1,"is_red":false,"text":"Driveway in good shape for age and wear. Some oil staining. Clean and seal to extend life."},{"checked":false,"id":1,"is_red":false,"text":"Driveway in good shape. Recommend sealing to extend life."},{"checked":false,"id":1,"is_red":false,"text":"The driveway is improperly sloped towards the foundation. Water can infiltrate into the interior. Recommend repairing or replacing the drive to properly slope away from the foundation."},{"checked":false,"id":1,"is_red":false,"text":"There are numerous areas of damaged concrete surfaces. Concrete replacement is expensive. Recommend a concrete specialist provide an estimate for repair and or replacing."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE:  Typical cracking was observed at the concrete surfaces. Further deterioration will occur as water expands and contracts from freeze and thaw cycles. Recommend sealing the cracks to prolong the life of the concrete."},{"checked":false,"id":1,"is_red":false,"text":"Uneven slabs at the driveway. "},{"checked":false,"id":1,"is_red":false,"text":"Uneven slabs at the driveway. This is a potential tripping hazard. Recommend repair and or replacement of the displaced walks."},{"checked":false,"id":1,"is_red":false,"text":"Monitor: Surface deterioration observed at the concrete surface. "},{"checked":false,"id":1,"is_red":false,"text":"Portions of the asphalt driveway has heavy cracking and displacement. Contact a driveway specialist to provide an estimate for replacing."},{"checked":false,"id":1,"is_red":false,"text":"Driveway improperly sloped towards the garage/Recommend slab jacking, repair or replacing the settled concrete."},{"checked":false,"id":1,"is_red":false,"text":"There are areas of damaged concrete surfaces."},{"checked":false,"id":1,"is_red":false,"text":"Improperly sloped towards foundation."},{"checked":false,"id":1,"is_red":false,"text":"Sealant observed between concrete drive and foundation. This is a temporary repair."},{"checked":false,"id":1,"is_red":false,"text":"Obtain an estimate for repairs or replacing before closing."},{"checked":false,"id":1,"is_red":false,"text":"There are minor predictable and common cracks in the asphalt. Monitor these areas for further movement or expansion and repair/seal as needed."},{"checked":false,"id":1,"is_red":false,"text":"Asphalt driveway appears new.  Highly recommend sealing within one year to extend life and maintain appearance."},{"checked":false,"id":1,"is_red":false,"text":"Sunken areas were observed with cracks and breaks."},{"checked":false,"id":1,"is_red":false,"text":"Gravel driveways need ongoing maintenance. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Minor settlement, or \"hairline\" cracks in driveways, are normal for properties of any age. They should, however, be monitored for expansion and sealed as necessary."},{"checked":false,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Moderate cracks in driveway.   Repair and / or monitor for expansion and development of trip hazards."},{"checked":false,"id":1,"is_red":false,"text":"Extensive cracks in driveway.   Repair and / or monitor for expansion and development of trip hazards."},{"checked":false,"id":1,"is_red":false,"text":"Concrete spalling noted at driveway.  This loosening of the top, smooth layer of the cement is a common occurrence, possibly due to an improper curing process, age, or use of snow-melting materials."},{"checked":false,"id":1,"is_red":false,"text":"Moderate cracks in sidewalk.   Repair and / or monitor for expansion and development of trip hazards."},{"checked":false,"id":1,"is_red":false,"text":"Extensive cracks in sidewalk.   Repair and / or monitor for expansion and development of trip hazards."},{"checked":false,"id":1,"is_red":false,"text":"Concrete spalling noted at sidewalk.  This loosening of the top, smooth layer of the cement is a common occurrence, possibly due to an improper curing process, age, or use of snow-melting materials."},{"checked":false,"id":1,"is_red":false,"text":"Potential Trip Hazard(s) at driveway; monitor / repair as necessary "},{"checked":false,"id":1,"is_red":false,"text":"Potential Trip Hazard(s) at sidewalk; monitor / repair as necessary.  "},{"checked":false,"id":1,"is_red":false,"text":"Snow covered; not fully inspected."},{"checked":false,"id":1,"is_red":false,"text":"Partially snow covered not fully inspected."},{"checked":false,"id":1,"is_red":false,"text":"Normal settlement / separation crack at concrete walk / steps junction."},{"checked":false,"id":1,"is_red":false,"text":"Water ponding in several places at walks, driveway & patios may present an ice hazard in winter."},{"checked":false,"id":1,"is_red":false,"text":"Storm drain at property line swale may pose a safety hazard; consider installing a grate over it to prevent falls."},{"checked":false,"id":1,"is_red":false,"text":"Common area maintained by association."}],"sepChoice":"4","title":"Driveway and Walkway Condition"}],"inspection_panels":[{"descr":"","id":3052,"options":[{"checked":false,"id":1,"is_red":false,"text":"Concrete driveway noted."},{"checked":false,"id":1,"is_red":false,"text":"Asphalt driveway noted."},{"checked":false,"id":1,"is_red":false,"text":"Gravel driveway noted."},{"checked":false,"id":1,"is_red":false,"text":"No driveway noted."},{"checked":false,"id":1,"is_red":false,"text":"Concrete sidewalk noted."},{"checked":false,"id":1,"is_red":false,"text":"Gravel sidewalk noted."},{"checked":false,"id":1,"is_red":false,"text":"Block / Brick sidewalk noted."},{"checked":false,"id":1,"is_red":false,"text":"No sidewalk noted."},{"checked":false,"id":1,"is_red":false,"text":"Gravel/dirt driveway and walks noted."},{"checked":false,"id":1,"is_red":false,"text":"Asphalt sidewalk noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood and stone walkways noted."},{"checked":false,"id":1,"is_red":false,"text":"Step stone sidewalk noted."},{"checked":false,"id":1,"is_red":false,"text":"Concrete, gravel and stone walkways noted."},{"checked":false,"id":1,"is_red":false,"text":"Driveway and walkways snow covered; not inspected. "}],"sepChoice":"1","title":"Driveway and Walkway"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Driveway and Walkway Condition Overall"}],"title":"Driveway/Walkway"},{"damage_panels":[{"descr":"","id":2189,"options":[{"checked":false,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Lot grading and drainage have a significant impact on the building, simply because of the direct and indirect damage that moisture can have on the foundation.  It is very important, therefore, that surface runoff water be  adequately diverted away from the home. Lot grading should slope away and fall a minimum of one (1) inch every foot for a distance of six (6) feet around the perimeter of the building."},{"checked":false,"id":1,"is_red":false,"text":"The exterior drainage is generally away from foundation."},{"checked":false,"id":1,"is_red":false,"text":"The exterior drainage is generally away from foundation -- except where noted below. "},{"checked":false,"id":1,"is_red":false,"text":"The exterior grading is improperly sloped towards the foundation. Water can intrude into the interior. Recommend creating the proper slope away from the foundation to allow for proper drainage."},{"checked":false,"id":1,"is_red":false,"text":"Low and settled grading was observed along the front flower bed.  Water can intrude under porch and affect the foundation. Critters can also infest. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"The grading is improperly sloped towards the foundation."},{"checked":false,"id":1,"is_red":false,"text":"Perimeter Pavement:  Appears to slope towards building. Recommend taking measures to direct rainwater away."},{"checked":false,"id":1,"is_red":false,"text":"There are some low spots along the foundation. Recommend adding additional backfill to create the proper slope away from the house to allow for effective drainage."},{"checked":false,"id":1,"is_red":false,"text":"Recommend adding additional backfill to create the proper slope away from the foundation."},{"checked":false,"id":1,"is_red":false,"text":"See driveway observations"},{"checked":false,"id":1,"is_red":false,"text":"While performance of lot drainage and water handling systems may appear serviceable at the time of inspection, the inspector cannot always accurately predict this performance as conditions constantly change. Furthermore, items such as leakage in downspout/gutter systems are very difficult to detect during dry weather. Inspection of foundation performance and water handling systems, therefore, is limited to visible conditions and evidence of past problems."},{"checked":false,"id":1,"is_red":false,"text":"Low areas were observed. Backfill is recommended."},{"checked":false,"id":1,"is_red":false,"text":"Improper slope towards foundation"},{"checked":false,"id":1,"is_red":false,"text":"Highly recommend removing the firewood pile from such close proximity to the house. Present location invites animal/insect infestation and damage to property. "},{"checked":false,"id":1,"is_red":false,"text":"There is no extension on sump pump discharge pipe. Evidence of erosion near foundation exists. Extend discharge pipe, as needed, away from foundation to keep water away from foundation. Consider extending to the nearby drainage culvert."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Install window wells to prevent water penetration through the windows."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Install new raised-type drain guard at bottom of basement walk-out stairs. This type of drain guard resists clogging."},{"checked":false,"id":1,"is_red":false,"text":"MAINTENANCE: Concrete floor drain at bottom of basement walk-out stairs is partially blocked with leaves and debris.  This is a potential basement flooding situation during heavy rains and before Sump Pump can keep up.  This type of drain guard is easily clogged with leaves -- therefore, it must be monitored and kept clean. "},{"checked":false,"id":1,"is_red":false,"text":"MAINTENANCE: Concrete floor drain at bottom of basement walk-out stairs is partially blocked with leaves and debris.  This is a potential basement flooding situation during heavy rains.  This type of drain guard is easily clogged with leaves -- therefore, it must be monitored and kept clean. "},{"checked":false,"id":1,"is_red":false,"text":"Out buildings and sheds are excluded from this report."},{"checked":false,"id":1,"is_red":false,"text":"Koi Pond present, not inspected by the inspector."},{"checked":false,"id":1,"is_red":false,"text":"Siding to Soil contact or proximity.  This may provide entrance of moisture or insects to siding.  Recommend grading soil so there is at least 6\" of space (where practical) between the siding and the soil below and checking for any damaged trim and siding materials."},{"checked":false,"id":1,"is_red":false,"text":"Retaining Wall shows signs of deterioration."},{"checked":false,"id":1,"is_red":false,"text":"Reverse slope at splash block(s).  Recommend sloping away from house so that water is carried away from foundation.  "},{"checked":false,"id":1,"is_red":false,"text":"Lack of uphill drain ditch or basin.  Monitor, as water may flow toward foundation. "},{"checked":false,"id":1,"is_red":false,"text":"Too much debris sitting up against exterior walls."},{"checked":false,"id":1,"is_red":false,"text":"There are separations in the seal between foundation and walkway; seal the walk way to foundation with appropriate caulking methods."},{"checked":false,"id":1,"is_red":false,"text":"The backyard patio concrete is severely cracked which will allow water to seep in and contribute to groundwater seepage potential."},{"checked":false,"id":1,"is_red":false,"text":"The walkway along the home should be sealed with a good caulk to help prevent water from draining along foundation wall."},{"checked":false,"id":1,"is_red":false,"text":"Unable to determine conditions of grade due to snow cover. Make sure that when the ground does become visible that you correct any areas of grade that pitch towards the foundation wall. Always avoid allowing excess water to stand next to the home."},{"checked":false,"id":1,"is_red":false,"text":"Snow covered; not fully inspected."}],"sepChoice":"4","title":"Grading"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Grading Overall"}],"title":"Grading"},{"damage_panels":[{"descr":"","id":2212,"options":[{"checked":false,"id":1,"is_red":false,"text":"No major system safety or functional concerns noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Prune or remove any plants that are in contact or proximity to home to eliminate pathways of wood destroying insects."},{"checked":false,"id":1,"is_red":false,"text":"Tree limbs within 10 feet of roof should be trimmed away to provide air and sunlight to roof, while minimizing debris & dampness."},{"checked":false,"id":1,"is_red":false,"text":"Trim trees that are in contact or proximity to home, as branches can abrade roofing or siding. "},{"checked":false,"id":1,"is_red":false,"text":"Trees in proximity to electric lines are a wind and icing hazard.  Contact utility company for trimming."},{"checked":false,"id":1,"is_red":false,"text":"Trees are within 6 feet of foundation. Monitor for potential root damage. "},{"checked":false,"id":1,"is_red":false,"text":"Tree branches are at eye level and a potential injury hazard.  "},{"checked":false,"id":1,"is_red":false,"text":"Tree branches overhanging roof and/or against siding.  Trim trees that are in contact or proximity to home, as branches can abrade siding and damage roofing. "},{"checked":false,"id":1,"is_red":false,"text":"Trees that grow too close, or overhang property, should be trimmed back.  This will help reduce the frequency of having to clean out the gutters, which should be done on a regular basis."},{"checked":false,"id":1,"is_red":false,"text":"Tree stump with apparent carpenter ant damage in proximity to home; recommend treatment or removal to keep wood destroying insects away from home.  Consider professional pest treatment.  See photos."},{"checked":false,"id":1,"is_red":false,"text":"Bamboo noted growing in yard. This is often considered to be an unwelcome and invasive species."},{"checked":false,"id":1,"is_red":false,"text":"Maintenance Tip:  When landscaping, keep plants, even at full growth, at least a foot (preferably 18 inches) from house siding and windows.  Keep trees away from foundation and roof.  Plants in contact or proximity to home can provide pathways for wood destroying insects, as well as abrade and damage siding, screens and roofs."},{"checked":false,"id":1,"is_red":false,"text":"The property has overgrown vegetation that needs to be landscaped. The front of home was maintained but the left side has overgrown bushes that are obscuring windows, the gas meter and the foundation."},{"checked":false,"id":1,"is_red":false,"text":"Shed roof is completely covered in moss."},{"checked":false,"id":1,"is_red":false,"text":"There is a large tree close to the structure, in a side lot.  The roots may cause problems with the plumbing system, and the leaves and branches can potentially fall onto the roof, clog the gutters and cause roofing damage."},{"checked":false,"id":1,"is_red":false,"text":"Snow covered; not fully inspected."}],"sepChoice":"4","title":"Vegetation Observations"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Vegetation Observations Overall"}],"title":"Vegetation"},{"damage_panels":[{"descr":"","id":2188,"options":[{"checked":false,"id":1,"is_red":false,"text":"Fences and gates are NOT INCLUDED as part of a home inspection.  Recommend confirming that all fences and gates are in serviceable condition before the close of escrow."},{"checked":false,"id":1,"is_red":false,"text":"Gate hardware missing or damaged; gate will not secure."},{"checked":false,"id":1,"is_red":false,"text":"Damaged gate observed."},{"checked":false,"id":1,"is_red":false,"text":"Gate is sagging."},{"checked":false,"id":1,"is_red":false,"text":"Gate sticks."},{"checked":false,"id":1,"is_red":false,"text":"Gates were locked at the time of inspection, did not operate."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the fences/gates are near the end of their useful life."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review of all gates for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Wood deterioration observed. Suggest repair or replacement as needed."}],"sepChoice":"4","title":"Gate Condition"}],"inspection_panels":[{"descr":"","id":3055,"options":[{"checked":false,"id":1,"is_red":false,"text":"Wood"},{"checked":false,"id":1,"is_red":false,"text":"Wrought iron"},{"checked":false,"id":1,"is_red":false,"text":"Chain link"},{"checked":false,"id":1,"is_red":false,"text":"Plastic"},{"checked":false,"id":1,"is_red":false,"text":"Aluminum"}],"sepChoice":"1","title":"Gate Material"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Gate Condition Overall"}],"title":"Gates"},{"damage_panels":[{"descr":"","id":2183,"options":[{"checked":false,"id":1,"is_red":false,"text":"Appeared functional at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Appears in satisfactory and functional condition with normal wear for its age."},{"checked":false,"id":1,"is_red":false,"text":"MAINTENANCE: Whether treated or not, it is important to keep a wood deck surface free of all forms of fungal growth and debris that retains moisture and will cause the deck to eventually rot. Recommend cleaning and resealing the deck annually. Cleaning can be accomplished by scrubbing the deck with a sodium-hypochlorite (bleach) and Tri-Sodium-Phosphate (TSP) deck wash and then rinsing with a pressure washer. Finally, a wood deck should be recoated with a high quality deck sealant.      "},{"checked":false,"id":1,"is_red":false,"text":"MAINTENANCE: Even decks of composite lumber need periodic maintenance to keep them free of algae and mold that can make the surface very slick. Recommend cleaning composite decks annually by scrubbing with a solution of: 1/3 cup laundry soap; 2/3 cup Tri-Sodium-Phosphate (TSP); one quart bleach; and 3 quarts of water. Rinse with a hose--Do Not Use a Pressure-Washer on composite lumber."},{"checked":false,"id":1,"is_red":false,"text":"Rotted Wood."},{"checked":false,"id":1,"is_red":false,"text":"Unstable supports."},{"checked":false,"id":1,"is_red":false,"text":"Reverse Grading."},{"checked":false,"id":1,"is_red":false,"text":"No flashing present."},{"checked":false,"id":1,"is_red":false,"text":"Floor boards damaged."},{"checked":false,"id":1,"is_red":false,"text":"Floor boards rotted."},{"checked":false,"id":1,"is_red":false,"text":"Improper fasteners."},{"checked":false,"id":1,"is_red":false,"text":"Lag bolts not present."},{"checked":false,"id":1,"is_red":false,"text":"Improper attachment of ledger board."},{"checked":false,"id":1,"is_red":false,"text":"Missing fasteners at joist hangers."},{"checked":false,"id":1,"is_red":false,"text":"Joist deck hangers are missing nails. Have all reviewed for adding additional nails."},{"checked":false,"id":1,"is_red":false,"text":"Have the deck reviewed for proper installation and attachment. Check for history of permits."},{"checked":false,"id":1,"is_red":false,"text":"Loose fasteners were observed. Review all fasteners and secure as needed."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Consider upgrading to new composite lumber decking material. "},{"checked":false,"id":1,"is_red":false,"text":"Deck ledger board lacking flashing. Flashing protects the ledger and keeps water away from the side of the house. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"The deck joists are set too far apart for the existing decking boards - as placed on a 45 degree angle to the joists. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Today's deck construction, support, and attachment standards typically call for proper footings, 6X6 posts, and 1/2 inch bolts securing deck to the beam and the house. Not all of these elements appear to be present. Consider upgrading deck to current standards."},{"checked":false,"id":1,"is_red":false,"text":"Missing handrails and balusters."},{"checked":false,"id":1,"is_red":false,"text":"Balusters spaced to far apart."},{"checked":false,"id":1,"is_red":false,"text":"There is wood and soil contact at step supports.  Deterioration may occur."},{"checked":false,"id":1,"is_red":false,"text":"Non-conforming steps, possible safety hazard."},{"checked":false,"id":1,"is_red":false,"text":"The steps are slanted and present a possible slipping hazard."},{"checked":false,"id":1,"is_red":false,"text":"Rails missing at exterior steps, and should be installed for safety."},{"checked":false,"id":1,"is_red":false,"text":"Settlement crack at base of front steps.  Monitor and repair as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Steps are deteriorated and should be evaluated for repair or replacement."},{"checked":false,"id":1,"is_red":false,"text":"Broken / missing step(s)."},{"checked":false,"id":1,"is_red":false,"text":"Clean and Seal Deck:  Recommend cleaning deck and treating with a waterproof sealant claiming to waterproof, block ultraviolet light, and stop mildew."},{"checked":false,"id":1,"is_red":false,"text":"Some deck boards are damaged, and some others need securing."},{"checked":false,"id":1,"is_red":false,"text":"Wood to Soil Contact at deck supports.  Deterioration may occur and insects may gain access to wood."},{"checked":false,"id":1,"is_red":false,"text":"Decking board spacing less than 3/8\". Recommend cleaning deck frequently to avoid accumulation of organic debris causing trapped moisture and eventual rot."},{"checked":false,"id":1,"is_red":false,"text":"Deck Substructure Inspection excluded, due to limited access because of low height or obstructions."},{"checked":false,"id":1,"is_red":false,"text":"Deck installed without supporting bracket hardware.  Recommend installing brackets.  "},{"checked":false,"id":1,"is_red":false,"text":"No Lag Bolts Visible:  The deck ledger board is nailed or screwed to the house, or is covered and not visible. Consider installing lag screws to securely attach ledger board to house, if they have not been used.  "},{"checked":false,"id":1,"is_red":false,"text":"Elevation changes at deck and deck steps; recommend caution and some type of visual alert.  "},{"checked":false,"id":1,"is_red":false,"text":"Deck has two levels that visually blend, which may be a potential fall hazard.  Recommend bright colored tape or paint at edge of step for safety. "},{"checked":false,"id":1,"is_red":false,"text":"Deck physically shakes / sways when walking on it; recommend evaluation / repair by contractor."},{"checked":false,"id":1,"is_red":false,"text":"Flexing deck boards - some boards have \"bounce\" to them and may need re-securing under the carpeted area at deck"},{"checked":false,"id":1,"is_red":false,"text":"Gate at deck will not secure."},{"checked":false,"id":1,"is_red":false,"text":"The deck joists are set too far apart for the existing decking boards - as placed on a 45 degree angle to the joists. Repair as needed."}],"sepChoice":"4","title":"Patio and Porch Deck"},{"descr":"","id":2184,"options":[{"checked":false,"id":1,"is_red":false,"text":"Appeared functional at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"There were no railings installed at the steps. Location: .  "},{"checked":false,"id":1,"is_red":false,"text":"There were no railings installed at the steps. Location: . This is a potential tripping hazard. Recommend installing protective railings. "},{"checked":false,"id":1,"is_red":false,"text":"The metal railing is damaged."},{"checked":false,"id":1,"is_red":false,"text":"The metal railing is showing areas of rust.  Refinish, prime and paint as needed."},{"checked":false,"id":1,"is_red":false,"text":"Missing handrails and balusters."},{"checked":false,"id":1,"is_red":false,"text":"Unstable railings are present."},{"checked":false,"id":1,"is_red":false,"text":"Balusters spaced too far apart."},{"checked":false,"id":1,"is_red":false,"text":"Handrail should be installed at a height of no less than 34\" and no higher than 38\"."},{"checked":false,"id":1,"is_red":false,"text":"Although railings are not required with drop-offs less than 30\" above grade - consider your own personal needs and those of your family and guests. By today's standards, balusters (spindles) at decks and steps should be spaced no more than 4\" apart for the safety of small children,"},{"checked":false,"id":1,"is_red":false,"text":"Guardrail(s) lower than 36\", or need repair / installation above drop-offs higher than 30\"."},{"checked":false,"id":1,"is_red":false,"text":"Spindles missing; safety hazard. "},{"checked":false,"id":1,"is_red":false,"text":"Spindle spacing exceeds the 4 inch spacing which is considered safe by today’s child safety standards.  "},{"checked":false,"id":1,"is_red":false,"text":"Rails missing in areas with drop offs of greater than 30 inches.  Recommend installation of rails for safety."},{"checked":false,"id":1,"is_red":false,"text":"Porch railing not secure."},{"checked":false,"id":1,"is_red":false,"text":"Handrail not graspable at ____.  By today's standards, rails should be configured so that a hand may grasp around a rail for safety."}],"sepChoice":"4","title":"Stairs & Handrail"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Patio and Porch Deck Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Stairs & Handrail Overall"}],"title":"Deck/Stairs"},{"damage_panels":[{"descr":"","id":2185,"options":[{"checked":false,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Covers or globes recommended over bare light bulbs."},{"checked":false,"id":1,"is_red":false,"text":"."},{"checked":false,"id":1,"is_red":false,"text":"OUTLETS:"},{"checked":false,"id":1,"is_red":false,"text":"Outlet cover(s) are for interior use and are not waterproof. "},{"checked":false,"id":1,"is_red":false,"text":"GFCI trip test failed.   "},{"checked":false,"id":1,"is_red":false,"text":"Open ground (or 2-wire) outlets present.  This means that the 3rd (round) part of an appliance plug is not getting ground protection.  This may be a concern with items such as computers and electronic devices."},{"checked":false,"id":1,"is_red":false,"text":"Hot-neutral reversed outlets present.  This means that the black and white wires in the circuit have been reversed, and may be a concern with items such as computers and electronic devices."},{"checked":false,"id":1,"is_red":false,"text":"Outlet damaged or apparently inoperable. "},{"checked":false,"id":1,"is_red":false,"text":"."},{"checked":false,"id":1,"is_red":false,"text":"SWITCHES:"},{"checked":false,"id":1,"is_red":false,"text":"missing switch plate covers were found, make sure they are replaced."},{"checked":false,"id":1,"is_red":false,"text":"The service shutoff for the steamer unit is located inside the laundry closet; and positioned in a way that makes it extremely difficult to access. "},{"checked":false,"id":1,"is_red":false,"text":"Switches are outdated and replacements may be hard to find; have an electrician upgrade them along with the receptacles."},{"checked":false,"id":1,"is_red":false,"text":"Poor, unprofessional installation of switch that controls the under cabinet lighting."},{"checked":false,"id":1,"is_red":false,"text":"The switches located in upstairs hallway are not functioning or their purpose is unknown."},{"checked":false,"id":1,"is_red":false,"text":"Light switches are often rocker type."},{"checked":false,"id":1,"is_red":false,"text":"Incomplete installation "},{"checked":false,"id":1,"is_red":false,"text":"Switch cover not waterproof."},{"checked":false,"id":1,"is_red":false,"text":"Light switch damaged or bulb inoperable."},{"checked":false,"id":1,"is_red":false,"text":"."},{"checked":false,"id":1,"is_red":false,"text":"WIRES:"},{"checked":false,"id":1,"is_red":false,"text":"Extension cord used in lieu of \"hard wire”."},{"checked":false,"id":1,"is_red":false,"text":"Interior grade Romex should be replaced with exterior-rated Romex and enclosed in conduit."},{"checked":false,"id":1,"is_red":false,"text":"Junction Box Covers missing or damaged; install cover for safety."},{"checked":false,"id":1,"is_red":false,"text":"Connections made outside of a Junction Box, which is a potential shock or electrocution hazard. "},{"checked":false,"id":1,"is_red":false,"text":"Frayed wire sheathing; possible shock or electrocution hazard.  Repair or replacement recommended."},{"checked":false,"id":1,"is_red":false,"text":"Wire ends are outside of a Junction Box, which is a potential shock or electrocution hazard."},{"checked":false,"id":1,"is_red":false,"text":"Live Bare Wire Ends, shock or electrocution hazard. See photo."},{"checked":false,"id":1,"is_red":false,"text":"."},{"checked":false,"id":1,"is_red":false,"text":"SERVICE ENTRANCE:"},{"checked":false,"id":1,"is_red":false,"text":"Overhead electrical service clearance -   Service conductors have inadequate height clearance from the ground. Requirements are as follows: 10 feet above a walkway (including decks and balconies), 12 feet above a drive, 18 feet above a roadway and 3 feet from an openable window. Contact local public service company to inquire about correction."},{"checked":false,"id":1,"is_red":false,"text":"- Electrical Service Wires: Less than 10' above ground.  "},{"checked":false,"id":1,"is_red":false,"text":"- Electrical Service Wires: Less than 12' above driveway.  "},{"checked":false,"id":1,"is_red":false,"text":"- Electrical Service Wires: Less than 3' from door or window openings.  "},{"checked":false,"id":1,"is_red":false,"text":"- Electrical Service Wires damaged.  See photo."},{"checked":false,"id":1,"is_red":false,"text":"- Electrical Service Mast: Bent / Loose.  "},{"checked":false,"id":1,"is_red":false,"text":"The Utility company seal is missing  from the meter. This will not affect electric service but the utility company should be notified so a new seal can be installed."},{"checked":false,"id":1,"is_red":false,"text":"Drip loop not present at weatherhead. This condition may allow moisture intrusion, resulting in damage to electrical components. Correction should be made by a qualified electrical contractor."},{"checked":false,"id":1,"is_red":false,"text":"Exterior breaker panel cover adjacent to meter is unsecured at hinges and should be repaired.  See photo."},{"checked":false,"id":1,"is_red":false,"text":"Exterior lights and fixtures have yet to be installed."},{"checked":false,"id":1,"is_red":false,"text":"Note that the main exterior disconnect is located at the side porch, under the decorative table."},{"checked":false,"id":1,"is_red":false,"text":"Garage exterior light loose from siding."},{"checked":false,"id":1,"is_red":false,"text":"Non-standard wiring from house to barn should be evaluated and repaired by licensed electrician."},{"checked":false,"id":1,"is_red":false,"text":"Bare electrical wire ends in detached root cellar should be enclosed in a box or removed."},{"checked":false,"id":1,"is_red":false,"text":"Service mast for (telephone line?) is bent, presumably from snow sliding on roof, and cable is abrading against roof."}],"sepChoice":"4","title":"Grounds Electrical"},{"descr":"","id":2186,"options":[{"checked":false,"id":1,"is_red":false,"text":"None visible."},{"checked":false,"id":1,"is_red":false,"text":"Weatherproof outlets—Exterior outlet / switch cover(s) not waterproof. Have certified electrician evaluate and repair as necessary."},{"checked":false,"id":1,"is_red":false,"text":"No Ground Fault Circuit Interrupter (GFCI) protection of home electrical outlets was provided in the home at the time of inspection. Although GFCI protection may not have been required at the time the home was built, for safety reasons, consider upgrading the electrical system to include GFCI protection at the following locations:\n•\tBathrooms \n•\tOutside \n•\tGarages \n•\tCrawlspace (at or below grade) \n•\tUnfinished basements \n•\tKitchens \n•\tLaundry rooms \n•\tWithin 6 feet of all plumbing fixtures\n•\tBoathouses \n"},{"checked":false,"id":1,"is_red":false,"text":"The exterior \"patio\" outlet GFCI did not shut of when tested, have a qualified electrician replace it."},{"checked":false,"id":1,"is_red":false,"text":"Replace the grounded outlet receptacle under \"utility sink\" located in mechanical closet with a GFCI protected receptacle as this is considered a wet location."},{"checked":false,"id":1,"is_red":false,"text":"Outlets in the basement were not Ground Fault Circuit Interrupter (GFCI) protected. Adding GFCI protection is relatively inexpensive. All electrical work should be performed by a qualified electrical contractor.\nConsider adding GFCI protection of these outlets.\n"},{"checked":false,"id":1,"is_red":false,"text":"Ejector pump outlet was not a GFCI protected receptacles, Have a qualified electrician replace with GFCIs."},{"checked":false,"id":1,"is_red":false,"text":"GFCI receptacles are in good condition."},{"checked":false,"id":1,"is_red":false,"text":"Outdoor receptacles are not GFCI protected, need to be updated."},{"checked":false,"id":1,"is_red":false,"text":"GFCI: Ground Fault Circuit interrupter ."},{"checked":false,"id":1,"is_red":false,"text":"GFCI not grounded."},{"checked":false,"id":1,"is_red":false,"text":"None."},{"checked":false,"id":1,"is_red":false,"text":"Missing cover."},{"checked":false,"id":1,"is_red":false,"text":"GFCI, lights & fans on same circuit."},{"checked":false,"id":1,"is_red":false,"text":"Irregular installation."},{"checked":false,"id":1,"is_red":false,"text":"Painted over."},{"checked":false,"id":1,"is_red":false,"text":"Reset button worn."},{"checked":false,"id":1,"is_red":false,"text":"Reset button stuck."},{"checked":false,"id":1,"is_red":false,"text":"Would not reset."},{"checked":false,"id":1,"is_red":false,"text":"Did not test."},{"checked":false,"id":1,"is_red":false,"text":"Could not locate GFCI reset."},{"checked":false,"id":1,"is_red":false,"text":"Reset is in the main panel."},{"checked":false,"id":1,"is_red":false,"text":"Reset is in the garage."}],"sepChoice":"4","title":"GFCI"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Grounds Electrical Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"GFCI Overall"}],"title":"Electrical"},{"damage_panels":[{"descr":"","id":2251,"options":[{"checked":false,"id":1,"is_red":false,"text":"Meter located at exterior. All gas appliances have cut-off valves in line at each unit. No gas odors detected."},{"checked":false,"id":1,"is_red":false,"text":"Missing shut off valves."},{"checked":false,"id":1,"is_red":false,"text":"The gas service is off to the structure. The inspector cannot inspect this system."},{"checked":false,"id":1,"is_red":false,"text":"There is a gas smell present at the main valve. We recommend contacting the gas utility company to repair."}],"sepChoice":"4","title":"Main Gas Valve Condition"}],"inspection_panels":[{"descr":"","id":3083,"options":[{"checked":false,"id":1,"is_red":false,"text":"North side."},{"checked":false,"id":1,"is_red":false,"text":"East side."},{"checked":false,"id":1,"is_red":false,"text":"South side."},{"checked":false,"id":1,"is_red":false,"text":"West side."},{"checked":false,"id":1,"is_red":false,"text":"At curb only."},{"checked":false,"id":1,"is_red":false,"text":"Front of structure."},{"checked":false,"id":1,"is_red":false,"text":"Rear of structure."},{"checked":false,"id":1,"is_red":false,"text":"Exterior of structure."},{"checked":false,"id":1,"is_red":false,"text":"Under structure."},{"checked":false,"id":1,"is_red":false,"text":"Parking structure."},{"checked":false,"id":1,"is_red":false,"text":"Could not locate."},{"checked":false,"id":1,"is_red":false,"text":"Main gas shut off located at outside meter - East side."},{"checked":false,"id":1,"is_red":false,"text":"LP Gas shutoff located at the gas manifold - labeled and client made aware."}],"sepChoice":"1","title":"Main Gas Valve"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Main Gas Valve Condition Overall"}],"title":"Main Gas Valve"},{"damage_panels":[{"descr":"","id":2190,"options":[{"checked":false,"id":1,"is_red":false,"text":"Sewer line— Due to the fact that the home was not well maintained I do recommend a sewer line inspection. This separate inspection will show the condition of the buried sewer line from the home to the city main. Items such as tree roots, broken drain pipes, and other obstructions will be\nrevealed."},{"checked":false,"id":1,"is_red":false,"text":"Sewer line—Due to the age of this home I recommend a sewer line inspection. This separate inspection will show the condition of the buried sewer line from the home to the city main. Items such as tree roots, broken drain pipes, and other obstructions will be revealed. A qualified plumber with a sewer camera sewer rodding machine can inspect."},{"checked":false,"id":1,"is_red":false,"text":"Septic system noted.  Client is advised to seek the services of a specialist in evaluating this system.\n"},{"checked":false,"id":1,"is_red":false,"text":"Potable water supplied by well.  Suggest water testing within inspection contingency period."},{"checked":false,"id":1,"is_red":false,"text":"Most n/a due to insulation covering the pipe."},{"checked":false,"id":1,"is_red":false,"text":"Corrosion is noted. Consult with a licensed plumbing contractor to determine and correct the cause of the issue."},{"checked":false,"id":1,"is_red":false,"text":"Rust is noted. Consult with a licensed plumbing contractor to determine and correct the cause of the issue."},{"checked":false,"id":1,"is_red":false,"text":"Visible leaking is noted. Consuls with a licensed plumbing contractor to determine and correct the cause of the issue."},{"checked":false,"id":1,"is_red":false,"text":"Copper to galvanized missing proper connections. This condition will lead to a galvanic reaction which will corrode the pipes. Contact a licensed plumbing contractor to have the proper fittings installed."},{"checked":false,"id":1,"is_red":false,"text":"Recommend contacting a licensed plumber to evaluate all areas."},{"checked":false,"id":1,"is_red":false,"text":"Front water spigot defective; leaks."}],"sepChoice":"4","title":"Plumbing"}],"inspection_panels":[{"descr":"","id":3056,"options":[{"checked":false,"id":1,"is_red":false,"text":"Copper piping noted."},{"checked":false,"id":1,"is_red":false,"text":"Galvanized piping noted."},{"checked":false,"id":1,"is_red":false,"text":"Aquapex piping noted."},{"checked":false,"id":1,"is_red":false,"text":"PVC piping noted."}],"sepChoice":"1","title":"Plumbing Material Type"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Plumbing Overall"}],"title":"Plumbing"},{"damage_panels":[{"descr":"","id":2192,"options":[{"checked":false,"id":1,"is_red":false,"text":"High pressure."},{"checked":false,"id":1,"is_red":false,"text":"recommend 80 psi"},{"checked":false,"id":1,"is_red":false,"text":"Low pressure."},{"checked":false,"id":1,"is_red":false,"text":"n/a"},{"checked":false,"id":1,"is_red":false,"text":"20"},{"checked":false,"id":1,"is_red":false,"text":"25"},{"checked":false,"id":1,"is_red":false,"text":"30"},{"checked":false,"id":1,"is_red":false,"text":"35"},{"checked":false,"id":1,"is_red":false,"text":"40"},{"checked":false,"id":1,"is_red":false,"text":"45"},{"checked":false,"id":1,"is_red":false,"text":"50"},{"checked":false,"id":1,"is_red":false,"text":"55"},{"checked":false,"id":1,"is_red":false,"text":"60"},{"checked":false,"id":1,"is_red":false,"text":"65"},{"checked":false,"id":1,"is_red":false,"text":"70"},{"checked":false,"id":1,"is_red":false,"text":"75"},{"checked":false,"id":1,"is_red":false,"text":"80"},{"checked":false,"id":1,"is_red":false,"text":"85"},{"checked":false,"id":1,"is_red":false,"text":"90"},{"checked":false,"id":1,"is_red":false,"text":"95"},{"checked":false,"id":1,"is_red":false,"text":"100"},{"checked":false,"id":1,"is_red":false,"text":"105"},{"checked":false,"id":1,"is_red":false,"text":"110"},{"checked":false,"id":1,"is_red":false,"text":"115"},{"checked":false,"id":1,"is_red":false,"text":"120"},{"checked":false,"id":1,"is_red":false,"text":"125"},{"checked":false,"id":1,"is_red":false,"text":"130"},{"checked":false,"id":1,"is_red":false,"text":"135"},{"checked":false,"id":1,"is_red":false,"text":"140"},{"checked":false,"id":1,"is_red":false,"text":"145"},{"checked":false,"id":1,"is_red":false,"text":"150"},{"checked":false,"id":1,"is_red":false,"text":"155"},{"checked":false,"id":1,"is_red":false,"text":"160"},{"checked":false,"id":1,"is_red":false,"text":"165"},{"checked":false,"id":1,"is_red":false,"text":"170"},{"checked":false,"id":1,"is_red":false,"text":"175"},{"checked":false,"id":1,"is_red":false,"text":"Water is turned off to the structure."},{"checked":false,"id":1,"is_red":false,"text":"psi"}],"sepChoice":"4","title":"Water Pressure"},{"descr":"","id":2193,"options":[{"checked":false,"id":1,"is_red":false,"text":"None."},{"checked":false,"id":1,"is_red":false,"text":"Pressure regulator noted."},{"checked":false,"id":1,"is_red":false,"text":"The pressure regulator is leaking."},{"checked":false,"id":1,"is_red":false,"text":"We recommend the installation of a pressure regulator."},{"checked":false,"id":1,"is_red":false,"text":"There is corrosion present around the pressure regulator."},{"checked":false,"id":1,"is_red":false,"text":"The pressure regulator is missing an adjustment screw."},{"checked":false,"id":1,"is_red":false,"text":"The pressure regulator has a stripped adjustment screw."}],"sepChoice":"4","title":"Pressure Regulator"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Water Pressure Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Pressure Regulator Overall"}],"title":"Water Pressure"},{"damage_panels":[{"descr":"","id":2194,"options":[{"checked":false,"id":1,"is_red":false,"text":"Hose bib missing handle."},{"checked":false,"id":1,"is_red":false,"text":"Hose bib at north side of house leaks. "},{"checked":false,"id":1,"is_red":false,"text":"Hose bib at south side of house leaks. "},{"checked":false,"id":1,"is_red":false,"text":"Hose bib at east side of house leaks. "},{"checked":false,"id":1,"is_red":false,"text":"Hose bib at west side of house leaks. "},{"checked":false,"id":1,"is_red":false,"text":"Hose bib leaks in garage."},{"checked":false,"id":1,"is_red":false,"text":"The water is off to structure, all water areas not tested."},{"checked":false,"id":1,"is_red":false,"text":"Appears Functional."},{"checked":false,"id":1,"is_red":false,"text":"Home does not appear to have any exterior hose spigots installed. <FYI>"},{"checked":false,"id":1,"is_red":false,"text":"Appears to be leaking at valve seal when in the open position, recommend repair for water conservation and to prevent possible water damage to structure/water intrusion if the hose is left on for extended period."},{"checked":false,"id":1,"is_red":false,"text":"Missing/broken handle noted at time of inspection, repairs recommended."},{"checked":false,"id":1,"is_red":false,"text":"Handle difficult to operate."},{"checked":false,"id":1,"is_red":false,"text":"Recommend upgrading to a frost proof type hose bibb to prevent possible damage due to cracking of water line in below freezing temperatures."},{"checked":false,"id":1,"is_red":false,"text":"The inspector not able to determine if valve is frost proof type due to lack of identification, recommend consulting with plumber as to valve type."},{"checked":false,"id":1,"is_red":false,"text":"Not operational at:"},{"checked":false,"id":1,"is_red":false,"text":"One or more water hose bibs are not frost proof and will need to be winterized before weather turns below 32* as pipe damage can occur."},{"checked":false,"id":1,"is_red":false,"text":"Loose at structure, repairs needed to prevent possible damage to supply line."},{"checked":false,"id":1,"is_red":false,"text":"Not functional at one or more locations, further review and repair recommended."},{"checked":false,"id":1,"is_red":false,"text":"Appears to be damaged, possibly due to freezing. Recommend review and repair by a qualified plumber."},{"checked":false,"id":1,"is_red":false,"text":"Appears to be damaged/leaking. Recommend review and repair by a qualified plumber."}],"sepChoice":"4","title":"Exterior Faucet Condition"}],"inspection_panels":[{"descr":"Location:","id":3057,"options":[{"checked":false,"id":1,"is_red":false,"text":"Front of structure."},{"checked":false,"id":1,"is_red":false,"text":"North side of house."},{"checked":false,"id":1,"is_red":false,"text":"East side of house."},{"checked":false,"id":1,"is_red":false,"text":"South side of house."},{"checked":false,"id":1,"is_red":false,"text":"West side of house."},{"checked":false,"id":1,"is_red":false,"text":"Outside of garage."},{"checked":false,"id":1,"is_red":false,"text":"Could not locate a hose bib."},{"checked":false,"id":1,"is_red":false,"text":"Located under the structure."}],"sepChoice":"1","title":"Exterior Faucet Location"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Exterior Faucet Condition Overall"}],"title":"Exterior Faucet"},{"damage_panels":[{"descr":"","id":2181,"options":[{"checked":false,"id":1,"is_red":false,"text":"Appears in satisfactory and functional condition with normal wear for its age.  Appears to be sound structure."},{"checked":false,"id":1,"is_red":false,"text":"MAINTENANCE: Whether treated or not, it is important to keep a wood deck surface free of all forms of fungal growth and debris that retains moisture and will cause the deck to eventually rot. Recommend cleaning and resealing the deck annually. Cleaning can be accomplished by scrubbing the deck with a sodium-hypochlorite (bleach) and Tri-Sodium-Phosphate (TSP) deck wash and then rinsing with a pressure washer. Finally, a wood deck should be recoated with a good-quality deck sealant.      "},{"checked":false,"id":1,"is_red":false,"text":"MAINTENANCE: Even decks of composite lumber need periodic maintenance to keep them free of algae and mold that can make the surface very slick. Recommend cleaning composite decks annually by scrubbing with a solution of: 1/3 cup laundry soap; 2/3 cup Tri-Sodium-Phosphate (TSP); one quart bleach; and 3 quarts of water. Rinse with a hose--Do Not Use a Pressure-Washer on composite lumber."},{"checked":false,"id":1,"is_red":false,"text":"Rotted Wood."},{"checked":false,"id":1,"is_red":false,"text":"Unstable supports."},{"checked":false,"id":1,"is_red":false,"text":"Reverse Grading."},{"checked":false,"id":1,"is_red":false,"text":"No flashing present."},{"checked":false,"id":1,"is_red":false,"text":"Floor boards damaged."},{"checked":false,"id":1,"is_red":false,"text":"Floor boards rotted."},{"checked":false,"id":1,"is_red":false,"text":"Improper fasteners."},{"checked":false,"id":1,"is_red":false,"text":"Lag bolts not present."},{"checked":false,"id":1,"is_red":false,"text":"Improper attachment of ledger board."},{"checked":false,"id":1,"is_red":false,"text":"Missing fasteners at joist hangers."},{"checked":false,"id":1,"is_red":false,"text":"Joist deck hangers are missing nails. Have all reviewed for adding additional nails."},{"checked":false,"id":1,"is_red":false,"text":"Have the deck reviewed for proper installation and attachment. Check for history of permits."},{"checked":false,"id":1,"is_red":false,"text":"Loose fasteners observed. Review all and secure as needed."},{"checked":false,"id":1,"is_red":false,"text":"Not visible underneath."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Consider upgrading to new composite lumber decking material. "},{"checked":false,"id":1,"is_red":false,"text":"Deck ledger board lacking flashing. Flashing protects the ledger and keeps water away from the side of the house. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Today's deck construction, support, and attachment standards typically call for proper footings, 6X6 posts, and 1/2 inch bolts securing deck to the beam and the house. Not all of these elements appear to be present. Consider upgrading deck to current standards."},{"checked":false,"id":1,"is_red":false,"text":"Appeared functional at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Missing handrails and balusters."},{"checked":false,"id":1,"is_red":false,"text":"Unstable railings."},{"checked":false,"id":1,"is_red":false,"text":"Balusters spaced to far apart."}],"sepChoice":"4","title":"Balcony"},{"descr":"","id":2182,"options":[{"checked":false,"id":1,"is_red":false,"text":"Appears in satisfactory and functional condition with normal wear for its age.  Appears to be sound structure."},{"checked":false,"id":1,"is_red":false,"text":"MAINTENANCE: Whether treated or not, it is important to keep a wood deck surface free of all forms of fungal growth and debris that retains moisture and will cause the deck to eventually rot. Recommend cleaning and resealing the deck annually. Cleaning can be accomplished by scrubbing the deck with a sodium-hypochlorite (bleach) and Tri-Sodium-Phosphate (TSP) deck wash and then rinsing with a pressure washer. Finally, a wood deck should be recoated with a good-quality deck sealant.      "},{"checked":false,"id":1,"is_red":false,"text":"MAINTENANCE: Even decks of composite lumber need periodic maintenance to keep them free of algae and mold that can make the surface very slick. Recommend cleaning composite decks annually by scrubbing with a solution of: 1/3 cup laundry soap; 2/3 cup Tri-Sodium-Phosphate (TSP); one quart bleach; and 3 quarts of water. Rinse with a hose--Do Not Use a Pressure-Washer on composite lumber."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Consider upgrading to new composite lumber decking material. "},{"checked":false,"id":1,"is_red":false,"text":"Rotted Wood."},{"checked":false,"id":1,"is_red":false,"text":"Unstable supports."},{"checked":false,"id":1,"is_red":false,"text":"No flashing present."},{"checked":false,"id":1,"is_red":false,"text":"Floor boards damaged."},{"checked":false,"id":1,"is_red":false,"text":"Floor boards rotted."},{"checked":false,"id":1,"is_red":false,"text":"Improper fasteners."},{"checked":false,"id":1,"is_red":false,"text":"Lag bolts not present"},{"checked":false,"id":1,"is_red":false,"text":"Improper attachment of ledger board."},{"checked":false,"id":1,"is_red":false,"text":"Missing fasteners at joist hangers."},{"checked":false,"id":1,"is_red":false,"text":"Joist deck hangers are missing nails. Have all reviewed for adding additional nails."},{"checked":false,"id":1,"is_red":false,"text":"Loose fasteners observed. Review all and secure as needed."},{"checked":false,"id":1,"is_red":false,"text":"Not visible underneath."},{"checked":false,"id":1,"is_red":false,"text":"Deck ledger board lacking flashing. Flashing protects the ledger and keeps water away from the side of the house. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Appeared functional at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Missing handrails and balusters."},{"checked":false,"id":1,"is_red":false,"text":"Unstable railings observed."},{"checked":false,"id":1,"is_red":false,"text":"Balusters spaced to far apart."},{"checked":false,"id":1,"is_red":false,"text":"Damaged supports."},{"checked":false,"id":1,"is_red":false,"text":"Improper footings."},{"checked":false,"id":1,"is_red":false,"text":"Mortar deterioration was observed."},{"checked":false,"id":1,"is_red":false,"text":"Floor joists damaged/rotting."},{"checked":false,"id":1,"is_red":false,"text":"Beams damaged/rotting."},{"checked":false,"id":1,"is_red":false,"text":"Floor rotted/damaged."},{"checked":false,"id":1,"is_red":false,"text":"Common cracks/Seal as needed."},{"checked":false,"id":1,"is_red":false,"text":"Torn/damaged screens in two areas of Screened Porch."},{"checked":false,"id":1,"is_red":false,"text":"General overall condition appear satisfactory with painted surfaces in good condition, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Routine maintenance required for all exterior painted surfaces."},{"checked":false,"id":1,"is_red":false,"text":"The patio is improperly sloped towards the foundation. Water can infiltrate into the interior. Recommend repairing or replacing the patio to properly slope away from the foundation."},{"checked":false,"id":1,"is_red":false,"text":"The patio has settled with a deteriorated mortar base and has created some tripping hazards. Recommend professional contractor review for repairs."},{"checked":false,"id":1,"is_red":false,"text":"The brick patio has settled and is improperly sloped towards the garage. Water can infiltrate under the slab and addition. The base appears to be inadequate. Recommend removing the bricks and installing the proper base or have a different type of patio installed like stamped concrete. The base and proper grading are the keys."},{"checked":false,"id":1,"is_red":false,"text":"Improve:  Typical cracking was observed at the concrete surfaces. Further deterioration will occur as water expands and contracts from freeze and thaw cycles. Recommend sealing the cracks to prolong the life of the concrete."},{"checked":false,"id":1,"is_red":false,"text":"Wood posts are improperly secured at concrete. Recommend properly securing."},{"checked":false,"id":1,"is_red":false,"text":"The indoor/outdoor carpet is damaged and is a tripping hazard."},{"checked":false,"id":1,"is_red":false,"text":"Uneven slabs at the patio. "},{"checked":false,"id":1,"is_red":false,"text":"Common cracks/Seal as needed."},{"checked":false,"id":1,"is_red":false,"text":"Sunken areas with cracks and breaks"}],"sepChoice":"4","title":"Patio Enclosure"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Balcony Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Patio Enclosure Overall"}],"title":"Patio"},{"damage_panels":[{"descr":"","id":2180,"options":[{"checked":false,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Clean roof areas:  Significant amounts of organic debris evident."},{"checked":false,"id":1,"is_red":false,"text":"Moss on roof. This can lead to the premature failure of the roof and subsequent leaks. Recommend treating moss during its growing season (wet months) with a moss killer. For information on various moss treatment products and their pros and cons, visit http://bryophytes.science.oregonstate.edu/page24.htm.  "},{"checked":false,"id":1,"is_red":false,"text":"Snow covered; not fully inspected."},{"checked":false,"id":1,"is_red":false,"text":"With the potential of roof collapses during winter, we recommend that the roof be evaluated for snow load and clearing in the immediate future.  Buildings constructed with building permits are generally designed to carry a snow load of 40 lbs per square foot.  We recommend that you monitor the snow load on your roof during winters and have the roof cleared as necessary.  Note that the snow load and snow load capacity of a roof is beyond the scope of a home inspection.  Snow accumulation, especially on a vacant home, should be monitored as frequently as on a daily basis. "},{"checked":false,"id":1,"is_red":false,"text":"Ridge cap: deteriorated or missing shingles. "},{"checked":false,"id":1,"is_red":false,"text":"Some shingles damaged."},{"checked":false,"id":1,"is_red":false,"text":"Minor shingle damage visible, presumably from raking snow off roof."},{"checked":false,"id":1,"is_red":false,"text":"Some shingles &/or tabs missing."},{"checked":false,"id":1,"is_red":false,"text":"Some shingles curling."},{"checked":false,"id":1,"is_red":false,"text":"Sagging / buckling on roof decking. "},{"checked":false,"id":1,"is_red":false,"text":"Exposed nails on roofing material. Recommend sealing all fastener heads."},{"checked":false,"id":1,"is_red":false,"text":"Roof ventilation may be inadequate; this may contribute to premature roof failure, conducive conditions for mold growth in attic, and/or high heating / cooling bills.  Consider further evaluation by qualified contractor."},{"checked":false,"id":1,"is_red":false,"text":"Semi-flat roof area should be kept clean to avoid leaks, snow loading or ice damming."},{"checked":false,"id":1,"is_red":false,"text":"Slope-slope, slope-wall or slope-semi flat roof design at    Recommend keeping this area clean to avoid leaks or ice damming."},{"checked":false,"id":1,"is_red":false,"text":"Siding-Roof Contact: Check for moisture damage.  Recommend a 1\" gap between the siding and the roofing below where necessary."},{"checked":false,"id":1,"is_red":false,"text":"Flashing appears inadequate; see photo. "},{"checked":false,"id":1,"is_red":false,"text":"Missing plumbing vent pipe; these are necessary for sanitary and smooth flow of the system."},{"checked":false,"id":1,"is_red":false,"text":"Damaged plumbing vent, presumably from sliding snow.  See photo."},{"checked":false,"id":1,"is_red":false,"text":"Partially snow covered, not fully inspected. "},{"checked":false,"id":1,"is_red":false,"text":"..."},{"checked":false,"id":1,"is_red":false,"text":"No \"Cricket\" (a small ridged roof section just above the chimney to shed water off to the sides) is installed above the (wider than 2’) chimney. Keep clean of any accumulated debris which may cause leaks. "},{"checked":false,"id":1,"is_red":false,"text":"Serviceability of roof is questionable; it should be evaluated and repaired as necessary by a professional roofing contractor."},{"checked":false,"id":1,"is_red":false,"text":"Wood Shake Roof: Consider professional evaluation and cleaning, and possibly having a preservative applied. "},{"checked":false,"id":1,"is_red":false,"text":"Some wood shakes missing / damaged / nails lifting."},{"checked":false,"id":1,"is_red":false,"text":"Some areas roofed by plastic or fiberglass panels; monitor for leaks or accumulated debris."},{"checked":false,"id":1,"is_red":false,"text":"Some areas not visible from inspection level"},{"checked":false,"id":1,"is_red":false,"text":"Ponding in areas."},{"checked":false,"id":1,"is_red":false,"text":"Recommend roofing contractor to evaluate."},{"checked":false,"id":1,"is_red":false,"text":"Under construction n/a."},{"checked":false,"id":1,"is_red":false,"text":"Porch roof sagging."},{"checked":false,"id":1,"is_red":false,"text":"Note that experts recommend that any roof over 10 years old receive a roof certification by a local roofing specialist. "},{"checked":false,"id":1,"is_red":false,"text":"Indications of past or present water leaks, seeps, or condensation at eaves."},{"checked":false,"id":1,"is_red":false,"text":"Maintenance Tip:  Structures constructed with building permits are generally designed to carry a snow load of 40 lbs per square foot.  We recommend that you monitor the snow load on your roof during winters and have the roof cleared as necessary. "},{"checked":false,"id":1,"is_red":false,"text":"Maintenance Tip: Roof design has many peaks and valleys; keep roof cleared of debris and heavy snow loads to extend life of roof."},{"checked":false,"id":1,"is_red":false,"text":"Maintenance Tip:  Weather permitting, keep debris cleared from roof valleys to extend life of roof. "}],"sepChoice":"4","title":"Patio and Porch Condition"}],"inspection_panels":[{"descr":"","id":3053,"options":[{"checked":false,"id":1,"is_red":false,"text":"The patio/porch roof is the same as main structure."},{"checked":false,"id":1,"is_red":false,"text":"Asphalt shingles noted."},{"checked":false,"id":1,"is_red":false,"text":"Concrete tiles noted."},{"checked":false,"id":1,"is_red":false,"text":"Rolled roofing noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood shingles noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood shakes noted."},{"checked":false,"id":1,"is_red":false,"text":"Metal standing seam roofing noted."},{"checked":false,"id":1,"is_red":false,"text":"Fiberglass composite shingles noted."},{"checked":false,"id":1,"is_red":false,"text":"Composition shingles noted."},{"checked":false,"id":1,"is_red":false,"text":"Flat roof, rubber membrane, inspected with Ladder."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum standing seam roof present."}],"sepChoice":"1","title":"Patio and Porch Roofing"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Patio and Porch Condition Overall"}],"title":"Patio/Porch Roof"},{"damage_panels":[{"descr":"","id":2187,"options":[{"checked":false,"id":1,"is_red":false,"text":"The inspector could not inspect due to overgrown ground cover."},{"checked":false,"id":1,"is_red":false,"text":"Retaining wall is leaning."},{"checked":false,"id":1,"is_red":false,"text":"Settled\\Loose stone observed."},{"checked":false,"id":1,"is_red":false,"text":"Appeared serviceable at time of inspection.  Structural assembly inaccessible."},{"checked":false,"id":1,"is_red":false,"text":"Damaged/ missing mortar observed, suggest tuckpointing as necessary."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the retaining walls are near the end of their useful life."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified professional for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Peeling paint observed, suggest scraping and painting as necessary."},{"checked":false,"id":1,"is_red":false,"text":"**FENCING**"},{"checked":false,"id":1,"is_red":false,"text":"Fence leaning in areas."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the fences/gates are near the end of their useful life."},{"checked":false,"id":1,"is_red":false,"text":"Loose top blocks observed. This is a safety concern. Suggest maintenance/repairs as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Wood deterioration observed. Suggest repairs/replacement as needed."},{"checked":false,"id":1,"is_red":false,"text":"Fence damaged."}],"sepChoice":"4","title":"Fence Condition"}],"inspection_panels":[{"descr":"","id":3054,"options":[{"checked":false,"id":1,"is_red":false,"text":"Wood"},{"checked":false,"id":1,"is_red":false,"text":"Concrete"},{"checked":false,"id":1,"is_red":false,"text":"Block"},{"checked":false,"id":1,"is_red":false,"text":"Stone"},{"checked":false,"id":1,"is_red":false,"text":"Brick"},{"checked":false,"id":1,"is_red":false,"text":"Not Visible"}],"sepChoice":"1","title":"Fence or Wall Material"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Fence Condition Overall"}],"title":"Fencing and Walls"},{"damage_panels":[{"descr":"","id":2191,"options":[{"checked":false,"id":1,"is_red":false,"text":"Home is equipped with an underground sprinkler system. The inspector recommends client consult with home owner for operation instructions and proper winterizing information. Sprinkler systems are beyond the scope of a Home Inspection, due to most of its parts/piping not visible for inspection."},{"checked":false,"id":1,"is_red":false,"text":"Sprinkler system noted; client is advised to seek advice of a specialist in evaluating this system before use."},{"checked":false,"id":1,"is_red":false,"text":"The sprinkler system operates with a control panel located in the garage."},{"checked":false,"id":1,"is_red":false,"text":"The sprinkler system operates with a control panel located in the basement."},{"checked":false,"id":1,"is_red":false,"text":"Several zone valves appear to be leaking. We recommend contacting a qualified contractor to repair. "},{"checked":false,"id":1,"is_red":false,"text":"Several heads appear to need adjustment to broaden their coverage area."},{"checked":false,"id":1,"is_red":false,"text":"A few of the sprinkler heads are spraying structure. We recommend adjusting the heads so they do not spray the house."},{"checked":false,"id":1,"is_red":false,"text":"The system did not operate when tested."},{"checked":false,"id":1,"is_red":false,"text":"The inspector noted a few broken heads."},{"checked":false,"id":1,"is_red":false,"text":"Main valve in off position, probably due to winterization. We cannot test without the valves being open."},{"checked":false,"id":1,"is_red":false,"text":"Main valve is missing its handle, probably due to winterization. We cannot test without the valves being open."},{"checked":false,"id":1,"is_red":false,"text":"The inspector could not locate the zone valve box. Consult with the seller for its location."},{"checked":false,"id":1,"is_red":false,"text":"The inspector could not access the zone valve box. Consult with the seller for its location."},{"checked":false,"id":1,"is_red":false,"text":"It appears that the zone valves are not connected to the control panel. We could not locate any form of wireless devices either."},{"checked":false,"id":1,"is_red":false,"text":"PVC line leaking."}],"sepChoice":"4","title":"Sprinklers"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Sprinklers Overall"}],"title":"Sprinklers"}],"title":"Grounds"},{"id":2,"tabbed_panels":[{"damage_panels":[{"descr":"","id":2159,"options":[{"checked":false,"id":1,"is_red":false,"text":"The door sill plate needs to be repaired or replaced. Location:"},{"checked":false,"id":1,"is_red":false,"text":"Appeared in  functional and in satisfactory condition, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Tempered glass is now required. Location: "},{"checked":false,"id":1,"is_red":false,"text":"Auto closure device is damaged/missing."},{"checked":false,"id":1,"is_red":false,"text":"Emergency Egress Concern. Exterior door(s) have a double-sided keyed dead bolt lock set.  This type of lock requires a key to unlock the door from the inside and can present an obstacle to anyone trying to evacuate the home in the event of a fire."},{"checked":false,"id":1,"is_red":false,"text":"Garage service door not tested due to storage blocking the door."},{"checked":false,"id":1,"is_red":false,"text":"The entry door to the @@@@@@@ needs to have the striker plate adjusted. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"SECURITY CONCERN:  The front entry door's main (lower) lock hardware does not latch/lock. The only way to keep door closed or locked is by using the deadbolt. Recommend a locksmith repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Rear exterior sliding door needs adjustment to close properly."},{"checked":false,"id":1,"is_red":false,"text":"Door does not latch, needs adjustment."},{"checked":false,"id":1,"is_red":false,"text":"Fog/condensation in thermo-pane glass door observed. This is an indication of a failed seal. Recommend review for repair as necessary"},{"checked":false,"id":1,"is_red":false,"text":"Hardware is damaged."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the exterior doors are near the end of their useful life. "},{"checked":false,"id":1,"is_red":false,"text":"Peeling paint observed, suggest scraping and painting as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Unable to operate, blocked by personal property at the time of inspection. Suggest confirming proper operation prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Unable to operate, locked at the time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Water staining observed."},{"checked":false,"id":1,"is_red":false,"text":"Wood deterioration observed.  Suggest repairs/replacement as needed."},{"checked":false,"id":1,"is_red":false,"text":"Back door is inoperable because of the poorly installed locking hardware."},{"checked":false,"id":1,"is_red":false,"text":"Basement walk out storm door difficult to open and close, appears to be misaligned."},{"checked":false,"id":1,"is_red":false,"text":"Doors do not seal well. this can be an energy drain."},{"checked":false,"id":1,"is_red":false,"text":"Exterior of back door is getting weathered, may need a new coat of paint."},{"checked":false,"id":1,"is_red":false,"text":"Front door appears crooked in door jam, there is a question as to adequacy of the seal against weather."},{"checked":false,"id":1,"is_red":false,"text":"Front door and hardware is damaged, hardware should be replaced and a deadbolt installed."},{"checked":false,"id":1,"is_red":false,"text":"Sliding doors to backyard."},{"checked":false,"id":1,"is_red":false,"text":"The back door is key deadbolt locked, key not present at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"The front entrance door glass is cracked in a few places."},{"checked":false,"id":1,"is_red":false,"text":"2nd floor screen door to porch is damaged."},{"checked":false,"id":1,"is_red":false,"text":"All entrance door hardware should be replaced (locks, door knobs etc)."},{"checked":false,"id":1,"is_red":false,"text":"Basement walkout door was literally screwed shut for some reason. "},{"checked":false,"id":1,"is_red":false,"text":"The entry doors are missing or boarded up, have a contractor evaluate for replacements."}],"sepChoice":"4","title":"Doors"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Doors Overall"}],"title":"Doors"},{"damage_panels":[{"descr":"","id":2164,"options":[{"checked":false,"id":1,"is_red":false,"text":"Components appeared in satisfactory condition at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Some window screens missing and some damaged."},{"checked":false,"id":1,"is_red":false,"text":"Some window screens missing.  Check with seller to determine if they are on the property."},{"checked":false,"id":1,"is_red":false,"text":"Some window screens damaged. "},{"checked":false,"id":1,"is_red":false,"text":"Some crawl space vent screen(s) missing."},{"checked":false,"id":1,"is_red":false,"text":"Some crawl space vent screen(s) damaged. "},{"checked":false,"id":1,"is_red":false,"text":"Screens have yet to be installed."},{"checked":false,"id":1,"is_red":false,"text":"Damaged screens observed."},{"checked":false,"id":1,"is_red":false,"text":"Condensation present in some double-paned windows, indicating a broken gas seal."},{"checked":false,"id":1,"is_red":false,"text":"Window glass cracked."},{"checked":false,"id":1,"is_red":false,"text":"Window glass broken."},{"checked":false,"id":1,"is_red":false,"text":"Frame separating from glass"},{"checked":false,"id":1,"is_red":false,"text":"Window pane not secure; needs glazing"},{"checked":false,"id":1,"is_red":false,"text":"Window hardware damaged."},{"checked":false,"id":1,"is_red":false,"text":"Window will not lock."},{"checked":false,"id":1,"is_red":false,"text":"Window binds in frame."},{"checked":false,"id":1,"is_red":false,"text":"Window will not open."},{"checked":false,"id":1,"is_red":false,"text":"Window will not stay open."},{"checked":false,"id":1,"is_red":false,"text":"Deteriorated frame(s) at window(s)"},{"checked":false,"id":1,"is_red":false,"text":"Questionable Egress from apparent / potential basement bedroom window.  Check building and fire codes."},{"checked":false,"id":1,"is_red":false,"text":"Inadequate wells at windows below grade. "},{"checked":false,"id":1,"is_red":false,"text":"Because it may not have been required when the house was built, windows and sliding glass doors may not have safety/tempered glass installed. Windows and doors with glass that reaches or nears the floor level could be dangerous. Suggest that the client install safety film, safety bars, or consider upgrading to safety/tempered glass to enhance safety. A licensed qualified glass company should be consulted for a complete review of all windows that may require upgrades to ensure safety prior to closing."},{"checked":false,"id":1,"is_red":false,"text":"Boarded up window(s) observed."},{"checked":false,"id":1,"is_red":false,"text":"Broken glazing observed, suggest re-glazing as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Broken sash wire/cord observed on window frame. This is a \"Safety Concern\". Sash wire/cord holds window in open position. Suggest repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Corrosion noted at basement window frames."},{"checked":false,"id":1,"is_red":false,"text":"Deterioration of wooden frames noted.  While basic maintenance may prolong the life of these window frames, replacement may be necessary at some point.  "},{"checked":false,"id":1,"is_red":false,"text":"Fog/condensation observed in thermopane windows. This is an indication of a failed seal. Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the windows/frames are near the end of their useful life."},{"checked":false,"id":1,"is_red":false,"text":"Metal frame windows are subject to frost and condensation and require regular maintenance for proper operation."},{"checked":false,"id":1,"is_red":false,"text":"Minor wood  softening noted.  Recommend ongoing maintenance."},{"checked":false,"id":1,"is_red":false,"text":"Peeling paint observed, suggest scraping and painting as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified professional for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Some windows in this home do not meet modern standards.  Upgrade would greatly enhance overall comfort and efficiency."},{"checked":false,"id":1,"is_red":false,"text":"Suggest caulking and refinishing of doors and window frames as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Suggest caulking around doors and windows as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Suggest sealing/caulking as part of routine maintenance to prevent further deterioration."},{"checked":false,"id":1,"is_red":false,"text":"Thermopane windows observed in the home. The inspector is unable to determine if all double glazed insulated windows in this property are completely intact and without compromised seals. Conditions indicating a broken seal are not always visible or present and may not be apparent or visible at the time of inspection. Changing conditions such as temperature, humidity, and lighting limit the ability of the inspector to visually review these windows for broken seals. For more complete information on the condition of all double glazed windows, consult the seller prior to closing."},{"checked":false,"id":1,"is_red":false,"text":"Windows in this home do not meet modern standards.  Upgrade would greatly enhance overall comfort and efficiency."},{"checked":false,"id":1,"is_red":false,"text":"Split Caulking and peeling paint noted."},{"checked":false,"id":1,"is_red":false,"text":"Suggest caulking around doors and windows as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Suggest sealing/caulking as part of routine maintenance to prevent further deterioration."},{"checked":false,"id":1,"is_red":false,"text":"Mostly original style window treatments outside home; they may not be as energy efficient as newer windows would be. "},{"checked":false,"id":1,"is_red":false,"text":"Unfinished attic space window is cracked; have it professionally repaired to keep with the \" look\"."},{"checked":false,"id":1,"is_red":false,"text":"There is broken window in the basement, and other windows are difficult and sometimes impossible to open; consider installing glass block windows with operable vents for the best appearance, longevity and function."},{"checked":false,"id":1,"is_red":false,"text":"Basement window loose /separating from window structure."},{"checked":false,"id":1,"is_red":false,"text":"Windows are weathered; paint is chipping,and peeling away. Any exterior wood must be protected from the elements as best as possible."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl crank out windows in apparent new condition, although screens are not installed but are located in Garage."},{"checked":false,"id":1,"is_red":false,"text":"Picture windows are tempered glass."},{"checked":false,"id":1,"is_red":false,"text":"Consider budgeting for replacement of the old wooden windows with a energy efficient replacement windows, such as vinyl windows for instance for their long lasing durability and ease of maintenance."},{"checked":false,"id":1,"is_red":false,"text":"Basement window facing front of building is taped on outside, could indicate a air leak/ energy drain."},{"checked":false,"id":1,"is_red":false,"text":"The screens of several windows in the home are missing."},{"checked":false,"id":1,"is_red":false,"text":"Storm windows are present but mostly without the screens installed."},{"checked":false,"id":1,"is_red":false,"text":"Several windows are broken and need to be replaces by a qualified individual."}],"sepChoice":"4","title":"Window Condition"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Window Condition Overall"}],"title":"Windows"},{"damage_panels":[{"descr":"","id":2162,"options":[{"checked":false,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Trim areas need minor prep, priming and painting"},{"checked":false,"id":1,"is_red":false,"text":"Some areas need restaining, or priming and repainting. "},{"checked":false,"id":1,"is_red":false,"text":"Some areas need priming and repainting. "},{"checked":false,"id":1,"is_red":false,"text":"Some areas need priming and repainting (NOTE:  Many houses built before 1978 have lead-based paint).  "},{"checked":false,"id":1,"is_red":false,"text":"Fresh paint was observed.  Although it improves the appearance, it may conceal any possible defects or prior repairs."},{"checked":false,"id":1,"is_red":false,"text":"Caulk and seal all gaps, cracks and openings."},{"checked":false,"id":1,"is_red":false,"text":"Some composition siding shows signs of water damage and swelling."},{"checked":false,"id":1,"is_red":false,"text":"."},{"checked":false,"id":1,"is_red":false,"text":"Foundation form wires protruding around foundation.  These sharp ends can cause injury.  "},{"checked":false,"id":1,"is_red":false,"text":"Areas of eaves (Fascia / Soffit) are in need of paint, repairs or replacement."},{"checked":false,"id":1,"is_red":false,"text":"Some wood deterioration noted.  Have repaired as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Some siding deterioration noted.  Have repaired as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl siding damage.  Recommend repair or replacement of damaged sections to keep moisture and insects from harming structure."},{"checked":false,"id":1,"is_red":false,"text":"Open Window Well(s) on window(s) below grade.  Install a safety grate or a clear weather shield to prevent moisture from entering window areas, and to prevent falls. "},{"checked":false,"id":1,"is_red":false,"text":"Dryer vent cover is missing."},{"checked":false,"id":1,"is_red":false,"text":"Dryer vent cover is damaged."},{"checked":false,"id":1,"is_red":false,"text":"Siding-Soil contact or proximity.  This may provide entrance of moisture or insects to siding.  Recommend grading soil so there is at least 6\" of space (where practical) between the siding and the soil below and checking for any damaged trim and siding materials."},{"checked":false,"id":1,"is_red":false,"text":"Split areas in log siding should be monitored for water / snow / ice retention, which could promote wood decay and insect activity.  Keep these areas sealed with products recommended for this type of application.  Check with seller regarding products that have been used in the past, and check with vendors regarding new products that are always coming onto the market."},{"checked":false,"id":1,"is_red":false,"text":"Firewood storage close to the home; may lead to insect or rodent damage."},{"checked":false,"id":1,"is_red":false,"text":"Warped siding present in some areas; recommend repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"."},{"checked":false,"id":1,"is_red":false,"text":"No major system or safety concerns noted."},{"checked":false,"id":1,"is_red":false,"text":"Sprinklers may be spraying side of house; check and readjust as necessary, to prevent siding damage by moisture or insects..  "},{"checked":false,"id":1,"is_red":false,"text":"Some siding nails need to be reset."},{"checked":false,"id":1,"is_red":false,"text":"Trim boards covering sill plate missing."},{"checked":false,"id":1,"is_red":false,"text":"Maintenance Tip:  Ensure that sprinklers do not spray house siding."},{"checked":false,"id":1,"is_red":false,"text":"There appears to be insecticide grauales (diazanon, etc.) around exterior of home.  Considering the moisture concerns present, client may wish to have an evaluation by a pest professional.  "},{"checked":false,"id":1,"is_red":false,"text":"Water staining at side of house below slope-slope roof area at garage. Water runs down side of hose in this area and may have the opportunity to penetrate walls.  Recommend repair to allow for proper drainage, or install gutters & downspouts."},{"checked":false,"id":1,"is_red":false,"text":"Natural wood siding has some knot holes.  Consider caulking or, at the very least, monitoring for the presence of insects, bird damage, or other activity."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of insect activity and/or insects around exterior of house. Recommend evaluation by licensed pest control specialist/exterminator. "},{"checked":false,"id":1,"is_red":false,"text":"Recommend re-pointing of some mortar areas at stone siding, to minimize pest intrusion.  See photo."},{"checked":false,"id":1,"is_red":false,"text":"Insect damage or activity suspected.  Recommend further evaluation by a licensed exterminator."},{"checked":false,"id":1,"is_red":false,"text":"Minimal eaves at several areas of house, which may allow water penetration at siding or windows."},{"checked":false,"id":1,"is_red":false,"text":"Some minor areas of aluminum and vinyl siding have been damaged.  Siding covers any prior or hidden damage from vegetation, insect, or other causes.  Vegetation has grown underneath the siding in some areas, and insect damage is suspected in some areas, especially in the garage under the stairway."},{"checked":false,"id":1,"is_red":false,"text":"Monitor rear door of carport and repair as needed, as water appears to be delaminating the siding."},{"checked":false,"id":1,"is_red":false,"text":"Some wood deterioration noted at garage - exterior personnel door frame base.  Have repaired and inspected for wood-destroying insect damage."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl siding loose at rear of house."},{"checked":false,"id":1,"is_red":false,"text":"Soffit vent screens need repair to keep birds out."},{"checked":false,"id":1,"is_red":false,"text":"Siding-Soil contact or proximity.  This may provide entrance of moisture or insects to siding.  Recommend grading soil so there is at least 6\" of space (where practical) between the siding and the soil below and checking for any damaged trim and siding materials."},{"checked":false,"id":1,"is_red":false,"text":"Some areas need prep, priming and repainting.  Ensure that composition siding is kept sealed and painted, including the bottom edges. Keeping the siding well sealed will extend the life of the siding."},{"checked":false,"id":1,"is_red":false,"text":"Maintain all exterior finishes, caulking, and other sealants at any dissimilar material abutments and all penetrations to the walls and roof. This inexpensive task aids in the prevention of moisture intrusion and saves on costly repairs."},{"checked":false,"id":1,"is_red":false,"text":"Structural defects may be hidden behind dense foliage, vines, snow, stored items,debris or finishes and cannot be included with this inspection."},{"checked":false,"id":1,"is_red":false,"text":"Wood or wood-like materials present. These materials are subject to moisture damage and weathering to a greater extent than other siding materials, as well as infestation by wood-destroying pests and organisms. Notwithstanding anything noted in this report, recommend further evaluation by licensed pest control professional, repair or replacement as needed, and regular homeowner monitoring and maintenance thereafter"},{"checked":false,"id":1,"is_red":false,"text":"Partially covered with vines."},{"checked":false,"id":1,"is_red":false,"text":"Remove all firewood or debris sitting against the walls of the home, including wood chips that touch the siding ; whether the siding is vinyl or not it is not a good practice to store items next to it "},{"checked":false,"id":1,"is_red":false,"text":"Vinyl siding covers rear portion of home."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum siding covering exterior walls appeared to be in generally serviceable condition at the time of the inspection. Any exceptions will be listed in this report.\nInspection of aluminum siding typically includes examination of…\n•\tinstallation practices\n•\tvisible condition\n"},{"checked":false,"id":1,"is_red":false,"text":"Brick work appears to be in good condition."},{"checked":false,"id":1,"is_red":false,"text":"Exterior walls of the home were covered with synthetic stucco called Exterior Insulation and Finish Systems (EIFS) which requires a specialist inspection. EIFS has installation requirements different from hardcoat stucco which have been widely misunderstood. Many structures with EIFS exterior wall coverings have had EIFS applied by installers who were not qualified and defective installations are common. The Inspector recommends that you have an EIFS inspection performed by a qualified inspector. \r\n"},{"checked":false,"id":1,"is_red":false,"text":"Damage- a hole in the EIFS was observed near entranceway on right side. An EIFS repair specialist can be contacted to correctly perform repairs on this specific type of wall covering."},{"checked":false,"id":1,"is_red":false,"text":"Moderate damage to vinyl: The vinyl siding covering exterior walls had areas of moderate damage which should be repaired to prevent moisture intrusion of the wall assembly. \r\nMoisture intrusion can damage materials and encourage the growth of microbes such as mold fungi. Excessive growth of mold fungi can produce high concentrations of mold spores in indoor air which can cause serious health problems in some people.\r\n"},{"checked":false,"id":1,"is_red":false,"text":"Several missing and damaged vent covers, have contractor replace."}],"sepChoice":"4","title":"Siding Condition"}],"inspection_panels":[{"descr":"","id":3051,"options":[{"checked":false,"id":1,"is_red":false,"text":"Composition wood  or composition cement siding (\"Hardi-Board\" etc.), wood frame construction, concrete / block foundation"},{"checked":false,"id":1,"is_red":false,"text":"Composition wood siding, wood frame construction, concrete / block foundation"},{"checked":false,"id":1,"is_red":false,"text":"Vinyl siding, wood frame construction, concrete / block foundation"},{"checked":false,"id":1,"is_red":false,"text":"Wood siding, wood frame construction, concrete / block foundation"},{"checked":false,"id":1,"is_red":false,"text":"Wood and composition wood siding, wood frame construction, concrete / block foundation."},{"checked":false,"id":1,"is_red":false,"text":"Wood, composition wood and metal siding with wood frame construction, concrete/block foundation"},{"checked":false,"id":1,"is_red":false,"text":"Aluminum siding, wood frame construction, concrete / block foundation."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum siding, wood frame construction, rock & mortar foundation"},{"checked":false,"id":1,"is_red":false,"text":"Manufactured home set on concrete pad with concrete block and steel supports with vinyl siding and wood frame construction."},{"checked":false,"id":1,"is_red":false,"text":"Brick veneer noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl siding noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminium siding noted."},{"checked":false,"id":1,"is_red":false,"text":"Painted wood siding\n\n"},{"checked":false,"id":1,"is_red":false,"text":"Stucco veneer noted."},{"checked":false,"id":1,"is_red":false,"text":"Stone veneer noted."},{"checked":false,"id":1,"is_red":false,"text":"Cedar siding , Shakes noted."},{"checked":false,"id":1,"is_red":false,"text":"Cement siding noted."},{"checked":false,"id":1,"is_red":false,"text":"Split faced concrete block noted."},{"checked":false,"id":1,"is_red":false,"text":"EIFS - Exterior Insulation and Finish Systems- AKA synthetic stucco."},{"checked":false,"id":1,"is_red":false,"text":"Composite shingle siding noted."},{"checked":false,"id":1,"is_red":false,"text":"Brick double-wythe,\nThe exterior walls of the home were double-wythe brick. Double-wythe brick construction includes inner and outer brick walls which may be fastened to each other by a variety of methods.\n"},{"checked":false,"id":1,"is_red":false,"text":"Brick cladding, \nAlthough exterior wall construction was hidden behind interior and exterior wall coverings, exterior walls of the home appeared to be conventional wood framing covered on the exterior by brick. Brick is typically fastened to the framing using metal fasteners and construction typically includes an air space between framing and brick. The Inspector was unable to confirm the presence of a moisture-resistant membrane.\n"},{"checked":false,"id":1,"is_red":false,"text":"Exterior walls of the home were covered with aluminum siding."}],"sepChoice":"1","title":"Siding"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Siding Condition Overall"}],"title":"Siding"},{"damage_panels":[{"descr":"","id":2160,"options":[{"checked":false,"id":1,"is_red":false,"text":"Evidence of repairs observed, unable to determine the effectiveness of these repairs."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the trim is near the end of its useful life"},{"checked":false,"id":1,"is_red":false,"text":"Loose trim cladding observed, suggest securing as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Moisture damage, wood rot, observed. Recommend review for repair as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Peeling paint observed, suggest scraping and painting as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified professional for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Split Caulking and peeling paint noted."},{"checked":false,"id":1,"is_red":false,"text":"Suggest sealing/caulking as part of routine maintenance to prevent further deterioration."},{"checked":false,"id":1,"is_red":false,"text":"Wood or wood-like materials present. These materials are subject to moisture damage and weathering to a greater extent than other siding materials, as well as infestation by wood-destroying pests and organisms. Notwithstanding anything noted in this report, recommend further evaluation by licensed pest control professional, repair or replacement as needed, and regular homeowner monitoring and maintenance thereafter"},{"checked":false,"id":1,"is_red":false,"text":"Soffits at the home appeared to be in serviceable condition at the time of the inspection."},{"checked":false,"id":1,"is_red":false,"text":"Fascia covering the ends of rafter or truss tails appeared to be in generally serviceable condition at the time of the inspection. Notable exceptions will be listed in this report."},{"checked":false,"id":1,"is_red":false,"text":"Monitor trim work ( fascia, soffits etc.) Contact siding installer for any needed maintenance/ repairs/ . Try to locate the previous owners receipts with the name of the company that installed the siding."}],"sepChoice":"4","title":"Eaves & Facia"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Eaves & Facia Overall"}],"title":"Eaves"},{"damage_panels":[{"descr":"","id":2161,"options":[{"checked":false,"id":1,"is_red":false,"text":"Suggest caulking around doors and windows as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Suggest sealing/caulking as part of routine maintenance to prevent further deterioration."},{"checked":false,"id":1,"is_red":false,"text":"Peeling paint observed, suggest scraping and painting as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Exposed wood surfaces observed. Wood rot & deterioration can occur. Prep, prime and paint wood trim surface where paint is peeling or missing."},{"checked":false,"id":1,"is_red":false,"text":"Weathered wood surfaces observed at @@@@@@@@@@@. Wood deterioration and rot can occur. Prep, prime and paint wood trim as needed."},{"checked":false,"id":1,"is_red":false,"text":"Exposed wood surfaces were observed at @@@@@@@@@@@@@@."},{"checked":false,"id":1,"is_red":false,"text":"Approximately 3/4 of the homes built before 1978 (about 64 million homes) contain some lead-based paint. For more information, refer to the following EPA Fact Sheet:\nhttp://www.hud.gov/offices/lead/library/enforcement/fs-discl.pdf"},{"checked":false,"id":1,"is_red":false,"text":"All exterior painted wood trim surfaces should be annually examined and sealed, re-caulked and re-painted as needed."},{"checked":false,"id":1,"is_red":false,"text":"All exterior trim covered with aluminum cladding - except front door trim and wood surfaces of front porch. These areas should be routinely examined and re-painted as needed."},{"checked":false,"id":1,"is_red":false,"text":"Split Caulking and peeling paint noted."},{"checked":false,"id":1,"is_red":false,"text":"Paint on exterior shutters is beginning to get weathered."}],"sepChoice":"4","title":"Exterior Paint"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Exterior Paint Overall"}],"title":"Paint"},{"damage_panels":[{"descr":"","id":2163,"options":[{"checked":false,"id":1,"is_red":false,"text":"The exterior stucco appears to be in a weathered condition. Stucco is a paintable surface, and based on the condition we suggest doing so."},{"checked":false,"id":1,"is_red":false,"text":"The exterior stucco appears to be stained. Stucco is a paintable surface, and based on the condition we suggest doing so."},{"checked":false,"id":1,"is_red":false,"text":"EIFS - This property was primarily clad with an Exterior Insulation and Finishing System (EIFS), also referred to as “artificial or synthetic stucco.” A certified EIFS inspection is beyond the scope of this inspection. Many EIFS-clad homes have had moisture-related problems and exacerbated microbial or insect infestations. Certified inspections and proper maintenance recommendations are imperative in order to minimize and/or prevent problems and to avoid costly repairs. I advise having this specialized inspection performed prior to purchase by an inspector associated with www.exterior-design-inst.com or www.awci.org."},{"checked":false,"id":1,"is_red":false,"text":"We recommend having a qualified exterior finish contractor evaluate and correct the issue."},{"checked":false,"id":1,"is_red":false,"text":"Some areas not accessible due to dense shrubbery against the house."},{"checked":false,"id":1,"is_red":false,"text":"The exterior stucco appears to numerous small cracks on the surface. Stucco is a paintable surface, and based on the condition we suggest doing so as paint can fill in the cracks and seal them up.."},{"checked":false,"id":1,"is_red":false,"text":"We recommend sealing holes & gaps in the stucco to keep water infiltration from causing further damage."},{"checked":false,"id":1,"is_red":false,"text":"The chimney is gapped at the structure. It cannot be determined if the movement in the chimney is ongoing or if it is done moving. We recommend sealing the gap with an exterior caulk, and monitor the chimney for any further settlement."},{"checked":false,"id":1,"is_red":false,"text":"There is moss present on the surface of the stucco. This is indicative of an on going moisture issue."},{"checked":false,"id":1,"is_red":false,"text":"There is stucco missing in areas of the exterior. We recommend having a qualified contractor evaluate and repair the areas."},{"checked":false,"id":1,"is_red":false,"text":"There is a missing stucco molding at the exterior door. "}],"sepChoice":"4","title":"Stucco"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Stucco Overall"}],"title":"Stucco"}],"title":"Exterior Areas"},{"id":3,"tabbed_panels":[{"damage_panels":[{"descr":"","id":2126,"options":[{"checked":false,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Clean roof areas:  Significant amounts of organic debris evident."},{"checked":false,"id":1,"is_red":false,"text":"Moss on roof. This can lead to the premature failure of the roof and subsequent leaks. Recommend treating moss during its growing season (wet months) with a moss killer. For information on various moss treatment products and their pros and cons, visit http://bryophytes.science.oregonstate.edu/page24.htm.  "},{"checked":false,"id":1,"is_red":false,"text":"Snow covered; not fully inspected."},{"checked":false,"id":1,"is_red":false,"text":"Ridge cap: deteriorated or missing shingles. "},{"checked":false,"id":1,"is_red":false,"text":"Some shingles damaged."},{"checked":false,"id":1,"is_red":false,"text":"Some shingles and/or tabs missing."},{"checked":false,"id":1,"is_red":false,"text":"Some shingles curling."},{"checked":false,"id":1,"is_red":false,"text":"Sagging / buckling on roof decking. "},{"checked":false,"id":1,"is_red":false,"text":"Exposed nails on roofing material. Recommend sealing all fastener heads."},{"checked":false,"id":1,"is_red":false,"text":"Roof ventilation may be inadequate; this may contribute to premature roof failure, conducive conditions for mold growth in attic, and/or high heating / cooling bills.  Consider further evaluation by qualified contractor."},{"checked":false,"id":1,"is_red":false,"text":"Semi-flat roof area should be kept clean to avoid leaks, snow loading or ice damming."},{"checked":false,"id":1,"is_red":false,"text":"Slope-slope, slope-wall or slope-semi flat roof design at @@@@   Recommend keeping this area clean to avoid leaks or ice damming."},{"checked":false,"id":1,"is_red":false,"text":"Siding-Roof Contact: Check for moisture damage.  Recommend a 1\" gap between the siding and the roofing below where necessary."},{"checked":false,"id":1,"is_red":false,"text":"Flashing appears inadequate; see photo. "},{"checked":false,"id":1,"is_red":false,"text":"Missing plumbing vent pipe; these are necessary for sanitary and smooth flow of the system."},{"checked":false,"id":1,"is_red":false,"text":"Damaged plumbing vent.  See photo."},{"checked":false,"id":1,"is_red":false,"text":"Partially snow covered, not fully inspected. "},{"checked":false,"id":1,"is_red":false,"text":"..."},{"checked":false,"id":1,"is_red":false,"text":"- Exposed plywood"},{"checked":false,"id":1,"is_red":false,"text":"- Damaged by tree"},{"checked":false,"id":1,"is_red":false,"text":"No \"Cricket\" (a small ridged roof section just above the chimney to shed water off to the sides) is installed above the (wider than 2’) chimney. Keep clean of any accumulated debris which may cause leaks. "},{"checked":false,"id":1,"is_red":false,"text":"Serviceability of roof is questionable; it should be evaluated and repaired as necessary by a professional roofing contractor."},{"checked":false,"id":1,"is_red":false,"text":"Wood Shake Roof: Consider professional evaluation and cleaning, and possibly having a preservative applied. "},{"checked":false,"id":1,"is_red":false,"text":"Some wood shakes missing / damaged / nails lifting."},{"checked":false,"id":1,"is_red":false,"text":"Some areas roofed by plastic or fiberglass panels; monitor for leaks or accumulated debris."},{"checked":false,"id":1,"is_red":false,"text":"Some areas not visible from inspection level."},{"checked":false,"id":1,"is_red":false,"text":"Irregular materials used."},{"checked":false,"id":1,"is_red":false,"text":"Ponding in areas."},{"checked":false,"id":1,"is_red":false,"text":"Recommend roofing contractor to evaluate."},{"checked":false,"id":1,"is_red":false,"text":"Antennae damaged; see photo."},{"checked":false,"id":1,"is_red":false,"text":"Porch roof sagging."},{"checked":false,"id":1,"is_red":false,"text":"Note that experts recommend that any roof over 10 years old receive a roof certification by a local roofing specialist. "},{"checked":false,"id":1,"is_red":false,"text":"Indications of past or present water leaks, seeps, or condensation at eaves."},{"checked":false,"id":1,"is_red":false,"text":"Maintenance Tip: Roof design has many peaks and valleys; keep roof cleared of debris and heavy snow loads to extend life of roof."},{"checked":false,"id":1,"is_red":false,"text":"Maintenance Tip:  Weather permitting, keep debris cleared from roof valleys to extend life of roof. "}],"sepChoice":"4","title":"Roof Condition"}],"inspection_panels":[{"descr":"","id":3039,"options":[{"checked":false,"id":1,"is_red":false,"text":"Common area of home owners association."},{"checked":false,"id":1,"is_red":false,"text":"Roofing is the same as main structure."},{"checked":false,"id":1,"is_red":false,"text":"Inspected from ground level with binoculars.  See Roofing Notes above, in blue.  Due to property and roof configurations, some areas of the roof may be visually restricted from inspection"},{"checked":false,"id":1,"is_red":false,"text":"Some areas of roof are obscured from view."},{"checked":false,"id":1,"is_red":false,"text":"Inspected from ladder."},{"checked":false,"id":1,"is_red":false,"text":"Limited inspection, the roof covered with ice and snow at the time of inspection. Recommend referring to the Seller Disclosure Statement regarding the condition of the roof."},{"checked":false,"id":1,"is_red":false,"text":"Observed from the ground with field glasses."},{"checked":false,"id":1,"is_red":false,"text":"Roof was visually inspected from accessible points on the interior and/or exterior. If a roof is too high, is too steep, is wet, or is composed of materials which can be damaged if walked upon, the roof is not mounted. Therefore, client is advised that this is a limited review and a licensed roofer should be contacted if a more detailed report is desired."},{"checked":false,"id":1,"is_red":false,"text":"Visually accessible from ground."},{"checked":false,"id":1,"is_red":false,"text":"Visually accessible from ground.  Not mounted due to height and pitch making mounting of roof dangerous."},{"checked":false,"id":1,"is_red":false,"text":"Visually accessible from ground.  Not mounted due to weather conditions making mounting of roof dangerous."},{"checked":false,"id":1,"is_red":false,"text":"Visually accessible from ground.  Not mounted due to wet surface."}],"sepChoice":"1","title":"Roof Info"},{"descr":"","id":3040,"options":[{"checked":false,"id":1,"is_red":false,"text":"Asphalt shingles noted."},{"checked":false,"id":1,"is_red":false,"text":"Concrete tiles noted."},{"checked":false,"id":1,"is_red":false,"text":"Rolled roofing noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood shingles noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood shakes noted."},{"checked":false,"id":1,"is_red":false,"text":"Metal standing seam roofing noted."},{"checked":false,"id":1,"is_red":false,"text":"Fiberglass composite shingles noted."},{"checked":false,"id":1,"is_red":false,"text":"Composition shingles noted."},{"checked":false,"id":1,"is_red":false,"text":"Flat roof, rubber membrane, inspected with Ladder."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum standing seam roof present."}],"sepChoice":"1","title":"Roof Material"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Roof Condition Overall"}],"title":"Garage Roof"},{"damage_panels":[{"descr":"","id":2131,"options":[{"checked":false,"id":1,"is_red":false,"text":"There are no firewalls present."},{"checked":false,"id":1,"is_red":false,"text":"Appeared satisfactory, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"The common wall between the garage and home has damage or improper covered areas. Fire potential to the home is at a greater risk. Recommend repairing or installing the proper fire rated wall. "},{"checked":false,"id":1,"is_red":false,"text":"The dryer vents breeches the fire wall protection. Needs to vent to the exterior."},{"checked":false,"id":1,"is_red":false,"text":"Garage drywall ceiling needs to be properly repaired."},{"checked":false,"id":1,"is_red":false,"text":"Does Not Appear to be a Rated Fire Wall/Ceiling"},{"checked":false,"id":1,"is_red":false,"text":"Mold-like bio growth observed. Professional testing & evaluation advised."},{"checked":false,"id":1,"is_red":false,"text":"Signs of mold-like bio growth are present on @@@@@ in several areas **LOCATION**. I did not inspect, test or determine if this growth is or is not a health hazard. The underlying cause is moisture or dampness. Recommend contacting a mold inspector or expert for investigation or correction as needed."},{"checked":false,"id":1,"is_red":false,"text":"The fire resistance sheathing that separates garage from heated space is compromised. This is considered unsafe until corrected. A qualified contractor should repair as needed"},{"checked":false,"id":1,"is_red":false,"text":"SAFETY CONCERN: Flammable materials should not be stored within closed garage areas."},{"checked":false,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Personal items in garage block complete inspection of all floor, wall and ceiling areas."},{"checked":false,"id":1,"is_red":false,"text":"Fire wall between garage & house not continuous.  "},{"checked":false,"id":1,"is_red":false,"text":"Pet Door Installed; this may compromise security or firewalls."},{"checked":false,"id":1,"is_red":false,"text":"Personal items prevent complete inspection."}],"sepChoice":"4","title":"Walls"},{"descr":"","id":2132,"options":[{"checked":false,"id":1,"is_red":false,"text":"The anchor bolte were inspected and appear to be serviceable."},{"checked":false,"id":1,"is_red":false,"text":"The anchor bolts were not visible."},{"checked":false,"id":1,"is_red":false,"text":"The anchor bolts were not visible, obscured by drywall."},{"checked":false,"id":1,"is_red":false,"text":"The anchor bolts were not visible obscured by insulation."},{"checked":false,"id":1,"is_red":false,"text":"Anchor straps noted."},{"checked":false,"id":1,"is_red":false,"text":"Some of the anchor bolts were missing nuts. We recommend replacing the missing nuts and tighten."},{"checked":false,"id":1,"is_red":false,"text":"There are what appears to be retro fitted anchor bolts noted."},{"checked":false,"id":1,"is_red":false,"text":"We recommend retrofit style anchor bolts where necessary."},{"checked":false,"id":1,"is_red":false,"text":"The builder used masonry or \"cut\" nails to attach the bottom plates to the foundation wall. We recommend adding retrofit style anchor bolts as necessary."}],"sepChoice":"4","title":"Anchor Bolts"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Walls Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Anchor Bolts Overall"}],"title":"Walls/Firewall"},{"damage_panels":[{"descr":"","id":2243,"options":[{"checked":false,"id":1,"is_red":false,"text":"Floor is not level. Suggest further evaluation by a licensed contractor within the inspection contingency period."},{"checked":false,"id":1,"is_red":false,"text":"Laminate floating floor system was installed with poor workmanship techniques, gaps, under size cuts, and chips are visible giving a less than appealing appearance and likely lowering the serviceable life of the flooring."},{"checked":false,"id":1,"is_red":false,"text":"It appears the existing carpeting was installed over the concrete slab without a moisture barrier;this is not a good installation method. The moisture content in the concrete can create the growth of organic materials \"Mold\" in the carpet. Recommend contacting a qualified contractor for further evaluation."},{"checked":false,"id":1,"is_red":false,"text":"Only the sub flooring is present and it is inconsistent in installation."},{"checked":false,"id":1,"is_red":false,"text":"Damaged grout observed, suggest regrouting as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Common cracks noted."},{"checked":false,"id":1,"is_red":false,"text":"Cracked tiles noted."},{"checked":false,"id":1,"is_red":false,"text":"Cracking noted in ceramic tiles.  This is an indication of inadequate subfloor installation."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of repairs observed, unable to determine the effectiveness of these repairs."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the floor is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"Minor damage noted."},{"checked":false,"id":1,"is_red":false,"text":"Numerous cracked tiles noted."},{"checked":false,"id":1,"is_red":false,"text":"Open seams observed."},{"checked":false,"id":1,"is_red":false,"text":"Popping floor tile observed."},{"checked":false,"id":1,"is_red":false,"text":"Possible trip hazard. This is a safety concern. Suggest repair/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified professional for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Recommend sealing cracks/voids."},{"checked":false,"id":1,"is_red":false,"text":"Tile has been painted/refinished, suggest taking care when cleaning to protect the surface."},{"checked":false,"id":1,"is_red":false,"text":"Water damage observed."}],"sepChoice":"4","title":"Floor Condition"}],"inspection_panels":[{"descr":"","id":3081,"options":[{"checked":false,"id":1,"is_red":false,"text":"Carpet is noted."},{"checked":false,"id":1,"is_red":false,"text":"Ceramic tile is noted."},{"checked":false,"id":1,"is_red":false,"text":"Sheet vinyl flooring is noted."},{"checked":false,"id":1,"is_red":false,"text":"Hardwood flooring is noted."},{"checked":false,"id":1,"is_red":false,"text":"Floating laminate type flooring noted."},{"checked":false,"id":1,"is_red":false,"text":"Marble floors noted."},{"checked":false,"id":1,"is_red":false,"text":"Natural stone floors noted."},{"checked":false,"id":1,"is_red":false,"text":"Bare concrete floors noted."},{"checked":false,"id":1,"is_red":false,"text":"Plywood subfloor is exposed."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl squares (tiles) are noted."}],"sepChoice":"1","title":"Floors"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Floor Condition Overall"}],"title":"Floors"},{"damage_panels":[{"descr":"","id":2129,"options":[{"checked":false,"id":1,"is_red":false,"text":"Dimensional lumber wood ceiling joists."},{"checked":false,"id":1,"is_red":false,"text":"Engineered wood roof truss framing noted."},{"checked":false,"id":1,"is_red":false,"text":"1x solid plank sheathing noted."},{"checked":false,"id":1,"is_red":false,"text":"Plywood Sheathing noted."},{"checked":false,"id":1,"is_red":false,"text":"Rafter construction noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood Joists noted."},{"checked":false,"id":1,"is_red":false,"text":"Pull down ladder is not fire rated."},{"checked":false,"id":1,"is_red":false,"text":"Garage drywall ceiling needs to be properly repaired."},{"checked":false,"id":1,"is_red":false,"text":"Hole in the ceiling is a breech in the fire protection."},{"checked":false,"id":1,"is_red":false,"text":"Not visible due to insulation."},{"checked":false,"id":1,"is_red":false,"text":"Limited review due to finished ceilings."},{"checked":false,"id":1,"is_red":false,"text":"Limited view of ceiling framing due to insulation."},{"checked":false,"id":1,"is_red":false,"text":"Visible areas appear satisfactory, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Staining was observed at the roof sheathing located in the attic. This is typically from the ventilation or insulation systems. The staining may contain mold & can be expensive to remove. Recommend contacting a remediation specialist and review the insulation & ventilation systems and repair as advised."},{"checked":false,"id":1,"is_red":false,"text":"The house roof structure was not visible to determine type or condition. (See limitations)"},{"checked":false,"id":1,"is_red":false,"text":"No deficiencies observed at the visible portions of the roof structure."},{"checked":false,"id":1,"is_red":false,"text":"Trusses are improperly cut."},{"checked":false,"id":1,"is_red":false,"text":"Recommend a qualified structural engineer review."},{"checked":false,"id":1,"is_red":false,"text":"Rafters are improperly cut."},{"checked":false,"id":1,"is_red":false,"text":"Cracked rafters."},{"checked":false,"id":1,"is_red":false,"text":"Limited review due to insulation and finishing materials."},{"checked":false,"id":1,"is_red":false,"text":"The roof structure has been improperly installed at the attached area of the garage. Have a general contractor review for repair, replacement or removal."},{"checked":false,"id":1,"is_red":false,"text":"There were no major deficiencies of the roof structure at the time of inspection. "},{"checked":false,"id":1,"is_red":false,"text":"Improper materials are being used as flooring to store items in the attic. This is a safety concern as someone can be injured as the material may not support the weight. Recommend removal of the material."}],"sepChoice":"4","title":"Rafters & Ceiling"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Rafters & Ceiling Overall"}],"title":"Rafters/Ceiling"},{"damage_panels":[{"descr":"","id":2118,"options":[{"checked":false,"id":1,"is_red":false,"text":"Some outlets not accessible due to furniture and or stored personal items."},{"checked":false,"id":1,"is_red":false,"text":"It is HIGHLY recommended to(have a qualified electrician) install an Arc Fault Circuit Interrupter breaker in place of the the one currently protecting the bedroom circuits,in the near future it will be a requirement and is a very safe and sound update."},{"checked":false,"id":1,"is_red":false,"text":"Bedroom circuits are NOT protected by an arc fault circuit interrupter type breaker. An arc fault interrupter will shut itself off if it detects a short, thus preventing an electrical fire."},{"checked":false,"id":1,"is_red":false,"text":"No Arc-Fault Circuit Interrupter (AFCI) protection was installed to protect electrical circuits in bedrooms.\n Building codes with which new homes must comply require the installation of AFCI protection of all bedroom outlets. This type of protection is designed to detect electrical arcing, which is a potential fire hazard. \nAlthough AFCI protection was not required at the time the home was originally constructed, as general knowledge of safe building practices has improved with the passage of time, building standards have changed to reflect current understanding. Consider updating the existing electrical to provide AFCI protection.\nArc-fault protection can be provided using either of two methods:\n1. Arc Fault Circuit Interrupters (AFCI's) electrical outlets which have this capability built in. \n2. AFCI circuit breakers installed at the main electrical panel which provide this protection to all non-AFCI outlets on the circuit controlled by that AFCI breaker.\n\n"},{"checked":false,"id":1,"is_red":false,"text":"Test AFCI breakers periodically to ensure proper operation."},{"checked":false,"id":1,"is_red":false,"text":"2-prong outlets -\nThe home contained outdated, ungrounded 2-prong electrical outlets. Although this condition may have been commonly considered safe or acceptable at the time the home was originally constructed, as general knowledge of safe building practices has improved with the passage of time, building standards have changed to reflect current understanding. Consider updating the existing condition to meet generally-accepted current standards.\n"},{"checked":false,"id":1,"is_red":false,"text":"Some loose and improperly installed receptacles were found, they should be installed correctly by a licensed electrician. Several are wired in reverse, one is poorly grounding."},{"checked":false,"id":1,"is_red":false,"text":"Some receptacles were painted over."},{"checked":false,"id":1,"is_red":false,"text":"It is recommended to avoid use of multiplier outlet plug ins ( converts 2 into 6 outlets ) "},{"checked":false,"id":1,"is_red":false,"text":"Missing outlet covers - throughout home.  See pictures."},{"checked":false,"id":1,"is_red":false,"text":"Several outlets were found to have been reverse polarity wired, see pics for locations. Have an electrician evaluate and repair."},{"checked":false,"id":1,"is_red":false,"text":"Most receptacles , except where noted, are in fair condition and tested ok, some are painted over."},{"checked":false,"id":1,"is_red":false,"text":"Have a qualified electrician repair items listed following a complete evaluation of the electrical system."},{"checked":false,"id":1,"is_red":false,"text":"The majority of grounded receptacles , were tested and found to be wired correctly."},{"checked":false,"id":1,"is_red":false,"text":"Loose receptacle outlet to left of entrance door."},{"checked":false,"id":1,"is_red":false,"text":"missing switch plate covers were found, make sure they are replaced."},{"checked":false,"id":1,"is_red":false,"text":"Worn switches noted."},{"checked":false,"id":1,"is_red":false,"text":"Worn outlets noted."},{"checked":false,"id":1,"is_red":false,"text":"Outlet cover plates missing."},{"checked":false,"id":1,"is_red":false,"text":"Switch cover plates missing."},{"checked":false,"id":1,"is_red":false,"text":"Loose outlets noted."},{"checked":false,"id":1,"is_red":false,"text":"Loose switches noted."},{"checked":false,"id":1,"is_red":false,"text":"All original knob and tube wiring appears to have been removed."},{"checked":false,"id":1,"is_red":false,"text":"A low voltage alarm system and a low voltage intercom system are installed. Due to the specialized nature of these systems, we suggest that you review these systems with the seller. As per our Inspection Agreement, these systems are beyond the scope of this report and were not inspected."},{"checked":false,"id":1,"is_red":false,"text":"A low voltage alarm system is installed. Due to the specialized nature of these systems, we suggest that you review this system with the seller. As per our Inspection Agreement, this system is beyond the scope of this report and was not inspected."},{"checked":false,"id":1,"is_red":false,"text":"A low voltage intercom system is installed. Due to the specialized nature of these systems, we suggest that you review this system with the seller. As per our Inspection Agreement, this system is beyond the scope of this report and was not inspected."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum wiring is now a concern with insurance companies due to fire risk.  Buyer is urged to confirm insurability and any related conditions that insurance company may place on this house.  Further inspection of this system may be required.  The inspector CANNOT ensure compliance of this electrical system for insurance purposes."},{"checked":false,"id":1,"is_red":false,"text":"Dimming lights were observed, this may be an indication of inadequate electrical distribution. We recommend review by a licensed electrician for evaluation and redistribution as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Improper use of extension cord observed. Extension cords should not be permanently installed or be routed through walls, floors or partitions."},{"checked":false,"id":1,"is_red":false,"text":"Insulation has been installed over knob and tube wiring at various locations. This is a fire \"Safety Concern\". Suggest review by a licensed electrician prior to closing to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Knob and tube wiring was observed in this home. This type of wiring was standard at the time of construction, and unless otherwise noted, appears to be in serviceable condition."},{"checked":false,"id":1,"is_red":false,"text":"Missing cover plates observed, suggest installing for safety."},{"checked":false,"id":1,"is_red":false,"text":"Open junction boxes were observed, which is a safety concern. Recommend installing proper covers, as needed, for safety."},{"checked":false,"id":1,"is_red":false,"text":"Recommend full review by qualified electrical contractor for quotes on upgrades/repair to ensure safe and adequate service."},{"checked":false,"id":1,"is_red":false,"text":"Reversed polarity, hot and neutral reversed and other terms used for electric receptacles are usually easily corrected by minor wiring adjustments at the specified item. When these conditions are noted in this report, a licensed electrician should be consulted for repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Since ungrounded receptacles were noted in the home, buyer is cautioned that proper grounding is strongly urged where sensitive electronic equipment is used.  Ungrounded receptacles do not offer protection for computers etc.  Consultation with a qualified electrical contractor is recommended."},{"checked":false,"id":1,"is_red":false,"text":"Ungrounded receptacles observed at water sources or exterior locations ideally should be grounded, suggest installing GFCI's for safety."}],"sepChoice":"4","title":"Electrical"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Electrical Overall"}],"title":"Electrical"},{"damage_panels":[{"descr":"","id":2119,"options":[{"checked":false,"id":1,"is_red":false,"text":"GFCI did not respond to test, suggest replacing for safety."},{"checked":false,"id":1,"is_red":false,"text":"GFCI had power when tripped.  This is often the result of miswiring and is usually easily fixed.  Advise repair on replacement as needed."},{"checked":false,"id":1,"is_red":false,"text":"GFCI in place and operational"},{"checked":false,"id":1,"is_red":false,"text":"GFCI in this bathroom resets other bathroom receptacles"},{"checked":false,"id":1,"is_red":false,"text":"GFCI protected receptacles may not have been required when the house was built. We suggest buyer consider upgrading with GFCI's at all receptacles near water sources."},{"checked":false,"id":1,"is_red":false,"text":"No GFCI protection present, suggest installing GFCI protected receptacles for safety."},{"checked":false,"id":1,"is_red":false,"text":"GFCI, lights & fans on same circuit"},{"checked":false,"id":1,"is_red":false,"text":"Reset forthe GFCI is in the main panel."},{"checked":false,"id":1,"is_red":false,"text":"Reset for the GFCI is in the garage."},{"checked":false,"id":1,"is_red":false,"text":"Reset for the GFCI is in in the master bath."},{"checked":false,"id":1,"is_red":false,"text":"Reset for the GFCI is in the 1/2 bathroom."},{"checked":false,"id":1,"is_red":false,"text":"GFCI tested and functioned properly"},{"checked":false,"id":1,"is_red":false,"text":"Recommend upgrading All receptacle to GFCI protection within 6 feet of all potential wet locations."},{"checked":false,"id":1,"is_red":false,"text":"GFCI tested and found to be improperly wired. Recommend review and repair by Qualified Electrician. "},{"checked":false,"id":1,"is_red":false,"text":"GFCI reset at breaker panel <FYI>"},{"checked":false,"id":1,"is_red":false,"text":"GFCI protected receptacles may not have been required when the house was built. We suggest buyer consider upgrading with GFCI's at all receptacles near water sources."},{"checked":false,"id":1,"is_red":false,"text":"Recommend full review by qualified electrical contractor for quotes on upgrades/repair to ensure safe and adequate service."},{"checked":false,"id":1,"is_red":false,"text":"Ungrounded receptacles observed at water sources or exterior locations ideally should be grounded, suggest installing GFCI's for safety."}],"sepChoice":"4","title":"GFCI"},{"descr":"","id":2120,"options":[{"checked":false,"id":1,"is_red":false,"text":"There are no 240 volt outlets visible in this room."},{"checked":false,"id":1,"is_red":false,"text":"The 240 volt outlets tested functional."},{"checked":false,"id":1,"is_red":false,"text":"There was no power present."},{"checked":false,"id":1,"is_red":false,"text":"The inspector could not access the 240 volt outlet due to stored personal items in the way."},{"checked":false,"id":1,"is_red":false,"text":"The outlet is missing it's cover plate, causing a shock hazard."},{"checked":false,"id":1,"is_red":false,"text":"The 240 volt outlet is loose at the wall. We suggest calling a licensed electrician to evaluate and correct the problem."},{"checked":false,"id":1,"is_red":false,"text":"Un-secured cable feeds the 240 volt outlet. Recommend securing the wire out of harms way."},{"checked":false,"id":1,"is_red":false,"text":"Exposed wires are noted."},{"checked":false,"id":1,"is_red":false,"text":"Irregular installation of the outlet noted."}],"sepChoice":"4","title":"240 Volt"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"GFCI Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"240 Volt Overall"}],"title":"Electrical 2"},{"damage_panels":[{"descr":"","id":2127,"options":[{"checked":false,"id":1,"is_red":false,"text":"Garage-house door does not close automatically.  This is to act as a fire stop, and keeps exhaust fumes out.    "},{"checked":false,"id":1,"is_red":false,"text":"Garage-house entry steps are non-standard in height &/or depth."},{"checked":false,"id":1,"is_red":false,"text":"Garage-house door may not be properly fire-rated.    "},{"checked":false,"id":1,"is_red":false,"text":"Garage-house door weatherstrip: apparent pet damage."},{"checked":false,"id":1,"is_red":false,"text":"Garage-house door weatherstrip is deteriorated.  "},{"checked":false,"id":1,"is_red":false,"text":"There is a pet door present in the garage exterior door."},{"checked":false,"id":1,"is_red":false,"text":"Appeared functional, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Window in the door is stuck in position."},{"checked":false,"id":1,"is_red":false,"text":"Doorknob/lockset is missing."},{"checked":false,"id":1,"is_red":false,"text":"Doorknob is missing."},{"checked":false,"id":1,"is_red":false,"text":"Door sticks, does not close, needs adjustment."},{"checked":false,"id":1,"is_red":false,"text":"Door sticks, needs adjustment."},{"checked":false,"id":1,"is_red":false,"text":"Hardware is loose or misaligned."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the door is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"Sliding door screen is missing/damaged"},{"checked":false,"id":1,"is_red":false,"text":"Sliding glass door is installed backwards/inside out."},{"checked":false,"id":1,"is_red":false,"text":"Damaged door stops"},{"checked":false,"id":1,"is_red":false,"text":"Tempered glass required"}],"sepChoice":"4","title":"Exterior Door"},{"descr":"","id":2128,"options":[{"checked":false,"id":1,"is_red":false,"text":"The door between the garage & house is not a fire rated door. @@@This may not have been required when originally built.  Fire doors are fundamental to the integrity of fire barriers which provide resistance to the spread of fire, smoke, and toxic gasses.  This means that should a fire occur in the garage, this door does not afford protection until fire-rescue people arrive. This door should be replaced with a fire rated door."},{"checked":false,"id":1,"is_red":false,"text":"There is no self-closing device on the door from the house leading to the garage. It is strongly recommended that one be installed in order to protect the residence against garage originated fires."},{"checked":false,"id":1,"is_red":false,"text":"The automatic closure device does not close the door properly. This could allow a fire to enter the home. Recommend adjusting or replacing the hinges to allow for proper closure of the door."},{"checked":false,"id":1,"is_red":false,"text":"The door knob does not operate properly at the garage entry door. Recommend repair or replacement."},{"checked":false,"id":1,"is_red":false,"text":"Does Not Appear to be a Rated Fire Door"},{"checked":false,"id":1,"is_red":false,"text":"No auto closure present"},{"checked":false,"id":1,"is_red":false,"text":"Auto closure needs adjusting"},{"checked":false,"id":1,"is_red":false,"text":"The door is not a fire rated."},{"checked":false,"id":1,"is_red":false,"text":"Appeared satisfactory and functional, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Operated When Tested"},{"checked":false,"id":1,"is_red":false,"text":"worn hardware"},{"checked":false,"id":1,"is_red":false,"text":"Garage-house door does not close automatically.  This is to act as a fire stop, and keeps exhaust fumes out.    "},{"checked":false,"id":1,"is_red":false,"text":"Garage-house entry steps are non-standard in height &/or depth."},{"checked":false,"id":1,"is_red":false,"text":"Garage-house door may not be properly fire-rated.    "},{"checked":false,"id":1,"is_red":false,"text":"Garage-house door weatherstrip: apparent pet damage."},{"checked":false,"id":1,"is_red":false,"text":"Garage-house door weatherstrip is deteriorated.  "}],"sepChoice":"4","title":"Fire Door"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Exterior Door Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Fire Door Overall"}],"title":"Other Doors"},{"damage_panels":[{"descr":"","id":2122,"options":[{"checked":false,"id":1,"is_red":false,"text":"No deficiencies observed."},{"checked":false,"id":1,"is_red":false,"text":"Rotted wood at overhead door. Recommend repairing damaged areas."},{"checked":false,"id":1,"is_red":false,"text":"Door bottom weatherstripping is missing or damaged. Recommend repair or replacement."},{"checked":false,"id":1,"is_red":false,"text":"Maintenance repairs needed."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Consider future replacement with new steel triple-layer insulated type doors."},{"checked":false,"id":1,"is_red":false,"text":"DEFFERED COST: Upgrade to newer metal insulated door. "},{"checked":false,"id":1,"is_red":false,"text":"Garage vehicle door hardware damaged or missing.  "},{"checked":false,"id":1,"is_red":false,"text":"Garage Vehicle door weatherstripping is damaged.   "},{"checked":false,"id":1,"is_red":false,"text":"Garage vehicle door panels damaged.  "},{"checked":false,"id":1,"is_red":false,"text":"weathered"},{"checked":false,"id":1,"is_red":false,"text":"cracked"},{"checked":false,"id":1,"is_red":false,"text":"missing handle"},{"checked":false,"id":1,"is_red":false,"text":"loose tension bars"},{"checked":false,"id":1,"is_red":false,"text":"door rubs jamb"},{"checked":false,"id":1,"is_red":false,"text":"dented"},{"checked":false,"id":1,"is_red":false,"text":"bent"},{"checked":false,"id":1,"is_red":false,"text":"holes"},{"checked":false,"id":1,"is_red":false,"text":"deteriorated"},{"checked":false,"id":1,"is_red":false,"text":"deteriorated jamb"},{"checked":false,"id":1,"is_red":false,"text":"Door did not close completely."},{"checked":false,"id":1,"is_red":false,"text":"warped wood"},{"checked":false,"id":1,"is_red":false,"text":"loose panels"},{"checked":false,"id":1,"is_red":false,"text":"missing hardware"},{"checked":false,"id":1,"is_red":false,"text":"tension bars missing"},{"checked":false,"id":1,"is_red":false,"text":"Difficult to operate."},{"checked":false,"id":1,"is_red":false,"text":"irregular installation"},{"checked":false,"id":1,"is_red":false,"text":"Tension out of adjustment - large door."},{"checked":false,"id":1,"is_red":false,"text":"rollers off tracks"},{"checked":false,"id":1,"is_red":false,"text":"Missing rollers on the door."},{"checked":false,"id":1,"is_red":false,"text":"Door did not stay open."}],"sepChoice":"4","title":"Garage Door Condition"}],"inspection_panels":[{"descr":"","id":3038,"options":[{"checked":false,"id":1,"is_red":false,"text":"Two - single 7', wood panel, sectional roll-up doors. Original equipment"},{"checked":false,"id":1,"is_red":false,"text":"Two - single 7', upgraded insulated steel panel, sectional roll-up doors."},{"checked":false,"id":1,"is_red":false,"text":"Two - single 7', steel panel, sectional roll-up doors."},{"checked":false,"id":1,"is_red":false,"text":"One 7' upgraded insulated steel door"},{"checked":false,"id":1,"is_red":false,"text":"One 7' Newer steel door"},{"checked":false,"id":1,"is_red":false,"text":"One 16' upgraded insulated steel door"},{"checked":false,"id":1,"is_red":false,"text":"Roll-up door noted."},{"checked":false,"id":1,"is_red":false,"text":"Vertical door noted."},{"checked":false,"id":1,"is_red":false,"text":"Slider door noted."},{"checked":false,"id":1,"is_red":false,"text":"Hinged door noted."},{"checked":false,"id":1,"is_red":false,"text":"Sectional door noted."}],"sepChoice":"1","title":"Garage Door Type"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Garage Door Condition Overall"}],"title":"Garage Door"},{"damage_panels":[{"descr":"","id":2123,"options":[{"checked":false,"id":1,"is_red":false,"text":"The garage door appeared functional during the inspection."},{"checked":false,"id":1,"is_red":false,"text":"The hinges appear to be worn on the door. We recommend that a professional be called in tho evaluate and repair."},{"checked":false,"id":1,"is_red":false,"text":"One of the coil springs is broken on the garage door. These springs are sized for the weight of the door so a professional should replace them."},{"checked":false,"id":1,"is_red":false,"text":"There is a broken torsion spring on the top of the door rendering the door inoperable. We recommend that a qualified contractor be called to perform the repair."},{"checked":false,"id":1,"is_red":false,"text":"The door is noisy and squeaks when moved. We recommend lubrication on the rollers and tracks."},{"checked":false,"id":1,"is_red":false,"text":"The door does not elevate straight. We recommend adjustment of the doors spring tension to correct this."},{"checked":false,"id":1,"is_red":false,"text":"The door does not stay open. We recommend adjustment of the doors spring tension to correct this."},{"checked":false,"id":1,"is_red":false,"text":"The door opens on its own. We recommend adjustment of the doors spring tension to correct this."},{"checked":false,"id":1,"is_red":false,"text":"The garage door is missing some of its hardware. We recommend contacting a qualified contractor to repair the door."},{"checked":false,"id":1,"is_red":false,"text":"The garage door is missing some of its rollers. We recommend contacting a qualified contractor to repair the door."},{"checked":false,"id":1,"is_red":false,"text":"The garage door has some loose hardware. We recommend contacting a qualified contractor to repair the door."}],"sepChoice":"4","title":"Garage Door Parts"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Garage Door Parts Overall"}],"title":"Garage Door Parts"},{"damage_panels":[{"descr":"","id":2124,"options":[{"checked":false,"id":1,"is_red":false,"text":"Chain drive opener noted."},{"checked":false,"id":1,"is_red":false,"text":"Screw drive opener noted."},{"checked":false,"id":1,"is_red":false,"text":"Belt drive opener noted."},{"checked":false,"id":1,"is_red":false,"text":"Garage vehicle door auto-reverse is inoperable."},{"checked":false,"id":1,"is_red":false,"text":"Photo safety reverse feature works but pressure reverse is not a feature on the 1 car garage door opener. "},{"checked":false,"id":1,"is_red":false,"text":"3 car garage door openers not inspected due to personal belongings limiting access to one or more doors."},{"checked":false,"id":1,"is_red":false,"text":"There appears to be an older model garage door opener without safety features."},{"checked":false,"id":1,"is_red":false,"text":"The garage door opener is functional, safety features are built in. "},{"checked":false,"id":1,"is_red":false,"text":"Garage vehicle door opener appears to be disconnected, damaged or otherwise inoperable.  Have evaluated and repaired."},{"checked":false,"id":1,"is_red":false,"text":"Garage vehicle door sensors appear to be mounted higher than the standard auto-reverse height."},{"checked":false,"id":1,"is_red":false,"text":"The Garage door opener operates with an extension cord as permanent wiring. This is not considered as \"to code\" and should be corrected. We recommend contacting a licensed electrical contractor to install a proper outlet near the opener."},{"checked":false,"id":1,"is_red":false,"text":"Photo safety reverse feature works but pressure reverse is not a feature on the 1 car garage door opener. "},{"checked":false,"id":1,"is_red":false,"text":"3 car garage door openers not inspected due to personal belongings limiting access to one or more doors."},{"checked":false,"id":1,"is_red":false,"text":"There appears to be an older model garage door opener without safety features."},{"checked":false,"id":1,"is_red":false,"text":"The garage door opener is functional, safety features are built in. "},{"checked":false,"id":1,"is_red":false,"text":"Appeared  functional using normal controls, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"DEFERRED COST: The openers are older."},{"checked":false,"id":1,"is_red":false,"text":"The opener is missing cover for bulb/light."},{"checked":false,"id":1,"is_red":false,"text":"Damaged cover observed."},{"checked":false,"id":1,"is_red":false,"text":"Neither garage door opener connected to doors. Not tested."},{"checked":false,"id":1,"is_red":false,"text":"Improper wiring practice/See electrical section."},{"checked":false,"id":1,"is_red":false,"text":"Right hand GDO light missing. Repair as needed."}],"sepChoice":"4","title":"Garage Opener Status"},{"descr":"","id":2125,"options":[{"checked":false,"id":1,"is_red":false,"text":"Garage vehicle door auto-reverse is inoperable."},{"checked":false,"id":1,"is_red":false,"text":"Eye beam system present and operating."},{"checked":false,"id":1,"is_red":false,"text":"No eye beam system present. This appears to be an older unit when these safety features were not included with openers. We recommend upgrading to a newer model with all safety features included."},{"checked":false,"id":1,"is_red":false,"text":" The door requires a great deal of resistance to trigger the auto-reverse mechanism. We recommend adjusting the opener for proper reverse tension."},{"checked":false,"id":1,"is_red":false,"text":"The opener did not operate properly. We recommend further evaluation by a qualified contractor."}],"sepChoice":"4","title":"Garage Door's Reverse Status"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Garage Opener Status Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Garage Door's Reverse Status Overall"}],"title":"Garage Opener"},{"damage_panels":[{"descr":"","id":2244,"options":[{"checked":false,"id":1,"is_red":false,"text":"Under eave soffit inlet vents noted. "},{"checked":false,"id":1,"is_red":false,"text":"Ridge exhaust venting noted."},{"checked":false,"id":1,"is_red":false,"text":"Thermostatically controlled Power Ventilator on roof field noted."},{"checked":false,"id":1,"is_red":false,"text":"Gable louver vents noted."},{"checked":false,"id":1,"is_red":false,"text":"No Visible Ventilation noted."},{"checked":false,"id":1,"is_red":false,"text":"Turbine Vents noted."},{"checked":false,"id":1,"is_red":false,"text":"Fixed, roof-field exhaust vent noted."},{"checked":false,"id":1,"is_red":false,"text":"Frost observed at underside of roof."},{"checked":false,"id":1,"is_red":false,"text":"No soffit vent baffles observed. Wind may displace insulation. Suggest  installing vent baffles "},{"checked":false,"id":1,"is_red":false,"text":"Recommend adding additional ventilation to avoid premature aging of roof and help to maintain proper humidity and temperature control."},{"checked":false,"id":1,"is_red":false,"text":"Recommend installing gable vents for improved ventilation."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Soffit vents are blocked with insulation."},{"checked":false,"id":1,"is_red":false,"text":"Thermostatically controlled fans are not operated."}],"sepChoice":"4","title":"Ventilation"},{"descr":"","id":2245,"options":[{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as functional."},{"checked":false,"id":1,"is_red":false,"text":"Suggest repair or replacing vent screens."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens are damaged or missing, suggest repairing or replacing screens as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as missing."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as torn."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as bent."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as blocked."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as restricted."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as loose."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as sealed off."}],"sepChoice":"4","title":"Vent Screens"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Ventilation Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Vent Screens Overall"}],"title":"Ventilation"},{"damage_panels":[{"descr":"","id":2116,"options":[{"checked":false,"id":1,"is_red":false,"text":"Most not accessible due to stored personal items."},{"checked":false,"id":1,"is_red":false,"text":"No deficiencies observed."},{"checked":false,"id":1,"is_red":false,"text":"Appeared functional and in satisfactory condition, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Recommend adding additional cabinet screws as drywall screws have been used."},{"checked":false,"id":1,"is_red":false,"text":"Loose at wall. Needs immediate attention. "},{"checked":false,"id":1,"is_red":false,"text":"Some cabinet doors need magnets or hardware to stay shut. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Some cabinet drawers  need  hardware repair/adjustment (to stay shut). Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Drawers are difficult to slide. It appears that if the guides are lubricated, that will correct the problem."},{"checked":false,"id":1,"is_red":false,"text":"Broken drawer guides noted. Recommend having a qualified contractor replace the guides."},{"checked":false,"id":1,"is_red":false,"text":"Noted cabinet(s) loose on the wall. Recommend having a qualified contractor re-fasten the cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Noted cabinet(s) loose at the floor. Recommend having a qualified contractor re-fasten the cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Noted cabinet(s) loose at the ceiling. Recommend having a qualified contractor re-fasten the cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Doors did not close completely."},{"checked":false,"id":1,"is_red":false,"text":"The door was locked to bathroom, could not access the room to inspect."},{"checked":false,"id":1,"is_red":false,"text":"The sliding cabinet doors were difficult to slide. It appears that lubrication will correct the problem."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors missing, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors missing hardware, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawers missing, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors have broken hinges, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawers missing handles, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawers off their guides, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors have loose hardware, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors missing knobs, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawer face is missing, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawer face is loose, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors have broken glass panels in them, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Drawer(s) bind in tracks"},{"checked":false,"id":1,"is_red":false,"text":"Drawer(s) unsupported in cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Shelving missing or damaged."}],"sepChoice":"4","title":"Cabinets"},{"descr":"","id":2117,"options":[{"checked":false,"id":1,"is_red":false,"text":"No discrepancies noted."},{"checked":false,"id":1,"is_red":false,"text":"Plastic laminate tops noted."},{"checked":false,"id":1,"is_red":false,"text":"Solid Surface tops noted."},{"checked":false,"id":1,"is_red":false,"text":"Granite tops noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood counter tops noted."},{"checked":false,"id":1,"is_red":false,"text":"There is normal wear noted for the age of the counter tops."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops are stained. Normal cleaning should take care of this."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops appear to be worn and may have reached the end of their useful life."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops are noted as being chipped."},{"checked":false,"id":1,"is_red":false,"text":"Some of the areas not visible due to stored personal items."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops appear to be loose on the cabinet. We recommend having a qualified contractor re-fasten them."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops are noted as having loose Formica. We recommend having a qualified contractor re-fasten it."},{"checked":false,"id":1,"is_red":false,"text":"Granite backsplash appears to not have been caulked when installed--except just behind sink.  Recommend sealing with clear silicone caulk along entire length of backsplash.  This prevents water leaks from spills and counter cleanups."},{"checked":false,"id":1,"is_red":false,"text":"Laminated countertop is swollen and beginning to blister @@lLOCATION@@. This is a cosmetic issue for your information. Repair as necessary."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops are noted as cracked or damaged."}],"sepChoice":"4","title":"Counters"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Cabinets Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Counters Overall"}],"title":"Cabinets & Counters"},{"damage_panels":[{"descr":"","id":2246,"options":[{"checked":false,"id":1,"is_red":false,"text":"DRAINS:"},{"checked":false,"id":1,"is_red":false,"text":"Drain line leaks under sink. "},{"checked":false,"id":1,"is_red":false,"text":"Stains from presumed past leaks noted."},{"checked":false,"id":1,"is_red":false,"text":"Note that without water the sink(s) and dishwasher could not be evaluated."},{"checked":false,"id":1,"is_red":false,"text":"Slow drain at sink.  Recommend clearing. "},{"checked":false,"id":1,"is_red":false,"text":"Slow drain at sink with gurgling which may indicate that the drain line needs to be cleaned and/or that the drain is not properly vented. "},{"checked":false,"id":1,"is_red":false,"text":"Stains at sink cabinet floor, presumably from past leak(s) or spilled products."},{"checked":false,"id":1,"is_red":false,"text":"SUPPLY:"},{"checked":false,"id":1,"is_red":false,"text":"Faucet leaks at base. "},{"checked":false,"id":1,"is_red":false,"text":"The hot & cold  water supplies are reversed. This is not a functional problem but to someone who is not familiar with this condition unexpected hot water could scald them. We suggest contacting a qualified plumbing contractor to repair."},{"checked":false,"id":1,"is_red":false,"text":"Faucet drips. "},{"checked":false,"id":1,"is_red":false,"text":"Faucet leaks at base."},{"checked":false,"id":1,"is_red":false,"text":"Supply line leaks. "},{"checked":false,"id":1,"is_red":false,"text":"No shutoff \"stop\" apparent. "},{"checked":false,"id":1,"is_red":false,"text":"Poor pressure flow when running several fixtures in one area."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the sink is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Sink appears to have been refinished, suggest taking care when cleaning to protect the surface."},{"checked":false,"id":1,"is_red":false,"text":"Sink is leaking at the time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Sink is loose, suggest securing as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Stopper is missing/inoperable."},{"checked":false,"id":1,"is_red":false,"text":"Suggest caulking as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Sink chipped (Cosmetic; does not affect function). "},{"checked":false,"id":1,"is_red":false,"text":"Sink rusted.  Monitor for developing leaks (none found during inspection)."},{"checked":false,"id":1,"is_red":false,"text":"Sink is poorly anchored."},{"checked":false,"id":1,"is_red":false,"text":"The piping to the sink was not installed properly."}],"sepChoice":"4","title":"Wash Basin"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Wash Basin Overall"}],"title":"Wash Basin"}],"title":"Garage"},{"id":4,"tabbed_panels":[{"damage_panels":[{"descr":"","id":2195,"options":[{"checked":false,"id":1,"is_red":false,"text":"The air pump did not operate properly."},{"checked":false,"id":1,"is_red":false,"text":"The air pump has a rusted housing and may be reaching the end of its useful life."},{"checked":false,"id":1,"is_red":false,"text":"The air pump has a damaged housing."},{"checked":false,"id":1,"is_red":false,"text":"The air pump has low air flow."},{"checked":false,"id":1,"is_red":false,"text":"The air pump has loose wiring."},{"checked":false,"id":1,"is_red":false,"text":"We recommend contacting a qualified pool service technician for evaluation/repair."}],"sepChoice":"4","title":"Air Booster Pump"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Air Booster Pump Overall"}],"title":"Air Pump"},{"damage_panels":[{"descr":"","id":2196,"options":[{"checked":false,"id":1,"is_red":false,"text":"Appears in satisfactory and functional condition with normal wear for its age.  Appears to be sound structure."},{"checked":false,"id":1,"is_red":false,"text":"MAINTENANCE: Whether treated or not, it is important to keep a wood deck surface free of all forms of fungal growth and debris that retains moisture and will cause the deck to eventually rot. Recommend cleaning and resealing the deck annually. Cleaning can be accomplished by scrubbing the deck with a sodium-hypochlorite (bleach) and Tri-Sodium-Phosphate (TSP) deck wash and then rinsing with a pressure washer. Finally, a wood deck should be recoated with a good-quality deck sealant.      "},{"checked":false,"id":1,"is_red":false,"text":"MAINTENANCE: Even decks of composite lumber need periodic maintenance to keep them free of algae and mold that can make the surface very slick. Recommend cleaning composite decks annually by scrubbing with a solution of: 1/3 cup laundry soap; 2/3 cup Tri-Sodium-Phosphate (TSP); one quart bleach; and 3 quarts of water. Rinse with a hose--Do Not Use a Pressure-Washer on composite lumber."},{"checked":false,"id":1,"is_red":false,"text":"Rotted Wood."},{"checked":false,"id":1,"is_red":false,"text":"Unstable supports."},{"checked":false,"id":1,"is_red":false,"text":"Reverse Grading."},{"checked":false,"id":1,"is_red":false,"text":"No flashing present."},{"checked":false,"id":1,"is_red":false,"text":"Floor boards damaged."},{"checked":false,"id":1,"is_red":false,"text":"Floor boards rotted."},{"checked":false,"id":1,"is_red":false,"text":"Improper fasteners."},{"checked":false,"id":1,"is_red":false,"text":"Lag bolts not present."},{"checked":false,"id":1,"is_red":false,"text":"Improper attachment of ledger board."},{"checked":false,"id":1,"is_red":false,"text":"Missing fasteners at joist hangers."},{"checked":false,"id":1,"is_red":false,"text":"Joist deck hangers are missing nails. Have all reviewed for adding additional nails."},{"checked":false,"id":1,"is_red":false,"text":"Have the deck reviewed for proper installation and attachment. Check for history of permits."},{"checked":false,"id":1,"is_red":false,"text":"Loose fasteners observed. Review all and secure as needed."},{"checked":false,"id":1,"is_red":false,"text":"Not visible underneath"},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Consider upgrading to new composite lumber decking material. "},{"checked":false,"id":1,"is_red":false,"text":"Deck ledger board lacking flashing. Flashing protects the ledger and keeps water away from the side of the house. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"The deck joists are set too far apart for the existing decking boards - as placed on a 45 degree angle to the joists. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Today's deck construction, support, and attachment standards typically call for proper footings, 6X6 posts, and 1/2 inch bolts securing deck to the beam and the house. Not all of these elements appear to be present. Consider upgrading deck to current standards."},{"checked":false,"id":1,"is_red":false,"text":"Appeared functional at time of inspection"},{"checked":false,"id":1,"is_red":false,"text":"Missing handrails and balusters."},{"checked":false,"id":1,"is_red":false,"text":"Balusters spaced to far apart."},{"checked":false,"id":1,"is_red":false,"text":"Wood – Soil Contact at step supports.  Even “treated” wood is better in contact only with cement."},{"checked":false,"id":1,"is_red":false,"text":"Non-conforming steps, possible safety hazard."},{"checked":false,"id":1,"is_red":false,"text":"Steps slanted, possible slip hazard."},{"checked":false,"id":1,"is_red":false,"text":"Rails missing at exterior steps, and should be installed for safety."},{"checked":false,"id":1,"is_red":false,"text":"Settlement crack at base of front steps.  Monitor and repair as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Steps are deteriorated and should be evaluated for repair or replacement."},{"checked":false,"id":1,"is_red":false,"text":"Broken / missing step(s)."},{"checked":false,"id":1,"is_red":false,"text":"Clean and Seal Deck:  Recommend cleaning deck and treating with a waterproof sealant claiming to waterproof, block ultraviolet light, and stop mildew."},{"checked":false,"id":1,"is_red":false,"text":"Some deck boards are damaged, and som others need resecuring."},{"checked":false,"id":1,"is_red":false,"text":"Decking board spacing less than 3/8\". Recommend cleaning deck frequently to avoid accumulation of organic debris causing trapped moisture and eventual rot."},{"checked":false,"id":1,"is_red":false,"text":"Deck Substructure Inspection excluded, due to limited access because of low height or obstructions."},{"checked":false,"id":1,"is_red":false,"text":"Deck installed without supporting bracket hardware.  Recommend installing brackets.  "},{"checked":false,"id":1,"is_red":false,"text":"No Lag Bolts Visible:  The deck ledger board is nailed or screwed to the house, or is covered and not visible. Consider installing lag screws to securely attach ledger board to house, if they have not been used.  "},{"checked":false,"id":1,"is_red":false,"text":"Elevation changes at deck and deck steps; recommend caution and some type of visual alert.  "},{"checked":false,"id":1,"is_red":false,"text":"Deck has two levels that visually blend, which may be a potential fall hazard.  Recommend bright colored tape or paint at edge of step for safety. "},{"checked":false,"id":1,"is_red":false,"text":"Deck physically shakes / sways when walking on it; recommend evaluation / repair by contractor."},{"checked":false,"id":1,"is_red":false,"text":"Flexing deck boards - some boards have \"bounce\" to them and may need re-securing under the carpeted area at deck"},{"checked":false,"id":1,"is_red":false,"text":"Gate at deck will not secure."},{"checked":false,"id":1,"is_red":false,"text":"Diving board is cracked."},{"checked":false,"id":1,"is_red":false,"text":"Loose diving board mount observed."},{"checked":false,"id":1,"is_red":false,"text":"Weathered wood deck."},{"checked":false,"id":1,"is_red":false,"text":"Diving board is weathered."}],"sepChoice":"4","title":"Deck Condition"}],"inspection_panels":[{"descr":"","id":3058,"options":[{"checked":false,"id":1,"is_red":false,"text":"n/a see grounds page for material type."}],"sepChoice":"1","title":"Pool Deck"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Deck Condition Overall"}],"title":"Deck"},{"damage_panels":[{"descr":"","id":2199,"options":[{"checked":false,"id":1,"is_red":false,"text":"Gate did not self latch."},{"checked":false,"id":1,"is_red":false,"text":"Weathered condition observed."},{"checked":false,"id":1,"is_red":false,"text":"Worn hardware."},{"checked":false,"id":1,"is_red":false,"text":"Gate is locked."},{"checked":false,"id":1,"is_red":false,"text":"Recommend 4 foot fence or better."}],"sepChoice":"4","title":"Gate & Fence Condition"}],"inspection_panels":[{"descr":"","id":3059,"options":[{"checked":false,"id":1,"is_red":false,"text":"Mesh type."},{"checked":false,"id":1,"is_red":false,"text":"See grounds page."}],"sepChoice":"1","title":"Gate & Fence"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Gate & Fence Condition Overall"}],"title":"Fencing"},{"damage_panels":[{"descr":"","id":2200,"options":[{"checked":false,"id":1,"is_red":false,"text":"Sand filter noted."},{"checked":false,"id":1,"is_red":false,"text":"Diatom. earth filter noted."},{"checked":false,"id":1,"is_red":false,"text":"Corrosion present."},{"checked":false,"id":1,"is_red":false,"text":"rust present"},{"checked":false,"id":1,"is_red":false,"text":"Shows signs of leakage."},{"checked":false,"id":1,"is_red":false,"text":"Did not operate n/a."},{"checked":false,"id":1,"is_red":false,"text":"Filter not level."},{"checked":false,"id":1,"is_red":false,"text":"Recommend pool contractor to evaluate."},{"checked":false,"id":1,"is_red":false,"text":"Pressure is high, recommend cleaning the filter."}],"sepChoice":"4","title":"Filter"},{"descr":"","id":2201,"options":[{"checked":false,"id":1,"is_red":false,"text":"None noted."},{"checked":false,"id":1,"is_red":false,"text":"Functional."},{"checked":false,"id":1,"is_red":false,"text":"Missing comer."},{"checked":false,"id":1,"is_red":false,"text":"Cracked cover noted."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of leaking."},{"checked":false,"id":1,"is_red":false,"text":"Bottom drain noted."},{"checked":false,"id":1,"is_red":false,"text":"Automatic pool vacuum \"Polaris\" outlet noted."}],"sepChoice":"4","title":"Skimmer and Basket"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Filter Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Skimmer and Basket Overall"}],"title":"Filter"},{"damage_panels":[{"descr":"","id":2202,"options":[{"checked":false,"id":1,"is_red":false,"text":"operated"},{"checked":false,"id":1,"is_red":false,"text":"did not operate"},{"checked":false,"id":1,"is_red":false,"text":"worn unit"},{"checked":false,"id":1,"is_red":false,"text":"rust present"},{"checked":false,"id":1,"is_red":false,"text":"missing"},{"checked":false,"id":1,"is_red":false,"text":"Flex line present, recommend ridged pipe."},{"checked":false,"id":1,"is_red":false,"text":"older unit"}],"sepChoice":"4","title":"Pool Heater Condition"}],"inspection_panels":[{"descr":"","id":3060,"options":[{"checked":false,"id":1,"is_red":false,"text":"Electric."},{"checked":false,"id":1,"is_red":false,"text":"Gas."}],"sepChoice":"1","title":"Pool Heater"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Pool Heater Condition Overall"}],"title":"Heater"},{"damage_panels":[{"descr":"","id":2203,"options":[{"checked":false,"id":1,"is_red":false,"text":"none"},{"checked":false,"id":1,"is_red":false,"text":"operated"},{"checked":false,"id":1,"is_red":false,"text":"did not operate"},{"checked":false,"id":1,"is_red":false,"text":"could not locate switch"},{"checked":false,"id":1,"is_red":false,"text":"recommend GFCI"},{"checked":false,"id":1,"is_red":false,"text":"loose at pool wall"}],"sepChoice":"4","title":"Lights"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Lights Overall"}],"title":"Lights"},{"damage_panels":[{"descr":"","id":2204,"options":[{"checked":false,"id":1,"is_red":false,"text":"none"},{"checked":false,"id":1,"is_red":false,"text":"Present on filter housing."},{"checked":false,"id":1,"is_red":false,"text":"did not operate"},{"checked":false,"id":1,"is_red":false,"text":"leaking"},{"checked":false,"id":1,"is_red":false,"text":"damaged"},{"checked":false,"id":1,"is_red":false,"text":"cracked lens"},{"checked":false,"id":1,"is_red":false,"text":"corroded"}],"sepChoice":"4","title":"Pressure Gauge"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Pressure Gauge Overall"}],"title":"Gauge"},{"damage_panels":[{"descr":"","id":2205,"options":[{"checked":false,"id":1,"is_red":false,"text":"operated"},{"checked":false,"id":1,"is_red":false,"text":"did not operate"},{"checked":false,"id":1,"is_red":false,"text":"worn pump"},{"checked":false,"id":1,"is_red":false,"text":"leaking pump"},{"checked":false,"id":1,"is_red":false,"text":"rusted"},{"checked":false,"id":1,"is_red":false,"text":"corrosion present"},{"checked":false,"id":1,"is_red":false,"text":"visible leaking"},{"checked":false,"id":1,"is_red":false,"text":"exposed wires"},{"checked":false,"id":1,"is_red":false,"text":"rubber hose patch present"},{"checked":false,"id":1,"is_red":false,"text":"recommend servicing"},{"checked":false,"id":1,"is_red":false,"text":"old pool sweep pump present"},{"checked":false,"id":1,"is_red":false,"text":"not tested"},{"checked":false,"id":1,"is_red":false,"text":"using c-clamp to hold lint basket on"}],"sepChoice":"4","title":"Pumps"},{"descr":"","id":2206,"options":[{"checked":false,"id":1,"is_red":false,"text":"none"},{"checked":false,"id":1,"is_red":false,"text":"operated"},{"checked":false,"id":1,"is_red":false,"text":"did not operate"},{"checked":false,"id":1,"is_red":false,"text":"consult owner n/a"},{"checked":false,"id":1,"is_red":false,"text":"low water flow"},{"checked":false,"id":1,"is_red":false,"text":"missing valves"}],"sepChoice":"4","title":"Jets"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Pumps Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Jets Overall"}],"title":"Pumps"},{"damage_panels":[{"descr":"","id":2207,"options":[{"checked":false,"id":1,"is_red":false,"text":"stained"},{"checked":false,"id":1,"is_red":false,"text":"chipping"},{"checked":false,"id":1,"is_red":false,"text":"rust present"},{"checked":false,"id":1,"is_red":false,"text":"surface cracking"},{"checked":false,"id":1,"is_red":false,"text":"missing drain screen"},{"checked":false,"id":1,"is_red":false,"text":"rough surface"},{"checked":false,"id":1,"is_red":false,"text":"Limited Inspection Only"},{"checked":false,"id":1,"is_red":false,"text":"painted surface"},{"checked":false,"id":1,"is_red":false,"text":"loose drain cover"}],"sepChoice":"4","title":"Structure Condition"}],"inspection_panels":[{"descr":"Type:","id":3061,"options":[{"checked":false,"id":1,"is_red":false,"text":"below ground"},{"checked":false,"id":1,"is_red":false,"text":"Above Ground"}],"sepChoice":"1","title":"Pool Type"},{"descr":"","id":3062,"options":[{"checked":false,"id":1,"is_red":false,"text":"gunite"},{"checked":false,"id":1,"is_red":false,"text":"plaster"},{"checked":false,"id":1,"is_red":false,"text":"fiberglass"},{"checked":false,"id":1,"is_red":false,"text":"Vinyl"}],"sepChoice":"1","title":"Material"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Structure Condition Overall"}],"title":"Structure"},{"damage_panels":[{"descr":"","id":2208,"options":[{"checked":false,"id":1,"is_red":false,"text":"stained"},{"checked":false,"id":1,"is_red":false,"text":"worn"},{"checked":false,"id":1,"is_red":false,"text":"cracked tiles"},{"checked":false,"id":1,"is_red":false,"text":"missing tiles"},{"checked":false,"id":1,"is_red":false,"text":"loose tiles"}],"sepChoice":"4","title":"Tile"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Tile Overall"}],"title":"Tiling"},{"damage_panels":[{"descr":"","id":2209,"options":[{"checked":false,"id":1,"is_red":false,"text":"present"},{"checked":false,"id":1,"is_red":false,"text":"missing inside plastic cover"},{"checked":false,"id":1,"is_red":false,"text":"loose box"},{"checked":false,"id":1,"is_red":false,"text":"rusted"},{"checked":false,"id":1,"is_red":false,"text":"unsecure conduit"},{"checked":false,"id":1,"is_red":false,"text":"timer door did not stay closed"}],"sepChoice":"4","title":"Timer"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Timer Overall"}],"title":"Timer"},{"damage_panels":[{"descr":"","id":2210,"options":[{"checked":false,"id":1,"is_red":false,"text":"clear"},{"checked":false,"id":1,"is_red":false,"text":"cloudy"},{"checked":false,"id":1,"is_red":false,"text":"empty"},{"checked":false,"id":1,"is_red":false,"text":"dirty"}],"sepChoice":"4","title":"Water Condition"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Water Condition Overall"}],"title":"Water"},{"damage_panels":[{"descr":"","id":2211,"options":[{"checked":false,"id":1,"is_red":false,"text":"none"},{"checked":false,"id":1,"is_red":false,"text":"operated"},{"checked":false,"id":1,"is_red":false,"text":"did not operate"},{"checked":false,"id":1,"is_red":false,"text":"leaking valve"},{"checked":false,"id":1,"is_red":false,"text":"missing handle"},{"checked":false,"id":1,"is_red":false,"text":"disconnected"},{"checked":false,"id":1,"is_red":false,"text":"worn valve"},{"checked":false,"id":1,"is_red":false,"text":"could not locate"}],"sepChoice":"4","title":"Water Fill Unit"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Water Fill Unit Overall"}],"title":"Water Fill Unit"},{"damage_panels":[{"descr":"","id":2252,"options":[{"checked":false,"id":1,"is_red":false,"text":"Some outlets were not accessible due to furniture and or stored personal items in the wat."},{"checked":false,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"GFCI trip test failed.  Have licensed electrician evaluate and repair / replace as necessary."},{"checked":false,"id":1,"is_red":false,"text":"GFCI protection is provided to all bathrooms.  If tripped reset in master bathroom."},{"checked":false,"id":1,"is_red":false,"text":"Switch damaged or apparently inoperable."},{"checked":false,"id":1,"is_red":false,"text":"Switch purpose unknown.  Check with seller. "},{"checked":false,"id":1,"is_red":false,"text":"Switch needs new cover."},{"checked":false,"id":1,"is_red":false,"text":"Outlet damaged."},{"checked":false,"id":1,"is_red":false,"text":"Outlet needs new cover."},{"checked":false,"id":1,"is_red":false,"text":"Outlet cover(s) missing."},{"checked":false,"id":1,"is_red":false,"text":"Outlet apparently inoperable."},{"checked":false,"id":1,"is_red":false,"text":"Open ground (or 2-wire) outlets present.  This means that the 3rd (round) part of an appliance plug is not getting ground protection.  This may be a concern with items such as computers and electronic devices."},{"checked":false,"id":1,"is_red":false,"text":"Hot-neutral reversed outlets present.  This means that the black and white wires in the circuit have been reversed, and may be a concern with items such as computers and electronic devices."},{"checked":false,"id":1,"is_red":false,"text":"Open neutral outlet.  This means the receptacle is not working properly because, even though the black wire is hot, the white (neutral) wire is not connected well somewhere, so that it cannot carry any current \"back\" to the main panel. "},{"checked":false,"id":1,"is_red":false,"text":"Connections made outside of a Junction Box.  This is a potential shock or electrocution hazard."},{"checked":false,"id":1,"is_red":false,"text":"Wire ends are outside of a Junction Box at.  This is a potential shock or electrocution hazard."},{"checked":false,"id":1,"is_red":false,"text":"Junction Box Cover(s) missing.  This is a potential shock or electrocution hazard."},{"checked":false,"id":1,"is_red":false,"text":"Romex wiring should all be enclosed in conduit for protection from nicks or cuts which could be a source of shocks or even electrocution."},{"checked":false,"id":1,"is_red":false,"text":"This property has “knob and tube” wiring which was commonly installed prior to 1950. It is ungrounded, and considered unsafe by today’s standards. Over time, the wire’s insulation may become brittle and fall apart or wear thin, resulting in exposed conductors and a risk of shock and/or fire. This wiring is also easily damaged by covering it with insulation (a common practice), and incorrectly tapping new wiring into it. Some energized knob and tube wiring was found during the inspection. It is not within the scope of this inspection to determine what percentage of this property’s wiring is of the knob and tube type or to determine what percentage of the knob and tube wiring is energized vs. abandoned. A qualified electrician should evaluate this wiring and make repairs or replace wiring as necessary. "},{"checked":false,"id":1,"is_red":false,"text":"Aluminum wiring present - Between 1965 and 1973, aluminum wiring was sometimes substituted for copper wiring in residential electrical systems. Connections in outlets, switches, and light fixtures with aluminum wiring may become increasingly dangerous as time passes. Poor connections cause wiring to overheat, creating a potential fire hazard. Aluminum wiring connections are subject to greater deterioration than is copper due to thermal expansion and contraction, vibration (caused when electric currents pass through wiring), oxidation (caused by exposure to oxygen in the air), and galvanic corrosion (caused when two different metals are connected together), all of which can cause poor connections. When wires are poorly connected they overheat, which creates a potential fire hazard.  The presence of aluminum wiring might also have an effect on your insurance policy. You should ask your insurance agent whether the presence of aluminum wiring is a problem that requires changes to your policy language in order to ensure that your house is covered. The wiring should be evaluated by a qualified electrician experienced in evaluating and correcting aluminum wiring problems. Not all electrical contractors qualify. "},{"checked":false,"id":1,"is_red":false,"text":"220 Volt receptacle needs to be secured to wall"},{"checked":false,"id":1,"is_red":false,"text":"Undersized extension cord in use."},{"checked":false,"id":1,"is_red":false,"text":"We recommend that a licensed electrician evaluate, repair and replace wires and connections as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Reversed polarity, hot and neutral reversed and other terms used for electric receptacles are usually easily corrected by minor wiring adjustments at the specified item. When these conditions are noted in this report, a licensed electrician should be consulted for repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Ungrounded receptacles observed at water sources or exterior locations ideally should be grounded, suggest installing GFCI's for safety."},{"checked":false,"id":1,"is_red":false,"text":"Switches have unknown function, consult the owner for clarification on what they control."},{"checked":false,"id":1,"is_red":false,"text":"Outlet with open ground noted."},{"checked":false,"id":1,"is_red":false,"text":"Replace all old not functioning smoke/ fire detectors with new hard wired detectors or make sure batteries are good."},{"checked":false,"id":1,"is_red":false,"text":"Recommend contacting a licensed electrician to evaluate and offer repair options."}],"sepChoice":"4","title":"Electrical"},{"descr":"","id":2253,"options":[{"checked":false,"id":1,"is_red":false,"text":"GFCI did not respond to test, suggest replacing for safety."},{"checked":false,"id":1,"is_red":false,"text":"GFCI had power when tripped.  This is often the result of miswiring and is usually easily fixed.  Advise repair on replacement as needed."},{"checked":false,"id":1,"is_red":false,"text":"GFCI in place and operational."},{"checked":false,"id":1,"is_red":false,"text":"GFCI in this bathroom resets other bathroom receptacles."},{"checked":false,"id":1,"is_red":false,"text":"GFCI protected receptacles may not have been required when the house was built. We suggest buyer consider upgrading with GFCI's at all receptacles near water sources."},{"checked":false,"id":1,"is_red":false,"text":"No GFCI protection present, suggest installing GFCI protected receptacles for safety."},{"checked":false,"id":1,"is_red":false,"text":"GFCI, lights & fans on same circuit."},{"checked":false,"id":1,"is_red":false,"text":"Reset forthe GFCI is in the main panel."},{"checked":false,"id":1,"is_red":false,"text":"Reset for the GFCI is in the garage."},{"checked":false,"id":1,"is_red":false,"text":"Reset for the GFCI is in in the master bath."},{"checked":false,"id":1,"is_red":false,"text":"Reset for the GFCI is in the 1/2 bathroom."},{"checked":false,"id":1,"is_red":false,"text":"GFCI tested and functioned properly."},{"checked":false,"id":1,"is_red":false,"text":"Recommend upgrading All receptacle to GFCI protection within 6 feet of all potential wet locations."},{"checked":false,"id":1,"is_red":false,"text":"GFCI tested and found to be improperly wired. Recommend review and repair by Qualified Electrician. "},{"checked":false,"id":1,"is_red":false,"text":"GFCI reset at breaker panel <FYI>."},{"checked":false,"id":1,"is_red":false,"text":"One or more bathrooms lack the installation of an outlet <FYI>. Typically at least one outlet is installed for the use of personal grooming appliances ie hair dryer, curling iron, electric razor ect. Recommend upgrading home with the installation of a Ground Fault Circuit Interrupter receptacle at all applicable locations."},{"checked":false,"id":1,"is_red":false,"text":"GFCI protected receptacles may not have been required when the house was built. We suggest buyer consider upgrading with GFCI's at all receptacles near water sources."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum wiring is now a concern with insurance companies due to fire risk.  Buyer is urged to confirm insurability and any related conditions that insurance company may place on this house.  Further inspection of this system may be required.  The inspector CANNOT ensure compliance of this electrical system for insurance purposes."},{"checked":false,"id":1,"is_red":false,"text":"Improper use of extension cord observed. Extension cords should not be permanently installed or be routed through walls, floors or partitions."},{"checked":false,"id":1,"is_red":false,"text":"Insulation has been installed over knob and tube wiring at various locations. This is a fire \"Safety Concern\". Suggest review by a licensed electrician prior to closing to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Missing cover plates observed, suggest installing for safety."},{"checked":false,"id":1,"is_red":false,"text":"Open junction boxes were observed, which is a safety concern. Recommend installing proper covers, as needed, for safety."},{"checked":false,"id":1,"is_red":false,"text":"Recommend full review by qualified electrical contractor for quotes on upgrades/repair to ensure safe and adequate service."},{"checked":false,"id":1,"is_red":false,"text":"Reversed polarity, hot and neutral reversed and other terms used for electric receptacles are usually easily corrected by minor wiring adjustments at the specified item. When these conditions are noted in this report, a licensed electrician should be consulted for repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Since ungrounded receptacles were noted in the home, buyer is cautioned that proper grounding is strongly urged where sensitive electronic equipment is used.  Ungrounded receptacles do not offer protection for computers etc.  Consultation with a qualified electrical contractor is recommended."},{"checked":false,"id":1,"is_red":false,"text":"Ungrounded receptacles observed at water sources or exterior locations ideally should be grounded, suggest installing GFCI's for safety."}],"sepChoice":"4","title":"GFCI"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Electrical Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"GFCI Overall"}],"title":"Electrical"}],"title":"Pool"},{"id":5,"tabbed_panels":[{"damage_panels":[{"descr":"","id":2149,"options":[{"checked":false,"id":1,"is_red":false,"text":"**Location of access**"},{"checked":false,"id":1,"is_red":false,"text":"Pull Down Ladder located in:"},{"checked":false,"id":1,"is_red":false,"text":"Scuttle Hole located in:"},{"checked":false,"id":1,"is_red":false,"text":"Bedroom Closet."},{"checked":false,"id":1,"is_red":false,"text":"Access at hallway ceiling."},{"checked":false,"id":1,"is_red":false,"text":"Garage ceiling."},{"checked":false,"id":1,"is_red":false,"text":"Bedroom Hall."},{"checked":false,"id":1,"is_red":false,"text":"Bedroom ceiling."},{"checked":false,"id":1,"is_red":false,"text":"Hallway closet."},{"checked":false,"id":1,"is_red":false,"text":"No attic present."},{"checked":false,"id":1,"is_red":false,"text":"No Visible Access."},{"checked":false,"id":1,"is_red":false,"text":"Attic light located just inside access."},{"checked":false,"id":1,"is_red":false,"text":"**Access Observations**"},{"checked":false,"id":1,"is_red":false,"text":"Area behind skylight visually inaccessible from hatch."},{"checked":false,"id":1,"is_red":false,"text":"Did not inspect, unable to access attic due to hatch inaccessibility. Recommend review of the Sellers Disclosure Statement regarding the condition of the attic prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Due to the cathedral construction design of this house, the space between the ceiling and roof was not visually inspected, as this area is not visible or accessible to the inspector. If client has concerns regarding this area of the home, a specialist should be contacted for further evaluation and information."},{"checked":false,"id":1,"is_red":false,"text":"Entering attics that are heavily insulated can cause damage to the insulation and attic framing. Attics with deep insulation cannot be safely inspected due to limited visibility of the framing members upon which the inspector must walk. In such cases, the attic is only partially accessed, thereby limiting the review of the attic area from the hatch area only. Inspectors will not crawl the attic area when they believe it is a danger to them or that they might damage the attic insulation or framing. This is a limited review of the attic area viewed from the hatch only."},{"checked":false,"id":1,"is_red":false,"text":"Limited access due to finished attic area.."},{"checked":false,"id":1,"is_red":false,"text":"No attic access observed."},{"checked":false,"id":1,"is_red":false,"text":"Limited visibility due to size of entry."},{"checked":false,"id":1,"is_red":false,"text":"Undersized or difficult to reach hatch making inspection limited."},{"checked":false,"id":1,"is_red":false,"text":"Attic sealed shut; not inspected."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE:  The attic access is not insulated. Expect some energy loss through convection. Recommend insulating  attic access hatch cover@@pull down ladder@@ with a batt of fiberglass insulation to reduce energy expenses. See diagram for detail."},{"checked":false,"id":1,"is_red":false,"text":"Insulation dams need to be properly installed at both attic access."},{"checked":false,"id":1,"is_red":false,"text":"No visible access to attic areas. (See limitations)"},{"checked":false,"id":1,"is_red":false,"text":"Entering attics that are heavily insulated can cause damage to the insulation and attic framing. Attics with deep insulation cannot be safely inspected due to limited visibility of the framing members upon which the inspector must walk. In such cases,the attic is only partially accessed, thereby limiting the review of the attic area from the hatch area only."},{"checked":false,"id":1,"is_red":false,"text":"Appeared functional - with batt insulation over hatch door."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Recommend professional installation of a Pull Down Ladder for ease of attic access."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Recommend professional installation of a Pull Down Ladder for ease of access and convenience in servicing the Heat Pump air handler unit installed in the attic.."},{"checked":false,"id":1,"is_red":false,"text":"Not Accessible."}],"sepChoice":"4","title":"Access"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Access Overall"}],"title":"Access"},{"damage_panels":[{"descr":"","id":2156,"options":[{"checked":false,"id":1,"is_red":false,"text":"Evidence of past or present leaks, dry at time of the inspection.  Monitor for leaks &/or have roofing contractor evaluate."},{"checked":false,"id":1,"is_red":false,"text":"Possible organic substance noted.  The United States Environmental Protection Association (EPA) states, “If you believe that you may have a hidden mold problem, consider hiring a professional.” (Brief Guide to Mold, p.14, EPA).   If any area of the residence is suspected of having organic growth, or any member of your family or household is sensitive to mold, we are lab-certified to conduct a Mold Inspection / Sampling to identify the types of mold (or any other airborne allergens) present.   "},{"checked":false,"id":1,"is_red":false,"text":"Some areas of attic sheathing are blackened, and inspectors cannot determine cause (soot, possible organic substance, or even stains from prior use).  The United States Environmental Protection Association (EPA) states, “If you believe that you may have a hidden mold problem, consider hiring a professional.” (Brief Guide to Mold, p.14, EPA).   If any area of the residence is suspected of having organic growth, or any member of your family or household is sensitive to mold, we are lab-certified to conduct a Mold Inspection / Sampling to identify the types of mold (or any other airborne allergens) present.   If necessary, we are also lab-certified to perform radon, meth, asbestos and other environmental testing services.  "},{"checked":false,"id":1,"is_red":false,"text":"Evidence of roof rafters bowing / cracking.   "},{"checked":false,"id":1,"is_red":false,"text":"Cracks / hole(s) in roof sheathing, shingled over.    "},{"checked":false,"id":1,"is_red":false,"text":"Cracks / hole(s) in roof sheathing, daylight visible"},{"checked":false,"id":1,"is_red":false,"text":"Evidence of past fire noted. The damage appears to be repaired."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of past leaking noted. The area tested dry with a moisture meter. Recommend monitoring for future leaking."},{"checked":false,"id":1,"is_red":false,"text":"Inspected from access hole only, limited space in attic prevented entry."},{"checked":false,"id":1,"is_red":false,"text":"Could not access all areas of the attic due to limited space."},{"checked":false,"id":1,"is_red":false,"text":"Stored personal items prevent complete attic inspection."},{"checked":false,"id":1,"is_red":false,"text":"Could not access due to size of entry."},{"checked":false,"id":1,"is_red":false,"text":"Split/Broken framing boards observed."},{"checked":false,"id":1,"is_red":false,"text":"Split/Broken rafters observed."},{"checked":false,"id":1,"is_red":false,"text":"Additional support added."},{"checked":false,"id":1,"is_red":false,"text":"Due to the framing design of this roof system we recommend limiting the number of roof layers to no more than one layer."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of improper repairs observed."},{"checked":false,"id":1,"is_red":false,"text":"Framing is poorly braced."},{"checked":false,"id":1,"is_red":false,"text":"Limited review due to insulation installed between the rafters."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified professional for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a structural engineer or other qualified professional for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Roof trusses have been cut or altered, this may compromise the integrity of the structure. We recommend review by a licensed structural engineer for evaluation and repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Unable to determine condition due to insulation."},{"checked":false,"id":1,"is_red":false,"text":"Attic area has been converted to living space."}],"sepChoice":"4","title":"Structure"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Structure Overall"}],"title":"Structure"},{"damage_panels":[{"descr":"","id":2157,"options":[{"checked":false,"id":1,"is_red":false,"text":"Under eave soffit inlet vents noted. "},{"checked":false,"id":1,"is_red":false,"text":"Ridge exhaust venting noted."},{"checked":false,"id":1,"is_red":false,"text":"Thermostatically controlled Power Ventilator on roof field noted."},{"checked":false,"id":1,"is_red":false,"text":"Gable louver vents noted."},{"checked":false,"id":1,"is_red":false,"text":"No Visible Ventilation noted."},{"checked":false,"id":1,"is_red":false,"text":"Turbine Vents noted."},{"checked":false,"id":1,"is_red":false,"text":"Fixed, roof-field exhaust vent noted."},{"checked":false,"id":1,"is_red":false,"text":"Attic fan appears to be controlled by a thermostat; no operational test was performed. Suggest verification of performance prior to closing."},{"checked":false,"id":1,"is_red":false,"text":"Attic fan is inoperable, recommend review for repair."},{"checked":false,"id":1,"is_red":false,"text":"Attic is inadequately vented. Recommend review by a qualified professional for repair as necessary to ensure proper ventilation."},{"checked":false,"id":1,"is_red":false,"text":"Frost observed at underside of roof."},{"checked":false,"id":1,"is_red":false,"text":"No soffit vent baffles observed. Wind may displace insulation. Suggest  installing vent baffles "},{"checked":false,"id":1,"is_red":false,"text":"Recommend adding additional ventilation to avoid premature aging of roof and help to maintain proper humidity and temperature control."},{"checked":false,"id":1,"is_red":false,"text":"Recommend installing gable vents for improved ventilation."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Soffit vents are blocked with insulation."},{"checked":false,"id":1,"is_red":false,"text":"Thermostatically controlled fans are not operated."}],"sepChoice":"4","title":"Ventilation"},{"descr":"","id":2158,"options":[{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as functional."},{"checked":false,"id":1,"is_red":false,"text":"Suggest repair or replacing vent screens."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens are damaged or missing, suggest repairing or replacing screens as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as missing."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as torn."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as bent."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as blocked."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as restricted."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as loose."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as sealed off."}],"sepChoice":"4","title":"Vent Screens"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Ventilation Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Vent Screens Overall"}],"title":"Ventilation"},{"damage_panels":[{"descr":"","id":2151,"options":[{"checked":false,"id":1,"is_red":false,"text":"None observed."},{"checked":false,"id":1,"is_red":false,"text":"Possible asbestos materials observed. The materials were torn, ripped, or damaged at the time of inspection. This is a possible safety hazard. Suggest further review by a licensed asbestos testing lab be performed prior to closing for repairs/replacement needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Possible asbestos materials observed. The materials appeared to be in serviceable condition at the time of inspection. Asbestos materials are considered safe by the EPA if they are not disturbed, torn, ripped, or damaged. No torn, ripped, or damaged materials were observed. If client has any concerns regarding asbestos materials, an asbestos testing lab should be consulted for further review to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Ducts were loose in areas; advise securing."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a licensed heating contractor for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"While asbestos detection and other chemical testing are beyond the scope of the inspection, the inspector's experience leads him to suspect that some building materials in this home may contain asbestos. If client has any concerns regarding this possibility, an asbestos testing lab should be consulted prior to closing."},{"checked":false,"id":1,"is_red":false,"text":"Functional."},{"checked":false,"id":1,"is_red":false,"text":"Wrapping is torn in areas."},{"checked":false,"id":1,"is_red":false,"text":"Loose connections were observed in areas."},{"checked":false,"id":1,"is_red":false,"text":"Recommend taping."},{"checked":false,"id":1,"is_red":false,"text":"Insulation missing in areas."},{"checked":false,"id":1,"is_red":false,"text":"Air leaking at plenum."},{"checked":false,"id":1,"is_red":false,"text":"Recommend cleaning."},{"checked":false,"id":1,"is_red":false,"text":"Exterior ducting present."},{"checked":false,"id":1,"is_red":false,"text":"Ducting runs through firewall."},{"checked":false,"id":1,"is_red":false,"text":"See HVAC page."},{"checked":false,"id":1,"is_red":false,"text":"Old duct work present."},{"checked":false,"id":1,"is_red":false,"text":"Recommend evaluation by Heating & A/C contractor."}],"sepChoice":"4","title":"Duct Work"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Duct Work Overall"}],"title":"Duct"},{"damage_panels":[{"descr":"","id":2152,"options":[{"checked":false,"id":1,"is_red":false,"text":"Most areas not accessible due to insulation."},{"checked":false,"id":1,"is_red":false,"text":"Electrical Box Covers missing or damaged, which is a potential shock or electrocution hazard."},{"checked":false,"id":1,"is_red":false,"text":"Connections made outside of a Junction Box, which is a potential shock or electrocution hazard. "},{"checked":false,"id":1,"is_red":false,"text":"Wire ends are outside of a Junction Box, which is a potential shock or electrocution hazard."},{"checked":false,"id":1,"is_red":false,"text":"Live knob and tube wiring present."},{"checked":false,"id":1,"is_red":false,"text":"Knob and tube wiring present, cannot be sure if it has been disconnected."},{"checked":false,"id":1,"is_red":false,"text":"All original knob and tube wiring appears to have been removed."},{"checked":false,"id":1,"is_red":false,"text":"All wiring should be properly secured to the framing."},{"checked":false,"id":1,"is_red":false,"text":"Any electrical components in attic were not accessible to inspection, therefore not within scope of this report."},{"checked":false,"id":1,"is_red":false,"text":"Exposed electrical wiring observed. This is a safety concern if used where it could be subject to \"Physical Damage\". Exposed electrical wires are normally encased in conduit to ensure safety. Client should consult with a licensed electrician prior to closing for repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Extension cord improperly used as permanent wiring. Extension cords should not be used for permanent wiring due to fire safety concerns. Client should consider review by a licensed electrician prior to closing for installation of proper electrical wiring and receptacles to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Improper use of extension cord observed. Extension cords should not be permanently installed or be routed through walls, floors or partitions."},{"checked":false,"id":1,"is_red":false,"text":"Insulation has been installed over knob and tube wiring at various locations. This is a fire \"Safety Concern\". Suggest review by a licensed electrician prior to closing to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Light fixture inoperative at time of inspection. Possible spent bulb. Suggest client verify fixture for proper operation prior to closing."},{"checked":false,"id":1,"is_red":false,"text":"Loose hanging light fixture observed, suggest repairing for safety."},{"checked":false,"id":1,"is_red":false,"text":"Missing cover plates observed, suggest installing for safety."},{"checked":false,"id":1,"is_red":false,"text":"Open junction boxes were observed, which is a safety concern. Recommend installing proper covers, as needed, for safety."},{"checked":false,"id":1,"is_red":false,"text":"Recessed lighting present in the attic may be a safety concern if insulation is too close or on top of these lights and/or if the lights are improperly installed. Please refer to the manufacturer's recommendations for each light for proper installation instructions or have these lights reviewed by a licensed electrician for proper and safe installation to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Reversed polarity, hot and neutral reversed and other terms used for electric receptacles are usually easily corrected by minor wiring adjustments at the specified item. When these conditions are noted in this report, a licensed electrician should be consulted for repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Ungrounded three prong receptacles observed. It is recommended that these type of receptacles be grounded, replaced with two prong receptacles, or protected on a GFCI circuits as applicable. Suggest review by licensed electrical contractor for repairs/replacements as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Switches have unknown function, consult the owner."},{"checked":false,"id":1,"is_red":false,"text":"Whole house fan present."},{"checked":false,"id":1,"is_red":false,"text":"Missing j-box cover."},{"checked":false,"id":1,"is_red":false,"text":"Missing j-boxes at connections."},{"checked":false,"id":1,"is_red":false,"text":"Using extension cord for power."},{"checked":false,"id":1,"is_red":false,"text":"Outlet covers missing."},{"checked":false,"id":1,"is_red":false,"text":"Switch covers missing."},{"checked":false,"id":1,"is_red":false,"text":"Bulb out, could not test."},{"checked":false,"id":1,"is_red":false,"text":"Recommend electrician to evaluate."}],"sepChoice":"4","title":"Electrical"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Electrical Overall"}],"title":"Electrical"},{"damage_panels":[{"descr":"","id":2155,"options":[{"checked":false,"id":1,"is_red":false,"text":"PVC plumbing vents"},{"checked":false,"id":1,"is_red":false,"text":"ABS plumbing vents"},{"checked":false,"id":1,"is_red":false,"text":"ABS (Acrylonitrile-Butadiene-Styrene)( black in color) - plumbing vent piping"},{"checked":false,"id":1,"is_red":false,"text":"Copper plumbing vent piping"},{"checked":false,"id":1,"is_red":false,"text":"Plumbing vent pipes terminate in the attic. this can lead to moisture and sewer gas exhausting into the attic."},{"checked":false,"id":1,"is_red":false,"text":"PVC plumbing vent pipe appeared functional, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"No deficiencies noted in plumbing vent piping."},{"checked":false,"id":1,"is_red":false,"text":"Outside light can be seen around plumbing vent pipe(s) penetration(s) through roof sheathing due to failed boot flanges. Water stains on sheathing and insulation observed. SEE \"ROOFING\" Section."},{"checked":false,"id":1,"is_red":false,"text":"Vent pipe does not extend to the exterior."}],"sepChoice":"4","title":"Attic Plumbing"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Attic Plumbing Overall"}],"title":"Attic Plumbing"},{"damage_panels":[{"descr":"","id":2154,"options":[{"checked":false,"id":1,"is_red":false,"text":"Apparent vermiculite insulation present; this type of insulation may contain asbestos, which has been linked to cancer (mesothelioma).  This inspector is qualified to sample the insulation for you and send it to a national laboratory which will determine if asbestos is present.  The EPA makes the following recommendation at http://www.epa.gov/asbestos/pubs/insulation.html :\n \n\"What should I do if I have vermiculite attic insulation?\nDO NOT DISTURB IT. Any disturbance has the potential to release asbestos fibers into the air. Limiting the number of trips you make to your attic and shortening the length of those trips can help limit your potential exposure. EPA and ATSDR strongly recommend that:\nVermiculite insulation be left undisturbed in your attic. Due to the uncertainties with existing testing techniques, it is best to assume that the material may contain asbestos. \nYou should not store boxes or other items in your attic if retrieving the material will disturb the insulation. \nChildren should not be allowed to play in an attic with open areas of vermiculite insulation. \nIf you plan to remodel or conduct renovations that would disturb the vermiculite, hire professionals trained and certified to handle asbestos to safely remove the material. \nYou should never attempt to remove the insulation yourself. Hire professionals trained and certified to safely remove the material.\"\n"},{"checked":false,"id":1,"is_red":false,"text":"No insulation over attic hatch; recommend installation, then sealing hatch with caulk to minimize heat loss."},{"checked":false,"id":1,"is_red":false,"text":"Uninsulated heating or cooling ducts present.  "},{"checked":false,"id":1,"is_red":false,"text":"Apparent vermiculite insulation present; this type of insulation may contain asbestos, which has been linked to cancer (mesothelioma).  This inspector is qualified to sample the insulation for you and send it to a national laboratory which will determine if asbestos is present.  The EPA makes the following recommendation at http://www.epa.gov/asbestos/pubs/insulation.html :\n \n\"What should I do if I have vermiculite attic insulation?\nDO NOT DISTURB IT. Any disturbance has the potential to release asbestos fibers into the air. Limiting the number of trips you make to your attic and shortening the length of those trips can help limit your potential exposure. EPA and ATSDR strongly recommend that:\nVermiculite insulation be left undisturbed in your attic. Due to the uncertainties with existing testing techniques, it is best to assume that the material may contain asbestos. \nYou should not store boxes or other items in your attic if retrieving the material will disturb the insulation. \nChildren should not be allowed to play in an attic with open areas of vermiculite insulation. \nIf you plan to remodel or conduct renovations that would disturb the vermiculite, hire professionals trained and certified to handle asbestos to safely remove the material. \nYou should never attempt to remove the insulation yourself. Hire professionals trained and certified to safely remove the material.\"\n"},{"checked":false,"id":1,"is_red":false,"text":"Insulation level in the attic is typical for homes this age"},{"checked":false,"id":1,"is_red":false,"text":"Insulation appears adequate."},{"checked":false,"id":1,"is_red":false,"text":"Insulation that is settled does not perform to the R-Value that it once did."},{"checked":false,"id":1,"is_red":false,"text":"Insulation is sparse in some areas."},{"checked":false,"id":1,"is_red":false,"text":"Insulation was installed wrong side up."},{"checked":false,"id":1,"is_red":false,"text":"Vapor retarder/barrier installed wrong side up."},{"checked":false,"id":1,"is_red":false,"text":"Staining observed."},{"checked":false,"id":1,"is_red":false,"text":"Wet."},{"checked":false,"id":1,"is_red":false,"text":"Damaged."},{"checked":false,"id":1,"is_red":false,"text":"Insulation is covering knob and tube wiring."},{"checked":false,"id":1,"is_red":false,"text":"Bird droppings are present."},{"checked":false,"id":1,"is_red":false,"text":"Irregular insulation."},{"checked":false,"id":1,"is_red":false,"text":"The insulation installed in the rafters is disturbed. The house insulation is minimal. Expect high energy costs. Recommend having the home professionally insulated to reduce energy expenses. "},{"checked":false,"id":1,"is_red":false,"text":"Vermin activity observed in the attic. Vermin can damage insulation & electrical wiring. Recommend a professional pest contractor evaluate for treatment."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE:  The attic access is not insulated. Expect higher energy costs. Recommend insulating the attic access to reduce energy expenses. See illustration."},{"checked":false,"id":1,"is_red":false,"text":"Vermiculite insulation may contain asbestos materials. Have evaluated by a qualified specialist."},{"checked":false,"id":1,"is_red":false,"text":"There is no insulation installed at the crawl space sub floor. Expect higher energy costs. Recommend having crawl area evaluated for adding insulation."},{"checked":false,"id":1,"is_red":false,"text":"UFFI (Urea Formaldehyde Foam Insulation) is a thermal insulation material that is no longer used because of formaldehyde gas emission. See the following site:\n\nhttp://www.ct.gov/dph/lib/dph/environmental_health/eoha/pdf/uffi.pdf"},{"checked":false,"id":1,"is_red":false,"text":"Flammable debris in attic--may result in a fire hazard. Recommend removal."},{"checked":false,"id":1,"is_red":false,"text":"Ceiling framing & vapor retarder/barrier not visible due to insulation."},{"checked":false,"id":1,"is_red":false,"text":"Vermin activity observed in the attic. Vermin can damage insulation & electrical wiring. Recommend a professional pest contractor evaluate for treatment."},{"checked":false,"id":1,"is_red":false,"text":"Tunneling observed at house insulation."},{"checked":false,"id":1,"is_red":false,"text":"Numerous insect nests observed in attic. Location: @@@@@@@@"},{"checked":false,"id":1,"is_red":false,"text":"Mold-like bio growth observed. Professional testing & evaluation advised."},{"checked":false,"id":1,"is_red":false,"text":"Personal storage items observed in the attic.  Attics are not generally designed for storage. Recommend removal."},{"checked":false,"id":1,"is_red":false,"text":"Insulation appears to be original installation.  Insulation has degraded and matted down to 3-4 inches in most of the attic area -- resulting in poor/degraded insulating capacity.  Expect higher energy loss and  heating & cooling energy expence. Recommend an insulation contractor evaluate for replacement and/or adding new insulation as needed."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE:   The house has only a minimal amount of visible insulation. Expect high heating and cooling energy costs. Recommend having the home professionally  insulated to reduce energy expenses.\n\n"},{"checked":false,"id":1,"is_red":false,"text":"SAFETY CONCERN: Attic insulation is in contact with recessed @@LOCATION@@ Heat Lamp@@ and @@LOCATION@@ bathroom Heater-Vent@@. These older recessed ceiling heaters trap heat, degrading the in-contact surrounding insulation, thereby increasing its combustion potential. This is a fire hazard. A minimum of 3\" clearance is required from insulation material. Recommend a qualified contractor review these recessed lights and repair as needed."}],"sepChoice":"4","title":"Insulation Condition"}],"inspection_panels":[{"descr":"","id":3049,"options":[{"checked":false,"id":1,"is_red":false,"text":"Unfinished fiberglass batts noted."},{"checked":false,"id":1,"is_red":false,"text":"Encapsulated fiberglass batts noted."},{"checked":false,"id":1,"is_red":false,"text":"Fiberglass batts with kraft paper facing noted."},{"checked":false,"id":1,"is_red":false,"text":"Fiberglass batts with foil facing noted."},{"checked":false,"id":1,"is_red":false,"text":"Loose fill insulation noted."},{"checked":false,"id":1,"is_red":false,"text":"Blown in fiberglass insulation noted."},{"checked":false,"id":1,"is_red":false,"text":"Blown in cellulose insulation noted."},{"checked":false,"id":1,"is_red":false,"text":"Foil sheeting vapor barrier noted."}],"sepChoice":"1","title":"Insulation Type"},{"descr":"Depth:","id":3050,"options":[{"checked":false,"id":1,"is_red":false,"text":"Insulation averages 3 to 4 inches.  Recommend installing more."},{"checked":false,"id":1,"is_red":false,"text":"Insulation averages about 4-6 inches in depth; more recommended."},{"checked":false,"id":1,"is_red":false,"text":"Insulation averages about 6-8 inches in depth"},{"checked":false,"id":1,"is_red":false,"text":"Insulation averages about 8 inches in depth"},{"checked":false,"id":1,"is_red":false,"text":"Insulation averages about 8-10 inches in depth"},{"checked":false,"id":1,"is_red":false,"text":"Insulation averages about 10-12 inches in depth"},{"checked":false,"id":1,"is_red":false,"text":"Insulation averages about 12-14 inches in depth"},{"checked":false,"id":1,"is_red":false,"text":"Insulation averages about 14-16 inches in depth"},{"checked":false,"id":1,"is_red":false,"text":"Insulation averages about 16-18 inches in depth."}],"sepChoice":"1","title":"Insulation Depth"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Insulation Condition Overall"}],"title":"Insulation"},{"damage_panels":[{"descr":"","id":2150,"options":[{"checked":false,"id":1,"is_red":false,"text":"11 feet is typical oil burner minimum chimney height requirement.  Advise review by qualified contractor to determine if this installation is appropriate."},{"checked":false,"id":1,"is_red":false,"text":"Double wall metal B-Vent pipe noted."},{"checked":false,"id":1,"is_red":false,"text":"15 feet is minimum fireplace chimney height according to common standards.  Suggest having evaluated by qualified contractor."},{"checked":false,"id":1,"is_red":false,"text":"Abandoned masonry chimney, no longer in use."},{"checked":false,"id":1,"is_red":false,"text":"Brick and mortar deterioration observed; repair advised."},{"checked":false,"id":1,"is_red":false,"text":"Chimney brick has been painted."},{"checked":false,"id":1,"is_red":false,"text":"Chimney is leaning."},{"checked":false,"id":1,"is_red":false,"text":"Chimney is too short. The 10-2-3 Rule states that the chimney should extend at least 3 ft. above the roof opening (measured at the uphill side on sloped roofs) and at least 2 ft. above the roof's (or any other structure's) highest point within 10 ft. for proper drafting. Simple repairs and/or modifications can usually be made to most chimneys to correct the problem. Recommend review by a qualified chimney specialist for repair or modification, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Chimney location at base of valley makes this area more prone to water infiltration."},{"checked":false,"id":1,"is_red":false,"text":"Chimney needs to be rebuilt above the roof line."},{"checked":false,"id":1,"is_red":false,"text":"Crown and Flashing intact where visible."},{"checked":false,"id":1,"is_red":false,"text":"Efflorescence observed; often a sign of water infiltration/exfiltration and can be a precursor of masonry deterioration."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of repairs observed, unable to determine the effectiveness of these repairs."},{"checked":false,"id":1,"is_red":false,"text":"Fireplace chimney height does not meet typical standard for spark and draft control."},{"checked":false,"id":1,"is_red":false,"text":"Flaking, spalling brick observed."},{"checked":false,"id":1,"is_red":false,"text":"Height is low; metal furnace chimneys are typically required to be two feet over the roof.  Low chimneys can affect draft."},{"checked":false,"id":1,"is_red":false,"text":"Loose bricks observed."},{"checked":false,"id":1,"is_red":false,"text":"Metal chimney liner observed."},{"checked":false,"id":1,"is_red":false,"text":"Recommend monitoring this area regularly."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified chimney professional for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Some corrosion observed; advise review by qualified HVAC contractor."},{"checked":false,"id":1,"is_red":false,"text":"Some mortar deterioration observed; advise repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Masonry intact where visible."},{"checked":false,"id":1,"is_red":false,"text":"Limited review, chimney was viewed from the ground only. Our chimney review is limited to visible accessible components only. If further review is desired, we suggest review by a qualified professional prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Limited review.  Our chimney review is limited to visible accessible components only. If further review is desired, we suggest review by a qualified professional prior to close."},{"checked":false,"id":1,"is_red":false,"text":"No way to determine presence of liner due to poor visual accessibility.  Further investigation required."},{"checked":false,"id":1,"is_red":false,"text":"Our chimney review is limited to visible accessible components only. If further review is desired, we suggest review by a qualified professional prior to close."}],"sepChoice":"4","title":"Chimney"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Chimney Overall"}],"title":"Chimney"},{"damage_panels":[{"descr":"","id":2153,"options":[{"checked":false,"id":1,"is_red":false,"text":"Functional."},{"checked":false,"id":1,"is_red":false,"text":"Could not access."},{"checked":false,"id":1,"is_red":false,"text":"Exhaust fan duct appears to terminate in attic.   Have duct routed to exterior to minimize moisture an possible development of mold."},{"checked":false,"id":1,"is_red":false,"text":"Terminates in the attic."},{"checked":false,"id":1,"is_red":false,"text":"Does not extend to exterior air."},{"checked":false,"id":1,"is_red":false,"text":"Loose connections."},{"checked":false,"id":1,"is_red":false,"text":"Missing vent pipe."},{"checked":false,"id":1,"is_red":false,"text":"Collapsed/crushed vent pipe."}],"sepChoice":"4","title":"Exhaust Vent"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Exhaust Vent Overall"}],"title":"Exhaust"}],"title":"Attic"},{"id":6,"tabbed_panels":[{"damage_panels":[{"descr":"","id":2165,"options":[{"checked":false,"id":1,"is_red":false,"text":"Concrete slab not visible due to floor coverings."},{"checked":false,"id":1,"is_red":false,"text":"Numerous cracks were observed at the basement concrete floor. Moisture and radon gases could enter through the cracks. Recommend sealing the cracks with a concrete crack filler or caulk that is recommended for concrete."},{"checked":false,"id":1,"is_red":false,"text":"Active leaks observed at the time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"All concrete floor slabs experience some degree of cracking due to shrinkage in the drying process.  In most instances floor coverings prevent recognition of cracks or settlement in all but the most severe cases.  Where carpeting and other floor coverings are installed, the materials and condition of the flooring underneath cannot be determined. "},{"checked":false,"id":1,"is_red":false,"text":"Common cracks noted."},{"checked":false,"id":1,"is_red":false,"text":"Common cracks noted.  Recommend consultation with qualified contractor should condition worsen or water intrusion occur."},{"checked":false,"id":1,"is_red":false,"text":"Efflorescence observed; this is a mineral deposit left behind from exterior water infiltration."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of past water penetration observed."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of repairs observed, unable to determine the effectiveness of these repairs."},{"checked":false,"id":1,"is_red":false,"text":"Expansive cracks and settling observed, suggest sealing cracks as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Floor drain is full of debris."},{"checked":false,"id":1,"is_red":false,"text":"Floor drain observed."},{"checked":false,"id":1,"is_red":false,"text":"Floor has been painted."},{"checked":false,"id":1,"is_red":false,"text":"Moisture present at the time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Mold-like bio growth observed. Professional testing & evaluation advised."},{"checked":false,"id":1,"is_red":false,"text":"Open floor drain observed, suggest installing a grate or cover for safety."},{"checked":false,"id":1,"is_red":false,"text":"Open seams observed."},{"checked":false,"id":1,"is_red":false,"text":"Popping floor tile observed."},{"checked":false,"id":1,"is_red":false,"text":"Possible trip hazard. This is a safety concern. Suggest repair/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Recommend installation of vapour barrier on dirt floor to reduce humidity and protect mechanical equipment and structure from damage."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified professional for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Recommend sealing cracks/voids."},{"checked":false,"id":1,"is_red":false,"text":"Standing water due to seepage noted."},{"checked":false,"id":1,"is_red":false,"text":"Not visible to inspect due to complete basement floor finished/covered."},{"checked":false,"id":1,"is_red":false,"text":"Visible areas appear satisfactory"},{"checked":false,"id":1,"is_red":false,"text":"Small visible area of unfinished basement utility room floor appeared satisfactory, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Concrete slab only."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of cracking at interior wall."},{"checked":false,"id":1,"is_red":false,"text":"Recommend contractor to evaluate."},{"checked":false,"id":1,"is_red":false,"text":"Raised Foundation Only."},{"checked":false,"id":1,"is_red":false,"text":"Raised Foundation In Areas."}],"sepChoice":"4","title":"Slab Foundation"},{"descr":"","id":2166,"options":[{"checked":false,"id":1,"is_red":false,"text":"No deficiencies were observed at the visible portions of the structural components of the home."},{"checked":false,"id":1,"is_red":false,"text":"No leaks were observed at the time of the inspection."},{"checked":false,"id":1,"is_red":false,"text":"No stains or evidence of moisture penetration observed."},{"checked":false,"id":1,"is_red":false,"text":"Moisture intrusion was observed numerous areas of the foundation. Moisture can create high humidity, mold & can damage stored items & finishing materials. Recommend a wet basement specialist review the foundation for correcting the water intrusion and advise as needed."},{"checked":false,"id":1,"is_red":false,"text":"Large cracks were observed at the visible foundation walls. Repairs can be expensive and further settling or damage could occur. Recommend a Structural Engineer to provide a detailed analysis."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: It is advised to purchase a humidity gauge to monitor the levels of humidity. Typical levels are 35 to 45% during the heating season and 45 to 55% during the cooling season."},{"checked":false,"id":1,"is_red":false,"text":"The home has a interior drainage system. It is advised to obtain documentation and warranty information from current owner."},{"checked":false,"id":1,"is_red":false,"text":"Area of major repair noted to poured concrete foundation wall.  This repair appears to be professionally done.  Buyer is recommended to request and review any existing documents relative to this repair to determine if any warranties exist.  No warranty for this or any other repair is implied by this inspection. "},{"checked":false,"id":1,"is_red":false,"text":"Visible portions of foundation wall were dry at the time of the inspection."},{"checked":false,"id":1,"is_red":false,"text":"Although there are no signs of water penetration we caution you to consider any basement as wet until experience proves it dry."},{"checked":false,"id":1,"is_red":false,"text":"Efflorescence observed; this is a mineral deposit left behind from previous exterior water infiltration."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of past water penetration observed."},{"checked":false,"id":1,"is_red":false,"text":"Active leaks observed at the time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Water stains, bulging walls, or other damage was observed near plumbing fixtures  that indicate leaks or possible concealed leaks. Client is advised to obtain further review by a licensed plumber prior to closing to determine the cause of this condition for repairs/replacement as needed."},{"checked":false,"id":1,"is_red":false,"text":"Mildew observed, which is an indication of inadequate ventilation."},{"checked":false,"id":1,"is_red":false,"text":"Mold-like bio growth observed. Professional testing & evaluation advised."},{"checked":false,"id":1,"is_red":false,"text":"Common cracks observed, these may leak at any time."},{"checked":false,"id":1,"is_red":false,"text":"Cracks and deterioration observed."},{"checked":false,"id":1,"is_red":false,"text":"Shrinkage cracking noted.  This cracking is common and usually no reason for concern.  Recommend monitoring and consultation with qualified contractor should condition worsen or if water intrusion occur."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of repairs observed, unable to determine the effectiveness of these repairs."},{"checked":false,"id":1,"is_red":false,"text":"Minor shrinkage/settlement cracking noted at exterior East side wall.  This is a relatively common condition that occurs during the curing process and is normally no reason for concern.  Recommend sealing with clear Polyurethane caulk and monitoring. Consult with a professional engineer or qualified contractor should condition worsen or if water intrusion occurs."},{"checked":false,"id":1,"is_red":false,"text":"Patching observed."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified professional for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"The waterproofing system has been poorly installed. Recommend having entire system reviewed."},{"checked":false,"id":1,"is_red":false,"text":"http://www.killmoldfast.com/"},{"checked":false,"id":1,"is_red":false,"text":"This situation can be minimized or eliminated by regrading exterior landscape at these locations and extending the front gutter downspouts away from foundation."},{"checked":false,"id":1,"is_red":false,"text":"Unsealed area around waste line penetration at foundation wall. Recommend sealing with hydraulic cement and polyurethane caulking. "}],"sepChoice":"4","title":"Foundation Perimeter"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Slab Foundation Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Foundation Perimeter Overall"}],"title":"Slab Foundation"},{"damage_panels":[{"descr":"","id":2172,"options":[{"checked":false,"id":1,"is_red":false,"text":"Normal settlement."},{"checked":false,"id":1,"is_red":false,"text":"Moisture intrusion was observed in numerous areas of the foundation. Moisture can create high humidity, mold & can damage stored items & finishing materials. It is recommended to have a basement specialist review the foundation for correcting the water intrusion and advise as needed before closing."},{"checked":false,"id":1,"is_red":false,"text":"Large cracks were observed at the visible foundation walls. Repairs can be expensive and further settling or damage could occur. Recommend a Structural Engineer to provide a detailed analysis before the close of escrow on the structure."},{"checked":false,"id":1,"is_red":false,"text":"Improve: It is advised to purchase a humidity gauge to monitor the levels of humidity. Typical levels are 35 to 45% during the heating season and 45 to 55% during the cooling season."},{"checked":false,"id":1,"is_red":false,"text":"The home has a interior drainage system. It is advised to obtain documentation and warranty information from current owner."},{"checked":false,"id":1,"is_red":false,"text":"Area of major repair noted to poured concrete foundation wall.  This repair appears to be professionally done.  Buyer is recommended to request and review any existing documents relative to this repair to determine if any warranties exist.  No warranty for this or any other repair is implied by this inspection. "},{"checked":false,"id":1,"is_red":false,"text":"Visible portions of foundation wall were dry at the time of the inspection. See Limitations."},{"checked":false,"id":1,"is_red":false,"text":"Although there are no signs of water penetration, we caution you to consider any basement as wet until experience proves it dry."},{"checked":false,"id":1,"is_red":false,"text":"Efflorescence observed; this is a mineral deposit left behind from exterior water infiltration."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of past water penetration observed."},{"checked":false,"id":1,"is_red":false,"text":"Active leaks observed at the time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Water stains, bulging walls, or other damage was observed near plumbing fixtures  that indicate leaks or possible concealed leaks. Client is advised to obtain further review by a licensed plumber prior to closing to determine the cause of this condition for repairs/replacement as needed."},{"checked":false,"id":1,"is_red":false,"text":"No leaks were observed at the time of the inspection."},{"checked":false,"id":1,"is_red":false,"text":"No stains or evidence of moisture penetration observed."},{"checked":false,"id":1,"is_red":false,"text":"Mildew observed, which is an indication of inadequate ventilation."},{"checked":false,"id":1,"is_red":false,"text":"Mold-like bio growth observed. Professional testing & evaluation advised."},{"checked":false,"id":1,"is_red":false,"text":"Common cracks observed, these may leak at any time."},{"checked":false,"id":1,"is_red":false,"text":"Cracks and deterioration observed."},{"checked":false,"id":1,"is_red":false,"text":"Shrinkage cracking noted in unfinished area.  This cracking is common and usually no reason for concern.  Recommend monitoring and consultation with qualified contractor should condition worsen or if water intrusion occur."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of repairs observed, unable to determine the effectiveness of these repairs."},{"checked":false,"id":1,"is_red":false,"text":"Minor shrinkage cracking noted.  This is a relatively common condition that occurs during the curing process and is normally no reason for concern.  Recommend monitoring and consultation with a qualified contractor should condition worsen or if water intrusion occurs."},{"checked":false,"id":1,"is_red":false,"text":"Patching observed."},{"checked":false,"id":1,"is_red":false,"text":"Limited review due to insulation cover and finished walls."},{"checked":false,"id":1,"is_red":false,"text":"Limited review due to storage of personal property."},{"checked":false,"id":1,"is_red":false,"text":"Limited review of unfinished area due to insulation cover."},{"checked":false,"id":1,"is_red":false,"text":"Walls have been recently painted."},{"checked":false,"id":1,"is_red":false,"text":"Limited view due to storage and finishing systems. See Limitations"},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified professional for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Walls are leaning."},{"checked":false,"id":1,"is_red":false,"text":"The waterproofing system has been poorly installed. Recommend having entire system reviewed."},{"checked":false,"id":1,"is_red":false,"text":"No deficiencies were observed at the visible portions of the structural components of the home."},{"checked":false,"id":1,"is_red":false,"text":"Have entire crawl space evaluated by a qualified professional. This includes waterproofing system, piping, insulation and wiring."},{"checked":false,"id":1,"is_red":false,"text":"http://www.cleancrawlspace.com/"},{"checked":false,"id":1,"is_red":false,"text":"http://www.killmoldfast.com/"},{"checked":false,"id":1,"is_red":false,"text":"This situation can be minimized or eliminated by regrading exterior landscape at these locations and extending the front gutter downspouts away from foundation."},{"checked":false,"id":1,"is_red":false,"text":"Unsealed area around waste line penetration at foundation wall. Recommend sealing with hydraulic cement and polyurethane caulking. "},{"checked":false,"id":1,"is_red":false,"text":"River rock foundation noted."},{"checked":false,"id":1,"is_red":false,"text":"Possible organic substance noted.  The United States Environmental Protection Association (EPA) states, “If you believe that you may have a hidden mold problem, consider hiring a professional.” (Brief Guide to Mold, p.14, EPA).   If any area of the residence is suspected of having organic growth, or any member of your family or household is sensitive to mold, we are lab-certified to conduct a Mold Inspection / Sampling to identify the types of mold (or any other airborne allergens) present.   If necessary, we are also lab-certified to perform radon, meth, asbestos and other environmental testing services.   See: www.IdahoHomeInspectors.biz/rates for more information."},{"checked":false,"id":1,"is_red":false,"text":"Cracks / Holes (1/4\" or less) present in: foundation / floor / ext. wall. Consider sealing them to prevent water infiltration. Generally speaking, cracks that are less than 1/4\" are not commonly regarded as being structurally significant. "},{"checked":false,"id":1,"is_red":false,"text":"Cracks / Holes (1/4\" to 3/4\") present in: foundation / ext. wall. These may be a structural concern.  If in doubt, consider having a structural engineer evaluate the integrity of the structure. At a minimum, recommend sealing cracks to prevent water infiltration."},{"checked":false,"id":1,"is_red":false,"text":"Cracks more than 3/4\".  Recommend having a contractor or structural engineer evaluate and repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Pressure bulge in wall indicates excessive forces are being applied to the exterior side."}],"sepChoice":"4","title":"Foundation Walls"},{"descr":"","id":2173,"options":[{"checked":false,"id":1,"is_red":false,"text":"Concrete block/wood piers support floor above."},{"checked":false,"id":1,"is_red":false,"text":"Foundation supports for most of the house are not visible for inspection. Consider consulting a contractor or structural engineer. "},{"checked":false,"id":1,"is_red":false,"text":"Recommend contacting a qualified contractor to evaluate and offer repair options."},{"checked":false,"id":1,"is_red":false,"text":"Apparent support post(s) at basement entry appears deteriorated.  Recommend contractor evaluation. "}],"sepChoice":"4","title":"Cripple Walls"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Foundation Walls Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Cripple Walls Overall"}],"title":"Foundation Walls"},{"damage_panels":[{"descr":"","id":2167,"options":[{"checked":false,"id":1,"is_red":false,"text":"No venting observed. Recommend contacting a qualified contractor to install venting."},{"checked":false,"id":1,"is_red":false,"text":"Screened openings noted."},{"checked":false,"id":1,"is_red":false,"text":"Grade above vent(s) will direct water into structure."},{"checked":false,"id":1,"is_red":false,"text":"Inadequate venting observed in crawlspace, suggest installing additional vents for proper moisture control."},{"checked":false,"id":1,"is_red":false,"text":"Suggest installing vents for proper moisture control."},{"checked":false,"id":1,"is_red":false,"text":"Soil should be removed from vicinity of vents."}],"sepChoice":"4","title":"Ventilation"},{"descr":"","id":2168,"options":[{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as functional."},{"checked":false,"id":1,"is_red":false,"text":"Suggest repair or replacing vent screens."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens are damaged or missing, suggest repairing or replacing screens as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as missing."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as torn."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as bent."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as blocked."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as restricted."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as loose."},{"checked":false,"id":1,"is_red":false,"text":"Vent screens noted as sealed off."}],"sepChoice":"4","title":"Vent Screens"},{"descr":"","id":2169,"options":[{"checked":false,"id":1,"is_red":false,"text":"The foundation access panel  installed and functional during the inspection."},{"checked":false,"id":1,"is_red":false,"text":"The exterior crawlspace access was missing a cover. We recommend installing a cover with a screen to assist in ventilating the space."},{"checked":false,"id":1,"is_red":false,"text":"Could not access the crawlspace,there was limited space for entry."},{"checked":false,"id":1,"is_red":false,"text":"Access pane sealed shut. Could not gain entry."},{"checked":false,"id":1,"is_red":false,"text":"There appears to be no means of access to the crawlspace."},{"checked":false,"id":1,"is_red":false,"text":"Could not access due to the presence of rodents."},{"checked":false,"id":1,"is_red":false,"text":"Could not access the Crawlspace due to roaches."},{"checked":false,"id":1,"is_red":false,"text":"Could not access the crawlspace due to fleas."},{"checked":false,"id":1,"is_red":false,"text":"Could not access the crawlspace due to animal debris present."},{"checked":false,"id":1,"is_red":false,"text":"Recommend at least 18 inches of clear access to gain entry."},{"checked":false,"id":1,"is_red":false,"text":"Limited inspection from the access area only."}],"sepChoice":"4","title":"Access Panel"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Ventilation Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Vent Screens Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Access Panel Overall"}],"title":"Foundation Ventilation"},{"damage_panels":[{"descr":"","id":2170,"options":[{"checked":false,"id":1,"is_red":false,"text":"Support Material: Wood/Bearing Wall"},{"checked":false,"id":1,"is_red":false,"text":"Support Material: Steel"},{"checked":false,"id":1,"is_red":false,"text":"Support Material: concrete block piers"},{"checked":false,"id":1,"is_red":false,"text":"Support Material:  Block Pillars"},{"checked":false,"id":1,"is_red":false,"text":"Beam Material:  Wood"},{"checked":false,"id":1,"is_red":false,"text":"Beam Material:  Steel"},{"checked":false,"id":1,"is_red":false,"text":"Steel I-Beams and Posts"},{"checked":false,"id":1,"is_red":false,"text":"Steel I-Beams and steel post/columns"},{"checked":false,"id":1,"is_red":false,"text":"Steel screw Jacks"},{"checked":false,"id":1,"is_red":false,"text":"Steel lally columns"},{"checked":false,"id":1,"is_red":false,"text":"Concrete piers"},{"checked":false,"id":1,"is_red":false,"text":"Brick piers"},{"checked":false,"id":1,"is_red":false,"text":"Concrete block/wood piers support floor above."},{"checked":false,"id":1,"is_red":false,"text":"Foundation supports for most of the house are not visible for inspection. Consider consulting a contractor or structural engineer. "},{"checked":false,"id":1,"is_red":false,"text":"Apparent support post(s) at basement entry appears deteriorated.  Recommend contractor evaluation. "},{"checked":false,"id":1,"is_red":false,"text":"Posts are finished or concealed, unable to inspect."},{"checked":false,"id":1,"is_red":false,"text":"Posts and beams are partially finished, unable to fully inspect."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified professional for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Screw jacks are usually intended as temporary supports, recommend installing permanent support posts for safety."},{"checked":false,"id":1,"is_red":false,"text":"Support framework should not be altered as it is a vital component of overall structure."},{"checked":false,"id":1,"is_red":false,"text":"Beams are finished, unable to inspect."},{"checked":false,"id":1,"is_red":false,"text":"Beams are improperly cut."},{"checked":false,"id":1,"is_red":false,"text":"Beams are partially finished, unable to fully inspect."},{"checked":false,"id":1,"is_red":false,"text":"Beams are sagging."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of repair observed, unable to determine effectiveness of repair."},{"checked":false,"id":1,"is_red":false,"text":"Excessive cracking or splitting observed."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified professional for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Rotted wood and debris was observed at various areas of the crawl space. Have entire crawl reviewed and repair or replace all damaged or rotted wood."},{"checked":false,"id":1,"is_red":false,"text":"No deficiencies were observed at the visible portions of the structural components of the home. See Limitations."},{"checked":false,"id":1,"is_red":false,"text":"No deficiencies were observed at the visible portions of the structural components of the home."},{"checked":false,"id":1,"is_red":false,"text":"Columns are finished or concealed, unable to inspect."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of repair observed, unable to determine effectiveness of repair."},{"checked":false,"id":1,"is_red":false,"text":"Excessive cracking or splitting observed."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified professional for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Unable to determine."},{"checked":false,"id":1,"is_red":false,"text":"No deficiencies observed."},{"checked":false,"id":1,"is_red":false,"text":"Steel column top flanges are not spot welded or bolted to the steel beams."},{"checked":false,"id":1,"is_red":false,"text":"Most of the walls and ceilings in the finished basement are covered and structural members are not visible. No visible deficiencies noted. I could not see behind these coverings."}],"sepChoice":"4","title":"Post and Girders"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Post and Girders Overall"}],"title":"Posts and Girders"},{"damage_panels":[{"descr":"","id":2171,"options":[{"checked":false,"id":1,"is_red":false,"text":"**DECKING**"},{"checked":false,"id":1,"is_red":false,"text":"Plywood sheathing sub floor."},{"checked":false,"id":1,"is_red":false,"text":"OSB (Oriented Strand Board) sheathing sub floor"},{"checked":false,"id":1,"is_red":false,"text":"Diagonal plank subfloor noted."},{"checked":false,"id":1,"is_red":false,"text":"**FRAMING**"},{"checked":false,"id":1,"is_red":false,"text":"Dimensional lumber wood Joists"},{"checked":false,"id":1,"is_red":false,"text":"Wood floor trusses noted."},{"checked":false,"id":1,"is_red":false,"text":"Engineered wood truss floor joists"},{"checked":false,"id":1,"is_red":false,"text":"Prefabricated Wood I-Joists"},{"checked":false,"id":1,"is_red":false,"text":"Metal trusses noted."},{"checked":false,"id":1,"is_red":false,"text":"Laminated Veneer"},{"checked":false,"id":1,"is_red":false,"text":"Prefabricated wood with metal cross-bar truss"},{"checked":false,"id":1,"is_red":false,"text":"Steel I-frame Joists"},{"checked":false,"id":1,"is_red":false,"text":"Limited review only in utility room due to 90% finished ceiling in basement."},{"checked":false,"id":1,"is_red":false,"text":"Limited review only in small utility room due to 95% finished ceiling in lower level."},{"checked":false,"id":1,"is_red":false,"text":"Not visible to inspect due to complete finished ceilings. See Limitations."},{"checked":false,"id":1,"is_red":false,"text":"Visible areas appear satisfactory at the time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"An excellent non-chemical 100% all natural enzyme cleaner:  http://www.SporiCLEAN.com/"},{"checked":false,"id":1,"is_red":false,"text":"Advise review and cost estimates by a qualified contractor."},{"checked":false,"id":1,"is_red":false,"text":"No leaks were observed at the time of the inspection."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified professional for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Wood rot, moisture damage observed "},{"checked":false,"id":1,"is_red":false,"text":"The area below the whirlpool tub appears to be poorly supported. Advise further review by construction/framing contractor."},{"checked":false,"id":1,"is_red":false,"text":"The floor slopes at the south side of the home. Have the sub floor reviewed in the crawl area for proper support."},{"checked":false,"id":1,"is_red":false,"text":"One of the wood joists under the steps as viewed from underneath was stained. Recommend removing stain."},{"checked":false,"id":1,"is_red":false,"text":"Mold-like bio growth staining observed at various areas of the wood joist sub floor. This is due to high humidity and poor exterior grading. Professional testing & evaluation advised."},{"checked":false,"id":1,"is_red":false,"text":"Mold-like bio growth observed. Professional testing & evaluation advised."},{"checked":false,"id":1,"is_red":false,"text":"Notches in top or bottom of joist to be maximum of 1/6 joist depth and are not allowed in the middle third of the span."},{"checked":false,"id":1,"is_red":false,"text":"Maximum notch depth at end of joist: 1/4 joist depth"},{"checked":false,"id":1,"is_red":false,"text":"Maximum hole diameter: 1/3 joist depth"},{"checked":false,"id":1,"is_red":false,"text":"Improper construction practices observed at one or more floor joist noted, Recommend review and repair by a Qualified Contractor to provide proper support to load bearing floor system."},{"checked":false,"id":1,"is_red":false,"text":"Deterioration/ damage of one or more floor joist noted, Recommend review and repair by a Qualified Contractor to evaluate load bearing members."},{"checked":false,"id":1,"is_red":false,"text":"Floor joists not properly supported at load bearing points. Installation of joist hanger's or other means of support are needed. Recommend review and repair by a qualified contractor. "},{"checked":false,"id":1,"is_red":false,"text":"Some areas are not visible for inspection due to wall/ceilings covered which prevents review of all  structural members."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review of floor support system by a qualified contractor for any repair or upgrades needed to structure.\n"},{"checked":false,"id":1,"is_red":false,"text":"Visible evidence of Wood Destroying Organisms observed. Recommend obtaining a termite inspection to confirm that no active infestation exists."},{"checked":false,"id":1,"is_red":false,"text":"Support beam lacks the proper 1/2 inch clearance around beam that is required by current building standards, recommend review and repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Damage from what appears to be caused by Wood Destroying Organisms is noted, Recommend review of support structure by a Qualified Contractor."},{"checked":false,"id":1,"is_red":false,"text":"Improper/insufficient repairs or upgrades are noted at support posts/joists. Further review for repairs and cost estimates are recommended to be performed by qualified contractors."},{"checked":false,"id":1,"is_red":false,"text":"Floor joist appear to be over spaces for proper support. Current building standards consist 16 inch spacing between joists. Recommend further review for repairs and costs."},{"checked":false,"id":1,"is_red":false,"text":"Not fully visible for inspection due to lack of access to all areas."},{"checked":false,"id":1,"is_red":false,"text":"Damaged or cracked floor joist is in need of repair/replacement by a qualified contractor."},{"checked":false,"id":1,"is_red":false,"text":"Support post/blocks appear to lack proper footing to support load, Review by a qualified foundation contractor is recommended."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of what appears to be consistant with carpenter ant damage was noted at one or more locations, recommend further review by a qualified Wood Destroying Organism Contractor to assure that no current infestation is present."}],"sepChoice":"4","title":"Sub Flooring"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Sub Flooring Overall"}],"title":"Sub Flooring"},{"damage_panels":[{"descr":"","id":2174,"options":[{"checked":false,"id":1,"is_red":false,"text":"The anchor bolts were not visible."},{"checked":false,"id":1,"is_red":false,"text":"The anchor bolts were not visible, obscured by drywall."},{"checked":false,"id":1,"is_red":false,"text":"The anchor bolts were not visible obscured by insulation."},{"checked":false,"id":1,"is_red":false,"text":"The anchor bolte were inspected and appear to be serviceable."},{"checked":false,"id":1,"is_red":false,"text":"Anchor straps noted."},{"checked":false,"id":1,"is_red":false,"text":"Some of the anchor bolts were missing nuts. We recommend replacing the missing nuts and tighten."},{"checked":false,"id":1,"is_red":false,"text":"There are what appears to be retro fitted anchor bolts noted."},{"checked":false,"id":1,"is_red":false,"text":"We recommend retrofit style anchor bolts where necessary."},{"checked":false,"id":1,"is_red":false,"text":"The builder used masonry or \"cut\" nails to attach the bottom plates to the foundation wall. We recommend adding retrofit style anchor bolts as necessary."}],"sepChoice":"4","title":"Anchor Bolts"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Anchor Bolts Overall"}],"title":"Anchor Bolts"},{"damage_panels":[{"descr":"","id":2176,"options":[{"checked":false,"id":1,"is_red":false,"text":"3-way switch is inoperable, improperly connected, recommend review for repair."},{"checked":false,"id":1,"is_red":false,"text":"All wiring should be properly secured to the framing."},{"checked":false,"id":1,"is_red":false,"text":"Cut live wire should be corrected for safety."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of amateur wiring noted. "},{"checked":false,"id":1,"is_red":false,"text":"Exposed electrical wiring observed. This is a safety concern if used where it could be subject to \"Physical Damage\". Exposed electrical wires are normally encased in conduit to ensure safety. Client should consult with a licensed electrician prior to closing for repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Extension cord improperly used as permanent wiring. Extension cords should not be used for permanent wiring due to fire safety concerns. Client should consider review by a licensed electrician prior to closing for installation of proper electrical wiring and receptacles to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Frayed wiring should be replaced."},{"checked":false,"id":1,"is_red":false,"text":"GFCI did not respond to test, suggest replacing for safety."},{"checked":false,"id":1,"is_red":false,"text":"GFCI had power when tripped.  This is often the result of miswiring and is usually easily fixed.  Advise repair on replacement as needed."},{"checked":false,"id":1,"is_red":false,"text":"Ground Fault Circuit Interrupters (GFCI) were not required when the home was built. Suggest client consider upgrading with GFCI's at all receptacles near water sources, such as the kitchen, the bathrooms, the garage, and exterior receptacles to enhance safety. Upgrades should be performed by a licensed electrician."},{"checked":false,"id":1,"is_red":false,"text":"Incomplete wiring noted in basement.  Recommend completion and/or final inspection by a qualified electrical contractor to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Insulation has been installed over knob and tube wiring at various locations. This is a fire \"Safety Concern\". Suggest review by a licensed electrician prior to closing to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Knob and tube wiring noted.  See Electrical Section."},{"checked":false,"id":1,"is_red":false,"text":"Light fixture inoperative at time of inspection. Possible spent bulb. Suggest client verify fixture for proper operation prior to closing."},{"checked":false,"id":1,"is_red":false,"text":"Loose hanging light fixture observed, suggest repairing for safety."},{"checked":false,"id":1,"is_red":false,"text":"Loose hanging receptacle observed, suggest repairing for safety."},{"checked":false,"id":1,"is_red":false,"text":"Missing pullchain observed, recommend review for repair."},{"checked":false,"id":1,"is_red":false,"text":"Open junction boxes were observed. Whenever an electric wire is cut and reconnected, the 'splice' should be encased in a covered junction box to prevent shocks and separation of the splice."},{"checked":false,"id":1,"is_red":false,"text":"Open junction box observed. Whenever an electric wire is cut and reconnected, the 'splice' should be encased in a covered junction box to prevent shocks and separation of the splice."},{"checked":false,"id":1,"is_red":false,"text":"Open splices were observed. This is a \"Safety Concern\". Whenever an electric wire is cut and reconnected, the \"splice\" should be encased in a covered \"junction box\" to prevent shocks and separation of the splice. Client is advised to consult with a licensed electrician prior to closing for repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Receptacle covers missing, recommend replacing for safety."},{"checked":false,"id":1,"is_red":false,"text":"Receptacle is inoperable, may be switch controlled."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Reversed polarity observed, recommend review for repair as necessary."},{"checked":false,"id":1,"is_red":false,"text":"The electrical system is an older non-grounded 2-wire system. This was common practice when this house was built. Due to safety concerns, it is suggested client consider upgrading to a new 3-wire grounded system with GFCI protection to enhance electrical safety. A review by a licensed electrician prior to closing for upgrading the electrical system is suggested."},{"checked":false,"id":1,"is_red":false,"text":"This home is equipped with a central vacuum system which is outside the scope of this inspection and was not tested. Recommend client confirm proper operation prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Ungrounded receptacle observed, suggest installing GFCI receptacle for safety."},{"checked":false,"id":1,"is_red":false,"text":"Ungrounded three prong receptacles observed. It is recommended that these type of receptacles be grounded, replaced with two prong receptacles, or protected on a GFCI circuits as applicable. Suggest review by licensed electrical contractor for repairs/replacements as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Wiring on the ground is a hazard that should be corrected."},{"checked":false,"id":1,"is_red":false,"text":"We recommend that a licensed electrician evaluate the electrical system, especially the area around the crawlspace well controls, as there appears to be a dropped grounding connection."}],"sepChoice":"4","title":"Foundation Electrical"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Foundation Electrical Overall"}],"title":"Foundation Electrical"},{"damage_panels":[{"descr":"","id":2177,"options":[{"checked":false,"id":1,"is_red":false,"text":"**SUPPLY**"},{"checked":false,"id":1,"is_red":false,"text":"3/4 inch copper"},{"checked":false,"id":1,"is_red":false,"text":"1 inch Copper"},{"checked":false,"id":1,"is_red":false,"text":"3/4 inch Galvanized"},{"checked":false,"id":1,"is_red":false,"text":"1+ inch galvanized\n\n"},{"checked":false,"id":1,"is_red":false,"text":"1+ inch PVC"},{"checked":false,"id":1,"is_red":false,"text":"Galvanized supply pipe noted."},{"checked":false,"id":1,"is_red":false,"text":"Not determined"},{"checked":false,"id":1,"is_red":false,"text":"Not visible for identification."},{"checked":false,"id":1,"is_red":false,"text":"**DRAIN, WASTE, VENT**"},{"checked":false,"id":1,"is_red":false,"text":"Poly Vinyl Chloride \"PVC\" waste and vent pipes noted."},{"checked":false,"id":1,"is_red":false,"text":"Acrylonitrile-Butadiene-Stryrene \"ABS\" waste and vent pipes noted."},{"checked":false,"id":1,"is_red":false,"text":"Cast iron waste and vent pipe noted."},{"checked":false,"id":1,"is_red":false,"text":"Copper waste and vent pipes noted."},{"checked":false,"id":1,"is_red":false,"text":"Galvanized waste and vent pipes noted."},{"checked":false,"id":1,"is_red":false,"text":"**OBSERVATIONS**"},{"checked":false,"id":1,"is_red":false,"text":"Appears Functional at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Water shut off location shown to client in the event of an emergency."},{"checked":false,"id":1,"is_red":false,"text":"See photo for main water shut off valve location.<FYI> Future reference in the event of an emergency."},{"checked":false,"id":1,"is_red":false,"text":"Gate valve present, this type of valve has a history of failure with age. Recommend monitor valve for leaks and upgrading to a ball type valve by a Qualified Plumber if leaking is observed."},{"checked":false,"id":1,"is_red":false,"text":"Poly Vinyl Chloride \"PVC\" plumbing was observed and is not an approved material for domestic water supply use in all locations. Most local building authorities allow PVC and Polyethylene piping in cold water distribution and ONLY outside the building. Recommend further review and repairs by a Qualified Plumbing Contractor familiar with local building regulations."},{"checked":false,"id":1,"is_red":false,"text":"Home winterized, not able to inspect system at time of inspection recommend complete review before closing date."},{"checked":false,"id":1,"is_red":false,"text":"Galvanized pipes present and has an average service life of 30 years. Pipes rust from the inside reducing the diameter and causing loss of pressure and rust in water. Recommend budgeting for replacement of galvanized piping in the near future.\n"},{"checked":false,"id":1,"is_red":false,"text":"Water meter is located in a poor location that prevents clear working space for review and repair of plumbing system."},{"checked":false,"id":1,"is_red":false,"text":"Galvanized and Copper plumbing pipes noted. Copper and galvanized are considered dissimilar metals and over time accelerated corrosion will occur to the galvanized pipe even with a dielectric union present. Minerals in the water provide continuity for electrolysis to occur allowing galvanic reaction to deteriorate the galvanized pipes. Recommend replacement of galvanized pipe by a qualified plumber to prevent leaks due to accelerated corrosion of pipes."},{"checked":false,"id":1,"is_red":false,"text":"Home is winterized making inspection of water supply and drain lines impossible. Recommend testing all supply and drain lines for possible leakage before the close of escrow"},{"checked":false,"id":1,"is_red":false,"text":"Copper line is not protected from concrete, Ideally a plastic sleeve is recommended around pipe before pouring of slab to prevent damage if settlement of concrete should occur.<FYI>"},{"checked":false,"id":1,"is_red":false,"text":"Leaking observed and needs immediate repair by a qualified Plumbing Contractor to prevent unwanted moisture in living space."},{"checked":false,"id":1,"is_red":false,"text":"Unprofessional repair noted at one or more locations noted, recommend review and repairs by a Qualified Plumber."},{"checked":false,"id":1,"is_red":false,"text":"Note that heaters are located in crawlspace, presumably to prevent pipes from freezing.  Check with sellers regarding operation."},{"checked":false,"id":1,"is_red":false,"text":"Improper plumbing cap installed; recommend having properly glued plumbing cap installed by plumber.  See photo"},{"checked":false,"id":1,"is_red":false,"text":"Home winterized, not able to inspect system at time of inspection recommend complete review before closing date."},{"checked":false,"id":1,"is_red":false,"text":"Drain lines appear to lack proper support, recommend adding support hangers."},{"checked":false,"id":1,"is_red":false,"text":"Inspection of all areas of the drain pipes was not possible due to limited access/finshed walls and ceilings to check for defects such as, but not limited too:leaks, corrosion, improper workmanship, and damage."},{"checked":false,"id":1,"is_red":false,"text":"Vent and Drain lines are not fully visible for inspection due to finished walls/ceiling preventing full view of plumbing."},{"checked":false,"id":1,"is_red":false,"text":"S-trap observed at one or more locations. This type of drain is no longer allowed in current building practice due to the potential for water to be siphoned out of trap, allowing sewer gas to enter structure. If sewer gas is detected, first try slowly running water down drain to refill trap assembly. If problem continues consult with a qualified plumber for review and repair."},{"checked":false,"id":1,"is_red":false,"text":"Active leak observed at one or more drain pipe/s. Recommend review and repair by a Qualified Plumber."},{"checked":false,"id":1,"is_red":false,"text":"Broken/damaged/rusted drain line noted at time of inspection, recommend review and repair by a qualified plumber."},{"checked":false,"id":1,"is_red":false,"text":"Water off to structure which prevents testing of drain lines for clogs and leaks. Recommend having all drains tested before the close of escrow to confirm that no leaks are present."},{"checked":false,"id":1,"is_red":false,"text":"Floor drains observed but not tested for proper operation."},{"checked":false,"id":1,"is_red":false,"text":"Cast iron drain lines have a life expectancy of 30-50 years. Recommend budgeting for replacement in the near future at areas where rust cysts are visible, BEFORE leaks occur."},{"checked":false,"id":1,"is_red":false,"text":"Open sewer drain line observed, recommend repairs be performed by qualified plumbing contractors"},{"checked":false,"id":1,"is_red":false,"text":"Corrosion/cysts were noted as one or more locations of the metal drain lines. Repairs recommended to be performed by a Qualified Plumber.\n"},{"checked":false,"id":1,"is_red":false,"text":"Evidence of leakage detected and requires review and repair by a qualified plumbing contractor."},{"checked":false,"id":1,"is_red":false,"text":"Water softener drain line exits through wall to an UNKNOWN location, recommend review and repair as needed. "},{"checked":false,"id":1,"is_red":false,"text":"Water softener drain line exits through floor/wall under structure, recommend review and repair to prevent unwanted water under structure. "},{"checked":false,"id":1,"is_red":false,"text":"Improper combination of dissimilar plastic drain pipe observed. There is no way to confirm that the use of a special PVC to ABS cement was used, most local building officials prohibit the combination of different types of plastic piping. Review and repair is recommended by a Qualified Plumber."},{"checked":false,"id":1,"is_red":false,"text":"Previous repairs are noted and recommend review of repairs to confirm that all work was performed according to current building standards."},{"checked":false,"id":1,"is_red":false,"text":"Improper drain line venting observed and is in need of repair by a Qualified Plumber at:"},{"checked":false,"id":1,"is_red":false,"text":"Please see www.toolbase.org/Technology-Inventory/Plumbing/air-admittance-valves \nfor further information on one of several repair techniques available as a repair option."},{"checked":false,"id":1,"is_red":false,"text":"Water to home was off at time of inspection. Could not test drain lines for slow drains or leaks. Recommend evaluation of drain lines before the close of escrow."},{"checked":false,"id":1,"is_red":false,"text":"Unprofessional work noted at one or more locations noted, recommend review and repairs by a qualified plumber to assure proper drain line function."},{"checked":false,"id":1,"is_red":false,"text":"Vent pipe appears to be undersized. Recommend review and repairs as needed by a Qualified Plumber."},{"checked":false,"id":1,"is_red":false,"text":"Drain line materials are improper, 90* fittings are subject to clogging and should be upgraded with the proper sweep type of fittings. Recommend review and replacement with proper drain fittings by a Qualified Plumber."},{"checked":false,"id":1,"is_red":false,"text":"Drain line appears to be improperly pitched 1/4\" per foot towards drain, recommend review and repair by a Qualified plumber."},{"checked":false,"id":1,"is_red":false,"text":"Old style \"Drum Trap\" noted at one or more tub drains. This type of drain is considered a poor design and is known for clogging and rusting out at the bottom, recommend review by a Qualified Plumber and ugrading before issues arise."},{"checked":false,"id":1,"is_red":false,"text":"Non typical installation of an Air Admittance Valve noted. Recommend further review by a Qualified Plumber familiar with current building standards. Air Admittance Valves are installed at a fixture above the drain pipe to allow proper  flow function on a section of the drain system that is isolated/not connected to the roof vent pipe."},{"checked":false,"id":1,"is_red":false,"text":"Venting system does not appear to be proper at one or more locations. Recommend review and repairs by a Qualified Plumbing Contractor."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of past leaking noted."},{"checked":false,"id":1,"is_red":false,"text":"Not fully visible for inspection due to insulation/limited view of material."},{"checked":false,"id":1,"is_red":false,"text":"Could not locate water shutoff location, recommend further review to locate in the event of an emergency."}],"sepChoice":"4","title":"Foundation Plumbing"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Foundation Plumbing Overall"}],"title":"Foundation Plumbing"},{"damage_panels":[{"descr":"","id":2250,"options":[{"checked":false,"id":1,"is_red":false,"text":"**SUMP PUMP**"},{"checked":false,"id":1,"is_red":false,"text":"Evidence of one sump pump and basin installed in basement. Pump was not readily visible."},{"checked":false,"id":1,"is_red":false,"text":"Appears to be a combination use sump pit."},{"checked":false,"id":1,"is_red":false,"text":"Battery backup present."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the sump pump is near the end of its useful life due to deterioration."},{"checked":false,"id":1,"is_red":false,"text":"Inoperable at the time of inspection. Recommend review by a licensed plumber for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Leak observed at the check valve connections."},{"checked":false,"id":1,"is_red":false,"text":"Pump was activated at the time of inspection, we suggest you verify operation prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a licensed plumber for repair or replacement, as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Sump pit cover is missing, suggest installing cover for safety."},{"checked":false,"id":1,"is_red":false,"text":"Sump pump appears to drain to the sanitary sewer."},{"checked":false,"id":1,"is_red":false,"text":"Sump pump appears to drain to the storm sewer."},{"checked":false,"id":1,"is_red":false,"text":"Sump pump is improperly wired with an extension cord, suggest installing a dedicated receptacle for safety."},{"checked":false,"id":1,"is_red":false,"text":"This may not be allowed by local standards. We recommend review of the local standards with the proper authorities, and repair as necessary."},{"checked":false,"id":1,"is_red":false,"text":"**PIT AND PLUMBING**"},{"checked":false,"id":1,"is_red":false,"text":"Suggest cleaning pump and pit"},{"checked":false,"id":1,"is_red":false,"text":"Suggest securing cover."},{"checked":false,"id":1,"is_red":false,"text":"Unable to test due to a sealed pit with no external switch. Recommend client confirm proper operation prior to close."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the sump plumbing is near the end of its useful life due to deterioration."},{"checked":false,"id":1,"is_red":false,"text":"Plumbing is loose; correction advised."},{"checked":false,"id":1,"is_red":false,"text":"Recommend routing discharge away from foundation to reduce the chance of water re-entry."},{"checked":false,"id":1,"is_red":false,"text":"Unable to determine location of discharge."},{"checked":false,"id":1,"is_red":false,"text":"The sump pump did not operate when tested. Possibly backup & flooding could occur. Recommend a qualified professional repair or replace the pump."},{"checked":false,"id":1,"is_red":false,"text":"The sump pump did not operate when tested."},{"checked":false,"id":1,"is_red":false,"text":"Lid damaged - service/inspection access ring broken--needs replacement "},{"checked":false,"id":1,"is_red":false,"text":"DEFERRED COST: Pumps have a 3-7 year life expectancy."},{"checked":false,"id":1,"is_red":false,"text":"Sump pump basin was totally dry and evidence that it has been dry for sometime.  Pump not tested. "},{"checked":false,"id":1,"is_red":false,"text":"A sump pump has been installed to augment drainage. The pump is equipped with an anti-backflow device and appears to be properly plumbed and wired. We checked to ensure the system is operational by lifting the float and noted that the pump came on. Though the device appears to be installed correctly and came on when tested--we did not test the system by flooding it so we cannot  say how much water it is capable of pumping within a given time frame or guarantee it will work when needed. If further analysis of this device is desired, recommend consulting a drainage specialist."},{"checked":false,"id":1,"is_red":false,"text":"Sump pump not accessible. Behind framed drywall compartment. "},{"checked":false,"id":1,"is_red":false,"text":"No sump pump installed."}],"sepChoice":"4","title":"Sump Pump"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Sump Pump Overall"}],"title":"Sump Pump"},{"damage_panels":[{"descr":"","id":2178,"options":[{"checked":false,"id":1,"is_red":false,"text":"No deficiencies were observed at the visible portions of the structural components of the home."},{"checked":false,"id":1,"is_red":false,"text":"Monitor:  In-slab ducts are subject to, and prone to water intrusion."},{"checked":false,"id":1,"is_red":false,"text":"Improper duct tape observed. HVAC tape is needed."},{"checked":false,"id":1,"is_red":false,"text":"Appeared functional, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Recommend using insulated ductwork in unconditioned spaces to prevent condensation from accumulating which could present potential mold issues in the ductwork or on the insulation."},{"checked":false,"id":1,"is_red":false,"text":"Recommend sealing all gaps, cracks and holes in the HVAC duct system for increased efficiency and lower energy bills."},{"checked":false,"id":1,"is_red":false,"text":"Heat ducts are wrapped with materials consistant with that containing asbestos which is a know cancer causing material. If in good condition and left undisturbed this material causes no need for alarm. Proper handling and abatement by Qualified contractors is recommended if repairs or upgrades are performed. "},{"checked":false,"id":1,"is_red":false,"text":"Asbestos \"type\" tape is noted to be in poor condition and should only be removed by a professional abatement contractor, due to the possible health hazards that exist."},{"checked":false,"id":1,"is_red":false,"text":"Home's heating and cooling duct system needs review and repair by a qualified Contractor."},{"checked":false,"id":1,"is_red":false,"text":"One or more areas of the heat ductwork is damaged/deteriorated/not attached. Recommend review and repairs by a qualified HVAC contractor to enhance homes heating efficiency."},{"checked":false,"id":1,"is_red":false,"text":"Galvanized duct pipe is in direct contact with copper water supply line. Over time a hole will develop in the galvanized pipe due to a chemical reaction known as galvanic reaction. Recommend seperation of the two dissimilar metals."},{"checked":false,"id":1,"is_red":false,"text":"Unprofessional use of foil duct piping noted at one or more locations, this is an inferior product and recommend review and upgrading to a metal galvanized pipe by a qualified heating contractor."},{"checked":false,"id":1,"is_red":false,"text":"Recommend further support to ductwork."},{"checked":false,"id":1,"is_red":false,"text":"Return air duct does not appear to properly connect to return plenum, further review and repair recommended."},{"checked":false,"id":1,"is_red":false,"text":"Cold air return intake observed near unit, which may result in backdrafting and mixing of combustion byproducts with interior circulation air.  This is a safety concern."},{"checked":false,"id":1,"is_red":false,"text":"Ducts were loose in areas; advise securing."},{"checked":false,"id":1,"is_red":false,"text":"No cold air return observed in finished basement, which may result in inadequate heating in this area."},{"checked":false,"id":1,"is_red":false,"text":"Possible asbestos materials observed. The materials appeared to be in serviceable condition at the time of inspection. Asbestos materials are considered safe by the EPA if they are not disturbed, torn, ripped, or damaged. No torn, ripped, or damaged materials were observed. If client has any concerns regarding asbestos materials, an asbestos testing lab should be consulted for further review to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Possible asbestos materials observed. The materials were torn, ripped, or damaged at the time of inspection. This is a possible safety hazard. Suggest further review by a licensed asbestos testing lab be performed prior to closing for repairs/replacement needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a licensed heating contractor for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Very limited review of ductwork due to basement finish."},{"checked":false,"id":1,"is_red":false,"text":"In Slab Ducts noted."},{"checked":false,"id":1,"is_red":false,"text":"Galvanized sheet metal ductwork noted."}],"sepChoice":"4","title":"Ducting"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Ducting Overall"}],"title":"Ducting"}],"title":"Foundation"},{"id":7,"tabbed_panels":[{"damage_panels":[{"descr":"","id":2142,"options":[{"checked":false,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Clean roof areas:  Significant amounts of organic debris evident."},{"checked":false,"id":1,"is_red":false,"text":"Moss on roof. This can lead to the premature failure of the roof and subsequent leaks. Recommend treating moss during its growing season (wet months) with a moss killer. For information on various moss treatment products and their pros and cons, visit http://bryophytes.science.oregonstate.edu/page24.htm.  "},{"checked":false,"id":1,"is_red":false,"text":"Snow covered; not fully inspected."},{"checked":false,"id":1,"is_red":false,"text":"Ridge cap: deteriorated or missing shingles. "},{"checked":false,"id":1,"is_red":false,"text":"Some shingles damaged."},{"checked":false,"id":1,"is_red":false,"text":"Some shingles &/or tabs missing."},{"checked":false,"id":1,"is_red":false,"text":"Some shingles curling."},{"checked":false,"id":1,"is_red":false,"text":"Sagging / buckling on roof decking. "},{"checked":false,"id":1,"is_red":false,"text":"Exposed nails on roofing material. Recommend sealing all fastener heads."},{"checked":false,"id":1,"is_red":false,"text":"Roof ventilation may be inadequate; this may contribute to premature roof failure, conducive conditions for mold growth in attic, and/or high heating / cooling bills.  Consider further evaluation by qualified contractor."},{"checked":false,"id":1,"is_red":false,"text":"Semi-flat roof area should be kept clean to avoid leaks, snow loading or ice damming."},{"checked":false,"id":1,"is_red":false,"text":"Slope-slope, slope-wall or slope-semi flat roof design at @@@@   Recommend keeping this area clean to avoid leaks or ice damming."},{"checked":false,"id":1,"is_red":false,"text":"Siding-Roof Contact: Check for moisture damage.  Recommend a 1\" gap between the siding and the roofing below where necessary."},{"checked":false,"id":1,"is_red":false,"text":"Flashing appears inadequate; see photo. "},{"checked":false,"id":1,"is_red":false,"text":"Missing plumbing vent pipe; these are necessary for sanitary and smooth flow of the system."},{"checked":false,"id":1,"is_red":false,"text":"Partially snow covered, not fully inspected. "},{"checked":false,"id":1,"is_red":false,"text":"Exposed plywood."},{"checked":false,"id":1,"is_red":false,"text":"Damaged by tree."},{"checked":false,"id":1,"is_red":false,"text":"No \"Cricket\" (a small ridged roof section just above the chimney to shed water off to the sides) is installed above the (wider than 2’) chimney. Keep clean of any accumulated debris which may cause leaks. "},{"checked":false,"id":1,"is_red":false,"text":"Serviceability of roof is questionable; it should be evaluated and repaired as necessary by a professional roofing contractor."},{"checked":false,"id":1,"is_red":false,"text":"Wood Shake Roof: Consider professional evaluation and cleaning, and possibly having a preservative applied. "},{"checked":false,"id":1,"is_red":false,"text":"Some wood shakes missing / damaged / nails lifting."},{"checked":false,"id":1,"is_red":false,"text":"Some areas roofed by plastic or fiberglass panels; monitor for leaks or accumulated debris."},{"checked":false,"id":1,"is_red":false,"text":"Some areas not visible from inspection level."},{"checked":false,"id":1,"is_red":false,"text":"Ponding noted in some areas."},{"checked":false,"id":1,"is_red":false,"text":"Recommend roofing contractor to evaluate."},{"checked":false,"id":1,"is_red":false,"text":"Antennae damaged; see photo."},{"checked":false,"id":1,"is_red":false,"text":"Porch roof sagging."},{"checked":false,"id":1,"is_red":false,"text":"Note that experts recommend that any roof over 10 years old receive a roof certification by a local roofing specialist. "},{"checked":false,"id":1,"is_red":false,"text":"Indications of past or present water leaks, seeps, or condensation at eaves."},{"checked":false,"id":1,"is_red":false,"text":"Inspectors observed roofs being shoveled in the neighborhood at time of inspection.  With the numerous peaks and valleys on this home's roof design, we recommend that the roof be evaluated for snow load and clearing in the immediate future as more snow is predicted.  Buildings constructed with building permits are generally designed to carry a snow load of 40 lbs per square foot.  We recommend that you monitor the snow load on your roof during North Idaho winters and have the roof cleared as necessary. "},{"checked":false,"id":1,"is_red":false,"text":"Maintenance Tip: Roof design has many peaks and valleys; keep roof cleared of debris and heavy snow loads to extend life of roof."},{"checked":false,"id":1,"is_red":false,"text":"Maintenance Tip:  Weather permitting, keep debris cleared from roof valleys to extend life of roof. "},{"checked":false,"id":1,"is_red":false,"text":"Some wood shakes missing / damaged / nails lifting."},{"checked":false,"id":1,"is_red":false,"text":"Some areas roofed by plastic or fiberglass panels; monitor for leaks or accumulated debris."},{"checked":false,"id":1,"is_red":false,"text":"Some wood shakes missing / damaged / nails lifting."},{"checked":false,"id":1,"is_red":false,"text":"Some areas roofed by plastic or fiberglass panels; monitor for leaks or accumulated debris."},{"checked":false,"id":1,"is_red":false,"text":"Some wood shakes missing / damaged / nails lifting."},{"checked":false,"id":1,"is_red":false,"text":"Some areas roofed by plastic or fiberglass panels; monitor for leaks or accumulated debris."},{"checked":false,"id":1,"is_red":false,"text":"Some areas not visible from inspection level."}],"sepChoice":"4","title":"Roof Condition"}],"inspection_panels":[{"descr":"","id":3047,"options":[{"checked":false,"id":1,"is_red":false,"text":"Common area of home owners association."},{"checked":false,"id":1,"is_red":false,"text":"Roofing is the same as main structure."},{"checked":false,"id":1,"is_red":false,"text":"Inspected from ground level with binoculars.  See Roofing Notes above, in blue.  Due to property and roof configurations, some areas of the roof may be visually restricted from inspection"},{"checked":false,"id":1,"is_red":false,"text":"Some areas of roof are obscured from view."},{"checked":false,"id":1,"is_red":false,"text":"Inspected from ladder."},{"checked":false,"id":1,"is_red":false,"text":"Limited inspection, the roof covered with ice and snow at the time of inspection. Recommend referring to the Seller Disclosure Statement regarding the condition of the roof."},{"checked":false,"id":1,"is_red":false,"text":"Observed from the ground with field glasses."},{"checked":false,"id":1,"is_red":false,"text":"Roof was visually inspected from accessible points on the interior and/or exterior. If a roof is too high, is too steep, is wet, or is composed of materials which can be damaged if walked upon, the roof is not mounted. Therefore, client is advised that this is a limited review and a licensed roofer should be contacted if a more detailed report is desired."},{"checked":false,"id":1,"is_red":false,"text":"Visually accessible from ground."},{"checked":false,"id":1,"is_red":false,"text":"Visually accessible from ground.  Not mounted due to height and pitch making mounting of roof dangerous."},{"checked":false,"id":1,"is_red":false,"text":"Visually accessible from ground.  Not mounted due to weather conditions making mounting of roof dangerous."},{"checked":false,"id":1,"is_red":false,"text":"Visually accessible from ground.  Not mounted due to wet surface."}],"sepChoice":"1","title":"Roof Info"},{"descr":"","id":3048,"options":[{"checked":false,"id":1,"is_red":false,"text":"Asphalt shingles noted."},{"checked":false,"id":1,"is_red":false,"text":"Concrete tiles noted."},{"checked":false,"id":1,"is_red":false,"text":"Rolled roofing noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood shingles noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood shakes noted."},{"checked":false,"id":1,"is_red":false,"text":"Metal standing seam roofing noted."},{"checked":false,"id":1,"is_red":false,"text":"Fiberglass composite shingles noted."},{"checked":false,"id":1,"is_red":false,"text":"Composition shingles noted."},{"checked":false,"id":1,"is_red":false,"text":"Flat roof, rubber membrane, inspected with Ladder."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum standing seam roof present."}],"sepChoice":"1","title":"Roof Material"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Roof Condition Overall"}],"title":"Condition"},{"damage_panels":[{"descr":"","id":2144,"options":[{"checked":false,"id":1,"is_red":false,"text":"Flashings are mastic covered, recommend re-sealing all through the roof vents and projections as a part of routine maintenance."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the flashings are near the end of their useful life due to wear."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a licensed roofer for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Typical maintenance necessary, now and on an annual or semi-annual basis. This generally consists of resealing gaps at through-the-roof projections and at the parapet walls as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Poor roof flashing-  it appears there are no drip edges installed."},{"checked":false,"id":1,"is_red":false,"text":"no clearance of siding to roof- wood touching roof is rotting"},{"checked":false,"id":1,"is_red":false,"text":"Parapet wall flashing is metal strip attached with fasteners; some rusting was evident."},{"checked":false,"id":1,"is_red":false,"text":"There may be an issue with a flashing leak by a roof vent; a small tub/pan was set underneath which suggests that there was a leak at sometime. Recommend further investigation or to ask present owners details."},{"checked":false,"id":1,"is_red":false,"text":"There is some damage to the top flashing on the parapet wall of the roof, this may lead to leaks in the future if left unattended and allowed to progress further, have a contractor evaluate and repair any possible leak points on the roof parapet walls."},{"checked":false,"id":1,"is_red":false,"text":"Missing edge flashings leave underlying framing exposed to weather. This condition may result in deterioration of home materials from moisture intrusion. The Inspector recommends missing flashing be replaced by a qualified contractor."},{"checked":false,"id":1,"is_red":false,"text":"Town home structure- Roof & flashing system covers entire building."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum flashing visible around chimney. "},{"checked":false,"id":1,"is_red":false,"text":"Terracotta parapet wall flashing is damaged in some areas."},{"checked":false,"id":1,"is_red":false,"text":"Incomplete aluminum flashings at fascia edge behind gutters; there is some exposed wood in areas."}],"sepChoice":"4","title":"Flashing"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Flashing Overall"}],"title":"Flashing"},{"damage_panels":[{"descr":"","id":2143,"options":[{"checked":false,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"No chimney cap visible from inspection level.  Recommend installation to prevent premature weathering, water intrusion, and nesting of wildlife."},{"checked":false,"id":1,"is_red":false,"text":"Chimney Mortar shows sign of deterioration. Recommend having repaired as necessary."},{"checked":false,"id":1,"is_red":false,"text":"No \"Cricket\" (a small ridged roof section just above the chimney to shed water off to the sides) is installed above the (wider than 2’) chimney. Keep clean of any accumulated debris which may cause leaks. "},{"checked":false,"id":1,"is_red":false,"text":"Minor mortar deterioration at chimney; moss present. Recommend cleaning and maintenance as needed."},{"checked":false,"id":1,"is_red":false,"text":"Step cracking at lower area of chimney."},{"checked":false,"id":1,"is_red":false,"text":"Flashing at base of chimney appears to need some maintenance to ensure a continued waterproof seal."},{"checked":false,"id":1,"is_red":false,"text":"Chimney supports TV antenna; this is not recommended as antenna can cause damage to chimney. "},{"checked":false,"id":1,"is_red":false,"text":"11 feet is typical oil burner minimum chimney height requirement.  Advise review by qualified contractor to determine if this installation is appropriate."},{"checked":false,"id":1,"is_red":false,"text":"15 feet is minimum fireplace chimney height according to common standards.  Suggest having evaluated by qualified contractor."},{"checked":false,"id":1,"is_red":false,"text":"Abandoned masonry chimney, no longer in use."},{"checked":false,"id":1,"is_red":false,"text":"Brick and mortar deterioration observed; repair advised."},{"checked":false,"id":1,"is_red":false,"text":"Chimney brick has been painted."},{"checked":false,"id":1,"is_red":false,"text":"Chimney is leaning."},{"checked":false,"id":1,"is_red":false,"text":"Chimney is too short. The 10-2-3 Rule states that the chimney should extend at least 3 ft. above the roof opening (measured at the uphill side on sloped roofs) and at least 2 ft. above the roof's (or any other structure's) highest point within 10 ft. for proper drafting. Simple repairs and/or modifications can usually be made to most chimneys to correct the problem. Recommend review by a qualified chimney specialist for repair or modification, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Chimney location at base of valley makes this area more prone to water infiltration."},{"checked":false,"id":1,"is_red":false,"text":"Chimney needs to be rebuilt above the roof line."},{"checked":false,"id":1,"is_red":false,"text":"Crown and Flashing intact where visible"},{"checked":false,"id":1,"is_red":false,"text":"Efflorescence observed; often a sign of water infiltration/exfiltration and can be a precursor of masonry deterioration."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of repairs observed, unable to determine the effectiveness of these repairs."},{"checked":false,"id":1,"is_red":false,"text":"Fireplace chimney height does not meet typical standard for spark and draft control."},{"checked":false,"id":1,"is_red":false,"text":"Flaking, spalling brick observed."},{"checked":false,"id":1,"is_red":false,"text":"Height is low; metal furnace chimneys are typically required to be two feet over the roof.  Low chimneys can affect draft."},{"checked":false,"id":1,"is_red":false,"text":"Loose bricks observed."},{"checked":false,"id":1,"is_red":false,"text":"Metal chimney liner observed."},{"checked":false,"id":1,"is_red":false,"text":"Recommend monitoring this area regularly."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified chimney professional for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Some corrosion observed; advise review by qualified HVAC contractor."},{"checked":false,"id":1,"is_red":false,"text":"Some mortar deterioration observed; advise repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"The chimney stack appears to have an unlined flue. While this may have been acceptable at the time of construction, flue liners are a fire safety feature which the client should consider installing to enhance safety. Regular cleaning of the chimney is recommended to ensure safe and efficient operation."},{"checked":false,"id":1,"is_red":false,"text":"Cracked flue tile observed."},{"checked":false,"id":1,"is_red":false,"text":"Cracked liner observed. We advise having chimney reviewed by a chimney specialist as this could be a safety issue. Repairs or installation of a flue liner may be needed."},{"checked":false,"id":1,"is_red":false,"text":"Cracked liner observed. We advise having chimney reviewed by a chimney specialist as this could be a safety issue. Repairs or installation of a flue liner may be needed."},{"checked":false,"id":1,"is_red":false,"text":"Flue liner may be needed."},{"checked":false,"id":1,"is_red":false,"text":"Flue, crown and flashing not inspected due to roof not being mounted."},{"checked":false,"id":1,"is_red":false,"text":"Attachments, satellite dish, antenna—[Satellite dish/antenna] attached to chimney. Chimneys typically are not constructed to support anything other than the chimney itself, and the structural and functional integrity of the chimney can be compromised when additional structural, mechanical, or utility systems are attached to them with screws, bolts, etc. Recommend having [satellite dish/antenna] moved and further evaluation by licensed chimney professional to ensure integrity and proper function of chimney."},{"checked":false,"id":1,"is_red":false,"text":"Unable to determine if a Chimney cricket is present. Chimney was at low end of moderately sloped roof and thirty inches or wider. A chimney cricket would be desirable for this chimney. Chimney crickets sometimes are not used in areas where rainfall is low. Lack of a chimney cricket simply means that regular monitoring and maintenance will need to be done to prevent leaking problems at the roof and chimney connection. Recommend having a chimney cricket installed if one is not present and/or regular homeowner monitoring and maintenance."},{"checked":false,"id":1,"is_red":false,"text":"Chimney not properly flashed, light visible from inside attic space."},{"checked":false,"id":1,"is_red":false,"text":"The chimneys flues are missing rain cap . This is a potential point of water entry and can lead to deteriorating brickwork. Have rain caps installed by a qualified individual."},{"checked":false,"id":1,"is_red":false,"text":"Chimney displays some areas of  efflorescence at its mortar joints. If the causing factor is not addressed and this is allowed to continue, it may lead to premature deterioration ."},{"checked":false,"id":1,"is_red":false,"text":"Missing flue liner for chimney."},{"checked":false,"id":1,"is_red":false,"text":"Unable to determine condition or presence of liner due to accessibility."}],"sepChoice":"4","title":"Chimney"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Chimney Overall"}],"title":"Chimney"},{"damage_panels":[{"descr":"","id":2146,"options":[{"checked":false,"id":1,"is_red":false,"text":"Skylights have very poor or non existent flashing. "},{"checked":false,"id":1,"is_red":false,"text":"additions do not appear to be flashed well when roof meets existing roof."},{"checked":false,"id":1,"is_red":false,"text":"The sky light is past its serviceable life time and shows signs of excessive leaking, have it replaced/repaired by a qualified individual."},{"checked":false,"id":1,"is_red":false,"text":"Skylight in bathroom,( see pic)did not display any outward signs of active or past leaks. "},{"checked":false,"id":1,"is_red":false,"text":"No signs of present or past leaking around the skylight were discovered at time of inspection."}],"sepChoice":"4","title":"Sky Lights"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Sky Lights Overall"}],"title":"Skylights"},{"damage_panels":[{"descr":"","id":2147,"options":[{"checked":false,"id":1,"is_red":false,"text":"Chimney rain cap is severely rusted and deteriorated, suggest painting to preserve its remaining life."},{"checked":false,"id":1,"is_red":false,"text":"Metal Furnace chimney missing cap; this will allow water entry and can cause back drafting.  Correction is important."},{"checked":false,"id":1,"is_red":false,"text":"No chimney rain cap observed, suggest installing a chimney raincap to prevent the entrance of the elements and local wildlife and to preserve the life of the chimney as well as minimize maintenance."},{"checked":false,"id":1,"is_red":false,"text":"Spark arrestor and rain cap suggested."},{"checked":false,"id":1,"is_red":false,"text":"Suggest rebuilding weather cap (chimney crown) to reduce opportunity for water infiltration and damage.  This is a common maintenance item that is often neglected by homeowners; you should make a crown inspection part of your routine seasonal maintenance checklist."},{"checked":false,"id":1,"is_red":false,"text":"Spark Arrestor screen appears to be missing; this acts to prevent sparks from escaping and to prevent stop animals/birds from entering chimney.  Recommend evaluation by chimney sweep when wood stoves are checked. "},{"checked":false,"id":1,"is_red":false,"text":"No Spark Arrestor visible from inspection level; potential fire hazard.  Verify that one exists, or have one installed."},{"checked":false,"id":1,"is_red":false,"text":"Wire mesh only is installed as a spark arrestor, this is considered to be inadequate and a proper spark arrestor should be installed."}],"sepChoice":"4","title":"Spark Arrestor"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Spark Arrestor Overall"}],"title":"Spark Arrestor"},{"damage_panels":[{"descr":"","id":2148,"options":[{"checked":false,"id":1,"is_red":false,"text":"There appears to be a home made vent cap installed on a B vent pipe."},{"checked":false,"id":1,"is_red":false,"text":"The vent cap is rusted and appears to be failing. We recommend replacing the vent cap."},{"checked":false,"id":1,"is_red":false,"text":"The vent cap is corroded and appears to be failing. We recommend replacing the vent cap."},{"checked":false,"id":1,"is_red":false,"text":"The vent cap is missing. We recommend replacing the vent cap."},{"checked":false,"id":1,"is_red":false,"text":"There are loose B vent caps noted. We recommend refastening the vent caps."},{"checked":false,"id":1,"is_red":false,"text":"The B vent does not extent to proper height above the roof. We recommend contacting a qualified contractor to repair this issue."}],"sepChoice":"4","title":"Vent Caps"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Vent Caps Overall"}],"title":"Vent Caps"},{"damage_panels":[{"descr":"","id":2145,"options":[{"checked":false,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Extensions / Splash blocks missing or insufficient: Install to divert water away from the foundation. "},{"checked":false,"id":1,"is_red":false,"text":"Perimeter Grading:  Appears to slope towards building in areas. Recommend grading soil so it slopes down and away from the building to direct rainwater away."},{"checked":false,"id":1,"is_red":false,"text":"Perimeter Pavement:  Appears to slope towards building. Recommend taking measures to direct rainwater away."},{"checked":false,"id":1,"is_red":false,"text":"No gutters or downspouts.  Full installation recommended to keep water away from structure.  Water can weaken the foundation and deteriorate the siding.  Be sure to install splashblocks or extensions to carry water away, and keep water from areas such as driveways or walks where it can be an ice hazard in winter."},{"checked":false,"id":1,"is_red":false,"text":"Partial gutters - Full installation recommended to keep water away from structure.  Water can weaken the foundation and deteriorate the siding.  Be sure to install splashblocks or extensions to carry water away, and keep water from areas such as driveways or walks where it can be an ice hazard in winter."},{"checked":false,"id":1,"is_red":false,"text":"Clean gutters:  Significant amounts of debris evident."},{"checked":false,"id":1,"is_red":false,"text":"Gutters missing, contributing to deterioration of finish on siding. "},{"checked":false,"id":1,"is_red":false,"text":"Gutter leak(s) noted.  Potential ice hazard in winter; repairs recommended."},{"checked":false,"id":1,"is_red":false,"text":"Gutter missing over entranceway(s); potential ice hazard."},{"checked":false,"id":1,"is_red":false,"text":"Gutters sagging; resecure as needed."},{"checked":false,"id":1,"is_red":false,"text":"Downspout drains onto sidewalk / driveway.  Recommend exploring ways to divert water away from this area, or at the very least, recognize this as a potential ice hazard; use ice melt products and exercise caution."},{"checked":false,"id":1,"is_red":false,"text":"Ends of downspouts not visible under deck area; cannot determine if water is drained sufficiently away from foundation."},{"checked":false,"id":1,"is_red":false,"text":"Downspouts missing; recommend installation."},{"checked":false,"id":1,"is_red":false,"text":"Downspouts pulling away from the house; resecure as needed."},{"checked":false,"id":1,"is_red":false,"text":"Maintenance Tip:  Keep gutters cleared of pine needles to prevent downspouts from being clogged and overflow at gutters. "},{"checked":false,"id":1,"is_red":false,"text":"Maintenance Tip:  Keep gutters cleared of organic debris to prevent downspouts from being clogged causing overflow at gutters, ensure that all downspouts have extensions/splash blocks to carry water away from the foundation and ensure that sprinkler system does not spray siding or windows of house. "},{"checked":false,"id":1,"is_red":false,"text":"Partial gutters - Full installation recommended to keep water away from structure.  Water can weaken the foundation and deteriorate the siding.  Be sure to install splashblocks or extensions to carry water away, and keep water from areas such as driveways or walks where it can be an ice hazard in winter."},{"checked":false,"id":1,"is_red":false,"text":"Partial gutters with metal roof - Full installation is generally recommended to keep water away from the structure.  However, since this house has a metal roof, check with a contractor on the feasibility of full gutter installation.  Water can weaken the foundation and deteriorate the siding.  Be sure to install splashblocks or extensions to carry water away, and keep water from areas such as driveways or walks where it can be an ice hazard in winter."},{"checked":false,"id":1,"is_red":false,"text":"No gutters or downspouts.  Installation recommended, at least over entranceways and walks, to keep water away from structure.  Water can weaken the foundation and deteriorate the siding.  Be sure to install splashblocks or extensions to carry water away, and keep water from areas such as driveways or walks where it can be an ice hazard in winter."},{"checked":false,"id":1,"is_red":false,"text":"No Gutters or downspouts.  Although we generally recommend installation, this home has a metal roof.  See notes in blue, above."},{"checked":false,"id":1,"is_red":false,"text":"The downspout off of the back porch roof gutter system is discharging against the foundation walls it is not directed far enough away from home;it should be at least 6 feet away."},{"checked":false,"id":1,"is_red":false,"text":"Roof appears to stay wet for extended periods of time, allowing moss or liken to grow on the surface."},{"checked":false,"id":1,"is_red":false,"text":"Gutter guards are installed , but it would be wise to trim back branches of any trees that over hang the roof and drops debris on it through the seasons."},{"checked":false,"id":1,"is_red":false,"text":"Gutters are filled with muck and vines, they need to be cleaned out ASAP."},{"checked":false,"id":1,"is_red":false,"text":"The roof is slightly pitched towards rear or building allowing for run off into the gutters."},{"checked":false,"id":1,"is_red":false,"text":"All the gutters should be evaluated for correct pitch in installation by a qualified installer."},{"checked":false,"id":1,"is_red":false,"text":"The gutter section above porch is pitched incorrectly, ( see pic)."},{"checked":false,"id":1,"is_red":false,"text":"Make sure all downspouts are connected and routed to discharge away from the homes foundation, this will reduce the potential for water to seep into the basement."},{"checked":false,"id":1,"is_red":false,"text":"Downspouts were not connected at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Make sure to periodically check and clean out debris from gutters to keep it flowing well when it rains. If it clogs, it will over flow, and may potentially cause roof leaks."},{"checked":false,"id":1,"is_red":false,"text":"Downspouts are discharging into the sewer system; typically it is a better arrangement to have the downspouts routed to discharge away from the homes foundation, this way the storm water will not over power the city sewer systems."},{"checked":false,"id":1,"is_red":false,"text":"There is a small hole and leak at the corner of the gutter under the roof valley ( see pics)."},{"checked":false,"id":1,"is_red":false,"text":"The gutter downspout on right hand side of fireplace chimney is poorly installed; discharge runs inward and against the home instead of out and away from the homes foundation. Also- the downspout may have been initially clogged by leaves and debris which could have lead to them presently being completely frozen solid."},{"checked":false,"id":1,"is_red":false,"text":"Ice dam visible (no damage)\r\nAn ice dam was present at several area of the roof eve at the time of the inspection. Ice dams form when, due to inadequate ceiling insulation, warm air enters the attic from the living space and in turn, warms the roof. Snow on the roof melts during the day and re- freezes at night, forming a dam which blocks melt water drainage. As the freeze/melt cycle continues, melt water is sometimes able to seep under the roofing material and contribute to leaks, mold, wood decay and other moisture-related problems. Although there appeared to be no visible evidence of moisture-related damage at the time of the inspection, you may help alleviate this problem by adding insulation to the attic floor, by improving attic ventilation or by installing a heating system designed to prevent ice dam formation at the roof edge.\r\n"},{"checked":false,"id":1,"is_red":false,"text":"The home had no roof drainage system to channel roof drainage away from the foundation. \nThe Inspector recommends installation of a roof drainage system to help protect the home foundation.\n\n"}],"sepChoice":"4","title":"Gutter"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Gutter Overall"}],"title":"Gutters"}],"title":"Roof"},{"id":8,"tabbed_panels":[],"title":"Earthquake Report"},{"id":9,"tabbed_panels":[{"damage_panels":[{"descr":"","id":2254,"options":[{"checked":false,"id":1,"is_red":false,"text":"No deficiencies were observed at the visible portions of the structural components of the home."},{"checked":false,"id":1,"is_red":false,"text":"No leaks were observed at the time of the inspection."},{"checked":false,"id":1,"is_red":false,"text":"No stains or evidence of moisture penetration observed."},{"checked":false,"id":1,"is_red":false,"text":"Moisture intrusion was observed in numerous areas of the foundation. Moisture can create high humidity, mold & can damage stored items & finishing materials. Recommend a wet basement specialist review the foundation for correcting the water intrusion and advise as needed."},{"checked":false,"id":1,"is_red":false,"text":"Large cracks were observed at the visible foundation walls. Repairs can be expensive and further settling or damage could occur. Recommend a Structural Engineer to provide a detailed analysis."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: It is advised to purchase a humidity gauge to monitor the levels of humidity. Typical levels are 35 to 45% during the heating season and 45 to 55% during the cooling season."},{"checked":false,"id":1,"is_red":false,"text":"Area of major repair noted to poured concrete foundation wall.  This repair appears to be professionally done.  Buyer is recommended to request and review any existing documents relative to this repair to determine if any warranties exist.  No warranty for this or any other repair is implied by this inspection. "},{"checked":false,"id":1,"is_red":false,"text":"Visible portions of foundation wall were dry at the time of the inspection."},{"checked":false,"id":1,"is_red":false,"text":"Although there are no signs of water penetration we caution you to consider any basement as wet until experience proves it dry."},{"checked":false,"id":1,"is_red":false,"text":"Efflorescence observed; this is a mineral deposit left behind from previous exterior water infiltration."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of past water penetration observed."},{"checked":false,"id":1,"is_red":false,"text":"Active leaks observed at the time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Water stains, bulging walls, or other damage was observed near plumbing fixtures  that indicate leaks or possible concealed leaks. Client is advised to obtain further review by a licensed plumber prior to closing to determine the cause of this condition for repairs/replacement as needed."},{"checked":false,"id":1,"is_red":false,"text":"Mildew observed, which is an indication of inadequate ventilation."},{"checked":false,"id":1,"is_red":false,"text":"Mold-like bio growth observed. Professional testing & evaluation advised."},{"checked":false,"id":1,"is_red":false,"text":"Common cracks observed, these may leak at any time."},{"checked":false,"id":1,"is_red":false,"text":"Cracks and deterioration observed."},{"checked":false,"id":1,"is_red":false,"text":"Shrinkage cracking noted in unfinished area.  This cracking is common and usually no reason for concern.  Recommend monitoring and consultation with qualified contractor should condition worsen or if water intrusion occur."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of repairs observed, unable to determine the effectiveness of these repairs."},{"checked":false,"id":1,"is_red":false,"text":"Minor shrinkage/settlement cracking noted at exterior East side wall.  This is a relatively common condition that occurs during the curing process and is normally no reason for concern.  Recommend sealing with clear Polyurethane caulk and monitoring. Consult with a professional engineer or qualified contractor should condition worsen or if water intrusion occurs."},{"checked":false,"id":1,"is_red":false,"text":"Patching observed."},{"checked":false,"id":1,"is_red":false,"text":"Limited review due to insulation cover and finished walls."},{"checked":false,"id":1,"is_red":false,"text":"Limited review due to storage of personal property and finished walls."},{"checked":false,"id":1,"is_red":false,"text":"Limited review of unfinished area due to insulation cover."},{"checked":false,"id":1,"is_red":false,"text":"Walls have been recently painted."},{"checked":false,"id":1,"is_red":false,"text":"Limited view due to storage and finishing systems. See Limitations."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified professional for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Walls are leaning."},{"checked":false,"id":1,"is_red":false,"text":"The waterproofing system has been poorly installed. Recommend having entire system reviewed."},{"checked":false,"id":1,"is_red":false,"text":"Have entire crawl space evaluated by a qualified professional. This includes waterproofing system, piping, insulation and wiring."},{"checked":false,"id":1,"is_red":false,"text":"http://www.cleancrawlspace.com/"},{"checked":false,"id":1,"is_red":false,"text":"http://www.killmoldfast.com/"},{"checked":false,"id":1,"is_red":false,"text":"This situation can be minimized or eliminated by regrading exterior landscape at these locations and extending the front gutter downspouts away from foundation."},{"checked":false,"id":1,"is_red":false,"text":"Unsealed area around waste line penetration at foundation wall. Recommend sealing with hydraulic cement and polyurethane caulking. "},{"checked":false,"id":1,"is_red":false,"text":"NOTE: All of the interior foundation wall surfaces have been recently painted with masonry waterproofing paint."},{"checked":false,"id":1,"is_red":false,"text":"Excessively high moisture levels can result in damage to the home structure or materials from decay or deterioration and may result in conditions which encourage the growth of microbes such as mold fungi. Excessive growth of mold fungi can produce high concentrations of mold spores in indoor air which can cause serious or fatal health problems in people with allergies, asthma, lung disease or compromised immune systems."},{"checked":false,"id":1,"is_red":false,"text":"A few small vertical cracks were observed; they do not appear to be traveling. Typically, cracks such as these would be considered normal settling. monitor for any movement/ widening over time."},{"checked":false,"id":1,"is_red":false,"text":"**FINISHED BASEMENTS**"},{"checked":false,"id":1,"is_red":false,"text":"Water puddles in basement room that has had its carpet removed ( very likely due to the recent heavy rain storm)."},{"checked":false,"id":1,"is_red":false,"text":"There were signs of past water damage to baseboard and paneling; however, no active moisture was detected during the inspection."},{"checked":false,"id":1,"is_red":false,"text":"There was previous flooding in the basement, but there was no visible moisture staining on portions of accessible drywall."},{"checked":false,"id":1,"is_red":false,"text":"Water damage to drywall in area of basement stairwell caused by plumbing leak.\r\nHave contractor replace and repair any damaged areas."},{"checked":false,"id":1,"is_red":false,"text":"**CRAWLSPACE**"},{"checked":false,"id":1,"is_red":false,"text":"Crawlspace is heated with a finned section of copper pipe from heater."},{"checked":false,"id":1,"is_red":false,"text":"Floor joist area in crawlspace near PVC waste plumbing exhibiting signs of water damage and biological growth consistent with mold. Have a licensed industrial hygienist evaluate the area."},{"checked":false,"id":1,"is_red":false,"text":"Clean up debris and replace damaged insulation."}],"sepChoice":"4","title":"Walls"}],"inspection_panels":[{"descr":"","id":3087,"options":[{"checked":false,"id":1,"is_red":false,"text":"Combination Basement and Crawlspace"},{"checked":false,"id":1,"is_red":false,"text":"**CRAWLSPACE**"},{"checked":false,"id":1,"is_red":false,"text":"Crawlspace noted."},{"checked":false,"id":1,"is_red":false,"text":"A raised perimeter with pier and beam supports -- Crawlspace."},{"checked":false,"id":1,"is_red":false,"text":"**BASEMENT**"},{"checked":false,"id":1,"is_red":false,"text":"Partly finished, full basement noted."},{"checked":false,"id":1,"is_red":false,"text":"Basement noted."},{"checked":false,"id":1,"is_red":false,"text":"Combination fully finished Basement and Slab on Grade."},{"checked":false,"id":1,"is_red":false,"text":"Fully finished basement."},{"checked":false,"id":1,"is_red":false,"text":"Unfinished basement ."}],"sepChoice":"1","title":"Basement/Crawlspace"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Walls Overall"}],"title":"Walls"},{"damage_panels":[{"descr":"","id":2255,"options":[{"checked":false,"id":1,"is_red":false,"text":"Recommend adding insulation to perimeter of structure to enhance the homes heating efficiency."},{"checked":false,"id":1,"is_red":false,"text":"Improper use of a moisture absorbing material is used to insulate the perimeter of band joists (which can cause unwanted mold growth in this closed cavity), recommend removal and installation of a proper material such as paperless fiberglass batting."},{"checked":false,"id":1,"is_red":false,"text":"Full view of foundation insulation was not available due to lack of access. "},{"checked":false,"id":1,"is_red":false,"text":"Insulation at perimeter has been improperly compacted or stapled, this prevents the fiberglass from performing as designed. Recommend review and repair by a qualified contractor to enhance homes efficiency."},{"checked":false,"id":1,"is_red":false,"text":"Recommend thermal imaging to confirm that home is not missing insulation at other concealed exterior walls"},{"checked":false,"id":1,"is_red":false,"text":"Rodent nests observed in insulation. Recommend sealing all gaps and cracks to prevent future infestation and consulting with a pest specialist to eliminate any present rodent infestation."},{"checked":false,"id":1,"is_red":false,"text":"Perimeter insulation was observed to be missing or out of place at one or more joist bay locations. Recommend repair/replacement to promote enhanced resistance to heat loss which will increase the efficiency of the home and lower heating costs."},{"checked":false,"id":1,"is_red":false,"text":"Insulation was observed to be missing or out of place in one or more locations. Recommend upgrading to promote proper insulation and increased efficiency of home."},{"checked":false,"id":1,"is_red":false,"text":"Insulation appears to be installed incorrectly. Manufacturers instructions typically state that the paper backing is to face the heated living space. Recommend review by a qualified insulation and ventilation contractor."},{"checked":false,"id":1,"is_red":false,"text":"Recommend removing paper backing on insulation at perimeter wall to prevent moisture accumulation. Moisture wicking into paper could lead to possible indoor mold issues."}],"sepChoice":"4","title":"Insulation"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Insulation Overall"}],"title":"Insulation"},{"damage_panels":[{"descr":"","id":2256,"options":[{"checked":false,"id":1,"is_red":false,"text":"Deterioration noted due to contact with moisture, repairs needed."},{"checked":false,"id":1,"is_red":false,"text":"Shower area's are a poor location for a window, recommend removal due to potential issues in the future."},{"checked":false,"id":1,"is_red":false,"text":"One or more window/s shows sign of loss of seal/condensation, recommend repair or replace to provide energy savings and prevent hazed window from limiting view out of window. "},{"checked":false,"id":1,"is_red":false,"text":"One or more windows did not lock/latch properly, recommend repairs for enhanced security/safety to occupants."},{"checked":false,"id":1,"is_red":false,"text":"Broken/cracked glass pane noted, repairs needed."},{"checked":false,"id":1,"is_red":false,"text":"Window sill height appears to be over 44 inches which is the maximum height for egress from a bedroom according to current building standards. This could be a fatal issue in the event of an emergency exit situation. Recommend review of current egress and upgrade as needed to enhance the safety to occupants."},{"checked":false,"id":1,"is_red":false,"text":"hardware difficult to operate at one or more locations. Recommend review and repair as needed by qualified window contractors"},{"checked":false,"id":1,"is_red":false,"text":"In the event of an emergency it appears that the windows could cause an issue of quick egress due to the windows are difficult to open for a small child to escape. Recommend review and repair to allow easy exit in the event of an emergency situation."},{"checked":false,"id":1,"is_red":false,"text":"Single pane windows observed, recommend budgeting for replacement for added efficiency of home."},{"checked":false,"id":1,"is_red":false,"text":"Broken glazing observed, suggest re-glazing as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Broken sash wire/cord observed on window frame. This is a \"Safety Concern\". Sash wire/cord holds window in open position. Suggest repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Damaged screens observed."},{"checked":false,"id":1,"is_red":false,"text":"Deterioration of wooden frames noted.  While basic maintenance may prolong the life of these window frames, replacement may be necessary at some point.  "},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the windows/frames are near the end of their useful life."},{"checked":false,"id":1,"is_red":false,"text":"Peeling paint observed, suggest scraping and painting as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Fog/condensation observed in thermopane windows. This is an indication of a failed seal. Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Glass block windows with vents in basement."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl crank out style windows with locks observed."},{"checked":false,"id":1,"is_red":false,"text":"Broken glass on a basement window. The windows in the basement are old and sometimes difficult or impossible to open. it is recommended to replace with glass block vented windows. "},{"checked":false,"id":1,"is_red":false,"text":"Painted wood windows possibly creating lead dust from friction on paint. "},{"checked":false,"id":1,"is_red":false,"text":"Metal \"double hung\" type with locks."},{"checked":false,"id":1,"is_red":false,"text":"Severe damage--\nSome vinyl windows in the home had severe damage visible at the time of the inspection. You may wish to get estimates for repair before the expiration of your Inspection Objection Deadline.\n"},{"checked":false,"id":1,"is_red":false,"text":"Minor damage--\nSome vinyl windows in the home had minor damage visible at the time of the inspection.\n"},{"checked":false,"id":1,"is_red":false,"text":"Some of the windows are difficult to lock."},{"checked":false,"id":1,"is_red":false,"text":"The home is fitted with vinyl windows."},{"checked":false,"id":1,"is_red":false,"text":"Basement well window has been riveted shut, making it impossible to use as a means of exit in an emergency."},{"checked":false,"id":1,"is_red":false,"text":"Some windows are very difficult to open and some were not able to open, this may be because of the paint."},{"checked":false,"id":1,"is_red":false,"text":"Screens were not installed at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"In accordance with ASHI Standards, we do not test every window in the house, and particularly if it is furnished. We do test every unobstructed window in every bedroom to ensure that at least one provides an emergency exit."},{"checked":false,"id":1,"is_red":false,"text":"Operated windows appeared functional, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"The windows that were tested, are functional."},{"checked":false,"id":1,"is_red":false,"text":"Damaged/Missing sash cords."},{"checked":false,"id":1,"is_red":false,"text":"Missing screens observed at @@LOCATION@@."},{"checked":false,"id":1,"is_red":false,"text":"Damage tilt-out feature locking clips at @@LOCATION@@. Window is still functional. FYI"},{"checked":false,"id":1,"is_red":false,"text":"Damage/missing hardware at @@LOCATION@@. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Torn screen(s)."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the windows/frames are near the end of their useful life."},{"checked":false,"id":1,"is_red":false,"text":"Cloudiness/condensation observed in @@NUMBER@@ of thermopane double glazed windows in @@LOCATION@@. This is an indication of a failed seal. A qualified contractor should review for replacement as needed."},{"checked":false,"id":1,"is_red":false,"text":"Cracked or broken window glass was observed. Injury could occur. Recommend repair or replacement of the damaged glass."},{"checked":false,"id":1,"is_red":false,"text":"Cracked window pane in @@LOCATION@@. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Improve:  Install glass block basement windows with vents. This type of window allows in more light, ventilation, added security and reduces the risks of moisture intrusion."},{"checked":false,"id":1,"is_red":false,"text":"DEFERRED COST: Windows are original, older type. Consider upgrading to double pane, thermally insulated, newer efficient type."},{"checked":false,"id":1,"is_red":false,"text":"Some windows did not open when tested. Recommend  all windows reviewed for proper operation during walkthrough inspection prior to closing."},{"checked":false,"id":1,"is_red":false,"text":"A representative number of windows were inspected. Most did not open when tested -- appears painted wood frames have sealed seams. Recommend  all windows be reviewed for proper operation during final walkthrough inspection."},{"checked":false,"id":1,"is_red":false,"text":"Improve: Install glass block basement windows."},{"checked":false,"id":1,"is_red":false,"text":"All accessible windows operated."},{"checked":false,"id":1,"is_red":false,"text":"SAFETY CONCERN: FYI - Do not use rooms in basement as \"bedrooms\" because the existing windows do not meet Emergency Escape & Rescue opening requirements."},{"checked":false,"id":1,"is_red":false,"text":"Mold-like bio growth observed. Professional testing & evaluation advised."},{"checked":false,"id":1,"is_red":false,"text":"There are older wood windows present."},{"checked":false,"id":1,"is_red":false,"text":"Glass block windows with vents in basement."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl crank out style windows with locks."},{"checked":false,"id":1,"is_red":false,"text":"Basement front window appears to have issues as it is taped up."},{"checked":false,"id":1,"is_red":false,"text":"Painted wood windows possibly creating lead dust from friction on paint. "},{"checked":false,"id":1,"is_red":false,"text":"Metal \"double hung\" type with locks."},{"checked":false,"id":1,"is_red":false,"text":"Basement well window has been riveted shut, making it impossible to use as a means of exit in an emergency."},{"checked":false,"id":1,"is_red":false,"text":"The windows in the home are rope and pulley style, may be original to home, and are approaching the end of their serviceable lifetime."},{"checked":false,"id":1,"is_red":false,"text":"Window or wood trim is damaged/deteriorated and needs repair or replacement to maintain a tight building structure which prevents entry by elements, rodents and insects."},{"checked":false,"id":1,"is_red":false,"text":"Gaps/cracks observed at foundation window/s, recommend repair to prevent intrusion by rodents/insects/moisture."},{"checked":false,"id":1,"is_red":false,"text":"Moisture/Condensation observed at basement window/s is evidence of loss of seal between double panes. Recommend review and repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Basement daylight window is at, near or below grade at one or more locations. recommend installing window well or correcting grade if allowable at this location to prevent water intrusion and premature deterioration of window casing."},{"checked":false,"id":1,"is_red":false,"text":"Window jamb extensions appear to be improper size/unprofessionally installed Review and repair recommended to allow proper trimming out of window casing."},{"checked":false,"id":1,"is_red":false,"text":"Metal framed single pane daylight windows present. They show signs of rusting, did not operate to confirm proper operation. Recommend budgeting for replacement in the future for increased aesthetics and efficiency. "},{"checked":false,"id":1,"is_red":false,"text":"Basement bedroom egress (emergency escape) window appears to improper sized/ does not allow sufficient opening for exit in the event of an emergency. Current building standards require all sleeping areas to have two means of exit. Windows must be at least 24\" high and at least 20\" wide with a net area of at least 5.7 sq. ft. with the window sill no higher than 44\" from the floor. The window well must have a min. of 3' deep and no less than 9 sq.ft in volume. Recommend upgrading to enhance safety to occupants."},{"checked":false,"id":1,"is_red":false,"text":"Broken/cracked window glass noted at time of inspection at one or more locations, repairs recommended."},{"checked":false,"id":1,"is_red":false,"text":"One or more window/s shows sign of loss of seal/condensation, recommend repair or replace to provide energy savings and prevent hazed window from limiting view out of window. "},{"checked":false,"id":1,"is_red":false,"text":"Single pane windows noted, recommend budgeting for replacement to enhance homes efficiency and aesthetics."},{"checked":false,"id":1,"is_red":false,"text":"One or more windows were difficult to operate or latch, repairs recommended."},{"checked":false,"id":1,"is_red":false,"text":"Drafts observed due to poor sealing at window/s."},{"checked":false,"id":1,"is_red":false,"text":"Child proof lock mechanism may present a safety hazard as quick egress in the event of an emergency. Latch is somewhat difficult to unlock and out of reach of smaller persons. Recommend changing mechanical lock or leaving the top one unlocked, if plans are to add space as a bedroom in the future."}],"sepChoice":"4","title":"Windows"}],"inspection_panels":[{"descr":"","id":3088,"options":[{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed casement window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Stationary(fixed) window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed casement window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed casement window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Garden style window noted."},{"checked":false,"id":1,"is_red":false,"text":"Bay type window noted."},{"checked":false,"id":1,"is_red":false,"text":"Bow type window noted."},{"checked":false,"id":1,"is_red":false,"text":"Glass blocks noted in window openings."},{"checked":false,"id":1,"is_red":false,"text":"Non-insulated glass noted."},{"checked":false,"id":1,"is_red":false,"text":"Insulated glass noted."}],"sepChoice":"1","title":"Window Types"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Windows Overall"}],"title":"Windows"},{"damage_panels":[{"descr":"","id":2257,"options":[{"checked":false,"id":1,"is_red":false,"text":"ABS"},{"checked":false,"id":1,"is_red":false,"text":"Cast Iron"},{"checked":false,"id":1,"is_red":false,"text":"Copper"},{"checked":false,"id":1,"is_red":false,"text":"Galvanized"},{"checked":false,"id":1,"is_red":false,"text":"Galvanized and Copper"},{"checked":false,"id":1,"is_red":false,"text":"Lead"},{"checked":false,"id":1,"is_red":false,"text":"No Dielectric Fittings"},{"checked":false,"id":1,"is_red":false,"text":"Pex"},{"checked":false,"id":1,"is_red":false,"text":"Plastic"},{"checked":false,"id":1,"is_red":false,"text":"Polybutylene"},{"checked":false,"id":1,"is_red":false,"text":"PVC"}],"sepChoice":"4","title":"Plumbing Materials"}],"inspection_panels":[{"descr":"","id":3089,"options":[{"checked":false,"id":1,"is_red":false,"text":"**WASTE**"},{"checked":false,"id":1,"is_red":false,"text":"Appears Functional."},{"checked":false,"id":1,"is_red":false,"text":"Unprofessional work noted at one or more locations noted, recommend review and repairs by a qualified plumber to assure proper drain line function."},{"checked":false,"id":1,"is_red":false,"text":"Unprofessional repair noted at one or more locations noted, recommend review and repairs by a Qualified Plumber."},{"checked":false,"id":1,"is_red":false,"text":"Unprofessional repairs/upgrades noted to supply lines at one or more locations observed. Recommend review and proper repairs by a Qualified Plumber."},{"checked":false,"id":1,"is_red":false,"text":"Home winterized, not able to inspect system at time of inspection recommend complete review before closing date."},{"checked":false,"id":1,"is_red":false,"text":"Drain lines appear to lack proper support, recommend adding support hangers."},{"checked":false,"id":1,"is_red":false,"text":"Inspection of all areas of the drain pipes was not possible due to limited access/finshed walls and ceilings to check for defects such as, but not limited too:leaks, corrosion, improper workmanship, and damage."},{"checked":false,"id":1,"is_red":false,"text":"Vent and Drain lines are not fully visible for inspection due to finished walls/ceiling preventing full view of plumbing."},{"checked":false,"id":1,"is_red":false,"text":"S-trap observed at one or more locations. This type of drain is no longer allowed in current building practice due to the potential for water to be siphoned out of trap, allowing sewer gas to enter structure. If sewer gas is detected first try slowly running water down drain to refill trap assembly. If problem continues consult with a qualified plumber for review and repair."},{"checked":false,"id":1,"is_red":false,"text":"Active leak observed at one or more drain pipe/s. Recommend review and repair by a Qualified Plumber."},{"checked":false,"id":1,"is_red":false,"text":"Broken/damaged/rusted drain line noted at time of inspection, recommend review and repair by a qualified plumber."},{"checked":false,"id":1,"is_red":false,"text":"Water off to structure which prevents testing of drain lines for clogs and leaks. Recommend having all drains tested before the close of escrow to confirm that no leaks are present."},{"checked":false,"id":1,"is_red":false,"text":"Floor drains observed but not tested for proper operation."},{"checked":false,"id":1,"is_red":false,"text":"Cast iron drain lines have a life expectancy of 30-50 years. Recommend budgeting for replacement in the near future at areas where rust cysts are visible, BEFORE leaks occur."},{"checked":false,"id":1,"is_red":false,"text":"Open sewer drain line observed, recommend repairs be performed by qualified plumbing contractors."},{"checked":false,"id":1,"is_red":false,"text":"Corrosion/cysts were noted as one or more locations of the metal drain lines. Repairs recommended to be performed by a Qualified Plumber.\n"},{"checked":false,"id":1,"is_red":false,"text":"Evidence of leakage detected and requires review and repair by a qualified plumbing contractor."},{"checked":false,"id":1,"is_red":false,"text":"Water softener drain line exits through wall to an UNKNOWN location, recommend review and repair as needed. "},{"checked":false,"id":1,"is_red":false,"text":"Water softener drain line exits through floor/wall under structure, recommend review and repair to prevent unwanted water under structure. "},{"checked":false,"id":1,"is_red":false,"text":"Improper combination of dissimilar plastic drain pipe observed. There is no way to confirm that the use of a special PVC to ABS cement was used, most local building officials prohibit the combination of different types of plastic piping. Review and repair is recommended by a Qualified Plumber."},{"checked":false,"id":1,"is_red":false,"text":"Previous repairs are noted and recommend review of repairs to confirm that all work was performed according to current building standards."},{"checked":false,"id":1,"is_red":false,"text":"Improper drain line venting observed and is in need of repair by a Qualified Plumber at:"},{"checked":false,"id":1,"is_red":false,"text":"Please see www.toolbase.org/Technology-Inventory/Plumbing/air-admittance-valves \nfor further information on one of several repair techniques available as a repair option."},{"checked":false,"id":1,"is_red":false,"text":"Water to home was off at time of inspection. Could not test drain lines for slow drains or leaks. Recommend evaluation of drain lines before the close of escrow."},{"checked":false,"id":1,"is_red":false,"text":"Vent pipe appears to be undersized. Recommend review and repairs as needed by a Qualified Plumber."},{"checked":false,"id":1,"is_red":false,"text":"Drain line materials are improper, 90* fittings are subject to clogging and should be upgraded with the proper sweep type of fittings. Recommend review and replacement with proper drain fittings by a Qualified Plumber."},{"checked":false,"id":1,"is_red":false,"text":"Drain line appears to be improperly pitched 1/4 per foot towards drain, recommend review and repair by a Qualified Plumer."},{"checked":false,"id":1,"is_red":false,"text":"Old style \"Drum Trap\" noted at one or more tub drains. This type of drain is considered a poor design and is known for clogging and rusting out at the bottom, recommend review by a Qualified Plumber and ugrading before issues arise."},{"checked":false,"id":1,"is_red":false,"text":"Non typical installation of an Air Admittance Valve noted. Recommend further review by a Qualified Plumber familiar with current building standards. Air Admittance Valves are installed at a fixture above the drain pipe to allow proper  flow function on a section of the drain system that is isolated/not connected to the roof vent pipe."},{"checked":false,"id":1,"is_red":false,"text":"Venting system does not appear to be proper at one or more locations. Recommend review and repairs by a Qualified Plumbing Contractor."},{"checked":false,"id":1,"is_red":false,"text":"**SUPPLY**"},{"checked":false,"id":1,"is_red":false,"text":"Appears Functional."},{"checked":false,"id":1,"is_red":false,"text":"Home winterized, not able to inspect entire system at time of inspection. Recommend complete review  of water supply lines before closing date."},{"checked":false,"id":1,"is_red":false,"text":"Support of supply lines appears to be insufficient which may result in \"water hammer\" due to pipes moving due to the pressure in line from water turning on and off rapidly (such as in a washing machine or dishwasher rinse cycle)."},{"checked":false,"id":1,"is_red":false,"text":"Corrosion due to galvanic reaction/electrolysis was observed at one or more locations of the water supply system. Please visit www.copper.org/applications/plumbing/techcorner/pdf/galvanic_corrosion.pdf\n Recommend upgrading system due to potential failure of water lines without notice by qualified contractors."},{"checked":false,"id":1,"is_red":false,"text":"Improper connection of copper to galvanized pipe was observed at one or more locations of the water supply system. Please visit www.copper.org/applications/plumbing/techcorner/pdf/galvanic_corrosion.pdf\n Recommend review and repair by a Qualified Plumber to upgrading system due to premature deterioration of water lines if left in disrepair."},{"checked":false,"id":1,"is_red":false,"text":"Plumbing pipes not fully visible for inspection due to finished ceilings and walls."},{"checked":false,"id":1,"is_red":false,"text":"Home is equipped with portions of Galvanized water lines. Typical lifespan of galvanized plumbing is 30 years. Recommend budgeting for replacement in the future due to the restriction/ loss of pressure/rust in water/rupture or leaks due to corrosion of pipes from the inside surface."},{"checked":false,"id":1,"is_red":false,"text":"Recommended considering PEX (Cross Linked Polyethylene) as an economical means of repair to damage/deteriorated water lines. Please visit http://pexinfo.com/ for more info on pex and installation practices."},{"checked":false,"id":1,"is_red":false,"text":"Portions of the supply lines are wrapped in a material that is consistant with Asbestos. Without sending a sample to a lab for analysis this cannot be confirmed. <FYI>"},{"checked":false,"id":1,"is_red":false,"text":"Absestos like material observed in poor condition needs review and removal. Please visit www.epa.gov/asbestos/ for further information on this potential health risk"},{"checked":false,"id":1,"is_red":false,"text":"Recommend review of water supply line system by a qualified plumber."},{"checked":false,"id":1,"is_red":false,"text":"Gate valve/s observed at one or more locations. This type of valve has a history of leaking at the stem seal with age, recommend monitor for leaks and budgeting for upgrading to ball type valves."},{"checked":false,"id":1,"is_red":false,"text":"Saddle valve observed in water supply line. These type of valves pierce the pipe with a needle and are known to fail without notice. Recommend review and repair by a Qualified Plumbing Contractor BEFORE seal fails, causing damage to structure and personal belongings."},{"checked":false,"id":1,"is_red":false,"text":"Damaged/open supply line noted and needs repair by a qualified plumber."},{"checked":false,"id":1,"is_red":false,"text":"Leaking observed in water pipe/s or valve at time of inspection. Recommend review and repair by a Qualified Plumber."},{"checked":false,"id":1,"is_red":false,"text":"Polybutylene piping observed and is considered a material known for leaking and failure and the subject of class action litigation. The inspector cannot predict the future of this system. Recommend further evaluation and potential replacement by a qualified professional. Whenever polybutylene is encountered we encourage our clients to contact the Plumbers Claims Group for more information,such as warranties, etc. (1-800-356-3496)"},{"checked":false,"id":1,"is_red":false,"text":"Pipe insulation is recommended to eliminate condensation from forming on cold water supply lines causing stains on floors/ceiling coverings and excess moisture in dwelling as well."},{"checked":false,"id":1,"is_red":false,"text":"Supply lines are susceptible to damage due to location in unheated crawlspace. Proper weatherization will be needed to prevent damage to water lines.  Review and repairs/upgades recommended. "},{"checked":false,"id":1,"is_red":false,"text":"Poly Vinyl Chloride \"PVC\" plumbing was observed and is not an approved material for domestic water supply use. Most local building authorities allow PVC and Polyethylene piping in cold water distribution and ONLY outside the building. Recommend further review and repairs by a Qualified Plumbing Contractor familiar with local building regulations."},{"checked":false,"id":1,"is_red":false,"text":"Lack of a proper dielectric union at copper and galvanized connection was observed. Recommend repairs to prevent corrosion of galvanized pipe."},{"checked":false,"id":1,"is_red":false,"text":"Damaged/deteriorated valve/s noted and is in need of repair by a Qualified Plumber to allow proper function of shut off valve/s."},{"checked":false,"id":1,"is_red":false,"text":"Uncapped supply line/valve noted. All water pipes not supplying a fixture must be properly terminated/capped to prevent possible water damage and or personal injury from scald burns if valve is accidentally operated."},{"checked":false,"id":1,"is_red":false,"text":"Copper and galvanized water lines connected without di-electric fittings. This causes electrolysis, which leads to rust, corrosion, and eventually leaks. Ideally, where copper and galvanized water lines are connected, they should be separated by a dielectric fitting. Suggest review by a licensed plumber prior to closing for repairs/replacement as needed."},{"checked":false,"id":1,"is_red":false,"text":"Galvanized water lines rust from the inside out and can become restricted over time. When low water flow is observed at plumbing fixtures, some restriction may have occurred. We suggest further review by a licensed plumbing contractor prior to closing for repairs/replacement as needed to ensure proper water flow."},{"checked":false,"id":1,"is_red":false,"text":"Poorly supported  piping observed at . Recommend installing additional pipe hangers as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Possible asbestos materials observed. The materials were torn, ripped, or damaged at the time of inspection. This is a possible safety hazard. Suggest further review by a licensed asbestos testing lab be performed prior to closing for repairs/replacement needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"The water supply system in this home utilizes Plastic Polybutylene Piping (PB).  While millions of residential homes have used PB throughout the United States, buyer should be aware of the past problems related to failures with the fittings of these pipes as well as other related leaks and problems associated with PB.  Suggest client obtain history of failures with sellers prior to close.  Other information can be obtained by call for the PB handbook at (630) 858-6540 or (800) 356-3496."},{"checked":false,"id":1,"is_red":false,"text":"While environmental concerns and other chemical testing are beyond the scope of the inspection, your inspector's experience leads him to suspect that the materials used on the main water service lines may contain lead. Lead can be hazardous to your health, therefore it is recommended that a Water chemical test be performed prior to closing to determine if your water supply system meets proper and safe health standards. Due to safety concerns client should consider future replacement of the lead pipes."}],"sepChoice":"1","title":"Plumbing "}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Plumbing Materials Overall"}],"title":"Plumbing"},{"damage_panels":[{"descr":"","id":2258,"options":[{"checked":false,"id":1,"is_red":false,"text":"Some outlets not accessible due to furniture and or stored personal items."},{"checked":false,"id":1,"is_red":false,"text":"It is HIGHLY recommended to(have a qualified electrician) install an Arc Fault Circuit Interrupter breaker in place of the the one currently protecting the bedroom circuits,in the near future it will be a requirement and is a very safe and sound update."},{"checked":false,"id":1,"is_red":false,"text":"Bedroom circuits are NOT protected by an arc fault circuit interrupter type breaker. An arc fault interrupter will shut itself off if it detects a short, thus preventing an electrical fire."},{"checked":false,"id":1,"is_red":false,"text":"2-prong outlets -\nThe home contained outdated, ungrounded 2-prong electrical outlets. Although this condition may have been commonly considered safe or acceptable at the time the home was originally constructed, as general knowledge of safe building practices has improved with the passage of time, building standards have changed to reflect current understanding. Consider updating the existing condition to meet generally-accepted current standards.\n"},{"checked":false,"id":1,"is_red":false,"text":"Some loose and improperly installed receptacles were found, they should be installed correctly by a licensed electrician. Several are wired in reverse, one is poorly grounding."},{"checked":false,"id":1,"is_red":false,"text":"Some receptacles were painted over."},{"checked":false,"id":1,"is_red":false,"text":"It is recommended to avoid use of multiplier outlet plug ins ( converts 2 into 6 outlets ) "},{"checked":false,"id":1,"is_red":false,"text":"Missing outlet covers - throughout home.  See pictures."},{"checked":false,"id":1,"is_red":false,"text":"Open ground - receptacle in wall across from windows in dining room."},{"checked":false,"id":1,"is_red":false,"text":"Several outlets were found to have been reverse polarity wired, see pics for locations. Have an electrician evaluate and repair."},{"checked":false,"id":1,"is_red":false,"text":"Reverse polarity- 2 receptacles. one in dining room left of window, one in front room on same wall as door. Have electrician rewire."},{"checked":false,"id":1,"is_red":false,"text":"Most receptacles , except where noted, are in fair condition and tested ok, some are painted over."},{"checked":false,"id":1,"is_red":false,"text":"Open ground- receptacle in basement"},{"checked":false,"id":1,"is_red":false,"text":"Have a qualified electrician repair items listed following a complete evaluation of the electrical system."},{"checked":false,"id":1,"is_red":false,"text":"The receptacles near laundry machines are polarized and should be GFCI"},{"checked":false,"id":1,"is_red":false,"text":"The kitchen receptacles are not GFCI protected. have one installed upstream of the other receptacles or install a GFCI breaker in the distribution box(electrical panel)."},{"checked":false,"id":1,"is_red":false,"text":"The majority of grounded receptacles , were tested and found to be wired correctly."},{"checked":false,"id":1,"is_red":false,"text":"Loose receptacle outlet to left of entrance door."},{"checked":false,"id":1,"is_red":false,"text":"Surface mount wiring in the bedroom- an outlet box has become loose and needs to be re affixed to the wall."},{"checked":false,"id":1,"is_red":false,"text":"missing switch plate covers were found, make sure they are replaced."},{"checked":false,"id":1,"is_red":false,"text":"Worn switches noted."},{"checked":false,"id":1,"is_red":false,"text":"Worn outlets noted."},{"checked":false,"id":1,"is_red":false,"text":"Outlet cover plates missing."},{"checked":false,"id":1,"is_red":false,"text":"Switch cover plates missing."},{"checked":false,"id":1,"is_red":false,"text":"Loose outlets noted."},{"checked":false,"id":1,"is_red":false,"text":"Loose switches noted."},{"checked":false,"id":1,"is_red":false,"text":"All original knob and tube wiring appears to have been removed."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum wiring is now a concern with insurance companies due to fire risk.  Buyer is urged to confirm insurability and any related conditions that insurance company may place on this house.  Further inspection of this system may be required.  The inspector CANNOT ensure compliance of this electrical system for insurance purposes."},{"checked":false,"id":1,"is_red":false,"text":"Dimming lights were observed, this may be an indication of inadequate electrical distribution. We recommend review by a licensed electrician for evaluation and redistribution as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Improper use of extension cord observed. Extension cords should not be permanently installed or be routed through walls, floors or partitions."},{"checked":false,"id":1,"is_red":false,"text":"Insulation has been installed over knob and tube wiring at various locations. This is a fire \"Safety Concern\". Suggest review by a licensed electrician prior to closing to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Knob and tube wiring was observed in this home. This type of wiring was standard at the time of construction, and unless otherwise noted, appears to be in serviceable condition."},{"checked":false,"id":1,"is_red":false,"text":"Missing cover plates observed, suggest installing for safety."},{"checked":false,"id":1,"is_red":false,"text":"Open junction boxes were observed, which is a safety concern. Recommend installing proper covers, as needed, for safety."},{"checked":false,"id":1,"is_red":false,"text":"Recommend full review by qualified electrical contractor for quotes on upgrades/repair to ensure safe and adequate service."},{"checked":false,"id":1,"is_red":false,"text":"Reversed polarity, hot and neutral reversed and other terms used for electric receptacles are usually easily corrected by minor wiring adjustments at the specified item. When these conditions are noted in this report, a licensed electrician should be consulted for repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Since ungrounded receptacles were noted in the home, buyer is cautioned that proper grounding is strongly urged where sensitive electronic equipment is used.  Ungrounded receptacles do not offer protection for computers etc.  Consultation with a qualified electrical contractor is recommended."},{"checked":false,"id":1,"is_red":false,"text":"Ungrounded receptacles observed at water sources or exterior locations ideally should be grounded, suggest installing GFCI's for safety."},{"checked":false,"id":1,"is_red":false,"text":"**ARC FAULT PROTECTION**"},{"checked":false,"id":1,"is_red":false,"text":"No Arc-Fault Circuit Interrupter (AFCI) protection was installed to protect electrical circuits in bedrooms.\n Building codes with which new homes must comply require the installation of AFCI protection of all bedroom outlets. This type of protection is designed to detect electrical arcing, which is a potential fire hazard. \nAlthough AFCI protection was not required at the time the home was originally constructed, as general knowledge of safe building practices has improved with the passage of time, building standards have changed to reflect current understanding. Consider updating the existing electrical to provide AFCI protection.\nArc-fault protection can be provided using either of two methods:\n1. Arc Fault Circuit Interrupters (AFCI's) electrical outlets which have this capability built in. \n2. AFCI circuit breakers installed at the main electrical panel which provide this protection to all non-AFCI outlets on the circuit controlled by that AFCI breaker.\n\n"},{"checked":false,"id":1,"is_red":false,"text":"Test AFCI breakers periodically to ensure proper operation."},{"checked":false,"id":1,"is_red":false,"text":"Damaged AFCI needs to be replaced"},{"checked":false,"id":1,"is_red":false,"text":"There is no AFCI protection. "},{"checked":false,"id":1,"is_red":false,"text":"All bedroom circuits are now required to be AFCI protected."},{"checked":false,"id":1,"is_red":false,"text":"The AFCI did not trip properly. This is a safety concern as the AFCI is designed to trip. Recommend repair or replacement of defective AFCI."},{"checked":false,"id":1,"is_red":false,"text":"This type of AFCI has been recalled."},{"checked":false,"id":1,"is_red":false,"text":"Installed AFCIs responded to test"},{"checked":false,"id":1,"is_red":false,"text":"One AFCI protected circuit failed to test at the service panel.  Recommend licensed electrician replace AFCI Circuit Breaker"},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Modern electrical codes require branch circuits at all bedrooms to be AFCI protected. The electrical code at the time this house was built may not have required AFCI protection at these circuits. Nonetheless, we strongly recommend they be added to all bedroom circuits as an extra preventive fire safety measure. Licensed electrician recommended."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: There is no AFCI protection in this house. There is the potential for a fire hazard. Recommend a licensed electrician provide an estimate on installing AFCI protection. "},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Licensed electrician add additional AFCI protection for @@@@@@@"},{"checked":false,"id":1,"is_red":false,"text":"**SYSTEMS NOT TESTED**"},{"checked":false,"id":1,"is_red":false,"text":"A low voltage alarm system and a low voltage intercom system are installed. Due to the specialized nature of these systems, we suggest that you review these systems with the seller. As per our Inspection Agreement, these systems are beyond the scope of this report and were not inspected."},{"checked":false,"id":1,"is_red":false,"text":"A low voltage alarm system is installed. Due to the specialized nature of these systems, we suggest that you review this system with the seller. As per our Inspection Agreement, this system is beyond the scope of this report and was not inspected."},{"checked":false,"id":1,"is_red":false,"text":"A low voltage intercom system is installed. Due to the specialized nature of these systems, we suggest that you review this system with the seller. As per our Inspection Agreement, this system is beyond the scope of this report and was not inspected."}],"sepChoice":"4","title":"Basement Electric"},{"descr":"","id":2259,"options":[{"checked":false,"id":1,"is_red":false,"text":"GFCI did not respond to test, suggest replacing for safety."},{"checked":false,"id":1,"is_red":false,"text":"GFCI had power when tripped.  This is often the result of miswiring and is usually easily fixed.  Advise repair on replacement as needed."},{"checked":false,"id":1,"is_red":false,"text":"Ground Fault Circuit Interrupters (GFCI) were not required when the home was built. Suggest client consider upgrading with GFCI's at all receptacles near water sources, such as the kitchen, the bathrooms, the garage, and exterior receptacles to enhance safety. Upgrades should be performed by a licensed electrician."},{"checked":false,"id":1,"is_red":false,"text":"Test GFCIs monthly to ensure proper operation."},{"checked":false,"id":1,"is_red":false,"text":"The GFCI is loose and needs to be secured."},{"checked":false,"id":1,"is_red":false,"text":"Damaged GFCI needs to be replaced at @@@@@@@@@"},{"checked":false,"id":1,"is_red":false,"text":"There is no GFCI protection at @@@@@@@@"},{"checked":false,"id":1,"is_red":false,"text":"Outlets in the basement were not Ground Fault Circuit Interrupter (GFCI) protected. Adding GFCI protection is relatively inexpensive. All electrical work should be performed by a qualified electrical contractor.\r\nConsider adding GFCI protection of these outlets.\r\n"},{"checked":false,"id":1,"is_red":false,"text":"There is no GFCI protection. There is the potential for an electric shock hazard.  Recommend a licensed electrician to provide an estimate on installing GFCI protection. "},{"checked":false,"id":1,"is_red":false,"text":"There is no GFCI protection at the kitchen, garage, bathrooms and exterior. These areas are now required to have GFCI protection. Recommend a licensed electrician evaluate installing GFCI’S. "},{"checked":false,"id":1,"is_red":false,"text":"There are no GFCI protected circuits in this house. This is a potential shock hazard. This was not required when this house was originally built. However, for your protection, I highly recommend a licensed electrician install GFCI protected circuits at your kitchen counters and in all the bathrooms."},{"checked":false,"id":1,"is_red":false,"text":"@@BLACK@@ Kitchen countertop accessible receptacles are not GFCI protected. There is the potential for a shock hazard. This was not required when this house was originally built. However, there has been some remodeling in the kitchen. This requires GFCI upgrade to all outlets accessible from the countertop."},{"checked":false,"id":1,"is_red":false,"text":"@@RED@@ SAFETY CONCERN:  Recommend licensed electrician provide GFCI upgrade to the all kitchen countertop accessible receptacles."},{"checked":false,"id":1,"is_red":false,"text":"For your protection -- all kitchen outlets/receptacles accessible from the counter top are now required to be GFCI protected."},{"checked":false,"id":1,"is_red":false,"text":"There is no GFCI protection at the laundry. This was required as of 2005. Recommend installing to meet current safety standards."},{"checked":false,"id":1,"is_red":false,"text":"The GFCI did not trip properly. This is a safety concern as the GFCI is designed to trip. Recommend repair or replacement of defective GFCI."},{"checked":false,"id":1,"is_red":false,"text":"GFCI had power when tripped. This is often the result of improper wiring and is usually easily fixed. Advise repair on replacement as needed. "},{"checked":false,"id":1,"is_red":false,"text":"The GFCI did not trip properly. "},{"checked":false,"id":1,"is_red":false,"text":"Whirlpool tub motor in the master  bath (#1) is not  GFCI protected.  Recommend licensed electrician install GFCI protection. This is protection from electrical shock."},{"checked":false,"id":1,"is_red":false,"text":"Installed GFCIs responded to test."},{"checked":false,"id":1,"is_red":false,"text":"Bathroom GFCI outlets reset at @@@@@"},{"checked":false,"id":1,"is_red":false,"text":"GFCI in place and tested operational at rear of home."},{"checked":false,"id":1,"is_red":false,"text":"There is no GFCI protection. Location: There is the potential for a shock hazard. See required locations in report binder or email attachment. Recommend a licensed electrician to provide an estimate on installing GFCI protection. "},{"checked":false,"id":1,"is_red":false,"text":"The GFCI did not trip properly. This is an electrical shock safety concern. Recommend repair or replacement of defective GFCI."},{"checked":false,"id":1,"is_red":false,"text":"Exterior receptacle at rear did not appear to be GFCI protected."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Licensed electrician add additional exterior outlet/receptacle at @@@@@@@@ of the house. "},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Modern safety codes require any branch circuit outlets accessible from the kitchen countertop(s) to be GFCI protected. At the time this house was built, this may not have required  protection. Nonetheless, we strongly recommend they be added at these locations as an extra preventative safety measure. "},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Licensed electrician add a dedicated non-GFCI protected outlet in the garage if you plan to have a refrigerator operating in the garage.  This will prevent the possibility of food spoiling with an unnoticed GFCI trip.."},{"checked":false,"id":1,"is_red":false,"text":"The right GFCI receptacle on basement wall, opposite the bar, is not able to reset; it appears the receptacle has failed and must be replaced with a new GFCI."}],"sepChoice":"4","title":"GFCI"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Basement Electric Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"GFCI Overall"}],"title":"Electric"},{"damage_panels":[{"descr":"","id":2260,"options":[{"checked":false,"id":1,"is_red":false,"text":"Handrails missing on exterior stairs."},{"checked":false,"id":1,"is_red":false,"text":"Exterior entrance is in serviceable condition."}],"sepChoice":"4","title":"Access"}],"inspection_panels":[{"descr":"","id":3090,"options":[{"checked":false,"id":1,"is_red":false,"text":"Exterior stairway noted."},{"checked":false,"id":1,"is_red":false,"text":"\"Bilco\" style exterior entrance."},{"checked":false,"id":1,"is_red":false,"text":"Exterior hatch door."}],"sepChoice":"1","title":"Basement/Crawlspace Access"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Access Overall"}],"title":"Access"},{"damage_panels":[{"descr":"","id":2261,"options":[{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the stairs are near the end of their useful life."},{"checked":false,"id":1,"is_red":false,"text":"No light observed, suggest installing a light fixture in stairway for safety."},{"checked":false,"id":1,"is_red":false,"text":"Peeling paint observed, suggest scraping and painting as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Possible trip hazard. This is a safety concern. Suggest repair/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified professional for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Stairs have inadequate headroom, this is a safety concern."},{"checked":false,"id":1,"is_red":false,"text":"Whenever three or more stairs are present a handrail is usually required."},{"checked":false,"id":1,"is_red":false,"text":"Nail sticking out presents possible hazard to occupants, repairs recommended."},{"checked":false,"id":1,"is_red":false,"text":"Step rise appears to be inconsistent or insufficient. Current building practices allow a max difference of 3/8 inch in step height as well as a minimum of 4 inch riser height. This is something that might be difficult/expensive to repair, but needs to be brought to your attention as a potential safety hazard."},{"checked":false,"id":1,"is_red":false,"text":"Current building standards require illumination at stairways and landings, recommend adding light fixture over stairway for enhanced safety to occupants and guests."},{"checked":false,"id":1,"is_red":false,"text":"Stair stringers appear to be over cut OR structural integrity appears to be compromised. Recommend review and repair by qualified contractor."},{"checked":false,"id":1,"is_red":false,"text":"Current building standards do not allow a door to swing Over or towards a stairway due to possible safety hazard potential. Recommend changing door to swing away from stairs to enhance safety to occupants."},{"checked":false,"id":1,"is_red":false,"text":"Lighting for stairway light is only controlled by main floor switch.<FYI>"},{"checked":false,"id":1,"is_red":false,"text":"Step treads are inadequate by todays building standards, a minimum of 10 inches of tread depth is required. Review and repairs are recommended for enhanced safety to occupants."},{"checked":false,"id":1,"is_red":false,"text":"Low head room noted at stairway location."},{"checked":false,"id":1,"is_red":false,"text":"Recommend adding support to stairs stringers due to excess flexing noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Stair light fixture into basement is not on a 3 way switch. This is not a defect but typically the light is controlled at the top and the bottom of the staircase. A qualified electrician can upgrade and prevent the light from only being controlled from the top of the stairway.\n"},{"checked":false,"id":1,"is_red":false,"text":"Handicap chair lift present in home, which is uncommon and inspection was limited. Inspector operated unit and appeared fully functional at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Unprofessional building practice/materials used, further review by a Qualified Contractor is recommended."}],"sepChoice":"4","title":"Stairs"},{"descr":"","id":2262,"options":[{"checked":false,"id":1,"is_red":false,"text":"Hand/Guardrail is loose. Recommend review for repair as necessary for safety."},{"checked":false,"id":1,"is_red":false,"text":"Missing guardrails observed. This is a \"Safety Concern\". Although guardrails may not have been required when the home was built, we recommend client consider installing guardrails as a safety enhancement."},{"checked":false,"id":1,"is_red":false,"text":"Partial handrail observed, recommend installing handrail as necessary for safety."},{"checked":false,"id":1,"is_red":false,"text":"Spacing between guardrails appears larger than 4 inches which may allow small children to crawl through the space. Client may wish to reduce spacing as a child safety enhancement."},{"checked":false,"id":1,"is_red":false,"text":"Railing appears to lack proper support, recommend review and repair for safety to occupants."},{"checked":false,"id":1,"is_red":false,"text":"Railing lacks the proper return to wall that is required by current building standards, repair recommended for enhanced safety to occupants."},{"checked":false,"id":1,"is_red":false,"text":"Stair railing appears to be insufficient/improper by current building standards which require handrail return to wall or newel posts at top and bottom of staircase as well as be located a minimum of 34 in. and a max of 38 in. from ground."},{"checked":false,"id":1,"is_red":false,"text":"Hand rail is loose/damaged/missing and is in need of repair/installation for enhanced safety to occupants."},{"checked":false,"id":1,"is_red":false,"text":"Recommend installing handrail with spindles that do not allow a 4\" sphere to pass between openings. This is to prevent small children from slipping through/getting their heads lodged between spindles."}],"sepChoice":"4","title":"Railings"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Stairs Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Railings Overall"}],"title":"Stairs"},{"damage_panels":[{"descr":"","id":2263,"options":[{"checked":false,"id":1,"is_red":false,"text":"Standing water noted on slab at time on inspection, review and repair needed to prevent possible water damage."},{"checked":false,"id":1,"is_red":false,"text":"Slab appears to have major cracking at one or more locations."},{"checked":false,"id":1,"is_red":false,"text":"Does not appear to have proper footing at perimeter apron."},{"checked":false,"id":1,"is_red":false,"text":"Recommend further review by a Qualified Foundation Contractor familiar with this type of foundation."},{"checked":false,"id":1,"is_red":false,"text":"All concrete floor slabs experience some degree of cracking due to shrinkage in the drying process.  In most instances floor coverings prevent recognition of cracks or settlement in all but the most severe cases.  Where carpeting and other floor coverings are installed, the materials and condition of the flooring underneath cannot be determined. "},{"checked":false,"id":1,"is_red":false,"text":"Common cracks noted."},{"checked":false,"id":1,"is_red":false,"text":"Common cracks noted.  Recommend consultation with qualified contractor should condition worsen or water intrusion occur."},{"checked":false,"id":1,"is_red":false,"text":"Efflorescence observed; this is a mineral deposit left behind from exterior water infiltration."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of past water penetration observed."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of repairs observed, unable to determine the effectiveness of these repairs."},{"checked":false,"id":1,"is_red":false,"text":"Expansive cracks and settling observed, suggest sealing cracks as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Floor drain is full of debris."},{"checked":false,"id":1,"is_red":false,"text":"Floor has been painted."},{"checked":false,"id":1,"is_red":false,"text":"Many slabs are found to contain cracks when the flooring or carpet and padding are removed, but there is no absolute standard for evaluating them. Those that are less than ¼\" wide and which exhibit no significant vertical or horizontal displacement are not regarded as being structurally threatening. They typically result from common shrinkage, but can also be caused by a deficient mixture of concrete, deterioration through time, seismic activity, expansive soil (such as clay), and poor drainage, and if they are not sealed they can allow moisture to enter a residence, particularly if roof drainage downspouts terminated next to the slab."},{"checked":false,"id":1,"is_red":false,"text":"Some minor cracks in basement floor.  (common)"},{"checked":false,"id":1,"is_red":false,"text":"Basement floor exhibits cracking/minor heaving in several places, this is to be expected in a home of this age."},{"checked":false,"id":1,"is_red":false,"text":"Basement floor is painted."},{"checked":false,"id":1,"is_red":false,"text":"Basement floor is only partially completed."}],"sepChoice":"4","title":"Slab Floor"},{"descr":"","id":2264,"options":[{"checked":false,"id":1,"is_red":false,"text":"Open seams observed."},{"checked":false,"id":1,"is_red":false,"text":"Popping floor tile observed."},{"checked":false,"id":1,"is_red":false,"text":"Possible trip hazard. This is a safety concern. Suggest repair/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Tile has been painted/refinished, suggest taking care when cleaning to protect the surface."},{"checked":false,"id":1,"is_red":false,"text":"Waviness noted in hardwood floor.  This may be a result of high humidity levels."},{"checked":false,"id":1,"is_red":false,"text":"Slab is partially covered with 9x9 linoleum tile in finished basement."},{"checked":false,"id":1,"is_red":false,"text":"Unfinished ( laundry/ utility room) area floor is painted with what appears top be an epoxy floor coating."},{"checked":false,"id":1,"is_red":false,"text":"The majority of the concrete basement floor slab was not visible due to floor coverings in the finished basement."}],"sepChoice":"4","title":"Finished Floor"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Slab Floor Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Finished Floor Overall"}],"title":"Floors"},{"damage_panels":[{"descr":"","id":2265,"options":[{"checked":false,"id":1,"is_red":false,"text":"Recommend further review of current perimeter foundation drainage system by a Qualified Foundation Drainage Contractor. Drain pit appears to be insufficient and may allow water to enter structure in the event of a heavy rainfall."},{"checked":false,"id":1,"is_red":false,"text":"The home has an interior drainage system. It is advised to obtain documentation and warranty information from current owner."}],"sepChoice":"4","title":"Drainage"},{"descr":"","id":2266,"options":[{"checked":false,"id":1,"is_red":false,"text":"Functional at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Sump discharges thru exterior wall next to structure. Recommend review of current plumbing configuration to conform to local building zone regulations.  "},{"checked":false,"id":1,"is_red":false,"text":"Unprofessional sump pump installation noted, recommend review by a qualified contractor."},{"checked":false,"id":1,"is_red":false,"text":"Operation of sump/ejector pump was not performed at the time of inspection due to no readily accessible water source to test for proper function of float and pump."},{"checked":false,"id":1,"is_red":false,"text":"Unprofessional installation of pump plumbing, recommend review and repairs by a Qualified Plumber."},{"checked":false,"id":1,"is_red":false,"text":"Leak in plumbing noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Recommend further review of current drainage pit system. Recommend upgrading of current pump for enhanced reliability of discharge water in case of power outage. Recommend installation of a battery backup sump pump by a qualified contractor to provide peace of mind to occupants and protection of personal belongings. "},{"checked":false,"id":1,"is_red":false,"text":"Recommend replacing the wood cover with plastic or other material that prevents unwanted organic growth which can cause unwanted indoor mold issues."},{"checked":false,"id":1,"is_red":false,"text":"Sump pump has debris in pit, recommend routine cleaning to prevent possible backup causing damage to flooring/personal belongings."},{"checked":false,"id":1,"is_red":false,"text":"Sump pump float appears to need adjustment to prevent overflow and possible damage to framing, furnace base and personal belongings."},{"checked":false,"id":1,"is_red":false,"text":"Pump is unplugged and not available for inspection. Recommend sump pump be brought up to working order for it to perform as designed."},{"checked":false,"id":1,"is_red":false,"text":"Recommend adding/repairing cover to sump pit."},{"checked":false,"id":1,"is_red":false,"text":"Recommend proper sealing by adding fasteners to the  sump cover."},{"checked":false,"id":1,"is_red":false,"text":"Sump present, but not tested due to no power/ not plugged in."},{"checked":false,"id":1,"is_red":false,"text":"Recommend budgeting for a Qualified Plumber to install a back flow preventer valve to prevent the possibility of a sewer backup in the event of a drain line clog."},{"checked":false,"id":1,"is_red":false,"text":"Lack of sufficient support to pump discharge pipe, recommend additional support."},{"checked":false,"id":1,"is_red":false,"text":"Sump pump not operational at time of inspection, repairs recommended.\n"},{"checked":false,"id":1,"is_red":false,"text":"Pump discharges into an unknown location, further review is recommended to confirm that proper discharge location practices have been followed."},{"checked":false,"id":1,"is_red":false,"text":"Sump pump is currently plugged into a GFCI receptacle. Recommend installation of a dedicated receptacle to prevent unwanted water damage in the event that the GFCI is tripped, leaving the sump pump non functional."}],"sepChoice":"4","title":"Sump Pump"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Drainage Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Sump Pump Overall"}],"title":"Drainage"},{"damage_panels":[{"descr":"","id":2267,"options":[{"checked":false,"id":1,"is_red":false,"text":"**JOISTS**"},{"checked":false,"id":1,"is_red":false,"text":"Appears Functional."},{"checked":false,"id":1,"is_red":false,"text":"Improper cutting/over notching of floor joist noted. Recommend review and repair by a qualified contractor to provide proper support to load bearing floor system."},{"checked":false,"id":1,"is_red":false,"text":"Deterioration/ damage of one or more floor joist noted. Recommend review and repair by a Qualified Contractor to evaluate load bearing members."},{"checked":false,"id":1,"is_red":false,"text":"Floor joists not properly supported at load bearing points. Installation of joist hanger's or other means of support are needed. Recommend review and repair by a qualified contractor. "},{"checked":false,"id":1,"is_red":false,"text":"Some areas are not visible for inspection due to wall/ceilings covered which prevents review of structural members."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review of floor support system by a qualified contractor for any repair or upgrades needed to structure."},{"checked":false,"id":1,"is_red":false,"text":"Visible evidence of Wood Destroying Organisms observed. Recommend obtaining a termite inspection to confirm that no active infestation exists."},{"checked":false,"id":1,"is_red":false,"text":"Support beam lacks the proper 1/2 inch clearance around beam that is required by current building standards, recommend review and repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Damage from what appears to be caused by Wood Destroying Organisms is noted, Recommend review of support structure by a Qualified Contractor."},{"checked":false,"id":1,"is_red":false,"text":"Improper/insufficient repairs or upgrades are noted at support posts/joists. Further review for repairs and cost estimates are recommended to be performed by qualified contractors."},{"checked":false,"id":1,"is_red":false,"text":"Floor joist appear to be over spaces for proper support. Current building standards consist 16 inch spacing between joists. Recommend further review for repairs and costs."},{"checked":false,"id":1,"is_red":false,"text":"Not fully visible for inspection due to lack of access to all areas."},{"checked":false,"id":1,"is_red":false,"text":"Damaged or cracked floor joist is in need of repair/replacement by a qualified contractor."},{"checked":false,"id":1,"is_red":false,"text":"Support post/blocks appear to lack proper footing to support load, Review by a qualified foundation contractor is recommended."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of what could be the presence of wood destroying organisms, recommend further review by a Qualified Wood Destroying Organism Contractor to assure that no infestation is present."},{"checked":false,"id":1,"is_red":false,"text":"Some notching of joists on outer third of span.( 2x3 inch cutouts)"},{"checked":false,"id":1,"is_red":false,"text":"Ends of joist resting on steel beam should be nailed / screwed or otherwise secured together."},{"checked":false,"id":1,"is_red":false,"text":"There is cross bracing installed."},{"checked":false,"id":1,"is_red":false,"text":"Large cut outs on top portion of floor joists. Any large cut outs such as this one can cause a structural weakness and should be supported, or braced by a professional. Sistering of the section of joist is a common repair."},{"checked":false,"id":1,"is_red":false,"text":"Severely cracked floor joists near front of home. ( visible in basement )"},{"checked":false,"id":1,"is_red":false,"text":"Floors are shaky/ bouncy near entrance to kitchen and stairwell to attic. Have contractor evaluate."},{"checked":false,"id":1,"is_red":false,"text":"One or more joist hanger/s is improperly installed/lacks fasteners. Further review and repair by a Qualified contractor is recommended."},{"checked":false,"id":1,"is_red":false,"text":"**BEAMS**"},{"checked":false,"id":1,"is_red":false,"text":"There is a steel beam and the posts are steel as well."},{"checked":false,"id":1,"is_red":false,"text":"The posts and beam are are obscured by finish material."},{"checked":false,"id":1,"is_red":false,"text":"Wood beam and posts- as with any wood, monitor for any changes and maintain well for longevity."},{"checked":false,"id":1,"is_red":false,"text":"Beams are finished, unable to inspect."},{"checked":false,"id":1,"is_red":false,"text":"Beams are improperly cut."},{"checked":false,"id":1,"is_red":false,"text":"Beams are partially finished, unable to fully inspect."},{"checked":false,"id":1,"is_red":false,"text":"Beams are sagging."}],"sepChoice":"4","title":"Framing"},{"descr":"","id":2268,"options":[{"checked":false,"id":1,"is_red":false,"text":"Not fully visible for inspection due to lack of access."},{"checked":false,"id":1,"is_red":false,"text":"Cracked and water damaged joists observed."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of past fire, charred wood, observed."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of pest, wood destroying insect damage observed. Recommend review by a licensed pest inspector prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Framing has improperly bored holes. Bored holes are usually not accepted within 2 inches of the top or bottom of the joist and should not exceed 1/3 of the depth of the joist. Repair advised."},{"checked":false,"id":1,"is_red":false,"text":"Inaccessible."},{"checked":false,"id":1,"is_red":false,"text":"No bridging observed, recommend installing proper bridging to increase support and stability of the floor system."},{"checked":false,"id":1,"is_red":false,"text":"Joists have been improperly notched; repair advised. Notches on ends of joists should not exceed ¼ the depth of the joist. Notches should not be located in the middle 1/3 of the joist."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified professional for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Severed joist noted, no appreciable floor deflection at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Wood deterioration observed to floor framing members."},{"checked":false,"id":1,"is_red":false,"text":"Limited inspection due to finished ceiling."},{"checked":false,"id":1,"is_red":false,"text":"Deterioration noted at sub flooring by excessive deflection, recommend review and repair by a qualified contractor."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of past leaking, recommend monitor area and repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Visible leaking under bathroom."},{"checked":false,"id":1,"is_red":false,"text":"Mold like spores present, recommend further investigation by means of testing the indoor air quality for elevated mold spore counts due to excessive water intrusion for what appears to be an extended length of time. All-Tech is certified as a member of the Indoor Air Consultants, IAC2 certification #IAC2-00-8831. Please call us at 231-638-1622 or visit us on the web at   www.alltechinspect.com to schedule air sampling."},{"checked":false,"id":1,"is_red":false,"text":"Uneven in areas, causing finished floor covering to have high and low spots. Further review and repairs are recommended to be performed by Qualified Contractor."},{"checked":false,"id":1,"is_red":false,"text":"Previous repairs due to damage/decay observed."},{"checked":false,"id":1,"is_red":false,"text":"Patched or altered in areas.<FYI>"},{"checked":false,"id":1,"is_red":false,"text":"Evidence of damage due to moisture observed, repairs needed."},{"checked":false,"id":1,"is_red":false,"text":"Unprofessional repairs to sub-flooring needs review and repair by qualified contractors."},{"checked":false,"id":1,"is_red":false,"text":"Damage observed to sub-flooring/floor joists, which could possibly be caused by termites or other wood destroying organisms. Highly recommend further review by qualified pest inspector to determine if active or prior infestation has occured."},{"checked":false,"id":1,"is_red":false,"text":"Sub flooring is partially visible from basement."},{"checked":false,"id":1,"is_red":false,"text":"Appears to be of a more recent construction date than main home."},{"checked":false,"id":1,"is_red":false,"text":"Contact a licensed industrial hygienist to test for biological substances such as mold. "},{"checked":false,"id":1,"is_red":false,"text":"Some past water damage/stains near joists especially around bathroom area plumbing. No active leaks were discovered at time of inspection."}],"sepChoice":"4","title":"Subfloor"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Framing Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Subfloor Overall"}],"title":"Structure"},{"damage_panels":[{"descr":"","id":2269,"options":[{"checked":false,"id":1,"is_red":false,"text":"No deficiencies were observed at the visible portions of the structural components of the home."},{"checked":false,"id":1,"is_red":false,"text":"Columns are finished or concealed, unable to inspect."},{"checked":false,"id":1,"is_red":false,"text":"Columns and beams are partially finished, unable to fully inspect."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified professional for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Screw jacks are usually intended as temporary supports, recommend installing permanent support posts for safety."},{"checked":false,"id":1,"is_red":false,"text":"Steel column top flanges are not spot welded or bolted to the steel beams."}],"sepChoice":"4","title":"Columns"},{"descr":"","id":2270,"options":[{"checked":false,"id":1,"is_red":false,"text":"No deficiencies were observed at the visible portions of the structural components of the home."},{"checked":false,"id":1,"is_red":false,"text":"Finished walls prevent full review/ inspection of all support posts/beams and foundation walls."},{"checked":false,"id":1,"is_red":false,"text":"Foundation appears to lack footings at one or more area/s which warrant further review by a qualified contractor.  "},{"checked":false,"id":1,"is_red":false,"text":"Recommend additional lumber at load bearing framing wall to properly transfer static load to footing.\n\n"},{"checked":false,"id":1,"is_red":false,"text":"One or more support post/s lack fasteners to prevent possible kick-out of post at bottom. Review and repair by a Qualified Contractor recommended to prevent potential damage to structure/persons in the event of damage to post."},{"checked":false,"id":1,"is_red":false,"text":"Support posts may possibly lack  proper footings to disperse load bearing weight imposed at noted area. Recommend review of post and support structure by a qualified contractor."},{"checked":false,"id":1,"is_red":false,"text":"Unprofessional upgrades/repairs have been performed at support posts/beam location. Recommend review and proper repairs by a qualified contractor."},{"checked":false,"id":1,"is_red":false,"text":"Support post/blocks appear to lack proper footing to support load, Review by a qualified foundation contractor is recommended."}],"sepChoice":"4","title":"Piers"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Columns Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Piers Overall"}],"title":"Columns and piers"},{"damage_panels":[{"descr":"","id":2271,"options":[{"checked":false,"id":1,"is_red":false,"text":"Recommend using insulated ductwork in unconditioned spaces to prevent condensation from accumulating which could present potential mold issues in the ductwork or on the insulation."},{"checked":false,"id":1,"is_red":false,"text":"Recommend sealing all gaps, cracks and holes in the HVAC duct system for increased efficiency and lower energy bills."},{"checked":false,"id":1,"is_red":false,"text":"Heat ducts are wrapped with materials consistant with that containing asbestos which is a know cancer causing material. If in good condition and left undisturbed this material causes no need for alarm. Proper handling and abatement by Qualified contractors is recommended if repairs or upgrades are performed. "},{"checked":false,"id":1,"is_red":false,"text":"Asbestos \"type\" tape is noted to be in poor condition and should only be removed by a professional abatement contractor, due to the possible health hazards that exist."},{"checked":false,"id":1,"is_red":false,"text":"Homes heating and cooling duct system needs review and repair by a Qualified Contractor."},{"checked":false,"id":1,"is_red":false,"text":"One or more areas of the heat ductwork is damaged/deteriorated/not attached. Recommend review and repairs by a qualified HVAC contractor to enhance homes heating efficiency."},{"checked":false,"id":1,"is_red":false,"text":"Galvanized duct pipe is in direct contact with copper water supply line. Over time a hole will develop in the galvanized pipe due to a chemical reaction known as galvanic reaction. Recommend seperation of the two dissimilar metals."},{"checked":false,"id":1,"is_red":false,"text":"Unprofessional use of foil duct piping noted at one or more locations, this is an inferior product and recommend review and upgrading to a metal galvanized pipe by a qualified heating contractor."},{"checked":false,"id":1,"is_red":false,"text":"Recommend further support to ductwork."},{"checked":false,"id":1,"is_red":false,"text":"Return air duct does not appear to properly connect to return plenum, further review and repair recommended."},{"checked":false,"id":1,"is_red":false,"text":"Improper duct tape observed. HVAC tape is needed."},{"checked":false,"id":1,"is_red":false,"text":"There is no heat source for @@@LOCATION@@@."},{"checked":false,"id":1,"is_red":false,"text":"Damaged flex vent in attic. Little or no conditioned air available to @@@@@@@. Recommend HVAC contractor repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Bent flex vent in attic due to improper installation of hanging straps. Little or no conditioned air available to @@@@@@@. Recommend HVAC contractor repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Blower compartment safety disconnect was inoperable or disabled at the time of inspection, which is a safety concern.  Recommend review for repair as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Cold air return intake observed near unit, which may result in back drafting and mixing of combustion by-products with interior circulation air.  This is a safety concern."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the distribution/ducting is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"No cold air return observed in finished basement, which may result in inadequate heating in this area."},{"checked":false,"id":1,"is_red":false,"text":"No leaks were observed at the time of the inspection."},{"checked":false,"id":1,"is_red":false,"text":"Recommend confirming proper operation prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a licensed heating contractor for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Suggest sealing opening at the condensate drain line."},{"checked":false,"id":1,"is_red":false,"text":"Cold air return intake observed near unit, which may result in backdrafting and mixing of combustion byproducts with interior circulation air.  This is a safety concern."},{"checked":false,"id":1,"is_red":false,"text":"Possible asbestos materials observed. The materials appeared to be in serviceable condition at the time of inspection. Asbestos materials are considered safe by the EPA if they are not disturbed, torn, ripped, or damaged. No torn, ripped, or damaged materials were observed. If client has any concerns regarding asbestos materials, an asbestos testing lab should be consulted for further review to ensure safety."}],"sepChoice":"4","title":"Basement/Crawlspace Ductwork"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Basement/Crawlspace Ductwork Overall"}],"title":"Ductwork"}],"title":"Basement/Crawlspace"},{"id":10,"tabbed_panels":[{"damage_panels":[{"descr":"","id":2135,"options":[{"checked":false,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection at main panel box."},{"checked":false,"id":1,"is_red":false,"text":"Panel cover screw(s) missing."},{"checked":false,"id":1,"is_red":false,"text":"Sharp-pointed metal screws hold panel cover in place.  These are a potential hazard as they may puncture wire insulation and electrify panel box, becoming a shock or electrocution hazard.  These screws should be replaced with approved, flat-tipped screws."},{"checked":false,"id":1,"is_red":false,"text":"Open breaker panel slot(s) at panel box cover.  Electrocution hazard."},{"checked":false,"id":1,"is_red":false,"text":"Panel cover missing, exposing live electrical wires as an electrocution hazard."},{"checked":false,"id":1,"is_red":false,"text":"Knockouts need snap-in caps inside panel box.  Should be installed to keep mice out of panel box and to avoid potential electrocution hazard. "},{"checked":false,"id":1,"is_red":false,"text":"Double tapped breaker(s) inside panel box (more than one electrical conductor attached).  This is not standard practice, and may cause overheating or even an electrical fire.  Recommend evaluation by an electrician.  Double tapping and lugging can create hot spots on breakers and neutral bars because they are not tightened to the correct torque--especially if two different size conductors are used. Because the hot [black] and neutral [white]wires are both current carrying conductors, the chance is then greater for potential hot spots. If the double tap or lug becomes loose, it begins to arc. As it arcs it builds up carbon. Carbon is then resistance and with more carbon buildup the more difficult it is for the conductor to make contact, thus increasing the current. The end result can be the breaker tripping because of the loose connection [current exceeding the rating of the breaker], or signs of overheating such as discolored wires, melted wires, etc, or even fire."},{"checked":false,"id":1,"is_red":false,"text":"Bushings missing from around branch wire(s) entering panel box. "},{"checked":false,"id":1,"is_red":false,"text":"Access to panel box blocked; interior not evaluated due to safety issues."},{"checked":false,"id":1,"is_red":false,"text":"Damage to insulation, or arcs / burns inside panel box.  "},{"checked":false,"id":1,"is_red":false,"text":"Questionable wiring in panel box.  Have licensed electrician evaluate. "},{"checked":false,"id":1,"is_red":false,"text":"Dirt or rust buildup inside panel box.   "},{"checked":false,"id":1,"is_red":false,"text":"Evidence of water intrusion."},{"checked":false,"id":1,"is_red":false,"text":"Exposed wire ends in panel box.  Have evaluated by a licensed electrician."},{"checked":false,"id":1,"is_red":false,"text":"Grounding / Bonding questionable at panel box. "},{"checked":false,"id":1,"is_red":false,"text":"This property has “knob and tube” wiring which was commonly installed prior to 1950. It is ungrounded, and considered unsafe by today’s standards. Over time, the wire’s insulation  becomes brittle and falls apart, resulting in exposed conductors and a risk of shock and/or fire. This wiring is also easily damaged by covering it with insulation (a common practice), and incorrectly tapping new wiring into it. Some energized knob and tube wiring was found during the inspection. It is not within the scope of this inspection to determine what percentage of this property’s wiring is of the knob and tube type or to determine what percentage of the knob and tube wiring is energized vs. abandoned. A qualified electrician should evaluate this wiring and make repairs or replace wiring as necessary. "},{"checked":false,"id":1,"is_red":false,"text":"Aluminum wiring present — Between 1965 and 1973, aluminum wiring was sometimes substituted for copper wiring in residential electrical systems. Connections in outlets, switches, and light fixtures with aluminum wiring become increasingly dangerous as time passes. Poor connections cause wiring to spark and overheat, creating a potential fire hazard.  The wiring should be evaluated by a qualified electrician experienced in evaluating and correcting aluminum wiring problems. Not all electrical contractors qualify. Aluminum wiring connections are subject to greater deterioration than is copper due to thermal expansion and contraction, vibration (caused when electric currents pass through wiring), oxidation (caused by exposure to oxygen in the air), and galvanic corrosion (caused when two different metals are connected together), all of which can cause poor connections. When wires are poorly connected they overheat, which creates a potential fire hazard."},{"checked":false,"id":1,"is_red":false,"text":"Recommend having breaker connections evaluated by a licensed electrician."},{"checked":false,"id":1,"is_red":false,"text":"There is a Federal Pacific Electric service panel in the house. There are studies that show that some FPE circuit breakers are prone to problems that can lead to failures, lack of proper protection of circuits and other serious issues, including fire and electrocution.  Although the Consumer Products Safety Commission has not issued a formal product recall, the panel is old and the company is now out of business.  We cannot definitively call this panel defective, but recommend, for your peace of mind, to consult a qualified electrical contractor to get their opinion on this matter.   You can learn more about this issue at: http://www.codecheck.com/pdf/electri...%20Nov2003.pdf,  www.inspect-ny.com/fpe/fpepanel.htm, and http://www.inspect-ny.com/fpe/CPSCsummary.htm. "},{"checked":false,"id":1,"is_red":false,"text":"There is a Zinsco service panel present. Zinsco components are prone to problems that can lead to failures, lack of proper protection of circuits and other serious issues, including fire and electrocution.    We cannot definitively call this panel defective, but recommend, for your peace of mind, to consult a qualified electrical contractor to get their opinion on this matter.  You can learn more about this issue at http://www.inspect-ny.com/electric/zinsco.htm"},{"checked":false,"id":1,"is_red":false,"text":"Generator wiring: The main service panel contained a large amount of extraneous wiring. Much of this wiring appears to be related to the use of an electric generator providing power to the home during general power failures. Inspection of the generator wiring lies beyond the scope of the general home inspection. You may wish to have the generator wiring evaluated by a qualified electrical contractor."},{"checked":false,"id":1,"is_red":false,"text":"."},{"checked":false,"id":1,"is_red":false,"text":"Spliced & taped wires."},{"checked":false,"id":1,"is_red":false,"text":"Irregular installation."},{"checked":false,"id":1,"is_red":false,"text":"Live electrical wire(s) that are not terminated (unattached & without wire nut) in panel box.   Possible shock / electrocution hazard, as it can come into contact with panel dead front cover, thereby energizing the cover."},{"checked":false,"id":1,"is_red":false,"text":"Panel amperage may be less than 100 amps, which is low by today's standards; recommend evaluation by licensed electrician."},{"checked":false,"id":1,"is_red":false,"text":"Have electrician ensure that ground is continuous, see photo.  "},{"checked":false,"id":1,"is_red":false,"text":"Panel box appears to be older than the projected effective life (25 years) of panel buss bar and breakers; recommend electrician evaluation of panel box and associated wiring, including non-tripping GFCIs on property. "},{"checked":false,"id":1,"is_red":false,"text":"There is evidence of water intrusion in the panel."},{"checked":false,"id":1,"is_red":false,"text":"Could not access n/a."},{"checked":false,"id":1,"is_red":false,"text":"Recommend upgrading service."},{"checked":false,"id":1,"is_red":false,"text":"Personal items prevent inspection n/a."},{"checked":false,"id":1,"is_red":false,"text":"Could not locate sub panel."},{"checked":false,"id":1,"is_red":false,"text":"We recommend contacting a licensed electrician to evaluate and repair the issues."},{"checked":false,"id":1,"is_red":false,"text":"Knob and tube wiring was observed in this home. This type of wiring was standard at the time of construction, and unless otherwise noted, appears to be in serviceable condition."}],"sepChoice":"4","title":"Electrical Panel"}],"inspection_panels":[{"descr":"Location:","id":3041,"options":[{"checked":false,"id":1,"is_red":false,"text":"Main Location: "},{"checked":false,"id":1,"is_red":false,"text":"North side of the house."},{"checked":false,"id":1,"is_red":false,"text":"Main Disconnect in panel box."},{"checked":false,"id":1,"is_red":false,"text":"Panel box located in garage."},{"checked":false,"id":1,"is_red":false,"text":"Panel box located in basement."},{"checked":false,"id":1,"is_red":false,"text":"South side of the house."},{"checked":false,"id":1,"is_red":false,"text":"East side of the house."},{"checked":false,"id":1,"is_red":false,"text":"West side of the house."},{"checked":false,"id":1,"is_red":false,"text":"In the front of the structure."},{"checked":false,"id":1,"is_red":false,"text":"Rear of structure."},{"checked":false,"id":1,"is_red":false,"text":"Subterranean parking area."},{"checked":false,"id":1,"is_red":false,"text":"Parking area."},{"checked":false,"id":1,"is_red":false,"text":"Exterior of structure."}],"sepChoice":"1","title":"Main Electrical Panel Location"},{"descr":"Location:","id":3042,"options":[{"checked":false,"id":1,"is_red":false,"text":"Sub Panel Location: "},{"checked":false,"id":1,"is_red":false,"text":"Located in the basement.  "},{"checked":false,"id":1,"is_red":false,"text":"Located in the detached shop."},{"checked":false,"id":1,"is_red":false,"text":"Located by the main panel."},{"checked":false,"id":1,"is_red":false,"text":"Located in the garage."},{"checked":false,"id":1,"is_red":false,"text":"Located at the guest house."},{"checked":false,"id":1,"is_red":false,"text":"Located in the master bedroom."},{"checked":false,"id":1,"is_red":false,"text":"Located in a storage area."},{"checked":false,"id":1,"is_red":false,"text":"Located in the second floor main hallway."},{"checked":false,"id":1,"is_red":false,"text":"No Sub Panels located."}],"sepChoice":"1","title":"Sub Electrical Panel Location"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Electrical Panel Overall"}],"title":"Service Panel"},{"damage_panels":[{"descr":"","id":2136,"options":[{"checked":false,"id":1,"is_red":false,"text":"30 amp"},{"checked":false,"id":1,"is_red":false,"text":"40 amp"},{"checked":false,"id":1,"is_red":false,"text":"50 amp"},{"checked":false,"id":1,"is_red":false,"text":"60 amp"},{"checked":false,"id":1,"is_red":false,"text":"70 amp"},{"checked":false,"id":1,"is_red":false,"text":"90 amp"},{"checked":false,"id":1,"is_red":false,"text":"100 amp"},{"checked":false,"id":1,"is_red":false,"text":"125 amp"},{"checked":false,"id":1,"is_red":false,"text":"150 amp"},{"checked":false,"id":1,"is_red":false,"text":"175 amp"},{"checked":false,"id":1,"is_red":false,"text":"200 amp"},{"checked":false,"id":1,"is_red":false,"text":"440 amp"},{"checked":false,"id":1,"is_red":false,"text":"800 amp"},{"checked":false,"id":1,"is_red":false,"text":"unknown"}],"sepChoice":"4","title":"Main Amp Breaker"},{"descr":"","id":2137,"options":[{"checked":false,"id":1,"is_red":false,"text":"0"},{"checked":false,"id":1,"is_red":false,"text":"1"},{"checked":false,"id":1,"is_red":false,"text":"2"},{"checked":false,"id":1,"is_red":false,"text":"3"},{"checked":false,"id":1,"is_red":false,"text":"4"},{"checked":false,"id":1,"is_red":false,"text":"5"},{"checked":false,"id":1,"is_red":false,"text":"6"},{"checked":false,"id":1,"is_red":false,"text":"7"},{"checked":false,"id":1,"is_red":false,"text":"8"},{"checked":false,"id":1,"is_red":false,"text":"9"}],"sepChoice":"4","title":"Breakers in off position"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Main Amp Breaker Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Breakers in off position Overall"}],"title":"Main Amp Capacity"},{"damage_panels":[{"descr":"","id":2140,"options":[{"checked":false,"id":1,"is_red":false,"text":"There is an overhead service drop noted."},{"checked":false,"id":1,"is_red":false,"text":"There is an underground service lateral noted."},{"checked":false,"id":1,"is_red":false,"text":"Exposed connection, missing splice cover observed at masthead. Suggest contacting the local electric utility company for repair, as necessary, for safety."},{"checked":false,"id":1,"is_red":false,"text":"Exposed wires observed at service entrance, which is a serious electrical safety concern. Recommend review by a licensed electrician for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Masthead is loose or improperly secured,  recommend review by a licensed electrician for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Normal acceptable clearance is 10-15' at the closest point."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a licensed electrician for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Temporary connections observed, recommend review by the local electric utility company for permanent connections as necessary."},{"checked":false,"id":1,"is_red":false,"text":"When utility company wires coming into the service mast are sagging, frayed, strung through trees, or otherwise appear improper, the client is advised to contact the utility company prior to closing to correct the condition or verify its safety."},{"checked":false,"id":1,"is_red":false,"text":"Wires are sagging, recommend review by the local utility company for repair as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Wires are too low over the @@@@@, this is a serious safety concern. Recommend review by a licensed electrician for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Wires are touching trees, recommend review by the local utility company for repair as necessary."}],"sepChoice":"4","title":"Cable Feeds"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Cable Feeds Overall"}],"title":"Cable Feeds"},{"damage_panels":[{"descr":"","id":2138,"options":[{"checked":false,"id":1,"is_red":false,"text":"All of the circuit breakers appeared serviceable."},{"checked":false,"id":1,"is_red":false,"text":"Open breaker panel slot(s) at panel box cover.  Electrocution hazard."},{"checked":false,"id":1,"is_red":false,"text":"Double tapped breaker(s) inside panel box (more than one electrical conductor attached).  This is not standard practice, and may cause overheating or even an electrical fire.  Recommend evaluation by an electrician.  Double tapping and lugging can create hot spots on breakers and neutral bars because they are not tightened to the correct torque--especially if two different size conductors are used. Because the hot [black] and neutral [white]wires are both current carrying conductors, the chance is then greater for potential hot spots. If the double tap or lug becomes loose, it begins to arc. As it arcs it builds up carbon. Carbon is then resistance and with more carbon buildup the more difficult it is for the conductor to make contact, thus increasing the current. The end result can be the breaker tripping because of the loose connection [current exceeding the rating of the breaker], or signs of overheating such as discolored wires, melted wires, etc, or even fire."},{"checked":false,"id":1,"is_red":false,"text":"There is a Federal Pacific Electric service panel in the house. There are studies that show that some FPE circuit breakers are prone to problems that can lead to failures, lack of proper protection of circuits and other serious issues, including fire and electrocution.  Although the Consumer Products Safety Commission has not issued a formal product recall, the panel is old and the company is now out of business.  We cannot definitively call this panel defective, but recommend, for your peace of mind, to consult a qualified electrical contractor to get their opinion on this matter.   You can learn more about this issue at: http://www.codecheck.com/pdf/electri...%20Nov2003.pdf,  www.inspect-ny.com/fpe/fpepanel.htm, and   http://www.inspect-ny.com/fpe/CPSCsummary.htm.  "},{"checked":false,"id":1,"is_red":false,"text":"Double tapping and lugging can create hot spots on breakers and neutral bars because they are not tightened to the correct torque--especially if two different size conductors are used. Because the hot [black] and neutral [white]wires are both current carrying conductors, the chance is then greater for potential hot spots. If the double tap or lug becomes loose, it begins to arc. As it arcs it builds up carbon. Carbon is then resistance and with more carbon buildup the more difficult it is for the conductor to make contact—thus increasing the current. The end result can be the breaker tripping because of the loose connection [current exceeding the rating of the breaker], or signs of overheating such as discolored wires, melted wires, etc, or worse yet--fire! \n"},{"checked":false,"id":1,"is_red":false,"text":"We recommend contacting a licensed electrician to evaluate and repair the issues."},{"checked":false,"id":1,"is_red":false,"text":"Burned or scorched wiring observed, recommend review by a licensed electrician."},{"checked":false,"id":1,"is_red":false,"text":"Double tapping observed. Double tapping (i.e. 2 wires on a single pole breaker) can add to the load of the affected circuit causing a possible overload and tripping breakers, or result in loose connections and overheating of the breaker or connections. Ideally, doubled-up circuits should be independently fused."},{"checked":false,"id":1,"is_red":false,"text":"Can not determine if push breaker is on or off."},{"checked":false,"id":1,"is_red":false,"text":"GFCI breaker noted."}],"sepChoice":"4","title":"Breakers"}],"inspection_panels":[{"descr":"","id":3043,"options":[{"checked":false,"id":1,"is_red":false,"text":"Copper non-metallic sheathed cable noted."},{"checked":false,"id":1,"is_red":false,"text":"Copper armor sheathed cable noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum non-metallic sheathed cable noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum armor sheathed cable noted."},{"checked":false,"id":1,"is_red":false,"text":"Could not determine the type of branch circuit wiring in the home."},{"checked":false,"id":1,"is_red":false,"text":"All original knob and tube wiring appears to have been removed."},{"checked":false,"id":1,"is_red":false,"text":"A low voltage alarm system and a low voltage intercom system are installed. Due to the specialized nature of these systems, we suggest that you review these systems with the seller. As per our Inspection Agreement, these systems are beyond the scope of this report and were not inspected."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum wiring is now a concern with insurance companies due to fire risk.  Buyer is urged to confirm insurability and any related conditions that insurance company may place on this house.  Further inspection of this system may be required.  The inspector CANNOT ensure compliance of this electrical system for insurance purposes."},{"checked":false,"id":1,"is_red":false,"text":"Improper use of extension cord observed. Extension cords should not be permanently installed or be routed through walls, floors or partitions."},{"checked":false,"id":1,"is_red":false,"text":"Insulation has been installed over knob and tube wiring at various locations. This is a fire \"Safety Concern\". Suggest review by a licensed electrician prior to closing to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Knob and tube wiring was observed in this home. This type of wiring was standard at the time of construction, and unless otherwise noted, appears to be in serviceable condition."}],"sepChoice":"1","title":"Wiring Type"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Breakers Overall"}],"title":"Breakers"},{"damage_panels":[{"descr":"","id":2139,"options":[{"checked":false,"id":1,"is_red":false,"text":"Recommend updating the service panel to circuit breakers."},{"checked":false,"id":1,"is_red":false,"text":"Recommend contacting a licensed electrician to evaluate and repair the issues."},{"checked":false,"id":1,"is_red":false,"text":"Burnt fuses noted."},{"checked":false,"id":1,"is_red":false,"text":"Missing fuses noted."},{"checked":false,"id":1,"is_red":false,"text":"Incorrect fuse size noted."},{"checked":false,"id":1,"is_red":false,"text":"Multiple wires to one fuse noted."},{"checked":false,"id":1,"is_red":false,"text":"Corroded fuses noted."}],"sepChoice":"4","title":"Fuses"}],"inspection_panels":[{"descr":"","id":3044,"options":[{"checked":false,"id":1,"is_red":false,"text":"Open fuse positions observed, suggest installing fuses for safety."},{"checked":false,"id":1,"is_red":false,"text":"The inspector has noted fuse ports that showed signs of prior arching or burning. We recommend having a licensed electrician evaluate the panel and possibly update to circuit breakers."}],"sepChoice":"1","title":"Number of Bad and Missing Fuses"},{"descr":"","id":3045,"options":[{"checked":false,"id":1,"is_red":false,"text":"10 amp."},{"checked":false,"id":1,"is_red":false,"text":"20 amp."},{"checked":false,"id":1,"is_red":false,"text":"30 amp."},{"checked":false,"id":1,"is_red":false,"text":"40 amp."},{"checked":false,"id":1,"is_red":false,"text":"50 amp."},{"checked":false,"id":1,"is_red":false,"text":"60 amp."},{"checked":false,"id":1,"is_red":false,"text":"70 amp."},{"checked":false,"id":1,"is_red":false,"text":"100 amp."}],"sepChoice":"1","title":"Amp Rating of Fuses"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Fuses Overall"}],"title":"Fuses"}],"title":"Electrical"},{"id":11,"tabbed_panels":[{"damage_panels":[{"descr":"","id":2094,"options":[{"checked":false,"id":1,"is_red":false,"text":"Fuel Furnace:  Last service date is over one year ago, or is unable to be determined. Although this unit appears to be operating properly from controls, there are areas which cannot be seen without specialized equipment and training.  One such area is the combustion chamber / heat exchanger where cold air blows across the \"fire box\", becoming the hot air that circulates throughout your home.  During the life span of any furnace, this metal wall may develop a crack or a broken weld, allowing carbon monoxide to circulate throughout the home.  This is why furnace specialists recommend a complete inspection annually; consider having unit inspected by certified HVAC technician."},{"checked":false,"id":1,"is_red":false,"text":"Electric Furnace: Last service date is over one year ago, or is unable to be determined. Although this unit appears to be operating properly from controls, there are areas which cannot be seen without specialized equipment and training.  Furnace specialists recommend a complete inspection annually; consider having unit inspected by certified HVAC technician."},{"checked":false,"id":1,"is_red":false,"text":"Pilot not lit; could not test."},{"checked":false,"id":1,"is_red":false,"text":"Service shut off; have HVAC tech inspect when utility is restored."},{"checked":false,"id":1,"is_red":false,"text":"Furnace condensate pump not running, and is overflowing."},{"checked":false,"id":1,"is_red":false,"text":"Condensation leaking at the heater."},{"checked":false,"id":1,"is_red":false,"text":"Could not test due to exterior temperature."},{"checked":false,"id":1,"is_red":false,"text":"Unit did not respond to thermostat."},{"checked":false,"id":1,"is_red":false,"text":"Pilot not lit; could not test."},{"checked":false,"id":1,"is_red":false,"text":"Can not determine outlet of drain."},{"checked":false,"id":1,"is_red":false,"text":"Recommend removal of gas heating in bedroom."},{"checked":false,"id":1,"is_red":false,"text":"Unit does not have proper clearance."},{"checked":false,"id":1,"is_red":false,"text":"Exposed wires at unit."},{"checked":false,"id":1,"is_red":false,"text":"Irregular wiring present."},{"checked":false,"id":1,"is_red":false,"text":"No power; could not test."},{"checked":false,"id":1,"is_red":false,"text":"Attic access to the heater is not the proper size."},{"checked":false,"id":1,"is_red":false,"text":"The safety shut off switch did not operate. Recommend further evaluation by a licensed electrician."},{"checked":false,"id":1,"is_red":false,"text":"Recommend heating-A/C contractor to evaluate."},{"checked":false,"id":1,"is_red":false,"text":"Recommend having gas company come in to evaluate."},{"checked":false,"id":1,"is_red":false,"text":"Check For Recall."},{"checked":false,"id":1,"is_red":false,"text":"Swamp cooler present; not tested by the inspector."},{"checked":false,"id":1,"is_red":false,"text":"A Heat Recovery Ventilator is noted.  This device provides central ventilation, while recovering heat/cooling from the exhausted air.  This is considered a specialized device, therefore it is excluded from this inspection."},{"checked":false,"id":1,"is_red":false,"text":"A mid or high efficiency gas furnace has been installed and vented through the masonry chimney.  Proper sizing of the chimney is important for venting of this type of heating system, as improper sizing can result in condensation that will destroy the mortar and chimney liner.  We are not qualified or equipped to perform a thorough chimney inspection or venting evaluation, therefore we recommend review by a licensed heating contractor for evaluation and/or repair as necessary. A mid or high efficiency gas furnace has been installed and vented through the masonry chimney. Flue gas temperatures are lower with these units causing condensate to collect on the chimney walls. This condensate contains acids which corrode, damage, and deteriorate the chimney masonry. Proper sizing of the chimney is extremely important for venting with this type of heating system. To prevent damage/deterioration to the masonry chimney we suggest further review of this system by a qualified heating contractor prior to closing to determine the proper sizing of the chimney for this type heating system and that proper venting is occurring. We are not qualified or equipped to evaluate if acid corrosion, damage, or deterioration has occurred in the chimney by a visual inspection, as the interior of the chimney/flue is not visible or accessible to the inspector."},{"checked":false,"id":1,"is_red":false,"text":"Due to rust/corrosion in burner chambers, this unit appears to be at the end of its useful life.  A service review is urged immediately for the safety of occupant.\nThis unit will likely be red tagged at time of service."},{"checked":false,"id":1,"is_red":false,"text":"Due to the higher efficiency of this unit, this review is limited. Most areas are sealed and inaccessible. We suggest review by a licensed heating contractor if a more detailed review is desired."},{"checked":false,"id":1,"is_red":false,"text":"Garage installation of gas-fired appliances generally require the burner to be 18 inches above the floor level to ensure separation from flammable vapors.  This is a serious safety concern.  Recommend review by a licensed heating contractor for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Heat pump was tested using normal operating controls. Unit appeared to operate properly at time of inspection. As with all mechanical equipment, the unit may fail at anytime without warning. Inspectors cannot determine future failures. A heat pump is basically a compressor-cycle air conditioning system that can operate in reverse. As long as the unit is functioning properly in either the heating or cooling mode, it is an indication that the major components (compressor, fans, and coils) are operational. Adequate air flow is important to the efficiency of these units; the filter should be kept clean as with air conditioners. If a detailed evaluation of the heating or cooling capacity of these units is desired, a licensed HVAC contractor should be consulted prior to closing."},{"checked":false,"id":1,"is_red":false,"text":"Not inspected. System is shut down.  Please confer with seller regarding start up procedure for this system."},{"checked":false,"id":1,"is_red":false,"text":"Relatively new high efficiency furnace in place."},{"checked":false,"id":1,"is_red":false,"text":"The Condominium Owners Association owns, operates and maintains the heating and/or cooling systems in this building. As such they are outside the scope of this inspection and were not inspected. We suggest a review of the system operations with the building maintenance department or a representative of the building management prior to close."},{"checked":false,"id":1,"is_red":false,"text":"The heating unit has exceeded its designed life expectancy. We make no warranty, guarantee or estimation as to the remaining useful life of this unit."},{"checked":false,"id":1,"is_red":false,"text":"The heating unit has reached its designed life expectancy. We make no warranty, guarantee or estimation as to the remaining useful life of this unit."},{"checked":false,"id":1,"is_red":false,"text":"The heating unit is approaching its designed life expectancy. We make no warranty, guarantee or estimation as to the remaining useful life of this unit."},{"checked":false,"id":1,"is_red":false,"text":"Unable to inspect heat exchanger due to closed system."}],"sepChoice":"4","title":"Heater Condition"}],"inspection_panels":[{"descr":"","id":3028,"options":[{"checked":false,"id":1,"is_red":false,"text":"Location: "},{"checked":false,"id":1,"is_red":false,"text":"The furnace is located in the hall closet"},{"checked":false,"id":1,"is_red":false,"text":"The furnace is located in the attic"},{"checked":false,"id":1,"is_red":false,"text":"The furnace is located in the garage"},{"checked":false,"id":1,"is_red":false,"text":"The furnace is located in the kitchen"},{"checked":false,"id":1,"is_red":false,"text":"The furnace is located in the laundry room"},{"checked":false,"id":1,"is_red":false,"text":"The furnace is located in the bedroom"},{"checked":false,"id":1,"is_red":false,"text":"The furnace is located in an exterior closet"},{"checked":false,"id":1,"is_red":false,"text":"The furnace is located in the crawlspace"},{"checked":false,"id":1,"is_red":false,"text":"The furnace is located in the basement"},{"checked":false,"id":1,"is_red":false,"text":"The furnace is located in the hall "},{"checked":false,"id":1,"is_red":false,"text":"The furnace is located in the living room"},{"checked":false,"id":1,"is_red":false,"text":"The furnace is located in the guest room"},{"checked":false,"id":1,"is_red":false,"text":"The furnace is located in the den"},{"checked":false,"id":1,"is_red":false,"text":"The furnace is located in the family room"},{"checked":false,"id":1,"is_red":false,"text":"The furnace is located in the addition"},{"checked":false,"id":1,"is_red":false,"text":"The furnace is located in the guest house"},{"checked":false,"id":1,"is_red":false,"text":"The furnace is located in the storage area"},{"checked":false,"id":1,"is_red":false,"text":"The furnace is located in the patio enclosure"},{"checked":false,"id":1,"is_red":false,"text":"The heater is located in the bedroom ceiling"},{"checked":false,"id":1,"is_red":false,"text":"The heater is located in an interior ceiling"},{"checked":false,"id":1,"is_red":false,"text":"The furnace is located in a common area maintained by the association"},{"checked":false,"id":1,"is_red":false,"text":"The heater is a wall unit only"},{"checked":false,"id":1,"is_red":false,"text":"The heater is located in the bathroom ceiling"}],"sepChoice":"1","title":"Heater Locations"},{"descr":"","id":3029,"options":[{"checked":false,"id":1,"is_red":false,"text":"Gas fired forced hot air."},{"checked":false,"id":1,"is_red":false,"text":"Electric forced hot air."},{"checked":false,"id":1,"is_red":false,"text":"The home has a split system."},{"checked":false,"id":1,"is_red":false,"text":"The home has a dual pack unit."},{"checked":false,"id":1,"is_red":false,"text":"The home has a gravity style octopus system."},{"checked":false,"id":1,"is_red":false,"text":"Heat pump noted."},{"checked":false,"id":1,"is_red":false,"text":"Radiant heat present, not tested n/a."}],"sepChoice":"1","title":"Heater Type"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Heater Condition Overall"}],"title":"Heaters"},{"damage_panels":[{"descr":"","id":2095,"options":[{"checked":false,"id":1,"is_red":false,"text":"The heater base appears to be functional."},{"checked":false,"id":1,"is_red":false,"text":"The heater base shows signs of water damage. Possible prior water intrusion."},{"checked":false,"id":1,"is_red":false,"text":"We recommend sealing holes and gaps in the heater base."},{"checked":false,"id":1,"is_red":false,"text":"The heating unit in the garage is not 18\" off the slab. This is a code violation."}],"sepChoice":"4","title":"Heater Base"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Heater Base Overall"}],"title":"Heater Base"},{"damage_panels":[{"descr":"","id":2096,"options":[{"checked":false,"id":1,"is_red":false,"text":"IMPROVE:  The furnace is dirty and there are no records of prior service. Recommend an HVAC contractor perform a system Clean-and-Check. HVAC systems require yearly maintenance."},{"checked":false,"id":1,"is_red":false,"text":"Concealed due to high efficiency furnace design."},{"checked":false,"id":1,"is_red":false,"text":"Construction dust buildup observed in service compartment and draft tubes."},{"checked":false,"id":1,"is_red":false,"text":"Due to presence of rust, scale, and some debris in this furnace, a professional cleaning and service review by a licensed HVAC contractor is highly advised to ensure proper and safe operation of this unit. Inspection for holes and/or cracks in heat exchanger is not within the scope of this inspection and should be performed by a HVAC contractor prior to ensure the proper and safe operation of this system."},{"checked":false,"id":1,"is_red":false,"text":"Excessive construction dust buildup observed in service compartment and draft tubes."},{"checked":false,"id":1,"is_red":false,"text":"Flame roll-out observed, which is a safety concern."},{"checked":false,"id":1,"is_red":false,"text":"Normal surface rust/corrosion observed, no signs of flaking or excessive deterioration noted."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a licensed heating contractor for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Suggest having this unit professionally cleaned and tuned to ensure proper and safe operation."},{"checked":false,"id":1,"is_red":false,"text":"Rust staining observed on both furnace cabinets at the refrigerant line connection. This is from the cold-side refrigerant line condensation and occurs during the cooling cycle only.  Recommend monitoring and repair/improve connection when unit is serviced by HVAC contractor."},{"checked":false,"id":1,"is_red":false,"text":"Rust and flaking observed."}],"sepChoice":"4","title":"Enclosure"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Enclosure Overall"}],"title":"Enclosure"},{"damage_panels":[{"descr":"","id":2099,"options":[{"checked":false,"id":1,"is_red":false,"text":"**VENTING MATERIALS**"},{"checked":false,"id":1,"is_red":false,"text":"Metal single wall chimney vent pipe noted."},{"checked":false,"id":1,"is_red":false,"text":"Metal double wall chimney vent pipe noted."},{"checked":false,"id":1,"is_red":false,"text":"Masonry chimney noted."},{"checked":false,"id":1,"is_red":false,"text":"Masonry lined chimney noted."},{"checked":false,"id":1,"is_red":false,"text":"Plastic - PVC vent noted."},{"checked":false,"id":1,"is_red":false,"text":"Chimney liner and cap installed."},{"checked":false,"id":1,"is_red":false,"text":"**VENTING OBSERVATIONS**"},{"checked":false,"id":1,"is_red":false,"text":"The metal chimney liner vent flue pipe was not inspected or visible form end to end. Recommend a certified chimney sweep inspect for your safety."},{"checked":false,"id":1,"is_red":false,"text":"The visible portions of the vent pipes appeared functional."},{"checked":false,"id":1,"is_red":false,"text":"A mid or high efficiency gas furnace has been installed and vented through the existing masonry chimney. Furnace flue gas temperatures are lower with these units causing condensate to collect on the chimney walls. This condensate contains acids which corrode, damage, and deteriorate the chimney masonry. Proper sizing of the chimney is extremely important for venting with this type of heating system. To prevent damage/deterioration to the masonry chimney we recommend further review by a licensed HVAC contractor to determine the proper sizing of the chimney for this type of heating system and that safe/proper venting is occurring."},{"checked":false,"id":1,"is_red":false,"text":"A thermally actuated automatic vent damping device is installed on this unit.  Recommend annual review by a licensed HVAC contractor to ensure proper operation and the installation of a Carbon Monoxide (CO) detector for your safety."},{"checked":false,"id":1,"is_red":false,"text":"Automatic vent damper did not open during furnace cycle. Recommended HVAC contractor repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Corrosion observed at the vent pipe and draft inducer housing.  A mid or high efficiency gas furnace is installed,  proper sizing of the chimney is important for venting of this type of heating system, as improper sizing can result in condensation that will destroy the chimney/liner.  Recommend further evaluation by a licensed HVAC contractor and repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"When a gas water heater and gas furnace connect to one vent pipe -- the unit with the highest BTU rating should connect at the bottom and below the other."},{"checked":false,"id":1,"is_red":false,"text":"SAFETY CONCERN: Chimney flue/vent pipe has inadequate clearance to combustible materials. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"SAFETY CONCERN: Holes observed in furnace vent pipe. Repair as needed"},{"checked":false,"id":1,"is_red":false,"text":"SAFETY CONCERN: Loose, disconnected, or improperly sloped vent pipes will allow combustion products to escape. Recommend licensed HVAC contractor repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"SAFETY CONCERN: Vent pipe is disconnected or poorly fitted. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"SAFETY CONCERN: The vent pipe from the natural draft gas water heater fails to rise 1/4\" per foot and may need re-locating or a power vent be installed. Recommend a licensed HVAC contractor inspect further and repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Water stains observed at the furnace draft inducer fan. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Add a new flue liner and cap when a new furnace is installed."},{"checked":false,"id":1,"is_red":false,"text":"Seal all openings at the chimney located in the @@@@@@@@basement."},{"checked":false,"id":1,"is_red":false,"text":"Rust and corrosion at top exterior chimney flue pipe at roof. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"@@BLUE@@ Combustion air venting in furnace room:  There are two gas fuel-burning appliances in the basement utility/furnace room: water heater and furnace.  All fuel-burning appliances must be provided with enough fresh air for proper combustion and ventilation of flue gases. In this home, these appliances are using indoor air for ventilation and combustion.  Other than the door--there is no visible venting into the utility/furnace room.  With the door closed--there may be a lack of combustion air resulting in hazardous Carbon Monoxide (CO) into the dwelling living areas."},{"checked":false,"id":1,"is_red":false,"text":"@@RED@@ SAFETY CONCERN: There is no visible venting into furnace room/closet.  Recommend HVAC contractor or trade professional  install appropriate vents into the basement utility/furnace room."},{"checked":false,"id":1,"is_red":false,"text":"CODE@@@@@  Combustion Air: Inclosed utility/furnace rooms with fuel burning appliances must be provided with two permanent openings to adjacent spaces: one within 12 inches from the top and one within 12 inches from the bottom of the adjoining wall.  The openings are not required if a louvered door to the furnace room is provided.\nEach opening must have a minimum free space area equal to 1 square inch per 1,000 BTU rating of all appliances in the room--but not less than 100 sq. inches.\nThe room must be at least 50 cubic feet per 1,000 BTU for no requirement.  "},{"checked":false,"id":1,"is_red":false,"text":"See also \"Electrical\" section, \"CO Detectors\""},{"checked":false,"id":1,"is_red":false,"text":"Efflorescence observed on vent pipe at joints."},{"checked":false,"id":1,"is_red":false,"text":"ABS vent pipe noted (black in color). Modern safety standards require that new installations use CPVC (white) pipe for high efficiency furnaces.  Any change to the existing furnace will require installation of new vent pipe.  The cost of this conversion may be added to any price quoted"},{"checked":false,"id":1,"is_red":false,"text":"Minimum furnace/water heater single wall vent pipe clearance from combustible material is6\". "},{"checked":false,"id":1,"is_red":false,"text":"Minimum furnace/water heater double wall vent pipe clearance from combustible material is 1\". "},{"checked":false,"id":1,"is_red":false,"text":"The furnace/water heater single wall vent pipe cannot start in or pass through the attic (unconditioned air) area."},{"checked":false,"id":1,"is_red":false,"text":"@@BLACK@@ Natural-draft type gas water heater vent pipes should have a \"WYE\" and not a \"T\" type connection to a common flue vent pipe that comes from a draft-induced (fan assisted) gas furnace. This prevents exhaust gases from the mechanical draft type furnace from being pushed back to the natural draft vent pie and contaminating the living space. "},{"checked":false,"id":1,"is_red":false,"text":"@@RED@@The gas water heater vent pipe connection to the furnace vent pipe should be a \"WYE\"  and not a \"T\" type connection. Recommend a licensed HVAC contractor inspect further and repair as needed."}],"sepChoice":"4","title":"Venting"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Venting Overall"}],"title":"Venting"},{"damage_panels":[{"descr":"","id":2097,"options":[{"checked":false,"id":1,"is_red":false,"text":"No gas shut off valves were present on the furnace. This is a safety and servicing issue."},{"checked":false,"id":1,"is_red":false,"text":"Gas shut off valves were present and functional."},{"checked":false,"id":1,"is_red":false,"text":"The gas shut off valve was observed in the off position. the inspection of this appliance could not be completed."},{"checked":false,"id":1,"is_red":false,"text":"An oil tank was observed on site, with no apparent leakage at time of inspection.  Buyer is advised that these tanks are prone to corrosion, even from the inside, making leakage a possibility at any time.  Inspector cannot warrant this tank from leakage, even between date of inspection and date of close."},{"checked":false,"id":1,"is_red":false,"text":"Oil line shut off valve installed for safety."},{"checked":false,"id":1,"is_red":false,"text":"Oil tank is located in the basement.  Current standards require that the tank be removed and installed outside."},{"checked":false,"id":1,"is_red":false,"text":"Oil tanks over 20 years of age are generally not insurable and will require replacement."},{"checked":false,"id":1,"is_red":false,"text":"The fuel tank oil line appears improperly installed, damaged, or is in an unsafe condition. Due to safety concerns, further review by a qualified contractor is recommended for repairs/replacement as required to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"The oil line is buried in concrete which is not compliant.  Installation of above slab line is recommended in order to reduce possibility of corrosion."},{"checked":false,"id":1,"is_red":false,"text":"There are visible oil leaks. This is considered a hazardous condition. Immediate review by a  licenced contractor is recommended to ensure safety."}],"sepChoice":"4","title":"Gas Valves"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Gas Valves Overall"}],"title":"Gas Valves"},{"damage_panels":[{"descr":"","id":2103,"options":[{"checked":false,"id":1,"is_red":false,"text":"No defects found."},{"checked":false,"id":1,"is_red":false,"text":"Could not fully inspect due to stored personal items in the basement."},{"checked":false,"id":1,"is_red":false,"text":"Missing insulation at A/C unit."},{"checked":false,"id":1,"is_red":false,"text":"Missing insulation at the furnace."},{"checked":false,"id":1,"is_red":false,"text":"Missing insulation in attic."},{"checked":false,"id":1,"is_red":false,"text":"Missing insulation in areas."},{"checked":false,"id":1,"is_red":false,"text":"Condensation dripping in the attic where the insulation has been removed. This should be repaired before moisture damage occurs to the ceilings below."},{"checked":false,"id":1,"is_red":false,"text":"Condensation dripping at heater where the insulation has been removed."},{"checked":false,"id":1,"is_red":false,"text":"Ice is forming on the suction lines due to missing insulation."},{"checked":false,"id":1,"is_red":false,"text":"Condensation drain line terminates under house."}],"sepChoice":"4","title":"Refrigerant Lines"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Refrigerant Lines Overall"}],"title":"Refrigerant Lines"},{"damage_panels":[{"descr":"","id":2104,"options":[{"checked":false,"id":1,"is_red":false,"text":"Appeared functional at the time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"The typical temperature differential split between supply and return air in an air conditioner of this type is 15 - 20 degrees F. This system responded and achieved an acceptable differential temperature of @@ degrees F."},{"checked":false,"id":1,"is_red":false,"text":"Annual HVAC service contract is recommended."},{"checked":false,"id":1,"is_red":false,"text":"The air conditioner did not operate properly. Recommend HVAC contractor evaluate the system."},{"checked":false,"id":1,"is_red":false,"text":"Exterior unit not level. This can affect system performance."},{"checked":false,"id":1,"is_red":false,"text":"Air Conditioning mounting pad not level; this may shorten motor life.  Suggest leveling pad or unit."},{"checked":false,"id":1,"is_red":false,"text":"The exterior condensor is dirty and needs to be cleaned."},{"checked":false,"id":1,"is_red":false,"text":"The exterior electrical disconnect/shut off box was rusted and not opened. Unable to verify fuse size."},{"checked":false,"id":1,"is_red":false,"text":"The insulation is missing or damaged at exterior refrigerant line."},{"checked":false,"id":1,"is_red":false,"text":"Air Conditioning line set has missing or damaged insulation; have HVAC tech repair."},{"checked":false,"id":1,"is_red":false,"text":"Exterior refrigerant lines wall penetration needs repair and sealing/caulking."},{"checked":false,"id":1,"is_red":false,"text":"Proper support needed under exterior A/C base."},{"checked":false,"id":1,"is_red":false,"text":"Dryer vent within 3 feet of exterior condensor."},{"checked":false,"id":1,"is_red":false,"text":"Rust/Stained at exterior condensor."},{"checked":false,"id":1,"is_red":false,"text":"There are improperly attached insulated ducts in the attic. Have all reviewed for repair."},{"checked":false,"id":1,"is_red":false,"text":"Rusted/Leaking condensate tray over furnace heat exchanger."},{"checked":false,"id":1,"is_red":false,"text":"NOTE: Unit(s) not tested in the cooling mode.  See Limitations."},{"checked":false,"id":1,"is_red":false,"text":"Further evaluation by an HVAC contractor recommended."},{"checked":false,"id":1,"is_red":false,"text":"The data plate on the exterior cooling unit was not visible/legible at the time of the inspection."},{"checked":false,"id":1,"is_red":false,"text":"Recommend clearing debris at unit."},{"checked":false,"id":1,"is_red":false,"text":"Drain line leaking at heater."},{"checked":false,"id":1,"is_red":false,"text":"Condensation dripping from secondary drain line."},{"checked":false,"id":1,"is_red":false,"text":"Recommend heating-a/c contractor to further evaluate the defects and provide repair options."},{"checked":false,"id":1,"is_red":false,"text":"Could not access the A/C unit due to its location."},{"checked":false,"id":1,"is_red":false,"text":"Maintenance Tip:  Recommend that HVAC professional seasonally check the air conditioning unit, and ensure the unit is level.  This can be accomplished at the same time as the annual furnace inspection."}],"sepChoice":"4","title":"AC Compress Condition"}],"inspection_panels":[{"descr":"Compressor Type:","id":3031,"options":[{"checked":false,"id":1,"is_red":false,"text":"Electric"},{"checked":false,"id":1,"is_red":false,"text":"Gas"}],"sepChoice":"1","title":"AC Compressor"},{"descr":"Location:","id":3032,"options":[{"checked":false,"id":1,"is_red":false,"text":"The compressor is located on the exterior grounds."},{"checked":false,"id":1,"is_red":false,"text":"The compressor is located near the patio area."},{"checked":false,"id":1,"is_red":false,"text":"The compressor is located on the roof."},{"checked":false,"id":1,"is_red":false,"text":"The compressor is located on the exterior north."},{"checked":false,"id":1,"is_red":false,"text":"The compressor is located on the exterior south."},{"checked":false,"id":1,"is_red":false,"text":"The compressor is located on the exterior east."},{"checked":false,"id":1,"is_red":false,"text":"The compressor is located on the exterior west."}],"sepChoice":"1","title":"AC Compressor Location"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"AC Compress Condition Overall"}],"title":"AC Compressor"},{"damage_panels":[{"descr":"","id":2101,"options":[{"checked":false,"id":1,"is_red":false,"text":"The return air supply system appears to be functional."},{"checked":false,"id":1,"is_red":false,"text":"Return air appears to be  leaking at unit. We recommend sealing or patching the ductwork in these areas."},{"checked":false,"id":1,"is_red":false,"text":"We recommend sealing all holes and gaps for maximum effectiveness."},{"checked":false,"id":1,"is_red":false,"text":"There is a loose return air grill noted."},{"checked":false,"id":1,"is_red":false,"text":"There is a missing return air grill noted."},{"checked":false,"id":1,"is_red":false,"text":"There is a bent return air grill. This is a cosmetic situation and does not effect the operation of the grill."},{"checked":false,"id":1,"is_red":false,"text":"Return air draws from garage area. This is a DANGEROUS situation due to carbon monoxide being drawn into the retun air grilles and must be corrected."}],"sepChoice":"4","title":"Air Supply"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Air Supply Overall"}],"title":"Air Supply"},{"damage_panels":[{"descr":"","id":2102,"options":[{"checked":false,"id":1,"is_red":false,"text":"The return air supply system appears to be functional."},{"checked":false,"id":1,"is_red":false,"text":"There is a loose return air grill noted."},{"checked":false,"id":1,"is_red":false,"text":"There is a missing return air grill noted."},{"checked":false,"id":1,"is_red":false,"text":"There is a bent return air grill. This is a cosmetic situation and does not effect the operation of the grill."},{"checked":false,"id":1,"is_red":false,"text":"Air flow weak at the register. We recommend further evaluation by a licensed HVAC technician."},{"checked":false,"id":1,"is_red":false,"text":"No air flow present at the register. We recommend further evaluation by a licensed HVAC technician."}],"sepChoice":"4","title":"Registers"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Registers Overall"}],"title":"Registers"},{"damage_panels":[{"descr":"","id":2100,"options":[{"checked":false,"id":1,"is_red":false,"text":"MAINTENANCE: The air filter(s) should be inspected at least monthly and cleaned or replaced as required. There are two types of filters commonly used:  (1) Washable filters, (constructed of aluminum mesh, foam, or reinforced fibers) these may be cleaned by soaking in mild detergent and rising with water. Or  (2) Fiberglass disposable filters that must be REPLACED before they become clogged. Remember that dirty filters are the most common cause of inadequate heating or cooling performance. "},{"checked":false,"id":1,"is_red":false,"text":"Poor type of filter installed."},{"checked":false,"id":1,"is_red":false,"text":"Access is a bit difficult."},{"checked":false,"id":1,"is_red":false,"text":"Heat Pump in basement missing filter (16X20 size)."},{"checked":false,"id":1,"is_red":false,"text":"Basement hall return air filter very dirty and clogged.  Install new 20\" X 25\" X 1\" fiberglass disposable filter. "},{"checked":false,"id":1,"is_red":false,"text":"Electronic air filters are beyond the scope of a home inspection."},{"checked":false,"id":1,"is_red":false,"text":"Furnace filter dirty. Needs replacement."},{"checked":false,"id":1,"is_red":false,"text":"The furnace filter is dirty. Filters help clean the house air, making the environment more pleasant. Filters also clean the air before it passes through the blower and heat exchanger. This helps to keep these furnace components working efficiently. It is recommended to change the filter and then regular inspection & maintenance is advised."},{"checked":false,"id":1,"is_red":false,"text":"MAINTENANCE: The thin washable aluminum mesh filters in the electronic air filter should be routinely checked and clean."},{"checked":false,"id":1,"is_red":false,"text":"Annual HVAC service contract is recommended."},{"checked":false,"id":1,"is_red":false,"text":"Disposable type filter appeared to have come apart inside unit. Replace as needed. "}],"sepChoice":"4","title":"Filters"}],"inspection_panels":[{"descr":"Location:","id":3030,"options":[{"checked":false,"id":1,"is_red":false,"text":"Located inside heater cabinet."},{"checked":false,"id":1,"is_red":false,"text":"Located inside a filter grill in the hall ceiling."},{"checked":false,"id":1,"is_red":false,"text":"Located below heater in a slot cut into the ductwork."},{"checked":false,"id":1,"is_red":false,"text":"Located in a filter grill in an interior area wall."},{"checked":false,"id":1,"is_red":false,"text":"Located in a filter grill in a hall area wall."},{"checked":false,"id":1,"is_red":false,"text":"Located in a filter grill in a bedroom ceiling."},{"checked":false,"id":1,"is_red":false,"text":"Located in a filter grill in a bedroom wall."},{"checked":false,"id":1,"is_red":false,"text":"Located in a filter grill in the kitchen ceiling."},{"checked":false,"id":1,"is_red":false,"text":"Located in a filter grill in an interior area ceiling."}],"sepChoice":"1","title":"Filter Locations"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Filters Overall"}],"title":"Filters"},{"damage_panels":[{"descr":"","id":2098,"options":[{"checked":false,"id":1,"is_red":false,"text":"Location: @@@@@@"},{"checked":false,"id":1,"is_red":false,"text":"Location(s):  Zone#1: Main level/dining room -- Zone#2: Master bedroom -- Zone#3: Sun room \n"},{"checked":false,"id":1,"is_red":false,"text":"Digital - programmable type."},{"checked":false,"id":1,"is_red":false,"text":"Analog, non-programmable type."},{"checked":false,"id":1,"is_red":false,"text":"Functional at the time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Thermostats are not checked for calibration or timed functions."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Non-programmable thermostats have no energy saving capabilities as do digital setback-type thermostats.  Recommend an upgrade to a modern, digital programmable thermostat. This could yield a saving of up to $180 per year in energy costs."},{"checked":false,"id":1,"is_red":false,"text":"Recommend that the client(s) have the homeowner provide the instructions for programming or show the client(s) how to do so."},{"checked":false,"id":1,"is_red":false,"text":"Low battery, suggest replacing."},{"checked":false,"id":1,"is_red":false,"text":"Thermostat does not appear to start unit, have furnace fully inspected by a licensed HVAC technician.   "}],"sepChoice":"4","title":"Thermostats"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Thermostats Overall"}],"title":"Thermostats"}],"title":"Heat/AC"},{"id":12,"tabbed_panels":[{"damage_panels":[{"descr":"","id":2105,"options":[{"checked":false,"id":1,"is_red":false,"text":"The water heater base is functional."},{"checked":false,"id":1,"is_red":false,"text":"The water heater base is stained. We recommend cleaning."},{"checked":false,"id":1,"is_red":false,"text":"The water heater base is showing signs of prior damage."},{"checked":false,"id":1,"is_red":false,"text":"The water heater base is rusted, due to prior water infiltration."},{"checked":false,"id":1,"is_red":false,"text":"The water heater base is bent due to prior damage."},{"checked":false,"id":1,"is_red":false,"text":"The water heater base is dented."},{"checked":false,"id":1,"is_red":false,"text":"The water heater base is dirty. We recommend cleaning the base."}],"sepChoice":"4","title":"Base"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Base Overall"}],"title":"Base"},{"damage_panels":[{"descr":"","id":2109,"options":[{"checked":false,"id":1,"is_red":false,"text":"The water heater enclosure is functional."},{"checked":false,"id":1,"is_red":false,"text":"The water heater enclosure is stained. We recommend cleaning."},{"checked":false,"id":1,"is_red":false,"text":"The water heater enclosure is showing signs of prior damage."},{"checked":false,"id":1,"is_red":false,"text":"The water heater enclosure is rusted, due to prior water infiltration."},{"checked":false,"id":1,"is_red":false,"text":"The water heater enclosure is bent due to prior damage."},{"checked":false,"id":1,"is_red":false,"text":"The water heater enclosure is dented."},{"checked":false,"id":1,"is_red":false,"text":"The water heater enclosure is dirty. We recommend cleaning the enclosure."}],"sepChoice":"4","title":"Heater Enclosure"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Heater Enclosure Overall"}],"title":"Enclosure"},{"damage_panels":[{"descr":"","id":2106,"options":[{"checked":false,"id":1,"is_red":false,"text":"The combustion chamber appears to in functional condition."},{"checked":false,"id":1,"is_red":false,"text":"The inspector could not fully inspect the combustion chamber due to the orientation of the water heater to an adjacent wall."},{"checked":false,"id":1,"is_red":false,"text":"No air vents were present."},{"checked":false,"id":1,"is_red":false,"text":"Personal items were present which limited the inspection."},{"checked":false,"id":1,"is_red":false,"text":"Combustible materials were close to the unit presenting a fire hazard."},{"checked":false,"id":1,"is_red":false,"text":"Recommend mesh screen in attic."}],"sepChoice":"4","title":"Combusion"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Combusion Overall"}],"title":"Combustion"},{"damage_panels":[{"descr":"","id":2115,"options":[{"checked":false,"id":1,"is_red":false,"text":"The water heater vent pipe is improperly sealed as it enters the chimney. Deadly C/O gases can enter the living spaces. Recommend sealing the vent pipe properly."},{"checked":false,"id":1,"is_red":false,"text":"Minimum water heater single-wall vent pipe clearance from combustible material is 6\". "},{"checked":false,"id":1,"is_red":false,"text":"Minimum water heater double-wall vent pipe clearance from combustible material is 1\". "},{"checked":false,"id":1,"is_red":false,"text":"SAFETY CONCERN: Gas burning water heater vent pipe has less than required minimum distance from combustible materials. This is a fire hazard. Licensed contractor should be repaired as needed."},{"checked":false,"id":1,"is_red":false,"text":"The vent pipe does not extend to the exterior. This is a serious safety concern and needs to be corrected ASAP."}],"sepChoice":"4","title":"Venting"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Venting Overall"}],"title":"Venting"},{"damage_panels":[{"descr":"","id":2107,"options":[{"checked":false,"id":1,"is_red":false,"text":"Tank appears to be in satisfactory condition -- no concerns."},{"checked":false,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"A Temperature Pressure Relief (TPR) valve present. This safety valve releases water (and thus relieves pressure) if either the temp or pressure in the tank gets too high. The TPR valve discharge tube must be made of copper, iron, or CPVC (NOT regular PVC). It must terminate within 6\" above the floor--the end cannot be threaded or have a fitting."},{"checked":false,"id":1,"is_red":false,"text":"No deficiencies noted with the Temperature Pressure Relief (TPR) valve and discharge pipe."},{"checked":false,"id":1,"is_red":false,"text":"Water temperature observed to be: @@@ degree F.  This is @@satisfactory/too hot@@. Recommended temp should be set at 118-122 degrees F to prevent scalding, extend water heater life, and improve energy efficiency and conservation.  "},{"checked":false,"id":1,"is_red":false,"text":"The extension at the water heater relief valve is missing. This is a potential scalding concern as water can discharge improperly. Recommend installing the proper type of relief extension to discharge within 6\" from the floor."},{"checked":false,"id":1,"is_red":false,"text":"SAFETY CONCERN: The water heater vent pipe is improperly sealed as it enters the chimney. Deadly CO gases can enter the living spaces. Recommend sealing the vent pipe properly."},{"checked":false,"id":1,"is_red":false,"text":"The water valve above the tank is leaking and the top of the tank is rusting & corroding. Damage can occur to the tank. Recommend repairing or replacing the leaking valve. "},{"checked":false,"id":1,"is_red":false,"text":"The water heater vent pipe is rusted. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"@@BLACK@@Water heater gas supply line missing drip leg (or dirt pocket). This drip leg serves as a collection area for sediment to reduce the chance of clogged gas valves or burners."},{"checked":false,"id":1,"is_red":false,"text":"@@RED@@Gas gas supply line missing drip leg. Licensed plumber repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"The vent pipe is loose."},{"checked":false,"id":1,"is_red":false,"text":"Leaking observed at @@@@@@@@@@@@"},{"checked":false,"id":1,"is_red":false,"text":"Abandoned vent pipe. Liner and cap advised."},{"checked":false,"id":1,"is_red":false,"text":"Water heater is past the end of its typical service life. Highly recommend replacement. "},{"checked":false,"id":1,"is_red":false,"text":"Improper supports being used."},{"checked":false,"id":1,"is_red":false,"text":"Power vent was unplugged and therefore not tested."},{"checked":false,"id":1,"is_red":false,"text":"Recommend extending TPR discharge tube with 3/4\" copper pipe to within 6\" off the floor."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Water heater appeared to be at the end of its typical service life. @@@ Consider replacement."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: A 40 gallon water heater is somewhat small for a home of this size. Recommend installing a larger tank or tankless system when a new water heater is needed."},{"checked":false,"id":1,"is_red":false,"text":"Signs of scorching observed around the @@heat roll out shield/gas valve/wiring/outside the tank@@. This is generally the result of flame flashback which can be caused by: overfiring or underfiring of the burner; lack of combustion air supply; a chimney obstruction or downdraft."},{"checked":false,"id":1,"is_red":false,"text":"Safety issue. Scorching observed at the water heater roll- out shield. Licensed plumber should service and repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Gas not turned ON at the unit. Water heater not tested and hot water not available to dwelling. Unable to inspect hot water at fixtures. There is an additional charge for a separate trip to return and inspect the water heater and hot water supply branching system."},{"checked":false,"id":1,"is_red":false,"text":"SAFETY CONCERN: The electric wire for the water heater is missing a romex connector. Wire damage could easily occur. Recommend licensed electrician repair as needed."},{"checked":false,"id":1,"is_red":false,"text":" “Sediment Knock” in tank noted; may decrease efficiency of the water heater."},{"checked":false,"id":1,"is_red":false,"text":"Temperature – Pressure drain line is missing.  One should be installed to terminate within six inches of the floor to minimize personal injury which may be caused by scalding water, in the event of a pressure blow-off."},{"checked":false,"id":1,"is_red":false,"text":"Temperature – Pressure drain line: more than 6\" from floor.  One should be installed to terminate within six inches of the floor to minimize personal injury which may be caused by scalding water, in the event of a pressure blow-off."},{"checked":false,"id":1,"is_red":false,"text":"Elbow at end of Temperature – Pressure drain line."},{"checked":false,"id":1,"is_red":false,"text":"Temperature – Pressure relief valve is leaking."},{"checked":false,"id":1,"is_red":false,"text":"Corrosion evident; monitor for leaks."},{"checked":false,"id":1,"is_red":false,"text":"Rust stains present from condensation or precipitation.  "},{"checked":false,"id":1,"is_red":false,"text":"Water leak noted."},{"checked":false,"id":1,"is_red":false,"text":"Flue Pipe of gas water heater loose or corroded.  Repair immediately to prevent carbon monoxide poisoning. "},{"checked":false,"id":1,"is_red":false,"text":"Possible organic substance noted.  The United States Environmental Protection Association (EPA) states, “If you believe that you may have a hidden mold problem, consider hiring a professional.” (Brief Guide to Mold, p.14, EPA).   If any area of the residence is suspected of having organic growth, or any member of your family or household is sensitive to mold, we are lab-certified to conduct a Mold Inspection / Sampling to identify the types of mold (or any other airborne allergens) present.   If necessary, we are also lab-certified to perform radon, meth, asbestos and other environmental testing services.   See: www.IdahoHomeInspectors.biz/rates for more information."},{"checked":false,"id":1,"is_red":false,"text":"Apparent back draft – potential carbon monoxide poisoning hazard.  Have plumber verify proper operation."},{"checked":false,"id":1,"is_red":false,"text":"Insulation blanket - Water heater casing was not visible due to insulation blanket. There is the possibility that problems or defects with the casing were concealed; concealed defects are not within the scope of the home inspection. Age, manufacturer’s information, and any safety concerns unknown. Modern water heaters typically are double-walled, and insulation blankets typically serve no useful purpose, particularly in an enclosed space. Additionally, some manufacturers void their warranties when important operation and safety information is not visible. Recommend further evaluation once insulation blanket has been removed."},{"checked":false,"id":1,"is_red":false,"text":"Limited access to water heater; not all areas visible for inspection (insulation wrap, etc.).  "},{"checked":false,"id":1,"is_red":false,"text":"No dedicated fuel shutoff visible."},{"checked":false,"id":1,"is_red":false,"text":"No Catch Pan and Drain: Water heater is installed over finished living space.  Consider installing pan."},{"checked":false,"id":1,"is_red":false,"text":"Pilot not lit, could not test unit.  Have seller or representative turn unit on and verify proper operation in time for Buyer's Final walkthrough, prior to closing."},{"checked":false,"id":1,"is_red":false,"text":"Gas turned off, could not test unit.  Have seller or representative turn unit on and verify proper operation in time for Buyer's Final walkthrough, prior to closing."},{"checked":false,"id":1,"is_red":false,"text":"No water, could not test unit.  Have seller or representative turn unit on and verify proper operation in time for Buyer's Final walkthrough, prior to closing."},{"checked":false,"id":1,"is_red":false,"text":"No electricity, could not test unit.  Have seller or representative turn unit on and verify proper operation in time for Buyer's Final walkthrough, prior to closing."},{"checked":false,"id":1,"is_red":false,"text":"No dedicated water shutoff visible."},{"checked":false,"id":1,"is_red":false,"text":"Gas flame cover plate not installed.  "},{"checked":false,"id":1,"is_red":false,"text":"Cover over electrical Connections should be re-installed."},{"checked":false,"id":1,"is_red":false,"text":"Electrical wires are not properly secured."},{"checked":false,"id":1,"is_red":false,"text":"No dielectric union between galvanized and copper connections to prevent corrosion."},{"checked":false,"id":1,"is_red":false,"text":"Single Wall flue less than 6\" from flammables.       "},{"checked":false,"id":1,"is_red":false,"text":"Less than 18” minimum height in garage installation; combustion hazard.  "},{"checked":false,"id":1,"is_red":false,"text":"Excessive dust / dirt should be cleaned off the top of the water heater, as it is a possible fire hazard."},{"checked":false,"id":1,"is_red":false,"text":"Rust noted around base of water heater.  Monitor for further deterioration or leaks."},{"checked":false,"id":1,"is_red":false,"text":"."},{"checked":false,"id":1,"is_red":false,"text":"Water Source: Public"},{"checked":false,"id":1,"is_red":false,"text":"Water Source:  Private Well"},{"checked":false,"id":1,"is_red":false,"text":"Water Source:  Community Well"},{"checked":false,"id":1,"is_red":false,"text":"No Smoke or Carbon Monoxide detector in vicinity.  "}],"sepChoice":"4","title":"Water Heater Condition"}],"inspection_panels":[{"descr":"Heater Type:","id":3033,"options":[{"checked":false,"id":1,"is_red":false,"text":"Gas"},{"checked":false,"id":1,"is_red":false,"text":"Electric"}],"sepChoice":"1","title":"Water Heater Type"},{"descr":"Location:","id":3034,"options":[{"checked":false,"id":1,"is_red":false,"text":"The heater is located in the hall closet."},{"checked":false,"id":1,"is_red":false,"text":"The heater is located in the attic."},{"checked":false,"id":1,"is_red":false,"text":"The heater is located in the garage."},{"checked":false,"id":1,"is_red":false,"text":"The heater is located in the kitchen."},{"checked":false,"id":1,"is_red":false,"text":"The heater is located in the laundry room."},{"checked":false,"id":1,"is_red":false,"text":"The heater is located in the exterior closet."},{"checked":false,"id":1,"is_red":false,"text":"The heater is located in the basement."},{"checked":false,"id":1,"is_red":false,"text":"The heater is located in the crawlspace."},{"checked":false,"id":1,"is_red":false,"text":"The heater is located under the structure."},{"checked":false,"id":1,"is_red":false,"text":"The heater is located on the roof."},{"checked":false,"id":1,"is_red":false,"text":"The heater is located in the bedroom."},{"checked":false,"id":1,"is_red":false,"text":"The heater is located in the living room."},{"checked":false,"id":1,"is_red":false,"text":"The heater is located in the bonus room."},{"checked":false,"id":1,"is_red":false,"text":"The heater is located in the guest house."},{"checked":false,"id":1,"is_red":false,"text":"The heater is located in the hall closet."},{"checked":false,"id":1,"is_red":false,"text":"The heater is located in the patio enclosure."},{"checked":false,"id":1,"is_red":false,"text":"The heater is located in the addition area."},{"checked":false,"id":1,"is_red":false,"text":"The heater is located in the family room."},{"checked":false,"id":1,"is_red":false,"text":"The heater is located in the den."}],"sepChoice":"1","title":"Heater Locations"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Water Heater Condition Overall"}],"title":"Condition"},{"damage_panels":[{"descr":"","id":2114,"options":[{"checked":false,"id":1,"is_red":false,"text":"There is no TPR valve present on this water heater. This is a serious safety concern and needs to be corrected at once. We recommend contacting a licensed plumber to install a proper valve."},{"checked":false,"id":1,"is_red":false,"text":"Appears to be in satisfactory condition -- no concerns."},{"checked":false,"id":1,"is_red":false,"text":"A pressure & temperature relief valve & extension is present and appears satisfactory."},{"checked":false,"id":1,"is_red":false,"text":"A Temperature Pressure Relief Valve (TPR Valve) present. This safety valve releases water (and thus relieves pressure) if either the temp or pressure in the tank gets too high. The TPR valve discharge tube must be made of copper, iron, or CPVC (NOT regular PVC). It must terminate within 6\" above the floor--the end cannot be threaded or have a fitting."},{"checked":false,"id":1,"is_red":false,"text":"Temperature Pressure Release (TPR) valve and discharge pipe -- functional and in satisfactory condition."}],"sepChoice":"4","title":"TPRV"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"TPRV Overall"}],"title":"TPRV"},{"damage_panels":[{"descr":"","id":2108,"options":[{"checked":false,"id":1,"is_red":false,"text":"30 gallons"},{"checked":false,"id":1,"is_red":false,"text":"40 gallons"},{"checked":false,"id":1,"is_red":false,"text":"50 gallons"},{"checked":false,"id":1,"is_red":false,"text":"75 gallons"},{"checked":false,"id":1,"is_red":false,"text":"100 gallons"},{"checked":false,"id":1,"is_red":false,"text":"Tankless demand unit present."},{"checked":false,"id":1,"is_red":false,"text":"Boiler present."}],"sepChoice":"4","title":"Number Of Gallons"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Number Of Gallons Overall"}],"title":"Water Number Of Gallons"},{"damage_panels":[{"descr":"","id":2110,"options":[{"checked":false,"id":1,"is_red":false,"text":"none"},{"checked":false,"id":1,"is_red":false,"text":"Appears functional."},{"checked":false,"id":1,"is_red":false,"text":"Could not access the gas valve."},{"checked":false,"id":1,"is_red":false,"text":"Valve appears to be worn."},{"checked":false,"id":1,"is_red":false,"text":"The gas line is capped."},{"checked":false,"id":1,"is_red":false,"text":"The gas line is made of aluminum."},{"checked":false,"id":1,"is_red":false,"text":"The wrong type of valve is installed."},{"checked":false,"id":1,"is_red":false,"text":"Unsecured gas line was observed."},{"checked":false,"id":1,"is_red":false,"text":"the flex line is outside of enclosure."},{"checked":false,"id":1,"is_red":false,"text":"The gas valve is missing."},{"checked":false,"id":1,"is_red":false,"text":"Flex line runs through wall."},{"checked":false,"id":1,"is_red":false,"text":"Flex line exceeds proper length."},{"checked":false,"id":1,"is_red":false,"text":"The smell of gas was  present."},{"checked":false,"id":1,"is_red":false,"text":"The gas line was bent."},{"checked":false,"id":1,"is_red":false,"text":"Can not determine if gas pipe is wrapped in the ground."}],"sepChoice":"4","title":"Gas Valve"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Gas Valve Overall"}],"title":"Gas Valve"},{"damage_panels":[{"descr":"","id":2112,"options":[{"checked":false,"id":1,"is_red":false,"text":"No deficiencies observed at the visible portions of the supply piping."},{"checked":false,"id":1,"is_red":false,"text":"Most of the piping is concealed and cannot be identified."},{"checked":false,"id":1,"is_red":false,"text":"The water supply pipes are Polybutylene plastic (PB). This system of plumbing has experienced a higher than normal failure rate associated with leaks where the pipes are joined together. There is also a current theory that chemicals in municipal water systems react with the piping and resins in the fittings, weakening the pipes and joints. The manufacturers have been involved with and settled class action lawsuits alleging manufacturing defects with this plumbing system containing plastic or metal insert fittings (including copper and brass). For further details about PB contact the Consumer Plumbing Recovery center at 800-392-7591 or the web: http://www.pbpipe.com or http://www.polybutylene.com \nRecommend you research further this type of plumbing system and rely on the evaluation and advice of a licensed plumbing contractor prior to the close of escrow."},{"checked":false,"id":1,"is_red":false,"text":"http://www.polybutylene.com/poly.html"},{"checked":false,"id":1,"is_red":false,"text":"Have all supply piping in the crawl space reviewed by a qualified specialist. "},{"checked":false,"id":1,"is_red":false,"text":"All pipes in crawl space should be insulated."},{"checked":false,"id":1,"is_red":false,"text":"Improper supports or lack of supports to pipes located in crawl space."},{"checked":false,"id":1,"is_red":false,"text":"Corrosion observed. Location: Have all pipes reviewed."},{"checked":false,"id":1,"is_red":false,"text":"Deferred cost: Older galvanized piping."},{"checked":false,"id":1,"is_red":false,"text":"Damaged shut off handles."},{"checked":false,"id":1,"is_red":false,"text":"Missing shut off handles."},{"checked":false,"id":1,"is_red":false,"text":"Leaking needs immediate attention."},{"checked":false,"id":1,"is_red":false,"text":"Leaking bleeder. Location: "},{"checked":false,"id":1,"is_red":false,"text":"Interior faucet needs a anti-siphon device. Location:"},{"checked":false,"id":1,"is_red":false,"text":"Insulation advised for pipes at unheated areas."},{"checked":false,"id":1,"is_red":false,"text":"Missing/Damaged supports."},{"checked":false,"id":1,"is_red":false,"text":"NOTE:  Water shut off valve for REAR HOSE BIB was not found and/identified. Suspect it was covered over by ceiling finishing process.  However, rear faucet does have an older type of \"frost-free\" hose bib. Client made aware."}],"sepChoice":"4","title":"Plumbing"}],"inspection_panels":[{"descr":"","id":3036,"options":[{"checked":false,"id":1,"is_red":false,"text":"Copper"},{"checked":false,"id":1,"is_red":false,"text":"Galvanized"},{"checked":false,"id":1,"is_red":false,"text":"PVC"},{"checked":false,"id":1,"is_red":false,"text":"Unknown"},{"checked":false,"id":1,"is_red":false,"text":"Aquapex"}],"sepChoice":"1","title":"Plumbing Material Type"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Plumbing Overall"}],"title":"Plumbing"},{"damage_panels":[{"descr":"","id":2111,"options":[{"checked":false,"id":1,"is_red":false,"text":"The discharge tube discharges above six inches from slab, this should be lowered due to the possibility of scalding should a discharge situation happen."},{"checked":false,"id":1,"is_red":false,"text":"We recommend that the  overflow line extend to the exterior of the enclosure."},{"checked":false,"id":1,"is_red":false,"text":"Appears to be in satisfactory condition -- no concerns."},{"checked":false,"id":1,"is_red":false,"text":"The extension at the water heater relief valve is missing. This is a potential scalding concern as water can discharge improperly. Recommend installing the proper type of relief extension to discharge within 6 to 8” from the floor."},{"checked":false,"id":1,"is_red":false,"text":"A Temperature Pressure Relief Valve (TPR Valve) present. This safety valve releases water (and thus relieves pressure) if either the temp or pressure in the tank gets too high. The TPR valve discharge tube must be made of copper, iron, or CPVC (NOT regular PVC). It must terminate within 6\" above the floor--the end cannot be threaded or have a fitting."},{"checked":false,"id":1,"is_red":false,"text":"Temperature Pressure Release (TPR) valve and discharge pipe -- functional and in satisfactory condition."}],"sepChoice":"4","title":"Overflow Condition"}],"inspection_panels":[{"descr":"","id":3035,"options":[{"checked":false,"id":1,"is_red":false,"text":"None"},{"checked":false,"id":1,"is_red":false,"text":"Copper"},{"checked":false,"id":1,"is_red":false,"text":"Galvanized"},{"checked":false,"id":1,"is_red":false,"text":"PVC"},{"checked":false,"id":1,"is_red":false,"text":"Plastic"},{"checked":false,"id":1,"is_red":false,"text":"Rubber"},{"checked":false,"id":1,"is_red":false,"text":"Flex line"}],"sepChoice":"1","title":"Overflow"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Overflow Condition Overall"}],"title":"Overflow Line"},{"damage_panels":[{"descr":"","id":2113,"options":[{"checked":false,"id":1,"is_red":false,"text":"The water heater is not strapped."},{"checked":false,"id":1,"is_red":false,"text":"Not to code, requires two 1 1/2\" steel straps 16 gauge, 1/3 from the top and the bottom."},{"checked":false,"id":1,"is_red":false,"text":"The water heater has makeshift strapping using plumbers tape. This method is not industry standard and needs to be corrected."},{"checked":false,"id":1,"is_red":false,"text":"The strapping is missing lag bolts and using screws instead. There is a structural concern here."},{"checked":false,"id":1,"is_red":false,"text":"The water heater is braced instead of using strapping."},{"checked":false,"id":1,"is_red":false,"text":"The water heater is missing one strap. Two are required."}],"sepChoice":"4","title":"Strapping"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Strapping Overall"}],"title":"Strapping"}],"title":"Water Heater"},{"id":13,"tabbed_panels":[{"damage_panels":[],"inspection_panels":[{"descr":"Locations:","id":3013,"options":[{"checked":false,"id":1,"is_red":false,"text":"Master Bathroom"},{"checked":false,"id":1,"is_red":false,"text":"Main Floor Bathroom"},{"checked":false,"id":1,"is_red":false,"text":"Basement Bathroom"},{"checked":false,"id":1,"is_red":false,"text":"Upstairs bathroom"},{"checked":false,"id":1,"is_red":false,"text":"Half bathroom"},{"checked":false,"id":1,"is_red":false,"text":"Upstairs#1"},{"checked":false,"id":1,"is_red":false,"text":"Guest bathroom"},{"checked":false,"id":1,"is_red":false,"text":"Main floor bath #2"},{"checked":false,"id":1,"is_red":false,"text":"Upstairs #2"},{"checked":false,"id":1,"is_red":false,"text":"Full bath "},{"checked":false,"id":1,"is_red":false,"text":"Bathrooms in bedrooms and a small guest bath on main floor."},{"checked":false,"id":1,"is_red":false,"text":"Full bathrooms in basement, main floor, second floor."},{"checked":false,"id":1,"is_red":false,"text":"Master bath adjacent to second floor bedroom."}],"sepChoice":"1","title":"Locations"}],"pictures":[],"ratings":[],"title":"Locations"},{"damage_panels":[{"descr":"","id":2034,"options":[{"checked":false,"id":1,"is_red":false,"text":"Most not accessible due to stored personal items."},{"checked":false,"id":1,"is_red":false,"text":"No deficiencies observed."},{"checked":false,"id":1,"is_red":false,"text":"Appeared functional and in satisfactory condition, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Recommend adding additional cabinet screws as drywall screws have been used."},{"checked":false,"id":1,"is_red":false,"text":"Loose at wall. Needs immediate attention. "},{"checked":false,"id":1,"is_red":false,"text":"DEFERRED COST:  The cabinets are original. Consider upgrade.."},{"checked":false,"id":1,"is_red":false,"text":"Appeared functional, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Mold-like bio growth observed inside vanity at powder room, bathroom #3.  Evidence of a prior leak in the sink drain trap. Professional testing & evaluation advised."},{"checked":false,"id":1,"is_red":false,"text":"Some cabinet doors need magnets or hardware to stay shut. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Some cabinet drawers  need  hardware repair/adjustment (to stay shut). Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Drawers are difficult to slide. It appears that if the guides are lubricated, that will correct the problem."},{"checked":false,"id":1,"is_red":false,"text":"Broken drawer guides noted. Recommend having a qualified contractor replace the guides."},{"checked":false,"id":1,"is_red":false,"text":"Noted cabinet(s) loose on the wall. Recommend having a qualified contractor re-fasten the cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Noted cabinet(s) loose at the floor. Recommend having a qualified contractor re-fasten the cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Noted cabinet(s) loose at the ceiling. Recommend having a qualified contractor re-fasten the cabinets."},{"checked":false,"id":1,"is_red":false,"text":"There appears to be water damage under sink. This tested dry at the time of the inspection, but monitor for any further intrusion."},{"checked":false,"id":1,"is_red":false,"text":"Doors did not close completely."},{"checked":false,"id":1,"is_red":false,"text":"The door was locked to bathroom, could not access the room to inspect."},{"checked":false,"id":1,"is_red":false,"text":"The sliding cabinet doors were difficult to slide. It appears that lubrication will correct the problem."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors missing, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors missing hardware, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawers missing, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors have broken hinges, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawers missing handles, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawers off their guides, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors have loose hardware, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors missing knobs, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawer face is missing, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawer face is loose, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors have broken glass panels in them, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Drawer(s) bind in tracks"},{"checked":false,"id":1,"is_red":false,"text":"Drawer(s) unsupported in cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Shelving missing or damaged."},{"checked":false,"id":1,"is_red":false,"text":"Lazy Susan cabinet binds and does not turn smoothly."}],"sepChoice":"4","title":"Cabinets"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Cabinets Overall"}],"title":"Cabinets"},{"damage_panels":[{"descr":"","id":2035,"options":[{"checked":false,"id":1,"is_red":false,"text":"Small cracking in the wall finish is noted. This is probably caused by the joint compound (spackle) drying too quickly during application. "},{"checked":false,"id":1,"is_red":false,"text":"Minor damage from what appears to be from excess moisture noted. Recommend review of current vent fan and possibly installing a timer to assure that fan is used during showers."},{"checked":false,"id":1,"is_red":false,"text":"The drywall is patched in areas. The reason for the patch could not be determined. "},{"checked":false,"id":1,"is_red":false,"text":"Small stains noted on the ceiling. They tested dry at the time of the inspection."},{"checked":false,"id":1,"is_red":false,"text":"Large stains noted on the ceiling. They tested dry at the time of the inspection."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of past leaking was noted."},{"checked":false,"id":1,"is_red":false,"text":"There were signs of paint blistering on the ceiling. The areas tested dry at the time of the inspection, but should be monitored for further damage or possibly water intrusion."},{"checked":false,"id":1,"is_red":false,"text":"The inspector could not access the area around the skylight."},{"checked":false,"id":1,"is_red":false,"text":"Visible leaking noted on the ceiling. We recommend contacting a qualified contractor to evaluate the roof and the drywall in this area and repair as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Freshly painted in areas. This could be concealing a defect that could not be determined."},{"checked":false,"id":1,"is_red":false,"text":"Mold like stains present on the ceiling. We recommend having a mold sample taken and lab tested, also monitor the area for water intrusion."},{"checked":false,"id":1,"is_red":false,"text":"There is a damaged ceiling tile in dining room - damage is between crown molding and tile in form of a puncture of sorts. see pic."},{"checked":false,"id":1,"is_red":false,"text":"Extensive water damage to general area of ceiling where the past leaking had occurred. Areas are marked with peeling paint and bulging drywall. Have a contractor evaluate."},{"checked":false,"id":1,"is_red":false,"text":"There is an anomaly present at the point in the ceiling that adjoins the inner wall. It appears there is a bowing / sagging in the corner. It is not clear as to what may have caused this. Ask association about this issue and about past occurrences that may be linked to this issue."},{"checked":false,"id":1,"is_red":false,"text":"The drywall installation is not entirely professional quality, have a contractor evaluate."}],"sepChoice":"4","title":"Ceiling Condition"}],"inspection_panels":[{"descr":"","id":3014,"options":[{"checked":false,"id":1,"is_red":false,"text":"There are drywall ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"There are plaster ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"There are acoustic grid and tile ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"There are wood plank ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"There are metal pan ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"Open beam ceiling construction noted."},{"checked":false,"id":1,"is_red":false,"text":"There is panel lighting present in the ceiling."},{"checked":false,"id":1,"is_red":false,"text":"The ceilings are clad in wood paneling."},{"checked":false,"id":1,"is_red":false,"text":"Cathedral style (vaulted) ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"Mirror panels are noted on the ceilings."},{"checked":false,"id":1,"is_red":false,"text":"The ceilings are clad in cork."},{"checked":false,"id":1,"is_red":false,"text":"The ceilings are clad in a laminate material."},{"checked":false,"id":1,"is_red":false,"text":"The ceilings are clad in tile squares."}],"sepChoice":"1","title":"Ceilings"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Ceiling Condition Overall"}],"title":"Ceilings"},{"damage_panels":[{"descr":"","id":2036,"options":[{"checked":false,"id":1,"is_red":false,"text":"Plastic laminate tops noted."},{"checked":false,"id":1,"is_red":false,"text":"Solid Surface tops noted."},{"checked":false,"id":1,"is_red":false,"text":"Granite tops noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood counter tops noted."},{"checked":false,"id":1,"is_red":false,"text":"There is normal wear noted for the age of the counter tops."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops are stained. Normal cleaning should take care of this."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops appear to be worn and may have reached the end of their useful life."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops are noted as being chipped."},{"checked":false,"id":1,"is_red":false,"text":"No discrepancies noted."},{"checked":false,"id":1,"is_red":false,"text":"Some of the areas not visible due to stored personal items."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops appear to be loose on the cabinet. We recommend having a qualified contractor re-fasten them."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops are noted as having loose Formica. We recommend having a qualified contractor re-fasten it."},{"checked":false,"id":1,"is_red":false,"text":"Granite backsplash appears to not have been caulked when installed--except just behind sink.  Recommend sealing with clear silicone caulk along entire length of backsplash.  This prevents water leaks from spills and counter cleanups."},{"checked":false,"id":1,"is_red":false,"text":"Laminated countertop is swollen and beginning to blister @@lLOCATION@@. This is a cosmetic issue for your information. Repair as necessary."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops are noted as cracked or damaged."}],"sepChoice":"4","title":"Counters"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Counters Overall"}],"title":"Counters"},{"damage_panels":[{"descr":"","id":2037,"options":[{"checked":false,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Door doesn't latch properly."},{"checked":false,"id":1,"is_red":false,"text":"Door binds in jamb or floor."},{"checked":false,"id":1,"is_red":false,"text":"Door damaged."},{"checked":false,"id":1,"is_red":false,"text":"Door missing."},{"checked":false,"id":1,"is_red":false,"text":"Door handle missing."},{"checked":false,"id":1,"is_red":false,"text":"Door handle loose."},{"checked":false,"id":1,"is_red":false,"text":"Pocket door does not latch or lock."},{"checked":false,"id":1,"is_red":false,"text":"Sliding Door(s) are not securely installed on tracks."},{"checked":false,"id":1,"is_red":false,"text":"Condensation present in sliding door double-paned window(s), suggesting a broken gas seal."},{"checked":false,"id":1,"is_red":false,"text":"Some door stop(s) missing / ineffective; recommend installation to avoid unnecessary wall or door damage.  "},{"checked":false,"id":1,"is_red":false,"text":"Doors are non-standard, which is characteristic for a house of this age."},{"checked":false,"id":1,"is_red":false,"text":"Low headroom at basement stairwell which is common for a house of this age."},{"checked":false,"id":1,"is_red":false,"text":"Door to basement opens over stairs.  Use caution; by modern standards, it should open into structure or onto a landing to prevent personal injury from falls."},{"checked":false,"id":1,"is_red":false,"text":"Air and light entering at entrance door."},{"checked":false,"id":1,"is_red":false,"text":"Threshhold of entrance door sags slightly when stepped upon; recommend providing more support."},{"checked":false,"id":1,"is_red":false,"text":"Caulk or grout recommended at entrance door - floor junctions to prevent water  carried in by foot traffic from entering under the flooring.  "},{"checked":false,"id":1,"is_red":false,"text":"Maintenance Tip: Caulk or grout recommended at door - floor junctions, where applicable, to prevent water that is carried in by foot traffic from entering under the flooring.  "},{"checked":false,"id":1,"is_red":false,"text":"Door stops missing; recommend installing to avoid unnecessary wall and/or door damage.  Note that living room closet door can hit into glass at front door. "},{"checked":false,"id":1,"is_red":false,"text":"Double door entryway noted."},{"checked":false,"id":1,"is_red":false,"text":"The back door is difficult to open and close; mechanism may not be installed true. Back door opens to a step off and fall situation, needs a landing and stairs built on exterior. At lease put up a sign during any open house viewing of the property."},{"checked":false,"id":1,"is_red":false,"text":"Bedroom door is missing doorknob & hardware."},{"checked":false,"id":1,"is_red":false,"text":"Hollow wood doors. "},{"checked":false,"id":1,"is_red":false,"text":"Front door and hardware is damaged."},{"checked":false,"id":1,"is_red":false,"text":"The bathroom door does not lock."},{"checked":false,"id":1,"is_red":false,"text":"The entry doors automatic closer is unable tp perform its function due to the thick carpeting that makes the door difficult to open and close."},{"checked":false,"id":1,"is_red":false,"text":"The bathroom closet door is off its tracks."},{"checked":false,"id":1,"is_red":false,"text":"The door for the furnace closet should be louvred to allow air in to help combustion. "},{"checked":false,"id":1,"is_red":false,"text":"Metal door with \"wood look\"."},{"checked":false,"id":1,"is_red":false,"text":"Sliding door in rear leading to porch."},{"checked":false,"id":1,"is_red":false,"text":"Back door missing a deadbolt lockset."},{"checked":false,"id":1,"is_red":false,"text":"The top floor units back door rubs on the floor as it opens and closes, may need some sanding on bottom of door to help clearance."},{"checked":false,"id":1,"is_red":false,"text":"Some doors are damaged."},{"checked":false,"id":1,"is_red":false,"text":"Several doors are a bit tight in jams, possibly from the new coat of paint."},{"checked":false,"id":1,"is_red":false,"text":"Loose door striker on bedroom door frame."},{"checked":false,"id":1,"is_red":false,"text":"The exit door to mechanical room utilises a self closing mechanism."},{"checked":false,"id":1,"is_red":false,"text":"Doors are not installed."},{"checked":false,"id":1,"is_red":false,"text":"Door did not latch and needs adjustment at:"},{"checked":false,"id":1,"is_red":false,"text":"Door hits toilet. Pocket door would eliminate this problem."},{"checked":false,"id":1,"is_red":false,"text":"Door lock appears inadequate, recommend upgrading to provide easier privacy use function of door."},{"checked":false,"id":1,"is_red":false,"text":"Damaged door noted at one or more locations."},{"checked":false,"id":1,"is_red":false,"text":"The installation of a security chain on an interior door is considered a safety hazard. In the event of an emergency a person could not escape due to inability to open door."},{"checked":false,"id":1,"is_red":false,"text":"Pocket door is noted as difficult to operate."},{"checked":false,"id":1,"is_red":false,"text":"Pocket door is noted as stuck in the wall at the time of inspection."}],"sepChoice":"4","title":"Doors"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Doors Overall"}],"title":"Doors"},{"damage_panels":[{"descr":"","id":2038,"options":[{"checked":false,"id":1,"is_red":false,"text":"Some outlets were not accessible due to furniture and or stored personal items in the wat."},{"checked":false,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Light loose from wall."},{"checked":false,"id":1,"is_red":false,"text":"Light fixture or bulb apparently inoperable at   .  Change bulb(s) and check."},{"checked":false,"id":1,"is_red":false,"text":"Light bulbs are missing at various fixtures throughout the house, and cannot be evaluated."},{"checked":false,"id":1,"is_red":false,"text":"Some smoke detectors inoperable, others missing in bedrooms.  Install or replace.   "},{"checked":false,"id":1,"is_red":false,"text":"Smoke detectors missing in bedrooms.  Installation recommended."},{"checked":false,"id":1,"is_red":false,"text":"Smoke detector(s) need new backup batteries."},{"checked":false,"id":1,"is_red":false,"text":"GFCI trip test failed.  Have licensed electrician evaluate and repair / replace as necessary."},{"checked":false,"id":1,"is_red":false,"text":"GFCI protection is provided to all bathrooms.  If tripped reset in master bathroom."},{"checked":false,"id":1,"is_red":false,"text":"Switch damaged or apparently inoperable."},{"checked":false,"id":1,"is_red":false,"text":"Switch purpose unknown.  Check with seller. "},{"checked":false,"id":1,"is_red":false,"text":"Switch needs new cover."},{"checked":false,"id":1,"is_red":false,"text":"Outlet damaged."},{"checked":false,"id":1,"is_red":false,"text":"Outlet needs new cover."},{"checked":false,"id":1,"is_red":false,"text":"Outlet cover(s) missing."},{"checked":false,"id":1,"is_red":false,"text":"Outlet apparently inoperable."},{"checked":false,"id":1,"is_red":false,"text":"Open ground (or 2-wire) outlets present.  This means that the 3rd (round) part of an appliance plug is not getting ground protection.  This may be a concern with items such as computers and electronic devices."},{"checked":false,"id":1,"is_red":false,"text":"Hot-neutral reversed outlets present.  This means that the black and white wires in the circuit have been reversed, and may be a concern with items such as computers and electronic devices."},{"checked":false,"id":1,"is_red":false,"text":"Open neutral outlet.  This means the receptacle is not working properly because, even though the black wire is hot, the white (neutral) wire is not connected well somewhere, so that it cannot carry any current \"back\" to the main panel. "},{"checked":false,"id":1,"is_red":false,"text":"Connections made outside of a Junction Box.  This is a potential shock or electrocution hazard."},{"checked":false,"id":1,"is_red":false,"text":"Wire ends are outside of a Junction Box at.  This is a potential shock or electrocution hazard."},{"checked":false,"id":1,"is_red":false,"text":"Junction Box Cover(s) missing.  This is a potential shock or electrocution hazard."},{"checked":false,"id":1,"is_red":false,"text":"Romex wiring should all be enclosed in conduit for protection from nicks or cuts which could be a source of shocks or even electrocution."},{"checked":false,"id":1,"is_red":false,"text":"This property has “knob and tube” wiring which was commonly installed prior to 1950. It is ungrounded, and considered unsafe by today’s standards. Over time, the wire’s insulation may become brittle and fall apart or wear thin, resulting in exposed conductors and a risk of shock and/or fire. This wiring is also easily damaged by covering it with insulation (a common practice), and incorrectly tapping new wiring into it. Some energized knob and tube wiring was found during the inspection. It is not within the scope of this inspection to determine what percentage of this property’s wiring is of the knob and tube type or to determine what percentage of the knob and tube wiring is energized vs. abandoned. A qualified electrician should evaluate this wiring and make repairs or replace wiring as necessary. "},{"checked":false,"id":1,"is_red":false,"text":"Aluminum wiring present - Between 1965 and 1973, aluminum wiring was sometimes substituted for copper wiring in residential electrical systems. Connections in outlets, switches, and light fixtures with aluminum wiring may become increasingly dangerous as time passes. Poor connections cause wiring to overheat, creating a potential fire hazard. Aluminum wiring connections are subject to greater deterioration than is copper due to thermal expansion and contraction, vibration (caused when electric currents pass through wiring), oxidation (caused by exposure to oxygen in the air), and galvanic corrosion (caused when two different metals are connected together), all of which can cause poor connections. When wires are poorly connected they overheat, which creates a potential fire hazard.  The presence of aluminum wiring might also have an effect on your insurance policy. You should ask your insurance agent whether the presence of aluminum wiring is a problem that requires changes to your policy language in order to ensure that your house is covered. The wiring should be evaluated by a qualified electrician experienced in evaluating and correcting aluminum wiring problems. Not all electrical contractors qualify. "},{"checked":false,"id":1,"is_red":false,"text":"220 Volt receptacle needs to be secured to wall."},{"checked":false,"id":1,"is_red":false,"text":"Undersized extension cord in use."},{"checked":false,"id":1,"is_red":false,"text":"We recommend that a licensed electrician evaluate, repair and replace wires and connections as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Note:  Smoke-carbon monoxide combination detector(s) recommended near utilities."},{"checked":false,"id":1,"is_red":false,"text":"Dimming lights were observed, this may be an indication of inadequate electrical distribution. We recommend review by a licensed electrician for evaluation and redistribution as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Reversed polarity, hot and neutral reversed and other terms used for electric receptacles are usually easily corrected by minor wiring adjustments at the specified item. When these conditions are noted in this report, a licensed electrician should be consulted for repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Ungrounded receptacles observed at water sources or exterior locations ideally should be grounded, suggest installing GFCI's for safety."},{"checked":false,"id":1,"is_red":false,"text":"Switches have unknown function, consult the owner for clarification on what they control."},{"checked":false,"id":1,"is_red":false,"text":"Outlet with open ground noted."},{"checked":false,"id":1,"is_red":false,"text":"Replace all old not functioning smoke/ fire detectors with new hard wired detectors or make sure batteries are good."},{"checked":false,"id":1,"is_red":false,"text":"The installation of smoke detectors is not yet completed. We recommend having the seller finish installation and verify proper operation of detectors."},{"checked":false,"id":1,"is_red":false,"text":"Missing detector in hallway."},{"checked":false,"id":1,"is_red":false,"text":"There are smoke detectors hard wired in and connected to each other,but there was one beeping continually- it may need to be replaced."},{"checked":false,"id":1,"is_red":false,"text":"Smoke detectors were tested and are functional. Remember to check detectors regularly, and replace when needed according to manufactures and fire safety guidelines. "},{"checked":false,"id":1,"is_red":false,"text":"No smoke/ fire detectors were installed at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"After 5 years of operation, CARBON MONOXIDE detectors should be replaced, because they wear out."},{"checked":false,"id":1,"is_red":false,"text":"It is recommended to test CO detectors regularly."},{"checked":false,"id":1,"is_red":false,"text":"Have hard wired, or plug in CO Detectors installed at a low elevation, as it may hover close to the ground and rise up during a fire."},{"checked":false,"id":1,"is_red":false,"text":"If a carbon monoxide detector sets its alarm from exposure to CO, it is no longer considered efficient to use as its sensor mechanism will have been depleted. "},{"checked":false,"id":1,"is_red":false,"text":"Tested and functional at time of inspection, but only the siren was tested, not the carbon monoxide sensor."},{"checked":false,"id":1,"is_red":false,"text":"Recommend contacting a licensed electrician to evaluate and offer repair options."},{"checked":false,"id":1,"is_red":false,"text":"GFCI protection is provided to all bathrooms.  If tripped reset in master bathroom."}],"sepChoice":"4","title":"Electrical"},{"descr":"","id":2039,"options":[{"checked":false,"id":1,"is_red":false,"text":"GFCI did not respond to test, suggest replacing for safety."},{"checked":false,"id":1,"is_red":false,"text":"GFCI had power when tripped.  This is often the result of miswiring and is usually easily fixed.  Advise repair on replacement as needed."},{"checked":false,"id":1,"is_red":false,"text":"GFCI in place and operational"},{"checked":false,"id":1,"is_red":false,"text":"GFCI in this bathroom resets other bathroom receptacles"},{"checked":false,"id":1,"is_red":false,"text":"GFCI protected receptacles may not have been required when the house was built. We suggest buyer consider upgrading with GFCI's at all receptacles near water sources."},{"checked":false,"id":1,"is_red":false,"text":"No GFCI protection present, suggest installing GFCI protected receptacles for safety."},{"checked":false,"id":1,"is_red":false,"text":"No GFCI - \r\nElectrical outlets in this bathroom appeared to be in serviceable condition at the time of the inspection but had no Ground Fault Circuit Interrupter (GFCI) protection. \r\nAlthough this condition may have been commonly considered safe or acceptable at the time the home was originally constructed, as general knowledge of safe building practices has improved with the passage of time, building standards have changed to reflect current understanding. \r\nConsider having GFCI protection installed as a safety precaution for outlets within 6 feet of a plumbing fixture.\r\nThis can be achieved by: \r\n1. Replacing the current standard outlets with GFCI outlets\r\n2. Replacing the outlet in this bathroom circuit which is nearest the main electrical service panel with a GFCI outlet. \r\n3. Replacing the breaker currently protecting the electrical circuit which contains these bathroom outlets with a GFCI breaker."},{"checked":false,"id":1,"is_red":false,"text":"GFCI, lights & fans on same circuit."},{"checked":false,"id":1,"is_red":false,"text":"Reset forthe GFCI is in the main panel."},{"checked":false,"id":1,"is_red":false,"text":"Reset for the GFCI is in the garage."},{"checked":false,"id":1,"is_red":false,"text":"Reset for the GFCI is in in the master bath."},{"checked":false,"id":1,"is_red":false,"text":"Reset for the GFCI is in the 1/2 bathroom."},{"checked":false,"id":1,"is_red":false,"text":"GFCI tested and functioned properly."},{"checked":false,"id":1,"is_red":false,"text":"Recommend upgrading All receptacle to GFCI protection within 6 feet of all potential wet locations."},{"checked":false,"id":1,"is_red":false,"text":"GFCI tested and found to be improperly wired. Recommend review and repair by Qualified Electrician. "},{"checked":false,"id":1,"is_red":false,"text":"GFCI reset at breaker panel. <FYI>"},{"checked":false,"id":1,"is_red":false,"text":"One or more bathrooms lack the installation of an outlet <FYI>. Typically at least one outlet is installed for the use of personal grooming appliances ie hair dryer, curling iron, electric razor ect. Recommend upgrading home with the installation of a Ground Fault Circuit Interrupter receptacle at all applicable locations."},{"checked":false,"id":1,"is_red":false,"text":"GFCI protected receptacles may not have been required when the house was built. We suggest buyer consider upgrading with GFCI's at all receptacles near water sources."},{"checked":false,"id":1,"is_red":false,"text":"Missing cover plates observed, suggest installing for safety."},{"checked":false,"id":1,"is_red":false,"text":"Recommend full review by qualified electrical contractor for quotes on upgrades/repair to ensure safe and adequate service."},{"checked":false,"id":1,"is_red":false,"text":"Reversed polarity, hot and neutral reversed and other terms used for electric receptacles are usually easily corrected by minor wiring adjustments at the specified item. When these conditions are noted in this report, a licensed electrician should be consulted for repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Since ungrounded receptacles were noted in the home, buyer is cautioned that proper grounding is strongly urged where sensitive electronic equipment is used.  Ungrounded receptacles do not offer protection for computers etc.  Consultation with a qualified electrical contractor is recommended."},{"checked":false,"id":1,"is_red":false,"text":"Ungrounded receptacles observed at water sources or exterior locations ideally should be grounded, suggest installing GFCI's for safety."}],"sepChoice":"4","title":"GFCI"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Electrical Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"GFCI Overall"}],"title":"Electrical"},{"damage_panels":[{"descr":"","id":2040,"options":[{"checked":false,"id":1,"is_red":false,"text":"The bath fan was operated and no issues were found."},{"checked":false,"id":1,"is_red":false,"text":"The bath fan is a worn unit which may be at the end of its useful life."},{"checked":false,"id":1,"is_red":false,"text":"Central ventilation is present."},{"checked":false,"id":1,"is_red":false,"text":"Current guidelines state that either exhaust fan or window should be in all bathrooms to ensure ventilation of moisture.  This is especially important where bathtubs or showers are present. "},{"checked":false,"id":1,"is_red":false,"text":"Destination of vent pipe could not be determined."},{"checked":false,"id":1,"is_red":false,"text":"Exhaust fan is inoperable."},{"checked":false,"id":1,"is_red":false,"text":"Exhaust fan is noisy.\n"},{"checked":false,"id":1,"is_red":false,"text":"Exhaust fan vibrates or is excessively noisy. This may indicate a worn armature or bearings. The fan may eventually need to be replaced to correct this condition."},{"checked":false,"id":1,"is_red":false,"text":"Fan is a slow starter, suggest having motor professionally cleaned."},{"checked":false,"id":1,"is_red":false,"text":"Fan is covered with plastic, did not test."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the exhaust fan is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"No fan was observed, we recommend an exhaust fan be installed in all bathrooms for proper ventilation and moisture control."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Recommend replacement of the fan by a qualified electrical contractor."},{"checked":false,"id":1,"is_red":false,"text":"The bath fan did not operate when tested. "},{"checked":false,"id":1,"is_red":false,"text":"Bathroom fans exhaust to exterior at soffits\r\n\r\n"},{"checked":false,"id":1,"is_red":false,"text":"Master Bath shower fan exhaust properly to exterior of home."},{"checked":false,"id":1,"is_red":false,"text":"Bathroom fans exhaust properly to exterior of home."},{"checked":false,"id":1,"is_red":false,"text":"Improve: There is no exhaust fan in Master #1. Recommend installing to reduce the risks of moisture."},{"checked":false,"id":1,"is_red":false,"text":"Improve: There are no exhaust fans."},{"checked":false,"id":1,"is_red":false,"text":"Improve: There is no bath fan. Location: Half bath"},{"checked":false,"id":1,"is_red":false,"text":"The fan terminates improperly in the attic. This can create excessive moisture. Recommend directing the vent towards the exterior to allow for proper ventilation."},{"checked":false,"id":1,"is_red":false,"text":"Appeared functional, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Several of the bathroom exhaust pipes terminate in the attic. This can cause a buildup of moisture and eventually mold in the attic. Recommend directing the vent towards the exterior to allow for proper ventilation."},{"checked":false,"id":1,"is_red":false,"text":"The bath fan is poorly located in the basement bath and should be located in the shower stall and by the toilet."},{"checked":false,"id":1,"is_red":false,"text":"Staining below bath fan. Recommend cleaning stain and having vent checked for proper termination to the exterior."},{"checked":false,"id":1,"is_red":false,"text":"Did not operate when tested."},{"checked":false,"id":1,"is_red":false,"text":"The vent pipe from the exhaust fan in the <<Bathrom Locations>>  terminates and is pointed at the attic roof ridge vent/soffit vent/gable vent. Although, this was within standard building practice at the time this house was built--This is less efficient and can cause a buildup of moisture and eventually mold in the attic.   Recommend upgrading to properly route vent(s) to the exterior of the home."}],"sepChoice":"4","title":"Exhaust Fan"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Exhaust Fan Overall"}],"title":"Bath Fan"},{"damage_panels":[{"descr":"","id":2041,"options":[{"checked":false,"id":1,"is_red":false,"text":"Some of the floors in this building are a vintage 9\" x 9\" size; be advised that these tiles may be the type that had an adhesive containing asbestos. Asbestos is a health risk when it is made friable - in other words, when its fibres and dust can be breathed in by the lungs. To be safe, please refrain from removal and damaging these tiles until it is certain they are not asbestos containing material."},{"checked":false,"id":1,"is_red":false,"text":"Floor is not level. Suggest further evaluation by a licensed contractor within the inspection contingency period."},{"checked":false,"id":1,"is_red":false,"text":"Laminate floating floor system was installed with poor workmanship techniques, gaps, under size cuts, and chips are visible giving a less than appealing appearance and likely lowering the serviceable life of the flooring."},{"checked":false,"id":1,"is_red":false,"text":"It appears the existing carpeting was installed over the concrete slab without a moisture barrier;this is not a good installation method. The moisture content in the concrete can create the growth of organic materials \"Mold\" in the carpet. Recommend contacting a qualified contractor for further evaluation."},{"checked":false,"id":1,"is_red":false,"text":"Only the sub flooring is present and it is inconsistent in installation."},{"checked":false,"id":1,"is_red":false,"text":"Damaged grout observed, suggest regrouting as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Common cracks noted."},{"checked":false,"id":1,"is_red":false,"text":"Cracked tiles noted."},{"checked":false,"id":1,"is_red":false,"text":"Cracking noted in ceramic tiles.  This is an indication of inadequate subfloor installation."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of repairs observed, unable to determine the effectiveness of these repairs."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the floor is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"Minor damage noted."},{"checked":false,"id":1,"is_red":false,"text":"Numerous cracked tiles noted."},{"checked":false,"id":1,"is_red":false,"text":"Open seams observed."},{"checked":false,"id":1,"is_red":false,"text":"Popping floor tile observed."},{"checked":false,"id":1,"is_red":false,"text":"Possible trip hazard. This is a safety concern. Suggest repair/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified professional for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Recommend sealing cracks/voids."},{"checked":false,"id":1,"is_red":false,"text":"Tile has been painted/refinished, suggest taking care when cleaning to protect the surface."},{"checked":false,"id":1,"is_red":false,"text":"Water damage observed."},{"checked":false,"id":1,"is_red":false,"text":"Carpet is not recommended in bathrooms due to potential to harbor moisture, which could lead to unwanted mold issues."},{"checked":false,"id":1,"is_red":false,"text":"Recommend caulking at the tub and shower areas"},{"checked":false,"id":1,"is_red":false,"text":"Flooring appears to have damaged subfloor due to plumbing leak ."}],"sepChoice":"4","title":"Floor Condition"}],"inspection_panels":[{"descr":"","id":3015,"options":[{"checked":false,"id":1,"is_red":false,"text":"Carpet is noted."},{"checked":false,"id":1,"is_red":false,"text":"Ceramic tile is noted."},{"checked":false,"id":1,"is_red":false,"text":"Sheet vinyl flooring is noted."},{"checked":false,"id":1,"is_red":false,"text":"Hardwood flooring is noted."},{"checked":false,"id":1,"is_red":false,"text":"Floating laminate type flooring noted."},{"checked":false,"id":1,"is_red":false,"text":"Marble floors noted."},{"checked":false,"id":1,"is_red":false,"text":"Natural stone floors noted."},{"checked":false,"id":1,"is_red":false,"text":"Bare concrete floors noted."},{"checked":false,"id":1,"is_red":false,"text":"Plywood subfloor is exposed."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl squares (tiles) are noted"}],"sepChoice":"1","title":"Floors"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Floor Condition Overall"}],"title":"Floors"},{"damage_panels":[{"descr":"","id":2042,"options":[{"checked":false,"id":1,"is_red":false,"text":"Central heating and cooling noted in this room. At the time of the inspection, all appeared to be functioning and in serviceable condition."},{"checked":false,"id":1,"is_red":false,"text":"Central heating noted in this room. At the time of the inspection, all appeared to be functioning and in serviceable condition."},{"checked":false,"id":1,"is_red":false,"text":"Electric wall heating and cooling noted in this room. At the time of the inspection, all appeared to be functioning and in serviceable condition."},{"checked":false,"id":1,"is_red":false,"text":"Electric ceiling mounted heating noted in this room. At the time of the inspection, it appeared to be functioning and in serviceable condition."},{"checked":false,"id":1,"is_red":false,"text":"Heat lamp mounted in the ceiling noted in this room. At the time of the inspection, it appeared to be functioning and in serviceable condition."},{"checked":false,"id":1,"is_red":false,"text":"See HVAC page for more information about this section."},{"checked":false,"id":1,"is_red":false,"text":"The inspector did not test the unit due to its poor condition. The heating unit appears to be well beyond its useful life."},{"checked":false,"id":1,"is_red":false,"text":"The inspector recommends removal of the  electric wall heating unit."}],"sepChoice":"4","title":"Heating"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Heating Overall"}],"title":"Heating"},{"damage_panels":[{"descr":"","id":2043,"options":[{"checked":false,"id":1,"is_red":false,"text":"The mirror/medicine cabinet was  not accessible due to stored  personal items."},{"checked":false,"id":1,"is_red":false,"text":"The mirror is chipped."},{"checked":false,"id":1,"is_red":false,"text":"The mirror/medicine cabinet glass is cracked."},{"checked":false,"id":1,"is_red":false,"text":"The mirror is loose on wall. We strongly recommend refastening."},{"checked":false,"id":1,"is_red":false,"text":"There is a loose hinge on the medicine cabinet. We recommend consulting with the seller about repair/replacement options."},{"checked":false,"id":1,"is_red":false,"text":"The mirror has a loose frame."},{"checked":false,"id":1,"is_red":false,"text":"The medicine cabinet is loose in the wall. We recommend refastening."},{"checked":false,"id":1,"is_red":false,"text":"The medicine cabinet door did not close properly."},{"checked":false,"id":1,"is_red":false,"text":"The bathroom is missing  the medicine cabinet."}],"sepChoice":"4","title":"Mirrors"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Mirrors Overall"}],"title":"Mirrors"},{"damage_panels":[{"descr":"","id":2044,"options":[{"checked":false,"id":1,"is_red":false,"text":"Flex drain observed, these are subject to frequent clogging."},{"checked":false,"id":1,"is_red":false,"text":"Improper \"S\" trap noted.  This trap configuration may cause the trap to siphon dry, allowing sewer gas and odour to enter the dwelling.  This situation may rectified by the installation of an anti siphon device (cheater vent).  Suggest repair by a qualified professional.  In the alternative, run a little bit of water into the sink to reseal the trap if odour is detected."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the drain is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"Limited review due to personal property stored in undersink cabinet."},{"checked":false,"id":1,"is_red":false,"text":"No drain trap observed."},{"checked":false,"id":1,"is_red":false,"text":"No way to determine presence of trap under sink as it is (if present) concealed between subfloor and ceiling finish."},{"checked":false,"id":1,"is_red":false,"text":"Older style metal traps noted.  Buyer is cautioned that these traps can leak at any time due to corrosion."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Sink drain assembly is loose, no leaks observed."},{"checked":false,"id":1,"is_red":false,"text":"Unable to inspect due to cabinet design, inaccessible."},{"checked":false,"id":1,"is_red":false,"text":"Water was off at time of the inspection. Unable to determine the condition of the system and/or the function of plumbing fixtures. We recommend confirming proper operation of all plumbing appliances and fixtures prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Illegal flex drain used under kitchen sink. Should be replaced with correct part by licensed plumber."},{"checked":false,"id":1,"is_red":false,"text":"Illegal plastic flex line used on bathroom sink drain."},{"checked":false,"id":1,"is_red":false,"text":"S traps present- these may cause dry traps, slow drains or loud drainage."},{"checked":false,"id":1,"is_red":false,"text":"Most not accessible due to personal items."},{"checked":false,"id":1,"is_red":false,"text":"Worn fixtures are noted."},{"checked":false,"id":1,"is_red":false,"text":"Visible leaking noted under the sink. We recommend contacting a licensed plumbing contractor for repair options."},{"checked":false,"id":1,"is_red":false,"text":"The hot & cold  water supplies are reversed. This is not a functional problem but to someone who is not familiar with this condition unexpected hot water could scald them. We suggest contacting a qualified plumbing contractor to repair."},{"checked":false,"id":1,"is_red":false,"text":"Pressure weakens when water is running in other areas."},{"checked":false,"id":1,"is_red":false,"text":"Copper to galvanized connection missing proper fittings. This can create a galvanic reaction which will eat away at the pipes."}],"sepChoice":"4","title":"Plumbing"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Plumbing Overall"}],"title":"Plumbing"},{"damage_panels":[{"descr":"","id":2045,"options":[{"checked":false,"id":1,"is_red":false,"text":"The security bars were operated and were functional."},{"checked":false,"id":1,"is_red":false,"text":"Security bars were present but were not accessible due to stored personal items."},{"checked":false,"id":1,"is_red":false,"text":"Security bars appeared to be missing hardware."},{"checked":false,"id":1,"is_red":false,"text":"Security bars appeared to be bent."},{"checked":false,"id":1,"is_red":false,"text":"Security bars appeared to be rusted."}],"sepChoice":"4","title":"Security Bars"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Security Bars Overall"}],"title":"Security Bars"},{"damage_panels":[{"descr":"","id":2046,"options":[{"checked":false,"id":1,"is_red":false,"text":"**SHOWER BASE**"},{"checked":false,"id":1,"is_red":false,"text":"functional"},{"checked":false,"id":1,"is_red":false,"text":"Base is cracked, no leaks observed at the time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Base is cracked and leaking, recommend review by a qualified professional for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Ceramic tile is \"hollow sounding\" when tapped, indicating poor bond with substrate. This usually results in loose tile and possible leakage."},{"checked":false,"id":1,"is_red":false,"text":"Common hairline cracks observed, no leaks observed at the time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Drain cover is ."},{"checked":false,"id":1,"is_red":false,"text":"Drain pipe is improperly installed, pipe extends above the level of the base resulting in the base retaining water and constituting a trip hazard. Recommend review by a licensed plumber for repair as necessary."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the shower base is near the end of its useful life due to moisture damage."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"The shower base has been painted/refinished, suggest taking care when cleaning to protect the surface."},{"checked":false,"id":1,"is_red":false,"text":"Tiled shower base observed, we are unable to determine if a proper shower pan has been installed. No leaks observed at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"**SHOWER FAUCET**"},{"checked":false,"id":1,"is_red":false,"text":"Faucet drips."},{"checked":false,"id":1,"is_red":false,"text":"Faucet handle is missing."},{"checked":false,"id":1,"is_red":false,"text":"Faucet is loose in the wall."},{"checked":false,"id":1,"is_red":false,"text":"Faucet is not flush to the wall, which may result in water penetration to the interior structure and deterioration of the wall."},{"checked":false,"id":1,"is_red":false,"text":"Hot/cold reversed plumbing observed."},{"checked":false,"id":1,"is_red":false,"text":"Installation is incomplete."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the faucet is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"Low water flow observed. Loss of pressure noted when two or more fixtures are operated at the same time."},{"checked":false,"id":1,"is_red":false,"text":"No hot water flow observed."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Shower diverter does not fully engage."},{"checked":false,"id":1,"is_red":false,"text":"Shower head leaks."},{"checked":false,"id":1,"is_red":false,"text":"The shower head is broken in the <<Bathrom Locations>>."},{"checked":false,"id":1,"is_red":false,"text":"Shower mast is loose in the wall."},{"checked":false,"id":1,"is_red":false,"text":"Unable to test, water was off at the time of service."},{"checked":false,"id":1,"is_red":false,"text":"Water was off at time of the inspection. Unable to determine the condition of the system and/or the function of plumbing fixtures. We recommend confirming proper operation of all plumbing appliances and fixtures prior to close."},{"checked":false,"id":1,"is_red":false,"text":"faucet leaks while operating"},{"checked":false,"id":1,"is_red":false,"text":"**SHOWER DOORS**"},{"checked":false,"id":1,"is_red":false,"text":"Bottom track is loose, suggest securing and resealing to prevent leakage."},{"checked":false,"id":1,"is_red":false,"text":"Does not appear to be tempered safety glass."},{"checked":false,"id":1,"is_red":false,"text":"Glass is cracked, which is a safety concern. Suggest replacing glass for safety."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the shower door is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"Missing grout noted at tile.  Recommend maintenance of grout and caulking to prevent water seepage."},{"checked":false,"id":1,"is_red":false,"text":"The hot & cold  water supplies are reversed. This is not a functional problem but to someone who is not familiar with this condition unexpected hot water could scald them. We suggest contacting a qualified plumbing contractor to repair."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"There is a missing drain screen noted. This should be replaced to keep the drains free fron hair, debris, ect."},{"checked":false,"id":1,"is_red":false,"text":"The shower faucet handle is stripped and is inoperable. Recommend repair by a qualified contractor."},{"checked":false,"id":1,"is_red":false,"text":"The shower faucet handle is missing and is inoperable. Recommend replacement by a qualified contractor."},{"checked":false,"id":1,"is_red":false,"text":"The shower faucet valves are difficult to operate. Recommend repair by a qualified contractor."},{"checked":false,"id":1,"is_red":false,"text":"No water present at the shower, could not test."},{"checked":false,"id":1,"is_red":false,"text":"Plumbing vibrates in wall when water is used. This is a sign of the pipes being incorrectly fastened in the wall, this is an invasive procedure to correct. Recommend contacting a qualified contractor to evaluate and repair."}],"sepChoice":"4","title":"Showers"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Showers Overall"}],"title":"Showers"},{"damage_panels":[{"descr":"","id":2047,"options":[{"checked":false,"id":1,"is_red":false,"text":"**MATERIALS**"},{"checked":false,"id":1,"is_red":false,"text":"Ceramic tile noted."},{"checked":false,"id":1,"is_red":false,"text":"Cultured Marble noted."},{"checked":false,"id":1,"is_red":false,"text":"Fiberglass surround noted."},{"checked":false,"id":1,"is_red":false,"text":"Marble tile noted."},{"checked":false,"id":1,"is_red":false,"text":"Plastic tub/shower surround noted."},{"checked":false,"id":1,"is_red":false,"text":"Plastic tile noted."},{"checked":false,"id":1,"is_red":false,"text":"Solid surface material noted."},{"checked":false,"id":1,"is_red":false,"text":"**OBSERVATIONS**"},{"checked":false,"id":1,"is_red":false,"text":"Broken tile observed."},{"checked":false,"id":1,"is_red":false,"text":"Caulking needed around perimeter."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of repair observed."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the tub/surround is near the end of its useful life due to moisture damage."},{"checked":false,"id":1,"is_red":false,"text":"Minor moisture detected behind tiles.  Recommend cleaning and application of grout seal to reduce further water intrusion."},{"checked":false,"id":1,"is_red":false,"text":"Missing/damaged grout observed, suggest regrouting as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Non-waterproof paneling installed in shower surround area, showering without proper protection for the wall surfaces will result in water damage to the surround and supporting structures."},{"checked":false,"id":1,"is_red":false,"text":"Plastic surround installed over ceramic tile."},{"checked":false,"id":1,"is_red":false,"text":"Recommend caulking as required."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Suggest all tile edges and tub/shower walls be caulked and sealed to prevent moisture penetration. All missing/damaged grouting should be replaced. Failure to keep walls sealed can cause deterioration and extensive moisture damage to the interior walls and surrounding sub-flooring. This damage is not always visible or accessible to the inspector at the time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Tile has been painted/refinished, suggest taking care when cleaning to protect the surface."},{"checked":false,"id":1,"is_red":false,"text":"Recommend sealing holes & gaps to stop water infiltration into walls."}],"sepChoice":"4","title":"Shower Walls"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Shower Walls Overall"}],"title":"Shower Walls"},{"damage_panels":[{"descr":"","id":2048,"options":[{"checked":false,"id":1,"is_red":false,"text":"Tub"},{"checked":false,"id":1,"is_red":false,"text":"Whirlpool"},{"checked":false,"id":1,"is_red":false,"text":"*****************"},{"checked":false,"id":1,"is_red":false,"text":"Whirlpool tub observed. Tub was filled to a level above the water jets and operated to check intake and jets. The tub was then drained to check for leaks and/or damage. Pump and supply lines were not completely visible or accessible. GFCI's were present and was tested. The items tested appeared to be in serviceable condition. If a more detailed report is desired, the client is advised to consult a licensed plumber for a complete review prior to closing."},{"checked":false,"id":1,"is_red":false,"text":"Debris was ejected from the jets during operation, recommend having circulation system professionally cleaned prior to use."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the tub/whirlpool is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"Inoperable at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Motor briefly activated to ensure motor was serviceable.  Due time and water wastage, the tub was not filled to test water flow through jets."},{"checked":false,"id":1,"is_red":false,"text":"Peeling observed, tub appears to have been refinished, suggest taking care when cleaning to protect the surface."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a licensed plumber for repair as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Stains observed."},{"checked":false,"id":1,"is_red":false,"text":"Stopper is inoperable."},{"checked":false,"id":1,"is_red":false,"text":"Stopper is missing."},{"checked":false,"id":1,"is_red":false,"text":"Tub has been refinished, suggest taking care when cleaning to protect the surface."},{"checked":false,"id":1,"is_red":false,"text":"Tub is cracked, no leaks observed."},{"checked":false,"id":1,"is_red":false,"text":"Unable to test whirlpool tub due to . Recommend client confirm proper operation prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Unable to test whirlpool tub, water off. Recommend confirming proper operation prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Whirlpool is inoperable, recommend review by a licensed plumber for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Whirlpool tub was filled to a level above the water jets and operated to check intake and jets. Pump and supply lines are not normally accessible and were not inspected unless otherwise noted."},{"checked":false,"id":1,"is_red":false,"text":"The hot & cold  water supplies are reversed. This is not a functional problem but to someone who is not familiar with this condition unexpected hot water could scald them. We suggest contacting a qualified plumbing contractor to repair."},{"checked":false,"id":1,"is_red":false,"text":"Faucet leaks while operating. Recommend contacting a licensed plumber to repair."},{"checked":false,"id":1,"is_red":false,"text":"The tub drains slow, this could mean the drain is clogged with hair or debris."},{"checked":false,"id":1,"is_red":false,"text":"Missing stopper noted."},{"checked":false,"id":1,"is_red":false,"text":"Loose escutcheon  plates noted. These should be refastened and caulked to keep water from infiltrating the walls."},{"checked":false,"id":1,"is_red":false,"text":"Missing escutcheon  plates noted. These should be replaced and caulked to keep water from infiltrating the walls."},{"checked":false,"id":1,"is_red":false,"text":"We recommend sealing holes & gaps to keep water from infiltrating the walls."},{"checked":false,"id":1,"is_red":false,"text":"No water present at the tub, could not test."},{"checked":false,"id":1,"is_red":false,"text":"Tub spout loose and leaking in wall."},{"checked":false,"id":1,"is_red":false,"text":"Recommend GFCI for spa tub as a safety requirement."},{"checked":false,"id":1,"is_red":false,"text":"GFCI for spa tub not visible"},{"checked":false,"id":1,"is_red":false,"text":"The tub's finish is stained. Epoxy touch up is available."},{"checked":false,"id":1,"is_red":false,"text":"Some caulking repair needed at tub in <<Bathrom Locations>>."},{"checked":false,"id":1,"is_red":false,"text":"Whirlpool tubs require GFCI protection to protect people from fatal shock. No GFCI protection found for this tub.   SEE \"Electrical\" Section under GFCI/AFCI"}],"sepChoice":"4","title":"Bath Tubs"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Bath Tubs Overall"}],"title":"Tub"},{"damage_panels":[{"descr":"","id":2049,"options":[{"checked":false,"id":1,"is_red":false,"text":"The shower enclosure was functional at the time of the inspection."},{"checked":false,"id":1,"is_red":false,"text":"Unable to determine if glass is tempered safety glass."},{"checked":false,"id":1,"is_red":false,"text":"Worn hardware on the shower door. The door and enclosure may be at the end of its useful life."},{"checked":false,"id":1,"is_red":false,"text":"Loose hardware on the shower door. The door and enclosure may be at the end of its useful life."},{"checked":false,"id":1,"is_red":false,"text":"Cracked glass on the shower door. The door and enclosure may be at the end of its useful life."},{"checked":false,"id":1,"is_red":false,"text":"Missing hardware on the shower door. The door and enclosure may be at the end of its useful life."},{"checked":false,"id":1,"is_red":false,"text":"A safety glass enclosure is noted."},{"checked":false,"id":1,"is_red":false,"text":"A tempered glass enclosure is noted."},{"checked":false,"id":1,"is_red":false,"text":"Corrosion present on the shower enclosure noted. It cannot be determined at the time of the inspection whether or not a simple cleaning will solve the problem."},{"checked":false,"id":1,"is_red":false,"text":"Curtain present at the shower enclosure."},{"checked":false,"id":1,"is_red":false,"text":"There is evidence of leaking noted. Recommend resealing the enclosure to prevent further leaking."},{"checked":false,"id":1,"is_red":false,"text":"There is visible leaking noted. Recommend resealing the enclosure to prevent further leaking."},{"checked":false,"id":1,"is_red":false,"text":"The shower doors are difficult to operate. Lubrication may solve this problem."},{"checked":false,"id":1,"is_red":false,"text":"The shower door is off it's guides. The door should be put back on it's guides and adjusted to prevent this from happening further,"},{"checked":false,"id":1,"is_red":false,"text":"The shower door did not close completely. The door can be adjusted to close and should be to prevent leaking and further damage."},{"checked":false,"id":1,"is_red":false,"text":"The shower door has a loose hinge. We recommend replacing the hinge for proper operation of the door."},{"checked":false,"id":1,"is_red":false,"text":"The shower door did not latch. We recommend adjustment for proper operation of the door."},{"checked":false,"id":1,"is_red":false,"text":"The frame of the shower enclosure is separating from glass. We recommend repair by a qualified contractor."},{"checked":false,"id":1,"is_red":false,"text":"Could not determine if the enclosure is constructed from tempered glass."}],"sepChoice":"4","title":"Enclosure"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Enclosure Overall"}],"title":"Enclosure"},{"damage_panels":[{"descr":"","id":2050,"options":[{"checked":false,"id":1,"is_red":false,"text":"**DRAINS**"},{"checked":false,"id":1,"is_red":false,"text":"Drain line leaks under sink. "},{"checked":false,"id":1,"is_red":false,"text":"Stains from presumed past leaks noted."},{"checked":false,"id":1,"is_red":false,"text":"Note that without water the sink(s) and dishwasher could not be evaluated."},{"checked":false,"id":1,"is_red":false,"text":"Slow drain at sink.  Recommend clearing. "},{"checked":false,"id":1,"is_red":false,"text":"Slow drain at sink with gurgling which may indicate that the drain line needs to be cleaned and/or that the drain is not properly vented. "},{"checked":false,"id":1,"is_red":false,"text":"Evidence of past or present rodents under kitchen sink.  "},{"checked":false,"id":1,"is_red":false,"text":"Stains at sink cabinet floor, presumably from past leak(s) or spilled products."},{"checked":false,"id":1,"is_red":false,"text":"**SUPPLY**"},{"checked":false,"id":1,"is_red":false,"text":"No deficiencies observed."},{"checked":false,"id":1,"is_red":false,"text":"Operated normally, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Faucet leaks at base. "},{"checked":false,"id":1,"is_red":false,"text":"The hot & cold  water supplies are reversed. This is not a functional problem but to someone who is not familiar with this condition unexpected hot water could scald them. We suggest contacting a qualified plumbing contractor to repair."},{"checked":false,"id":1,"is_red":false,"text":"Faucet drips. "},{"checked":false,"id":1,"is_red":false,"text":"Supply line leaks. "},{"checked":false,"id":1,"is_red":false,"text":"No shutoff \"stop\" apparent. "},{"checked":false,"id":1,"is_red":false,"text":"Poor pressure flow when running several fixtures in one area."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the sink is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Sink appears to have been refinished, suggest taking care when cleaning to protect the surface."},{"checked":false,"id":1,"is_red":false,"text":"Sink is leaking at the time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Sink is loose, suggest securing as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Stopper is missing/inoperable."},{"checked":false,"id":1,"is_red":false,"text":"Suggest caulking as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Sink chipped (Cosmetic; does not affect function). "},{"checked":false,"id":1,"is_red":false,"text":"Sink rusted.  Monitor for developing leaks (none found during inspection)."},{"checked":false,"id":1,"is_red":false,"text":"Sink is poorly anchored."},{"checked":false,"id":1,"is_red":false,"text":"Stains from presumed past leaks noted."},{"checked":false,"id":1,"is_red":false,"text":"Note that without water the sink(s) and dishwasher could not be evaluated."},{"checked":false,"id":1,"is_red":false,"text":"Slow drain at sink.  Recommend clearing. "},{"checked":false,"id":1,"is_red":false,"text":"Slow drain at sink with gurgling which may indicate that the drain line needs to be cleaned and/or that the drain is not properly vented. "},{"checked":false,"id":1,"is_red":false,"text":"Evidence of past or present rodents under kitchen sink.  "},{"checked":false,"id":1,"is_red":false,"text":"Stains at sink cabinet floor, presumably from past leak(s) or spilled products."},{"checked":false,"id":1,"is_red":false,"text":"Kitchen has a Dupont Corian molded sink"},{"checked":false,"id":1,"is_red":false,"text":"The sink finish is damaged. Recommend repair or replacement."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Older style faucet observed."},{"checked":false,"id":1,"is_red":false,"text":"Aerator is blocked, suggest cleaning for proper flow."},{"checked":false,"id":1,"is_red":false,"text":"Under mounted sink leaks along mounting joint. Repair as needed. "},{"checked":false,"id":1,"is_red":false,"text":"The piping to the sink was not installed properly."},{"checked":false,"id":1,"is_red":false,"text":"Mold-like bio growth observed. Professional testing & evaluation advised."}],"sepChoice":"4","title":"Sinks"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Sinks Overall"}],"title":"Sinks"},{"damage_panels":[{"descr":"","id":2051,"options":[{"checked":false,"id":1,"is_red":false,"text":"0bserved as functional and in good visual condition."},{"checked":false,"id":1,"is_red":false,"text":"Operated when tested. No deficiencies noted."},{"checked":false,"id":1,"is_red":false,"text":"Operated when tested. Appeared functional, at time of inspection - except as noted."},{"checked":false,"id":1,"is_red":false,"text":"Toilet loose and may need re-anchoring."},{"checked":false,"id":1,"is_red":false,"text":"Toilet drains slowly.  Recommend clearing drain."},{"checked":false,"id":1,"is_red":false,"text":"Toilet valve not operating properly."},{"checked":false,"id":1,"is_red":false,"text":"Toilet not flushing adequately.  Assembly needs repair or adjustment."},{"checked":false,"id":1,"is_red":false,"text":"Toilet seat cover loose; recommend tightening."},{"checked":false,"id":1,"is_red":false,"text":"Toilet continues to run after flushing; have contractor evaluate and repair."},{"checked":false,"id":1,"is_red":false,"text":"A loose toilet and/or loose/soft sub-flooring was observed. This can indicate damage to the sub-flooring beneath the fixture and floor covering. This condition is not visible or fully accessible to the inspector without destructive investigation. Client is advised to seek further review by a licensed plumbing contractor prior to closing for repairs/replacement as required."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the toilet is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"Leak observed at the connection between the tank and the base."},{"checked":false,"id":1,"is_red":false,"text":"Mechanism in tank sticking, requires adjustment for proper flushing."},{"checked":false,"id":1,"is_red":false,"text":"No shut-off valve observed."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Tank lid is cracked/broken."},{"checked":false,"id":1,"is_red":false,"text":"The toilet bowl is loose at floor anchor bolts. The wax ring inside the unit must have a snug, secure fit in order to keep from leaking. Properly resealing and re-securing this unit is suggested to prevent water leakage and damage to the sub-floor area. This type of damage is not always visible or accessible to the inspector at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Toilet fill valve leaks, suggest replacing."},{"checked":false,"id":1,"is_red":false,"text":"Toilet runs for long time, requires adjustment."},{"checked":false,"id":1,"is_red":false,"text":"Toilet slightly loose.  Recommend tightening to prevent water damage."},{"checked":false,"id":1,"is_red":false,"text":"Unable to test, water was off at the time of service."},{"checked":false,"id":1,"is_red":false,"text":"Toilet not secure at floor. Condition typically is caused by loose bolts or nuts or missing floor seals/caulking/grouting; other causes or multiple causes are possible. Loose toilets can result in damage to water supply lines and drainage pipes (leaks, water damage, and mold), as well as damage to the bolts or toilet. Recommend further evaluation by a licensed plumbing professional before close of escrow."},{"checked":false,"id":1,"is_red":false,"text":"A licensed plumber should evaluate, correct and/or repair any issues found with toilets or any issues of plumbing throughout the home, that need to be addressed."},{"checked":false,"id":1,"is_red":false,"text":"Master bath toilet cracked."},{"checked":false,"id":1,"is_red":false,"text":"Excessive corrosion on water shutoff valve. Valve could leak at any time or may not work properly when used. Recommend further evaluation by licensed plumbing professional."},{"checked":false,"id":1,"is_red":false,"text":"Unable to test functionality due to the water being shut off (winterized)."},{"checked":false,"id":1,"is_red":false,"text":"Toilets are of good quality."},{"checked":false,"id":1,"is_red":false,"text":"Bidet may not be completely installed;it appears there is still a leveling shim in place. see pic"},{"checked":false,"id":1,"is_red":false,"text":"Bidet present and in serviceable condition."},{"checked":false,"id":1,"is_red":false,"text":"Bidet did not operate ate the time of the inspection, could not test."},{"checked":false,"id":1,"is_red":false,"text":"Bidet is loose at the floor and leaking. Recommend contacting a licensed plumber for repair."},{"checked":false,"id":1,"is_red":false,"text":"Toilet seat lid broken--needs replacement."},{"checked":false,"id":1,"is_red":false,"text":"Moderate staining and bio growth observed on the inside of all toilet bowls/tanks due to prolonged period of winterization. Recommend a thorough and heavy cleaning prior to use."}],"sepChoice":"4","title":"Toilets"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Toilets Overall"}],"title":"Toilet"},{"damage_panels":[{"descr":"","id":2215,"options":[{"checked":false,"id":1,"is_red":false,"text":"Deterioration noted due to contact with moisture, repairs needed."},{"checked":false,"id":1,"is_red":false,"text":"Shower area's are a poor location for a window, recommend removal due to potential issues in the future."},{"checked":false,"id":1,"is_red":false,"text":"One or more window/s shows sign of loss of seal/condensation, recommend repair or replace to provide energy savings and prevent hazed window from limiting view out of window. "},{"checked":false,"id":1,"is_red":false,"text":"One or more windows did not lock/latch properly, recommend repairs for enhanced security/safety to occupants."},{"checked":false,"id":1,"is_red":false,"text":"Broken/cracked glass pane noted, repairs needed."},{"checked":false,"id":1,"is_red":false,"text":"Hardware difficult to operate at one or more locations. Recommend review and repair as needed by qualified window contractors."},{"checked":false,"id":1,"is_red":false,"text":"In the event of an emergency it appears that the windows could cause an issue of quick egress due to the windows are difficult to open for a small child for escape. Recommend review and repair to allow easy exit in the event of an emergency situation."},{"checked":false,"id":1,"is_red":false,"text":"Single pane windows observed, recommend budgeting for replacement for added efficiency of home."},{"checked":false,"id":1,"is_red":false,"text":"Broken glazing observed, suggest re-glazing as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Broken sash wire/cord observed on window frame. This is a \"Safety Concern\". Sash wire/cord holds window in open position. Suggest repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Damaged screens observed."},{"checked":false,"id":1,"is_red":false,"text":"Deterioration of wooden frames noted.  While basic maintenance may prolong the life of these window frames, replacement may be necessary at some point.  "},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the windows/frames are near the end of their useful life."},{"checked":false,"id":1,"is_red":false,"text":"Peeling paint observed, suggest scraping and painting as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Fog/condensation observed in thermopane windows. This is an indication of a failed seal. Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl crank out style windows with locks."},{"checked":false,"id":1,"is_red":false,"text":"Painted wood windows possibly creating lead dust from friction on paint. "},{"checked":false,"id":1,"is_red":false,"text":"Metal \"double hung\" type with locks."},{"checked":false,"id":1,"is_red":false,"text":"Severe damage--\nSome vinyl windows in the home had severe damage visible at the time of the inspection. You may wish to get estimates for repair before the expiration of your Inspection Objection Deadline.\n"},{"checked":false,"id":1,"is_red":false,"text":"Minor damage--\nSome vinyl windows in the home had minor damage visible at the time of the inspection.\n"},{"checked":false,"id":1,"is_red":false,"text":"Some of the windows are difficult to lock."},{"checked":false,"id":1,"is_red":false,"text":"The upstairs crank out window facing front of home appears to be missing some minor hardware & a screen."},{"checked":false,"id":1,"is_red":false,"text":"The home is fitted with vinyl windows."},{"checked":false,"id":1,"is_red":false,"text":"Some windows are very difficult to open and some were not able to open, this may be because of the paint."},{"checked":false,"id":1,"is_red":false,"text":"In accordance with ASHI Standards, we do not test every window in the house, and particularly if it is furnished. We do test every unobstructed window in every bedroom to ensure that at least one provides and emergency exit."},{"checked":false,"id":1,"is_red":false,"text":"Highly recommend operating all windows during final walk through inspection."},{"checked":false,"id":1,"is_red":false,"text":"Operated windows appeared functional, at time of inspection"},{"checked":false,"id":1,"is_red":false,"text":"The windows that were tested, are functional."},{"checked":false,"id":1,"is_red":false,"text":"Broken sash wire/cord observed on window frame. This is a \"Safety Concern\". Sash wire/cord holds window in open position. Suggest repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Damaged/Missing sash cords"},{"checked":false,"id":1,"is_red":false,"text":"Damaged screens observed."},{"checked":false,"id":1,"is_red":false,"text":"Missing screens observed at <<Bathrom Locations>>."},{"checked":false,"id":1,"is_red":false,"text":"Damage tilt-out feature locking clips at <<Bathrom Locations>>. Window is still functional. FYI"},{"checked":false,"id":1,"is_red":false,"text":"Damage/missing hardware at <<Bathrom Locations>>. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the windows/frames are near the end of their useful life."},{"checked":false,"id":1,"is_red":false,"text":"Peeling paint observed, suggest scraping and painting as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Cloudiness/condensation observed in <<Bathrom Locations>> of thermopane double glazed windows. This is an indication of a failed seal. A qualified contractor should review for replacement as needed."},{"checked":false,"id":1,"is_red":false,"text":"Cracked or broken window glass was observed. Injury could occur. Recommend repair or replacement of the damaged glass."},{"checked":false,"id":1,"is_red":false,"text":"Cracked window pane in <<Bathrom Locations>>. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Improve:  Install glass block basement windows with vents. This type of window allows in more light, ventilation, added security and reduces the risks of moisture intrusion."},{"checked":false,"id":1,"is_red":false,"text":"DEFERRED COST: Windows are original, older type. Consider upgrading to double pane, thermally insulated, newer efficient type."},{"checked":false,"id":1,"is_red":false,"text":"Some windows did not open when tested. Recommend  all windows reviewed for proper operation during walkthrough inspection prior to closing"},{"checked":false,"id":1,"is_red":false,"text":"A representative number of windows were inspected. Most did not open when tested -- appears painted wood frames have sealed seams. Recommend  all windows be reviewed for proper operation during final walkthrough inspection."},{"checked":false,"id":1,"is_red":false,"text":"Improve: Install glass block basement windows."},{"checked":false,"id":1,"is_red":false,"text":"All accessible windows operated."},{"checked":false,"id":1,"is_red":false,"text":"Family room window, to the left of fireplace, does not lock with either latch.  Needs repair - for security reasons due to being at ground level."},{"checked":false,"id":1,"is_red":false,"text":"Mold-like bio growth observed. Professional testing & evaluation advised."},{"checked":false,"id":1,"is_red":false,"text":"There are older wood windows present."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl crank out style windows with locks."},{"checked":false,"id":1,"is_red":false,"text":"Painted wood windows possibly creating lead dust from friction on paint. "},{"checked":false,"id":1,"is_red":false,"text":"Metal \"double hung\" type with locks."},{"checked":false,"id":1,"is_red":false,"text":"Severe damage--\nSome vinyl windows in the home had severe damage visible at the time of the inspection. You may wish to get estimates for repair before the expiration of your Inspection Objection Deadline.\n"},{"checked":false,"id":1,"is_red":false,"text":"Minor damage--\nSome vinyl windows in the home had minor damage visible at the time of the inspection.\n"},{"checked":false,"id":1,"is_red":false,"text":"The windows in the home are rope and pulley style, may be original to home, and are approaching the end of their serviceable lifetime."},{"checked":false,"id":1,"is_red":false,"text":"Screens were not installed at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Broken sash wire/cord observed on window frame. This is a \"Safety Concern\". Sash wire/cord holds window in open position. Suggest repairs/replacement as needed to ensure safety."}],"sepChoice":"4","title":"Window Condition"}],"inspection_panels":[{"descr":"","id":3065,"options":[{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed casement window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Stationary(fixed) window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed casement window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed casement window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Garden style window noted."},{"checked":false,"id":1,"is_red":false,"text":"Bay type window noted."},{"checked":false,"id":1,"is_red":false,"text":"Bow type window noted."},{"checked":false,"id":1,"is_red":false,"text":"Glass blocks noted in window openings."},{"checked":false,"id":1,"is_red":false,"text":"Non-insulated glass noted."},{"checked":false,"id":1,"is_red":false,"text":"Insulated glass noted."}],"sepChoice":"1","title":"Windows"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Window Condition Overall"}],"title":"Windows"}],"title":"Bathroom"},{"id":14,"tabbed_panels":[{"damage_panels":[],"inspection_panels":[{"descr":"Locations:","id":3006,"options":[{"checked":false,"id":1,"is_red":false,"text":"Master#1"},{"checked":false,"id":1,"is_red":false,"text":"North East#1"},{"checked":false,"id":1,"is_red":false,"text":"South East#2"},{"checked":false,"id":1,"is_red":false,"text":"North West#4"},{"checked":false,"id":1,"is_red":false,"text":"Hall#2"},{"checked":false,"id":1,"is_red":false,"text":"South West#3"},{"checked":false,"id":1,"is_red":false,"text":"North#3"},{"checked":false,"id":1,"is_red":false,"text":"West#2"},{"checked":false,"id":1,"is_red":false,"text":"kitchen area"},{"checked":false,"id":1,"is_red":false,"text":"Upstairs East#3"},{"checked":false,"id":1,"is_red":false,"text":"South East#3"},{"checked":false,"id":1,"is_red":false,"text":"North East#3"},{"checked":false,"id":1,"is_red":false,"text":"Upstairs hall#2"},{"checked":false,"id":1,"is_red":false,"text":"Downstairs#3"},{"checked":false,"id":1,"is_red":false,"text":"Upstairs Master#1"},{"checked":false,"id":1,"is_red":false,"text":"Upstairs North East"},{"checked":false,"id":1,"is_red":false,"text":"South West#3"},{"checked":false,"id":1,"is_red":false,"text":"Upstairs South East#2"},{"checked":false,"id":1,"is_red":false,"text":"Upstairs South West#3"},{"checked":false,"id":1,"is_red":false,"text":"Upstairs#1"},{"checked":false,"id":1,"is_red":false,"text":"Upstairs West#4"},{"checked":false,"id":1,"is_red":false,"text":"Upstairs  South#2"},{"checked":false,"id":1,"is_red":false,"text":"North Central#2"},{"checked":false,"id":1,"is_red":false,"text":"1/2 bath#3"},{"checked":false,"id":1,"is_red":false,"text":"Unit#1 through 5"},{"checked":false,"id":1,"is_red":false,"text":"Downstairs#5"},{"checked":false,"id":1,"is_red":false,"text":"see kitchen area"},{"checked":false,"id":1,"is_red":false,"text":"In the garage area"},{"checked":false,"id":1,"is_red":false,"text":"Downstairs#3"},{"checked":false,"id":1,"is_red":false,"text":"Pool house#6"},{"checked":false,"id":1,"is_red":false,"text":"Unit#1,2"},{"checked":false,"id":1,"is_red":false,"text":"South East#4"},{"checked":false,"id":1,"is_red":false,"text":"Pool Area #4"},{"checked":false,"id":1,"is_red":false,"text":"Common area of Association"},{"checked":false,"id":1,"is_red":false,"text":"Exterior area"},{"checked":false,"id":1,"is_red":false,"text":"Bathroom Area"},{"checked":false,"id":1,"is_red":false,"text":"Guest #2"},{"checked":false,"id":1,"is_red":false,"text":"Hall"},{"checked":false,"id":1,"is_red":false,"text":"3/4 laundry area#2"},{"checked":false,"id":1,"is_red":false,"text":"South West#3"},{"checked":false,"id":1,"is_red":false,"text":"South#2"},{"checked":false,"id":1,"is_red":false,"text":"Jack & Jill#3"},{"checked":false,"id":1,"is_red":false,"text":"Half Bath#4"},{"checked":false,"id":1,"is_red":false,"text":"North East#3"},{"checked":false,"id":1,"is_red":false,"text":"Downstairs#3"},{"checked":false,"id":1,"is_red":false,"text":"In basement area"},{"checked":false,"id":1,"is_red":false,"text":"South#2"},{"checked":false,"id":1,"is_red":false,"text":"Guest House#5"},{"checked":false,"id":1,"is_red":false,"text":"Guest House#4"},{"checked":false,"id":1,"is_red":false,"text":"East#3"},{"checked":false,"id":1,"is_red":false,"text":"North#4"},{"checked":false,"id":1,"is_red":false,"text":"South"}],"sepChoice":"1","title":"Locations"}],"pictures":[],"ratings":[],"title":"Locations"},{"damage_panels":[{"descr":"","id":2019,"options":[{"checked":false,"id":1,"is_red":false,"text":"Most not accessible due to stored personal items."},{"checked":false,"id":1,"is_red":false,"text":"No deficiencies observed."},{"checked":false,"id":1,"is_red":false,"text":"No deficiencies observed on all kitchen cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Appeared functional and in satisfactory condition, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Recommend adding additional cabinet screws as drywall screws have been used."},{"checked":false,"id":1,"is_red":false,"text":"Loose at wall. Needs immediate attention. "},{"checked":false,"id":1,"is_red":false,"text":"DEFERRED COST:  The cabinets are original. Consider upgrade.."},{"checked":false,"id":1,"is_red":false,"text":"Appeared functional, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Some cabinet doors need magnets or hardware to stay shut. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Some cabinet drawers  need  hardware repair/adjustment (to stay shut). Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Drawers are difficult to slide. It appears that if the guides are lubricated, that will correct the problem."},{"checked":false,"id":1,"is_red":false,"text":"Broken drawer guides noted. Recommend having a qualified contractor replace the guides."},{"checked":false,"id":1,"is_red":false,"text":"Noted cabinet(s) loose on the wall. Recommend having a qualified contractor re-fasten the cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Noted cabinet(s) loose at the floor. Recommend having a qualified contractor re-fasten the cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Noted cabinet(s) loose at the ceiling. Recommend having a qualified contractor re-fasten the cabinets."},{"checked":false,"id":1,"is_red":false,"text":"There appears to be water damage under sink. This tested dry at the time of the inspection, but monitor for any further intrusion."},{"checked":false,"id":1,"is_red":false,"text":"Doors did not close completely."},{"checked":false,"id":1,"is_red":false,"text":"The door was locked to bathroom, could not access the room to inspect."},{"checked":false,"id":1,"is_red":false,"text":"The sliding cabinet doors were difficult to slide. It appears that lubrication will correct the problem."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors missing, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors missing hardware, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawers missing, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors have broken hinges, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawers missing handles, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawers off their guides, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors have loose hardware, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors missing knobs, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawer face is missing, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawer face is loose, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors have broken glass panels in them, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Drawer(s) bind in tracks."},{"checked":false,"id":1,"is_red":false,"text":"Drawer(s) unsupported in cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Shelving missing or damaged."},{"checked":false,"id":1,"is_red":false,"text":"Lazy Susan cabinet binds and does not turn smoothly."}],"sepChoice":"4","title":"Cabinets"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Cabinets Overall"}],"title":"Cabinets"},{"damage_panels":[{"descr":"","id":2021,"options":[{"checked":false,"id":1,"is_red":false,"text":"None present."},{"checked":false,"id":1,"is_red":false,"text":"Operated normally when tested, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Ceiling fans observed in @@@@@@@@@. Due to the amount of insulation or type of construction, it was not possible to determine the method of attachment to the ceiling. These units are heavy and due to the designed movement, must have the proper style mounting boxes for correct and safe attachment.  Recommend confirming the method of attachment prior to use. This may require the removal of the fan or insulation to visually verify proper support."},{"checked":false,"id":1,"is_red":false,"text":"The ceiling fan is a worn unit that has reached the end of its useful life."},{"checked":false,"id":1,"is_red":false,"text":"The ceiling fan did not operate when tested."},{"checked":false,"id":1,"is_red":false,"text":"The fan blades wobble when tested."},{"checked":false,"id":1,"is_red":false,"text":"The ceiling fan appears to be loose at ceiling. This is a safety issue, recommend contacting a licensed electrician to repair."},{"checked":false,"id":1,"is_red":false,"text":"The ceiling fan has exposed wiring. This is a safety issue, recommend contacting a licensed electrician to repair."},{"checked":false,"id":1,"is_red":false,"text":"There is a missing fixture globe on the ceiling fan. These are usually easy and inexpensive to replace from your local home improvement center."},{"checked":false,"id":1,"is_red":false,"text":"The ceiling fan is missing blades, generic replacement blades are available at your local home improvement center."},{"checked":false,"id":1,"is_red":false,"text":"The ceiling fan has damaged blades, generic replacement blades are available at your local home improvement center."},{"checked":false,"id":1,"is_red":false,"text":"The fan unit makes an  irregular noise. This may be a sign that it has reached the end of its useful life."},{"checked":false,"id":1,"is_red":false,"text":"The ceiling fan is missing a pull chain. These are easily purchased at your local hardware store."},{"checked":false,"id":1,"is_red":false,"text":"Could not locate remote."},{"checked":false,"id":1,"is_red":false,"text":"The ceiling fan is using an extension cord for power. This is an illegal operation and should be corrected at once."}],"sepChoice":"4","title":"Ceiling Fans"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Ceiling Fans Overall"}],"title":"Ceiling Fan"},{"damage_panels":[{"descr":"","id":2022,"options":[{"checked":false,"id":1,"is_red":false,"text":"No closets were present in this room. this room cannot be considered as a bedroom without at least one closet."},{"checked":false,"id":1,"is_red":false,"text":"The closet is in serviceable condition."},{"checked":false,"id":1,"is_red":false,"text":"Stains were present on the closet ceilings indicating prior water infiltration. Although they tested dry they should be noted."},{"checked":false,"id":1,"is_red":false,"text":"The closet door was missing."},{"checked":false,"id":1,"is_red":false,"text":"The closet door has fallen out of square and drags on the floor. We recommend contacting a qualified contractor to realign the door."},{"checked":false,"id":1,"is_red":false,"text":"The closet shelving needs to be refastened to the wall."},{"checked":false,"id":1,"is_red":false,"text":"The closet shelving is missing."},{"checked":false,"id":1,"is_red":false,"text":"The closet light is missing fixture globe. This can be a potential fire hazard if clothing comes in contact with an exposed light bulb."},{"checked":false,"id":1,"is_red":false,"text":"The closet shelves are broken. Recommend having a qualified contractor replace the shelving."}],"sepChoice":"4","title":"Closets"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Closets Overall"}],"title":"Closets"},{"damage_panels":[{"descr":"","id":2023,"options":[{"checked":false,"id":1,"is_red":false,"text":"Double door entryway."},{"checked":false,"id":1,"is_red":false,"text":"The back door is difficult to open and close; mechanism may not be installed true. Back door opens to a step off and fall situation, needs a landing and stairs built on exterior. At lease put up a sign during any open house viewing of the property."},{"checked":false,"id":1,"is_red":false,"text":"Bedroom door is missing doorknob & hardware."},{"checked":false,"id":1,"is_red":false,"text":"Hollow wood doors. "},{"checked":false,"id":1,"is_red":false,"text":"Sliding doors to backyard."},{"checked":false,"id":1,"is_red":false,"text":"There is a steel, \"fire rated\" door to garage with self closing mechanism."},{"checked":false,"id":1,"is_red":false,"text":"Front door and hardware is damaged."},{"checked":false,"id":1,"is_red":false,"text":"The bathroom door does not lock."},{"checked":false,"id":1,"is_red":false,"text":"The entry doors automatic closer is unable tp perform its function due to the thick carpeting that makes the door difficult to open and close."},{"checked":false,"id":1,"is_red":false,"text":"The bathroom closet door is off its tracks."},{"checked":false,"id":1,"is_red":false,"text":"Door bell is not functional."},{"checked":false,"id":1,"is_red":false,"text":"The door for the furnace closet should be louvred to allow air in to help combustion. "},{"checked":false,"id":1,"is_red":false,"text":"Several doors are sealed and made not functional by amateurish construction of the office space, have contractor evaluate and repair."},{"checked":false,"id":1,"is_red":false,"text":"Metal door  with \"wood look\""},{"checked":false,"id":1,"is_red":false,"text":"Sliding door in rear leading to porch."},{"checked":false,"id":1,"is_red":false,"text":"Back door missing a deadbolt lockset."},{"checked":false,"id":1,"is_red":false,"text":"The top floor units back door rubs on the floor as it opens and closes, may need some sanding on bottom of door to help clearance."},{"checked":false,"id":1,"is_red":false,"text":"Some doors are damaged."},{"checked":false,"id":1,"is_red":false,"text":"Several doors are a bit tight in jams, possibly from the new coat of paint."},{"checked":false,"id":1,"is_red":false,"text":"Loose door striker on bedroom door frame."},{"checked":false,"id":1,"is_red":false,"text":"The exit door to mechanical room utilises a self closing mechanism."},{"checked":false,"id":1,"is_red":false,"text":"Doors are not installed"}],"sepChoice":"4","title":"Doors"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Doors Overall"}],"title":"Doors"},{"damage_panels":[{"descr":"","id":2024,"options":[{"checked":false,"id":1,"is_red":false,"text":"Some outlets not accessible due to furniture and or stored personal items."},{"checked":false,"id":1,"is_red":false,"text":"2-prong outlets -\nThe home contained outdated, ungrounded 2-prong electrical outlets. Although this condition may have been commonly considered safe or acceptable at the time the home was originally constructed, as general knowledge of safe building practices has improved with the passage of time, building standards have changed to reflect current understanding. Consider updating the existing condition to meet generally-accepted current standards.\n"},{"checked":false,"id":1,"is_red":false,"text":"Some loose and improperly installed receptacles were found, they should be installed correctly by a licensed electrician. Several are wired in reverse, one is poorly grounding."},{"checked":false,"id":1,"is_red":false,"text":"Smoke detectors missing in bedrooms.  Installation recommended."},{"checked":false,"id":1,"is_red":false,"text":"Smoke detector near attic bedrooms did not function, may need a new battery."},{"checked":false,"id":1,"is_red":false,"text":"Some receptacles were painted over."},{"checked":false,"id":1,"is_red":false,"text":"It is recommended to avoid use of multiplier outlet plug ins ( converts 2 into 6 outlets ) "},{"checked":false,"id":1,"is_red":false,"text":"Missing outlet covers - throughout home.  See pictures."},{"checked":false,"id":1,"is_red":false,"text":"Open ground - receptacle in wall across from windows in dining room."},{"checked":false,"id":1,"is_red":false,"text":"Reversed polarity, hot and neutral reversed and other terms used for electric receptacles are usually easily corrected by minor wiring adjustments at the specified item. When these conditions are noted in this report, a licensed electrician should be consulted for repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Several outlets were found to have been reverse polarity wired, see pics for locations. Have an electrician evaluate and repair."},{"checked":false,"id":1,"is_red":false,"text":"Most receptacles , except where noted, are in fair condition and tested ok, some are painted over."},{"checked":false,"id":1,"is_red":false,"text":"Have a qualified electrician repair items listed following a complete evaluation of the electrical system."},{"checked":false,"id":1,"is_red":false,"text":"The majority of grounded receptacles , were tested and found to be wired correctly."},{"checked":false,"id":1,"is_red":false,"text":"Surface mount wiring in the bedroom- an outlet box has become loose and needs to be re affixed to the wall."},{"checked":false,"id":1,"is_red":false,"text":"Missing switch plate covers were found, make sure they are replaced."},{"checked":false,"id":1,"is_red":false,"text":"Worn switches noted."},{"checked":false,"id":1,"is_red":false,"text":"Worn outlets noted."},{"checked":false,"id":1,"is_red":false,"text":"Outlet cover plates missing."},{"checked":false,"id":1,"is_red":false,"text":"Switch cover plates missing."},{"checked":false,"id":1,"is_red":false,"text":"Loose outlets noted."},{"checked":false,"id":1,"is_red":false,"text":"Loose switches noted."},{"checked":false,"id":1,"is_red":false,"text":"All original knob and tube wiring appears to have been removed."},{"checked":false,"id":1,"is_red":false,"text":"A low voltage alarm system is installed. Due to the specialized nature of these systems, we suggest that you review this system with the seller. As per our Inspection Agreement, this system is beyond the scope of this report and was not inspected."},{"checked":false,"id":1,"is_red":false,"text":"A low voltage intercom system is installed. Due to the specialized nature of these systems, we suggest that you review this system with the seller. As per our Inspection Agreement, this system is beyond the scope of this report and was not inspected."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum wiring is now a concern with insurance companies due to fire risk.  Buyer is urged to confirm insurability and any related conditions that insurance company may place on this house.  Further inspection of this system may be required.  The inspector CANNOT ensure compliance of this electrical system for insurance purposes."},{"checked":false,"id":1,"is_red":false,"text":"Dimming lights were observed, this may be an indication of inadequate electrical distribution. We recommend review by a licensed electrician for evaluation and redistribution as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Improper use of extension cord observed. Extension cords should not be permanently installed or be routed through walls, floors or partitions."},{"checked":false,"id":1,"is_red":false,"text":"Insulation has been installed over knob and tube wiring at various locations. This is a fire \"Safety Concern\". Suggest review by a licensed electrician prior to closing to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Knob and tube wiring was observed in this home. This type of wiring was standard at the time of construction, and unless otherwise noted, appears to be in serviceable condition."},{"checked":false,"id":1,"is_red":false,"text":"Missing cover plates observed, suggest installing for safety."},{"checked":false,"id":1,"is_red":false,"text":"Open junction boxes were observed, which is a safety concern. Recommend installing proper covers, as needed, for safety."},{"checked":false,"id":1,"is_red":false,"text":"Recommend full review by qualified electrical contractor for quotes on upgrades/repair to ensure safe and adequate service."},{"checked":false,"id":1,"is_red":false,"text":"Since ungrounded receptacles were noted in the home, buyer is cautioned that proper grounding is strongly urged where sensitive electronic equipment is used.  Ungrounded receptacles do not offer protection for computers etc.  Consultation with a qualified electrical contractor is recommended."},{"checked":false,"id":1,"is_red":false,"text":"**ARC FAULT PROTECTION**"},{"checked":false,"id":1,"is_red":false,"text":"Bedroom circuits are NOT protected by an arc fault circuit interrupter type breaker. An arc fault interrupter will shut itself off if it detects a short, thus preventing an electrical fire."},{"checked":false,"id":1,"is_red":false,"text":"No Arc-Fault Circuit Interrupter (AFCI) protection was installed to protect electrical circuits in bedrooms.\n Building codes with which new homes must comply require the installation of AFCI protection of all bedroom outlets. This type of protection is designed to detect electrical arcing, which is a potential fire hazard. \nAlthough AFCI protection was not required at the time the home was originally constructed, as general knowledge of safe building practices has improved with the passage of time, building standards have changed to reflect current understanding. Consider updating the existing electrical to provide AFCI protection.\nArc-fault protection can be provided using either of two methods:\n1. Arc Fault Circuit Interrupters (AFCI's) electrical outlets which have this capability built in. \n2. AFCI circuit breakers installed at the main electrical panel which provide this protection to all non-AFCI outlets on the circuit controlled by that AFCI breaker.\n\n"},{"checked":false,"id":1,"is_red":false,"text":"It is HIGHLY recommended to (have a qualified electrician) install an Arc Fault Circuit Interrupter breaker in place of the the one currently protecting the bedroom circuits. In the near future it will be a requirement and is a very safe and sound update."},{"checked":false,"id":1,"is_red":false,"text":"Test AFCI breakers periodically to ensure proper operation."},{"checked":false,"id":1,"is_red":false,"text":"Damaged AFCI needs to be replaced"},{"checked":false,"id":1,"is_red":false,"text":"There is no AFCI protection. "},{"checked":false,"id":1,"is_red":false,"text":"All bedroom circuits are now required to be AFCI protected."},{"checked":false,"id":1,"is_red":false,"text":"The AFCI did not trip properly. This is a safety concern as the AFCI is designed to trip. Recommend repair or replacement of defective AFCI."},{"checked":false,"id":1,"is_red":false,"text":"This type of AFCI has been recalled."},{"checked":false,"id":1,"is_red":false,"text":"Installed AFCIs responded to test"},{"checked":false,"id":1,"is_red":false,"text":"One AFCI protected circuit failed to test at the service panel.  Recommend licensed electrician replace AFCI Circuit Breaker"},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Modern electrical codes require branch circuits at all bedrooms to be AFCI protected. The electrical code at the time this house was built may not have required AFCI protection at these circuits. Nonetheless, we strongly recommend they be added to all bedroom circuits as an extra preventive fire safety measure. Licensed electrician recommended."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: There is no AFCI protection in this house. There is the potential for a fire hazard. Recommend a licensed electrician provide an estimate on installing AFCI protection. "},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Licensed electrician should add additional AFCI protection for @@@@@@@"}],"sepChoice":"4","title":"Electrical"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Electrical Overall"}],"title":"Electrical"},{"damage_panels":[{"descr":"","id":2025,"options":[{"checked":false,"id":1,"is_red":false,"text":"**Wood Fireplaces**"},{"checked":false,"id":1,"is_red":false,"text":"The fireplace damper is damaged and not functional; The lever will not open or close the damper correctly. Do not attempt to start a fire until corrected."},{"checked":false,"id":1,"is_red":false,"text":"Damper was opened and closed several times."},{"checked":false,"id":1,"is_red":false,"text":"Level II inspection—The National Fire Protection Association (www.nfpa.org) advises that each chimney receive a Level II inspection each time a residence is sold. Inspection levels are explained at www.csia.org/pressroom/press-inspection-levels-explained.htm. It is also advised that this inspection be conducted by a chimney sweep certified by the Chimney Safety Institute of America (www.csia.org)."},{"checked":false,"id":1,"is_red":false,"text":"Several wood burning fireplaces with gas lighters- these should not be uses like a gas fireplace constantly on, they are for lighting wood logs. NOT TO BE USED WITH CERAMIC GAS LOGS."},{"checked":false,"id":1,"is_red":false,"text":"The room contains a vent free type of fireplace. It should not be operated for more than 2-4 hours at a time because of the inherent CO poisoning possibility."},{"checked":false,"id":1,"is_red":false,"text":"The fireplace front/screen assembly is not affixed to the opening of the chimney. have a fireplace professional evaluate and repair any issues as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Have a fireplace professional evaluate and repair any issues found before attempting to use fireplace."},{"checked":false,"id":1,"is_red":false,"text":"Ventless gas fireplace assembly enclosure."},{"checked":false,"id":1,"is_red":false,"text":"It was observed that some of the mortar around the firebox was failing; have a qualified individual evaluate and repair to avoid possible safety issue."},{"checked":false,"id":1,"is_red":false,"text":"The hearth extention appears to have an inadequate minimum clearance; should be minimum 16 inches in front and 8 inches on sides."},{"checked":false,"id":1,"is_red":false,"text":"Hearth Extension Dimensions - Hearth extensions shall extend at least 16 inches (406mm) in front of and at least 8 inches (203mm) beyond each side of the fireplace opening."},{"checked":false,"id":1,"is_red":false,"text":"The Fireplace mantle does not appear to be treated in any way and may be a fire hazard. Have a fireplace professional evaluate and repair any issues found before attempting to use the fireplace."},{"checked":false,"id":1,"is_red":false,"text":"**Gas Fireplaces**"},{"checked":false,"id":1,"is_red":false,"text":"The gas line is capped."},{"checked":false,"id":1,"is_red":false,"text":"Have a gas fireplace professional service/evaluate fireplace before operating."},{"checked":false,"id":1,"is_red":false,"text":"Have chimneys swept by professional."},{"checked":false,"id":1,"is_red":false,"text":"Fireplace in patterned wallpaper den is vent-less and should not be used over 4 hours due to possibility of CO poisoning."},{"checked":false,"id":1,"is_red":false,"text":"Master bedroom fireplace is not venting correctly."},{"checked":false,"id":1,"is_red":false,"text":"Functional."},{"checked":false,"id":1,"is_red":false,"text":"Make sure to get owner manuals for gas fireplace assembly."},{"checked":false,"id":1,"is_red":false,"text":"The fireplace appears to be in fair visual condition. Was operated and observed as functional during inspection."},{"checked":false,"id":1,"is_red":false,"text":"Wood was being burned in this GAS FIREPLACE."},{"checked":false,"id":1,"is_red":false,"text":"Small cracks were present. Recommend evaluation by a qualified fireplace professional."},{"checked":false,"id":1,"is_red":false,"text":"Could not fully inspect due to accumulation of ash"},{"checked":false,"id":1,"is_red":false,"text":"A flex line was observed in firebox."}],"sepChoice":"4","title":"Fireplace"}],"inspection_panels":[{"descr":"","id":3008,"options":[{"checked":false,"id":1,"is_red":false,"text":"Living Room"},{"checked":false,"id":1,"is_red":false,"text":"Family Room"},{"checked":false,"id":1,"is_red":false,"text":"Dining Room"},{"checked":false,"id":1,"is_red":false,"text":"Bedroom"},{"checked":false,"id":1,"is_red":false,"text":"Kitchen"},{"checked":false,"id":1,"is_red":false,"text":"Bathroom"},{"checked":false,"id":1,"is_red":false,"text":"Patio Area"},{"checked":false,"id":1,"is_red":false,"text":"Bonus Room"},{"checked":false,"id":1,"is_red":false,"text":"Bathroom"},{"checked":false,"id":1,"is_red":false,"text":"Den"},{"checked":false,"id":1,"is_red":false,"text":"Study"},{"checked":false,"id":1,"is_red":false,"text":"Library"},{"checked":false,"id":1,"is_red":false,"text":"Master"},{"checked":false,"id":1,"is_red":false,"text":"Theater Room"},{"checked":false,"id":1,"is_red":false,"text":"Guest House"}],"sepChoice":"1","title":"Fireplace Locations"},{"descr":"","id":3009,"options":[{"checked":false,"id":1,"is_red":false,"text":"Masonry fireplace noted."},{"checked":false,"id":1,"is_red":false,"text":"Prefabricated \"zero clearance\" fireplace noted."},{"checked":false,"id":1,"is_red":false,"text":"Pot belly style wood burning stove noted."},{"checked":false,"id":1,"is_red":false,"text":"Free standing style wood burning stove noted."},{"checked":false,"id":1,"is_red":false,"text":"Decorative electric fireplace noted. This is not inspected."}],"sepChoice":"1","title":"Fireplace Materials"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Fireplace Overall"}],"title":"Fireplaces"},{"damage_panels":[{"descr":"","id":2026,"options":[{"checked":false,"id":1,"is_red":false,"text":"Some of the floors in this building are a vintage 9x9 size; be advised that these tiles may be the type that had an adhesive containing asbestos. Asbestos is a health risk when it is made friable - in other words, when its fibres and dust can be breathed in by the lungs. to be safe, please refrain from removal and damaging these tiles until it is certain they are not asbestos containing material.  "},{"checked":false,"id":1,"is_red":false,"text":"Floor is not level. Suggest further evaluation by a licensed contractor within the inspection contingency period."},{"checked":false,"id":1,"is_red":false,"text":"Laminate floating floor system was installed with poor workmanship techniques, gaps, under size cuts, and chips are visible giving a less than appealing appearance and likely lowering the serviceable life of the flooring."},{"checked":false,"id":1,"is_red":false,"text":"It appears the existing carpeting was installed over the concrete slab without a moisture barrier;this is not a good installation method. The moisture content in the concrete can create the growth of organic materials \"Mold\" in the carpet. Recommend contacting a qualified contractor for further evaluation."},{"checked":false,"id":1,"is_red":false,"text":"Only the sub flooring is present and it is inconsistent in installation."},{"checked":false,"id":1,"is_red":false,"text":"Damaged grout observed, suggest regrouting as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Common cracks noted."},{"checked":false,"id":1,"is_red":false,"text":"Cracked tiles noted."},{"checked":false,"id":1,"is_red":false,"text":"Cracking noted in ceramic tiles.  This is an indication of inadequate subfloor installation."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of repairs observed, unable to determine the effectiveness of these repairs."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the floor is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"Minor damage noted."},{"checked":false,"id":1,"is_red":false,"text":"Numerous cracked tiles noted."},{"checked":false,"id":1,"is_red":false,"text":"Open seams observed."},{"checked":false,"id":1,"is_red":false,"text":"Popping floor tile observed."},{"checked":false,"id":1,"is_red":false,"text":"Possible trip hazard. This is a safety concern. Suggest repair/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified professional for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Recommend sealing cracks/voids."},{"checked":false,"id":1,"is_red":false,"text":"Tile has been painted/refinished, suggest taking care when cleaning to protect the surface."},{"checked":false,"id":1,"is_red":false,"text":"Water damage observed."},{"checked":false,"id":1,"is_red":false,"text":"Carpet is not recommended in bathrooms due to potential to harbor moisture, which could lead to unwanted mold issues."},{"checked":false,"id":1,"is_red":false,"text":"Recommend caulking at the tub and shower areas"},{"checked":false,"id":1,"is_red":false,"text":"Flooring appears to have damaged subfloor due to plumbing leak ."}],"sepChoice":"4","title":"Floor Condition"}],"inspection_panels":[{"descr":"Flooring Types:","id":3010,"options":[{"checked":false,"id":1,"is_red":false,"text":"Carpet is noted."},{"checked":false,"id":1,"is_red":false,"text":"Ceramic tile is noted."},{"checked":false,"id":1,"is_red":false,"text":"Sheet vinyl flooring is noted."},{"checked":false,"id":1,"is_red":false,"text":"Hardwood flooring is noted."},{"checked":false,"id":1,"is_red":false,"text":"Floating laminate type flooring noted."},{"checked":false,"id":1,"is_red":false,"text":"Marble floors noted."},{"checked":false,"id":1,"is_red":false,"text":"Natural stone floors noted."},{"checked":false,"id":1,"is_red":false,"text":"Bare concrete floors noted."},{"checked":false,"id":1,"is_red":false,"text":"Plywood subfloor is exposed."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl squares (tiles) are noted"}],"sepChoice":"1","title":"Floors"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Floor Condition Overall"}],"title":"Floors"},{"damage_panels":[{"descr":"","id":2027,"options":[{"checked":false,"id":1,"is_red":false,"text":"No security bars are present in this room."},{"checked":false,"id":1,"is_red":false,"text":"The security bars were operated and appeared functional."},{"checked":false,"id":1,"is_red":false,"text":"The security bars did not operate, this is not to building standards."},{"checked":false,"id":1,"is_red":false,"text":"The security bars are missing hardware, compromising their effective usage."},{"checked":false,"id":1,"is_red":false,"text":"The security bars were bent and appeared to not function properly."},{"checked":false,"id":1,"is_red":false,"text":"The security bars were rusted and appeared to not function properly."}],"sepChoice":"4","title":"Security Bars"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Security Bars Overall"}],"title":"Security Bars"},{"damage_panels":[{"descr":"","id":2030,"options":[{"checked":false,"id":1,"is_red":false,"text":"**Smoke Detectors**"},{"checked":false,"id":1,"is_red":false,"text":"The smoke detectors operated during the inspection."},{"checked":false,"id":1,"is_red":false,"text":"The smoke detectors did not operate during the inspection."},{"checked":false,"id":1,"is_red":false,"text":"There was no test button present on the smoke detector(s)."},{"checked":false,"id":1,"is_red":false,"text":"The smoke detector(s) were loose at the wall."},{"checked":false,"id":1,"is_red":false,"text":"The smoke detector(s) were loose at the ceiling."},{"checked":false,"id":1,"is_red":false,"text":"The smoke detector(s) were not in the proper position."},{"checked":false,"id":1,"is_red":false,"text":"Could not gain access to some of the rooms to test the smoke detectors due to stored items."},{"checked":false,"id":1,"is_red":false,"text":"We recommend hard wired smoke detectors with battery backups."},{"checked":false,"id":1,"is_red":false,"text":"There were no smoke detectors present in the bedroom(s)."},{"checked":false,"id":1,"is_red":false,"text":"There is a central station alarm system in the house which was not tested. The smoke detectors are part of this system so they were also not tested."},{"checked":false,"id":1,"is_red":false,"text":"There are several rooms that should have smoke detectors installed. We recommend having them installed."},{"checked":false,"id":1,"is_red":false,"text":"Replace all old not functioning smoke/ fire detectors with new hard wired detectors or make sure batteries are good."},{"checked":false,"id":1,"is_red":false,"text":"The installation of smoke detectors is not yet completed. We recommend having the seller finish installation and verify proper operation of detectors."},{"checked":false,"id":1,"is_red":false,"text":"Smoke detector near attic bedrooms did not function, may need a new battery."},{"checked":false,"id":1,"is_red":false,"text":"There are smoke detectors hard wired in and connected to each other,but there was one beeping continually- it may need to be replaced."},{"checked":false,"id":1,"is_red":false,"text":"Smoke detectors were tested and are functional. Remember to check detectors regularly, and replace when needed according to manufactures and fire safety guidelines. "},{"checked":false,"id":1,"is_red":false,"text":"No smoke/ fire detectors were installed at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"**Carbon Monoxide Detectors**"},{"checked":false,"id":1,"is_red":false,"text":"After 5 years of operation, CARBON MONOXIDE detectors should be replaced, because they wear out."},{"checked":false,"id":1,"is_red":false,"text":"It is recommended to test CO detectors regularly."},{"checked":false,"id":1,"is_red":false,"text":"Have hard wired, or plug in CO Detectors installed at a low elevation, as it may hover close to the ground and rise up during a fire."},{"checked":false,"id":1,"is_red":false,"text":"If a carbon monoxide detector sets its alarm from exposure to CO, it is no longer considered efficient to use as its sensor mechanism will have been depleted. "},{"checked":false,"id":1,"is_red":false,"text":"No CO detector was observed at time of inspection. "},{"checked":false,"id":1,"is_red":false,"text":"Tested and functional at time of inspection, but only the siren was tested, not the carbon monoxide sensor."}],"sepChoice":"4","title":"Smoke Detectors"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Smoke Detectors Overall"}],"title":"Smoke Detector"},{"damage_panels":[{"descr":"","id":2031,"options":[{"checked":false,"id":1,"is_red":false,"text":"Some areas not accessible due to stored personal items."},{"checked":false,"id":1,"is_red":false,"text":"There is evidence of moisture entering structure. We recommend contacting a contractor experienced in exterior systems to evaluate the area and suggest repair options."},{"checked":false,"id":1,"is_red":false,"text":"Loose wall paneling is noted."},{"checked":false,"id":1,"is_red":false,"text":"There are loose mirrors noted."},{"checked":false,"id":1,"is_red":false,"text":"There is loose wall paper noted."},{"checked":false,"id":1,"is_red":false,"text":"There are areas still under construction. These areas are not tested."},{"checked":false,"id":1,"is_red":false,"text":"Missing drywall noted."},{"checked":false,"id":1,"is_red":false,"text":"Mold like stains are present under sink. We recommend having a mold sample taken and lab tested."},{"checked":false,"id":1,"is_red":false,"text":"Vacuum system present, not tested consult owner"},{"checked":false,"id":1,"is_red":false,"text":"Loose baseboards in areas, these are easily re-secured with a hammer ad some 6-D finish nails."}],"sepChoice":"4","title":"Wall Condition"}],"inspection_panels":[{"descr":"","id":3011,"options":[{"checked":false,"id":1,"is_red":false,"text":"Drywall walls noted."},{"checked":false,"id":1,"is_red":false,"text":"Plaster walls noted."},{"checked":false,"id":1,"is_red":false,"text":"Wall paper finish noted."},{"checked":false,"id":1,"is_red":false,"text":"Painted finish noted."},{"checked":false,"id":1,"is_red":false,"text":"Walls are clad in paneling."},{"checked":false,"id":1,"is_red":false,"text":"Mirror panels are noted."},{"checked":false,"id":1,"is_red":false,"text":"The walls are clad in wood plank material. "},{"checked":false,"id":1,"is_red":false,"text":"There is a brick veneer noted."},{"checked":false,"id":1,"is_red":false,"text":"There is a stone veneer noted."},{"checked":false,"id":1,"is_red":false,"text":"Walls are clad in a laminate material."},{"checked":false,"id":1,"is_red":false,"text":"Walls are clad in granite panels."},{"checked":false,"id":1,"is_red":false,"text":"Cork finish noted."},{"checked":false,"id":1,"is_red":false,"text":"Walls are clad in ceramic tile."}],"sepChoice":"1","title":"Walls"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Wall Condition Overall"}],"title":"Walls"},{"damage_panels":[{"descr":"","id":2032,"options":[{"checked":false,"id":1,"is_red":false,"text":"Did not operate the window air conditioning unit. Operation of this type of unit is beyong the scope of this inspection."},{"checked":false,"id":1,"is_red":false,"text":"The wall heater is a worn unit possibly beyond it's useful life."},{"checked":false,"id":1,"is_red":false,"text":"The wall heater is missing it's cover. We recommend contacting the seller for replacement of the cover."},{"checked":false,"id":1,"is_red":false,"text":"Heating unit was unplugged with no available power nearby, did not test."},{"checked":false,"id":1,"is_red":false,"text":"Heating/AC unit is missing control knobs. Consult with the seller for possible replacement."},{"checked":false,"id":1,"is_red":false,"text":"The units airflow was not cold, recommend servicing the unit."},{"checked":false,"id":1,"is_red":false,"text":"The units airflow was not warm, recommend servicing the unit."},{"checked":false,"id":1,"is_red":false,"text":"The combination heater/ ac unit was not secured properly in the wall. We recommend contacting a qualified contractor to re-secure the unit."},{"checked":false,"id":1,"is_red":false,"text":"The combination heater/ ac unit was making an irregular noise. We recommend contacting a qualified contractor to service the unit."},{"checked":false,"id":1,"is_red":false,"text":"The inspector could not access the unit due to stored personal items in the way."},{"checked":false,"id":1,"is_red":false,"text":"There is a swamp cooler present and not tested by inspector."}],"sepChoice":"4","title":"Window-Wall AC or Heat"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Window-Wall AC or Heat Overall"}],"title":"Window/Wall AC/Heat"},{"damage_panels":[{"descr":"","id":2214,"options":[{"checked":false,"id":1,"is_red":false,"text":"Deterioration noted due to contact with moisture, repairs needed."},{"checked":false,"id":1,"is_red":false,"text":"Shower area's are a poor location for a window, recommend removal due to potential issues in the future."},{"checked":false,"id":1,"is_red":false,"text":"One or more window/s shows sign of loss of seal/condensation, recommend repair or replace to provide energy savings and prevent hazed window from limiting view out of window. "},{"checked":false,"id":1,"is_red":false,"text":"One or more windows did not lock/latch properly, recommend repairs for enhanced security/safety to occupants."},{"checked":false,"id":1,"is_red":false,"text":"Broken/cracked glass pane noted, repairs needed."},{"checked":false,"id":1,"is_red":false,"text":"Window sill height appears to be over 44 inches which is the maximum height for egress from a bedroom according to current building standards. This could be a fatal issue in the event of an emergency exit situation. Recommend review of current egress and upgrade as needed to enhance the safety to occupants."},{"checked":false,"id":1,"is_red":false,"text":"hardware difficult to operate at one or more locations. Recommend review and repair as needed by qualified window contractors"},{"checked":false,"id":1,"is_red":false,"text":"In the event of an emergency it appears that the windows could cause an issue of quick egress due to the windows are difficult to open for a small child for escape. Recommend review and repair to allow easy exit in the event of an emergency situation."},{"checked":false,"id":1,"is_red":false,"text":"Single pane windows observed, recommend budgeting for replacement for added efficiency of home."},{"checked":false,"id":1,"is_red":false,"text":"Broken glazing observed, suggest re-glazing as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Broken sash wire/cord observed on window frame. This is a \"Safety Concern\". Sash wire/cord holds window in open position. Suggest repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Damaged screens observed."},{"checked":false,"id":1,"is_red":false,"text":"Deterioration of wooden frames noted.  While basic maintenance may prolong the life of these window frames, replacement may be necessary at some point.  "},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the windows/frames are near the end of their useful life."},{"checked":false,"id":1,"is_red":false,"text":"Peeling paint observed, suggest scraping and painting as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Fog/condensation observed in thermopane windows. This is an indication of a failed seal. Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl crank out style windows with locks."},{"checked":false,"id":1,"is_red":false,"text":"Painted wood windows possibly creating lead dust from friction on paint. "},{"checked":false,"id":1,"is_red":false,"text":"Metal \"double hung\" type with locks."},{"checked":false,"id":1,"is_red":false,"text":"Severe damage--\nSome vinyl windows in the home had severe damage visible at the time of the inspection. You may wish to get estimates for repair before the expiration of your Inspection Objection Deadline.\n"},{"checked":false,"id":1,"is_red":false,"text":"Minor damage--\nSome vinyl windows in the home had minor damage visible at the time of the inspection.\n"},{"checked":false,"id":1,"is_red":false,"text":"Some of the windows are difficult to lock, especially window located in childs room."},{"checked":false,"id":1,"is_red":false,"text":"The upstairs crank out window facing front of home appears to be missing some minor hardware & a screen."},{"checked":false,"id":1,"is_red":false,"text":"The home is fitted with vinyl windows."},{"checked":false,"id":1,"is_red":false,"text":"Some windows are very difficult to open and some were not able to open, this may be because of the paint."},{"checked":false,"id":1,"is_red":false,"text":"Screens were not installed at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"In accordance with ASHI Standards, we do not test every window in the house, and particularly if it is furnished. We do test every unobstructed window in every bedroom to ensure that at least one provides and emergency exit."},{"checked":false,"id":1,"is_red":false,"text":"Highly recommend operating all windows during final walk through inspection."},{"checked":false,"id":1,"is_red":false,"text":"Operated windows appeared functional, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"The windows that were tested, are functional."},{"checked":false,"id":1,"is_red":false,"text":"Apparent mold observed. Location: @@@@@"},{"checked":false,"id":1,"is_red":false,"text":"Damaged/Missing sash cords."},{"checked":false,"id":1,"is_red":false,"text":"Missing screens observed at @@LOCATION@@."},{"checked":false,"id":1,"is_red":false,"text":"Damage tilt-out feature locking clips at @@LOCATION@@. Window is still functional. FYI"},{"checked":false,"id":1,"is_red":false,"text":"Damage/missing hardware at @@LOCATION@@. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Torn screen(s)"},{"checked":false,"id":1,"is_red":false,"text":"Deterioration of wooden frames noted.  While basic maintenance may prolong the life of these window frames, replacement may be necessary at some point.  "},{"checked":false,"id":1,"is_red":false,"text":"Cloudiness/condensation observed in @@NUMBER@@ of thermopane double glazed windows in @@LOCATION@@. This is an indication of a failed seal. A qualified contractor should review for replacement as needed."},{"checked":false,"id":1,"is_red":false,"text":"Cracked or broken window glass was observed. Injury could occur. Recommend repair or replacement of the damaged glass."},{"checked":false,"id":1,"is_red":false,"text":"Cracked window pane in @@LOCATION@@. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"DEFERRED COST: Windows are original, older type. Consider upgrading to double pane, thermally insulated, newer efficient type."},{"checked":false,"id":1,"is_red":false,"text":"Some windows did not open when tested. Recommend  all windows reviewed for proper operation during walkthrough inspection prior to closing"},{"checked":false,"id":1,"is_red":false,"text":"A representative number of windows were inspected. Most did not open when tested -- appears painted wood frames have sealed seams. Recommend  all windows be reviewed for proper operation during final walkthrough inspection."},{"checked":false,"id":1,"is_red":false,"text":"All accessible windows operated"},{"checked":false,"id":1,"is_red":false,"text":"Mold-like bio growth observed. Professional testing & evaluation advised."},{"checked":false,"id":1,"is_red":false,"text":"There are older wood windows present."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl crank out style windows with locks."},{"checked":false,"id":1,"is_red":false,"text":"Painted wood windows possibly creating lead dust from friction on paint. "},{"checked":false,"id":1,"is_red":false,"text":"Metal \"double hung\" type with locks."},{"checked":false,"id":1,"is_red":false,"text":"Severe damage--\nSome vinyl windows in the home had severe damage visible at the time of the inspection. You may wish to get estimates for repair before the expiration of your Inspection Objection Deadline.\n"},{"checked":false,"id":1,"is_red":false,"text":"Minor damage--\nSome vinyl windows in the home had minor damage visible at the time of the inspection.\n"},{"checked":false,"id":1,"is_red":false,"text":"Some of the windows are difficult to lock, especially window located in childs room."},{"checked":false,"id":1,"is_red":false,"text":"The upstairs crank out window facing front of home appears to be missing some minor hardware & a screen."},{"checked":false,"id":1,"is_red":false,"text":"The home is fitted with vinyl windows."},{"checked":false,"id":1,"is_red":false,"text":"The windows in the home are rope and pulley style, may be original to home, and are approaching the end of their serviceable lifetime."}],"sepChoice":"4","title":"Window Condition"}],"inspection_panels":[{"descr":"","id":3064,"options":[{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed casement window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Stationary(fixed) window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed casement window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed casement window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Garden style window noted."},{"checked":false,"id":1,"is_red":false,"text":"Bay type window noted."},{"checked":false,"id":1,"is_red":false,"text":"Bow type window noted."},{"checked":false,"id":1,"is_red":false,"text":"Glass blocks noted in window openings."},{"checked":false,"id":1,"is_red":false,"text":"Non-insulated glass noted."},{"checked":false,"id":1,"is_red":false,"text":"Insulated glass noted."}],"sepChoice":"1","title":"Windows"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Window Condition Overall"}],"title":"Windows"},{"damage_panels":[{"descr":"","id":2227,"options":[{"checked":false,"id":1,"is_red":false,"text":"Small cracking in the wall finish is noted. This is probably caused by the joint compound (spackle) drying too quickly during application. "},{"checked":false,"id":1,"is_red":false,"text":"Minor damage from what appears to be from excess moisture noted. Recommend review of current vent fan and possibly installing a timer to assure that fan is used during showers."},{"checked":false,"id":1,"is_red":false,"text":"The drywall is patched in areas. The reason for the patch could not be determined. "},{"checked":false,"id":1,"is_red":false,"text":"Small stains noted on the ceiling. They tested dry at the time of the inspection."},{"checked":false,"id":1,"is_red":false,"text":"Large stains noted on the ceiling. They tested dry at the time of the inspection."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of past leaking was noted."},{"checked":false,"id":1,"is_red":false,"text":"There were signs of paint blistering on the ceiling. The areas tested dry at the time of the inspection, but should be monitored for further damage or possibly water intrusion."},{"checked":false,"id":1,"is_red":false,"text":"The inspector could not access the area around the skylight."},{"checked":false,"id":1,"is_red":false,"text":"Visible leaking noted on the ceiling. We recommend contacting a qualified contractor to evaluate the roof and the drywall in this area and repair as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Freshly painted in areas. This could be concealing a defect that could not be determined."},{"checked":false,"id":1,"is_red":false,"text":"Mold like stains present on the ceiling. We recommend having a mold sample taken and lab tested, also monitor the area for water intrusion."},{"checked":false,"id":1,"is_red":false,"text":"There is a damaged ceiling tile in dining room - damage is between crown molding and tile in form of a puncture of sorts. see pic."},{"checked":false,"id":1,"is_red":false,"text":"Extensive water damage to general area of ceiling where the past leaking had occurred. Areas are marked with peeling paint and bulging drywall. Have a contractor evaluate."},{"checked":false,"id":1,"is_red":false,"text":"There is an anomaly present a the point in the ceiling that adjoins the inner wall. It appears there is a bowing / sagging in the corner. It is not clear as to what may have caused this. Ask association about this issue and about past occurrences that may be linked to this issue."},{"checked":false,"id":1,"is_red":false,"text":"The ceiling was not painted all the way to the edge in kitchen."},{"checked":false,"id":1,"is_red":false,"text":"The drywall installation is not entirely professional quality, have a contractor evaluate."}],"sepChoice":"4","title":"Ceiling Condition"}],"inspection_panels":[{"descr":"","id":3075,"options":[{"checked":false,"id":1,"is_red":false,"text":"There are drywall ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"There are plaster ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"There are acoustic grid and tile ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"There are wood plank ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"There are metal pan ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"Open beam ceiling construction noted."},{"checked":false,"id":1,"is_red":false,"text":"There is panel lighting present in the ceiling."},{"checked":false,"id":1,"is_red":false,"text":"The ceilings are clad in wood paneling."},{"checked":false,"id":1,"is_red":false,"text":"Cathedral style (vaulted) ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"Mirror panels are noted on the ceilings."},{"checked":false,"id":1,"is_red":false,"text":"The ceilings are clad in cork."},{"checked":false,"id":1,"is_red":false,"text":"The ceilings are clad in a laminate material."},{"checked":false,"id":1,"is_red":false,"text":"The ceilings are clad in tile squares."}],"sepChoice":"1","title":"Ceilings"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Ceiling Condition Overall"}],"title":"Ceilings"},{"damage_panels":[{"descr":"","id":2237,"options":[{"checked":false,"id":1,"is_red":false,"text":"**Sliding Patio Doors**"},{"checked":false,"id":1,"is_red":false,"text":"There are no patio doors present in this room."},{"checked":false,"id":1,"is_red":false,"text":"The sliding patio door was functional during the inspection."},{"checked":false,"id":1,"is_red":false,"text":"The hinged patio door was functional during the inspection."},{"checked":false,"id":1,"is_red":false,"text":"The doors hardware is showing signs of wear and may be at the end of its useful life. We recommend budgeting for replacement."},{"checked":false,"id":1,"is_red":false,"text":"The sliding door tracks appeared dirty at the inspection making the door difficult to operate. We recommend cleaning the tracks and lubricating the doors rollers."},{"checked":false,"id":1,"is_red":false,"text":"Tempered glass noted in the patio door."},{"checked":false,"id":1,"is_red":false,"text":"Door is difficult to operate, this presents a safety hazard in the event of an emergency/fire. Recommend repair/adjusting of door by a Qualified Contractor to allow easy and smooth operation. Current building standards require this second means of egress in a sleeping area for quick escape in the event of an emergency."},{"checked":false,"id":1,"is_red":false,"text":"One or more sliding door/s shows sign of loss of seal/condensation, recommend repair or replace by Qualified Contractors, to provide energy savings and prevent hazed window from limiting view out of window. "},{"checked":false,"id":1,"is_red":false,"text":"Sliding glass door is installed backwards/inside out."},{"checked":false,"id":1,"is_red":false,"text":"**Hinged Patio Doors**"},{"checked":false,"id":1,"is_red":false,"text":"Door is difficult to operate, this presents a safety hazard in the event of an emergency/fire. Recommend repair/adjusting of door by a Qualified Contractor to allow easy and smooth operation. Current building standards require this second means of egress in a sleeping area for quick escape in the event of an emergency."},{"checked":false,"id":1,"is_red":false,"text":"The patio door did not lock.\r\n"},{"checked":false,"id":1,"is_red":false,"text":"The patio door did not latch."},{"checked":false,"id":1,"is_red":false,"text":"Tempered glass noted in the patio door."},{"checked":false,"id":1,"is_red":false,"text":"The doors hardware is showing signs of wear and may be at the end of its useful life. We recommend budgeting for replacement."},{"checked":false,"id":1,"is_red":false,"text":"Frame is separating from glass."},{"checked":false,"id":1,"is_red":false,"text":"The inspector can not determine if tempered glass is in the door."}],"sepChoice":"4","title":"Patio Doors"},{"descr":"","id":2238,"options":[{"checked":false,"id":1,"is_red":false,"text":"Not installed, recommend installation and confirmation of proper screen door operation."},{"checked":false,"id":1,"is_red":false,"text":"Sliding door screen is missing/damaged."},{"checked":false,"id":1,"is_red":false,"text":"Sliding door screen is functional."},{"checked":false,"id":1,"is_red":false,"text":"Sliding door screen tracks are dirty making the door difficult to operate. Recommend cleaning the tracks out."},{"checked":false,"id":1,"is_red":false,"text":"The sliding screen door has worn hardware and may be at the end of its useful life. Recommend budgeting for replacement."},{"checked":false,"id":1,"is_red":false,"text":"Security screen door present."},{"checked":false,"id":1,"is_red":false,"text":"Sliding screen door is torn sliding screen door is difficult to operate."},{"checked":false,"id":1,"is_red":false,"text":"Sliding screen door is difficult to operate."},{"checked":false,"id":1,"is_red":false,"text":"Sliding screen door is off the tracks."},{"checked":false,"id":1,"is_red":false,"text":"Sliding screen door is bent."},{"checked":false,"id":1,"is_red":false,"text":"Sliding screen door is missing hardware."},{"checked":false,"id":1,"is_red":false,"text":"Broken latch on the sliding screen door."}],"sepChoice":"4","title":"Screen Doors"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Patio Doors Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Screen Doors Overall"}],"title":"Patio Doors"}],"title":"Bedrooms"},{"id":15,"tabbed_panels":[{"damage_panels":[{"descr":"","id":2000,"options":[{"checked":false,"id":1,"is_red":false,"text":"The bar area appears functional at the time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Worn fixtures noted at the bar area."},{"checked":false,"id":1,"is_red":false,"text":"There is cold water service only to the bar sink."},{"checked":false,"id":1,"is_red":false,"text":"There is a non GFCI protected outlet next to the bar sink. Recommend installation of a GFCI protected outlet."},{"checked":false,"id":1,"is_red":false,"text":"GFCI outlet tested and operated."},{"checked":false,"id":1,"is_red":false,"text":"The bar sink faucet drips. Recommend contacting a licensed plumber to repair."},{"checked":false,"id":1,"is_red":false,"text":"Faucet leaking while operating. Recommend contacting a licensed plumber to repair."},{"checked":false,"id":1,"is_red":false,"text":"The bar sink drains slow, this could be from a clogged drain pipe to improper venting. We recommend trying to clean the drain, if this doesn't work contact a licensed plumber to evaluate the cause of the problem."},{"checked":false,"id":1,"is_red":false,"text":"The cabinet doors have loose hardware."},{"checked":false,"id":1,"is_red":false,"text":"The cabinet doors are missing hardware."},{"checked":false,"id":1,"is_red":false,"text":"There is water leaking under wet bar. Recommend contacting a licensed plumber for evaluation and repair."},{"checked":false,"id":1,"is_red":false,"text":"There is a flex line present under sink."},{"checked":false,"id":1,"is_red":false,"text":"The bar area appears to have been added at a later date and not original to the home. There are some irregular installations involved  in its construction. We recommend checking the township building permits to see if this area was ever inspected."},{"checked":false,"id":1,"is_red":false,"text":"Could not access this area  due to stored personal items."},{"checked":false,"id":1,"is_red":false,"text":"Shut valves under the sink are in the off position."}],"sepChoice":"4","title":"Bar"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Bar Overall"}],"title":"Bar"},{"damage_panels":[{"descr":"","id":2001,"options":[{"checked":false,"id":1,"is_red":false,"text":"Most not accessible due to stored personal items."},{"checked":false,"id":1,"is_red":false,"text":"No deficiencies observed."},{"checked":false,"id":1,"is_red":false,"text":"No deficiencies observed on all kitchen cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Appeared functional and in satisfactory condition, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Recommend adding additional cabinet screws as drywall screws have been used."},{"checked":false,"id":1,"is_red":false,"text":"Loose at wall. Needs immediate attention. "},{"checked":false,"id":1,"is_red":false,"text":"DEFERRED COST:  The cabinets are original. Consider upgrade.."},{"checked":false,"id":1,"is_red":false,"text":"Appeared functional, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Mold-like bio growth observed inside vanity at powder room, bathroom #3.  Evidence of a prior leak in the sink drain trap. Professional testing & evaluation advised."},{"checked":false,"id":1,"is_red":false,"text":"Some cabinet doors need magnets or hardware to stay shut. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Some cabinet drawers  need  hardware repair/adjustment (to stay shut). Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Drawers are difficult to slide. It appears that if the guides are lubricated, that will correct the problem."},{"checked":false,"id":1,"is_red":false,"text":"Broken drawer guides noted. Recommend having a qualified contractor replace the guides."},{"checked":false,"id":1,"is_red":false,"text":"Noted cabinet(s) loose on the wall. Recommend having a qualified contractor re-fasten the cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Noted cabinet(s) loose at the floor. Recommend having a qualified contractor re-fasten the cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Noted cabinet(s) loose at the ceiling. Recommend having a qualified contractor re-fasten the cabinets."},{"checked":false,"id":1,"is_red":false,"text":"There appears to be water damage under sink. This tested dry at the time of the inspection, but monitor for any further intrusion."},{"checked":false,"id":1,"is_red":false,"text":"Doors did not close completely."},{"checked":false,"id":1,"is_red":false,"text":"The door was locked to bathroom, could not access the room to inspect."},{"checked":false,"id":1,"is_red":false,"text":"The sliding cabinet doors were difficult to slide. It appears that lubrication will correct the problem."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors missing, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors missing hardware, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawers missing, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors have broken hinges, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawers missing handles, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawers off their guides, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors have loose hardware, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors missing knobs, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawer face is missing, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawer face is loose, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors have broken glass panels in them, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Drawer(s) bind in tracks,"},{"checked":false,"id":1,"is_red":false,"text":"Drawer(s) unsupported in cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Shelving missing or damaged."},{"checked":false,"id":1,"is_red":false,"text":"Lazy Susan cabinet binds and does not turn smoothly."}],"sepChoice":"4","title":"Cabinets"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Cabinets Overall"}],"title":"Cabinets"},{"damage_panels":[{"descr":"","id":2002,"options":[{"checked":false,"id":1,"is_red":false,"text":"None present."},{"checked":false,"id":1,"is_red":false,"text":"Operated normally when tested, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Ceiling fans observed in @@@@@@@@@. Due to the amount of insulation or type of construction, it was not possible to determine the method of attachment to the ceiling. These units are heavy and due to the designed movement, must have the proper style mounting boxes for correct and safe attachment.  Recommend confirming the method of attachment prior to use. This may require the removal of the fan or insulation to visually verify proper support."},{"checked":false,"id":1,"is_red":false,"text":"The ceiling fan is a worn unit that has reached the end of its useful life."},{"checked":false,"id":1,"is_red":false,"text":"The ceiling fan did not operate when tested."},{"checked":false,"id":1,"is_red":false,"text":"The fan blades wobble when tested."},{"checked":false,"id":1,"is_red":false,"text":"The ceiling fan appears to be loose at ceiling. This is a safety issue, recommend contacting a licensed electrician to repair."},{"checked":false,"id":1,"is_red":false,"text":"The ceiling fan has exposed wiring. This is a safety issue, recommend contacting a licensed electrician to repair."},{"checked":false,"id":1,"is_red":false,"text":"There is a missing fixture globe on the ceiling fan. These are usually easy and inexpensive to replace from your local home improvement center."},{"checked":false,"id":1,"is_red":false,"text":"The ceiling fan is missing blades, generic replacement blades are available at your local home improvement center."},{"checked":false,"id":1,"is_red":false,"text":"The ceiling fan has damaged blades, generic replacement blades are available at your local home improvement center."},{"checked":false,"id":1,"is_red":false,"text":"The fan unit makes an  irregular noise. This may be a sign that it has reached the end of its useful life."},{"checked":false,"id":1,"is_red":false,"text":"The ceiling fan is missing a pull chain. These are easily purchased at your local hardware store."},{"checked":false,"id":1,"is_red":false,"text":"The ceiling fan is using an extension cord for power. This is an illegal operation and should be corrected at once."},{"checked":false,"id":1,"is_red":false,"text":"Could not locate remote."}],"sepChoice":"4","title":"Ceiling Fans"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Ceiling Fans Overall"}],"title":"Ceiling Fans"},{"damage_panels":[{"descr":"","id":2004,"options":[{"checked":false,"id":1,"is_red":false,"text":"No closets were present in this room. this room cannot be considered as a bedroom without at least one closet."},{"checked":false,"id":1,"is_red":false,"text":"The closet is in serviceable condition."},{"checked":false,"id":1,"is_red":false,"text":"Stains were present on the closet ceilings indicating prior water infiltration. Although they tested dry they should be noted."},{"checked":false,"id":1,"is_red":false,"text":"The closet door was missing."},{"checked":false,"id":1,"is_red":false,"text":"The closet door has fallen out of square and drags on the floor. We recommend contacting a qualified contractor to realign the door."},{"checked":false,"id":1,"is_red":false,"text":"The closet shelving needs to be refastened to the wall."},{"checked":false,"id":1,"is_red":false,"text":"The closet shelving is missing."},{"checked":false,"id":1,"is_red":false,"text":"The closet light is missing fixture globe. This can be a potential fire hazard if clothing comes in contact with an exposed light bulb."},{"checked":false,"id":1,"is_red":false,"text":"The closet shelves are broken. Recommend having a qualified contractor replace the shelving."}],"sepChoice":"4","title":"Closets"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Closets Overall"}],"title":"Closets"},{"damage_panels":[{"descr":"","id":2005,"options":[{"checked":false,"id":1,"is_red":false,"text":"Operated normally when tested."},{"checked":false,"id":1,"is_red":false,"text":"Wireless door bell unit noted. Remember to change the batteries approximately every six months to insure working status."},{"checked":false,"id":1,"is_red":false,"text":"The inspector was not able to operate the doorbell."},{"checked":false,"id":1,"is_red":false,"text":"The exterior push button was noted as loose on the wall."},{"checked":false,"id":1,"is_red":false,"text":"The exterior push button is noted as missing."},{"checked":false,"id":1,"is_red":false,"text":"Damaged button. Replace as needed."},{"checked":false,"id":1,"is_red":false,"text":"The interior door chime is missing it's decorative cover exposing the working parts. Consult with the seller for replacement."},{"checked":false,"id":1,"is_red":false,"text":"The doorbell did not operate when tested.  Recommend checking the door bell button, chime & transformer & replace or repair as needed. "},{"checked":false,"id":1,"is_red":false,"text":"There are door chime wires exposed inside the home. These wires are subject to physical damage and should be encased on a surface mounted wire raceway."}],"sepChoice":"4","title":"Door Bell"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Door Bell Overall"}],"title":"Door Bell"},{"damage_panels":[{"descr":"","id":2006,"options":[{"checked":false,"id":1,"is_red":false,"text":"Double door entryway."},{"checked":false,"id":1,"is_red":false,"text":"The back door is difficult to open and close; mechanism may not be installed true. Back door opens to a step off and fall situation, needs a landing and stairs built on exterior. At lease put up a sign during any open house viewing of the property."},{"checked":false,"id":1,"is_red":false,"text":"Bedroom door is missing doorknob & hardware."},{"checked":false,"id":1,"is_red":false,"text":"Hollow wood doors. "},{"checked":false,"id":1,"is_red":false,"text":"Sliding doors to backyard."},{"checked":false,"id":1,"is_red":false,"text":"There is a steel, \"fire rated\" door to garage with self closing mechanism."},{"checked":false,"id":1,"is_red":false,"text":"Front door and hardware is damaged."},{"checked":false,"id":1,"is_red":false,"text":"The bathroom door does not lock."},{"checked":false,"id":1,"is_red":false,"text":"The entry doors automatic closer is unable tp perform its function due to the thick carpeting that makes the door difficult to open and close."},{"checked":false,"id":1,"is_red":false,"text":"The bathroom closet door is off its tracks."},{"checked":false,"id":1,"is_red":false,"text":"Door bell is not functional."},{"checked":false,"id":1,"is_red":false,"text":"The door for the furnace closet should be louvred to allow air in to help combustion. "},{"checked":false,"id":1,"is_red":false,"text":"Several doors are sealed and made not functional by amateurish construction of the office space, have contractor evaluate and repair."},{"checked":false,"id":1,"is_red":false,"text":"Metal door  with \"wood look\"."},{"checked":false,"id":1,"is_red":false,"text":"Sliding door in rear leading to porch."},{"checked":false,"id":1,"is_red":false,"text":"Back door missing a deadbolt lockset."},{"checked":false,"id":1,"is_red":false,"text":"The top floor units back door rubs on the floor as it opens and closes, may need some sanding on bottom of door to help clearance."},{"checked":false,"id":1,"is_red":false,"text":"Some doors are damaged."},{"checked":false,"id":1,"is_red":false,"text":"Several doors are a bit tight in jams, possibly from the new coat of paint."},{"checked":false,"id":1,"is_red":false,"text":"Loose door striker on bedroom door frame."},{"checked":false,"id":1,"is_red":false,"text":"The exit door to mechanical room utilises a self closing mechanism."},{"checked":false,"id":1,"is_red":false,"text":"Doors are not installed."}],"sepChoice":"4","title":"Doors"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Doors Overall"}],"title":"Doors"},{"damage_panels":[{"descr":"","id":2007,"options":[{"checked":false,"id":1,"is_red":false,"text":"Some outlets not accessible due to furniture and or stored personal items."},{"checked":false,"id":1,"is_red":false,"text":"It is HIGHLY recommended to(have a qualified electrician) install an Arc Fault Circuit Interrupter breaker in place of the the one currently protecting the bedroom circuits,in the near future it will be a requirement and is a very safe and sound update."},{"checked":false,"id":1,"is_red":false,"text":"Bedroom circuits are NOT protected by an arc fault circuit interrupter type breaker. An arc fault interrupter will shut itself off if it detects a short, thus preventing an electrical fire."},{"checked":false,"id":1,"is_red":false,"text":"No Arc-Fault Circuit Interrupter (AFCI) protection was installed to protect electrical circuits in bedrooms.\n Building codes with which new homes must comply require the installation of AFCI protection of all bedroom outlets. This type of protection is designed to detect electrical arcing, which is a potential fire hazard. \nAlthough AFCI protection was not required at the time the home was originally constructed, as general knowledge of safe building practices has improved with the passage of time, building standards have changed to reflect current understanding. Consider updating the existing electrical to provide AFCI protection.\nArc-fault protection can be provided using either of two methods:\n1. Arc Fault Circuit Interrupters (AFCI's) electrical outlets which have this capability built in. \n2. AFCI circuit breakers installed at the main electrical panel which provide this protection to all non-AFCI outlets on the circuit controlled by that AFCI breaker.\n\n"},{"checked":false,"id":1,"is_red":false,"text":"No Ground Fault Circuit Interrupter (GFCI) protection of home electrical outlets was provided in the home at the time of inspection. Although GFCI protection may not have been required at the time the home was built, for safety reasons, consider upgrading the electrical system to include GFCI protection at the following locations:\r\n•\tBathrooms \r\n•\tOutside \r\n•\tGarages \r\n•\tCrawlspace (at or below grade) \r\n•\tUnfinished basements \r\n•\tKitchens \r\n•\tLaundry rooms \r\n•\tWithin 6 feet of all plumbing fixtures\r\n•\tBoathouses \r\n"},{"checked":false,"id":1,"is_red":false,"text":"Test AFCI breakers periodically to ensure proper operation."},{"checked":false,"id":1,"is_red":false,"text":"2-prong outlets -\nThe home contained outdated, ungrounded 2-prong electrical outlets. Although this condition may have been commonly considered safe or acceptable at the time the home was originally constructed, as general knowledge of safe building practices has improved with the passage of time, building standards have changed to reflect current understanding. Consider updating the existing condition to meet generally-accepted current standards.\n"},{"checked":false,"id":1,"is_red":false,"text":"Some loose and improperly installed receptacles were found, they should be installed correctly by a licensed electrician. Several are wired in reverse, one is poorly grounding."},{"checked":false,"id":1,"is_red":false,"text":"Some receptacles were painted over."},{"checked":false,"id":1,"is_red":false,"text":"It is recommended to avoid use of multiplier outlet plug ins ( converts 2 into 6 outlets ) "},{"checked":false,"id":1,"is_red":false,"text":"Missing outlet covers - throughout home.  See pictures."},{"checked":false,"id":1,"is_red":false,"text":"Open ground - receptacle in wall across from windows in dining room."},{"checked":false,"id":1,"is_red":false,"text":"Several outlets were found to have been reverse polarity wired, see pics for locations. Have an electrician evaluate and repair."},{"checked":false,"id":1,"is_red":false,"text":"Reverse polarity- 2 receptacles. one in dining room left of window, one in front room on same wall as door. Have electrician rewire."},{"checked":false,"id":1,"is_red":false,"text":"Most receptacles , except where noted, are in fair condition and tested ok, some are painted over."},{"checked":false,"id":1,"is_red":false,"text":"Open ground- receptacle in basement"},{"checked":false,"id":1,"is_red":false,"text":"Have a qualified electrician repair items listed following a complete evaluation of the electrical system."},{"checked":false,"id":1,"is_red":false,"text":"The receptacles near laundry machines are polarized and should be GFCI"},{"checked":false,"id":1,"is_red":false,"text":"The kitchen receptacles are not GFCI protected. have one installed upstream of the other receptacles or install a GFCI breaker in the distribution box(electrical panel)."},{"checked":false,"id":1,"is_red":false,"text":"The majority of grounded receptacles , were tested and found to be wired correctly."},{"checked":false,"id":1,"is_red":false,"text":"Loose receptacle outlet to left of entrance door."},{"checked":false,"id":1,"is_red":false,"text":"Surface mount wiring in the bedroom- an outlet box has become loose and needs to be re affixed to the wall."},{"checked":false,"id":1,"is_red":false,"text":"Missing switch plate covers were found, make sure they are replaced."},{"checked":false,"id":1,"is_red":false,"text":"Worn switches noted."},{"checked":false,"id":1,"is_red":false,"text":"Worn outlets noted."},{"checked":false,"id":1,"is_red":false,"text":"Outlet cover plates missing."},{"checked":false,"id":1,"is_red":false,"text":"Switch cover plates missing."},{"checked":false,"id":1,"is_red":false,"text":"Loose outlets noted."},{"checked":false,"id":1,"is_red":false,"text":"Loose switches noted."},{"checked":false,"id":1,"is_red":false,"text":"All original knob and tube wiring appears to have been removed."},{"checked":false,"id":1,"is_red":false,"text":"A low voltage alarm system and a low voltage intercom system are installed. Due to the specialized nature of these systems, we suggest that you review these systems with the seller. As per our Inspection Agreement, these systems are beyond the scope of this report and were not inspected."},{"checked":false,"id":1,"is_red":false,"text":"A low voltage alarm system is installed. Due to the specialized nature of these systems, we suggest that you review this system with the seller. As per our Inspection Agreement, this system is beyond the scope of this report and was not inspected."},{"checked":false,"id":1,"is_red":false,"text":"A low voltage intercom system is installed. Due to the specialized nature of these systems, we suggest that you review this system with the seller. As per our Inspection Agreement, this system is beyond the scope of this report and was not inspected."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum wiring is now a concern with insurance companies due to fire risk.  Buyer is urged to confirm insurability and any related conditions that insurance company may place on this house.  Further inspection of this system may be required.  The inspector CANNOT ensure compliance of this electrical system for insurance purposes."},{"checked":false,"id":1,"is_red":false,"text":"Dimming lights were observed, this may be an indication of inadequate electrical distribution. We recommend review by a licensed electrician for evaluation and redistribution as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Improper use of extension cord observed. Extension cords should not be permanently installed or be routed through walls, floors or partitions."},{"checked":false,"id":1,"is_red":false,"text":"Insulation has been installed over knob and tube wiring at various locations. This is a fire \"Safety Concern\". Suggest review by a licensed electrician prior to closing to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Knob and tube wiring was observed in this home. This type of wiring was standard at the time of construction, and unless otherwise noted, appears to be in serviceable condition."},{"checked":false,"id":1,"is_red":false,"text":"Missing cover plates observed, suggest installing for safety."},{"checked":false,"id":1,"is_red":false,"text":"Open junction boxes were observed, which is a safety concern. Recommend installing proper covers, as needed, for safety."},{"checked":false,"id":1,"is_red":false,"text":"Recommend full review by qualified electrical contractor for quotes on upgrades/repair to ensure safe and adequate service."},{"checked":false,"id":1,"is_red":false,"text":"Reversed polarity, hot and neutral reversed and other terms used for electric receptacles are usually easily corrected by minor wiring adjustments at the specified item. When these conditions are noted in this report, a licensed electrician should be consulted for repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Since ungrounded receptacles were noted in the home, buyer is cautioned that proper grounding is strongly urged where sensitive electronic equipment is used.  Ungrounded receptacles do not offer protection for computers etc.  Consultation with a qualified electrical contractor is recommended."},{"checked":false,"id":1,"is_red":false,"text":"Ungrounded receptacles observed at water sources or exterior locations ideally should be grounded, suggest installing GFCI's for safety."},{"checked":false,"id":1,"is_red":false,"text":"Third floor sink, located outside of bathroom has a receptacle in close proximity that is not GFCI receptacle. Have a qualified electrician replace existing outlet with a GFCI receptacle. "},{"checked":false,"id":1,"is_red":false,"text":"Missing smoke detector in hallway."}],"sepChoice":"4","title":"Electrical"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Electrical Overall"}],"title":"Electrical"},{"damage_panels":[{"descr":"","id":2010,"options":[{"checked":false,"id":1,"is_red":false,"text":"No security bars are present in this room."},{"checked":false,"id":1,"is_red":false,"text":"The security bars were operated and appeared functional."},{"checked":false,"id":1,"is_red":false,"text":"The security bars did not operate, this is not to building standards."},{"checked":false,"id":1,"is_red":false,"text":"The security bars are missing hardware, compromising their effective usage."},{"checked":false,"id":1,"is_red":false,"text":"The security bars were bent and appeared to not function properly."},{"checked":false,"id":1,"is_red":false,"text":"The security bars were rusted and appeared to not function properly."}],"sepChoice":"4","title":"Security Bars"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Security Bars Overall"}],"title":"Security Bars"},{"damage_panels":[{"descr":"","id":2013,"options":[{"checked":false,"id":1,"is_red":false,"text":"**SMOKE DETECTORS**"},{"checked":false,"id":1,"is_red":false,"text":"Operated when tested."},{"checked":false,"id":1,"is_red":false,"text":"Testing of smoke detectors is not included in this inspection.  Pushing the \"Test\" button only verifies that there is power at the detector--either a battery or hard wired to the house power--and not the operational workings of the detector. The operational check is done by filling the sensor with smoke and is beyond the scope of this inspection. Battery operated smoke alarms should be checked routinely and the batteries changed frequently. "},{"checked":false,"id":1,"is_red":false,"text":"MAINTENANCE: Periodic testing and changing batteries yearly to ensure proper Smoke Alarm operation is required."},{"checked":false,"id":1,"is_red":false,"text":"The smoke alarm(s) did not operate when tested.  "},{"checked":false,"id":1,"is_red":false,"text":"SAFETY CONCERN: The smoke alarm(s) did not operate when tested. You need to be alerted in case of a fire. Recommend repair or replacement of the smoke alarm."},{"checked":false,"id":1,"is_red":false,"text":"There were no visible smoke detectors. "},{"checked":false,"id":1,"is_red":false,"text":"SAFETY CONCERN: There are no visible smoke detectors. You need to be alarmed in case of a fire. Recommend installing at least one smoke detector on each level of the home.  "},{"checked":false,"id":1,"is_red":false,"text":"Not secured properly."},{"checked":false,"id":1,"is_red":false,"text":"Old detectors. Smoke detectors last 6-10 years. Recommend replacing."},{"checked":false,"id":1,"is_red":false,"text":"The smoke alarm battery needs to be replaced. Location:"},{"checked":false,"id":1,"is_red":false,"text":"The smoke detector is in a Poor location and does not provide adequate protection."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE: Recommend installing one in each bedroom to bring up to  modern safety standards"},{"checked":false,"id":1,"is_red":false,"text":"Smoke detector missing in upper level ceiling. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Several smoke detectors missing battery. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Without a working smoke detector in your home you have no first alert to a possible fire."},{"checked":false,"id":1,"is_red":false,"text":"**CARBON MONOXIDE DETECTORS**"},{"checked":false,"id":1,"is_red":false,"text":"SAFETY INFO: Carbon Monoxide (CO) is a lethal gas--invisible,tasteless, odorless--produced in normal amounts whenever you use an appliance which burns a combustible fuel--gas, oil, kerosene, charcoal, and wood. When proper ventilation becomes blocked or inadequate, CO concentrations build up inside your home and become deadly."},{"checked":false,"id":1,"is_red":false,"text":"IMPROVE:  There was no visible CO (Carbon Monoxide) detector(s) in the home. The Consumer Product Safety Commission recommends that every residence with fuel-burning (gas) appliances be equipped with a UL Listed CO alarm. CO is colorless and odorless and thus impossible to detect without a proper electronic detector. At a minimum, put an alarm near the sleeping rooms on each level in your home. For the most trouble-free operation, I recommend the plug-in type -- not the battery operated type -- with digital readout that tells you the peak CO concentration whenever you push the peak level button."},{"checked":false,"id":1,"is_red":false,"text":"The carbon monoxide detector did not sound off the alarm when tested. Install a new battery and test monthly."},{"checked":false,"id":1,"is_red":false,"text":"CO detector did not operate when tested."}],"sepChoice":"4","title":"Smoke Detectors"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Smoke Detectors Overall"}],"title":"Smoke Detectors"},{"damage_panels":[{"descr":"","id":2014,"options":[{"checked":false,"id":1,"is_red":false,"text":"Wrought iron stair railings noted."},{"checked":false,"id":1,"is_red":false,"text":"Unfinished masonry walls along sides of stairs."},{"checked":false,"id":1,"is_red":false,"text":"Basement stairwell - spindles are over 4 inches wide, dangerous to children."},{"checked":false,"id":1,"is_red":false,"text":"Need guard rails installed at opening or stairs to attic."},{"checked":false,"id":1,"is_red":false,"text":"The stair tread depth is under 10 inches."},{"checked":false,"id":1,"is_red":false,"text":"Stair riser height-- over 7 3/4 inches ( but at least 4 inches)."},{"checked":false,"id":1,"is_red":false,"text":"A handrail is MISSING."},{"checked":false,"id":1,"is_red":false,"text":"Lighting is NOT INSTALLED."},{"checked":false,"id":1,"is_red":false,"text":"The walking surface has more than a 2 degree slope."},{"checked":false,"id":1,"is_red":false,"text":"Stairway leading to top floors  - first hand rail is detached from wall, and the first spindle is loose; have a contractor evaluate."},{"checked":false,"id":1,"is_red":false,"text":"There are openings on the left of the basement stairs. Have a contractor evaluate the construction of the basement stairs."},{"checked":false,"id":1,"is_red":false,"text":"Stairs are partially covered in carpeting."},{"checked":false,"id":1,"is_red":false,"text":"Steps to finished attic covered in carpeting."},{"checked":false,"id":1,"is_red":false,"text":"The stair wells in the home can be considered narrow by current standards"},{"checked":false,"id":1,"is_red":false,"text":"Incomplete installation of lights on several risers on basement stairway steps."},{"checked":false,"id":1,"is_red":false,"text":"Missing handrails for stairs to basement and also missing on stairs to attic."},{"checked":false,"id":1,"is_red":false,"text":"The opening between spindles is over 4 inches wide ."},{"checked":false,"id":1,"is_red":false,"text":"Upstairs handrail extremely loose."},{"checked":false,"id":1,"is_red":false,"text":"Guard rail and spindles at top of stairs are extremely loose."},{"checked":false,"id":1,"is_red":false,"text":"Handrail is not 1.5 inches from wall."},{"checked":false,"id":1,"is_red":false,"text":"Handrail should not project more than 4.5 inches from wall."},{"checked":false,"id":1,"is_red":false,"text":"Basement stairwell leading down - very makeshift amateurish addition of hand rail and side guards; have a contractor evaluate. see pictures."},{"checked":false,"id":1,"is_red":false,"text":"Stairway leading to top floor - the short,first hand rail is detached from wall, and the first spindle is loose; have a contractor evaluate."},{"checked":false,"id":1,"is_red":false,"text":"It appears the home owner was attempting to address issues with the basement stairs, but the work was not professional by any means. Have a contractor evaluate."},{"checked":false,"id":1,"is_red":false,"text":"Basement stairwell - spindles are over 4 inches wide, dangerous to children"},{"checked":false,"id":1,"is_red":false,"text":"Safety issue - There is no guard rail around the opening for the stairs in the finished attic, this could cause a serious fall."}],"sepChoice":"4","title":"Stairs & Handrail"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Stairs & Handrail Overall"}],"title":"Stairs"},{"damage_panels":[{"descr":"","id":2016,"options":[{"checked":false,"id":1,"is_red":false,"text":"Did not operate the window air conditioning unit. Operation of this type of unit is beyong the scope of this inspection."},{"checked":false,"id":1,"is_red":false,"text":"The wall heater is a worn unit possibly beyond it's useful life."},{"checked":false,"id":1,"is_red":false,"text":"The wall heater is missing it's cover. We recommend contacting the seller for replacement of the cover."},{"checked":false,"id":1,"is_red":false,"text":"Heating unit was unplugged with no available power nearby, did not test."},{"checked":false,"id":1,"is_red":false,"text":"Heating/AC unit is missing control knobs. Consult with the seller for possible replacement."},{"checked":false,"id":1,"is_red":false,"text":"The units airflow was not cold, recommend servicing the unit."},{"checked":false,"id":1,"is_red":false,"text":"The units airflow was not warm, recommend servicing the unit."},{"checked":false,"id":1,"is_red":false,"text":"The combination heater/ ac unit was not secured properly in the wall. We recommend contacting a qualified contractor to re-secure the unit."},{"checked":false,"id":1,"is_red":false,"text":"The combination heater/ ac unit was making an irregular noise. We recommend contacting a qualified contractor to service the unit."},{"checked":false,"id":1,"is_red":false,"text":"The inspector could not access the unit due to stored personal items in the way."},{"checked":false,"id":1,"is_red":false,"text":"There is a swamp cooler present and not tested by inspector."}],"sepChoice":"4","title":"Window-Wall AC or Heat"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Window-Wall AC or Heat Overall"}],"title":"Window/Wall AC/Heat"},{"damage_panels":[{"descr":"","id":2224,"options":[{"checked":false,"id":1,"is_red":false,"text":"Small cracking in the wall finish is noted. This is probably caused by the joint compound (spackle) drying too quickly during application. "},{"checked":false,"id":1,"is_red":false,"text":"Minor damage from what appears to be excess moisture. Recommend review of current vent fan and possibly installing a timer to assure that fan is used during showers."},{"checked":false,"id":1,"is_red":false,"text":"The drywall is patched in areas. The reason for the patch could not be determined. "},{"checked":false,"id":1,"is_red":false,"text":"Small stains noted on the ceiling. They tested dry at the time of the inspection."},{"checked":false,"id":1,"is_red":false,"text":"Large stains noted on the ceiling. They tested dry at the time of the inspection."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of past leaking was noted."},{"checked":false,"id":1,"is_red":false,"text":"There were signs of paint blistering on the ceiling. The areas tested dry at the time of the inspection, but should be monitored for further damage or possibly water intrusion."},{"checked":false,"id":1,"is_red":false,"text":"The inspector could not access the area around the skylight."},{"checked":false,"id":1,"is_red":false,"text":"Visible leaking noted on the ceiling. We recommend contacting a qualified contractor to evaluate the roof and the drywall in this area and repair as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Freshly painted in areas. This could be concealing a defect that could not be determined."},{"checked":false,"id":1,"is_red":false,"text":"Mold like stains present on the ceiling. We recommend having a mold sample taken and lab tested, also monitor the area for water intrusion."},{"checked":false,"id":1,"is_red":false,"text":"There is a damaged ceiling tile in dining room - damage is between crown molding and tile in form of a puncture of sorts. see pic."},{"checked":false,"id":1,"is_red":false,"text":"Extensive water damage to general area of ceiling where the past leaking had occurred. Areas are marked with peeling paint and bulging drywall. Have a contractor evaluate."},{"checked":false,"id":1,"is_red":false,"text":"There is an anomaly present at the point in the ceiling that adjoins the inner wall. It appears there is a bowing / sagging in the corner. It is not clear as to what may have caused this. Ask association about this issue and about past occurrences that may be linked to this issue."},{"checked":false,"id":1,"is_red":false,"text":"The ceiling was not painted all the way to the edge in kitchen."},{"checked":false,"id":1,"is_red":false,"text":"The drywall installation is not entirely professional quality, have a contractor evaluate."}],"sepChoice":"4","title":"Ceiling Condition"}],"inspection_panels":[{"descr":"","id":3072,"options":[{"checked":false,"id":1,"is_red":false,"text":"There are drywall ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"There are plaster ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"There are acoustic grid and tile ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"There are wood plank ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"There are metal pan ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"Open beam ceiling construction noted."},{"checked":false,"id":1,"is_red":false,"text":"There is panel lighting present in the ceiling."},{"checked":false,"id":1,"is_red":false,"text":"The ceilings are clad in wood paneling."},{"checked":false,"id":1,"is_red":false,"text":"Cathedral style (vaulted) ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"Mirror panels are noted on the ceilings."},{"checked":false,"id":1,"is_red":false,"text":"The ceilings are clad in cork."},{"checked":false,"id":1,"is_red":false,"text":"The ceilings are clad in a laminate material."},{"checked":false,"id":1,"is_red":false,"text":"The ceilings are clad in tile squares."}],"sepChoice":"1","title":"Ceilings"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Ceiling Condition Overall"}],"title":"Ceilings"},{"damage_panels":[{"descr":"","id":2239,"options":[{"checked":false,"id":1,"is_red":false,"text":"**Sliding Patio Doors**"},{"checked":false,"id":1,"is_red":false,"text":"There are no patio doors present in this room."},{"checked":false,"id":1,"is_red":false,"text":"The sliding patio door was functional during the inspection."},{"checked":false,"id":1,"is_red":false,"text":"The hinged patio door was functional during the inspection."},{"checked":false,"id":1,"is_red":false,"text":"The doors hardware is showing signs of wear and may be at the end of its useful life. We recommend budgeting for replacement."},{"checked":false,"id":1,"is_red":false,"text":"The sliding door tracks appeared dirty at the inspection making the door difficult to operate. We recommend cleaning the tracks and lubricating the doors rollers."},{"checked":false,"id":1,"is_red":false,"text":"Tempered glass noted in the patio door."},{"checked":false,"id":1,"is_red":false,"text":"Door is difficult to operate, this presents a safety hazard in the event of an emergency/fire. Recommend repair/adjusting of door by a Qualified Contractor to allow easy and smooth operation. Current building standards require this second means of egress in a sleeping area for quick escape in the event of an emergency."},{"checked":false,"id":1,"is_red":false,"text":"One or more sliding door/s shows sign of loss of seal/condensation, recommend repair or replace by Qualified Contractors, to provide energy savings and prevent hazed window from limiting view out of window. "},{"checked":false,"id":1,"is_red":false,"text":"Sliding glass door is installed backwards/inside out."},{"checked":false,"id":1,"is_red":false,"text":"**Hinged Patio Doors**"},{"checked":false,"id":1,"is_red":false,"text":"The patio door did not lock.\r\n"},{"checked":false,"id":1,"is_red":false,"text":"The patio door did not latch."},{"checked":false,"id":1,"is_red":false,"text":"Tempered glass noted in the patio door."},{"checked":false,"id":1,"is_red":false,"text":"The doors hardware is showing signs of wear and may be at the end of its useful life. We recommend budgeting for replacement."},{"checked":false,"id":1,"is_red":false,"text":"Frame is separating from glass."},{"checked":false,"id":1,"is_red":false,"text":"The inspector can not determine if tempered glass is in the door."}],"sepChoice":"4","title":"Patio Doors"},{"descr":"","id":2240,"options":[{"checked":false,"id":1,"is_red":false,"text":"Not installed, recommend installation and confirmation of proper screen door operation."},{"checked":false,"id":1,"is_red":false,"text":"Sliding door screen is missing/damaged."},{"checked":false,"id":1,"is_red":false,"text":"Sliding door screen is functional."},{"checked":false,"id":1,"is_red":false,"text":"Sliding door screen tracks are dirty making the door difficult to operate. Recommend cleaning the tracks out."},{"checked":false,"id":1,"is_red":false,"text":"The sliding screen door has worn hardware and may be at the end of its useful life. Recommend budgeting for replacement."},{"checked":false,"id":1,"is_red":false,"text":"Security screen door present."},{"checked":false,"id":1,"is_red":false,"text":"Sliding screen door is torn and is difficult to operate."},{"checked":false,"id":1,"is_red":false,"text":"Sliding screen door is difficult to operate."},{"checked":false,"id":1,"is_red":false,"text":"Sliding screen door is off the tracks."},{"checked":false,"id":1,"is_red":false,"text":"Sliding screen door is bent."},{"checked":false,"id":1,"is_red":false,"text":"Sliding screen door is missing hardware."},{"checked":false,"id":1,"is_red":false,"text":"Broken latch on the sliding screen door."}],"sepChoice":"4","title":"Screen Doors"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Patio Doors Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Screen Doors Overall"}],"title":"Patio Doors"},{"damage_panels":[{"descr":"","id":2241,"options":[{"checked":false,"id":1,"is_red":false,"text":"Some areas not accessible due to stored personal items."},{"checked":false,"id":1,"is_red":false,"text":"There is evidence of moisture entering structure. We recommend contacting a contractor experienced in exterior systems to evaluate the area and suggest repair options."},{"checked":false,"id":1,"is_red":false,"text":"Loose wall paneling is noted."},{"checked":false,"id":1,"is_red":false,"text":"There are loose mirrors noted."},{"checked":false,"id":1,"is_red":false,"text":"There is loose wall paper noted."},{"checked":false,"id":1,"is_red":false,"text":"There are areas still under construction. These areas are not tested."},{"checked":false,"id":1,"is_red":false,"text":"Missing drywall noted."},{"checked":false,"id":1,"is_red":false,"text":"Mold like stains are present under sink. We recommend having a mold sample taken and lab tested."},{"checked":false,"id":1,"is_red":false,"text":"Vacuum system present, not tested consult owner."},{"checked":false,"id":1,"is_red":false,"text":"Loose baseboards in areas, these are easily re-secured with a hammer ad some 6-D finish nails."},{"checked":false,"id":1,"is_red":false,"text":"Mold-like bio growth observed. Professional testing & evaluation advised."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of repairs observed, unable to determine the effectiveness of these repairs."},{"checked":false,"id":1,"is_red":false,"text":"Limited review due to storage of personal property and finished walls."},{"checked":false,"id":1,"is_red":false,"text":"Walls have been recently painted."},{"checked":false,"id":1,"is_red":false,"text":"There were signs of past water damage to baseboard and paneling; however, no active moisture was detected during the inspection."}],"sepChoice":"4","title":"Wall Condition"}],"inspection_panels":[{"descr":"","id":3078,"options":[{"checked":false,"id":1,"is_red":false,"text":"Drywall walls noted."},{"checked":false,"id":1,"is_red":false,"text":"Plaster walls noted."},{"checked":false,"id":1,"is_red":false,"text":"Wall paper finish noted."},{"checked":false,"id":1,"is_red":false,"text":"Painted finish noted."},{"checked":false,"id":1,"is_red":false,"text":"Walls are clad in paneling."},{"checked":false,"id":1,"is_red":false,"text":"Mirror panels are noted."},{"checked":false,"id":1,"is_red":false,"text":"The walls are clad in wood plank material. "},{"checked":false,"id":1,"is_red":false,"text":"There is a brick veneer noted."},{"checked":false,"id":1,"is_red":false,"text":"There is a stone veneer noted."},{"checked":false,"id":1,"is_red":false,"text":"Walls are clad in a laminate material."},{"checked":false,"id":1,"is_red":false,"text":"Walls are clad in granite panels."},{"checked":false,"id":1,"is_red":false,"text":"Cork finish noted."},{"checked":false,"id":1,"is_red":false,"text":"Walls are clad in ceramic tile."}],"sepChoice":"1","title":"Walls"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Wall Condition Overall"}],"title":"Walls"},{"damage_panels":[{"descr":"","id":2242,"options":[{"checked":false,"id":1,"is_red":false,"text":"**Wood Fireplaces**"},{"checked":false,"id":1,"is_red":false,"text":"The fireplace damper is damaged and not functional; The lever will not open or close the damper correctly. Do not attempt to start a fire until corrected."},{"checked":false,"id":1,"is_red":false,"text":"Damper was opened and closed several times."},{"checked":false,"id":1,"is_red":false,"text":"Level II inspection—The National Fire Protection Association (www.nfpa.org) advises that each chimney receive a Level II inspection each time a residence is sold. Inspection levels are explained at www.csia.org/pressroom/press-inspection-levels-explained.htm. It is also advised that this inspection be conducted by a chimney sweep certified by the Chimney Safety Institute of America (www.csia.org)."},{"checked":false,"id":1,"is_red":false,"text":"Several wood burning fireplaces with gas lighters- these should not be uses like a gas fireplace constantly on, they are for lighting wood logs. NOT TO BE USED WITH CERAMIC GAS LOGS."},{"checked":false,"id":1,"is_red":false,"text":"The room contains a vent free type of fireplace. It should not be operated for more than 2-4 hours at a time because of the inherent CO poisoning possibility."},{"checked":false,"id":1,"is_red":false,"text":"The fireplace front/screen assembly is not affixed to the opening of the chimney. have a fireplace professional evaluate and repair any issues as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Have a fireplace professional evaluate and repair any issues found before attempting to use fireplace."},{"checked":false,"id":1,"is_red":false,"text":"Ventless gas fireplace assembly enclosure."},{"checked":false,"id":1,"is_red":false,"text":"It was observed that some of the mortar around the firebox was failing; have a qualified individual evaluate and repair to avoid possible safety issue."},{"checked":false,"id":1,"is_red":false,"text":"The hearth extention appears to have an inadequate minimum clearance; should be minimum 16 inches in front and 8 inches on sides."},{"checked":false,"id":1,"is_red":false,"text":"Hearth Extension Dimensions - Hearth extensions shall extend at least 16 inches (406mm) in front of and at least 8 inches (203mm) beyond each side of the fireplace opening."},{"checked":false,"id":1,"is_red":false,"text":"The Fireplace mantle does not appear to be treated in any way and may be a fire hazard. Have a fireplace professional evaluate and repair any issues found before attempting to use the fireplace."},{"checked":false,"id":1,"is_red":false,"text":"**Gas Fireplaces**"},{"checked":false,"id":1,"is_red":false,"text":"The gas line is capped."},{"checked":false,"id":1,"is_red":false,"text":"Have a gas fireplace professional service/evaluate fireplace before operating."},{"checked":false,"id":1,"is_red":false,"text":"Have chimneys swept by professional."},{"checked":false,"id":1,"is_red":false,"text":"Fireplace in patterned wallpaper den is vent less and should not be used over 4 hours due to possibility of CO poisoning."},{"checked":false,"id":1,"is_red":false,"text":"Master bedroom fireplace is not venting correctly."},{"checked":false,"id":1,"is_red":false,"text":"Functional."},{"checked":false,"id":1,"is_red":false,"text":"Make sure to get owner manuals for gas fireplace assembly."},{"checked":false,"id":1,"is_red":false,"text":"The fireplace appears to be in fair visual condition. Was operated and observed as functional during inspection."},{"checked":false,"id":1,"is_red":false,"text":"Wood was being burned in this GAS FIREPLACE."},{"checked":false,"id":1,"is_red":false,"text":"Small cracks present."},{"checked":false,"id":1,"is_red":false,"text":"Could not fully inspect due to accumulation of ash."},{"checked":false,"id":1,"is_red":false,"text":"There was a flex line in the firebox."}],"sepChoice":"4","title":"Fireplace"}],"inspection_panels":[{"descr":"","id":3079,"options":[{"checked":false,"id":1,"is_red":false,"text":"Living Room"},{"checked":false,"id":1,"is_red":false,"text":"Family Room"},{"checked":false,"id":1,"is_red":false,"text":"Dining Room"},{"checked":false,"id":1,"is_red":false,"text":"Bedroom"},{"checked":false,"id":1,"is_red":false,"text":"Kitchen"},{"checked":false,"id":1,"is_red":false,"text":"Bathroom"},{"checked":false,"id":1,"is_red":false,"text":"Patio Area"},{"checked":false,"id":1,"is_red":false,"text":"Bonus Room"},{"checked":false,"id":1,"is_red":false,"text":"Bathroom"},{"checked":false,"id":1,"is_red":false,"text":"Den"},{"checked":false,"id":1,"is_red":false,"text":"Study"},{"checked":false,"id":1,"is_red":false,"text":"Library"},{"checked":false,"id":1,"is_red":false,"text":"Master"},{"checked":false,"id":1,"is_red":false,"text":"Theater Room"},{"checked":false,"id":1,"is_red":false,"text":"Guest House"}],"sepChoice":"1","title":"Fireplace Locations"},{"descr":"","id":3080,"options":[{"checked":false,"id":1,"is_red":false,"text":"Masonry fireplace noted."},{"checked":false,"id":1,"is_red":false,"text":"Prefabricated \"zero clearance\" fireplace noted."},{"checked":false,"id":1,"is_red":false,"text":"Pot belly style wood burning stove noted."},{"checked":false,"id":1,"is_red":false,"text":"Free standing style wood burning stove noted."},{"checked":false,"id":1,"is_red":false,"text":"Decorative electric fireplace noted. This is not inspected."}],"sepChoice":"1","title":"Fireplace Materials"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Fireplace Overall"}],"title":"Fireplaces"},{"damage_panels":[{"descr":"","id":2273,"options":[{"checked":false,"id":1,"is_red":false,"text":"Deterioration noted due to contact with moisture, repairs needed."},{"checked":false,"id":1,"is_red":false,"text":"Shower area's are a poor location for a window, recommend removal due to potential issues in the future."},{"checked":false,"id":1,"is_red":false,"text":"One or more window/s shows sign of loss of seal/condensation, recommend repair or replace to provide energy savings and prevent hazed window from limiting view out of window. "},{"checked":false,"id":1,"is_red":false,"text":"One or more windows did not lock/latch properly, recommend repairs for enhanced security/safety to occupants."},{"checked":false,"id":1,"is_red":false,"text":"Broken/cracked glass pane noted, repairs needed."},{"checked":false,"id":1,"is_red":false,"text":"hardware difficult to operate at one or more locations. Recommend review and repair as needed by qualified window contractors"},{"checked":false,"id":1,"is_red":false,"text":"In the event of an emergency it appears that the windows could cause an issue of quick egress due to the windows are difficult to open for a small child for escape. Recommend review and repair to allow easy exit in the event of an emergency situation."},{"checked":false,"id":1,"is_red":false,"text":"Single pane windows observed, recommend budgeting for replacement for added efficiency of home"},{"checked":false,"id":1,"is_red":false,"text":"Broken glazing observed, suggest re-glazing as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Broken sash wire/cord observed on window frame. This is a \"Safety Concern\". Sash wire/cord holds window in open position. Suggest repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Damaged screens observed."},{"checked":false,"id":1,"is_red":false,"text":"Deterioration of wooden frames noted.  While basic maintenance may prolong the life of these window frames, replacement may be necessary at some point.  "},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the windows/frames are near the end of their useful life."},{"checked":false,"id":1,"is_red":false,"text":"Peeling paint observed, suggest scraping and painting as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Fog/condensation observed in thermopane windows. This is an indication of a failed seal. Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl crank out style windows with locks."},{"checked":false,"id":1,"is_red":false,"text":"Painted wood windows possibly creating lead dust from friction on paint. "},{"checked":false,"id":1,"is_red":false,"text":"Metal \"double hung\" type with locks."},{"checked":false,"id":1,"is_red":false,"text":"Severe damage--\nSome vinyl windows in the home had severe damage visible at the time of the inspection. You may wish to get estimates for repair before the expiration of your Inspection Objection Deadline.\n"},{"checked":false,"id":1,"is_red":false,"text":"Minor damage--\nSome vinyl windows in the home had minor damage visible at the time of the inspection.\n"},{"checked":false,"id":1,"is_red":false,"text":"Some of the windows are difficult to lock."},{"checked":false,"id":1,"is_red":false,"text":"The upstairs crank out window facing front of home appears to be missing some minor hardware & a screen."},{"checked":false,"id":1,"is_red":false,"text":"The home is fitted with vinyl windows."},{"checked":false,"id":1,"is_red":false,"text":"Some windows are very difficult to open and some were not able to open, this may be because of the paint."},{"checked":false,"id":1,"is_red":false,"text":"In accordance with ASHI Standards, we do not test every window in the house, and particularly if it is furnished. We do test every unobstructed window in every bedroom to ensure that at least one provides and emergency exit."},{"checked":false,"id":1,"is_red":false,"text":"Highly recommend operating all windows during final walk through inspection."},{"checked":false,"id":1,"is_red":false,"text":"Operated windows appeared functional, at time of inspection"},{"checked":false,"id":1,"is_red":false,"text":"The windows that were tested, are functional."},{"checked":false,"id":1,"is_red":false,"text":"Broken sash wire/cord observed on window frame. This is a \"Safety Concern\". Sash wire/cord holds window in open position. Suggest repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Damaged/Missing sash cords"},{"checked":false,"id":1,"is_red":false,"text":"Damaged screens observed."},{"checked":false,"id":1,"is_red":false,"text":"Missing screens observed at @@LOCATION@@."},{"checked":false,"id":1,"is_red":false,"text":"Damage tilt-out feature locking clips at @@LOCATION@@. Window is still functional. FYI"},{"checked":false,"id":1,"is_red":false,"text":"Damage/missing hardware at @@LOCATION@@. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Torn screen(s)"},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the windows/frames are near the end of their useful life."},{"checked":false,"id":1,"is_red":false,"text":"Peeling paint observed, suggest scraping and painting as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Cloudiness/condensation observed in @@NUMBER@@ of thermopane double glazed windows in @@LOCATION@@. This is an indication of a failed seal. A qualified contractor should review for replacement as needed."},{"checked":false,"id":1,"is_red":false,"text":"Cracked or broken window glass was observed. Injury could occur. Recommend repair or replacement of the damaged glass."},{"checked":false,"id":1,"is_red":false,"text":"Cracked window pane in @@LOCATION@@. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Improve:  Install glass block basement windows with vents. This type of window allows in more light, ventilation, added security and reduces the risks of moisture intrusion."},{"checked":false,"id":1,"is_red":false,"text":"DEFERRED COST: Windows are original, older type. Consider upgrading to double pane, thermally insulated, newer efficient type."},{"checked":false,"id":1,"is_red":false,"text":"Some windows did not open when tested. Recommend  all windows reviewed for proper operation during walkthrough inspection prior to closing"},{"checked":false,"id":1,"is_red":false,"text":"A representative number of windows were inspected. Most did not open when tested -- appears painted wood frames have sealed seams. Recommend  all windows be reviewed for proper operation during final walkthrough inspection."},{"checked":false,"id":1,"is_red":false,"text":"Improve: Install glass block basement windows."},{"checked":false,"id":1,"is_red":false,"text":"All accessible windows operated"},{"checked":false,"id":1,"is_red":false,"text":"Family room window, to the left of fireplace, does not lock with either latch.  Needs repair - for security reasons due to being at ground level."},{"checked":false,"id":1,"is_red":false,"text":"Mold-like bio growth observed. Professional testing & evaluation advised."},{"checked":false,"id":1,"is_red":false,"text":"There are older wood windows present."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl crank out style windows with locks."},{"checked":false,"id":1,"is_red":false,"text":"Painted wood windows possibly creating lead dust from friction on paint. "},{"checked":false,"id":1,"is_red":false,"text":"Metal \"double hung\" type with locks."},{"checked":false,"id":1,"is_red":false,"text":"Severe damage--\nSome vinyl windows in the home had severe damage visible at the time of the inspection. You may wish to get estimates for repair before the expiration of your Inspection Objection Deadline.\n"},{"checked":false,"id":1,"is_red":false,"text":"Minor damage--\nSome vinyl windows in the home had minor damage visible at the time of the inspection.\n"},{"checked":false,"id":1,"is_red":false,"text":"The windows in the home are rope and pulley style, may be original to home, and are approaching the end of their serviceable lifetime."},{"checked":false,"id":1,"is_red":false,"text":"Screens were not installed at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Broken sash wire/cord observed on window frame. This is a \"Safety Concern\". Sash wire/cord holds window in open position. Suggest repairs/replacement as needed to ensure safety."}],"sepChoice":"4","title":"Window Condition"}],"inspection_panels":[{"descr":"","id":3092,"options":[{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed casement window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Stationary(fixed) window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed casement window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed casement window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Garden style window noted."},{"checked":false,"id":1,"is_red":false,"text":"Bay type window noted."},{"checked":false,"id":1,"is_red":false,"text":"Bow type window noted."},{"checked":false,"id":1,"is_red":false,"text":"Glass blocks noted in window openings."},{"checked":false,"id":1,"is_red":false,"text":"Non-insulated glass noted."},{"checked":false,"id":1,"is_red":false,"text":"Insulated glass noted."}],"sepChoice":"1","title":"Windows"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Window Condition Overall"}],"title":"Windows"}],"title":"Interior Areas"},{"id":16,"tabbed_panels":[{"damage_panels":[{"descr":"","id":2054,"options":[{"checked":false,"id":1,"is_red":false,"text":"Most not accessible due to stored personal items."},{"checked":false,"id":1,"is_red":false,"text":"No deficiencies observed."},{"checked":false,"id":1,"is_red":false,"text":"No deficiencies observed on all kitchen cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Appeared functional and in satisfactory condition, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Recommend adding additional cabinet screws as drywall screws have been used."},{"checked":false,"id":1,"is_red":false,"text":"Loose at wall. Needs immediate attention. "},{"checked":false,"id":1,"is_red":false,"text":"DEFERRED COST:  The cabinets are original. Consider upgrade."},{"checked":false,"id":1,"is_red":false,"text":"Appeared functional at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Mold-like bio growth observed inside vanity at powder room, bathroom #3.  Evidence of a prior leak in the sink drain trap. Professional testing & evaluation advised."},{"checked":false,"id":1,"is_red":false,"text":"Some cabinet doors need magnets or hardware to stay shut. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Some cabinet drawers  need  hardware repair/adjustment (to stay shut). Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Drawers are difficult to slide. It appears that if the guides are lubricated, that will correct the problem."},{"checked":false,"id":1,"is_red":false,"text":"Broken drawer guides noted. Recommend having a qualified contractor replace the guides."},{"checked":false,"id":1,"is_red":false,"text":"Noted cabinet(s) loose on the wall. Recommend having a qualified contractor re-fasten the cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Noted cabinet(s) loose at the floor. Recommend having a qualified contractor re-fasten the cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Noted cabinet(s) loose at the ceiling. Recommend having a qualified contractor re-fasten the cabinets."},{"checked":false,"id":1,"is_red":false,"text":"There appears to be water damage under sink. This tested dry at the time of the inspection, but monitor for any further intrusion."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors did not close completely."},{"checked":false,"id":1,"is_red":false,"text":"The door was locked to bathroom, could not access the room to inspect."},{"checked":false,"id":1,"is_red":false,"text":"The sliding cabinet doors were difficult to slide. It appears that lubrication will correct the problem."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors missing, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors missing hardware, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawers missing, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors have broken hinges, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawers missing handles, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawers off their guides, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors have loose hardware, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors missing knobs, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawer face is missing, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawer face is loose, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors have broken glass panels in them, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Drawer(s) bind in tracks."},{"checked":false,"id":1,"is_red":false,"text":"Drawer(s) unsupported in cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Shelving missing or damaged."},{"checked":false,"id":1,"is_red":false,"text":"Lazy Susan cabinet binds and does not turn smoothly."}],"sepChoice":"4","title":"Cabinets"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Cabinets Overall"}],"title":"Cabinets"},{"damage_panels":[{"descr":"","id":2056,"options":[{"checked":false,"id":1,"is_red":false,"text":"Plastic laminate tops noted."},{"checked":false,"id":1,"is_red":false,"text":"Solid Surface tops noted."},{"checked":false,"id":1,"is_red":false,"text":"Granite tops noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood counter tops noted."},{"checked":false,"id":1,"is_red":false,"text":"There is normal wear noted for the age of the counter tops."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops are stained. Normal cleaning should take care of this."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops appear to be worn and may have reached the end of their useful life."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops are noted as being chipped."},{"checked":false,"id":1,"is_red":false,"text":"No discrepancies noted."},{"checked":false,"id":1,"is_red":false,"text":"Some of the areas not visible due to stored personal items."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops appear to be loose on the cabinet. We recommend having a qualified contractor re-fasten them."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops are noted as having loose Formica. We recommend having a qualified contractor re-fasten it."},{"checked":false,"id":1,"is_red":false,"text":"Granite backsplash appears to not have been caulked when installed--except just behind sink.  Recommend sealing with clear silicone caulk along entire length of backsplash.  This prevents water leaks from spills and counter cleanups."},{"checked":false,"id":1,"is_red":false,"text":"Laminated countertop is swollen and beginning to blister @@lLOCATION@@. This is a cosmetic issue for your information. Repair as necessary."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops are noted as cracked or damaged."}],"sepChoice":"4","title":"Counters"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Counters Overall"}],"title":"Counters"},{"damage_panels":[{"descr":"","id":2057,"options":[{"checked":false,"id":1,"is_red":false,"text":"None present."},{"checked":false,"id":1,"is_red":false,"text":"Operated."},{"checked":false,"id":1,"is_red":false,"text":"The dishwasher did not operate when tested, consult with the seller about servicing the unit."},{"checked":false,"id":1,"is_red":false,"text":"The dishwasher appears to be a worn unit, and may have reached the end of its useful life."},{"checked":false,"id":1,"is_red":false,"text":"The dishwasher appears to be an older unit, and may have reached the end of its useful life."},{"checked":false,"id":1,"is_red":false,"text":"Lack of a proper air gap noted at dishwasher drain line. In the event of a sewer backup this device prevents sewer matter from entering into dishwasher. Recommend  having a qualified plumber install a air gap to prevent possible contamination."},{"checked":false,"id":1,"is_red":false,"text":"Unit is not properly fastened, recommend securing to countertop using the appropriate length screw to prevent tip from exiting top of counter causing damage."},{"checked":false,"id":1,"is_red":false,"text":"Dirty/mineral build up noted in unit, recommend cleaning."},{"checked":false,"id":1,"is_red":false,"text":"Kink in supply line observed, repair needed.\n"},{"checked":false,"id":1,"is_red":false,"text":"Dishwasher drain is upstream of the trap.  This is the proper positioning to ensure sewer gases do not enter the appliance should client choose to install dishwasher."},{"checked":false,"id":1,"is_red":false,"text":"Dishwasher is draining upstream of the trap.  This is the proper positioning to ensure sewer gases do not enter the appliance."},{"checked":false,"id":1,"is_red":false,"text":"Dishwasher operating upon arrival of inspector.  Buyer is advised that no warranty is offered on this or any other appliance, as outlined in Inspection Agreement."},{"checked":false,"id":1,"is_red":false,"text":"Dishwasher was not tested at time of inspection due to ."},{"checked":false,"id":1,"is_red":false,"text":"Dishwasher was operational at the time of inspection. Dishwashers most commonly fail internally at the pump, motor or seals. We do not disassemble these units to inspect these components. We recommend you operate this unit prior to closing."},{"checked":false,"id":1,"is_red":false,"text":"Future dishwasher should drain upstream of the trap.  This is the proper positioning to ensure sewer gases do not enter the appliance."},{"checked":false,"id":1,"is_red":false,"text":"Inspector could not confirm that dishwasher is draining upstream of the trap due to inaccessibility.  This is the proper positioning to ensure sewer gases do not enter the appliance."},{"checked":false,"id":1,"is_red":false,"text":"Installation is incomplete."},{"checked":false,"id":1,"is_red":false,"text":"No air gap present."},{"checked":false,"id":1,"is_red":false,"text":"No loop in drain line."},{"checked":false,"id":1,"is_red":false,"text":"Portable unit, did not test. Not within the scope of this inspection."},{"checked":false,"id":1,"is_red":false,"text":"Proper hook ups in place, ready for installation."},{"checked":false,"id":1,"is_red":false,"text":"Water was off at time of the inspection. Unable to determine the condition of the system and/or the function of plumbing fixtures. We recommend confirming proper operation of all plumbing appliances and fixtures prior to close."}],"sepChoice":"4","title":"Dishwasher"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Dishwasher Overall"}],"title":"Dishwasher"},{"damage_panels":[{"descr":"","id":2058,"options":[{"checked":false,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Door doesn't latch properly."},{"checked":false,"id":1,"is_red":false,"text":"Door binds in jamb or floor."},{"checked":false,"id":1,"is_red":false,"text":"Door damaged."},{"checked":false,"id":1,"is_red":false,"text":"Door missing."},{"checked":false,"id":1,"is_red":false,"text":"Door handle missing."},{"checked":false,"id":1,"is_red":false,"text":"Door handle loose."},{"checked":false,"id":1,"is_red":false,"text":"Pocket door does not latch or lock."},{"checked":false,"id":1,"is_red":false,"text":"Sliding Door(s) are not securely installed on tracks."},{"checked":false,"id":1,"is_red":false,"text":"Condensation present in sliding door double-paned window(s), suggesting a broken gas seal."},{"checked":false,"id":1,"is_red":false,"text":"Some door stop(s) missing / ineffective; recommend installation to avoid unnecessary wall or door damage.  "},{"checked":false,"id":1,"is_red":false,"text":"Doors are non-standard, which is characteristic for a house of this age."},{"checked":false,"id":1,"is_red":false,"text":"Low headroom at basement stairwell which is common for a house of this age."},{"checked":false,"id":1,"is_red":false,"text":"Door to the basement opens over stairs.  Use caution; by modern standards, it should open into structure or onto a landing to prevent personal injury from falls."},{"checked":false,"id":1,"is_red":false,"text":"Air and light entering at entrance door."},{"checked":false,"id":1,"is_red":false,"text":"Threshhold of entrance door sags slightly when stepped upon; recommend providing more support."},{"checked":false,"id":1,"is_red":false,"text":"Caulk or grout recommended at entrance door - floor junctions to prevent water  carried in by foot traffic from entering under the flooring.  "},{"checked":false,"id":1,"is_red":false,"text":"Maintenance Tip: Caulk or grout recommended at door - floor junctions, where applicable, to prevent water that is carried in by foot traffic from entering under the flooring.  "},{"checked":false,"id":1,"is_red":false,"text":"Door stops missing; recommend installing to avoid unnecessary wall and/or door damage.  Note that living room closet door can hit into glass at front door. "},{"checked":false,"id":1,"is_red":false,"text":"Double door entryway noted."},{"checked":false,"id":1,"is_red":false,"text":"The back door is difficult to open and close; mechanism may not be installed true. Back door opens to a step off and fall situation, needs a landing and stairs built on exterior. At lease put up a sign during any open house viewing of the property."},{"checked":false,"id":1,"is_red":false,"text":"Hollow wood doors. "},{"checked":false,"id":1,"is_red":false,"text":"The entry doors automatic closer is unable tp perform its function due to the thick carpeting that makes the door difficult to open and close."},{"checked":false,"id":1,"is_red":false,"text":"The door for the furnace closet should be louvred to allow air in to help combustion. "},{"checked":false,"id":1,"is_red":false,"text":"Metal door with \"wood look\"."},{"checked":false,"id":1,"is_red":false,"text":"Sliding door in rear leading to porch."},{"checked":false,"id":1,"is_red":false,"text":"Back door missing a deadbolt lockset."},{"checked":false,"id":1,"is_red":false,"text":"The top floor units back door rubs on the floor as it opens and closes, may need some sanding on bottom of door to help clearance."},{"checked":false,"id":1,"is_red":false,"text":"Some doors are damaged."},{"checked":false,"id":1,"is_red":false,"text":"EXAMPLES:"},{"checked":false,"id":1,"is_red":false,"text":"Several doors are a bit tight in jams, possibly from the new coat of paint."},{"checked":false,"id":1,"is_red":false,"text":"The exit door to mechanical room utilises a self closing mechanism."},{"checked":false,"id":1,"is_red":false,"text":"Doors are not installed."},{"checked":false,"id":1,"is_red":false,"text":"Door did not latch and needs adjustment at:"},{"checked":false,"id":1,"is_red":false,"text":"Door lock appears inadequate, recommend upgrading to provide easier privacy use function of door."},{"checked":false,"id":1,"is_red":false,"text":"Damaged door noted at one or more locations."},{"checked":false,"id":1,"is_red":false,"text":"The installation of a security chain on an interior door is considered a safety hazard. In the event of an emergency a person could not escape due to inability to open door."},{"checked":false,"id":1,"is_red":false,"text":"Pocket door is noted as difficult to operate."},{"checked":false,"id":1,"is_red":false,"text":"Pocket door is noted as stuck in the wall at the time of inspection."}],"sepChoice":"4","title":"Doors"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Doors Overall"}],"title":"Doors"},{"damage_panels":[{"descr":"","id":2062,"options":[{"checked":false,"id":1,"is_red":false,"text":"Operated - appeared functional at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"You should not have a disposal with a septic system."},{"checked":false,"id":1,"is_red":false,"text":"Disposal On/Off switch located behind Electric Range.  This is not conveniently  functional and awkward/out of reach of sink area.  Recommend licensed electrician evaluate and upgrade location.  "},{"checked":false,"id":1,"is_red":false,"text":"The disposal is a worn unit and may have reached the end of its useful life."},{"checked":false,"id":1,"is_red":false,"text":"There is rust present on the disposal unit."},{"checked":false,"id":1,"is_red":false,"text":"The  disposal splash guard is worn and deteriorating. This part is usually available for replacement at a retailer that sells the disposal."},{"checked":false,"id":1,"is_red":false,"text":"The  disposal splash guard is missing. This part is usually available for replacement at a retailer that sells the disposal."},{"checked":false,"id":1,"is_red":false,"text":"The unit makes irregular noise. This may be a foreign object stuck in the disposal."},{"checked":false,"id":1,"is_red":false,"text":"The unit vibrates abnormally. This may be a foreign object stuck in the disposal."},{"checked":false,"id":1,"is_red":false,"text":"Uses unprotected  romex wire for power. We recommend routing the cable out of harms way and or protecting it in a conduit."},{"checked":false,"id":1,"is_red":false,"text":"The disposal unit is leaking. We recommend contacting a licensed plumber to correct the leak."},{"checked":false,"id":1,"is_red":false,"text":"Damaged flexible armoured cable, exposed wiring observed, which is a safety concern."},{"checked":false,"id":1,"is_red":false,"text":"Disposal is improperly wired with extension cord."},{"checked":false,"id":1,"is_red":false,"text":"Disposal was inoperable at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Drain pipe in wall is mounted unusually high, which results in the disposer holding water which will result in a decreased life expectancy."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of past leaking observed."},{"checked":false,"id":1,"is_red":false,"text":"Exposed splices and/or improper wiring observed, which is a safety concern."},{"checked":false,"id":1,"is_red":false,"text":"Garbage disposal is noisy."},{"checked":false,"id":1,"is_red":false,"text":"Garbage disposal vibrates and shudders indicating unit may contain foreign matter or have loose/broken/missing blades. Unit may require tightening and replacing to correct these problems."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the disposal is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Rubber splash guard is deteriorated, recommend replacing."},{"checked":false,"id":1,"is_red":false,"text":"Switch sticks in the on position, this is a safety concern."}],"sepChoice":"4","title":"Garbage Disposal"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Garbage Disposal Overall"}],"title":"Disposal"},{"damage_panels":[{"descr":"","id":2063,"options":[{"checked":false,"id":1,"is_red":false,"text":"Built-in microwave ovens are tested using normal operating controls. Unit was tested and appeared to be serviceable at time of inspection. Leak and/or efficiency testing is beyond the scope of this inspection. If concerned, client should seek further review by qualified technician prior to closing."},{"checked":false,"id":1,"is_red":false,"text":"Inoperable at the time of inspection,"},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified appliance technician for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"The microwave unit arched when tested. We recommend contacting a qualified appliance repair technician to evaluate/repair."},{"checked":false,"id":1,"is_red":false,"text":"The microwave unit made an irregular noise when tested. We recommend contacting a qualified appliance repair technician to evaluate/repair."},{"checked":false,"id":1,"is_red":false,"text":"The microwave unit is missing a door handle. We recommend contacting a qualified appliance repair technician to evaluate/repair."},{"checked":false,"id":1,"is_red":false,"text":"The microwave unit door did not close properly when tested. We recommend contacting a qualified appliance repair technician to evaluate/repair."}],"sepChoice":"4","title":"Microwave"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Microwave Overall"}],"title":"Microwave"},{"damage_panels":[{"descr":"","id":2064,"options":[{"checked":false,"id":1,"is_red":false,"text":"Gas cook top noted."},{"checked":false,"id":1,"is_red":false,"text":"Electric cook top noted."},{"checked":false,"id":1,"is_red":false,"text":"All heating elements operated when tested."},{"checked":false,"id":1,"is_red":false,"text":"The burners did not operate properly when tested."},{"checked":false,"id":1,"is_red":false,"text":"Oven(s) operated when tested."},{"checked":false,"id":1,"is_red":false,"text":"Anti-tip bracket is missing from range installation. See label inside oven door. All free-standing, slide-in ranges include an anti-tip device and is essential in the safe operation of the range. It provides protection when excess force or weight is applied to an open oven door. Carried by home building centers."},{"checked":false,"id":1,"is_red":false,"text":"SAFETY CONCERN:  Free standing range missing anti-tip bracket/device. Should be installed."},{"checked":false,"id":1,"is_red":false,"text":"DEFERRED COST: Older unit. Normally stoves/ovens last about 15-20 years."},{"checked":false,"id":1,"is_red":false,"text":"IRREGULAR INSTALLATION:  Range projects too far out and impedes on the full and proper opening of dishwasher door. Eventually this condition will damage the front of the oven door. Recommend qualified individual reset range further into counter by approximately one inch."},{"checked":false,"id":1,"is_red":false,"text":"The cook top has worn temperature control knobs. Exact knobs may be able to be purchased as replacement parts, or generic ones may be available."},{"checked":false,"id":1,"is_red":false,"text":"The cook top is missing some temperature control knobs. Exact knobs may be able to be purchased as replacement parts, or generic ones may be available."},{"checked":false,"id":1,"is_red":false,"text":"The gas service to the house was off, did not test the cook top."},{"checked":false,"id":1,"is_red":false,"text":"The cook top is missing a gas shut off valve. We recommend contacting a licensed plumber to install the proper valve."},{"checked":false,"id":1,"is_red":false,"text":"The cook top has broken temperature control knobs. Exact knobs may be able to be purchased as replacement parts, or generic ones may be available."},{"checked":false,"id":1,"is_red":false,"text":"Did not test, installation is incomplete."},{"checked":false,"id":1,"is_red":false,"text":"Electric elements may fail without warning"},{"checked":false,"id":1,"is_red":false,"text":"Gas odor detected, this is a safety concern."},{"checked":false,"id":1,"is_red":false,"text":"Gas valve missing at gas service pipe."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the stove/cooktop is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"In use at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Pilot light was out at the time of inspection, did not operate."},{"checked":false,"id":1,"is_red":false,"text":"Recommend confirming proper operation prior to close."},{"checked":false,"id":1,"is_red":false,"text":"The  burner is inoperable."},{"checked":false,"id":1,"is_red":false,"text":"The electrical stove/range elements were tested at the time of inspection and appeared to function properly. These can fail at anytime without warning. No warranty, guarantee, or certification is given as to future failure."},{"checked":false,"id":1,"is_red":false,"text":"The  element is inoperable."},{"checked":false,"id":1,"is_red":false,"text":"This unit was tested and appeared serviceable at time of inspection.  Inspection does not include calibration as this is not a technically exhaustive inspection.  No warranties or guarantees of this or any other appliance can be offered."}],"sepChoice":"4","title":"Cook top condition"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Cook top condition Overall"}],"title":"Cook top"},{"damage_panels":[{"descr":"","id":2065,"options":[{"checked":false,"id":1,"is_red":false,"text":"Oven: Electric radiant heating coils or infrared halogen."},{"checked":false,"id":1,"is_red":false,"text":"Oven: gas burners"},{"checked":false,"id":1,"is_red":false,"text":"Oven: Propane gas burners"},{"checked":false,"id":1,"is_red":false,"text":"Oven(s): Electric"},{"checked":false,"id":1,"is_red":false,"text":"All heating elements operated when tested."},{"checked":false,"id":1,"is_red":false,"text":"The burners did not operate properly when tested."},{"checked":false,"id":1,"is_red":false,"text":"Oven(s) operated when tested."},{"checked":false,"id":1,"is_red":false,"text":"Anti-tip bracket is missing from range installation. See label inside oven door. All free-standing, slide-in ranges include an anti-tip device and is essential in the safe operation of the range. It provides protection when excess force or weight is applied to an open oven door. Carried by home building centers."},{"checked":false,"id":1,"is_red":false,"text":"Anti-Tip devises became a UL (Underwriters Laboratories) safety standard requirement in 1991."},{"checked":false,"id":1,"is_red":false,"text":"SAFETY CONCERN:  Free standing range missing anti-tip bracket/device. Should be installed."},{"checked":false,"id":1,"is_red":false,"text":"DEFERRED COST: Older unit. Normally stoves/ovens last about 15-20 years."},{"checked":false,"id":1,"is_red":false,"text":"IRREGULAR INSTALLATION:  Range projects too far out and impedes on the full and proper opening of dishwasher door. Eventually this condition will damage the front of the oven door. Recommend qualified individual reset range further into counter by approximately one inch."},{"checked":false,"id":1,"is_red":false,"text":"The cook top has worn temperature control knobs. Exact knobs may be able to be purchased as replacement parts, or generic ones may be available."},{"checked":false,"id":1,"is_red":false,"text":"The cook top is missing some temperature control knobs. Exact knobs may be able to be purchased as replacement parts, or generic ones may be available."},{"checked":false,"id":1,"is_red":false,"text":"The gas service to the house was off, did not test the cook top."},{"checked":false,"id":1,"is_red":false,"text":"The cook top is missing agas shut off valve. We recommend contacting a licensed plumber to install the proper valve."},{"checked":false,"id":1,"is_red":false,"text":"The oven door did not close completely. We recommend contacting a qualified appliance repair technician to evaluate/repair."},{"checked":false,"id":1,"is_red":false,"text":"Did not test, installation is incomplete."},{"checked":false,"id":1,"is_red":false,"text":"Electric elements may fail without warning"},{"checked":false,"id":1,"is_red":false,"text":"Fuel off, unable to test."},{"checked":false,"id":1,"is_red":false,"text":"Gas odor detected, this is a safety concern."},{"checked":false,"id":1,"is_red":false,"text":"In use at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Recommend confirming proper operation prior to close."},{"checked":false,"id":1,"is_red":false,"text":"The upper and lower electric oven elements were tested at the time of inspection and appeared to function properly. These can fail at anytime without warning. No warranty, guarantee, or certification is given as to future failures."}],"sepChoice":"4","title":"Oven & Range"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Oven & Range Overall"}],"title":"Oven"},{"damage_panels":[{"descr":"","id":2068,"options":[{"checked":false,"id":1,"is_red":false,"text":"**DRAINS**"},{"checked":false,"id":1,"is_red":false,"text":"Drain line leaks under sink. "},{"checked":false,"id":1,"is_red":false,"text":"Stains from presumed past leaks noted."},{"checked":false,"id":1,"is_red":false,"text":"Note that without water the sink(s) and dishwasher could not be evaluated."},{"checked":false,"id":1,"is_red":false,"text":"Slow drain at sink.  Recommend clearing. "},{"checked":false,"id":1,"is_red":false,"text":"Slow drain at sink with gurgling which may indicate that the drain line needs to be cleaned and/or that the drain is not properly vented. "},{"checked":false,"id":1,"is_red":false,"text":"Evidence of past or present rodents under kitchen sink.  "},{"checked":false,"id":1,"is_red":false,"text":"Stains at sink cabinet floor, presumably from past leak(s) or spilled products."},{"checked":false,"id":1,"is_red":false,"text":"**SUPPLY**"},{"checked":false,"id":1,"is_red":false,"text":"Faucet leaks at base. "},{"checked":false,"id":1,"is_red":false,"text":"The hot & cold  water supplies are reversed. This is not a functional problem but to someone who is not familiar with this condition unexpected hot water could scald them. We suggest contacting a qualified plumbing contractor to repair."},{"checked":false,"id":1,"is_red":false,"text":"Faucet drips. "},{"checked":false,"id":1,"is_red":false,"text":"Faucet leaks at base."},{"checked":false,"id":1,"is_red":false,"text":"Supply line leaks. "},{"checked":false,"id":1,"is_red":false,"text":"No shutoff \"stop\" apparent. "},{"checked":false,"id":1,"is_red":false,"text":"Poor pressure flow when running several fixtures in one area."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the sink is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Sink appears to have been refinished, suggest taking care when cleaning to protect the surface."},{"checked":false,"id":1,"is_red":false,"text":"Sink is leaking at the time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Sink is loose, suggest securing as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Stopper is missing/inoperable."},{"checked":false,"id":1,"is_red":false,"text":"Suggest caulking as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Sink chipped (Cosmetic; does not affect function). "},{"checked":false,"id":1,"is_red":false,"text":"Sink rusted.  Monitor for developing leaks (none found during inspection)."},{"checked":false,"id":1,"is_red":false,"text":"Sink is poorly anchored."},{"checked":false,"id":1,"is_red":false,"text":"Stains from presumed past leaks noted."},{"checked":false,"id":1,"is_red":false,"text":"Note that without water the sink(s) and dishwasher could not be evaluated."},{"checked":false,"id":1,"is_red":false,"text":"Slow drain at sink.  Recommend clearing. "},{"checked":false,"id":1,"is_red":false,"text":"Slow drain at sink with gurgling which may indicate that the drain line needs to be cleaned and/or that the drain is not properly vented. "},{"checked":false,"id":1,"is_red":false,"text":"Evidence of past or present rodents under kitchen sink.  "},{"checked":false,"id":1,"is_red":false,"text":"Stains at sink cabinet floor, presumably from past leak(s) or spilled products."},{"checked":false,"id":1,"is_red":false,"text":"No deficiencies observed."},{"checked":false,"id":1,"is_red":false,"text":"Kitchen has a Dupont Corian molded sink."},{"checked":false,"id":1,"is_red":false,"text":"Kitchen has a Stainless steel - under mounted sink."},{"checked":false,"id":1,"is_red":false,"text":"Kitchen has a Stainless steel - surface mounted sink."},{"checked":false,"id":1,"is_red":false,"text":"Kitchen has a Ceramic sink."},{"checked":false,"id":1,"is_red":false,"text":"Kitchen has a Cast iron sink."},{"checked":false,"id":1,"is_red":false,"text":"Newer, brushed nickel, pullout wand faucet."},{"checked":false,"id":1,"is_red":false,"text":"The sink finish is damaged. Recommend repair or replacement."},{"checked":false,"id":1,"is_red":false,"text":"Sink appears to have been refinished, suggest taking care when cleaning to protect the surface."},{"checked":false,"id":1,"is_red":false,"text":"Sink is leaking at the time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Sink is loose, suggest securing as necessary."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the sink is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Stopper is missing/inoperable."},{"checked":false,"id":1,"is_red":false,"text":"Suggest caulking as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Operated normally, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Older style faucet observed."},{"checked":false,"id":1,"is_red":false,"text":"Aerator is blocked, suggest cleaning for proper flow."},{"checked":false,"id":1,"is_red":false,"text":"Kitchen faucet leaks. Recommend repair or replacement."},{"checked":false,"id":1,"is_red":false,"text":"Sink finish is damaged. Recommend repair or replacement."},{"checked":false,"id":1,"is_red":false,"text":"Spray wand leaks."},{"checked":false,"id":1,"is_red":false,"text":"Under mounted sink leaks along mounting joint. Repair as needed. "},{"checked":false,"id":1,"is_red":false,"text":"Laundry sink slow to drain. Suspect clogged drain trap. Recommend licensed plumber repair."},{"checked":false,"id":1,"is_red":false,"text":"Mold-like bio growth observed. Professional testing & evaluation advised."}],"sepChoice":"4","title":"Sinks"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Sinks Overall"}],"title":"Sinks"},{"damage_panels":[{"descr":"","id":2069,"options":[{"checked":false,"id":1,"is_red":false,"text":"There was no drinking fountain present in this kitchen."},{"checked":false,"id":1,"is_red":false,"text":"The drinking fountain was operated and was functional."},{"checked":false,"id":1,"is_red":false,"text":"The drinking fountain had an irregular spray."},{"checked":false,"id":1,"is_red":false,"text":"The drinking fountain did not operate when tested."},{"checked":false,"id":1,"is_red":false,"text":"An irregular spray is noted from the drinking fountain."},{"checked":false,"id":1,"is_red":false,"text":"The drinking fountain appears to be loose in its location. We recommend contacting a licensed plumber to evaluate/repair."},{"checked":false,"id":1,"is_red":false,"text":"The drinking fountain appears to be leaking. We recommend contacting a licensed plumber to evaluate/repair."}],"sepChoice":"4","title":"Drinking Fountain"},{"descr":"","id":2070,"options":[{"checked":false,"id":1,"is_red":false,"text":"There was no spray wand present in this kitchen."},{"checked":false,"id":1,"is_red":false,"text":"The spray wand was operated and was functional."},{"checked":false,"id":1,"is_red":false,"text":"The spray wand had an irregular spray."},{"checked":false,"id":1,"is_red":false,"text":"An irregular spray is noted from the spray wand."},{"checked":false,"id":1,"is_red":false,"text":"The spray wand appears to be loose in its location. We recommend contacting a licensed plumber to evaluate/repair."},{"checked":false,"id":1,"is_red":false,"text":"The spray wand appears to be leaking. We recommend contacting a licensed plumber to evaluate/repair."},{"checked":false,"id":1,"is_red":false,"text":"The spray wand did not operate when tested."}],"sepChoice":"4","title":"Spray Wand"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Drinking Fountain Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Spray Wand Overall"}],"title":"Sinks 2"},{"damage_panels":[{"descr":"","id":2071,"options":[{"checked":false,"id":1,"is_red":false,"text":"The hot water dispenser \"Instant Hot\" did not operate when tested."},{"checked":false,"id":1,"is_red":false,"text":"The hot water dispenser \"Instant Hot\" did not operate when tested. It appears to not have power to it. We recommend having a licensed electrician evaluate the power problem."},{"checked":false,"id":1,"is_red":false,"text":"The hot water dispenser appears to be a worn unit and may be at the end of its useful life."},{"checked":false,"id":1,"is_red":false,"text":"The hot water dispenser appears to be leaking and may be at the end of its useful life. "},{"checked":false,"id":1,"is_red":false,"text":"The hot water dispenser appears to be leaking. We recommend having a licensed plumber repair the leak. "}],"sepChoice":"4","title":"Hot Water Dispenser"},{"descr":"","id":2072,"options":[{"checked":false,"id":1,"is_red":false,"text":"The soap dispenser was missing from its location. We recommend contacting the seller for replacement options."},{"checked":false,"id":1,"is_red":false,"text":"The soap dispenser was functional."},{"checked":false,"id":1,"is_red":false,"text":"The soap dispenser did not operate."},{"checked":false,"id":1,"is_red":false,"text":"There was no soap present in the dispenser, could not test."}],"sepChoice":"4","title":"Soap Dispenser"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Hot Water Dispenser Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Soap Dispenser Overall"}],"title":"Sinks 3"},{"damage_panels":[{"descr":"","id":2075,"options":[{"checked":false,"id":1,"is_red":false,"text":"Down Draft type."},{"checked":false,"id":1,"is_red":false,"text":"Recirculating type."},{"checked":false,"id":1,"is_red":false,"text":"Vented to exterior."},{"checked":false,"id":1,"is_red":false,"text":"Functioned and operated normally when tested."},{"checked":false,"id":1,"is_red":false,"text":"Did not operate properly. Recommend repair or replacing."},{"checked":false,"id":1,"is_red":false,"text":"DEFERRED COST: Older, non filtered, style. Consider replacing."},{"checked":false,"id":1,"is_red":false,"text":"Filter is missing."},{"checked":false,"id":1,"is_red":false,"text":"Filter is dirty/Clean or replace."},{"checked":false,"id":1,"is_red":false,"text":"Improve: Recommend adding an exhaust fan or range hood to allow for proper ventilation of the stove."},{"checked":false,"id":1,"is_red":false,"text":"Light did not operate."},{"checked":false,"id":1,"is_red":false,"text":"Fan did not operate."},{"checked":false,"id":1,"is_red":false,"text":"Installed duct does not connect to exterior. Refer to \"Attic\" section."},{"checked":false,"id":1,"is_red":false,"text":"Integrated with Microwave above range."}],"sepChoice":"4","title":"Trash Compactor"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Trash Compactor Overall"}],"title":"Compactor"},{"damage_panels":[{"descr":"","id":2076,"options":[{"checked":false,"id":1,"is_red":false,"text":"Appears to be wired with extension cord."},{"checked":false,"id":1,"is_red":false,"text":"Central ventilation system is present."},{"checked":false,"id":1,"is_red":false,"text":"Did not test, installation is incomplete."},{"checked":false,"id":1,"is_red":false,"text":"Exhaust fan is inoperable."},{"checked":false,"id":1,"is_red":false,"text":"Exhaust fan is noisy."},{"checked":false,"id":1,"is_red":false,"text":"Exhaust fan vibrates or is excessively noisy. This may indicate a worn armature or bearings. The fan may eventually need to be replaced to correct this condition."},{"checked":false,"id":1,"is_red":false,"text":"Exterior vented fan is recommended where gas appliances are in place."},{"checked":false,"id":1,"is_red":false,"text":"Fan is a slow starter, suggest having motor professionally cleaned."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the hood/fan is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"Recirculator only.  Exterior vented fans are generally required when gas range in place."},{"checked":false,"id":1,"is_red":false,"text":"Recommend cleaning filter regularly for fire safety."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Vent fan light is inoperable."}],"sepChoice":"4","title":"Vent Condition"}],"inspection_panels":[{"descr":"","id":3020,"options":[{"checked":false,"id":1,"is_red":false,"text":"Exterior Vented"},{"checked":false,"id":1,"is_red":false,"text":"Recirculating"}],"sepChoice":"1","title":"Venting"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Vent Condition Overall"}],"title":"Vent"},{"damage_panels":[{"descr":"","id":2216,"options":[{"checked":false,"id":1,"is_red":false,"text":"Deterioration noted due to contact with moisture, repairs needed."},{"checked":false,"id":1,"is_red":false,"text":"One or more window/s shows sign of loss of seal/condensation, recommend repair or replace to provide energy savings and prevent hazed window from limiting view out of window. "},{"checked":false,"id":1,"is_red":false,"text":"One or more windows did not lock/latch properly, recommend repairs for enhanced security/safety to occupants."},{"checked":false,"id":1,"is_red":false,"text":"Broken/cracked glass pane noted, repairs needed."},{"checked":false,"id":1,"is_red":false,"text":"Hardware difficult to operate at one or more locations. Recommend review and repair as needed by qualified window contractors."},{"checked":false,"id":1,"is_red":false,"text":"Single pane windows observed, recommend budgeting for replacement for added efficiency of home."},{"checked":false,"id":1,"is_red":false,"text":"Broken glazing observed, suggest re-glazing as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Broken sash wire/cord observed on window frame. This is a \"Safety Concern\". Sash wire/cord holds window in open position. Suggest repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Damaged screens observed."},{"checked":false,"id":1,"is_red":false,"text":"Deterioration of wooden frames noted.  While basic maintenance may prolong the life of these window frames, replacement may be necessary at some point.  "},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the windows/frames are near the end of their useful life."},{"checked":false,"id":1,"is_red":false,"text":"Peeling paint observed, suggest scraping and painting as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Fog/condensation observed in thermopane windows. This is an indication of a failed seal. Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl crank out style windows with locks."},{"checked":false,"id":1,"is_red":false,"text":"Painted wood windows possibly creating lead dust from friction on paint. "},{"checked":false,"id":1,"is_red":false,"text":"Metal \"double hung\" type with locks."},{"checked":false,"id":1,"is_red":false,"text":"Severe damage--\nSome vinyl windows in the home had severe damage visible at the time of the inspection. You may wish to get estimates for repair before the expiration of your Inspection Objection Deadline.\n"},{"checked":false,"id":1,"is_red":false,"text":"Minor damage--\nSome vinyl windows in the home had minor damage visible at the time of the inspection.\n"},{"checked":false,"id":1,"is_red":false,"text":"The home is fitted with vinyl windows."},{"checked":false,"id":1,"is_red":false,"text":"Some windows are very difficult to open and some were not able to open, this may be because of the paint."},{"checked":false,"id":1,"is_red":false,"text":"Screens were not installed at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"In accordance with ASHI Standards, we do not test every window in the house, and particularly if it is furnished. We do test every unobstructed window in every bedroom to ensure that at least one provides and emergency exit."},{"checked":false,"id":1,"is_red":false,"text":"Highly recommend operating all windows during final walk through inspection."},{"checked":false,"id":1,"is_red":false,"text":"Operated windows appeared functional, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"The windows that were tested, are functional."},{"checked":false,"id":1,"is_red":false,"text":"Broken sash wire/cord observed on window frame. This is a \"Safety Concern\". Sash wire/cord holds window in open position. Suggest repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Damaged/Missing sash cords"},{"checked":false,"id":1,"is_red":false,"text":"Damaged screens observed."},{"checked":false,"id":1,"is_red":false,"text":"Missing screens observed at @@LOCATION@@."},{"checked":false,"id":1,"is_red":false,"text":"Damage tilt-out feature locking clips at @@LOCATION@@. Window is still functional. FYI"},{"checked":false,"id":1,"is_red":false,"text":"Damage/missing hardware at @@LOCATION@@. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Cloudiness/condensation observed in @@NUMBER@@ of thermopane double glazed windows in @@LOCATION@@. This is an indication of a failed seal. A qualified contractor should review for replacement as needed."},{"checked":false,"id":1,"is_red":false,"text":"Cracked or broken window glass was observed. Injury could occur. Recommend repair or replacement of the damaged glass."},{"checked":false,"id":1,"is_red":false,"text":"Cracked window pane in @@LOCATION@@. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"DEFERRED COST: Windows are original, older type. Consider upgrading to double pane, thermally insulated, newer efficient type."},{"checked":false,"id":1,"is_red":false,"text":"Some windows did not open when tested. Recommend  all windows reviewed for proper operation during walkthrough inspection prior to closing"},{"checked":false,"id":1,"is_red":false,"text":"A representative number of windows were inspected. Most did not open when tested -- appears painted wood frames have sealed seams. Recommend  all windows be reviewed for proper operation during final walkthrough inspection."},{"checked":false,"id":1,"is_red":false,"text":"All accessible windows operated."},{"checked":false,"id":1,"is_red":false,"text":"Mold-like bio growth observed. Professional testing & evaluation advised."},{"checked":false,"id":1,"is_red":false,"text":"There are older wood windows present."},{"checked":false,"id":1,"is_red":false,"text":"The windows in the home are rope and pulley style, may be original to home, and are approaching the end of their serviceable lifetime."}],"sepChoice":"4","title":"Window Condition"}],"inspection_panels":[{"descr":"","id":3066,"options":[{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed casement window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Stationary(fixed) window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed casement window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed casement window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Garden style window noted."},{"checked":false,"id":1,"is_red":false,"text":"Bay type window noted."},{"checked":false,"id":1,"is_red":false,"text":"Bow type window noted."},{"checked":false,"id":1,"is_red":false,"text":"Glass blocks noted in window openings."},{"checked":false,"id":1,"is_red":false,"text":"Non-insulated glass noted."},{"checked":false,"id":1,"is_red":false,"text":"Insulated glass noted."}],"sepChoice":"1","title":"Windows"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Window Condition Overall"}],"title":"Windows"},{"damage_panels":[{"descr":"","id":2220,"options":[{"checked":false,"id":1,"is_red":false,"text":"Some of the floors in this building are a vintage 9x9 size tile; be advised that these tiles may be the type that had an adhesive containing asbestos. Asbestos is a health risk when it is made friable - in other words, when its fibres and dust can be breathed in by the lungs. to be safe, please refrain from removal and damaging these tiles until it is certain they are not asbestos containing material.  "},{"checked":false,"id":1,"is_red":false,"text":"Floor is not level. Suggest further evaluation by a licensed contractor within the inspection contingency period."},{"checked":false,"id":1,"is_red":false,"text":"Laminate floating floor system was installed with poor workmanship techniques, gaps, under size cuts, and chips are visible giving a less than appealing appearance and likely lowering the serviceable life of the flooring."},{"checked":false,"id":1,"is_red":false,"text":"It appears the existing carpeting was installed over the concrete slab without a moisture barrier;this is not a good installation method. The moisture content in the concrete can create the growth of organic materials \"Mold\" in the carpet. Recommend contacting a qualified contractor for further evaluation."},{"checked":false,"id":1,"is_red":false,"text":"Only the sub flooring is present and it is inconsistent in installation."},{"checked":false,"id":1,"is_red":false,"text":"Damaged grout observed, suggest regrouting as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Common cracks noted."},{"checked":false,"id":1,"is_red":false,"text":"Cracked tiles noted."},{"checked":false,"id":1,"is_red":false,"text":"Cracking noted in ceramic tiles.  This is an indication of inadequate subfloor installation."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of repairs observed, unable to determine the effectiveness of these repairs."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the floor is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"Minor damage noted."},{"checked":false,"id":1,"is_red":false,"text":"Numerous cracked tiles noted."},{"checked":false,"id":1,"is_red":false,"text":"Open seams observed."},{"checked":false,"id":1,"is_red":false,"text":"Popping floor tile observed."},{"checked":false,"id":1,"is_red":false,"text":"Possible trip hazard. This is a safety concern. Suggest repair/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified professional for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Recommend sealing cracks/voids."},{"checked":false,"id":1,"is_red":false,"text":"Tile has been painted/refinished, suggest taking care when cleaning to protect the surface."},{"checked":false,"id":1,"is_red":false,"text":"Water damage observed."},{"checked":false,"id":1,"is_red":false,"text":"Carpet is not recommended in bathrooms due to potential to harbor moisture, which could lead to unwanted mold issues."},{"checked":false,"id":1,"is_red":false,"text":"Recommend caulking at the tub and shower areas"},{"checked":false,"id":1,"is_red":false,"text":"Flooring appears to have damaged subfloor due to plumbing leak ."}],"sepChoice":"4","title":"Floor Condition"}],"inspection_panels":[{"descr":"","id":3070,"options":[{"checked":false,"id":1,"is_red":false,"text":"Carpet is noted."},{"checked":false,"id":1,"is_red":false,"text":"Ceramic tile is noted."},{"checked":false,"id":1,"is_red":false,"text":"Sheet vinyl flooring is noted."},{"checked":false,"id":1,"is_red":false,"text":"Hardwood flooring is noted."},{"checked":false,"id":1,"is_red":false,"text":"Floating laminate type flooring noted."},{"checked":false,"id":1,"is_red":false,"text":"Marble floors noted."},{"checked":false,"id":1,"is_red":false,"text":"Natural stone floors noted."},{"checked":false,"id":1,"is_red":false,"text":"Bare concrete floors noted."},{"checked":false,"id":1,"is_red":false,"text":"Plywood subfloor is exposed."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl squares (tiles) are noted."}],"sepChoice":"1","title":"Floors"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Floor Condition Overall"}],"title":"Floors"},{"damage_panels":[{"descr":"","id":2222,"options":[{"checked":false,"id":1,"is_red":false,"text":"Flex drain observed, these are subject to frequent clogging."},{"checked":false,"id":1,"is_red":false,"text":"Improper \"S\" trap noted.  This trap configuration may cause the trap to siphon dry, allowing sewer gas and odour to enter the dwelling.  This situation may rectified by the installation of an anti siphon device (cheater vent).  Suggest repair by a qualified professional.  In the alternative, run a little bit of water into the sink to reseal the trap if odour is detected."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the drain is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"Limited review due to personal property stored in undersink cabinet."},{"checked":false,"id":1,"is_red":false,"text":"No drain trap observed."},{"checked":false,"id":1,"is_red":false,"text":"No way to determine presence of trap under sink as it is (if present) concealed between subfloor and ceiling finish."},{"checked":false,"id":1,"is_red":false,"text":"Older style metal traps noted.  Buyer is cautioned that these traps can leak at any time due to corrosion."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Sink drain assembly is loose, no leaks observed."},{"checked":false,"id":1,"is_red":false,"text":"Unable to inspect due to cabinet design, inaccessible."},{"checked":false,"id":1,"is_red":false,"text":"Water was off at time of the inspection. Unable to determine the condition of the system and/or the function of plumbing fixtures. We recommend confirming proper operation of all plumbing appliances and fixtures prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Illegal flex drain used under kitchen sink. Should be replaced with correct part by licensed plumber."},{"checked":false,"id":1,"is_red":false,"text":"Illegal plastic flex line used on bathroom sink drain."},{"checked":false,"id":1,"is_red":false,"text":"S traps present- these may cause dry traps, slow drains or loud drainage."},{"checked":false,"id":1,"is_red":false,"text":"Most not accessible because of excessive personal items present."},{"checked":false,"id":1,"is_red":false,"text":"Worn fixtures are noted."},{"checked":false,"id":1,"is_red":false,"text":"Visible leaking noted under the sink. We recommend contacting a licensed plumbing contractor for repair options."},{"checked":false,"id":1,"is_red":false,"text":"The hot & cold  water supplies are reversed. This is not a functional problem but to someone who is not familiar with this condition unexpected hot water could scald them. We suggest contacting a qualified plumbing contractor to repair."},{"checked":false,"id":1,"is_red":false,"text":"Pressure weakens when other areas are in use."},{"checked":false,"id":1,"is_red":false,"text":"Copper to galvanized connection missing proper fittings. This can create a galvanic reaction which will eat away at the pipes."},{"checked":false,"id":1,"is_red":false,"text":"Possible cross contamination noted due to suppy water in direct connection with the waste line."}],"sepChoice":"4","title":"Plumbing"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Plumbing Overall"}],"title":"Plumbing"},{"damage_panels":[{"descr":"","id":2226,"options":[{"checked":false,"id":1,"is_red":false,"text":"Small cracking in the wall finish is noted. This is probably caused by the joint compound (spackle) drying too quickly during application. "},{"checked":false,"id":1,"is_red":false,"text":"Minor damage from what appears to be from excess moisture noted. Recommend review of current vent fan and possibly installing a timer to assure that fan is used during showers."},{"checked":false,"id":1,"is_red":false,"text":"The drywall is patched in areas. The reason for the patch could not be determined. "},{"checked":false,"id":1,"is_red":false,"text":"Small stains noted on the ceiling. They tested dry at the time of the inspection."},{"checked":false,"id":1,"is_red":false,"text":"Large stains noted on the ceiling. They tested dry at the time of the inspection."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of past leaking was noted."},{"checked":false,"id":1,"is_red":false,"text":"There were signs of paint blistering on the ceiling. The areas tested dry at the time of the inspection, but should be monitored for further damage or possibly water intrusion."},{"checked":false,"id":1,"is_red":false,"text":"The inspector could not access the area around the skylight."},{"checked":false,"id":1,"is_red":false,"text":"Visible leaking noted on the ceiling. We recommend contacting a qualified contractor to evaluate the roof and the drywall in this area and repair as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Freshly painted in areas. This could be concealing a defect that could not be determined."},{"checked":false,"id":1,"is_red":false,"text":"Mold like stains present on the ceiling. We recommend having a mold sample taken and lab tested, also monitor the area for water intrusion."},{"checked":false,"id":1,"is_red":false,"text":"There is a damaged ceiling tile in dining room - damage is between crown molding and tile in form of a puncture of sorts. see pic."},{"checked":false,"id":1,"is_red":false,"text":"Extensive water damage to general area of ceiling where the past leaking had occurred. Areas are marked with peeling paint and bulging drywall. Have a contractor evaluate."},{"checked":false,"id":1,"is_red":false,"text":"There is an anomaly present a the point in the ceiling that adjoins the inner wall. It appears there is a bowing / sagging in the corner. It is not clear as to what may have caused this. Ask association about this issue and about past occurrences that may be linked to this issue."},{"checked":false,"id":1,"is_red":false,"text":"The ceiling was not painted all the way to the edge in kitchen."},{"checked":false,"id":1,"is_red":false,"text":"The drywall installation is not entirely professional quality, have a contractor evaluate."}],"sepChoice":"4","title":"Ceiling Condition"}],"inspection_panels":[{"descr":"","id":3074,"options":[{"checked":false,"id":1,"is_red":false,"text":"There are drywall ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"There are plaster ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"There are acoustic grid and tile ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"There are wood plank ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"There are metal pan ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"Open beam ceiling construction noted."},{"checked":false,"id":1,"is_red":false,"text":"There is panel lighting present in the ceiling."},{"checked":false,"id":1,"is_red":false,"text":"The ceilings are clad in wood paneling."},{"checked":false,"id":1,"is_red":false,"text":"Cathedral style (vaulted) ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"Mirror panels are noted on the ceilings."},{"checked":false,"id":1,"is_red":false,"text":"The ceilings are clad in cork."},{"checked":false,"id":1,"is_red":false,"text":"The ceilings are clad in a laminate material."},{"checked":false,"id":1,"is_red":false,"text":"The ceilings are clad in tile squares."}],"sepChoice":"1","title":"Ceilings"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Ceiling Condition Overall"}],"title":"Ceilings"},{"damage_panels":[{"descr":"","id":2234,"options":[{"checked":false,"id":1,"is_red":false,"text":"No security bars are present in this room."},{"checked":false,"id":1,"is_red":false,"text":"The security bars were operated and appeared functional."},{"checked":false,"id":1,"is_red":false,"text":"The security bars did not operate, this is not to building standards."},{"checked":false,"id":1,"is_red":false,"text":"The security bars are missing hardware, compromising their effective usage."},{"checked":false,"id":1,"is_red":false,"text":"The security bars were bent and appeared to not function properly."},{"checked":false,"id":1,"is_red":false,"text":"The security bars were rusted and appeared to not function properly."}],"sepChoice":"4","title":"Security Bars"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Security Bars Overall"}],"title":"Security Bars"},{"damage_panels":[{"descr":"","id":2235,"options":[{"checked":false,"id":1,"is_red":false,"text":"**Sliding Patio Doors**"},{"checked":false,"id":1,"is_red":false,"text":"There are no patio doors present in this room."},{"checked":false,"id":1,"is_red":false,"text":"The sliding patio door was functional during the inspection."},{"checked":false,"id":1,"is_red":false,"text":"The hinged patio door was functional during the inspection."},{"checked":false,"id":1,"is_red":false,"text":"The doors hardware is showing signs of wear and may be at the end of its useful life. We recommend budgeting for replacement."},{"checked":false,"id":1,"is_red":false,"text":"The sliding door tracks appeared dirty at the inspection making the door difficult to operate. We recommend cleaning the tracks and lubricating the doors rollers."},{"checked":false,"id":1,"is_red":false,"text":"Tempered glass noted in the patio door."},{"checked":false,"id":1,"is_red":false,"text":"Door is difficult to operate, this presents a safety hazard in the event of an emergency/fire. Recommend repair/adjusting of door by a Qualified Contractor to allow easy and smooth operation. Current building standards require this second means of egress in a sleeping area for quick escape in the event of an emergency."},{"checked":false,"id":1,"is_red":false,"text":"One or more sliding door/s shows sign of loss of seal/condensation, recommend repair or replace by Qualified Contractors, to provide energy savings and prevent hazed window from limiting view out of window. "},{"checked":false,"id":1,"is_red":false,"text":"Sliding glass door is installed backwards/inside out."},{"checked":false,"id":1,"is_red":false,"text":"**Hinged Patio Doors**"},{"checked":false,"id":1,"is_red":false,"text":"Door is difficult to operate, this presents a safety hazard in the event of an emergency/fire. Recommend repair/adjusting of door by a Qualified Contractor to allow easy and smooth operation. Current building standards require this second means of egress in a sleeping area for quick escape in the event of an emergency."},{"checked":false,"id":1,"is_red":false,"text":"The patio door did not lock.\r\n"},{"checked":false,"id":1,"is_red":false,"text":"The patio door did not latch."},{"checked":false,"id":1,"is_red":false,"text":"Tempered glass noted in the patio door."},{"checked":false,"id":1,"is_red":false,"text":"The doors hardware is showing signs of wear and may be at the end of its useful life. We recommend budgeting for replacement."},{"checked":false,"id":1,"is_red":false,"text":"Frame is separating from glass."},{"checked":false,"id":1,"is_red":false,"text":"The inspector can not determine if tempered glass is in the door."}],"sepChoice":"4","title":"Patio Doors"},{"descr":"","id":2236,"options":[{"checked":false,"id":1,"is_red":false,"text":"Not installed, recommend installation and confirmation of proper screen door operation."},{"checked":false,"id":1,"is_red":false,"text":"Sliding door screen is missing/damaged"},{"checked":false,"id":1,"is_red":false,"text":"Sliding door screen is functional."},{"checked":false,"id":1,"is_red":false,"text":"Sliding door screen tracks are dirty making the door difficult to operate. Recommend cleaning the tracks out."},{"checked":false,"id":1,"is_red":false,"text":"The sliding screen door has worn hardware and may be at the end of its useful life. Recommend budgeting for replacement."},{"checked":false,"id":1,"is_red":false,"text":"Security screen door present."},{"checked":false,"id":1,"is_red":false,"text":"Sliding screen door is torn sliding screen door is difficult to operate."},{"checked":false,"id":1,"is_red":false,"text":"Sliding screen door is difficult to operate."},{"checked":false,"id":1,"is_red":false,"text":"Sliding screen door is off the tracks."},{"checked":false,"id":1,"is_red":false,"text":"Sliding screen door is bent."},{"checked":false,"id":1,"is_red":false,"text":"Sliding screen door is missing hardware."},{"checked":false,"id":1,"is_red":false,"text":"Broken latch on the sliding screen door."}],"sepChoice":"4","title":"Screen Doors"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Patio Doors Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Screen Doors Overall"}],"title":"Patio Doors"},{"damage_panels":[{"descr":"","id":2247,"options":[{"checked":false,"id":1,"is_red":false,"text":"Some outlets were not accessible due to furniture and or stored personal items in the way."},{"checked":false,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Light fixture or bulb apparently inoperable at   .  Change bulb(s) and check."},{"checked":false,"id":1,"is_red":false,"text":"Light bulbs are missing at various fixtures throughout the house, and cannot be evaluated."},{"checked":false,"id":1,"is_red":false,"text":"GFCI trip test failed.  Have licensed electrician evaluate and repair / replace as necessary."},{"checked":false,"id":1,"is_red":false,"text":"No smoke/ fire detectors were installed at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Smoke detector(s) need new backup batteries."},{"checked":false,"id":1,"is_red":false,"text":"Smoke detectors were tested and are functional. Remember to check detectors regularly, and replace when needed according to manufactures and fire safety guidelines. "},{"checked":false,"id":1,"is_red":false,"text":"There are smoke detectors hard wired in and connected to each other,but there was one beeping continually- it may need to be replaced."},{"checked":false,"id":1,"is_red":false,"text":"Note:  Smoke-carbon monoxide combination detector(s) recommended near utilities."},{"checked":false,"id":1,"is_red":false,"text":"Replace all old not functioning smoke/ fire detectors with new hard wired detectors or make sure batteries are good."},{"checked":false,"id":1,"is_red":false,"text":"The installation of smoke detectors is not yet completed. We recommend having the seller finish installation and verify proper operation of detectors."},{"checked":false,"id":1,"is_red":false,"text":"Switch damaged or apparently inoperable."},{"checked":false,"id":1,"is_red":false,"text":"Switch purpose unknown.  Check with seller. "},{"checked":false,"id":1,"is_red":false,"text":"Switch needs new cover."},{"checked":false,"id":1,"is_red":false,"text":"Outlet damaged."},{"checked":false,"id":1,"is_red":false,"text":"Outlet needs new cover."},{"checked":false,"id":1,"is_red":false,"text":"Outlet cover(s) missing."},{"checked":false,"id":1,"is_red":false,"text":"Outlet apparently inoperable."},{"checked":false,"id":1,"is_red":false,"text":"Open ground (or 2-wire) outlets present.  This means that the 3rd (round) part of an appliance plug is not getting ground protection.  This may be a concern with items such as computers and electronic devices."},{"checked":false,"id":1,"is_red":false,"text":"Hot-neutral reversed outlets present.  This means that the black and white wires in the circuit have been reversed, and may be a concern with items such as computers and electronic devices."},{"checked":false,"id":1,"is_red":false,"text":"Open neutral outlet.  This means the receptacle is not working properly because, even though the black wire is hot, the white (neutral) wire is not connected well somewhere, so that it cannot carry any current \"back\" to the main panel. "},{"checked":false,"id":1,"is_red":false,"text":"Connections made outside of a Junction Box.  This is a potential shock or electrocution hazard."},{"checked":false,"id":1,"is_red":false,"text":"Wire ends are outside of a Junction Box at.  This is a potential shock or electrocution hazard."},{"checked":false,"id":1,"is_red":false,"text":"Junction Box Cover(s) missing.  This is a potential shock or electrocution hazard."},{"checked":false,"id":1,"is_red":false,"text":"Romex wiring should all be enclosed in conduit for protection from nicks or cuts which could be a source of shocks or even electrocution."},{"checked":false,"id":1,"is_red":false,"text":"This property has “knob and tube” wiring which was commonly installed prior to 1950. It is ungrounded, and considered unsafe by today’s standards. Over time, the wire’s insulation may become brittle and fall apart or wear thin, resulting in exposed conductors and a risk of shock and/or fire. This wiring is also easily damaged by covering it with insulation (a common practice), and incorrectly tapping new wiring into it. Some energized knob and tube wiring was found during the inspection. It is not within the scope of this inspection to determine what percentage of this property’s wiring is of the knob and tube type or to determine what percentage of the knob and tube wiring is energized vs. abandoned. A qualified electrician should evaluate this wiring and make repairs or replace wiring as necessary. "},{"checked":false,"id":1,"is_red":false,"text":"Aluminum wiring present - Between 1965 and 1973, aluminum wiring was sometimes substituted for copper wiring in residential electrical systems. Connections in outlets, switches, and light fixtures with aluminum wiring may become increasingly dangerous as time passes. Poor connections cause wiring to overheat, creating a potential fire hazard. Aluminum wiring connections are subject to greater deterioration than is copper due to thermal expansion and contraction, vibration (caused when electric currents pass through wiring), oxidation (caused by exposure to oxygen in the air), and galvanic corrosion (caused when two different metals are connected together), all of which can cause poor connections. When wires are poorly connected they overheat, which creates a potential fire hazard.  The presence of aluminum wiring might also have an effect on your insurance policy. You should ask your insurance agent whether the presence of aluminum wiring is a problem that requires changes to your policy language in order to ensure that your house is covered. The wiring should be evaluated by a qualified electrician experienced in evaluating and correcting aluminum wiring problems. Not all electrical contractors qualify. "},{"checked":false,"id":1,"is_red":false,"text":"220 Volt receptacle needs to be secured to wall."},{"checked":false,"id":1,"is_red":false,"text":"Undersized extension cord in use."},{"checked":false,"id":1,"is_red":false,"text":"We recommend that a licensed electrician evaluate, repair and replace wires and connections as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Dimming lights were observed, this may be an indication of inadequate electrical distribution. We recommend review by a licensed electrician for evaluation and redistribution as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Reversed polarity, hot and neutral reversed and other terms used for electric receptacles are usually easily corrected by minor wiring adjustments at the specified item. When these conditions are noted in this report, a licensed electrician should be consulted for repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Ungrounded receptacles observed at water sources or exterior locations ideally should be grounded, suggest installing GFCI's for safety."},{"checked":false,"id":1,"is_red":false,"text":"Switches have unknown function, consult the owner for clarification on what they control."},{"checked":false,"id":1,"is_red":false,"text":"Outlet with open ground noted."},{"checked":false,"id":1,"is_red":false,"text":"After 5 years of operation, CARBON MONOXIDE detectors should be replaced, because they wear out."},{"checked":false,"id":1,"is_red":false,"text":"It is recommended to test CO detectors regularly."},{"checked":false,"id":1,"is_red":false,"text":"Have hard wired, or plug in CO Detectors installed at a low elevation, as it may hover close to the ground and rise up during a fire."},{"checked":false,"id":1,"is_red":false,"text":"If a carbon monoxide detector sets its alarm from exposure to CO, it is no longer considered efficient to use as its sensor mechanism will have been depleted. "},{"checked":false,"id":1,"is_red":false,"text":"No CO detector was observed at time of inspection. "},{"checked":false,"id":1,"is_red":false,"text":"Tested and functional at time of inspection, but only the siren was tested, not the carbon monoxide sensor."},{"checked":false,"id":1,"is_red":false,"text":"Recommend contacting a licensed electrician to evaluate and offer repair options."}],"sepChoice":"4","title":"Electrical"},{"descr":"","id":2248,"options":[{"checked":false,"id":1,"is_red":false,"text":"GFCI in place and operational."},{"checked":false,"id":1,"is_red":false,"text":"GFCI did not respond to test, suggest replacing for safety."},{"checked":false,"id":1,"is_red":false,"text":"GFCI had power when tripped.  This is often the result of miswiring and is usually easily fixed.  Advise repair on replacement as needed."},{"checked":false,"id":1,"is_red":false,"text":"GFCI in this bathroom resets other bathroom receptacles."},{"checked":false,"id":1,"is_red":false,"text":"No GFCI protection present, suggest installing GFCI protected receptacles for safety."},{"checked":false,"id":1,"is_red":false,"text":"GFCI protected receptacles may not have been required when the house was built. We suggest buyer consider upgrading with GFCI's at all receptacles near water sources."},{"checked":false,"id":1,"is_red":false,"text":"GFCI, lights & fans on same circuit."},{"checked":false,"id":1,"is_red":false,"text":"Reset forthe GFCI is in the main panel."},{"checked":false,"id":1,"is_red":false,"text":"Reset for the GFCI is in the garage."},{"checked":false,"id":1,"is_red":false,"text":"Reset for the GFCI is in in the master bath."},{"checked":false,"id":1,"is_red":false,"text":"Reset for the GFCI is in the 1/2 bathroom."},{"checked":false,"id":1,"is_red":false,"text":"GFCI tested and functioned properly."},{"checked":false,"id":1,"is_red":false,"text":"Recommend upgrading All receptacle to GFCI protection within 6 feet of all potential wet locations."},{"checked":false,"id":1,"is_red":false,"text":"GFCI tested and found to be improperly wired. Recommend review and repair by Qualified Electrician. "},{"checked":false,"id":1,"is_red":false,"text":"GFCI reset at breaker panel <FYI>."},{"checked":false,"id":1,"is_red":false,"text":"One or more bathrooms lack the installation of an outlet <FYI>. Typically at least one outlet is installed for the use of personal grooming appliances ie hair dryer, curling iron, electric razor ect. Recommend upgrading home with the installation of a Ground Fault Circuit Interrupter receptacle at all applicable locations."},{"checked":false,"id":1,"is_red":false,"text":"GFCI protected receptacles may not have been required when the house was built. We suggest buyer consider upgrading with GFCI's at all receptacles near water sources."},{"checked":false,"id":1,"is_red":false,"text":"All original knob and tube wiring appears to have been removed."},{"checked":false,"id":1,"is_red":false,"text":"A low voltage alarm system is installed. Due to the specialized nature of these systems, we suggest that you review this system with the seller. As per our Inspection Agreement, this system is beyond the scope of this report and was not inspected."},{"checked":false,"id":1,"is_red":false,"text":"A low voltage intercom system is installed. Due to the specialized nature of these systems, we suggest that you review this system with the seller. As per our Inspection Agreement, this system is beyond the scope of this report and was not inspected."},{"checked":false,"id":1,"is_red":false,"text":"A low voltage alarm system and a low voltage intercom system are installed. Due to the specialized nature of these systems, we suggest that you review these systems with the seller. As per our Inspection Agreement, these systems are beyond the scope of this report and were not inspected."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum wiring is now a concern with insurance companies due to fire risk.  Buyer is urged to confirm insurability and any related conditions that insurance company may place on this house.  Further inspection of this system may be required.  The inspector CANNOT ensure compliance of this electrical system for insurance purposes."},{"checked":false,"id":1,"is_red":false,"text":"Dimming lights were observed, this may be an indication of inadequate electrical distribution. We recommend review by a licensed electrician for evaluation and redistribution as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Improper use of extension cord observed. Extension cords should not be permanently installed or be routed through walls, floors or partitions."},{"checked":false,"id":1,"is_red":false,"text":"Insulation has been installed over knob and tube wiring at various locations. This is a fire \"Safety Concern\". Suggest review by a licensed electrician prior to closing to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Knob and tube wiring was observed in this home. This type of wiring was standard at the time of construction, and unless otherwise noted, appears to be in serviceable condition."},{"checked":false,"id":1,"is_red":false,"text":"Missing cover plates observed, suggest installing for safety."},{"checked":false,"id":1,"is_red":false,"text":"Open junction boxes were observed, which is a safety concern. Recommend installing proper covers, as needed, for safety."},{"checked":false,"id":1,"is_red":false,"text":"Recommend full review by qualified electrical contractor for quotes on upgrades/repair to ensure safe and adequate service."},{"checked":false,"id":1,"is_red":false,"text":"Reversed polarity, hot and neutral reversed and other terms used for electric receptacles are usually easily corrected by minor wiring adjustments at the specified item. When these conditions are noted in this report, a licensed electrician should be consulted for repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Since ungrounded receptacles were noted in the home, buyer is cautioned that proper grounding is strongly urged where sensitive electronic equipment is used.  Ungrounded receptacles do not offer protection for computers etc.  Consultation with a qualified electrical contractor is recommended."},{"checked":false,"id":1,"is_red":false,"text":"Ungrounded receptacles observed at water sources or exterior locations ideally should be grounded, suggest installing GFCI's for safety."}],"sepChoice":"4","title":"GFCI"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Electrical Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"GFCI Overall"}],"title":"Electrical"},{"damage_panels":[{"descr":"","id":2249,"options":[{"checked":false,"id":1,"is_red":false,"text":"Some areas not accessible due to stored personal items."},{"checked":false,"id":1,"is_red":false,"text":"Limited review due to storage of personal property and finished walls."},{"checked":false,"id":1,"is_red":false,"text":"There is evidence of moisture entering structure. We recommend contacting a contractor experienced in exterior systems to evaluate the area and suggest repair options."},{"checked":false,"id":1,"is_red":false,"text":"Loose wall paneling is noted."},{"checked":false,"id":1,"is_red":false,"text":"There are loose mirrors noted."},{"checked":false,"id":1,"is_red":false,"text":"There is loose wall paper noted."},{"checked":false,"id":1,"is_red":false,"text":"There are areas still under construction. These areas are not tested."},{"checked":false,"id":1,"is_red":false,"text":"Missing drywall noted."},{"checked":false,"id":1,"is_red":false,"text":"Mold like stains are present under sink. We recommend having a mold sample taken and lab tested."},{"checked":false,"id":1,"is_red":false,"text":"Mold-like bio growth observed. Professional testing & evaluation advised."},{"checked":false,"id":1,"is_red":false,"text":"Vacuum system present, not tested consult owner"},{"checked":false,"id":1,"is_red":false,"text":"Loose baseboards in areas, these are easily re-secured with a hammer ad some 6-D finish nails."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of repairs observed, unable to determine the effectiveness of these repairs."},{"checked":false,"id":1,"is_red":false,"text":"Walls have been recently painted."},{"checked":false,"id":1,"is_red":false,"text":"There were signs of past water damage to baseboard and paneling; however, no active moisture was detected during the inspection."}],"sepChoice":"4","title":"Wall Condition"}],"inspection_panels":[{"descr":"","id":3082,"options":[{"checked":false,"id":1,"is_red":false,"text":"Drywall walls noted."},{"checked":false,"id":1,"is_red":false,"text":"Plaster walls noted."},{"checked":false,"id":1,"is_red":false,"text":"Wall paper finish noted."},{"checked":false,"id":1,"is_red":false,"text":"Painted finish noted."},{"checked":false,"id":1,"is_red":false,"text":"Walls are clad in paneling."},{"checked":false,"id":1,"is_red":false,"text":"Mirror panels are noted."},{"checked":false,"id":1,"is_red":false,"text":"The walls are clad in wood plank material. "},{"checked":false,"id":1,"is_red":false,"text":"There is a brick veneer noted."},{"checked":false,"id":1,"is_red":false,"text":"There is a stone veneer noted."},{"checked":false,"id":1,"is_red":false,"text":"Walls are clad in a laminate material."},{"checked":false,"id":1,"is_red":false,"text":"Walls are clad in granite panels."},{"checked":false,"id":1,"is_red":false,"text":"Cork finish noted."},{"checked":false,"id":1,"is_red":false,"text":"Walls are clad in ceramic tile."}],"sepChoice":"1","title":"Walls"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Wall Condition Overall"}],"title":"Walls"}],"title":"Kitchen"},{"id":17,"tabbed_panels":[{"damage_panels":[],"inspection_panels":[{"descr":"Locations:","id":3023,"options":[{"checked":false,"id":1,"is_red":false,"text":"Master#1"},{"checked":false,"id":1,"is_red":false,"text":"North East#2"},{"checked":false,"id":1,"is_red":false,"text":"South#2"},{"checked":false,"id":1,"is_red":false,"text":"North West#2"},{"checked":false,"id":1,"is_red":false,"text":"Hall#2"},{"checked":false,"id":1,"is_red":false,"text":"South West#3"},{"checked":false,"id":1,"is_red":false,"text":"North#3"},{"checked":false,"id":1,"is_red":false,"text":"West#2"},{"checked":false,"id":1,"is_red":false,"text":"kitchen area"},{"checked":false,"id":1,"is_red":false,"text":"Upstairs East#3"},{"checked":false,"id":1,"is_red":false,"text":"South East#3"},{"checked":false,"id":1,"is_red":false,"text":"North East#3"},{"checked":false,"id":1,"is_red":false,"text":"Upstairs hall#2"},{"checked":false,"id":1,"is_red":false,"text":"Downstairs#3"},{"checked":false,"id":1,"is_red":false,"text":"Upstairs Master#1"},{"checked":false,"id":1,"is_red":false,"text":"Upstairs North East"},{"checked":false,"id":1,"is_red":false,"text":"South West#4"},{"checked":false,"id":1,"is_red":false,"text":"Upstairs South East#2"},{"checked":false,"id":1,"is_red":false,"text":"Upstairs South West#3"},{"checked":false,"id":1,"is_red":false,"text":"Upstairs#1"},{"checked":false,"id":1,"is_red":false,"text":"Upstairs West#4"},{"checked":false,"id":1,"is_red":false,"text":"Upstairs  South#2"},{"checked":false,"id":1,"is_red":false,"text":"North Central#2"},{"checked":false,"id":1,"is_red":false,"text":"1/2 bath#3"},{"checked":false,"id":1,"is_red":false,"text":"Unit#1 through 5"},{"checked":false,"id":1,"is_red":false,"text":"Downstairs#5"},{"checked":false,"id":1,"is_red":false,"text":"In the garage area"},{"checked":false,"id":1,"is_red":false,"text":"Downstairs#3"},{"checked":false,"id":1,"is_red":false,"text":"Unit#1,2"},{"checked":false,"id":1,"is_red":false,"text":"South East#4"},{"checked":false,"id":1,"is_red":false,"text":"none present"},{"checked":false,"id":1,"is_red":false,"text":"Pool Area#4"},{"checked":false,"id":1,"is_red":false,"text":"Common area of Association"},{"checked":false,"id":1,"is_red":false,"text":"Bathroom Area"},{"checked":false,"id":1,"is_red":false,"text":"Guest#2"},{"checked":false,"id":1,"is_red":false,"text":"Hall"},{"checked":false,"id":1,"is_red":false,"text":"3/4 laundry area#2"},{"checked":false,"id":1,"is_red":false,"text":"none#1"},{"checked":false,"id":1,"is_red":false,"text":"South West#3"},{"checked":false,"id":1,"is_red":false,"text":"South#2"},{"checked":false,"id":1,"is_red":false,"text":"Jack & Jill#3"},{"checked":false,"id":1,"is_red":false,"text":"none"},{"checked":false,"id":1,"is_red":false,"text":"Half Bath#4"},{"checked":false,"id":1,"is_red":false,"text":"North East#3"},{"checked":false,"id":1,"is_red":false,"text":"Downstairs#3"},{"checked":false,"id":1,"is_red":false,"text":"South#2"},{"checked":false,"id":1,"is_red":false,"text":"East#3"},{"checked":false,"id":1,"is_red":false,"text":"North#4"},{"checked":false,"id":1,"is_red":false,"text":"South"}],"sepChoice":"1","title":"Locations"}],"pictures":[],"ratings":[],"title":"Locations"},{"damage_panels":[{"descr":"","id":2079,"options":[{"checked":false,"id":1,"is_red":false,"text":"Most not accessible due to stored personal items."},{"checked":false,"id":1,"is_red":false,"text":"No deficiencies observed."},{"checked":false,"id":1,"is_red":false,"text":"No deficiencies observed on all kitchen cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Appeared functional and in satisfactory condition, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Recommend adding additional cabinet screws as drywall screws have been used."},{"checked":false,"id":1,"is_red":false,"text":"Loose at wall. Needs immediate attention. "},{"checked":false,"id":1,"is_red":false,"text":"DEFERRED COST:  The cabinets are original. Consider upgrade.."},{"checked":false,"id":1,"is_red":false,"text":"Appeared functional, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Some cabinet doors need magnets or hardware to stay shut. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Some cabinet drawers  need  hardware repair/adjustment (to stay shut). Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Drawers are difficult to slide. It appears that if the guides are lubricated, that will correct the problem."},{"checked":false,"id":1,"is_red":false,"text":"Broken drawer guides noted. Recommend having a qualified contractor replace the guides."},{"checked":false,"id":1,"is_red":false,"text":"Noted cabinet(s) loose on the wall. Recommend having a qualified contractor re-fasten the cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Noted cabinet(s) loose at the floor. Recommend having a qualified contractor re-fasten the cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Noted cabinet(s) loose at the ceiling. Recommend having a qualified contractor re-fasten the cabinets."},{"checked":false,"id":1,"is_red":false,"text":"There appears to be water damage under sink. This tested dry at the time of the inspection, but monitor for any further intrusion."},{"checked":false,"id":1,"is_red":false,"text":"The sliding cabinet doors were difficult to slide. It appears that lubrication will correct the problem."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors missing, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors missing hardware, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawers missing, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors have broken hinges, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawers missing handles, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawers off their guides, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors have loose hardware, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors missing knobs, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawer face is missing, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet drawer face is loose, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Cabinet doors have broken glass panels in them, consult with seller on repair/ replacement options."},{"checked":false,"id":1,"is_red":false,"text":"Drawer(s) bind in tracks"},{"checked":false,"id":1,"is_red":false,"text":"Drawer(s) unsupported in cabinets."},{"checked":false,"id":1,"is_red":false,"text":"Shelving missing or damaged."},{"checked":false,"id":1,"is_red":false,"text":"Lazy Susan cabinet binds and does not turn smoothly."}],"sepChoice":"4","title":"Cabinets"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Cabinets Overall"}],"title":"Cabinets"},{"damage_panels":[{"descr":"","id":2080,"options":[{"checked":false,"id":1,"is_red":false,"text":"Plastic laminate tops noted."},{"checked":false,"id":1,"is_red":false,"text":"Solid Surface tops noted."},{"checked":false,"id":1,"is_red":false,"text":"Granite tops noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood counter tops noted."},{"checked":false,"id":1,"is_red":false,"text":"There is normal wear noted for the age of the counter tops."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops are stained. Normal cleaning should take care of this."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops appear to be worn and may have reached the end of their useful life."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops are noted as being chipped."},{"checked":false,"id":1,"is_red":false,"text":"No discrepancies noted."},{"checked":false,"id":1,"is_red":false,"text":"Some of the areas not visible due to stored personal items."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops appear to be loose on the cabinet. We recommend having a qualified contractor re-fasten them."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops are noted as having loose Formica. We recommend having a qualified contractor re-fasten it."},{"checked":false,"id":1,"is_red":false,"text":"Granite backsplash appears to not have been caulked when installed--except just behind sink.  Recommend sealing with clear silicone caulk along entire length of backsplash.  This prevents water leaks from spills and counter cleanups."},{"checked":false,"id":1,"is_red":false,"text":"Laminated countertop is swollen and beginning to blister @@lLOCATION@@. This is a cosmetic issue for your information. Repair as necessary."},{"checked":false,"id":1,"is_red":false,"text":"The counter tops are noted as cracked or damaged."}],"sepChoice":"4","title":"Counters"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Counters Overall"}],"title":"Counters"},{"damage_panels":[{"descr":"","id":2082,"options":[{"checked":false,"id":1,"is_red":false,"text":"Could not fully inspect the dryer vent, it is obscured by cabinetry."},{"checked":false,"id":1,"is_red":false,"text":"The dryer vent is missing the exterior cover."},{"checked":false,"id":1,"is_red":false,"text":"The dryer vent has a damaged exterior cover."},{"checked":false,"id":1,"is_red":false,"text":"The dryer vent has loose exterior cover."},{"checked":false,"id":1,"is_red":false,"text":"The dryer vent does not extend to the exterior."},{"checked":false,"id":1,"is_red":false,"text":"The dryer vent terminates in the garage."},{"checked":false,"id":1,"is_red":false,"text":"The dryer vent terminates under structure."},{"checked":false,"id":1,"is_red":false,"text":"The dryer vent pipe is crushed in spots. This should be replaced due to the fact that lint can accumulate in the crushed areas and catch fire."},{"checked":false,"id":1,"is_red":false,"text":"The dryer vent pipe is damaged."},{"checked":false,"id":1,"is_red":false,"text":"Irregular vent pipe at the fire wall noted."},{"checked":false,"id":1,"is_red":false,"text":"Irregular materials were used to create a dryer vent. Recommend replacing the vent pipe with the proper materials."}],"sepChoice":"4","title":"Dryer Vent"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Dryer Vent Overall"}],"title":"Dryer Vent"},{"damage_panels":[{"descr":"","id":2083,"options":[{"checked":false,"id":1,"is_red":false,"text":"Some outlets not accessible due to furniture and or stored personal items."},{"checked":false,"id":1,"is_red":false,"text":"It is HIGHLY recommended to (have a qualified electrician) install an Arc Fault Circuit Interrupter breaker in place of the the one currently protecting the bedroom circuits. In the near future it will be a requirement and is a very safe and sound update."},{"checked":false,"id":1,"is_red":false,"text":"Bedroom circuits are NOT protected by an arc fault circuit interrupter type breaker. An arc fault interrupter will shut itself off if it detects a short, thus preventing an electrical fire."},{"checked":false,"id":1,"is_red":false,"text":"No Arc-Fault Circuit Interrupter (AFCI) protection was installed to protect electrical circuits in bedrooms.\n Building codes with which new homes must comply require the installation of AFCI protection of all bedroom outlets. This type of protection is designed to detect electrical arcing, which is a potential fire hazard. \nAlthough AFCI protection was not required at the time the home was originally constructed, as general knowledge of safe building practices has improved with the passage of time, building standards have changed to reflect current understanding. Consider updating the existing electrical to provide AFCI protection.\nArc-fault protection can be provided using either of two methods:\n1. Arc Fault Circuit Interrupters (AFCI's) electrical outlets which have this capability built in. \n2. AFCI circuit breakers installed at the main electrical panel which provide this protection to all non-AFCI outlets on the circuit controlled by that AFCI breaker.\n\n"},{"checked":false,"id":1,"is_red":false,"text":"Test AFCI breakers periodically to ensure proper operation."},{"checked":false,"id":1,"is_red":false,"text":"2-prong outlets -\nThe home contained outdated, ungrounded 2-prong electrical outlets. Although this condition may have been commonly considered safe or acceptable at the time the home was originally constructed, as general knowledge of safe building practices has improved with the passage of time, building standards have changed to reflect current understanding. Consider updating the existing condition to meet generally-accepted current standards.\n"},{"checked":false,"id":1,"is_red":false,"text":"Some loose and improperly installed receptacles were found, they should be installed correctly by a licensed electrician. Several are wired in reverse, one is poorly grounding."},{"checked":false,"id":1,"is_red":false,"text":"Some receptacles were painted over."},{"checked":false,"id":1,"is_red":false,"text":"It is recommended to avoid use of multiplier outlet plug ins ( converts 2 into 6 outlets )."},{"checked":false,"id":1,"is_red":false,"text":"Missing outlet covers - throughout home.  See pictures."},{"checked":false,"id":1,"is_red":false,"text":"Open ground - receptacle in wall across from windows in dining room."},{"checked":false,"id":1,"is_red":false,"text":"Several outlets were found to have been reverse polarity wired, see pics for locations. Have an electrician evaluate and repair."},{"checked":false,"id":1,"is_red":false,"text":"Reverse polarity- 2 receptacles. one in dining room left of window, one in front room on same wall as door. Have electrician rewire."},{"checked":false,"id":1,"is_red":false,"text":"Most receptacles , except where noted, are in fair condition and tested ok, some are painted over."},{"checked":false,"id":1,"is_red":false,"text":"Open ground- receptacle in basement."},{"checked":false,"id":1,"is_red":false,"text":"Have a qualified electrician repair items listed following a complete evaluation of the electrical system."},{"checked":false,"id":1,"is_red":false,"text":"The receptacles near laundry machines are polarized and should be GFCI."},{"checked":false,"id":1,"is_red":false,"text":"The majority of grounded receptacles , were tested and found to be wired correctly."},{"checked":false,"id":1,"is_red":false,"text":"Loose receptacle outlet to left of entrance door."},{"checked":false,"id":1,"is_red":false,"text":"Missing switch plate covers were found, make sure they are replaced."},{"checked":false,"id":1,"is_red":false,"text":"Worn switches noted."},{"checked":false,"id":1,"is_red":false,"text":"Worn outlets noted."},{"checked":false,"id":1,"is_red":false,"text":"Outlet cover plates missing."},{"checked":false,"id":1,"is_red":false,"text":"Switch cover plates missing."},{"checked":false,"id":1,"is_red":false,"text":"Loose outlets noted."},{"checked":false,"id":1,"is_red":false,"text":"Loose switches noted."},{"checked":false,"id":1,"is_red":false,"text":"All original knob and tube wiring appears to have been removed."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum wiring is now a concern with insurance companies due to fire risk.  Buyer is urged to confirm insurability and any related conditions that insurance company may place on this house.  Further inspection of this system may be required.  The inspector CANNOT ensure compliance of this electrical system for insurance purposes."},{"checked":false,"id":1,"is_red":false,"text":"Dimming lights were observed, this may be an indication of inadequate electrical distribution. We recommend review by a licensed electrician for evaluation and redistribution as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Improper use of extension cord observed. Extension cords should not be permanently installed or be routed through walls, floors or partitions."},{"checked":false,"id":1,"is_red":false,"text":"Insulation has been installed over knob and tube wiring at various locations. This is a fire \"Safety Concern\". Suggest review by a licensed electrician prior to closing to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Knob and tube wiring was observed in this home. This type of wiring was standard at the time of construction, and unless otherwise noted, appears to be in serviceable condition."},{"checked":false,"id":1,"is_red":false,"text":"Missing cover plates observed, suggest installing for safety."},{"checked":false,"id":1,"is_red":false,"text":"Open junction boxes were observed, which is a safety concern. Recommend installing proper covers, as needed, for safety."},{"checked":false,"id":1,"is_red":false,"text":"Recommend full review by qualified electrical contractor for quotes on upgrades/repair to ensure safe and adequate service."},{"checked":false,"id":1,"is_red":false,"text":"Reversed polarity, hot and neutral reversed and other terms used for electric receptacles are usually easily corrected by minor wiring adjustments at the specified item. When these conditions are noted in this report, a licensed electrician should be consulted for repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Since ungrounded receptacles were noted in the home, buyer is cautioned that proper grounding is strongly urged where sensitive electronic equipment is used.  Ungrounded receptacles do not offer protection for computers etc.  Consultation with a qualified electrical contractor is recommended."},{"checked":false,"id":1,"is_red":false,"text":"Ungrounded receptacles observed at water sources or exterior locations ideally should be grounded, suggest installing GFCI's for safety."}],"sepChoice":"4","title":"Electrical"},{"descr":"","id":2084,"options":[{"checked":false,"id":1,"is_red":false,"text":"GFCI did not respond to test, suggest replacing for safety."},{"checked":false,"id":1,"is_red":false,"text":"GFCI had power when tripped.  This is often the result of miswiring and is usually easily fixed.  Advise repair on replacement as needed."},{"checked":false,"id":1,"is_red":false,"text":"GFCI in place and operational"},{"checked":false,"id":1,"is_red":false,"text":"The laundry receptacle should be GFCI protected type."},{"checked":false,"id":1,"is_red":false,"text":"The receptacles near laundry machines are polarized and should be GFCI"},{"checked":false,"id":1,"is_red":false,"text":"GFCI protected receptacles may not have been required when the house was built. We suggest buyer consider upgrading with GFCI's at all receptacles near water sources."},{"checked":false,"id":1,"is_red":false,"text":"No GFCI protection present, suggest installing GFCI protected receptacles for safety."},{"checked":false,"id":1,"is_red":false,"text":"GFCI, lights & fans on same circuit"},{"checked":false,"id":1,"is_red":false,"text":"Reset forthe GFCI is in the main panel."},{"checked":false,"id":1,"is_red":false,"text":"Reset for the GFCI is in the garage."},{"checked":false,"id":1,"is_red":false,"text":"Reset for the GFCI is in in the master bath."},{"checked":false,"id":1,"is_red":false,"text":"Reset for the GFCI is in the 1/2 bathroom."},{"checked":false,"id":1,"is_red":false,"text":"GFCI tested and functioned properly"},{"checked":false,"id":1,"is_red":false,"text":"Recommend upgrading All receptacle to GFCI protection within 6 feet of all potential wet locations."},{"checked":false,"id":1,"is_red":false,"text":"GFCI tested and found to be improperly wired. Recommend review and repair by Qualified Electrician. "},{"checked":false,"id":1,"is_red":false,"text":"GFCI reset at breaker panel <FYI>"},{"checked":false,"id":1,"is_red":false,"text":"One or more bathrooms lack the installation of an outlet <FYI>. Typically at least one outlet is installed for the use of personal grooming appliances ie hair dryer, curling iron, electric razor ect. Recommend upgrading home with the installation of a Ground Fault Circuit Interrupter receptacle at all applicable locations."},{"checked":false,"id":1,"is_red":false,"text":"GFCI protected receptacles may not have been required when the house was built. We suggest buyer consider upgrading with GFCI's at all receptacles near water sources."},{"checked":false,"id":1,"is_red":false,"text":"Ungrounded receptacles observed at water sources or exterior locations ideally should be grounded, suggest installing GFCI's for safety."},{"checked":false,"id":1,"is_red":false,"text":"Dimming lights were observed, this may be an indication of inadequate electrical distribution. We recommend review by a licensed electrician for evaluation and redistribution as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Improper use of extension cord observed. Extension cords should not be permanently installed or be routed through walls, floors or partitions."},{"checked":false,"id":1,"is_red":false,"text":"Missing cover plates observed, suggest installing for safety."},{"checked":false,"id":1,"is_red":false,"text":"Open junction boxes were observed, which is a safety concern. Recommend installing proper covers, as needed, for safety."},{"checked":false,"id":1,"is_red":false,"text":"Recommend full review by qualified electrical contractor for quotes on upgrades/repair to ensure safe and adequate service."},{"checked":false,"id":1,"is_red":false,"text":"Reversed polarity, hot and neutral reversed and other terms used for electric receptacles are usually easily corrected by minor wiring adjustments at the specified item. When these conditions are noted in this report, a licensed electrician should be consulted for repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Since ungrounded receptacles were noted in the home, buyer is cautioned that proper grounding is strongly urged where sensitive electronic equipment is used.  Ungrounded receptacles do not offer protection for computers etc.  Consultation with a qualified electrical contractor is recommended."}],"sepChoice":"4","title":"GFCI"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Electrical Overall"},{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"GFCI Overall"}],"title":"Electrical"},{"damage_panels":[{"descr":"","id":2085,"options":[{"checked":false,"id":1,"is_red":false,"text":"None present."},{"checked":false,"id":1,"is_red":false,"text":"The exhaust fan was operated and no issues were found."},{"checked":false,"id":1,"is_red":false,"text":"The exhaust fan is a worn unit which may be at the end of its useful life."},{"checked":false,"id":1,"is_red":false,"text":"Exhaust fan is inoperable."},{"checked":false,"id":1,"is_red":false,"text":"Exhaust fan is noisy.\n"},{"checked":false,"id":1,"is_red":false,"text":"Exhaust fan vibrates or is excessively noisy. This may indicate a worn armature or bearings. The fan may eventually need to be replaced to correct this condition."},{"checked":false,"id":1,"is_red":false,"text":"Fan is a slow starter, suggest having motor professionally cleaned."},{"checked":false,"id":1,"is_red":false,"text":"Fan is covered with plastic, did not test."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the exhaust fan is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Recommend replacement of the fan by a qualified electrical contractor."},{"checked":false,"id":1,"is_red":false,"text":"The fan terminates improperly in the attic. This can create excessive moisture. Recommend directing the vent towards the exterior to allow for proper ventilation."},{"checked":false,"id":1,"is_red":false,"text":"Appeared functional, at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Did not operate when tested."},{"checked":false,"id":1,"is_red":false,"text":"The vent pipe from the exhaust fan terminates and is pointed at the attic roof ridge vent/soffit vent/gable vent. Although, this was within standard building practice at the time this house was built--This is less efficient and can cause a buildup of moisture and eventually mold in the attic.   Recommend upgrading to properly route vent(s) to the exterior of the home."}],"sepChoice":"4","title":"Exhaust Fan"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Exhaust Fan Overall"}],"title":"Exhaust Fan"},{"damage_panels":[{"descr":"","id":2088,"options":[{"checked":false,"id":1,"is_red":false,"text":"No gas present."},{"checked":false,"id":1,"is_red":false,"text":"Gas line not secure."},{"checked":false,"id":1,"is_red":false,"text":"Valve in off position."},{"checked":false,"id":1,"is_red":false,"text":"None visible."},{"checked":false,"id":1,"is_red":false,"text":"No gas shut off valves were present on the gas heated dryer. This is a safety and servicing issue."},{"checked":false,"id":1,"is_red":false,"text":"Gas shut off valves were present and functional."},{"checked":false,"id":1,"is_red":false,"text":"The gas shut off valve was observed in the off position. the inspection of this appliance could not be completed."},{"checked":false,"id":1,"is_red":false,"text":"There are visible oil leaks. This is considered a hazardous condition. Immediate review by a  licenced contractor is recommended to ensure safety."}],"sepChoice":"4","title":"Gas Valves"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Gas Valves Overall"}],"title":"Gas Valve"},{"damage_panels":[{"descr":"","id":2091,"options":[{"checked":false,"id":1,"is_red":false,"text":"DRAINS:"},{"checked":false,"id":1,"is_red":false,"text":"Drain line leaks under sink. "},{"checked":false,"id":1,"is_red":false,"text":"Stains from presumed past leaks noted."},{"checked":false,"id":1,"is_red":false,"text":"Note that without water the sink(s) and dishwasher could not be evaluated."},{"checked":false,"id":1,"is_red":false,"text":"Slow drain at sink.  Recommend clearing. "},{"checked":false,"id":1,"is_red":false,"text":"Slow drain at sink with gurgling which may indicate that the drain line needs to be cleaned and/or that the drain is not properly vented. "},{"checked":false,"id":1,"is_red":false,"text":"Evidence of past or present rodents under kitchen sink.  "},{"checked":false,"id":1,"is_red":false,"text":"Stains at sink cabinet floor, presumably from past leak(s) or spilled products."},{"checked":false,"id":1,"is_red":false,"text":"SUPPLY:"},{"checked":false,"id":1,"is_red":false,"text":"Faucet leaks at base. "},{"checked":false,"id":1,"is_red":false,"text":"The hot & cold  water supplies are reversed. This is not a functional problem but to someone who is not familiar with this condition unexpected hot water could scald them. We suggest contacting a qualified plumbing contractor to repair."},{"checked":false,"id":1,"is_red":false,"text":"Faucet drips. "},{"checked":false,"id":1,"is_red":false,"text":"Faucet leaks at base."},{"checked":false,"id":1,"is_red":false,"text":"Supply line leaks. "},{"checked":false,"id":1,"is_red":false,"text":"No shutoff \"stop\" apparent. "},{"checked":false,"id":1,"is_red":false,"text":"Poor pressure flow when running several fixtures in one area."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the sink is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Sink appears to have been refinished, suggest taking care when cleaning to protect the surface."},{"checked":false,"id":1,"is_red":false,"text":"Sink is leaking at the time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Sink is loose, suggest securing as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Stopper is missing/inoperable."},{"checked":false,"id":1,"is_red":false,"text":"Suggest caulking as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Sink chipped (Cosmetic; does not affect function). "},{"checked":false,"id":1,"is_red":false,"text":"Sink rusted.  Monitor for developing leaks (none found during inspection)."},{"checked":false,"id":1,"is_red":false,"text":"Sink is poorly anchored."},{"checked":false,"id":1,"is_red":false,"text":"Stains from presumed past leaks noted."},{"checked":false,"id":1,"is_red":false,"text":"Note that without water the sink(s) and dishwasher could not be evaluated."},{"checked":false,"id":1,"is_red":false,"text":"Slow drain at sink.  Recommend clearing. "},{"checked":false,"id":1,"is_red":false,"text":"Slow drain at sink with gurgling which may indicate that the drain line needs to be cleaned and/or that the drain is not properly vented. "},{"checked":false,"id":1,"is_red":false,"text":"Evidence of past or present rodents under kitchen sink.  "},{"checked":false,"id":1,"is_red":false,"text":"Stains at sink cabinet floor, presumably from past leak(s) or spilled products."},{"checked":false,"id":1,"is_red":false,"text":"Sink backed up in laundry room."},{"checked":false,"id":1,"is_red":false,"text":"The laundry sink drain pipe is leaking."},{"checked":false,"id":1,"is_red":false,"text":"The laundry faucet leaks."},{"checked":false,"id":1,"is_red":false,"text":"The laundry sink is improperly secured."},{"checked":false,"id":1,"is_red":false,"text":"The laundry sink is cracked."},{"checked":false,"id":1,"is_red":false,"text":"The piping to the sink was not installed properly."}],"sepChoice":"4","title":"Wash Basin"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Wash Basin Overall"}],"title":"Wash Basin"},{"damage_panels":[{"descr":"","id":2221,"options":[{"checked":false,"id":1,"is_red":false,"text":"Some of the floors in this building are a vintage 9x9 tile size; be advised that these tiles may be the type that had an adhesive containing asbestos. Asbestos is a health risk when it is made friable - in other words, when its fibres and dust can be breathed in by the lungs. to be safe, please refrain from removal and damaging these tiles until it is certain they are not asbestos containing material.  "},{"checked":false,"id":1,"is_red":false,"text":"Floor is not level. Suggest further evaluation by a licensed contractor within the inspection contingency period."},{"checked":false,"id":1,"is_red":false,"text":"Laminate floating floor system was installed with poor workmanship techniques, gaps, under size cuts, and chips are visible giving a less than appealing appearance and likely lowering the serviceable life of the flooring."},{"checked":false,"id":1,"is_red":false,"text":"It appears the existing carpeting was installed over the concrete slab without a moisture barrier;this is not a good installation method. The moisture content in the concrete can create the growth of organic materials \"Mold\" in the carpet. Recommend contacting a qualified contractor for further evaluation."},{"checked":false,"id":1,"is_red":false,"text":"Only the sub flooring is present and it is inconsistent in installation."},{"checked":false,"id":1,"is_red":false,"text":"Damaged grout observed, suggest regrouting as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Common cracks noted."},{"checked":false,"id":1,"is_red":false,"text":"Cracked tiles noted."},{"checked":false,"id":1,"is_red":false,"text":"Cracking noted in ceramic tiles.  This is an indication of inadequate subfloor installation."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of repairs observed, unable to determine the effectiveness of these repairs."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the floor is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"Minor damage noted."},{"checked":false,"id":1,"is_red":false,"text":"Numerous cracked tiles noted."},{"checked":false,"id":1,"is_red":false,"text":"Open seams observed."},{"checked":false,"id":1,"is_red":false,"text":"Popping floor tile observed."},{"checked":false,"id":1,"is_red":false,"text":"Possible trip hazard. This is a safety concern. Suggest repair/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review by a qualified professional for repair or replacement, as necessary, prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Recommend sealing cracks/voids."},{"checked":false,"id":1,"is_red":false,"text":"Tile has been painted/refinished, suggest taking care when cleaning to protect the surface."},{"checked":false,"id":1,"is_red":false,"text":"Water damage observed."},{"checked":false,"id":1,"is_red":false,"text":"Carpet is not recommended in bathrooms due to potential to harbor moisture, which could lead to unwanted mold issues."},{"checked":false,"id":1,"is_red":false,"text":"Recommend caulking at the tub and shower areas"},{"checked":false,"id":1,"is_red":false,"text":"Flooring appears to have damaged subfloor due to plumbing leak ."}],"sepChoice":"4","title":"Floor Condition"}],"inspection_panels":[{"descr":"","id":3071,"options":[{"checked":false,"id":1,"is_red":false,"text":"Carpet is noted."},{"checked":false,"id":1,"is_red":false,"text":"Ceramic tile is noted."},{"checked":false,"id":1,"is_red":false,"text":"Sheet vinyl flooring is noted."},{"checked":false,"id":1,"is_red":false,"text":"Hardwood flooring is noted."},{"checked":false,"id":1,"is_red":false,"text":"Floating laminate type flooring noted."},{"checked":false,"id":1,"is_red":false,"text":"Marble floors noted."},{"checked":false,"id":1,"is_red":false,"text":"Natural stone floors noted."},{"checked":false,"id":1,"is_red":false,"text":"Bare concrete floors noted."},{"checked":false,"id":1,"is_red":false,"text":"Plywood subfloor is exposed."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl squares (tiles) are noted"}],"sepChoice":"1","title":"Floors"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Floor Condition Overall"}],"title":"Floors"},{"damage_panels":[{"descr":"","id":2223,"options":[{"checked":false,"id":1,"is_red":false,"text":"Some not accessible."},{"checked":false,"id":1,"is_red":false,"text":"Flex drain observed, these are subject to frequent clogging."},{"checked":false,"id":1,"is_red":false,"text":"Improper \"S\" trap noted.  This trap configuration may cause the trap to siphon dry, allowing sewer gas and odour to enter the dwelling.  This situation may rectified by the installation of an anti siphon devise (cheater vent).  Suggest repair by a qualified professional.  In the alternative, run a little bit of water into the sink to reseal the trap if odour is detected."},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the drain is near the end of its useful life due to ."},{"checked":false,"id":1,"is_red":false,"text":"Limited review due to personal property stored in undersink cabinet."},{"checked":false,"id":1,"is_red":false,"text":"No drain trap observed."},{"checked":false,"id":1,"is_red":false,"text":"No way to determine presence of trap under sink as it is (if present) concealed between subfloor and ceiling finish."},{"checked":false,"id":1,"is_red":false,"text":"Older style metal traps noted.  Buyer is cautioned that these traps can leak at any time due to corrosion."},{"checked":false,"id":1,"is_red":false,"text":"Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Sink drain assembly is loose, no leaks observed."},{"checked":false,"id":1,"is_red":false,"text":"Unable to inspect due to cabinet design, inaccessible."},{"checked":false,"id":1,"is_red":false,"text":"Water was off at time of the inspection. Unable to determine the condition of the system and/or the function of plumbing fixtures. We recommend confirming proper operation of all plumbing appliances and fixtures prior to close."},{"checked":false,"id":1,"is_red":false,"text":"Illegal flex drain used under kitchen sink. Should be replaced with correct part by licensed plumber."},{"checked":false,"id":1,"is_red":false,"text":"Illegal plastic flex line used on bathroom sink drain."},{"checked":false,"id":1,"is_red":false,"text":"S traps present- these may cause dry traps, slow drains or loud drainage."},{"checked":false,"id":1,"is_red":false,"text":"Most not accessible due to personal items."},{"checked":false,"id":1,"is_red":false,"text":"Worn fixtures are noted."},{"checked":false,"id":1,"is_red":false,"text":"Visible leaking noted under the sink. We recommend contacting a licensed plumbing contractor for repair options."},{"checked":false,"id":1,"is_red":false,"text":"The hot & cold  water supplies are reversed. This is not a functional problem but to someone who is not familiar with this condition unexpected hot water could scald them. We suggest contacting a qualified plumbing contractor to repair."},{"checked":false,"id":1,"is_red":false,"text":"pressure weakens when other areas are in use"},{"checked":false,"id":1,"is_red":false,"text":"Copper to galvanized connection missing proper fittings. This can create a galvanic reaction which will eat away at the pipes."}],"sepChoice":"4","title":"Plumbing"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Plumbing Overall"}],"title":"Plumbing"},{"damage_panels":[{"descr":"","id":2228,"options":[{"checked":false,"id":1,"is_red":false,"text":"Some areas not accessible due to stored personal items."},{"checked":false,"id":1,"is_red":false,"text":"There is evidence of moisture entering structure. We recommend contacting a contractor experienced in exterior systems to evaluate the area and suggest repair options."},{"checked":false,"id":1,"is_red":false,"text":"Loose wall paneling is noted."},{"checked":false,"id":1,"is_red":false,"text":"There are loose mirrors noted."},{"checked":false,"id":1,"is_red":false,"text":"There is loose wall paper noted."},{"checked":false,"id":1,"is_red":false,"text":"There are areas still under construction. These areas are not tested."},{"checked":false,"id":1,"is_red":false,"text":"Missing drywall noted."},{"checked":false,"id":1,"is_red":false,"text":"Mold like stains are present under sink. We recommend having a mold sample taken and lab tested."},{"checked":false,"id":1,"is_red":false,"text":"Vacuum system present, not tested consult owner"},{"checked":false,"id":1,"is_red":false,"text":"Loose baseboards in areas, these are easily re-secured with a hammer ad some 6-D finish nails."}],"sepChoice":"4","title":"Wall Condition"}],"inspection_panels":[{"descr":"","id":3076,"options":[{"checked":false,"id":1,"is_red":false,"text":"Drywall walls noted."},{"checked":false,"id":1,"is_red":false,"text":"Plaster walls noted."},{"checked":false,"id":1,"is_red":false,"text":"Wall paper finish noted."},{"checked":false,"id":1,"is_red":false,"text":"Painted finish noted."},{"checked":false,"id":1,"is_red":false,"text":"Walls are clad in paneling."},{"checked":false,"id":1,"is_red":false,"text":"Mirror panels are noted."},{"checked":false,"id":1,"is_red":false,"text":"The walls are clad in wood plank material. "},{"checked":false,"id":1,"is_red":false,"text":"There is a brick veneer noted."},{"checked":false,"id":1,"is_red":false,"text":"There is a stone veneer noted."},{"checked":false,"id":1,"is_red":false,"text":"Walls are clad in a laminate material."},{"checked":false,"id":1,"is_red":false,"text":"Walls are clad in granite panels."},{"checked":false,"id":1,"is_red":false,"text":"Cork finish noted."},{"checked":false,"id":1,"is_red":false,"text":"Walls are clad in ceramic tile."}],"sepChoice":"1","title":"Walls"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Wall Condition Overall"}],"title":"Walls"},{"damage_panels":[{"descr":"","id":2229,"options":[{"checked":false,"id":1,"is_red":false,"text":"Small cracking in the wall finish is noted. This is probably caused by the joint compound (spackle) drying too quickly during application. "},{"checked":false,"id":1,"is_red":false,"text":"Minor damage from what appears to be from excess moisture noted. Recommend review of current vent fan and possibly installing a timer to assure that fan is used during showers."},{"checked":false,"id":1,"is_red":false,"text":"The drywall is patched in areas. The reason for the patch could not be determined. "},{"checked":false,"id":1,"is_red":false,"text":"Small stains noted on the ceiling. They tested dry at the time of the inspection."},{"checked":false,"id":1,"is_red":false,"text":"Large stains noted on the ceiling. They tested dry at the time of the inspection."},{"checked":false,"id":1,"is_red":false,"text":"Evidence of past leaking was noted."},{"checked":false,"id":1,"is_red":false,"text":"There were signs of paint blistering on the ceiling. The areas tested dry at the time of the inspection, but should be monitored for further damage or possibly water intrusion."},{"checked":false,"id":1,"is_red":false,"text":"The inspector could not access the area around the skylight."},{"checked":false,"id":1,"is_red":false,"text":"Visible leaking noted on the ceiling. We recommend contacting a qualified contractor to evaluate the roof and the drywall in this area and repair as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Freshly painted in areas. This could be concealing a defect that could not be determined."},{"checked":false,"id":1,"is_red":false,"text":"Mold like stains present on the ceiling. We recommend having a mold sample taken and lab tested, also monitor the area for water intrusion."},{"checked":false,"id":1,"is_red":false,"text":"Extensive water damage to general area of ceiling where the past leaking had occurred. Areas are marked with peeling paint and bulging drywall. Have a contractor evaluate."},{"checked":false,"id":1,"is_red":false,"text":"There is an anomaly present a the point in the ceiling that adjoins the inner wall. It appears there is a bowing / sagging in the corner. It is not clear as to what may have caused this. Ask association about this issue and about past occurrences that may be linked to this issue."},{"checked":false,"id":1,"is_red":false,"text":"The ceiling was not painted all the way to the edge in kitchen."},{"checked":false,"id":1,"is_red":false,"text":"The drywall installation is not entirely professional quality, have a contractor evaluate."}],"sepChoice":"4","title":"Ceiling Condition"}],"inspection_panels":[{"descr":"","id":3077,"options":[{"checked":false,"id":1,"is_red":false,"text":"There are drywall ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"There are plaster ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"There are acoustic grid and tile ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"There are wood plank ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"There are metal pan ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"Open beam ceiling construction noted."},{"checked":false,"id":1,"is_red":false,"text":"There is panel lighting present in the ceiling."},{"checked":false,"id":1,"is_red":false,"text":"The ceilings are clad in wood paneling."},{"checked":false,"id":1,"is_red":false,"text":"Cathedral style (vaulted) ceilings noted."},{"checked":false,"id":1,"is_red":false,"text":"Mirror panels are noted on the ceilings."},{"checked":false,"id":1,"is_red":false,"text":"The ceilings are clad in cork."},{"checked":false,"id":1,"is_red":false,"text":"The ceilings are clad in a laminate material."},{"checked":false,"id":1,"is_red":false,"text":"The ceilings are clad in tile squares."}],"sepChoice":"1","title":"Ceilings"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Ceiling Condition Overall"}],"title":"Ceilings"},{"damage_panels":[{"descr":"","id":2230,"options":[{"checked":false,"id":1,"is_red":false,"text":"No security bars are present in this room."},{"checked":false,"id":1,"is_red":false,"text":"The security bars were operated and appeared functional."},{"checked":false,"id":1,"is_red":false,"text":"The security bars did not operate, this is not to building standards."},{"checked":false,"id":1,"is_red":false,"text":"The security bars are missing hardware, compromising their effective usage."},{"checked":false,"id":1,"is_red":false,"text":"The security bars were bent and appeared to not function properly."},{"checked":false,"id":1,"is_red":false,"text":"The security bars were rusted and appeared to not function properly."}],"sepChoice":"4","title":"Security Bars"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Security Bars Overall"}],"title":"Security Bars"},{"damage_panels":[{"descr":"","id":2231,"options":[{"checked":false,"id":1,"is_red":false,"text":"No major system safety or function concerns noted at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"Door doesn't latch properly."},{"checked":false,"id":1,"is_red":false,"text":"Door binds in jamb or floor."},{"checked":false,"id":1,"is_red":false,"text":"Door damaged."},{"checked":false,"id":1,"is_red":false,"text":"Door missing."},{"checked":false,"id":1,"is_red":false,"text":"Door handle missing."},{"checked":false,"id":1,"is_red":false,"text":"Door handle loose."},{"checked":false,"id":1,"is_red":false,"text":"Pocket door does not latch or lock."},{"checked":false,"id":1,"is_red":false,"text":"Sliding Door(s) are not securely installed on tracks "},{"checked":false,"id":1,"is_red":false,"text":"Condensation present in sliding door double-paned window(s), suggesting a broken gas seal."},{"checked":false,"id":1,"is_red":false,"text":"Some door stop(s) missing / ineffective; recommend installation to avoid unnecessary wall or door damage.  "},{"checked":false,"id":1,"is_red":false,"text":"Doors are non-standard, which is characteristic for a house of this age."},{"checked":false,"id":1,"is_red":false,"text":"Low headroom at basement stairwell which is common for a house of this age."},{"checked":false,"id":1,"is_red":false,"text":"Door to basement opens over stairs.  Use caution; by modern standards, it should open into structure or onto a landing to prevent personal injury from falls."},{"checked":false,"id":1,"is_red":false,"text":"Threshhold of entrance door sags slightly when stepped upon; recommend providing more support."},{"checked":false,"id":1,"is_red":false,"text":"Caulk or grout recommended at entrance door - floor junctions to prevent water  carried in by foot traffic from entering under the flooring.  "},{"checked":false,"id":1,"is_red":false,"text":"Maintenance Tip: Caulk or grout recommended at door - floor junctions, where applicable, to prevent water that is carried in by foot traffic from entering under the flooring.  "},{"checked":false,"id":1,"is_red":false,"text":"Door stops missing; recommend installing to avoid unnecessary wall and/or door damage.  Note that living room closet door can hit into glass at front door. "},{"checked":false,"id":1,"is_red":false,"text":"The back door is difficult to open and close; mechanism may not be installed true. Back door opens to a step off and fall situation, needs a landing and stairs built on exterior. At lease put up a sign during any open house viewing of the property."},{"checked":false,"id":1,"is_red":false,"text":"Front door and hardware is damaged."},{"checked":false,"id":1,"is_red":false,"text":"The entry doors automatic closer is unable to perform its function due to the thick carpeting that makes the door difficult to open and close."},{"checked":false,"id":1,"is_red":false,"text":"The door for the furnace closet should be louvred to allow air in to help combustion. "},{"checked":false,"id":1,"is_red":false,"text":"Sliding door in rear leading to porch."},{"checked":false,"id":1,"is_red":false,"text":"Back door missing a deadbolt lockset."},{"checked":false,"id":1,"is_red":false,"text":"Some doors are damaged."},{"checked":false,"id":1,"is_red":false,"text":"EXAMPLES:"},{"checked":false,"id":1,"is_red":false,"text":"Several doors are a bit tight in jams, possibly from the new coat of paint."},{"checked":false,"id":1,"is_red":false,"text":"The exit door to mechanical room utilises a self closing mechanism."},{"checked":false,"id":1,"is_red":false,"text":"Doors are not installed."},{"checked":false,"id":1,"is_red":false,"text":"Door did not latch and needs adjustment at:"},{"checked":false,"id":1,"is_red":false,"text":"Door lock appears inadequate, recommend upgrading to provide easier privacy use function of door."},{"checked":false,"id":1,"is_red":false,"text":"Damaged door noted at one or more locations."},{"checked":false,"id":1,"is_red":false,"text":"The installation of a security chain on an interior door is considered a safety hazard. In the event of an emergency a person could not escape due to inability to open door."},{"checked":false,"id":1,"is_red":false,"text":"Pocket door is noted as difficult to operate."},{"checked":false,"id":1,"is_red":false,"text":"Pocket door is noted as stuck in the wall at the time of inspection."}],"sepChoice":"4","title":"Doors"}],"inspection_panels":[],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Doors Overall"}],"title":"Doors"},{"damage_panels":[{"descr":"","id":2272,"options":[{"checked":false,"id":1,"is_red":false,"text":"Deterioration noted due to contact with moisture, repairs needed."},{"checked":false,"id":1,"is_red":false,"text":"One or more window/s shows sign of loss of seal/condensation, recommend repair or replace to provide energy savings and prevent hazed window from limiting view out of window. "},{"checked":false,"id":1,"is_red":false,"text":"One or more windows did not lock/latch properly, recommend repairs for enhanced security/safety to occupants."},{"checked":false,"id":1,"is_red":false,"text":"Broken/cracked glass pane noted, repairs needed."},{"checked":false,"id":1,"is_red":false,"text":"Hardware difficult to operate at one or more locations. Recommend review and repair as needed by qualified window contractors."},{"checked":false,"id":1,"is_red":false,"text":"Single pane windows observed, recommend budgeting for replacement for added efficiency of home."},{"checked":false,"id":1,"is_red":false,"text":"Broken glazing observed, suggest re-glazing as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Broken sash wire/cord observed on window frame. This is a \"Safety Concern\". Sash wire/cord holds window in open position. Suggest repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Damaged screens observed."},{"checked":false,"id":1,"is_red":false,"text":"Deterioration of wooden frames noted.  While basic maintenance may prolong the life of these window frames, replacement may be necessary at some point.  "},{"checked":false,"id":1,"is_red":false,"text":"In the inspectors opinion the windows/frames are near the end of their useful life."},{"checked":false,"id":1,"is_red":false,"text":"Peeling paint observed, suggest scraping and painting as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Fog/condensation observed in thermopane windows. This is an indication of a failed seal. Recommend review for repair or replacement as necessary."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl crank out style windows with locks."},{"checked":false,"id":1,"is_red":false,"text":"Painted wood windows possibly creating lead dust from friction on paint. "},{"checked":false,"id":1,"is_red":false,"text":"Metal \"double hung\" type with locks."},{"checked":false,"id":1,"is_red":false,"text":"Severe damage--\nSome vinyl windows in the home had severe damage visible at the time of the inspection. You may wish to get estimates for repair before the expiration of your Inspection Objection Deadline.\n"},{"checked":false,"id":1,"is_red":false,"text":"Minor damage--\nSome vinyl windows in the home had minor damage visible at the time of the inspection.\n"},{"checked":false,"id":1,"is_red":false,"text":"The home is fitted with vinyl windows."},{"checked":false,"id":1,"is_red":false,"text":"Some windows are very difficult to open and some were not able to open, this may be because of the paint."},{"checked":false,"id":1,"is_red":false,"text":"Screens were not installed at time of inspection."},{"checked":false,"id":1,"is_red":false,"text":"In accordance with ASHI Standards, we do not test every window in the house, and particularly if it is furnished. We do test every unobstructed window in every bedroom to ensure that at least one provides and emergency exit."},{"checked":false,"id":1,"is_red":false,"text":"Highly recommend operating all windows during final walk through inspection."},{"checked":false,"id":1,"is_red":false,"text":"Operated windows appeared functional, at time of inspection"},{"checked":false,"id":1,"is_red":false,"text":"The windows that were tested, are functional."},{"checked":false,"id":1,"is_red":false,"text":"Broken sash wire/cord observed on window frame. This is a \"Safety Concern\". Sash wire/cord holds window in open position. Suggest repairs/replacement as needed to ensure safety."},{"checked":false,"id":1,"is_red":false,"text":"Damaged/Missing sash cords"},{"checked":false,"id":1,"is_red":false,"text":"Damaged screens observed."},{"checked":false,"id":1,"is_red":false,"text":"Missing screens observed at @@LOCATION@@."},{"checked":false,"id":1,"is_red":false,"text":"Damage tilt-out feature locking clips at @@LOCATION@@. Window is still functional. FYI"},{"checked":false,"id":1,"is_red":false,"text":"Damage/missing hardware at @@LOCATION@@. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"Cloudiness/condensation observed in @@NUMBER@@ of thermopane double glazed windows in @@LOCATION@@. This is an indication of a failed seal. A qualified contractor should review for replacement as needed."},{"checked":false,"id":1,"is_red":false,"text":"Cracked or broken window glass was observed. Injury could occur. Recommend repair or replacement of the damaged glass."},{"checked":false,"id":1,"is_red":false,"text":"Cracked window pane in @@LOCATION@@. Repair as needed."},{"checked":false,"id":1,"is_red":false,"text":"DEFERRED COST: Windows are original, older type. Consider upgrading to double pane, thermally insulated, newer efficient type."},{"checked":false,"id":1,"is_red":false,"text":"Some windows did not open when tested. Recommend  all windows reviewed for proper operation during walkthrough inspection prior to closing"},{"checked":false,"id":1,"is_red":false,"text":"A representative number of windows were inspected. Most did not open when tested -- appears painted wood frames have sealed seams. Recommend  all windows be reviewed for proper operation during final walkthrough inspection."},{"checked":false,"id":1,"is_red":false,"text":"All accessible windows operated."},{"checked":false,"id":1,"is_red":false,"text":"Mold-like bio growth observed. Professional testing & evaluation advised."},{"checked":false,"id":1,"is_red":false,"text":"There are older wood windows present."},{"checked":false,"id":1,"is_red":false,"text":"The windows in the home are rope and pulley style, may be original to home, and are approaching the end of their serviceable lifetime."}],"sepChoice":"4","title":"Window Condition"}],"inspection_panels":[{"descr":"","id":3091,"options":[{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed casement window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Stationary(fixed) window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed casement window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Aluminum louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Vinyl louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Wood louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel louvers noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed double hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed single hung window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed sliding window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed casement window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed fixed window noted."},{"checked":false,"id":1,"is_red":false,"text":"Steel framed awning window noted."},{"checked":false,"id":1,"is_red":false,"text":"Garden style window noted."},{"checked":false,"id":1,"is_red":false,"text":"Bay type window noted."},{"checked":false,"id":1,"is_red":false,"text":"Bow type window noted."},{"checked":false,"id":1,"is_red":false,"text":"Glass blocks noted in window openings."},{"checked":false,"id":1,"is_red":false,"text":"Non-insulated glass noted."},{"checked":false,"id":1,"is_red":false,"text":"Insulated glass noted."}],"sepChoice":"1","title":"Windows"}],"pictures":[],"ratings":[{"descr":"","id":0,"options":[{"checked":false,"text":"Good"},{"checked":false,"text":"Fair"},{"checked":false,"text":"Poor"},{"checked":false,"text":"N/A"},{"checked":false,"text":"None"}],"sepChoice":"","title":"Window Condition Overall"}],"title":"Windows"}],"title":"Laundry"}],"pictures":[{"menuItem":null,"caption":"Cover Photo","section":"Cover","id":-1,"imageFileName":"0.jpg"}],"videos":[],"insertsFileType":"JSON","insertsJSON":{"inserts":[{"n":"<<Bathrom Locations>>","c":[]}]},"currInsp":"Test_9-30-18"};
//root.push(arrayCreate);
Alloy.Globals.root = arrayCreate;
Alloy.Globals.tabbedWindowOpened = false;
Alloy.Globals.inspectWindowOpened = false;
Alloy.Globals.inspectionLoaded = false;

Alloy.Globals.commentDoubleClickColor = '#CC0000';
Alloy.Globals.commentSingleClickColor = '#00FF00';
Alloy.Globals.commentRowsFGColor = '#000000';
Alloy.Globals.commentRowsBGColor = '#FFFFFF';
Alloy.Globals.fontSizeVal = '15';
Alloy.Globals.multilistSeparator = "~-~#";
Alloy.Globals.autoListSwitch = true;

Alloy.Globals.currentInspection = "";
Alloy.Globals.setCurrentInspection = function(inspectionName) {
    Alloy.Globals.currentInspection = inspectionName;
    Titanium.App.Properties.setString('currentInspection', inspectionName);
};
Alloy.Globals.getCurrentInspection = function() {
    Alloy.Globals.currentInspection = Titanium.App.Properties.getString('currentInspection');
    return Alloy.Globals.currentInspection;
};

Alloy.Globals.setCurrentInspection('Test_9-30-18');

var sliderValue = Ti.App.Properties.getInt('sliderValue');
if (!sliderValue) {
    Ti.App.Properties.setInt('sliderValue', 3);
}